<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:oslc_qm="http://open-services.net/xmlns/qm/1.0/"
    xmlns:ext="http://jazz.net/xmlns/alm/qm/v0.1/"
	xmlns:dc="http://purl.org/dc/terms/"
	xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
    >

	<xsl:output method="html" encoding="UTF-8" indent="yes" version="4.0"/>
	
	<xsl:variable name="iconsUrl" select="//ext:iconsUrl"/>
	
	<!-- NLS -->
	<xsl:variable name="xslt_i18n_name" select="//ext:xslt_i18n_name"/>
	<xsl:variable name="xslt_i18n_state" select="//ext:xslt_i18n_state"/>
	<xsl:variable name="xslt_i18n_description" select="//ext:xslt_i18n_description"/>
	<xsl:variable name="xslt_i18n_details" select="//ext:xslt_i18n_details"/>
	<xsl:variable name="xslt_i18n_updated" select="//ext:xslt_i18n_updated"/>
	<xsl:variable name="xslt_i18n_originator" select="//ext:xslt_i18n_originator"/>
	<xsl:variable name="xslt_i18n_communityRisk" select="//ext:xslt_i18n_communityRisk"/>
	<xsl:variable name="xslt_i18n_calculatedRisk" select="//ext:xslt_i18n_calculatedRisk"/>
	<xsl:variable name="xslt_i18n_testScripts" select="//ext:xslt_i18n_testScripts"/>
	<xsl:variable name="xslt_i18n_weight" select="//ext:xslt_i18n_weight"/>
	<xsl:variable name="xslt_i18n_trigger" select="//ext:xslt_i18n_trigger"/>
	<xsl:variable name="xslt_i18n_activity" select="//ext:xslt_i18n_activity"/>
	<xsl:variable name="xslt_i18n_projectArea" select="//ext:xslt_i18n_projectArea"/>
	
    <xsl:template match="oslc_qm:testcase">
		<head>
			<style type="text/css">
				body { background-color: transparent; margin: 0px; padding: 0px; }
				table {  font-family: Arial,sans-serif; font-size: 9pt; font-weight: normal; }
				table.section { margin: 4px; }
				th { text-align: left; }
				a:link { color: #005C87; text-decoration: none; }
				a:hover { color: #8a9084; text-decoration: underline; }
				a:visited { color: #005C87; text-decoration: none; }
				a.yellow:link { color: rgb(128,128,0); text-decoration: none; }
				a.yellow:hover { color: rgb(128,128,0); text-decoration: underline; }
				a.yellow:visited { color: rgb(128,128,0); text-decoration: none; }
				td.sectionTitle { padding-top:0; font-weight:bold; padding-right:10px; vertical-align:top; }
				td.sectionContent { padding-left:1px; padding-right:10px; vertical-align:top;}
				td.sectionContentNoWrap { white-space:nowrap; padding-left:1px; padding-right:10px; vertical-align:top;}
				span.imageLabel {padding-left:3px;vertical-align:top;}
			</style>
		</head>
        <body>
        	<table class="section">
        		<tr>
        			<td class="sectionTitle"><xsl:value-of select="$xslt_i18n_name"/></td>
        			<td class="sectionTitle"><xsl:value-of select="$xslt_i18n_state"/></td>
        		</tr>
        		<tr>
        			<td class="sectionContent"><xsl:value-of select="ext:id"/>: <xsl:value-of select="dc:title"/></td>
        			<td class="sectionContent"><xsl:value-of select="ext:state"/></td>
        		</tr>
        	</table>
   			<xsl:if test="dc:description">
	        	<table class="section">
	        		<tr>
	        			<td class="sectionTitle"><xsl:value-of select="$xslt_i18n_description"/></td>
	        		</tr>
	        		<tr>
	        			<td class="sectionContent"><xsl:value-of select="dc:description"/></td>
	        		</tr>
	        	</table>
   			</xsl:if>
        	<table class="section">
        		<tr>
        			<th colspan="4"><xsl:value-of select="$xslt_i18n_details"/></th>
        		</tr>
        		<tr>
        			<td valign="top" class="sectionContent"><xsl:value-of select="$xslt_i18n_weight"/>:</td>
        			<td valign="top" class="sectionContent">
	        			<xsl:value-of select="ext:weight"/>
      				</td>
        			<td valign="top" class="sectionContent"><xsl:value-of select="$xslt_i18n_updated"/>:</td>
        			<td valign="top" class="sectionContent">
	        			<xsl:value-of select="dc:modified"/>
      				</td>
    			</tr>
        		<tr>
        			<td valign="top" class="sectionContent"><xsl:value-of select="$xslt_i18n_originator"/>:</td>
        			<td valign="top" class="sectionContent">
	        			<xsl:value-of select="dc:creator"/>
      				</td>
        			<td valign="top" class="sectionContent"><xsl:value-of select="$xslt_i18n_trigger"/>:</td>
        			<td valign="top" class="sectionContent">
	        			<xsl:value-of select="ext:trigger"/>
      				</td>
      				
    			</tr>
        		<tr>
      				<td valign="top" class="sectionContent"><xsl:value-of select="$xslt_i18n_calculatedRisk"/>:</td>
      				<td valign="top" class="sectionContent">
						<xsl:choose>
							<xsl:when test="ext:risk/ext:calculatedRisk = 5">
		      					<img border="0" src="{$iconsUrl}/elcl16/risklevel5.gif" alt="5"/>
							</xsl:when>
							<xsl:when test="ext:risk/ext:calculatedRisk = 4">
		      					<img border="0" src="{$iconsUrl}/elcl16/risklevel4.gif" alt="4"/>
							</xsl:when>
							<xsl:when test="ext:risk/ext:calculatedRisk = 3">
		      					<img border="0" src="{$iconsUrl}/elcl16/risklevel3.gif" alt="3"/>
							</xsl:when>
							<xsl:when test="ext:risk/ext:calculatedRisk = 2">
		      					<img border="0" src="{$iconsUrl}/elcl16/risklevel2.gif" alt="2"/>
							</xsl:when>
							<xsl:when test="ext:risk/ext:calculatedRisk = 1">
		      					<img border="0" src="{$iconsUrl}/elcl16/risklevel1.gif" alt="1"/>
							</xsl:when>
							<xsl:otherwise>
		      					<img border="0" src="{$iconsUrl}/elcl16/risklevel0.gif" alt="0"/>
							</xsl:otherwise>
						</xsl:choose>
       				</td>
        			<td valign="top" class="sectionContent"><xsl:value-of select="$xslt_i18n_activity"/>:</td>
        			<td valign="top" class="sectionContent">
	        			<xsl:value-of select="ext:activity"/>
      				</td>
    			</tr>
        		<tr>
      				<td valign="top" class="sectionContent"><xsl:value-of select="$xslt_i18n_communityRisk"/>:</td>
      				<td valign="top" class="sectionContent">
						<xsl:choose>
							<xsl:when test="ext:risk/ext:communityRisk = 5">
		      					<img border="0" src="{$iconsUrl}/elcl16/risklevel5.gif" alt="5"/>
							</xsl:when>
							<xsl:when test="ext:risk/ext:communityRisk = 4">
		      					<img border="0" src="{$iconsUrl}/elcl16/risklevel4.gif" alt="4"/>
							</xsl:when>
							<xsl:when test="ext:risk/ext:communityRisk = 3">
		      					<img border="0" src="{$iconsUrl}/elcl16/risklevel3.gif" alt="3"/>
							</xsl:when>
							<xsl:when test="ext:risk/ext:communityRisk = 2">
		      					<img border="0" src="{$iconsUrl}/elcl16/risklevel2.gif" alt="2"/>
							</xsl:when>
							<xsl:when test="ext:risk/ext:communityRisk = 1">
		      					<img border="0" src="{$iconsUrl}/elcl16/risklevel1.gif" alt="1"/>
							</xsl:when>
							<xsl:otherwise>
		      					<img border="0" src="{$iconsUrl}/elcl16/risklevel0.gif" alt="0"/>
							</xsl:otherwise>
						</xsl:choose>
       				</td>
        			<td valign="top" class="sectionContent"><xsl:value-of select="$xslt_i18n_projectArea"/>:</td>
        			<td valign="top" class="sectionContent">
	        			<xsl:value-of select="ext:projectArea"/>
      				</td>
        		</tr>
				<xsl:for-each select="ext:categories/ext:category">
					<tr>
						<td valign="top" class="sectionContent"><xsl:value-of select="ext:term"/>:</td>
						<td colspan="3"><xsl:value-of select="ext:value"/></td>
					</tr>
				</xsl:for-each>        		
        	</table>
   			<xsl:if test="ext:testscripts/*">
	        	<table class="section">
	        		<tr>
	        			<th colspan="2"><xsl:value-of select="$xslt_i18n_testScripts"/></th>
	        		</tr>
					<xsl:for-each select="ext:testscripts/ext:testscript">
						<xsl:sort select="ext:id"/>
						<xsl:variable name="testscriptUrl" select="ext:url"/>
						<tr>
							<td valign="top" class="sectionContent">
								<a href="{$testscriptUrl}"><img border="0" src="{$iconsUrl}/obj16/qm_testscript16.gif" alt="$xslt_i18n_testScripts"/></a>
							</td>
							<td>
								<a href="{$testscriptUrl}"><xsl:value-of select="ext:id"/>: <xsl:value-of select="ext:name"/></a>
							</td>
						</tr>
					</xsl:for-each>        		
	        	</table>
	       	</xsl:if>
        </body>
    </xsl:template>
    
</xsl:stylesheet>
