<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:fo="http://www.w3.org/1999/XSL/Format" xmlns:atom="http://www.w3.org/2005/Atom"
    xmlns:fox="http://xml.apache.org/fop/extensions"
    xmlns:ns10="http://jazz.net/xmlns/alm/qm/v0.1/executionworkitem/v0.1"
    xmlns:ns11="http://jazz.net/xmlns/alm/qm/v0.1/tsl/v0.1/"
    xmlns:ns2="http://schema.ibm.com/vega/2008/" xmlns:ns3="http://purl.org/dc/elements/1.1/"
    xmlns:ns4="http://jazz.net/xmlns/alm/v0.1/"
    xmlns:ns5="http://jazz.net/xmlns/alm/qm/qmadapter/task/v0.1"
    xmlns:ns6="http://jazz.net/xmlns/alm/qm/qmadapter/v0.1"
    xmlns:ns7="http://jazz.net/xmlns/alm/qm/v0.1/executionresult/v0.1"
    xmlns:ns8="http://jazz.net/xmlns/alm/qm/v0.1/catalog/v0.1"
    xmlns:ns9="http://jazz.net/xmlns/alm/qm/v0.1/datapool/v0.1/"
    xmlns:ts="http://jazz.net/xmlns/alm/qm/v0.1/"
    exclude-result-prefixes="ns9 ns8 ns7 ns6 ns5 ns4 ns3 ns2 ts xsl">
    <xsl:include href="xhtml-to-xslfo.xsl"/>
    <xsl:variable name="lang">
        <xsl:value-of select="locale"/>
    </xsl:variable>
    <xsl:template match="transformArgs">
        <xsl:choose>
            <xsl:when test="(componentType='STAND_ALONE') or (componentType='STAND_ALONE_SUMMARY') or (componentType='SUMMARY') or (componentType='COMPOSITE') or (componentType='COMPOSITE_SUMMARY')">
                <fo:page-sequence xmlns:fo="http://www.w3.org/1999/XSL/Format"
                    initial-page-number="1" force-page-count="no-force"
                    master-reference="PageMaster">
                    <fo:static-content flow-name="xsl-region-before">
                        <fo:block font-size="8pt" text-align="right">
                            <fo:page-number/> / <fo:page-number-citation ref-id="{reqNumber}"/>
                        </fo:block>
                    </fo:static-content>
                    <fo:static-content flow-name="xsl-region-after">
                    	<fo:block-container height="0.1in" padding-after="0.07in">
							<fo:block text-align="center">
								<fo:leader leader-pattern='rule' rule-thickness='1pt' leader-length='100%'/>
							</fo:block>
						</fo:block-container>
                        <fo:block text-align="center">
                            <fo:retrieve-marker retrieve-class-name="artifactUri"/>
                        </fo:block>
                    </fo:static-content>
                    <fo:flow flow-name="xsl-region-body">
                        <fo:marker marker-class-name="artifactUri">
                            <fo:block font-size="6pt">
                                <fo:basic-link external-destination="{datapoolUuid}" color="blue"
                                    text-decoration="underline">
                                    <xsl:value-of select="datapoolUuid"/>
                                </fo:basic-link>
                            </fo:block>
                        </fo:marker>
                        <xsl:apply-templates select="descendant::ts:datapool"/>
                        <fo:block id="{reqNumber}"/>
                    </fo:flow>
                </fo:page-sequence>
            </xsl:when>
            <xsl:otherwise>
                <xsl:apply-templates select="descendant::ts:datapool"/>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>
    <xsl:template match="ts:datapool">
        <xsl:choose>
            <xsl:when
                test="(../../componentType='SUMMARY') or (../../componentType='STAND_ALONE_SUMMARY') or (../../componentType='COMPOSITE_SUMMARY')">
                 <fo:block font-size="14pt" space-before="2mm" space-after="2mm" border-after-style="solid" border-after-width="thin">
                  <xsl:value-of select="ns3:title"/>
                 </fo:block>
            </xsl:when>
        </xsl:choose> 
    </xsl:template>
    <xsl:template match="ns9:*">
        <xsl:apply-templates select="*|text()"/>
    </xsl:template>
</xsl:stylesheet>
