<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:fo="http://www.w3.org/1999/XSL/Format" xmlns:req="http://purl.org/dc/elements/1.1/"
    xmlns:ns2="http://jazz.net/xmlns/alm/qm/v0.1/" xmlns:ns3="http://jazz.net/xmlns/alm/v0.1/"
    xmlns:ns4="http://schema.ibm.com/vega/2008/"
    xmlns:ns5="http://jazz.net/xmlns/alm/qm/v0.1/testscript/v0.1/"
    xmlns:ns6="http://jazz.net/xmlns/alm/qm/v0.1/executionworkitem/v0.1"
    xmlns:ns7="http://jazz.net/xmlns/alm/qm/v0.1/executionresult/v0.1"
    xmlns:ns8="http://jazz.net/xmlns/alm/qm/v0.1/tsl/v0.1/"
    exclude-result-prefixes="ns8 ns7 ns6 ns5 ns4 ns3 ns2 req xsl">
    <xsl:variable name="lang">
        <xsl:value-of select="locale"/>
    </xsl:variable>
    <xsl:template match="transformArgs">
        <xsl:choose>
            <xsl:when test="(componentType='STAND_ALONE') or (componentType='STAND_ALONE_SUMMARY')">
                <fo:page-sequence xmlns:fo="http://www.w3.org/1999/XSL/Format"
                    initial-page-number="1" force-page-count="no-force"
                    master-reference="PageMaster">
                    <fo:static-content flow-name="xsl-region-before">
                        <fo:block font-size="8pt" text-align="right">
                            <fo:page-number/> / <fo:page-number-citation ref-id="{reqNumber}"/>
                        </fo:block>
                    </fo:static-content>
                    <fo:static-content flow-name="xsl-region-after">
                        <fo:block text-align="center">
                            <fo:retrieve-marker retrieve-class-name="artifactUri"/>
                        </fo:block>
                    </fo:static-content>
                    <fo:flow flow-name="xsl-region-body">
                        <fo:marker marker-class-name="artifactUri">
                            <fo:block font-size="6pt">
                                <fo:basic-link external-destination="{originUrl}" color="blue"
                                    text-decoration="underline">
                                    <xsl:value-of select="originUrl"/>
                                </fo:basic-link>
                            </fo:block>
                        </fo:marker>
                        <xsl:apply-templates select="descendant::ns2:request"/>
                        <fo:block id="{reqNumber}"/>
                    </fo:flow>
                </fo:page-sequence>
            </xsl:when>
            <xsl:otherwise>
                <xsl:apply-templates select="descendant::ns2:request"/>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>
    <xsl:template match="ns2:request">
        <xsl:choose>
            <xsl:when
                test="(../../componentType='SUMMARY') or (../../componentType='STAND_ALONE_SUMMARY') or (../../componentType='COMPOSITE_SUMMARY')">
                <xsl:choose>
                    <xsl:when
                        test="../../componentType='STAND_ALONE_SUMMARY' or (../../componentType='COMPOSITE_SUMMARY')">
                        <xsl:if test="../../componentType='STAND_ALONE_SUMMARY'">
                            <fo:block font-size="14pt" space-before="6mm" space-after="2mm"
                                    ><xsl:value-of
                                    select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/labelSummary"
                                />: <xsl:value-of
                                    select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/reqLabel_request"
                                /></fo:block>
                        </xsl:if>
                        <fo:table border="0.5pt solid black" text-align="left">
                            <fo:table-header>
                                <fo:table-row keep-together="always"
                                    background-color="rgb(249,245,219)">
                                    <fo:table-cell keep-together.within-column="always" width="10mm">
                                        <fo:block-container overflow="hidden">
                                            <fo:block font-size="10pt" font-weight="bold">
                                                <xsl:value-of
                                                  select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/labelId"
                                                />
                                            </fo:block>
                                        </fo:block-container>
                                    </fo:table-cell>
                                    <fo:table-cell keep-together.within-column="always">
                                        <fo:block-container overflow="hidden">
                                            <fo:block font-size="10pt" font-weight="bold">
                                                <xsl:value-of
                                                  select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/labelSummary"
                                                />
                                            </fo:block>
                                        </fo:block-container>
                                    </fo:table-cell>
                                    <fo:table-cell keep-together.within-column="always" width="20mm">
                                        <fo:block-container overflow="hidden">
                                            <fo:block font-size="10pt" font-weight="bold">
                                                <xsl:value-of
                                                  select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/reqLabel_created_on"
                                                />
                                            </fo:block>
                                        </fo:block-container>
                                    </fo:table-cell>
                                    <fo:table-cell keep-together.within-column="always" width="20mm">
                                        <fo:block-container overflow="hidden">
                                            <fo:block font-size="10pt" font-weight="bold">
                                                <xsl:value-of
                                                  select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/reqLabel_confirm_by"
                                                />
                                            </fo:block>
                                        </fo:block-container>
                                    </fo:table-cell>
                                    <fo:table-cell keep-together.within-column="always" width="20mm">
                                        <fo:block-container overflow="hidden">
                                            <fo:block font-size="10pt" font-weight="bold">
                                                <xsl:value-of
                                                  select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/reqLabel_assigned"
                                                />
                                            </fo:block>
                                        </fo:block-container>
                                    </fo:table-cell>
                                    <fo:table-cell keep-together.within-column="always" width="15mm">
                                        <fo:block-container overflow="hidden">
                                            <fo:block font-size="10pt" font-weight="bold">
                                                <xsl:value-of
                                                  select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/reqLabel_priority"
                                                />
                                            </fo:block>
                                        </fo:block-container>
                                    </fo:table-cell>
                                    <fo:table-cell keep-together.within-column="always" width="20mm">
                                        <fo:block-container overflow="hidden">
                                            <fo:block font-size="10pt" font-weight="bold">
                                                <xsl:value-of
                                                  select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/reqLabel_status"
                                                />
                                            </fo:block>
                                        </fo:block-container>
                                    </fo:table-cell>
                                </fo:table-row>
                            </fo:table-header>
                            <fo:table-body>
                                <fo:table-row keep-together="always">
                                    <fo:table-cell keep-together.within-column="always"
                                        padding="3pt" border="0.5pt solid black">
                                        <fo:block-container overflow="hidden">
                                            <fo:block font-size="10pt">
                                                <xsl:value-of select="ns2:visibleId"/>
                                            </fo:block>
                                        </fo:block-container>
                                    </fo:table-cell>
                                    <fo:table-cell keep-together.within-column="always"
                                        padding="3pt" border="0.5pt solid black">
                                        <fo:block-container overflow="hidden">
                                            <fo:block font-size="10pt">
                                                <xsl:value-of select="ns2:summary"/>
                                            </fo:block>
                                        </fo:block-container>
                                    </fo:table-cell>
                                    <fo:table-cell keep-together.within-column="always"
                                        padding="3pt" border="0.5pt solid black">
                                        <fo:block-container overflow="hidden">
                                            <fo:block font-size="10pt">
                                                <xsl:value-of select="ns2:createDate"/>
                                            </fo:block>
                                        </fo:block-container>
                                    </fo:table-cell>
                                    <fo:table-cell keep-together.within-column="always"
                                        padding="3pt" border="0.5pt solid black">
                                        <fo:block-container overflow="hidden">
                                            <fo:block font-size="10pt">
                                                <xsl:value-of select="ns2:confirmationDate"/>
                                            </fo:block>
                                        </fo:block-container>
                                    </fo:table-cell>
                                    <fo:table-cell keep-together.within-column="always"
                                        padding="3pt" border="0.5pt solid black">
                                        <fo:block-container overflow="hidden">
                                            <fo:block font-size="10pt">
                                                <xsl:value-of select="ns2:fulfiller"/>
                                            </fo:block>
                                        </fo:block-container>
                                    </fo:table-cell>
                                    <fo:table-cell keep-together.within-column="always"
                                        padding="3pt" border="0.5pt solid black">
                                        <fo:block-container overflow="hidden">
                                            <fo:block font-size="10pt">
                                                <xsl:value-of select="ns2:priority"/>
                                            </fo:block>
                                        </fo:block-container>
                                    </fo:table-cell>
                                    <fo:table-cell keep-together.within-column="always"
                                        padding="3pt" border="0.5pt solid black">
                                        <fo:block-container overflow="hidden">
                                            <fo:block font-size="10pt">
                                                <xsl:value-of select="ns3:state"/>
                                            </fo:block>
                                        </fo:block-container>
                                    </fo:table-cell>
                                </fo:table-row>
                            </fo:table-body>
                        </fo:table>
                    </xsl:when>
                    <xsl:otherwise>
                        <fo:table-row keep-together="always">
                            <fo:table-cell keep-together.within-column="always" padding="3pt"
                                border="0.5pt solid black">
                                <fo:block-container overflow="hidden">
                                    <fo:block font-size="10pt">
                                        <xsl:value-of select="ns2:visibleId"/>
                                    </fo:block>
                                </fo:block-container>
                            </fo:table-cell>
                            <fo:table-cell keep-together.within-column="always" padding="3pt"
                                border="0.5pt solid black">
                                <fo:block-container overflow="hidden">
                                    <fo:block font-size="10pt">
                                        <xsl:value-of select="ns2:summary"/>
                                    </fo:block>
                                </fo:block-container>
                            </fo:table-cell>
                            <fo:table-cell keep-together.within-column="always" padding="3pt"
                                border="0.5pt solid black">
                                <fo:block-container overflow="hidden">
                                    <fo:block font-size="10pt">
                                        <xsl:value-of select="ns2:createDate"/>
                                    </fo:block>
                                </fo:block-container>
                            </fo:table-cell>
                            <fo:table-cell keep-together.within-column="always" padding="3pt"
                                border="0.5pt solid black">
                                <fo:block-container overflow="hidden">
                                    <fo:block font-size="10pt">
                                        <xsl:value-of select="ns2:confirmationDate"/>
                                    </fo:block>
                                </fo:block-container>
                            </fo:table-cell>
                            <fo:table-cell keep-together.within-column="always" padding="3pt"
                                border="0.5pt solid black">
                                <fo:block-container overflow="hidden">
                                    <fo:block font-size="10pt">
                                        <xsl:value-of select="ns2:fulfiller"/>
                                    </fo:block>
                                </fo:block-container>
                            </fo:table-cell>
                            <fo:table-cell keep-together.within-column="always" padding="3pt"
                                border="0.5pt solid black">
                                <fo:block-container overflow="hidden">
                                    <fo:block font-size="10pt">
                                        <xsl:value-of select="ns2:priority"/>
                                    </fo:block>
                                </fo:block-container>
                            </fo:table-cell>
                            <fo:table-cell keep-together.within-column="always" padding="3pt"
                                border="0.5pt solid black">
                                <fo:block-container overflow="hidden">
                                    <fo:block font-size="10pt">
                                        <xsl:value-of select="ns3:state"/>
                                    </fo:block>
                                </fo:block-container>
                            </fo:table-cell>
                        </fo:table-row>
                    </xsl:otherwise>
                </xsl:choose>
            </xsl:when>
            <xsl:otherwise>
                <fo:block xmlns:fo="http://www.w3.org/1999/XSL/Format">
                    <xsl:if test="(../../componentType='COMPOSITE' )">
                        <xsl:attribute name="break-after">page</xsl:attribute>
                    </xsl:if>
                    <fo:block/>
                    <fo:block font-size="14pt" space-before="4mm" space-after="2mm"
                        border-after-style="solid" border-after-width="thin"><xsl:value-of
                            select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/reqLabel_request"
                        />: <xsl:value-of select="ns2:title"/></fo:block>
                    <fo:block font-size="10pt"><xsl:value-of
                            select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/reqLabel_created_on"
                        />: <xsl:value-of select="ns2:createDate"/>
                    </fo:block>
                    <fo:table>
                        <fo:table-body>
                            <fo:table-row keep-together="always">
                                <fo:table-cell keep-together.within-column="always">
                                    <fo:block-container overflow="hidden">
                                        <fo:block font-size="10pt"><xsl:value-of
                                                select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/reqLabel_created_by"
                                            />: <xsl:value-of select="ns2:requester"/></fo:block>
                                    </fo:block-container>
                                </fo:table-cell>
                                <fo:table-cell keep-together.within-column="always">
                                    <fo:block-container overflow="hidden">
                                        <fo:block font-size="10pt"><xsl:value-of
                                                select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/reqLabel_status"
                                            />: <xsl:value-of select="ns3:state"/></fo:block>
                                    </fo:block-container>
                                </fo:table-cell>
                                <fo:table-cell keep-together.within-column="always">
                                    <fo:block-container overflow="hidden">
                                        <fo:block font-size="10pt"><xsl:value-of
                                                select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/reqLabel_priority"
                                            />: <xsl:value-of select="ns2:priority"/></fo:block>
                                    </fo:block-container>
                                </fo:table-cell>
                            </fo:table-row>
                            <fo:table-row keep-together="always">
                                <fo:table-cell keep-together.within-column="always">
                                    <fo:block-container overflow="hidden">
                                        <fo:block font-size="10pt"><xsl:value-of
                                                select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/reqLabel_assigned"
                                            />: <xsl:value-of select="ns2:fulfiller"/></fo:block>
                                    </fo:block-container>
                                </fo:table-cell>
                                <fo:table-cell keep-together.within-column="always"
                                    number-columns-spanned="2">
                                    <fo:block-container overflow="hidden">
                                        <fo:block font-size="10pt"><xsl:value-of
                                                select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/reqLabel_confirm_by"
                                            />: <xsl:value-of select="ns2:confirmationDate"/>
                                        </fo:block>
                                    </fo:block-container>
                                </fo:table-cell>
                            </fo:table-row>
                            <fo:table-row keep-together="always">
                                <fo:table-cell keep-together.within-column="always"
                                    number-columns-spanned="3">
                                    <fo:block-container overflow="hidden">
                                        <fo:block font-size="10pt"><xsl:value-of
                                                select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/labeldescription"
                                            />: <xsl:value-of select="ns2:summary"/></fo:block>
                                    </fo:block-container>
                                </fo:table-cell>
                            </fo:table-row>
                            <fo:table-row keep-together="always">
                                <fo:table-cell keep-together.within-column="always"
                                    number-columns-spanned="3">
                                    <fo:block-container overflow="hidden">
                                        <fo:block font-size="10pt"><xsl:value-of
                                                select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/resreservefrom"
                                            />: <xsl:value-of select="ns2:reserveFrom"/></fo:block>
                                    </fo:block-container>
                                </fo:table-cell>
                            </fo:table-row>
                            <fo:table-row keep-together="always">
                                <fo:table-cell keep-together.within-column="always"
                                    number-columns-spanned="3">
                                    <fo:block-container overflow="hidden">
                                        <fo:block font-size="10pt"><xsl:value-of
                                                select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/resreserveTo"
                                            />: <xsl:value-of select="ns2:reserveTo"/></fo:block>
                                    </fo:block-container>
                                </fo:table-cell>
                            </fo:table-row>
                        </fo:table-body>
                    </fo:table>
                    <xsl:apply-templates select="ns2:configuration/Assets/AssetInstance"/>
                    <fo:block space-before="2mm" font-size="10pt"><xsl:value-of
                            select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/reqLabel_comments"
                        />: <xsl:value-of select="ns2:comments"/></fo:block>
                </fo:block>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>
    <xsl:template match="ns2:configuration/Assets/AssetInstance">
        <fo:block space-before="4mm" font-size="14pt">
            <xsl:value-of select="Label"/>
        </fo:block>
        <xsl:apply-templates select="AssetType"/>
    </xsl:template>
    <xsl:template match="AssetType">
        <fo:block><xsl:value-of select="type"/>: <xsl:value-of select="name"/></fo:block>
        <xsl:apply-templates select="Attributes/Attribute"/>
    </xsl:template>
    <xsl:template match="Attributes/Attribute">
        <fo:block>
            <xsl:attribute name="text-indent">
                <xsl:value-of select="concat(count(ancestor::AssetInstance) * .75,'cm')"/>
            </xsl:attribute>
            <xsl:variable name="reqLabel">
                <xsl:value-of select="translate(@name,' ','')"/>
            </xsl:variable>
            <xsl:choose>
                <xsl:when test="@type='StringType'">
                    <xsl:value-of
                        select="document('fopmessages.xml')/fopmessages//*[name()=$lang]//*[name()=$reqLabel]"
                    />: <xsl:value-of select="value/string"/>
                </xsl:when>
                <xsl:when test="@type='PointerType'">
                    <xsl:value-of
                        select="document('fopmessages.xml')/fopmessages//*[name()=$lang]//*[name()=$reqLabel]"
                    />: <xsl:value-of select="value/DisplayValue/displayString"/>
                </xsl:when>
                <xsl:when test="@type='NumericType'">
                    <xsl:value-of
                        select="document('fopmessages.xml')/fopmessages//*[name()=$lang]//*[name()=$reqLabel]"
                    />: <xsl:value-of select="value/int"/>
                </xsl:when>
                <xsl:when test="@type='ConfigurationPartType'">
                    <xsl:value-of
                        select="document('fopmessages.xml')/fopmessages//*[name()=$lang]//*[name()=$reqLabel]"
                    />: <xsl:apply-templates select="value/AssetInstance/AssetType"/>
                </xsl:when>
            </xsl:choose>
        </fo:block>
    </xsl:template>
</xsl:stylesheet>
