<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:fo="http://www.w3.org/1999/XSL/Format" xmlns:atom="http://www.w3.org/2005/Atom"
    xmlns:fox="http://xml.apache.org/fop/extensions"
    xmlns:ns10="http://jazz.net/xmlns/alm/qm/v0.1/executionworkitem/v0.1"
    xmlns:ns11="http://jazz.net/xmlns/alm/qm/v0.1/tsl/v0.1/"
    xmlns:ns2="http://schema.ibm.com/vega/2008/" xmlns:ns3="http://purl.org/dc/elements/1.1/"
    xmlns:ns4="http://jazz.net/xmlns/alm/v0.1/"
    xmlns:ns5="http://jazz.net/xmlns/alm/qm/qmadapter/task/v0.1"
    xmlns:ns6="http://jazz.net/xmlns/alm/qm/qmadapter/v0.1"
    xmlns:ns7="http://jazz.net/xmlns/alm/qm/v0.1/executionresult/v0.1"
    xmlns:ns8="http://jazz.net/xmlns/alm/qm/v0.1/catalog/v0.1"
    xmlns:ns9="http://jazz.net/xmlns/alm/qm/v0.1/testscript/v0.1/"
    xmlns:ts="http://jazz.net/xmlns/alm/qm/v0.1/"
    exclude-result-prefixes="ns9 ns8 ns7 ns6 ns5 ns4 ns3 ns2 ts xsl">
    <xsl:include href="xhtml-to-xslfo.xsl"/>
    <xsl:variable name="lang">
        <xsl:value-of select="locale"/>
    </xsl:variable>
    <xsl:template match="transformArgs">
        <xsl:choose>
            <xsl:when test="(componentType='STAND_ALONE') or (componentType='STAND_ALONE_SUMMARY')">
                <fo:page-sequence xmlns:fo="http://www.w3.org/1999/XSL/Format"
                    initial-page-number="1" force-page-count="no-force"
                    master-reference="PageMaster">
                    <fo:static-content flow-name="xsl-region-before">
                        <fo:block font-size="8pt" text-align="right">
                            <fo:page-number/> / <fo:page-number-citation ref-id="{reqNumber}"/>
                        </fo:block>
                    </fo:static-content>
                    <fo:static-content flow-name="xsl-region-after">
                        <fo:block text-align="center">
                            <fo:retrieve-marker retrieve-class-name="artifactUri"/>
                        </fo:block>
                    </fo:static-content>
                    <fo:flow flow-name="xsl-region-body">
                        <fo:marker marker-class-name="artifactUri">
                            <fo:block font-size="6pt">
                                <fo:basic-link external-destination="{originUrl}" color="blue"
                                    text-decoration="underline">
                                    <xsl:value-of select="originUrl"/>
                                </fo:basic-link>
                            </fo:block>
                        </fo:marker>
                        <xsl:apply-templates select="descendant::ts:testscript"/>
                        <fo:block id="{reqNumber}"/>
                    </fo:flow>
                </fo:page-sequence>
            </xsl:when>
            <xsl:otherwise>
                <xsl:apply-templates select="descendant::ts:testscript"/>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>
    <xsl:template match="ts:testscript">
        <xsl:choose>
            <xsl:when
                test="(../../componentType='SUMMARY') or (../../componentType='STAND_ALONE_SUMMARY') or (../../componentType='COMPOSITE_SUMMARY')">
                <xsl:choose>
                    <xsl:when
                        test="../../componentType='STAND_ALONE_SUMMARY' or (../../componentType='COMPOSITE_SUMMARY')">
                        <xsl:if test="../../componentType='STAND_ALONE_SUMMARY'">
                            <fo:block font-size="14pt" space-before="6mm" space-after="2mm">
                                <xsl:value-of
                                    select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/labelSummary"
                                /> : <xsl:value-of
                                    select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/labelTestScript"
                                />
                            </fo:block>
                        </xsl:if>
                        <fo:table border="0.5pt solid black">
                            <fo:table-header>
                                <fo:table-row keep-together="always"
                                    background-color="rgb(249,245,219)">
                                    <fo:table-cell keep-together.within-column="always" width="7mm"
                                        padding="3pt" border="0.5pt solid black">
                                        <fo:block-container overflow="hidden">
                                            <fo:block font-weight="bold">
                                                <xsl:value-of
                                                  select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/labelId"
                                                />
                                            </fo:block>
                                        </fo:block-container>
                                    </fo:table-cell>
                                    <fo:table-cell keep-together.within-column="always"
                                        border="0.5pt solid black" padding="3pt">
                                        <fo:block-container overflow="hidden">
                                            <fo:block font-weight="bold">
                                                <xsl:value-of
                                                  select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/labelName"
                                                />
                                            </fo:block>
                                        </fo:block-container>
                                    </fo:table-cell>
                                    <fo:table-cell keep-together.within-column="always" width="30mm"
                                        padding="3pt" border="0.5pt solid black">
                                        <fo:block-container overflow="hidden">
                                            <fo:block font-weight="bold">
                                                <xsl:value-of
                                                  select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/labelState"
                                                />
                                            </fo:block>
                                        </fo:block-container>
                                    </fo:table-cell>
                                    <fo:table-cell keep-together.within-column="always" width="20mm"
                                        padding="3pt" border="0.5pt solid black">
                                        <fo:block-container overflow="hidden">
                                            <fo:block font-weight="bold">
                                                <xsl:value-of
                                                  select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/labelScriptType"
                                                />
                                            </fo:block>
                                        </fo:block-container>
                                    </fo:table-cell>
                                    <fo:table-cell keep-together.within-column="always" width="20mm"
                                        padding="3pt" border="0.5pt solid black">
                                        <fo:block-container overflow="hidden">
                                            <fo:block font-weight="bold">
                                                <xsl:value-of
                                                  select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/labelModifiedDate"
                                                />
                                            </fo:block>
                                        </fo:block-container>
                                    </fo:table-cell>
                                </fo:table-row>
                            </fo:table-header>
                            <fo:table-body>
                                <fo:table-row keep-together="always">
                                    <fo:table-cell keep-together.within-column="always"
                                        padding="3pt" border="0.5pt solid black">
                                        <fo:block-container overflow="hidden">
                                            <fo:block font-size="10pt">
                                                <xsl:variable name="ident"
                                                  select="*[local-name()='identifier']"/>
                                                <xsl:value-of
                                                  select="substring-after($ident,'testscript:')"/>
                                            </fo:block>
                                        </fo:block-container>
                                    </fo:table-cell>
                                    <fo:table-cell keep-together.within-column="always"
                                        padding="3pt" border="0.5pt solid black">
                                        <fo:block-container overflow="hidden">
                                            <fo:block font-size="10pt">
                                                <xsl:value-of select="ns3:title"/>
                                            </fo:block>
                                        </fo:block-container>
                                    </fo:table-cell>
                                    <fo:table-cell keep-together.within-column="always"
                                        padding="3pt" border="0.5pt solid black">
                                        <fo:block-container overflow="hidden">
                                            <fo:block font-size="10pt">
                                                <xsl:choose>
                                                  <xsl:when
                                                  test="ns4:state='com.ibm.rqm.planning.common.underreview'">
                                                  <xsl:value-of
                                                  select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/com.ibm.rqm.planning.common.underreview"
                                                  />
                                                  </xsl:when>
                                                  <xsl:when
                                                  test="ns4:state='com.ibm.rqm.planning.common.new'">
                                                  <xsl:value-of
                                                  select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/com.ibm.rqm.planning.common.new"
                                                  />
                                                  </xsl:when>
                                                  <xsl:when
                                                  test="ns4:state='com.ibm.rqm.planning.common.approved'">
                                                  <xsl:value-of
                                                  select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/com.ibm.rqm.planning.common.approved"
                                                  />
                                                  </xsl:when>
                                                </xsl:choose>
                                            </fo:block>
                                        </fo:block-container>
                                    </fo:table-cell>
                                    <fo:table-cell keep-together.within-column="always"
                                        padding="3pt" border="0.5pt solid black">
                                        <fo:block-container overflow="hidden">
                                            <fo:block font-size="10pt">
                                                <xsl:value-of select="ts:scripttype"/>
                                            </fo:block>
                                        </fo:block-container>
                                    </fo:table-cell>
                                    <fo:table-cell keep-together.within-column="always"
                                        padding="3pt" border="0.5pt solid black">
                                        <fo:block-container overflow="hidden">
                                            <fo:block font-size="10pt">
                                                <xsl:value-of select="ns4:updated"/>
                                            </fo:block>
                                        </fo:block-container>
                                    </fo:table-cell>
                                </fo:table-row>
                            </fo:table-body>
                        </fo:table>
                    </xsl:when>
                    <xsl:otherwise>
                        <fo:table-row keep-together="always">
                            <fo:table-cell keep-together.within-column="always" padding="3pt"
                                border="0.5pt solid black">
                                <fo:block-container overflow="hidden">
                                    <fo:block font-size="10pt">
                                        <xsl:variable name="ident"
                                            select="*[local-name()='identifier']"/>
                                        <xsl:value-of select="substring-after($ident,'testscript:')"
                                        />
                                    </fo:block>
                                </fo:block-container>
                            </fo:table-cell>
                            <fo:table-cell keep-together.within-column="always" padding="3pt"
                                border="0.5pt solid black">
                                <fo:block-container overflow="hidden">
                                    <fo:block font-size="10pt">
                                        <xsl:value-of select="ns3:title"/>
                                    </fo:block>
                                </fo:block-container>
                            </fo:table-cell>
                            <fo:table-cell keep-together.within-column="always" padding="3pt"
                                border="0.5pt solid black">
                                <fo:block-container overflow="hidden">
                                    <fo:block font-size="10pt">
                                        <xsl:choose>
                                            <xsl:when
                                                test="ns4:state='com.ibm.rqm.planning.common.underreview'">
                                                <xsl:value-of
                                                  select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/com.ibm.rqm.planning.common.underreview"
                                                />
                                            </xsl:when>
                                            <xsl:when
                                                test="ns4:state='com.ibm.rqm.planning.common.new'">
                                                <xsl:value-of
                                                  select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/com.ibm.rqm.planning.common.new"
                                                />
                                            </xsl:when>
                                            <xsl:when
                                                test="ns4:state='com.ibm.rqm.planning.common.approved'">
                                                <xsl:value-of
                                                  select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/com.ibm.rqm.planning.common.approved"
                                                />
                                            </xsl:when>
                                        </xsl:choose>
                                    </fo:block>
                                </fo:block-container>
                            </fo:table-cell>
                            <fo:table-cell keep-together.within-column="always" padding="3pt"
                                border="0.5pt solid black">
                                <fo:block-container overflow="hidden">
                                    <fo:block font-size="10pt">
                                        <xsl:value-of select="ts:scripttype"/>
                                    </fo:block>
                                </fo:block-container>
                            </fo:table-cell>
                            <fo:table-cell keep-together.within-column="always" padding="3pt"
                                border="0.5pt solid black">
                                <fo:block-container overflow="hidden">
                                    <fo:block font-size="10pt">
                                        <xsl:value-of select="ns4:updated"/>
                                    </fo:block>
                                </fo:block-container>
                            </fo:table-cell>
                        </fo:table-row>
                    </xsl:otherwise>
                </xsl:choose>
            </xsl:when>
            <xsl:when test="(../../componentType='COMPOSITE') and (../../recursive)">
                <fo:wrapper>
                    <fo:table-row keep-together="always">
                        <fo:table-cell keep-together.within-column="always" padding="3pt"
                            border="0.5pt solid black">
                            <fo:block-container overflow="hidden">
                                <fo:block font-size="10pt">
                                    <xsl:variable name="ident" select="*[local-name()='identifier']"/>
                                    <xsl:value-of select="substring-after($ident,'testscript:')"/>
                                </fo:block>
                            </fo:block-container>
                        </fo:table-cell>
                        <fo:table-cell keep-together.within-column="always" padding="3pt"
                            border="0.5pt solid black">
                            <fo:block-container overflow="hidden">
                                <fo:block font-size="10pt">
                                    <fo:basic-link
                                        internal-destination="{*[local-name()='identifier']}"
                                        color="blue" text-decoration="underline">
                                        <xsl:value-of select="ns3:title"/>
                                    </fo:basic-link>
                                </fo:block>
                            </fo:block-container>
                        </fo:table-cell>
                        <fo:table-cell keep-together.within-column="always" padding="3pt"
                            border="0.5pt solid black">
                            <fo:block-container overflow="hidden">
                                <fo:block font-size="10pt">
                                    <xsl:choose>
                                        <xsl:when
                                            test="ns4:state='com.ibm.rqm.planning.common.underreview'">
                                            <xsl:value-of
                                                select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/com.ibm.rqm.planning.common.underreview"
                                            />
                                        </xsl:when>
                                        <xsl:when test="ns4:state='com.ibm.rqm.planning.common.new'">
                                            <xsl:value-of
                                                select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/com.ibm.rqm.planning.common.new"
                                            />
                                        </xsl:when>
                                        <xsl:when
                                            test="ns4:state='com.ibm.rqm.planning.common.approved'">
                                            <xsl:value-of
                                                select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/com.ibm.rqm.planning.common.approved"
                                            />
                                        </xsl:when>
                                    </xsl:choose>
                                </fo:block>
                            </fo:block-container>
                        </fo:table-cell>
                        <fo:table-cell keep-together.within-column="always" padding="3pt"
                            border="0.5pt solid black">
                            <fo:block-container overflow="hidden">
                                <fo:block font-size="10pt">
                                    <xsl:value-of select="ts:scripttype"/>
                                </fo:block>
                            </fo:block-container>
                        </fo:table-cell>
                        <fo:table-cell keep-together.within-column="always" padding="3pt"
                            border="0.5pt solid black">
                            <fo:block-container overflow="hidden">
                                <fo:block font-size="10pt">
                                    <xsl:value-of select="ns4:updated"/>
                                </fo:block>
                            </fo:block-container>
                        </fo:table-cell>
                    </fo:table-row>
                    <fo:block xmlns:fo="http://www.w3.org/1999/XSL/Format">
                        <xsl:attribute name="id">
                            <xsl:value-of select="*[local-name()='identifier']"/>
                        </xsl:attribute>
                        <fo:block font-size="14pt" space-before="2mm" space-after="2mm"
                            border-after-style="solid" border-after-width="thin">
                            <xsl:value-of
                                select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/labelTestScript"
                            /> : <xsl:value-of select="ns3:title"/>
                        </fo:block>
                        <fo:block space-after="2mm">
                            <xsl:value-of
                                select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/labelScriptType"
                            /> : <xsl:value-of select="ts:scripttype"/>
                        </fo:block>
                        <fo:block space-after="4mm">
                            <xsl:value-of
                                select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/labeldescription"
                            /> : <xsl:value-of select="ns3:description"/>
                        </fo:block>
                        <xsl:apply-templates select="ts:steps"/>
                    </fo:block>
                </fo:wrapper>
            </xsl:when>
            <xsl:otherwise>
                <fo:block xmlns:fo="http://www.w3.org/1999/XSL/Format">
                    <xsl:if test="(../../componentType='COMPOSITE' )">
                        <xsl:attribute name="id">
                            <xsl:value-of select="ns3:identifier"/>
                        </xsl:attribute>
                        <xsl:attribute name="break-after">page</xsl:attribute>
                    </xsl:if>
                    <fo:block font-size="14pt" space-before="2mm" space-after="2mm"
                        border-after-style="solid" border-after-width="thin">
                        <xsl:value-of
                            select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/labelTestScript"
                        /> : <xsl:value-of select="ns3:title"/>
                    </fo:block>
                    <fo:block space-after="2mm">
                        <xsl:value-of
                            select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/labelScriptType"
                        /> : <xsl:value-of select="ts:scripttype"/>
                    </fo:block>
                    <fo:block space-after="4mm">
                        <xsl:value-of
                            select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/labeldescription"
                        /> : <xsl:value-of select="ns3:description"/>
                    </fo:block>
                    <xsl:apply-templates select="ts:steps"/>
                </fo:block>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>
    <xsl:template match="ts:steps">
        <xsl:if test="ns9:step">
            <fo:block space-after="4mm">
                <xsl:value-of
                    select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/labelScriptSteps"
                />
            </fo:block>
            <fo:table border="0.5pt solid black">
                <fo:table-column column-width="6mm"/>
                <fo:table-column column-width="25mm"/>
                <fo:table-column/>
                <fo:table-column/>
                <fo:table-header>
                    <fo:table-cell keep-together.within-column="always"
                        background-color="rgb(222,242,236)">
                        <fo:block-container overflow="hidden">
                            <fo:block font-weight="bold" text-align="left">#</fo:block>
                        </fo:block-container>
                    </fo:table-cell>
                    <fo:table-cell keep-together.within-column="always"
                        background-color="rgb(222,242,236)">
                        <fo:block-container overflow="hidden">
                            <fo:block font-weight="bold" text-align="left">
                                <xsl:value-of
                                    select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/labelType"
                                />
                            </fo:block>
                        </fo:block-container>
                    </fo:table-cell>
                    <fo:table-cell keep-together.within-column="always"
                        background-color="rgb(222,242,236)">
                        <fo:block-container overflow="hidden">
                            <fo:block font-weight="bold" text-align="left">
                                <xsl:value-of
                                    select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/labeldescription"
                                />
                            </fo:block>
                        </fo:block-container>
                    </fo:table-cell>
                    <fo:table-cell keep-together.within-column="always"
                        background-color="rgb(222,242,236)">
                        <fo:block-container overflow="hidden">
                            <fo:block font-weight="bold" text-align="left">
                                <xsl:value-of
                                    select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/labelExpectedResult"
                                />
                            </fo:block>
                        </fo:block-container>
                    </fo:table-cell>
                </fo:table-header>
                <fo:table-body>
                    <xsl:apply-templates select="ns9:step"/>
                </fo:table-body>
            </fo:table>
        </xsl:if>
    </xsl:template>
    <xsl:template match="ns9:step">
        <xsl:choose>
            <xsl:when test="count(ancestor::ns9:step) &gt; 0">
                <fo:block>
                    <xsl:attribute name="text-indent">
                        <xsl:value-of select="concat(count(ancestor::ns9:step) * .75,'cm')"/>
                    </xsl:attribute>
                    <xsl:apply-templates select="ns9:description"/>
                    <xsl:apply-templates select="ns9:step"/>
                </fo:block>
            </xsl:when>
            <xsl:otherwise>
                <fo:table-row keep-together="always">
                    <fo:table-cell keep-together.within-column="always" padding="3pt"
                        border="0.5pt solid black">
                        <fo:block-container overflow="hidden">
                            <fo:block font-size="10pt">
                                <xsl:number/>
                            </fo:block>
                        </fo:block-container>
                    </fo:table-cell>
                    <fo:table-cell keep-together.within-column="always" padding="3pt"
                        border="0.5pt solid black">
                        <fo:block-container overflow="hidden">
                            <fo:block font-size="10pt" text-align="left">
                                <xsl:choose>
                                    <xsl:when test="@type='execution'">
                                        <xsl:value-of
                                            select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/labelExecutionStep"
                                        />
                                    </xsl:when>
                                    <xsl:when test="@type='verification'">
                                        <xsl:value-of
                                            select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/labelVerificationPoint"
                                        />
                                    </xsl:when>
                                    <xsl:when test="@type='reporting'">
                                        <xsl:value-of
                                            select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/labelReportingStep"
                                        />
                                    </xsl:when>
                                </xsl:choose>
                            </fo:block>
                        </fo:block-container>
                    </fo:table-cell>
                    <fo:table-cell keep-together.within-column="always" padding="3pt"
                        border="0.5pt solid black">
                        <fo:block-container overflow="hidden">
                            <fo:block text-align="left">
                                <xsl:apply-templates select="ns9:description"/>
                                <xsl:apply-templates select="ns9:step"/>
                            </fo:block>
                        </fo:block-container>
                    </fo:table-cell>
                    <fo:table-cell keep-together.within-column="always" padding="3pt"
                        border="0.5pt solid black">
                        <fo:block-container overflow="hidden">
                            <fo:block text-align="left">
                                <xsl:apply-templates select="ns9:expectedResult"/>
                            </fo:block>
                        </fo:block-container>
                    </fo:table-cell>
                </fo:table-row>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>
    <xsl:template match="ns9:*">
        <xsl:apply-templates select="*|text()"/>
    </xsl:template>
</xsl:stylesheet>
