<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:fo="http://www.w3.org/1999/XSL/Format"
    xmlns:ns9="http://jazz.net/xmlns/alm/qm/v0.1/#extension"
    xmlns:ns8="http://jazz.net/xmlns/alm/qm/v0.1/tsl/v0.1/"
    xmlns:ns7="http://jazz.net/xmlns/alm/qm/v0.1/executionworkitem/v0.1"
    xmlns:ns6="http://jazz.net/xmlns/alm/qm/v0.1/executionresult/v0.1"
    xmlns:ns5="http://jazz.net/xmlns/alm/qm/v0.1/testscript/v0.1/"
    xmlns:ns3="http://purl.org/dc/elements/1.1/" xmlns:ns4="http://jazz.net/xmlns/alm/v0.1/"
    xmlns:ns2="http://schema.ibm.com/vega/2008/" xmlns:ts="http://jazz.net/xmlns/alm/qm/v0.1/"
    xmlns:atom="http://www.w3.org/2005/Atom"
    exclude-result-prefixes="ns9 ns8 ns7 ns6 ns5 ns4 ns3 ns2 atom xsl">
    <xsl:variable name="lang">
        <xsl:value-of select="locale"/>
    </xsl:variable>
    <xsl:include href="xhtml-to-xslfo.xsl"/>
    <xsl:template match="transformArgs">
        <xsl:choose>
            <xsl:when test="(componentType='STAND_ALONE') or (componentType='STAND_ALONE_SUMMARY')">
                <fo:page-sequence xmlns:fo="http://www.w3.org/1999/XSL/Format"
                    initial-page-number="1" force-page-count="no-force"
                    master-reference="PageMaster">
                    <fo:static-content flow-name="xsl-region-before">
                        <fo:block font-size="8pt" text-align="right">
                            <fo:page-number/> / <fo:page-number-citation ref-id="{reqNumber}"/>
                        </fo:block>
                    </fo:static-content>
                    <fo:static-content flow-name="xsl-region-after">
                        <fo:block text-align="center">
                            <fo:retrieve-marker retrieve-class-name="artifactUri"/>
                        </fo:block>
                    </fo:static-content>
                    <fo:flow flow-name="xsl-region-body">
                        <fo:marker marker-class-name="artifactUri">
                            <fo:block font-size="6pt">
                                <fo:basic-link external-destination="{originUrl}" color="blue"
                                    text-decoration="underline">
                                    <xsl:value-of select="originUrl"/>
                                </fo:basic-link>
                            </fo:block>
                        </fo:marker>
                        <xsl:apply-templates select="descendant::ts:testsuite"/>
                        <fo:block id="{reqNumber}"/>
                    </fo:flow>
                </fo:page-sequence>
            </xsl:when>
            <xsl:otherwise>
                <xsl:apply-templates select="descendant::ts:testsuite"/>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>
    <xsl:template match="ts:testsuite">
        <xsl:choose>
            <xsl:when
                test="(../../componentType='SUMMARY') or (../../componentType='STAND_ALONE_SUMMARY') or (../../componentType='COMPOSITE_SUMMARY')">
                <xsl:choose>
                    <xsl:when
                        test="../../componentType='STAND_ALONE_SUMMARY' or (../../componentType='COMPOSITE_SUMMARY')">
                        <xsl:if test="../../componentType='STAND_ALONE_SUMMARY'">
                            <fo:block font-size="14pt" space-before="6mm" space-after="2mm"
                                    ><xsl:value-of
                                    select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/labelSummary"
                                />: <xsl:value-of
                                    select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/labelTestSuite"
                                /></fo:block>
                        </xsl:if>
                        <fo:table border="0.5pt solid black">
                            <fo:table-header>
                                <fo:table-row keep-togther="always"
                                    background-color="rgb(249,245,219)">
                                    <fo:table-cell keep-together.within-column="always"
                                        border="0.5pt solid black">
                                        <fo:block-container overflow="hidden">
                                            <fo:block font-weight="bold">
                                                <xsl:value-of
                                                  select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/labelId"
                                                />
                                            </fo:block>
                                        </fo:block-container>
                                    </fo:table-cell>
                                    <fo:table-cell keep-together.within-column="always"
                                        border="0.5pt solid black">
                                        <fo:block-container overflow="hidden">
                                            <fo:block font-weight="bold">
                                                <xsl:value-of
                                                  select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/labelName"
                                                />
                                            </fo:block>
                                        </fo:block-container>
                                    </fo:table-cell>
                                    <fo:table-cell keep-together.within-column="always"
                                        border="0.5pt solid black">
                                        <fo:block-container overflow="hidden">
                                            <fo:block font-weight="bold">
                                                <xsl:value-of
                                                  select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/labelState"
                                                />
                                            </fo:block>
                                        </fo:block-container>
                                    </fo:table-cell>
                                    <fo:table-cell keep-together.within-column="always"
                                        border="0.5pt solid black">
                                        <fo:block-container overflow="hidden">
                                            <fo:block font-weight="bold">
                                                <xsl:value-of
                                                  select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/labelOwner"
                                                />
                                            </fo:block>
                                        </fo:block-container>
                                    </fo:table-cell>
                                    <fo:table-cell keep-together.within-column="always"
                                        border="0.5pt solid black">
                                        <fo:block-container overflow="hidden">
                                            <fo:block font-weight="bold">
                                                <xsl:value-of
                                                  select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/labelModifiedDate"
                                                />
                                            </fo:block>
                                        </fo:block-container>
                                    </fo:table-cell>
                                </fo:table-row>
                            </fo:table-header>
                            <fo:table-body>
                                <fo:table-row keep-togther="always">
                                    <fo:table-cell keep-together.within-column="always"
                                        padding="3pt" border="0.5pt solid black">
                                        <fo:block-container overflow="hidden">
                                            <fo:block font-size="10pt">
                                                <xsl:variable name="ident" select="ns3:identifier"/>
                                                <xsl:value-of
                                                  select="substring-after($ident,'testsuite:')"/>
                                            </fo:block>
                                        </fo:block-container>
                                    </fo:table-cell>
                                    <fo:table-cell keep-together.within-column="always"
                                        padding="3pt" border="0.5pt solid black">
                                        <fo:block-container overflow="hidden">
                                            <fo:block font-size="10pt">
                                                <xsl:value-of select="ns3:title"/>
                                            </fo:block>
                                        </fo:block-container>
                                    </fo:table-cell>
                                    <fo:table-cell keep-together.within-column="always"
                                        padding="3pt" border="0.5pt solid black">
                                        <fo:block-container overflow="hidden">
                                            <fo:block>
                                                <xsl:choose>
                                                  <xsl:when
                                                  test="ns4:state='com.ibm.rqm.planning.common.new'">
                                                  <xsl:value-of
                                                  select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/com.ibm.rqm.planning.common.new"
                                                  />
                                                  </xsl:when>
                                                  <xsl:when
                                                  test="ns4:state='com.ibm.rqm.planning.common.underreview'">
                                                  <xsl:value-of
                                                  select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/com.ibm.rqm.planning.common.underreview"
                                                  />
                                                  </xsl:when>
                                                  <xsl:when
                                                  test="ns4:state='com.ibm.rqm.planning.common.approved'">
                                                  <xsl:value-of
                                                  select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/com.ibm.rqm.planning.common.approved"
                                                  />
                                                  </xsl:when>
                                                  <xsl:otherwise>
                                                  <xsl:value-of
                                                  select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/labelUnassigned"
                                                  />
                                                  </xsl:otherwise>
                                                </xsl:choose>
                                            </fo:block>
                                        </fo:block-container>
                                    </fo:table-cell>
                                    <fo:table-cell keep-together.within-column="always"
                                        padding="3pt" border="0.5pt solid black">
                                        <fo:block-container overflow="hidden">
                                            <fo:block font-size="10pt">
                                                <xsl:value-of select="ns4:owner"/>
                                            </fo:block>
                                        </fo:block-container>
                                    </fo:table-cell>
                                    <fo:table-cell keep-together.within-column="always"
                                        padding="3pt" border="0.5pt solid black">
                                        <fo:block-container overflow="hidden">
                                            <fo:block font-size="10pt">
                                                <xsl:value-of select="ns4:updated"/>
                                            </fo:block>
                                        </fo:block-container>
                                    </fo:table-cell>
                                </fo:table-row>
                            </fo:table-body>
                        </fo:table>
                    </xsl:when>
                    <xsl:otherwise>
                        <fo:table-row keep-togther="always">
                            <fo:table-cell keep-together.within-column="always" padding="3pt"
                                border="0.5pt solid black">
                                <fo:block-container overflow="hidden">
                                    <fo:block font-size="10pt">
                                        <xsl:variable name="ident" select="ns3:identifier"/>
                                        <xsl:value-of select="substring-after($ident,'testsuite:')"
                                        />
                                    </fo:block>
                                </fo:block-container>
                            </fo:table-cell>
                            <fo:table-cell keep-together.within-column="always" padding="3pt"
                                border="0.5pt solid black">
                                <fo:block-container overflow="hidden">
                                    <fo:block font-size="10pt">
                                        <xsl:value-of select="ns3:title"/>
                                    </fo:block>
                                </fo:block-container>
                            </fo:table-cell>
                            <fo:table-cell keep-together.within-column="always" padding="3pt"
                                border="0.5pt solid black">
                                <fo:block-container overflow="hidden">
                                    <fo:block>
                                        <xsl:choose>
                                            <xsl:when
                                                test="ns4:state='com.ibm.rqm.planning.common.new'">
                                                <xsl:value-of
                                                  select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/com.ibm.rqm.planning.common.new"
                                                />
                                            </xsl:when>
                                            <xsl:when
                                                test="ns4:state='com.ibm.rqm.planning.common.underreview'">
                                                <xsl:value-of
                                                  select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/com.ibm.rqm.planning.common.underreview"
                                                />
                                            </xsl:when>
                                            <xsl:when
                                                test="ns4:state='com.ibm.rqm.planning.common.approved'">
                                                <xsl:value-of
                                                  select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/com.ibm.rqm.planning.common.approved"
                                                />
                                            </xsl:when>
                                            <xsl:otherwise>
                                                <xsl:value-of
                                                  select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/labelUnassigned"
                                                />
                                            </xsl:otherwise>
                                        </xsl:choose>
                                    </fo:block>
                                </fo:block-container>
                            </fo:table-cell>
                            <fo:table-cell keep-together.within-column="always" padding="3pt"
                                border="0.5pt solid black">
                                <fo:block-container overflow="hidden">
                                    <fo:block font-size="10pt">
                                        <xsl:value-of select="ns4:owner"/>
                                    </fo:block>
                                </fo:block-container>
                            </fo:table-cell>
                            <fo:table-cell keep-together.within-column="always" padding="3pt"
                                border="0.5pt solid black">
                                <fo:block-container overflow="hidden">
                                    <fo:block font-size="10pt">
                                        <xsl:value-of select="ns4:updated"/>
                                    </fo:block>
                                </fo:block-container>
                            </fo:table-cell>
                        </fo:table-row>
                    </xsl:otherwise>
                </xsl:choose>
            </xsl:when>
            <xsl:otherwise>
                <fo:block xmlns:fo="http://www.w3.org/1999/XSL/Format">
                    <xsl:if test="(../../componentType='COMPOSITE' )">
                        <xsl:attribute name="break-after">page</xsl:attribute>
                    </xsl:if>
                    <fo:block font-size="14pt" space-after="4mm"><xsl:value-of
                            select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/labelTestSuite"
                        />: <xsl:value-of select="ns3:title"/></fo:block>
                    <fo:table>
                        <fo:table-body>
                            <fo:table-row keep-togther="always">
                                <fo:table-cell keep-together.within-column="always">
                                    <fo:block-container overflow="hidden">
                                        <fo:block>
                                            <xsl:value-of
                                                select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/labelState"
                                            />: <xsl:choose>
                                                <xsl:when
                                                  test="ns4:state='com.ibm.rqm.planning.common.new'">
                                                  <xsl:value-of
                                                  select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/com.ibm.rqm.planning.common.new"
                                                  />
                                                </xsl:when>
                                                <xsl:when
                                                  test="ns4:state='com.ibm.rqm.planning.common.underreview'">
                                                  <xsl:value-of
                                                  select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/com.ibm.rqm.planning.common.underreview"
                                                  />
                                                </xsl:when>
                                                <xsl:when
                                                  test="ns4:state='com.ibm.rqm.planning.common.approved'">
                                                  <xsl:value-of
                                                  select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/com.ibm.rqm.planning.common.approved"
                                                  />
                                                </xsl:when>
                                                <xsl:otherwise>
                                                  <xsl:value-of
                                                  select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/labelUnassigned"
                                                  />
                                                </xsl:otherwise>
                                            </xsl:choose>
                                        </fo:block>
                                    </fo:block-container>
                                </fo:table-cell>
                                <fo:table-cell keep-together.within-column="always">
                                    <fo:block-container overflow="hidden">
                                        <fo:block>
                                            <xsl:value-of select="ns4:updated"/>
                                        </fo:block>
                                    </fo:block-container>
                                </fo:table-cell>
                            </fo:table-row>
                        </fo:table-body>
                    </fo:table>
                    <fo:block space-after="4mm"><xsl:value-of
                            select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/labeldescription"
                        />: <xsl:value-of select="ns3:description"/></fo:block>
                    <xsl:if test="ns9:com.ibm.rqm.execution.editor.section.summary">
                        <fo:block font-size="12pt" space-after="2mm"><xsl:value-of
                                select="ns9:com.ibm.rqm.execution.editor.section.summary/@extensionDisplayName"
                            />:</fo:block>
                        <fo:block space-after="4mm">
                            <xsl:apply-templates
                                select="ns9:com.ibm.rqm.execution.editor.section.summary"/>
                        </fo:block>
                    </xsl:if>
                    <xsl:if test="../../atom:elementDetails/atom:element">
                        <fo:block font-size="13pt" space-after="4mm">
                            <fo:block><xsl:value-of
                                    select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/labelTestCases"
                                />:</fo:block>
                            <fo:table border="0.5pt solid black" text-align="left">
                                <fo:table-header>
                                    <fo:table-row keep-togther="always"
                                        background-color="rgb(249,245,219)">
                                        <fo:table-cell keep-together.within-column="always"
                                            border="0.5pt solid black">
                                            <fo:block-container overflow="hidden">
                                                <fo:block font-size="10pt" font-weight="bold">
                                                  <xsl:value-of
                                                  select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/labelTestCase"
                                                  />
                                                </fo:block>
                                            </fo:block-container>
                                        </fo:table-cell>
                                        <fo:table-cell keep-together.within-column="always"
                                            border="0.5pt solid black">
                                            <fo:block-container overflow="hidden">
                                                <fo:block font-size="10pt" font-weight="bold">
                                                  <xsl:value-of
                                                  select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/labelTestEnvironment"
                                                  />
                                                </fo:block>
                                            </fo:block-container>
                                        </fo:table-cell>
                                        <fo:table-cell keep-together.within-column="always"
                                            border="0.5pt solid black">
                                            <fo:block-container overflow="hidden">
                                                <fo:block font-size="10pt" font-weight="bold">
                                                  <xsl:value-of
                                                  select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/labelTestPlan"
                                                  />
                                                </fo:block>
                                            </fo:block-container>
                                        </fo:table-cell>
                                        <fo:table-cell keep-together.within-column="always"
                                            border="0.5pt solid black">
                                            <fo:block-container overflow="hidden">
                                                <fo:block font-size="10pt" font-weight="bold">
                                                  <xsl:value-of
                                                  select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/labelState"
                                                  />
                                                </fo:block>
                                            </fo:block-container>
                                        </fo:table-cell>
                                        <fo:table-cell keep-together.within-column="always"
                                            border="0.5pt solid black">
                                            <fo:block-container overflow="hidden">
                                                <fo:block font-size="10pt" font-weight="bold">
                                                  <xsl:value-of
                                                  select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/labelTestScript"
                                                  />
                                                </fo:block>
                                            </fo:block-container>
                                        </fo:table-cell>
                                        <fo:table-cell keep-together.within-column="always"
                                            border="0.5pt solid black">
                                            <fo:block-container overflow="hidden">
                                                <fo:block font-size="10pt" font-weight="bold">
                                                  <xsl:value-of
                                                  select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/labelModifiedDate"
                                                  />
                                                </fo:block>
                                            </fo:block-container>
                                        </fo:table-cell>
                                    </fo:table-row>
                                </fo:table-header>
                                <fo:table-body>
                                    <xsl:for-each select="../../atom:elementDetails/atom:element">
                                        <fo:table-row keep-togther="always">
                                            <fo:table-cell keep-together.within-column="always"
                                                padding="3pt" border="0.5pt solid black">
                                                <fo:block-container overflow="hidden">
                                                  <fo:block font-size="10pt">
                                                  <xsl:call-template name="FormatText">
                                                  <xsl:with-param name="Text"
                                                  select="atom:elementName"/>
                                                  <xsl:with-param name="MaxLength" select="'10'"/>
                                                  </xsl:call-template>
                                                  </fo:block>
                                                </fo:block-container>
                                            </fo:table-cell>
                                            <fo:table-cell keep-together.within-column="always"
                                                padding="3pt" border="0.5pt solid black">
                                                <fo:block-container overflow="hidden">
                                                  <fo:block font-size="10pt">
                                                  <xsl:choose>
                                                  <xsl:when test="atom:elementTc">
                                                  <xsl:call-template name="FormatText">
                                                  <xsl:with-param name="Text"
                                                  select="atom:elementTc"/>
                                                  <xsl:with-param name="MaxLength" select="'10'"/>
                                                  </xsl:call-template>
                                                  </xsl:when>
                                                  <xsl:otherwise>
                                                  <xsl:value-of
                                                  select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/labelUnassigned"
                                                  />
                                                  </xsl:otherwise>
                                                  </xsl:choose>
                                                  </fo:block>
                                                </fo:block-container>
                                            </fo:table-cell>
                                            <fo:table-cell keep-together.within-column="always"
                                                padding="3pt" border="0.5pt solid black">
                                                <fo:block-container overflow="hidden">
                                                  <fo:block font-size="10pt">
                                                  <xsl:choose>
                                                  <xsl:when test="atom:elementTp">
                                                  <xsl:value-of select="atom:elementTp"/>
                                                  </xsl:when>
                                                  <xsl:otherwise>
                                                  <xsl:value-of
                                                  select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/labelUnassigned"
                                                  />
                                                  </xsl:otherwise>
                                                  </xsl:choose>
                                                  </fo:block>
                                                </fo:block-container>
                                            </fo:table-cell>
                                            <fo:table-cell keep-together.within-column="always"
                                                padding="3pt" border="0.5pt solid black">
                                                <fo:block-container overflow="hidden">
                                                  <fo:block font-size="10pt">
                                                  <xsl:choose>
                                                  <xsl:when
                                                  test="atom:elementState='com.ibm.rqm.planning.common.new'">
                                                  <xsl:value-of
                                                  select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/com.ibm.rqm.planning.common.new"
                                                  />
                                                  </xsl:when>
                                                  <xsl:when
                                                  test="atom:elementState='com.ibm.rqm.planning.common.underreview'">
                                                  <xsl:value-of
                                                  select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/com.ibm.rqm.planning.common.underreview"
                                                  />
                                                  </xsl:when>
                                                  <xsl:when
                                                  test="atom:elementState='com.ibm.rqm.planning.common.approved'">
                                                  <xsl:value-of
                                                  select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/com.ibm.rqm.planning.common.approved"
                                                  />
                                                  </xsl:when>
                                                  <xsl:otherwise>
                                                  <xsl:value-of
                                                  select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/labelUnassigned"
                                                  />
                                                  </xsl:otherwise>
                                                  </xsl:choose>
                                                  </fo:block>
                                                </fo:block-container>
                                            </fo:table-cell>
                                            <fo:table-cell keep-together.within-column="always"
                                                padding="3pt" border="0.5pt solid black">
                                                <fo:block-container overflow="hidden">
                                                  <fo:block font-size="10pt">
                                                  <xsl:choose>
                                                  <xsl:when test="atom:elementTs">
                                                  <xsl:value-of select="atom:elementTs"/>
                                                  </xsl:when>
                                                  <xsl:otherwise>
                                                  <xsl:value-of
                                                  select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/labelUnassigned"
                                                  />
                                                  </xsl:otherwise>
                                                  </xsl:choose>
                                                  </fo:block>
                                                </fo:block-container>
                                            </fo:table-cell>
                                            <fo:table-cell keep-together.within-column="always"
                                                padding="3pt" border="0.5pt solid black">
                                                <fo:block-container overflow="hidden">
                                                  <fo:block font-size="10pt">
                                                  <xsl:value-of select="atom:elementMod"/>
                                                  </fo:block>
                                                </fo:block-container>
                                            </fo:table-cell>
                                        </fo:table-row>
                                    </xsl:for-each>
                                </fo:table-body>
                            </fo:table>
                        </fo:block>
                    </xsl:if>
                </fo:block>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>
    <xsl:template name="FormatText">
        <xsl:param name="Text"/>
        <xsl:param name="MaxLength"/>
        <xsl:choose>
            <xsl:when test="string-length($Text) &gt; number($MaxLength)">
                <xsl:value-of select="substring($Text,1,number($MaxLength))"/>
                <xsl:text>...</xsl:text>
            </xsl:when>
            <xsl:otherwise>
                <xsl:value-of select="$Text"/>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>
    <xsl:template match="atom:RQM-KEY-EXE-SUMMARY-TITLE">
        <xsl:apply-templates select="*|text()"/>
    </xsl:template>
</xsl:stylesheet>
