/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.rqm.defects.web.client.internal.CmIntegrationClient");

dojo.require("com.ibm.team.repository.web.transport.ServiceRequest");
dojo.require("com.ibm.team.repository.web.transport.TeamServerClient");
dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");
dojo.require("com.ibm.team.repository.web.foundation.Status");
dojo.require("com.ibm.team.process.web.client.projectarea");

(function() {

var ServiceRequest					= com.ibm.team.repository.web.transport.ServiceRequest;
var TeamServerClient				= com.ibm.team.repository.web.transport.TeamServerClient;
var ServiceResponseHandler			= com.ibm.team.repository.web.transport.ServiceResponseHandler;
var Status							= com.ibm.team.repository.web.foundation.Status;
var getCurrentPA            		= com.ibm.team.process.web.client.projectarea.getCurrentProjectArea;

var SERVICE_URI						= "com.ibm.rqm.defects.service.internal.rest.ICmIntegrationRestService";

var EWI_BLOCKING_DEFECT 			= "com.ibm.rqm.execution.linktype.ewiblockingdefect";
var RESULT_RELATEDTO_DEFECT 		= "com.ibm.rqm.execution.linktype.eresultrelatedtodefect";

com.ibm.rqm.defects.web.client.internal.CmIntegrationClient= {

	// ---- api ------------------------------------------------------------------------------------------------------------

	postNewLink: function(linkParams, responceCallback) {
		this._invokeTeamConcertConnectionService("postNewLink", responceCallback, linkParams);
	},
	
	postBlockDefect: function(postParams, responceCallback) {
		this._invokeTeamConcertConnectionService("postBlockDefect", responceCallback, postParams);
	},
	
	postAssociatedWorkItems: function(workItemIdentification, responceCallback) {
		this._invokeTeamConcertConnectionService("postAssociatedWorkItems", responceCallback, workItemIdentification);
	},
	
	postDeleteLink: function(postParams, responceCallback){
		this._invokeTeamConcertConnectionService("postDeleteLink", responceCallback, postParams);
	},
	
	postNewPlanItemLinks: function(postParams, responseCallback) {
		this._invokeTeamConcertConnectionService("postNewPlanItemLinks", responseCallback, postParams);
	},
	
	getPlanItemLinks: function(getParams, responseCallback) {
		this._invokeTeamConcertConnectionService("getPlanItemLinks", responseCallback, getParams);
	},
	
	postDeletePlanItemLinks: function(postParams, responseCallback) {
		this._invokeTeamConcertConnectionService("postDeletePlanItemLinks", responseCallback, postParams);
	},
	
	getReferencedDefects: function(getParams, responseCallback){
		this._invokeTeamConcertConnectionService("getReferencedDefects", responseCallback, getParams);
	},
	
	getReferencedDefectsFromMultipleEWIs: function(getParams, responseCallback){
		this._invokeTeamConcertConnectionService("getReferencedDefectsFromMultipleEWIs", responseCallback, getParams);
	},
	// ---- implementation -------------------------------------------------------------------------------------------------

	_invokeTeamConcertConnectionService: function(method, serviceCallback, appArgs) {
		// scope each service call to current project area
		if (!appArgs) {
			var appArgs = {};
		}
		appArgs.rqmProjectAreaItemId = getCurrentPA().itemId;
		appArgs.projectAreaItemId = getCurrentPA().itemId;
		var serviceRequest= new ServiceRequest(SERVICE_URI, method, appArgs);
		var serviceResponseHandler= new ServiceResponseHandler({
			success: function(result) {
				serviceCallback(Status.OK_STATUS, result);
			},
			failure: function(error) {
				serviceCallback(new Status(Status.ERROR, error.message, error), null);
			}
		}, "success", "failure");

		TeamServerClient.invokeService(serviceRequest, serviceResponseHandler);
	},

	__sentinel: null // terminates this class definition
};

	com.ibm.rqm.defects.web.client.internal.CmIntegrationClient.EWI_BLOCKING_DEFECT = EWI_BLOCKING_DEFECT;
    com.ibm.rqm.defects.web.client.internal.CmIntegrationClient.RESULT_RELATEDTO_DEFECT = RESULT_RELATEDTO_DEFECT;

})();
