/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.asq.common.web.client.internal.Constants");

(function() {
	
dojo.require("com.ibm.asq.common.web.ui.internal.util.MessageUtil");

com.ibm.asq.common.web.client.internal.Constants = {

	NEW_PAGE_TITLE: "< New _type: _id > ",

	CLASSNAME_PLAN: "TestPlanDTO",
	CLASSNAME_GROUP: "TestCaseGroupDTO",
	CLASSNAME_CASE: "TestCaseDTO",
	CLASSNAME_SCRIPT: "ManualExecutionScriptDTO",
	CLASSNAME_EWI: "ExecutionWorkItemDTO",
	CLASSNAME_PLAN_SIZING: "TestPlanWithSizingDTO",
	CLASSNAME_GROUP_SIZING: "TestCaseGroupWithSizingDTO",
	CLASSNAME_CASE_SIZING: "TestCaseWithSizingDTO",
	CLASSNAME_SCRIPT_SIZING: "TestScriptWithSizingDTO",
	
	MODEL_PACKAGE: "com.ibm.rqm.planning",
	MODEL_TYPE_PLAN: "com.ibm.rqm.planning.TestPlan",
	MODEL_TYPE_GROUP: "com.ibm.rqm.planning.TestCaseGroup",
	MODEL_TYPE_CASE: "com.ibm.rqm.planning.TestCase",
	MODEL_TYPE_SCRIPT: "com.ibm.rqm.planning.ManualExecutionScript",
	MODEL_TYPE_UNKNOWN: "Unknown",

	USER_PROJECT_AREAS_OBJECT_ID: "com.ibm.rqm.web.userProjectAreas",
	
	TYPE_WORK_ITEM: "Work Item",
	TYPE_PLAN: "Test Plan",
	TYPE_GROUP: "Test Case Group",
	TYPE_CASE: "Test Case",
	TYPE_SCRIPT: "Test Script",
	TYPE_EWI: "Test Execution Record",		// CML: term
	EWI: "executionworkitem",
	TYPE_EWILIST: "Test Execution Record",	// CML: term
	TYPE_PLAN_SIZING: "Test Plan Sizing",
	TYPE_GROUP_SIZING: "Test Group Sizing",
	TYPE_CASE_SIZING: "Test Case Sizing",
	TYPE_SCRIPT_SIZING: "Test Script Sizing",
	
	STATUS_SUCCESS: "success",
	STATUS_FAILURE: "failure",
	STATUS_SAVING: "saving",
	STATUS_NEW: "new",
	STATUS_DIRTY: "dirty",
	
	TEST_GROUP_WORKITEM_SUMMARY: "Complete Definition of new Test Case Group",
	TEST_CASE_WORKITEM_SUMMARY: "Complete Definition of new Test Case",
		
	//To show initial loading.. and when the lists are empty	
	LOADING: "Loading...",
	NO: "No ",
	FOUND: " Found"	,
	
	/**
     * Return the message from the message bundle with the specified keyword.
     * Optional token arguments are for replacing place holders in the message
     * definition.  The place holders have the syntax "%number" with the number
     * starting from 1.  For example, if the message "myStr" is defined as
     * "This is %1 of %2 message".  getMessage("myStr", "one", "my many") will return
     * "This is one of my many message".
     */
	getMessage: function(keyword, tokens) {
		return MessageUtil.getMessage(MessageBundle.COMMON, keyword, tokens);
    }
		
};

})();
