/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
(function () {
dojo.provide("com.ibm.rqm.planning.web.client.internal.DocumentRestClient");

dojo.require("com.ibm.team.process.web.client.projectarea");
dojo.require("com.ibm.team.repository.web.transport.ServiceRequest");
dojo.require("com.ibm.team.repository.web.transport.TeamServerClient");

var ServiceRequest 			= com.ibm.team.repository.web.transport.ServiceRequest;
var TeamServerClient 		= com.ibm.team.repository.web.transport.TeamServerClient;
var getCurrentProjectArea        = com.ibm.team.process.web.client.projectarea.getCurrentProjectArea;

var DOCUMENT_REST_SERVICE_URI = "com.ibm.rqm.planning.common.service.rest.IDocumentRestService";


function postDocument(serviceResponseHandler, document) {
	// create a wrapper for the document
	var wrapper = {};
	wrapper.documentJsonString = dojo.toJson(document);
	
	var actualArgs= {};
	if (document) {
		actualArgs.documentJsonString = wrapper.documentJsonString;
		actualArgs.processAreaUUID = getCurrentProjectArea().itemId;
	}
	var serviceRequest= new ServiceRequest(DOCUMENT_REST_SERVICE_URI, "postDocument", actualArgs);
	TeamServerClient.invokeService(serviceRequest, serviceResponseHandler);
}

com.ibm.rqm.planning.web.client.internal.DocumentRestClient.postDocument = postDocument;

})();
