/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.client.internal.RegistryClient");

dojo.require("com.ibm.team.repository.web.transport.ServiceRequest");
dojo.require("com.ibm.team.repository.web.transport.TeamServerClient");

(function() { //module container

var ServiceRequest 			= com.ibm.team.repository.web.transport.ServiceRequest;
var TeamServerClient 		= com.ibm.team.repository.web.transport.TeamServerClient;

com.ibm.rqm.planning.web.client.internal.RegistryClient = {

	REGISTRY_SERVICE_URI: "com.ibm.rqm.planning.common.service.rest.IRegistryRestService",

	_invokeService: function(responseHandler, method, appArgs) {
		var actualArgs= {};
		if (appArgs) {
			var jsonArgs= dojo.toJson(appArgs);						
		}
		if(appArgs.paramId)
			actualArgs.paramId = appArgs.paramId; 
		
		var serviceRequest= new ServiceRequest(this.REGISTRY_SERVICE_URI, method, actualArgs);
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	},

	getAllExecutionScriptTypes: function(serviceResponseHandler) {
		this._invokeService(serviceResponseHandler, "getAllExecutionScriptTypes", { });
	},
	
	getAllExecutionElementTypes: function(serviceResponseHandler, testId) {
		this._invokeService(serviceResponseHandler, "getAllExecutionElementTypes", {});
	},
	
	/*
	getAllExecutionResultStateTypes: function(serviceResponseHandler, testId) {
		this._invokeService(serviceResponseHandler, "getAllExecutionResultStateTypes", {});
	},
    */
	
	getAllExecutionFrequencyTypes: function(serviceResponseHandler, testId) {
		this._invokeService(serviceResponseHandler, "getAllExecutionFrequencyTypes", {});
	},

	getAllExecutionEnvironmentTypes: function(serviceResponseHandler, testId) {
		this._invokeService(serviceResponseHandler, "getAllExecutionEnvironmentTypes", {});
	},
			
	getAllExecutionElementResultStateTypes: function(serviceResponseHandler, testId) {
		this._invokeService(serviceResponseHandler, "getAllExecutionElementResultStateTypes", {});
	},
	
	getExecutionEnvironmentTypeValues: function(serviceResponseHandler, testId) {
		this._invokeService(serviceResponseHandler, "getAllExecutionEnvironmentValues", {paramId: testId});
	},
	
	getAllArtifactStateTypes: function(serviceResponseHandler) {
		this._invokeService(serviceResponseHandler, "getAllArtifactStateTypes", { });
	},
	
	getAllArtifactActionTypes: function(serviceResponseHandler) {
		this._invokeService(serviceResponseHandler, "getAllArtifactActionTypes", { });
	},
	
	getAllArtifactTransitions: function(serviceResponseHandler, stateId) {
		this._invokeService(serviceResponseHandler, "getArtifactTransitions", {paramId: stateId});
	},
	
	getAllExtensibleEditorInfo: function(serviceResponseHandler) {
		this._invokeService(serviceResponseHandler, "getAllEditors", { });
	},
	
    getActionBarEntries: function(serviceResponseHandler) {
        this._invokeService(serviceResponseHandler, "getActionBarEntries", { });
    },
	getAllTestActivityTypes: function(serviceResponseHandler) {
        this._invokeService(serviceResponseHandler, "getAllTestActivityTypes", { });
    },
	getAllTriggerTypes: function(serviceResponseHandler) {
        this._invokeService(serviceResponseHandler, "getAllTriggerTypes", { });
    }
		
};

})();
