/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.process.web.client.internal.common.TextContentClient");

var UNSECURE_SERVICE_PREFIX = dojo.baseUrl + "../../public/service/";
var SECURE_SERVICE_PREFIX = dojo.baseUrl + "../../secure/service/";
var CONTENT_TYPE_TEXT = "text";
var CONTENT_SERVICE_URL = "com.ibm.team.repository.common.internal.IContentRestService/content/";

com.ibm.rqm.process.web.client.internal.common.TextContentClient = {
    /*API*/
    getContentById: function(/*content UUID*/uuid, objectScope, callback){
        this._httpGet(this._getServicePrefix() + CONTENT_SERVICE_URL + uuid, objectScope, callback);
    },
    /*internal implementation*/
    _httpGet: function(/*relative path MUST*/url,/*execution scope MUST*/ objectScope,/*MUST*/ successCallbackFunc){
        var arg = {
            "url": url,
            "handleAs": CONTENT_TYPE_TEXT,
            "load": function(response, ioArgs){
                objectScope[successCallbackFunc].call(objectScope, response, ioArgs);
            },
            "error": function(response, ioArgs){
                objectScope[successCallbackFunc].call(objectScope, "", ioArgs);
            }
        };
        dojo.xhrGet(arg);
    },
    
    _getServicePrefix: function(){
        var regex = /^https/;
        return (location.href.match(regex) === null) ? UNSECURE_SERVICE_PREFIX : SECURE_SERVICE_PREFIX;
    }
};
