/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.client.internal.construction.DatapoolInTestScriptClient");

dojo.require("com.ibm.team.repository.web.transport.ServiceRequest");
dojo.require("com.ibm.team.repository.web.transport.TeamServerClient");
dojo.require("com.ibm.team.process.web.client.projectarea");


(function() { //module container

var ServiceRequest 			= com.ibm.team.repository.web.transport.ServiceRequest;
var TeamServerClient 		= com.ibm.team.repository.web.transport.TeamServerClient;
var getCurrentProjectArea = com.ibm.team.process.web.client.projectarea.getCurrentProjectArea;

com.ibm.rqm.planning.web.client.internal.construction.DatapoolInTestScriptClient = {

	DATAPOOL_SERVICE_URI: "com.ibm.rqm.datapool.common.service.rest.IDatapoolRestService",

	 _invokeService: function(responseHandler, method, appArgs){
        var actutualArgs = {};
        if (appArgs.itemId) {
            actutualArgs.itemId = appArgs.itemId;
        }
        if (appArgs.id) {
            actutualArgs.id = appArgs.id;
        }
        if (appArgs.name) {
			actutualArgs.name = appArgs.name;
		}
		if (appArgs.isDataRequired) {
			actutualArgs.isDataRequired = appArgs.isDataRequired;
		}
		if (appArgs.dataItemUUID) {
			actutualArgs.dataItemUUID = appArgs.dataItemUUID;
		}
		if (appArgs.dataItemStateUUID) {
			actutualArgs.dataItemStateUUID = appArgs.dataItemStateUUID;
		}
		if (appArgs.execItemUUID) {
			actutualArgs.execItemUUID = appArgs.execItemUUID;
		}
		if (appArgs.execItemStateUUID) {
			actutualArgs.execItemStateUUID = appArgs.execItemStateUUID;
		}
		if (appArgs.linkedTestScriptUUID){
			actutualArgs.linkedTestScriptUUID = appArgs.linkedTestScriptUUID;
		}
		if (appArgs.linkedTestScriptStateUUID){
			actutualArgs.linkedTestScriptStateUUID = appArgs.linkedTestScriptStateUUID;
		}
		if (appArgs.variableItemId) {
			actutualArgs.variableItemId = appArgs.variableItemId;
		}
		if (appArgs.jsonString) {
			actutualArgs.jsonString = appArgs.jsonString;
		}
		
		if(appArgs.scriptVersionableItemId){
			actutualArgs.scriptVersionableItemId = appArgs.scriptVersionableItemId;
		}
		
		actutualArgs.processArea = getCurrentProjectArea().itemId;
        var serviceRequest = new ServiceRequest(this.DATAPOOL_SERVICE_URI, method, actutualArgs);
        TeamServerClient.invokeService(serviceRequest, responseHandler);
    },
    
    postDatapoolLink: function(serviceResponseHandler, params){
		this._invokeService(serviceResponseHandler, "postDatapoolLink", params);
	},
	
    getDatapools: function(serviceResponseHandler, params){
        this._invokeService(serviceResponseHandler, "getDatapools", params);
    },
    
	getDatapoolDTOs: function(serviceResponseHandler, params){
        this._invokeService(serviceResponseHandler, "getDatapoolDTOs", params);
    },
	
	getVariableValues: function(serviceResponseHandler, params){
        this._invokeService(serviceResponseHandler, "getVariableValues", params);
    },
	
	postDatapoolVariableLink2: function(serviceResponseHandler, params){
        this._invokeService(serviceResponseHandler, "postDatapoolVariableLink2", params);
    }
	
};

})();
