/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.client.internal.construction.TestScriptClient");

dojo.require("com.ibm.team.process.web.client.projectarea");
dojo.require("com.ibm.team.repository.web.transport.ServiceRequest");
dojo.require("com.ibm.team.repository.web.transport.TeamServerClient");
dojo.require("com.ibm.rqm.planning.web.client.internal.WorkItemUtils");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");

(function() { //module container

var getCurrentPA            = com.ibm.team.process.web.client.projectarea.getCurrentProjectArea;
var ServiceRequest 			= com.ibm.team.repository.web.transport.ServiceRequest;
var TeamServerClient 		= com.ibm.team.repository.web.transport.TeamServerClient;
var WorkItemUtils           = com.ibm.rqm.planning.web.client.internal.WorkItemUtils;
var ServiceResponseHandler	= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;

com.ibm.rqm.planning.web.client.internal.construction.TestScriptClient = {

	TEST_SCRIPT_SERVICE_URI: "com.ibm.rqm.planning.common.service.rest.IManualExecutionScriptRestService",

	_invokeService: function(responseHandler, method, appArgs) {
		var actualArgs= {};
		if (appArgs) {
			//var jsonArgs= dojo.toJson(appArgs);
			//actualArgs.jsonString= jsonArgs;
			actualArgs.processArea = getCurrentPA().itemId;
			actualArgs.isWebUI = true;
			
			if(appArgs.ids){
			     actualArgs.ids = appArgs.ids;	
			}
			
			if(appArgs.newScript) {
				actualArgs.newScript = appArgs.newScript;
			}			
			if (appArgs.newItem) {
				actualArgs.newScript = appArgs.newItem;
			}
			if(appArgs.id) {
				actualArgs.id = appArgs.id;
			}
			if(appArgs.uuid) {
				actualArgs.uuid = appArgs.uuid;
			}
			if(appArgs.createSnapshot) {
				actualArgs.createSnapshot = appArgs.createSnapshot;
			}
			if(appArgs.snapshotName) {
				actualArgs.snapshotName = appArgs.snapshotName;
			}
			if(appArgs.snapshotDescription) {
				actualArgs.snapshotDescription = appArgs.snapshotDescription;
			}
			if(appArgs.snapshotContent) {
				actualArgs.snapshotContent = appArgs.snapshotContent;
			}
			if(appArgs.revision) {
				actualArgs.revision = appArgs.revision;
			}
			if(appArgs.includeSnapshots){
				actualArgs.includeSnapshots = appArgs.includeSnapshots;
			}
			if(appArgs.itemId) {
				actualArgs.itemId = appArgs.itemId;
			}
			if(appArgs.versionableItemId) {
				actualArgs.versionableItemId = appArgs.versionableItemId;
			}
			if(appArgs.stateId) {
				actualArgs.stateId = appArgs.stateId;
			}			
			if(appArgs.name) {
				actualArgs.name = appArgs.name;
			}
			if(appArgs.ownerId) {
				actualArgs.ownerId = appArgs.ownerId;
			}			
			if(appArgs.description) {
				actualArgs.description = appArgs.description;
			}							
			if(appArgs.originator) {
				actualArgs.originator = appArgs.originator;
			}							
			if(appArgs.state) {
				actualArgs.state = appArgs.state;
			}							
			if(appArgs.type) {
				actualArgs.type = appArgs.type;
			} else if (appArgs.newItem) { /* handle case of limited creation from list widget */
				actualArgs.type = "Unknown";
			}
			
			if(appArgs.dataStoreLocation)
				actualArgs.dataStoreLocation = appArgs.dataStoreLocation;
			if(appArgs.actualName)
				actualArgs.actualName = appArgs.actualName;	 
			if(appArgs.workItemsJsonString)
				actualArgs.workItemsJsonString = appArgs.workItemsJsonString; 
			if(appArgs.elements) {
				/*
				for ( var i = 0; i < appArgs.elements.length; i++ ) {
					if ( appArgs.elements[i].typeName == null  ) {
						appArgs.elements[i].typeName = appArgs.elements[i].elementType.name;
					}
					if ( !appArgs.elements[i].properties ) {
						delete appArgs.elements[i].properties;
					}
				}
				*/
				actualArgs.elementsJsonString = dojo.toJson(appArgs.elements);
			}
			if(appArgs.uuid_script)
				actualArgs.uuid_script = appArgs.uuid_script;
			if(appArgs.archive)
				actualArgs.archive = appArgs.archive;	
            
			if (appArgs.versionedTestCaseItemId) {
                actualArgs.versionedTestCaseItemId = appArgs.versionedTestCaseItemId;
            }			
            if (appArgs.minimal) {
                actualArgs.minimal = appArgs.minimal;
            }
			if(appArgs.includeArchived){
				actualArgs.includeArchived = appArgs.includeArchived;
			}
			
			//additional args for search
            if(appArgs.originatorUUIDs) {
                actualArgs.originatorUUIDs = appArgs.originatorUUIDs;
            }
		    if(appArgs.scriptTypeIds) {
                actualArgs.scriptTypeIds = appArgs.scriptTypeIds;
            }				
            if(appArgs.stateIds) {
                actualArgs.stateIds = appArgs.stateIds;
            }               
            if(appArgs.myItemsOnly) {
                actualArgs.myItemsOnly = appArgs.myItemsOnly;
            }	
	       if(appArgs.policy) {
                actualArgs.policy = appArgs.policy;
            }
            if(appArgs.lock) {
                actualArgs.lock = appArgs.lock;
            }			
			
		}else{
			appArgs = {};
		}
		if(!appArgs.projectAreaItemId){
			actualArgs.projectAreaItemId = getCurrentPA().itemId;
		}				

		var serviceRequest= new ServiceRequest(this.TEST_SCRIPT_SERVICE_URI, method, actualArgs);
		TeamServerClient.invokeService(serviceRequest, responseHandler);
		return serviceRequest; //return the service request - enable clients to abort request
	},
	
	getTestScripts: function(serviceResponseHandler, args) {
		return this._invokeService(serviceResponseHandler, "getExecutionScriptsDTO", args);
	},
	
    getTestScriptsSummary: function(serviceResponseHandler, args) {
		var actualHandler = this.getWorkItemMappingHandler(serviceResponseHandler);
        return this._invokeService(actualHandler, "getExecutionScriptsSummaryDTO", args);
    },

    getTestScriptsMinimal: function(serviceResponseHandler, args) {
        args = args ? args : {};
        args.minimal = true;		
        var actualHandler = this.getWorkItemMappingHandler(serviceResponseHandler);
        return this._invokeService(actualHandler, "getExecutionScriptsSummaryDTO", args);
    },
	
    searchTestScripts: function(serviceResponseHandler, args)
    {
        /*
                VALID PARAMETERS
                --------------------------------                
                String processArea;         //project area itemId
                String name;
                String[] originatorUUIDs;   //originator itemId
                String[] scriptTypeIds;     //array of registered script type ids
                String[] stateIds;          //eg. 'com.ibm.rqm.planning.common.new'
                boolean myItemsOnly;
                boolean includeArchived = false;           
                String policy;              //'enforce', 'truncate', 'ignore'     
         */         
        if ( !args ) args = { };
        return this._invokeService(serviceResponseHandler, "getSearchExecutionScripts", args);
    },	
			
    getTestCaseTestScripts: function(serviceResponseHandler, args){
        //expected args: versionedTestCaseItemId
        return this._invokeService(serviceResponseHandler, "getTestCaseExecutionScriptsDTO", args);
    },
	
	getTestScript: function(serviceResponseHandler, scriptId) {
		var actualHandler = this.getWorkItemMappingHandler(serviceResponseHandler);
		var args = {
			id: scriptId,
			includeArchived: true
		}
		return this._invokeService(actualHandler, "getExecutionScriptsDTO", args);
	},

     getTestScriptRevision: function(serviceResponseHandler, versionableItemId, aRevision){
        var actualHandler = this.getWorkItemMappingHandler(serviceResponseHandler);
        return this._invokeService(actualHandler, "getExecutionScriptsDTO", {
            itemId: versionableItemId,
            revision: aRevision
        });
     },

	getSnapshots: function(serviceResponseHandler, args)
	{
		if ( !args ) args = { };
		return this._invokeService(serviceResponseHandler, "getSnapshots", args);
	},
	
	getSnapshotCapturedContent: function(serviceResponseHandler, args)
	{
		if ( !args ) args = { };
		return this._invokeService(serviceResponseHandler, "getSnapshotCapturedContent", args);
	},
	
    postBulkChangeTestScript: function(serviceResponseHandler, args)
    {
        var actualHandler = this.getWorkItemMappingHandler(serviceResponseHandler);         
        return this._invokeService(actualHandler, "postBulkChangeTestScriptDTO", args);
    },
	
	saveTestScript: function(serviceResponseHandler, aScriptObject) {
		var actualHandler = this.getWorkItemMappingHandler(serviceResponseHandler);
		return this._invokeService(actualHandler, "postExecutionScriptDTO", aScriptObject);
	},
	
	archiveTestScript: function(serviceResponseHandler, archiveArgs) {
		return this._invokeService(serviceResponseHandler, "postArchiveTestScript", archiveArgs);
	},
	
    postLockTestScript: function(serviceResponseHandler, args)
    {
        var actualHandler = this.getWorkItemMappingHandler(serviceResponseHandler);
        return this._invokeService(actualHandler, "postLockTestScript", args);
    },   	
	
    getWorkItemMappingHandler: function(responseHandler) {
        var start = new Date();
        var internalHandler = {
            success: function(testScriptDTOs){
                //fixup each workitem for each test case
                testScriptDTOs = WorkItemUtils.fixupArtifactsWorkItems(testScriptDTOs);
                responseHandler.doCallback(testScriptDTOs);
            },
            failure: function(error){
                responseHandler.doErrorCallback(error);
            }
        };
        var handler = new ServiceResponseHandler(internalHandler, "success", "failure");
        return handler;
    }
	
};

})();
