//ERGClient
/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultGroupClient");

dojo.require("com.ibm.team.repository.web.transport.ServiceRequest");
dojo.require("com.ibm.team.repository.web.transport.TeamServerClient");
dojo.require("com.ibm.team.process.web.client.projectarea");

(function() { //module container

var ServiceRequest 			= com.ibm.team.repository.web.transport.ServiceRequest;
var TeamServerClient 		= com.ibm.team.repository.web.transport.TeamServerClient;
var getCurrentPA            = com.ibm.team.process.web.client.projectarea.getCurrentProjectArea;

com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultGroupClient= {

	EXECUTION_RESULT_GROUP_SERVICE_URI: "com.ibm.rqm.execution.common.service.rest.IExecutionResultGroupRestService",
	
	_invokeService: function(responseHandler, method, appArgs) {
		var actualArgs = {};
		if (appArgs) {
			var jsonArgs = dojo.toJson(appArgs);
			actualArgs.jsonString= jsonArgs;
			if (appArgs.name) {
				actualArgs.name = appArgs.name;
			}
			if (appArgs.id) {
				actualArgs.id = appArgs.id;
			}
			if (appArgs.startTime != null) {
				actualArgs.startTime = appArgs.startTime;
			}
			if (appArgs.endTime != null) {
				actualArgs.endTime = appArgs.endTime;
			}	
			if (appArgs.itemId) {
				actualArgs.itemId = appArgs.itemId;
			}	
			if (appArgs.resultItemId) {
				actualArgs.resultItemId = appArgs.resultItemId;
			}	
			if (appArgs.state) {
				actualArgs.state = appArgs.state;
			}			
			if(appArgs.newExecutionResult){
				actualArgs.newExecutionResult = appArgs.newExecutionResult;
			}
			if(appArgs.outOfTimePeriod){
				actualArgs.outOfTimePeriod = appArgs.outOfTimePeriod;
			}
			if(appArgs.addExecutionResult){
				actualArgs.addExecutionResult = appArgs.addExecutionResult;
			}			
			if(appArgs.removeExecutionResult){
				actualArgs.removeExecutionResult = appArgs.removeExecutionResult;
			}			
			if(appArgs.externalId){
				actualArgs.externalId = appArgs.externalId;
			}
			if(appArgs.addResults){
				actualArgs.addResults = appArgs.addResults;
			}
			if(appArgs.stateId){
				actualArgs.stateId = appArgs.stateId;
			}
			if(appArgs.uuid_erg){
				actualArgs.uuid_erg = appArgs.uuid_erg;
			}
			if(appArgs.archive){
				actualArgs.archive = appArgs.archive;
			}
			if(appArgs.originator){
				actualArgs.originator = appArgs.originator;
			}
			if(appArgs.includeArchived){
				actualArgs.includeArchived = appArgs.includeArchived;
			}
			if(appArgs.includeResult == true || appArgs.includeResult == false){
				actualArgs.includeResult = appArgs.includeResult;
			}
			if(appArgs.includeFullResult == true || appArgs.includeFullResult == false){
				actualArgs.includeFullResult = appArgs.includeFullResult;
			}
			if(appArgs.includeRequest == true || appArgs.includeRequest == false){
				actualArgs.includeRequest = appArgs.includeRequest;
			}
			if(appArgs.requestJsonString){
				actualArgs.requestJsonString = appArgs.requestJsonString;
			}
			if(appArgs.ergItemId){
				actualArgs.ergItemId = appArgs.ergItemId;
			}
			if(appArgs.includeConfiguration == true || appArgs.includeConfiguration == false){
				actualArgs.includeConfiguration = appArgs.includeConfiguration;
			}
			if(appArgs.includeTestPhase == true || appArgs.includeTestPhase == false){
				actualArgs.includeTestPhase = appArgs.includeTestPhase;
			}
			if(appArgs.includeTestPlan == true || appArgs.includeTestPlan == false){
				actualArgs.includeTestPlan = appArgs.includeTestPlan;
			}
			if(appArgs.includeTestcase == true || appArgs.includeTestcase == false){
				actualArgs.includeTestcase = appArgs.includeTestcase;
			}
			if(appArgs.includeTestScript == true || appArgs.includeTestScript == false){
				actualArgs.includeTestScript = appArgs.includeTestScript;
			}
		}else{
			appArgs = {};
		}
		if(!appArgs.projectAreaItemId){
			actualArgs.projectAreaItemId = getCurrentPA().itemId;
		}
		var serviceRequest= new ServiceRequest(this.EXECUTION_RESULT_GROUP_SERVICE_URI, method, actualArgs);
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	},

	getExecutionResultGroup: function(serviceResponseHandler, workItemId) {
		this._invokeService(serviceResponseHandler, "getExecutionResultGroup", {workItemId: workItemId});
	},
	
	getExecutionResultGroupDTOs: function(serviceResponseHandler, args) {
		var params = {};
		if(args)
			params = args;
		this._invokeService(serviceResponseHandler, "getExecutionResultGroupDTOs", params);
	},
	
	postDeleteResult: function(serviceResponseHandler, params){
		this._invokeService(serviceResponseHandler, "postArchiveERG", params);
	},
	
	postExecutionResultGroup: function(serviceResponseHandler, params){
		this._invokeService(serviceResponseHandler, "postExecutionResultGroup", params);
	},
	
	postExecutionResultGroupDTO: function(serviceResponseHandler, params){
		this._invokeService(serviceResponseHandler, "postExecutionResultGroupDTO", params);
	},
	
	postExecutionResultGroupSummaryDTO: function(serviceResponseHandler, params){
		this._invokeService(serviceResponseHandler, "postExecutionResultGroupSummaryDTO", params);
	},
		
	getUpdatedRequests:function(serviceResponseHandler, params){
		this._invokeService(serviceResponseHandler, "getRequestUpdates", params);
	},
	
	getUpdatedRequests:function(serviceResponseHandler, params){
		this._invokeService(serviceResponseHandler, "getRequestUpdates", params);
	},
	
    searchAllResults: function(serviceResponseHandler, params) {
        /*
            VALID PARAMETERS
            --------------------------------
            String processArea;         //itemId
            String name;                    
            String[] ownerUUIDs;        //itemId
            String[] stateIds;          // eg. 'com.ibm.rqm.state.new'
            boolean myItemsOnly = false;
            boolean includeArchived = false;
            String policy;              //'enforce', 'truncate', 'ignore'  
        */         
        params = params ? params : {};
        if (!params.processArea) {
            params.processArea = getCurrentPA().itemId;
        }   
        var serviceRequest= new ServiceRequest(this.EXECUTION_RESULT_GROUP_SERVICE_URI, "getSearchAllResults", params);
        TeamServerClient.invokeService(serviceRequest, serviceResponseHandler);		
    }	
};	
})();
