/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.execution.web.client.internal.execution.ExecutionWorkItemClient");

dojo.require("com.ibm.team.repository.web.transport.ServiceRequest");
dojo.require("com.ibm.team.repository.web.transport.TeamServerClient");
dojo.require("com.ibm.team.process.web.client.projectarea");
(function() { //module container

var ServiceRequest 			= com.ibm.team.repository.web.transport.ServiceRequest;
var TeamServerClient 		= com.ibm.team.repository.web.transport.TeamServerClient;
var getCurrentPA            = com.ibm.team.process.web.client.projectarea.getCurrentProjectArea;

com.ibm.rqm.execution.web.client.internal.execution.ExecutionWorkItemClient= {

	EXECUTION_WORKITEM_SERVICE_URI: "com.ibm.rqm.execution.common.service.rest.IExecutionWorkItemRestService",
	
	_invokeService: function(responseHandler, method, appArgs) {
		var actualArgs = {};
		if (appArgs) {
			var jsonArgs= dojo.toJson(appArgs);
			actualArgs.jsonString= jsonArgs;
			if(appArgs.owner) {
				actualArgs.owner = appArgs.owner;
			}
			if(appArgs.newExecutionWorkItem){
				actualArgs.newExecutionWorkItem = appArgs.newExecutionWorkItem;
				if(appArgs.originator){
					actualArgs.originator = appArgs.originator;
				}
				if(appArgs.environment){
					actualArgs.environment = appArgs.environment;
				}
				if(appArgs.frequency){
					actualArgs.frequency = appArgs.frequency;
				}
				if(appArgs.testCase){
					actualArgs.testCase = appArgs.testCase;
				}
			}
			else{
				if(appArgs.owner){
					actualArgs.owner = appArgs.owner;
				}
				if(appArgs.defaultScript){
					actualArgs.defaultScript = appArgs.defaultScript;
				}
			}
			
			if(appArgs.ids)
			    actualArgs.ids = appArgs.ids;
			if(appArgs.id)
				actualArgs.id = appArgs.id;
			if(appArgs.ewiStateIds)
			    actualArgs.ewiStateIds = appArgs.ewiStateIds;		
			if(appArgs.defaultScript)
				actualArgs.defaultScript = appArgs.defaultScript;
			if(appArgs.itemId)
				actualArgs.itemId = appArgs.itemId;
			if(appArgs.stateId)
				actualArgs.stateId = appArgs.stateId;
			if(appArgs.resultStateId)
				actualArgs.resultStateId = appArgs.resultStateId;
			if(appArgs.ewiItemId)
				actualArgs.ewiItemId = appArgs.ewiItemId;
			if(appArgs.ewiStateId)
				actualArgs.ewiStateId = appArgs.ewiStateId;
			if(appArgs.testScriptItemid)
				actualArgs.testScriptItemid = appArgs.testScriptItemid;
			if(appArgs.scriptStateId)
				actualArgs.scriptStateId = appArgs.scriptStateId;
			if(appArgs.testCaseItemId)
				actualArgs.testCaseItemId = appArgs.testCaseItemId;
            if(appArgs.includeArchived)
                actualArgs.includeArchived = appArgs.includeArchived;
			if(appArgs.testConfig)
				actualArgs.testConfig = appArgs.testConfig;
			if(appArgs.resultItemId)
				actualArgs.resultItemId = appArgs.resultItemId;	
			if(appArgs.name)
				actualArgs.name = appArgs.name;	
			if(appArgs.testPlanItemId)
				actualArgs.testPlanItemId = appArgs.testPlanItemId;	
			if(appArgs.testPhase)
				actualArgs.testPhase = appArgs.testPhase;			
			if(appArgs.testCase)
				actualArgs.testCase = appArgs.testCase;
			if(appArgs.testcaseStateId)
				actualArgs.testcaseStateId = appArgs.testcaseStateId;
			if(appArgs.uuid_ewi)
				actualArgs.uuid_ewi = appArgs.uuid_ewi;
            if(appArgs.uuid_ewis)
                actualArgs.uuid_ewis = appArgs.uuid_ewis;
			if(appArgs.archive)
				actualArgs.archive = appArgs.archive;	
			if(appArgs.addDefectIds)
				actualArgs.addDefectIds = appArgs.addDefectIds;
			if(appArgs.removeDefectIds)
				actualArgs.removeDefectIds = appArgs.removeDefectIds;
            if(appArgs.weight)
                actualArgs.weight = appArgs.weight;
			if(appArgs.startTime)
				actualArgs.startTime = appArgs.startTime;
			if(appArgs.requestId)	
				actualArgs.requestId = appArgs.requestId;
			if(appArgs.resolveResults == true || appArgs.resolveResults == false)
				actualArgs.resolveResults = appArgs.resolveResults;
			if(appArgs.resolveWorkItems == true || appArgs.resolveWorkItems == false)
				actualArgs.resolveWorkItems = appArgs.resolveWorkItems;
			if(appArgs.resolveCurrentResult == true || appArgs.resolveCurrentResult == false)
				actualArgs.resolveCurrentResult = appArgs.resolveCurrentResult;
			if(appArgs.resolvePlan == true || appArgs.resolvePlan == false)
				actualArgs.resolvePlan = appArgs.resolvePlan;
			if(appArgs.resolveFullPlan == true || appArgs.resolveFullPlan == false)
				actualArgs.resolveFullPlan = appArgs.resolveFullPlan;
			if(appArgs.resolveTestcase == true || appArgs.resolveTestcase == false)
				actualArgs.resolveTestcase = appArgs.resolveTestcase;
			if(appArgs.resolveFullTestcase == true || appArgs.resolveFullTestcase == false)
				actualArgs.resolveFullTestcase = appArgs.resolveFullTestcase;
			if(appArgs.resolveDefects == true || appArgs.resolveDefects == false)
				actualArgs.resolveDefects = appArgs.resolveDefects;
			if(appArgs.resolveConfiguration == true || appArgs.resolveConfiguration == false)
				actualArgs.resolveConfiguration = appArgs.resolveConfiguration;
			if(appArgs.resolveEnv == true || appArgs.resolveEnv == false)
				actualArgs.resolveEnv = appArgs.resolveEnv;
			if(appArgs.resolveDefaultScript == true || appArgs.resolveDefaultScript == false)
				actualArgs.resolveDefaultScript = appArgs.resolveDefaultScript;
			if(appArgs.resolvePhase == true || appArgs.resolvePhase == false)
				actualArgs.resolvePhase = appArgs.resolvePhase;
			if(appArgs.resolveMinDefScript == true || appArgs.resolveMinDefScript == false)
				actualArgs.resolveMinDefScript = appArgs.resolveMinDefScript;
			if(appArgs.resolveMinCurResult == true || appArgs.resolveMinCurResult == false)
				actualArgs.resolveMinCurResult = appArgs.resolveMinCurResult;
			if(appArgs.testCaseRevision)
				actualArgs.testCaseRevision = appArgs.testCaseRevision;	
		}else{
			appArgs = {};
		}
		if(!appArgs.projectAreaItemId)
			actualArgs.projectAreaItemId = getCurrentPA().itemId;	
			
        actualArgs.isWebUI = true;
			
		var serviceRequest= new ServiceRequest(this.EXECUTION_WORKITEM_SERVICE_URI, method, actualArgs);
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	},

	getExecutionWorkItemDTOs: function(serviceResponseHandler, params) {
		this._invokeService(serviceResponseHandler, "getWorkItemDTOs", params);
	},
	
	getExecutionWorkItemSummaryDTOs: function(serviceResponseHandler, params) {
		this._invokeService(serviceResponseHandler, "getWorkItemSummaryDTOs", params);
	},
	
	getExecutionWorkItem: function(serviceResponseHandler, owner ){
		this._invokeService(serviceResponseHandler, "getWorkItem", {owner: owner });
	},
	
	getRequestDTO: function(serviceResponseHandler, params){
		this._invokeService(serviceResponseHandler, "getRequestDTO", params);
	},

	postExecutionWorkItem: function(serviceResponseHandler, params )
	{
		this._invokeService(serviceResponseHandler, "postWorkItem", params);
	},
	
	postExecutionWorkItemDTO: function(serviceResponseHandler, params )
	{
		this._invokeService(serviceResponseHandler, "postWorkItemDTO", params);
	},
	
	postExecutionWorkItemMinimalSummaryDTO: function(serviceResponseHandler, params )
	{
		this._invokeService(serviceResponseHandler, "postWorkItemMinimalSummaryDTO", params);
	},
	
	postExecute: function(serviceResponseHandler, params)
	{
		this._invokeService(serviceResponseHandler, "postExecute", params);
	},
	
	postDelete: function(serviceResponseHandler, params)
	{
		this._invokeService(serviceResponseHandler, "postDelete", params);
	},
	
	getAllTCToEWIMaps: function(serviceResponseHandler, params)
	{
		this._invokeService(serviceResponseHandler, "getAllTCToEWIMaps", params);
	},
	
	getExecutionWorkItemByItemId: function(serviceResponseHandler, params)
	{
	this._invokeService(serviceResponseHandler, "getExecutionWorkItemByItemId", params);
	},
	
	postArchiveEWI: function(serviceResponseHandler, params)
	{
		this._invokeService(serviceResponseHandler, "postArchiveEWI", params);
	},
	postArchiveEWIsForTC: function(serviceResponseHandler, params)
	{
		this._invokeService(serviceResponseHandler, "postArchiveEWIsForTC", params);
	},
	postBulkChangeEWI: function(serviceResponseHandler, params)
	{
		this._invokeService(serviceResponseHandler, "postBulkChangeWorkItemSummaryDTO", params);
	},
    
    searchExecutionWorkItem: function(serviceResponseHandler, params)
    {
        /*
            VALID PARAMETERS
            --------------------------------
            String processArea;         //itemId
            String name;                    
            String[] originatorUUIDs;   //itemId
            String[] ownerUUIDs;        //itemId
            String[] stateIds;          // eg. 'com.ibm.rqm.state.new'
            String weightComparator
            int weightValue
            boolean myItemsOnly = false;
            boolean includeArchived = false;
            String policy;              //'enforce', 'truncate', 'ignore'  
        */         
        params = params ? params : {};
        if (!params.processArea) {
            params.processArea = getCurrentPA().itemId;
        }           
        var serviceRequest= new ServiceRequest(this.EXECUTION_WORKITEM_SERVICE_URI, "getSearchEWIs", params);
        TeamServerClient.invokeService(serviceRequest, serviceResponseHandler);
    },
    
    getRelatedDefects: function(serviceResponseHandler, params)
    {
		/*
		 * params:
         *  String projectAreaItemId;
         *  String uuid_ewi;
         *  String ewiStateId;
         */
        this._invokeService(serviceResponseHandler, "getReferencedDefects", params);
    },
	
	getRelatedDefectsFromMultipleEWIs: function(serviceResponseHandler, params)
	{
        /*
         * params:
         *  String projectAreaItemId;
         *  String uuid_ewis;
         *  String ewiStateIds;
         */
        this._invokeService(serviceResponseHandler, "getReferencedDefectsFromMultipleEWIs", params);
	}

};

})();
