/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
//
/*
*
*	This class is specific to jobs.  It extends to container object.
*
*
*/
dojo.require("com.ibm.asq.common.web.client.internal.container");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.provide("com.ibm.rational.test.lm.web.client.internal.job");
//dojo.require("com.ibm.rational.test.lm.web.client.internal.Catalog");
dojo.declare("com.ibm.rational.test.lm.web.client.internal.job", com.ibm.asq.common.web.client.internal.container, 
		
		
	{
		constructor: function()
		{
        	this.setServiceInterface('com.ibm.rational.test.lm.common.IJobRestService');
		},
		
		/**
		 * params supported: 
		 * 		withinSeconds - filters the list of jobResults returned to
		 * 				only those that were started within the last withinSeconds.  
		 * 
		 * Returns an array of JobResultDTOs.  Each of these contains
		 * 		- A JobDTO (containing a jobId and jobName)
		 *		- startTime (a timestamp)
		 *		- duration (time in seconds that the job took or has taken if still running)
		 *		- state - a NameCodeDTO containing a state id and name. 
		 *			state values:
		 *				Pending: 1
		 *				Running: 2
		 *				Completed: 3
		 *				Other: 4
		 *		- result - a NameCodeDTO containing a result id and name
		 *			result values:
		 *				None: 1
		 *				Running: 2
		 *				Passed: 3
		 *				Warning: 4
		 *				Failed: 5
		 *		- name - the name of the jobresult (for BF it is the tag)
		 *		- id - a string uniquely identifying the job result (within
		 *				the job provider, for now BuildForge only).
		 *		- hostname - the hostname where the job ran.
		 */
		getJobsResults: function(responseHandler, args)
		{
        	return this._invokeService(	responseHandler, 
        								"getJobsResults", 
        								args );
		},
		
		        //Run a particular job on a particular machine
        //
        postRunJob: function(responseHandler, jobId,hostName)
        {
        	var args = {};
        	args[ "jobId" ] = jobId;
        	args[ "hostname" ] = hostName;
        	return this._invokeService(	responseHandler, 
        								"postRunJob", 
        								args );
        },

        //Get the jobs for a particular machine
        //
        getAllJobs: function(responseHandler)
        {
        	var args = {};
        	return this._invokeService(	responseHandler, 
        								"getAllJobs", 
        								args );
        }      

//        //run discovery on a particular machine
//        //
//        discover: function(responseHandler,attributes){
//        	var myResponseHandler = new com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper({
//					_success: function ( response ) {
//						var catalog = new com.ibm.rational.test.lm.web.client.internal.Catalog();
//						var config = catalog.getNewConfiguration();
//		                for (var i = 0; i < response.length; i++){
//		                	var name = response[i].name;
//		                	var value = response[i].value;
//		                	if (name == 'operatingSystem') name = 'operatingsystem';
//		                	if (name == 'status'){
//		                		if (value == 'available') value = 'Online';
//		                		if (value == 'unavailable') value = 'Offline';
//		                	}
//                    		config.setAttribute(name,value);;
//                    	}
//						responseHandler._contextObject[responseHandler._callbackName](config);
//					},
//					_failure: function (errObj) {
//						responseHandler._contextObject[responseHandler._errorCallbackName](errObj);
//					}
//				},
//				"_success",
//				"_failure"
//			);
//        	return this._invokeService(	myResponseHandler, "getDiscovery", attributes );
//        }
		
	}	
)
