/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.client.internal.mapper.ScoredResultMapper");

dojo.require("com.ibm.asq.common.web.client.internal.mapper.AbstractMapper");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");

(function() {
	
var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
	
dojo.declare("com.ibm.rqm.planning.web.client.internal.mapper.ScoredResultMapper",
             com.ibm.asq.common.web.client.internal.mapper.AbstractMapper, {
	
    /*
     * Map items of type IScoredResult which are the results of a FullText search 
     * from very lightweight info into a more robust object
     */ 
    map: function(summaryDTO) {
        if (summaryDTO && summaryDTO.resultValue) {
            summaryDTO.uri = summaryDTO.resultValue.uriVal;
            summaryDTO.type = summaryDTO.resultValue.typeVal;
            
			var name = summaryDTO.resultValue.name || "";
            if (name.indexOf(":") > -1) {
				var firstOccurIndex = name.indexOf(":");
				if (summaryDTO.type == Constants.MODEL_TYPE_WORKITEM) {
					//summaryDTO.workItemType = nameTokens[0];
					summaryDTO.id = name.slice(0, firstOccurIndex).trim();
					summaryDTO.name = name.slice(firstOccurIndex + 1).trim();
				} else {
					summaryDTO.id = name.slice(0, firstOccurIndex).trim();
					summaryDTO.name = name.slice(firstOccurIndex + 1).trim();
				}
            }
            summaryDTO.details = summaryDTO.resultValue.details;
            delete summaryDTO.resultValue;
        }   
        return summaryDTO;
    }
	
});

})();