/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rational.test.lm.sequencer.web.client.internal.sequence.SequenceClient");
/*
 * author: vasrivas
 */
dojo.require("com.ibm.team.process.web.client.projectarea");
dojo.require("com.ibm.team.repository.web.transport.ServiceRequest");
dojo.require("com.ibm.team.repository.web.transport.TeamServerClient");

(function() { //module container

var ServiceRequest 			= com.ibm.team.repository.web.transport.ServiceRequest;
var getCurrentPA            = com.ibm.team.process.web.client.projectarea.getCurrentProjectArea;
var TeamServerClient 		= com.ibm.team.repository.web.transport.TeamServerClient;

com.ibm.rational.test.lm.sequencer.web.client.internal.sequence.SequenceClient = {
    
	SEQUENCE_SERVICE_URI: "com.ibm.rational.test.lm.sequencer.common.service.rest.IExecutionSequenceRestService",
	
	_invokeService: function(responseHandler, method, args) {
		if (args && !args.projectArea) {
			args.projectArea = getCurrentPA().itemId;
		}
		var serviceRequest= new ServiceRequest(this.SEQUENCE_SERVICE_URI, method, args);
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	},
	
	getExecutionSequencesDTO: function(responseHandler, args){
		this._invokeService(responseHandler, "getExecutionSequencesDTO", args);
	},

	getExecutionSequencesSummaryDTO: function(responseHandler, args){
		this._invokeService(responseHandler, "getExecutionSequencesSummaryDTO", args);
	},
	
	getExecutionSequenceResultsDTO: function(responseHandler, args){
		this._invokeService(responseHandler, "getExecutionSequenceResultsDTO", args);
	},
	
	getExecutionSequenceResultsSummaryDTO: function(responseHandler, args){
		this._invokeService(responseHandler, "getExecutionSequenceResultsSummaryDTO", args);
	},
	
	postExecutionSequenceDTO: function(responseHandler, args){
		this._invokeService(responseHandler, "postExecutionSequenceDTO", args);
	},
	
	postArchiveExecutionSequence: function(responseHandler, args){
		this._invokeService(responseHandler, "postArchiveExecutionSequence", args);
	},
	searchExecutionSequences:function(responseHandler, args){
		if ( !args ) args = { };
		this._invokeService(responseHandler, "getSearchExecutionSequences", args);
	},
	
	postCancelRunningExecutionSequence: function(responseHandler, args){
		this._invokeService(responseHandler, "postCancelRunningExecutionSequence", args);
	},
	getBuildRecordsWithStatisticsDTO:function(responseHandler, args){
		this._invokeService(responseHandler, "getBuildRecordsWithStatisticsDTO", args);
	}
};

})();
