/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.client.internal.template.TemplateClient");

dojo.require("com.ibm.team.process.web.client.projectarea");
dojo.require("com.ibm.team.repository.web.transport.ServiceRequest");
dojo.require("com.ibm.team.repository.web.transport.TeamServerClient");

(function() { //module container

var ServiceRequest 			= com.ibm.team.repository.web.transport.ServiceRequest;
var getCurrentPA            = com.ibm.team.process.web.client.projectarea.getCurrentProjectArea;
var TeamServerClient 		= com.ibm.team.repository.web.transport.TeamServerClient;

com.ibm.rqm.planning.web.client.internal.template.TemplateClient = {

	TEMPLATE_SERVICE_URI: "com.ibm.rqm.template.common.service.ITemplateRestService",
	TEMPLATE_SECTION_SERVICE_URI: "com.ibm.rqm.template.common.service.ITemplateSectionRestService",

	_invokeTemplateService: function(responseHandler, method, args) {
		if (args && !args.processAreaUUID) {
			args.processAreaUUID = getCurrentPA().itemId;
		}
		var serviceRequest= new ServiceRequest(this.TEMPLATE_SERVICE_URI, method, args);
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	},
	
    _invokeSectionService: function(responseHandler, method, args) {
        if (args && !args.processAreaUUID) {
            args.processAreaUUID = getCurrentPA().itemId;
        }
        var serviceRequest= new ServiceRequest(this.TEMPLATE_SECTION_SERVICE_URI, method, args);
        TeamServerClient.invokeService(serviceRequest, responseHandler);
    },	
	
	_getItemType: function(/*string*/ modelType) {
        return modelType.substr(modelType.lastIndexOf(".") + 1)		
	},

    getTemplate: function(serviceResponseHandler, args) {
        this._invokeTemplateService(serviceResponseHandler, "getTemplate", args);
    },

    getDefaultTemplate: function(serviceResponseHandler, editorId) {
		var args = {
			editorId: editorId
		}
        this._invokeTemplateService(serviceResponseHandler, "getDefaultTemplate", args);
    },
			
    getTemplates: function(serviceResponseHandler, args) {
        this._invokeTemplateService(serviceResponseHandler, "getTemplates", args);
    },
	   
    postTemplate: function(serviceResponseHandler, templateObj) {
		//templateObj: tbd
        this._invokeTemplateService(serviceResponseHandler, "postTemplate", templateObj);
    },
	
	postSetDefaultTemplate: function(serviceResponseHandler, editorId, templateItemId) {
        var args = {
			editorId: editorId,
			templateItemId: templateItemId
		}
        this._invokeTemplateService(serviceResponseHandler, "postSetDefaultTemplate", args);
    },
	
    getSections: function(serviceResponseHandler, args) {
        this._invokeSectionService(serviceResponseHandler, "getSections", args);
    }	
};

})();
