//BUIU
/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.buildintegration.web.ui.internal.BuildUiUtil");

(function() {

dojo.require("com.ibm.asq.common.web.ui.internal.util.MessageUtil");
dojo.requireLocalization("com.ibm.rqm.buildintegration.web.ui.internal", "messages");

// define a message bundle id for RTC
var MessageBundleRQMBuild = "RQMBuild";
var MessageBundleRTLMSequencer = "RTLMSequencer";
var MessageBundleRQM = "RQM";
dojo.declare("com.ibm.rqm.buildintegration.web.ui.internal._MessageLoader", null,
{
    constructor: function(){
        // initializes the rqm message bundle
       MessageUtil.registerRequireBundle(MessageBundleRQMBuild, "com.ibm.rqm.buildintegration.web.ui.internal", "messages");
	   MessageUtil.registerRequireBundle(MessageBundleRTLMSequencer, "com.ibm.rational.test.lm.sequencer.web.ui.internal", "messages");
    }
});

com.ibm.rqm.buildintegration.web.ui.internal.MessageLoader = new com.ibm.rqm.buildintegration.web.ui.internal._MessageLoader();
com.ibm.rqm.buildintegration.web.ui.internal.BuildUiUtil = {
	   
    /**
     * Return the message from the message bundle with the specified keyword.
     * Optional token arguments are for replacing place holders in the message
     * definition.  The place holders have the syntax "%number" with the number
     * starting from 1.  For example, if the message "myStr" is defined as
     * "This is %1 of %2 message".  getMessage("myStr", "one", "my many") will return
     * "This is one of my many message".
     */
    getMessage: function(keyword, tokens) {
        var args = [];
		if (arguments.length > 1)
		{
        	for( var i = 1; i < arguments.length; i++){ 
            	args.push(arguments[i]);
			}
        }
		if (args.length == 0)
			return MessageUtil.getMessage(MessageBundleRQMBuild, keyword);
		else if (args.length == 1)
			return MessageUtil.getMessage(MessageBundleRQMBuild, keyword, args[0]);
		else if (args.length == 2)
			return MessageUtil.getMessage(MessageBundleRQMBuild, keyword, args[0], args[1]);
		else if (args.length == 3)
        	return MessageUtil.getMessage(MessageBundleRQMBuild, keyword, args[0], args[1], args[2]);
    },
	getBuildRecordURI: function(buildRecId){
		return "#action=com.ibm.rqm.planning.home.actionDispatcher&subAction=editBuild&id="+buildRecId;
	},
	getBuildDefURI: function(buildDefId){
		return "#action=com.ibm.rqm.planning.home.actionDispatcher&subAction=editBuildDef&id="+buildDefId;
	},
	getDisplayName:function(stateId, displayName){
		if (stateId) {
			switch (stateId) {
				case "com.ibm.buildintegration.common.states.unassigned":
					return MessageUtil.getMessage(MessageBundleRQMBuild, "labelUnassigned");
				case "com.ibm.rqm.buildintegration.buildstate.complete":
					return MessageUtil.getMessage(MessageBundleRQMBuild, "labelComplete");
				case "com.ibm.rqm.buildintegration.buildstate.running":
					return MessageUtil.getMessage(MessageBundleRQMBuild,"labelRunning");
				case "com.ibm.rqm.buildintegration.buildstate.inprogress":
					return MessageUtil.getMessage(MessageBundleRQMBuild,"labelInProgress");
				case "com.ibm.rqm.buildintegration.buildstate.queued":
					return MessageUtil.getMessage(MessageBundleRQMBuild, "labelQueued");
				case "com.ibm.rqm.buildintegration.buildstate.cancelled":
					return MessageUtil.getMessage(MessageBundleRQMBuild, "labelCancelled");
				case "com.ibm.rqm.buildintegration.buildstatus.ok":
					return MessageUtil.getMessage(MessageBundleRQMBuild, "labelOK");
				case "com.ibm.rqm.buildintegration.buildstatus.error":
					return MessageUtil.getMessage(MessageBundleRQMBuild, "labelError");
				case "com.ibm.rqm.buildintegration.buildstatus.inprogress":
					return MessageUtil.getMessage(MessageBundleRQMBuild,"labelInProgress");
				default:
					return displayName?displayName:"";
			}
		}
	},
	getResultString:function(resultState){
			switch(resultState){
				case "IN_PROGRESS":
					return MessageUtil.getMessage(MessageBundleRTLMSequencer,"labelInProgress");
				case "CANCELLED":
					return MessageUtil.getMessage(MessageBundleRTLMSequencer,"labelCancelledSequence");
				case "NOTSTARTED":
					return MessageUtil.getMessage(MessageBundleRTLMSequencer,"labelNotStarted");	
				case "PAUSED":
					return MessageUtil.getMessage(MessageBundleRTLMSequencer,"labelCancelledSequence");
				case "COMPLETE":
					return MessageUtil.getMessage(MessageBundleRTLMSequencer,"labelComplete");	
				case "PASS":
					return MessageUtil.getMessage(MessageBundleRQM,"labelPass");
				case "INCONCLUSIVE":
					return MessageUtil.getMessage(MessageBundleRQM,"labelInconclusive");	
				case "FAIL":
					return MessageUtil.getMessage(MessageBundleRQM,"labelFail");	
				case "ERROR":
					return MessageUtil.getMessage(MessageBundleRQM,"labelError");
				case "BLOCKED":
					return MessageUtil.getMessage(MessageBundleRQM,"labelBlocked");	
				case "UNKNOWN":
					return MessageUtil.getMessage(MessageBundleRQM,"labelUnknown");	
				default:
					return resultState;
			}			 
		}
};
})();
