/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.rqm.reports.viewlets.cognos.ui.internal.CognosReportsViewlet");

dojo.require("com.ibm.rqm.reports.cognos.web.ui.internal.CognosReportsBrowseDialog");
dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");
dojo.require("com.ibm.team.reports.web.client.internal.ReportsClient");

dojo.require("com.ibm.rqm.reports.cognos.web.client.internal.CognosReportsClient");
dojo.require("com.ibm.team.dashboard.web.ui.Viewlet");
dojo.require("com.ibm.team.dashboard.web.util.internal.I18nUtil");
dojo.require("com.ibm.asq.common.web.ui.internal.view.viewlets.AbstractViewlet");
(function() {

var CognosReportsBrowseDialog = com.ibm.rqm.reports.cognos.web.ui.internal.CognosReportsBrowseDialog;
var CognosReportsClient = com.ibm.rqm.reports.cognos.web.client.internal.CognosReportsClient;
var ServiceResponseHandler = com.ibm.team.repository.web.transport.ServiceResponseHandler;
var ReportsClient = com.ibm.team.reports.web.client.internal.ReportsClient;
var Viewlet = com.ibm.team.dashboard.web.ui.Viewlet;
var AbstractViewlet = com.ibm.asq.common.web.ui.internal.view.viewlets.AbstractViewlet;
var I18nUtil = com.ibm.team.dashboard.web.util.internal.I18nUtil;
var messages;


/*
 * The Cognos viewlet class.
 */
dojo.declare("com.ibm.rqm.reports.viewlets.cognos.ui.internal.CognosReportsViewlet",
	AbstractViewlet, {
	
	templatePath: dojo.moduleUrl("com.ibm.rqm.reports.viewlets.cognos", "ui/internal/templates/CognosReportsViewlet.html"),
	
	constructor: function(args) {
		//messages = dojo.i18n.getLocalization("com.ibm.team.dashboard.viewlets.web.ui.internal", "BookmarksMessages");
	},
	
	init: function() { 
		var nodes = I18nUtil.addMessage(this._noQueriesEditContentsLink,"To add a cognos report, select <0>Edit Contents</0> from the viewlet menu." );
		this.connect(nodes[0], "onclick", this._doEdit);
		//this.connect(this.reportFrame,"onload",this._resize);
	},
	
	_resize: function() {
		var h = this.reportFrame.contentDocument.body.scrollHeight;
		var w = this.reportFrame.contentDocument.body.scrollWidth;
		console.debug(h+","+w);
		this.reportFrame.style.height = h +'px';
		this.reportFrame.style.width = w +'px';
	},
	
	refresh: function() {
		this.update();
		this.getSite().doneRefresh();
	},
	
	update: function(){
		var iFrame = this.getViewletState().get("iFrame");
		if(iFrame != null){
			//non empty viewlet
			console.log("before getting iframe---"+iFrame);
			this._createIframe(iFrame);
		}
		
		if (this.isEditing()) {// check if we're in the editing mode
			var addLi = document.createElement("div");
			addLi.className = "action add-cognos-report";
			var addLink = document.createElement("a");
			addLink.innerHTML = "Add Cognos Report";
			addLink.href = "";
			addLi.appendChild(addLink);
			this._site.getActionArea().appendChild(addLi);
			this.connect(addLink, "onclick", this._addCognosReport);
			this._addLi = null;
			this._addLi = addLi;
		}
		var length = this._site.getActionArea().childNodes.length;
		if(this._site.getActionArea().childNodes != null && !this.isEditing() && length != 0){
			this._site.getActionArea().removeChild(this._site.getActionArea().firstChild);
		}
		if (this.iFrame == null || this.iFrame == "") {
			this._noQueriesEditContentsLink.innerHTML = "No Cognos Report selected";
			dojo.addClass(this._noQueriesEditContentsLink, "title");
		}		
	},
	
	_onOkClick: function(){
		var reportUUID = this.cognosReportsBrowseDialog.reportUUID;
		this.cognosReportName = this.cognosReportsBrowseDialog.cognosReportName;
		var args ={reportUUID: reportUUID};
		var handler = new ServiceResponseHandler(this, "_success", "_failure");
		ReportsClient.getRenderedReport(handler, args);
	},
	
	_success: function(chartHTML){
		chartHTML= chartHTML.replace("(h>600?h:600)", "h");
		var obj = new Object();
		obj.iFrame = chartHTML;
		obj.cognosReportName = this.cognosReportName;
		this._createIframe(obj);
		this._saveChanges();		
	},
	
	_failure: function(){
		alert("Error fetching the project");
	},
	
	_doEdit: function(e){
		//alert("in _doEdit");
		e.preventDefault();
		this.getSite().editContents();
	},
	
	_addCognosReport: function(e){
		e.preventDefault();
		 var args = {
			elementsToBeDisplayed: "Reports"
	  	};
		this.cognosReportsBrowseDialog = new CognosReportsBrowseDialog(args);
		this.connect(this.cognosReportsBrowseDialog._okButton, "onclick", this._onOkClick);
	},
	
	setDashboardEditing: function(editing) {
		if (this.isEditing() || !editing) {
			dojo.addClass(this._noQueriesEditContentsLink, "hidden");
		} else {
			dojo.removeClass(this._noQueriesEditContentsLink, "hidden");
		}
	},
	
	_createIframe: function(iFrameElement){		
		this.iFrame = iFrameElement;
		var newNode = document.createElement('div');
		newNode.innerHTML = iFrameElement.iFrame;
		this._removeChildren(this.renderedReportDiv);
		this.renderedReportDiv.appendChild(newNode);
		
		
		this._noQueriesEditContentsLink.innerHTML = iFrameElement.cognosReportName;
		dojo.addClass(this._noQueriesEditContentsLink, "title");
	},
	
	_saveChanges: function() {
		// if this is a new iframe, assign an id
		var iFrame = this.iFrame;
		if (iFrame != null) {
			iFrame.id = 1;
			console.debug(iFrame.id,iFrame.iFrame, iFrame.cognosReportName);
			this.getViewletState().set("iFrame", iFrame);
		}
		this.update();
		this._site.getActionArea().removeChild(this._addLi);
	},
	
	/* object */ getDefaultState: function() {
		var state = new Object();
		state.nextId = 1;
		state.iFrame = "";
		state.cognosReportName = "";
		return state;
	},
	
	_removeChildren: function(element) {
			while (element.firstChild) {
				element.removeChild(element.firstChild);
			}
	}
});

})();
