/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007, 2009. All Rights Reserved. 
 * 
 * Note to U.S. Government Users Restricted Rights:  Use, 
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.rqm.reports.cognos.web.ui.internal.UploadCognosReport");

dojo.require("com.ibm.rqm.reports.cognos.web.client.internal.CognosReportsClient");
dojo.require("com.ibm.rqm.reports.cognos.web.ui.internal.NewTemplateDialog");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants"); 

dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");
dojo.require("com.ibm.team.process.web.client.projectarea");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");

dojo.require("dojo.i18n");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.Tree");
dojo.require("dojo.data.ItemFileReadStore");

(function() { // module container

var ServiceResponseHandler = com.ibm.team.repository.web.transport.ServiceResponseHandler;
var CognosReportsClient = com.ibm.rqm.reports.cognos.web.client.internal.CognosReportsClient;
var Constants =  com.ibm.rqm.reports.cognos.web.client.internal.Constants;
var AlertDialog 	= com.ibm.asq.common.web.ui.internal.widgets.AlertDialog;
var NewTemplateDialog=com.ibm.rqm.reports.cognos.web.ui.internal.NewTemplateDialog;
/**
 * Widget to create dialog for Uploading cognos report.
 */
dojo.declare("com.ibm.rqm.reports.cognos.web.ui.internal.UploadCognosReport", [dijit._Widget, dijit._Templated], {
		templatePath: dojo.moduleUrl("com.ibm.rqm.reports.cognos.web", "ui/internal/templates/UploadCognosReport.html"),
				
		postCreate: function() {
			var self = this;		
			this.newTemplateDialog = new NewTemplateDialog();
			this.connect(this.newTemplateDialog._okButton, "onclick", this._onOk);			
			this.connect(this.newTemplateDialog._cancelButton, "onclick", this.destroy);			
		},
		
		uninitialize: function(){
			this.newTemplateDialog.destroy();
		},
		
		_onOk: function(){
			var currentProjectArea = com.ibm.team.process.web.client.projectarea.getCurrentProjectArea();
			var args={
				ip:this.newTemplateDialog.reportServerAddress,
				username:this.newTemplateDialog.reportServerUser,
				password:this.newTemplateDialog.reportServerPass,
				"namespace":this.newTemplateDialog._namespaceInput.value,
				reportPath: this.newTemplateDialog.reportPath,
				name: this.newTemplateDialog._nameInput.value,
				projectArea: currentProjectArea.itemId,
				//processId: processDefinitionId.itemId,
				isShared: this.newTemplateDialog._isShared.checked?true:false,
				description: this.newTemplateDialog._descriptionInput.value,
				folderUUID: this.newTemplateDialog._folderInput.value,
				id: this.newTemplateDialog._IDInput.value,
				fileName: this.newTemplateDialog._reportInput.value
			};
			var responseHandler = new ServiceResponseHandler(
				this,
				"_uploadComplete",
				"_Error");
			CognosReportsClient.postUploadCognosReportTemplate(responseHandler, args);
			
		},
		
		_Error: function(){
			(new AlertDialog({'message': "Error uploading the template" })).open();
			this.destroy();
		},
	
		_uploadComplete: function(message){
			if(message=="success"){
				console.debug("Template uploaded");
				(new AlertDialog({'message': Constants.getMessage("msgSuccess") })).open();
			}
			else if(message=="ReportDescriptorConflictException"){
				(new AlertDialog({'message': Constants.getMessage("errorDuplicateTemplate") })).open();
			}
			this.reportsTableView.refreshCallback();
			
			
			/*this._templateTree.removeChild(this._templateTree.firstChild);
			var responseHandler = new ServiceResponseHandler(
					this,
					"_addTemplates",
					"_remoteError");
			ReportsClient.getReportDescriptors(responseHandler, {});
			*/
			this.destroy();
		}
	}
);

})();