/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.asq.common.web.ui.internal.app.PaddedPageList");

dojo.require("net.jazz.ajax.ui.PageList");

(function() {
     
dojo.declare("com.ibm.asq.common.web.ui.internal.app.PaddedPageList", [net.jazz.ajax.ui.PageList], {
    
    postCreate: function() {
        com.ibm.asq.common.web.ui.internal.app.PaddedPageList.superclass.postCreate.apply(this);
        dojo.addClass(this.domNode, "com-ibm-asq-common-web-ui-PageList");
    },
    
    /**
     * Override the Jazz PageList to add a DIV on the right of each link in the tab as separator
     */
    _createPageLink: function(page) {
        // create the link dom object from superclass
        var link = com.ibm.asq.common.web.ui.internal.app.PaddedPageList.superclass._createPageLink(page);
        
        // create a table to wrap around the link and the separator div
        var table = document.createElement('table');
        table.cellPadding = "0";
        table.cellSpacing = "0";
        table.border = "0";
        var row = table.insertRow(0);
        var linkCol = row.insertCell(0);
        linkCol.appendChild(link);
        var paddedCol = row.insertCell(1);
        var paddedDiv = document.createElement('div');
        paddedDiv.className = "padded-nav-separator";
        paddedCol.appendChild(paddedDiv);
        return table;
    }
});

})();
