/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.ui.internal.model.ArtifactModel");
dojo.require("com.ibm.rqm.planning.web.ui.internal.model.SaveContext");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");

(function(){ // module container    
    var SaveContext = com.ibm.rqm.planning.web.ui.internal.model.SaveContext;
	var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
    
    dojo.declare("com.ibm.rqm.planning.web.ui.internal.model.ArtifactModel", null, {
    
        _saveContext: null,
        _artifactType: null,
        _artifact: null,
        _tabClass: null,
		_lockSupported: false,
        
        constructor: function(artifactType){
            this._saveContext = new SaveContext();
            this._artifactType = artifactType;
			
        	switch(artifactType){
				case Constants.TYPE_PLAN:
					this._tabClass = "testplan-icon-16";
					this._lockSupported = true;
					break;
				case Constants.TYPE_CASE:
					this._tabClass = "testcase-icon-16";
					this._lockSupported = true;
					break;
				case Constants.TYPE_SCRIPT:
					this._tabClass = "testscript-icon-16";
					this._lockSupported = true;
					break;
				case Constants.TYPE_DATAPOOL:
					this._tabClass = "datapool-icon-16";
					break;
				case Constants.TYPE_SUITE:
					this._tabClass = "testsuite-icon-16";
					break;	
				default:
					break;
			}      
        },
        
        uninitialize: function(){
            this._saveContext.uninitialize();
            this._artifact = null;    
        },
        
        getSaveContext: function(){
            return this._saveContext;
        },
        
        getArtifactType: function(){
            return this._artifactType;
        },
        
        setArtifact: function(artifact){
            this._artifact = artifact;
        },
        
        getArtifact: function(){
            return this._artifact;
        },
        
        setTabClass: function(tabClass){
            this._tabClass = tabClass;
        },
		
        getTabClass: function(){
            return this._tabClass;
        },
		
		isLockSupported: function() {
			return this._lockSupported;
		},
		
		discardChanges: function() {
            this._saveContext.uninitialize();
			delete this._saveContext;
			this._saveContext = new SaveContext();
		}
    
    });
    
})();
