/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.ui.internal.module.AbstractSelectionPickerWidget");//$NON-NLS-1$
// declare dependencies on other Dojo modules
dojo.require("com.ibm.rqm.planning.web.ui.internal.module.AbstractPickerWidget");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");

(function(){

    var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
    
    // Table view presented in the picker, wer are wrapping existing table view w/ view builder added and actions disabled
    dojo.declare("com.ibm.rqm.planning.web.ui.internal.module.PickerTableView", [dijit._Widget, dijit._Templated], {
        templateString: '<div><div dojoAttachPoint="_artifactTable" style="margin-left:0em;width:100%;height:475px;overflow-x:hidden;overflow-y:auto;position:relative"></div><div style="float:right;margin-top:0.5em;position:relative;"><button class="Button" dojoattachevent="onclick:_onOk">' + Constants.getMessage("labelOk") + '</button><button class="Button" dojoattachevent="onclick:_onCancel">' + Constants.getMessage("labelCancel") + '</button></div></div>',
        postCreate: function(){
            // concrete class is responsible to construct the table view
            var contentWidgetConstructor = this.pickerWidget.getContentWidgetConstructor();
            var contentWidgetArgs = this.pickerWidget.getContentWidgetArgs();
            this.tableViewer = new contentWidgetConstructor(contentWidgetArgs);
            
            this._artifactTable.appendChild(this.tableViewer.domNode);
        },
        
        _onOk: function(){
            if (this.tableViewer.getSelectedItems().length > 0) {
                this.onOk(this.tableViewer.getSelectedItems());
            }
        },
        _onCancel: function(){
            this.onCancel();
        }
    });
    
    // declare and implement the widget "class"
    dojo.declare("com.ibm.rqm.planning.web.ui.internal.module.AbstractSelectionPickerWidget", com.ibm.rqm.planning.web.ui.internal.module.AbstractPickerWidget, {
    
        // APIs - sub widget should override this to provide content
        getContentWidgetConstructor: function(){
            return null;
        },
        
        getContentWidgetArgs: function(){
            return null;
        },
        
        // internal
        getContentArea: function(){
            var self = this;
            var contentParams = {
                pickerWidget: self,
                onOk: dojo.hitch(this, this._onOk),
                onCancel: dojo.hitch(this, this._onCancel),
                testplans: []
            };
            var content = new com.ibm.rqm.planning.web.ui.internal.module.PickerTableView(contentParams);
            return content;
        },
        
        _onOk: function(testplans){
            this.send(testplans, com.ibm.rqm.planning.web.ui.internal.module.AbstractPickerWidget.RETURN_MSG_SELECT);
        },
        
        _onCancel: function(){
            this.send(null, com.ibm.rqm.planning.web.ui.internal.module.AbstractPickerWidget.RETURN_MSG_SELECT);
        }
        
    });
    
})();
