/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.ui.internal.module.TestCaseCreationPickerWidget");//$NON-NLS-1$
// declare dependencies on other Dojo modules
dojo.require("dojo.number");

dojo.require("com.ibm.rqm.planning.web.ui.internal.module.AbstractPickerWidget");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.NewTestCasePanel");
dojo.require("com.ibm.rqm.planning.web.client.internal.construction.TestCaseClient");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");

(function(){

    var TEST_CASE_FACTORY_PREFIX = "/jazz/oslc_qm/contexts/";
    var OSCL_ATTRIB_SUMMARY = "dc:name";//$NON-NLS-1$
    var OSCL_ATTRIB_DESCRIPION = "dc:description";//$NON-NLS-1$
    var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
    var newTestCasePanel = com.ibm.rqm.planning.web.ui.internal.view.common.NewTestCasePanel;
    var TestCaseClient = com.ibm.rqm.planning.web.client.internal.construction.TestCaseClient;
    var ServiceResponseHandler = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
    
    dojo.declare("com.ibm.rqm.planning.web.ui.internal.module.TestCaseCreationWidget", [dijit._Widget, dijit._Templated], {
        templateString: '<div style="margin-left:0;margin-top:0.5em;overflow-x:auto;overflow-y:auto;position:relative;width:100%;"><div dojoAttachPoint="_artifactTable" class=""></div><div style="float:right;margin-top:0.5em;margin-right:0.5em;position:relative;"><button class="Button" dojoattachevent="onclick:_onOk">' + Constants.getMessage("labelOk") + '</button><button class="Button" dojoattachevent="onclick:_onCancel">' + Constants.getMessage("labelCancel") + '</button></div></div>',
        
        postCreate: function(){
            this.newTestCasePanel = new newTestCasePanel({
                isInPicker: true,
                defaultSummary: this.defaultSummary,
                defaultDesc: this.defaultDesc
            });
            this._artifactTable.appendChild(this.newTestCasePanel.domNode);
        },
        
        validate: function(attr){
            if (!attr.names || dojo.trim(attr.names[0]).length == 0) {
                alert(Constants.getMessage("msgNameRequired"));
                return false;
            }
            //validate the weight 
            if (!attr.weights || dojo.trim(attr.weights[0]).length == 0 || isNaN(dojo.number.parse(attr.weights[0]))) {
                alert(Constants.getMessage("msgNumericWeightRequired"));
                return false;
            }
            return true;
        },
        
        _onOk: function(){
            var editorObj = this.newTestCasePanel.getAttributes();
            if (this.validate(editorObj)) {
                var aTestCaseObj = {};
                aTestCaseObj.newTestCase = true;
                aTestCaseObj.name = editorObj.names[0];
                aTestCaseObj.weight = editorObj.weights[0];
                aTestCaseObj.description = editorObj.descriptions[0];
				aTestCaseObj.state = Constants.STATETRANSITION_STATE_DRAFT;
                if (editorObj.ownerIds[0] && editorObj.ownerIds[0] != "-1") {
                    aTestCaseObj.ownerId = editorObj.ownerIds[0];
                }
                dojo.mixin(aTestCaseObj, editorObj);
                var self = this;
                var handler = {
                    success: function(testcase){
                        self.pickerWidget.send([testcase], com.ibm.rqm.planning.web.ui.internal.module.AbstractPickerWidget.RETURN_MSG_CREATE);
                    },
                    error: function(e){
                        self._error(e);
                    }
                }
                var responseHandler = new ServiceResponseHandler(handler, "success", "error");
                TestCaseClient.saveTestCase(responseHandler, aTestCaseObj);
            }
        },
        
        _onCancel: function(){
            this.pickerWidget.send(null, com.ibm.rqm.planning.web.ui.internal.module.AbstractPickerWidget.RETURN_MSG_CREATE);
        },
        
        _error: function(e){
            console.debug(this.declaredClass + ": Error: " + e.message);
        }
    });
    // declare and implement the widget "class"
    dojo.declare("com.ibm.rqm.planning.web.ui.internal.module.TestCaseCreationPickerWidget", com.ibm.rqm.planning.web.ui.internal.module.AbstractPickerWidget, {
    
        getItemType: function() {
			return Constants.getMessage("labelTestCase");
		}, 
		
		getItemUri: function(itemId){
            if (this.currentProjectArea) {
                var projectAreaId = this.currentProjectArea.itemId;
                return location.protocol + '//' + location.host + TEST_CASE_FACTORY_PREFIX + projectAreaId + '/resources/com.ibm.rqm.planning.TestCase/' + itemId;
            }
            else {
                this._noProjectArea();
            }
        },
        
        getContentArea: function(){
            var content = new com.ibm.rqm.planning.web.ui.internal.module.TestCaseCreationWidget({
                pickerWidget: this,
                defaultSummary: this.getDialogArgs()[OSCL_ATTRIB_SUMMARY],
                defaultDesc: this.getDialogArgs()[OSCL_ATTRIB_DESCRIPION]
            });
            return content;
        }
    });
    
})();
