/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
({
    "bundle_description": "AppScan Tester Edition messages",
    
    // Global messages
    "error_ase_not_configured": "Integration with Rational AppScan Tester Edition is currently not configured.",
	"error_ase_retrieving_templates": "An error occurred while attempting to retrieve the templates from Rational AppScan Tester Edition: ",
    "loading": "Loading...",
    "name": "Name",
    "description": "Description",
    
    // Test policy names
    "wf-default-test-policy": "Default",
    // Test policy descriptions
    "IDS_DEFAULT_TEST_POLICY_DESCRIPTION": "This test policy includes all tests except invasive and port listener tests.",
    
    // Issue severities
    "issue_severity_high": "High",
    "issue_severity_medium": "Medium",
    "issue_severity_low": "Low",
    "issue_severity_information": "Information",
    
    // Execution log messages
	"view_stats" : "View detailed statistics in Rational AppScan Tester Edition",
	"view_stats_header" : "Scan Statistics",
	"scan_progress_header" : "Pages",
	"error_details_header" : "Error Details",
    "execution_progress": "Scan Progress",
    "scan_log_entries": "%1 Entries",
    "scan_log_download": "Download",
    "scan_log_empty": "Log is empty",
    "reports_view_in_ase": "View in Rational AppScan Tester Edition",
	"error_text_none": "None",
    "summary_severity": "Severity",
    "summary_issues": "Active Issues",
    "executionlog_message": "Message:",
    "executionlog_threshold": "Severity Threshold:",
    "executionlog_issues": "Security Issues Found:",
    "executionlog_reports": "Reports:",
    "executionlog_scanlog": "Scan Log:",
	"execution_with_no_scan": "There is no scan associated with this Rational AppScan Tester Edition script. You must edit the test script and create a scan to run the security test.",
	"execution_canceled": "Execution canceled",
    "view_test_script_link": "Edit the test script",
	
    "scan_result_success": "Scan completed successfully.",
    "scan_result_failed": "Scan did not complete.  View the Scan Log for details.",
    "scan_result_noscan": "The test script does not have an Rational AppScan Tester Edition scan associated with it.",
	"scan_result_could_not_start" : "Could not start the scan.",
	"scan_result_no_retrieve_scan" : "Could not retrieve the scan, it may have been deleted.",
	"scan_result_cancelled" : "The scan was canceled.",
	"scan_result_nosecurityissues" : "Security summary could not be found.  Ensure that the Security Issues report is included in the scan.",
    
    // Test Plan messages
    "available_test_policies": "Available Test Policies",
    "plan_security_summary": "View the available Rational AppScan Tester Edition test policies in the Test Plan.",
    "edit_item": "Edit %1",
    
    // Test Script editor dynamic messages
    "create_scan": "Create Scan",
    "creating": "Creating Scan...",
    "edit_scan": "Edit Scan",
    "ase_wrong_version": "Integration with Rational Quality Manager is not available with version %1 of Rational AppScan Tester Edition (current version = %2; expected version = %3).",
    "ase_no_templates": " There are no templates defined in Rational AppScan Tester Edition. A scan cannot be created until a template is defined. See your administrator.",
    "creating_scan": "The Rational AppScan Tester Edition scan is being created. When creation has completed, the scan will open in a new browser window.",
    "confirm_save": "To proceed with the creation of a Rational AppScan Tester Edition scan you must first save the test script.  Would you like to save now?",
    "confirm_create": "You are saving the test script but have not created a Rational AppScan Tester Edition scan. You will not be able to execute the test script until the scan is created. Press OK to continue saving the test script. Press Cancel to go back and create a scan.",
    "popup_blocker_title": "Unable to open Rational AppScan Tester Edition in a new window or tab",
    "popup_blocker": "Unable to open Rational AppScan Tester Edition in a new window or tab. This may be caused by the presence of a pop-up blocker; Disable the software used to block pop-up windows for this website and click on the link again.",
	"error_creating_scan" : "An error has occurred during scan creation.  Consult the Quality Manager log for more details.",
	
	// Test Script editor static messages
	"testscript_intro": "Rational AppScan Tester Edition will scan your web application for security vulnerabilities.",
	"testscript_template_title": "Template",
	"testscript_template_intro": "Select the template type to use while creating the scan. Once the scan has been created, this information can no longer be modified.",
	"testscript_type_title": "Type",
	"testscript_verdict_title": "Verdict Strategy",
	"testscript_verdict_intro": "The verdict strategy determines the criteria that must be met for a related test execution record to pass or fail.",
	"testscript_severity_threshold_title": "Severity Threshold",
	"testscript_400": "High",
	"testscript_300": "Medium",
	"testscript_200": "Low",
	"testscript_100": "Information",		
	
	// training viewlet static messages
	"toviewlet_overview": "The IBM Rational Web-based Training for AppScan e-Learning collection provides an online, self-paced training curriculum based on a decade of expertise and best practices from customer deployments in challenging and complex Web environments. The courses are designed to help you learn about Web Application Security and how to use AppScan effectively.",
	"toviewlet_course_intro": "The following courses are recommended for Rational Quality Manager (RQM) users:",
	"toviewlet_course_title_title": "Course title",
	"toviewlet_course_code_title": "Course code",
	"toviewlet_course_title_webappsec": "Essentials of Web Application Security",
	"toviewlet_course_title_ase": "IBM Rational AppScan Enterprise Edition",
	"toviewlet_buy_link_before": "If you have purchased the IBM Rational Web-based Training for AppScan collection, log on to our Learner Portal to view these courses: ",
	"toviewlet_buy_link_after": "."
})
