/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005-2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
	
dojo.provide("com.ibm.rqm.planning.web.ui.internal.page.NotAuthorized");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("net.jazz.ajax.ui.PlatformUI");

dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");

function workbenchRootNode(){
	// summary:
	//		helper to get workbench root node
	return net.jazz.ajax.ui.PlatformUI.getWorkbench().rootNode();
}

var Constants = com.ibm.rqm.planning.web.client.internal.Constants;

dojo.declare("com.ibm.rqm.planning.web.ui.internal.page.NotAuthorized", [dijit._Widget, dijit._Templated], {
	
	templateString: '<div>' +
					'   <div id="box">' +
					'      <div id="content">' +
					'         <img id="lock-image" dojoAttachPoint="_lockImg"></img>' +
					'         <div id="no-auth-text" dojoAttachPoint="_textNode">' +
					'            <p dojoAttachPoint="_upperText">${upperText}</p>' +
					'            <p dojoAttachPoint="_middleText">${middleText}</p>' +
					'            <p dojoAttachPoint="_lowerText">${lowerTextPreLink} <a dojoAttachPoint="_anchor" id="login-failure-anchor">${linkText}</a> ${lowerTextPostLink}</p>' +
					'         </div>' +
					'      </div>' +
					'   </div>' +
					'</div>',
	
	
	constructor: function() {
		//default text
		this.upperText = Constants.getMessage("labelNoLicense");
		this.middleText = Constants.getMessage("labelNoLicenseContact");
		this.lowerText = null;
		this.lowerTextPreLink = Constants.getMessage("labelNoLicense2");
		this.lowerTextPostLink = Constants.getMessage("labelNoLicense3");
		this.linkText = Constants.getMessage("labelReturnToLogin");
		this.linkOnClick = null;
		this.showLockIcon = true;
	},
	
	postCreate: function() {
		this._lockImg.src = dojo.moduleUrl("com.ibm.rqm.planning.web", "ui/internal/page/templates/images/authorize_lock_obj32.gif");
		this._anchor.setAttribute("href", "javascript:{}");
		this.connect(this._anchor, "onclick", this.linkOnClick != null ? this.linkOnClick : "_doLogout");
		
        dojo.addClass(workbenchRootNode(), "com-ibm-rqm-not-auth-container");
		workbenchRootNode().appendChild(this.domNode);		
		
		if (this._isEmpty(this.middleText)) {
			this._middleText.style.display = "none";
		}
		if (this._isEmpty(this.lowerTextPreLink) && this._isEmpty(this.lowerTextPostLink)) {
			this._lowerText.style.display = "none";
		}
		if (!this._isEmpty(this.lowerText)) {
			dojox.data.dom.removeChildren(this._lowerText);
			this._lowerText.appendChild(document.createTextNode(this.lowerText));
		}
		if (!this.showLockIcon) {
			this._lockImg.style.display = "none";
		}
	},
	
	_isEmpty: function(aString) {
		return (aString == null || dojo.trim(aString).length == 0);
	},
	
	_doLogout: function() {
        var bindArgs = {
            url: net.jazz.ajax._contextRoot + "/auth/logout",
            handleAs: "json",
            headers: {
				accept: "text/json"
            },
            preventCache: dojo.isIE,
            handle: function(response, ioArgs) {
				window.location.href = document.location.protocol + "//" +
									   document.location.host +
									   document.location.pathname +
									   document.location.search;
            }
        };
        dojo.xhrPost(bindArgs);
	}
});

})();