/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading com.ibm.rqm.planning.web.ui.internal.page.home.HomePageView");
dojo.provide("com.ibm.rqm.planning.web.ui.internal.page.home.HomePageView");

dojo.require("dojox.data.dom");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("jazz.app.events");

dojo.require("net.jazz.ajax.ui.PlatformUI");
dojo.require("com.ibm.team.process.web.client.projectarea");
dojo.require("com.ibm.team.repository.web.client.init.InitializationData");
dojo.require("com.ibm.team.dashboard.web.ui.Dashboard");
dojo.require("com.ibm.team.dashboard.web.client.internal.DashboardClient");
dojo.require("com.ibm.team.dashboard.web.ui.DashboardConstants");
//workaround Jazz dashboard missing dojo.require and variable declaration problem in M5a.
//dojo.require("com.ibm.team.dashboard.web.ui.IMemento");

dojo.require("com.ibm.asq.common.web.client.internal.option");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.RelatedInfo");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.asq.common.web.ui.internal.util.GlobalEvents");

dojo.require("com.ibm.rqm.planning.web.ui.internal.page.home.HomePageController");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.ActionBar");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.ContentArea");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.EditorUtil");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.client.internal.PreferenceClient");

var ServiceResponseHandler  = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var InitializationData      = com.ibm.team.repository.web.client.init.InitializationData;
var DashboardClient 		= com.ibm.team.dashboard.web.client.internal.DashboardClient;
var DashboardConstants 		= com.ibm.team.dashboard.web.ui.DashboardConstants;
var RelatedInfoPanel=com.ibm.asq.common.web.ui.internal.view.common.RelatedInfoPanel;
(function()
{
    var PlatformUI            = net.jazz.ajax.ui.PlatformUI;
    var ActionRegistry        = null; // initialize later
    var root                  = "com.ibm.rqm.planning.home.";
    var Dispatcher            = "actionDispatcher";
    var HomeViewAction        = "viewUserHome";
    var Constants             = com.ibm.rqm.planning.web.client.internal.Constants;
    var PreferenceClient      = com.ibm.rqm.planning.web.client.internal.PreferenceClient;
    var EditorUtil            = com.ibm.rqm.planning.web.ui.internal.util.EditorUtil;
    var getCurrentProjectArea = com.ibm.team.process.web.client.projectarea.getCurrentProjectArea;
	var GlobalEvents		  = com.ibm.asq.common.web.ui.internal.util.GlobalEvents;
    
    dojo.declare("com.ibm.rqm.planning.web.ui.internal.page.home.HomePageView",
      [dijit._Widget, dijit._Templated],
    {      
        controller: null,      
        templatePath: dojo.moduleUrl("com.ibm.rqm.planning.web", "ui/internal/page/templates/home/HomePageView.html"),
        homeViewActionTag: HomeViewAction,
        
        /*
         * Required by Jazz web framework to make hyperlinking and back/forward
         * work.
         */
        getController: function()
        {
            if (!this.controller) {
                this.controller = dojo.getObject("com.ibm.rqm.web.homePageController");
                this.controller.setView(this);
            }
            return (this.controller);
        },
        
        // initialization      
        postCreate: function() {
            this.getController();
            this.controller.registerDispatchAction(HomeViewAction, dojo.hitch(this, "showUserDashboard"));
            
            this._initUI();    
            this.controller.initTrackTabChange();
            
            this.bannerDashboardButton = null;
            this.bannerDashboardButtonNotFound = false;
        },                
        
        _initUI: function()
        {
            this._homePageCreated = false;
            
            PreferenceClient.getCurrentUserPreferences(this, this.showRelatedInfo, Constants.USER_UI_CUSTOMISE_ACTIONBAR_RELATEDINFO_CATEGORY.key);

            // There is only one page for the HomePage View with only one content area.
            // Set a unique id for the one and only one the content area.
            //
            var contentAreaArg = { id: "one-and-only-one-com-ibm-rqm-web-home-page-content-area" };
            this._contentArea = new com.ibm.rqm.planning.web.ui.internal.view.common.ContentArea(contentAreaArg);
            // filter "sectionId" from the list of criteria used to match a URI
            this._contentArea.addUriFilter(/&?sectionId=[^&]+/);
            this._contentArea.initialize();
            this._centerArea.appendChild(this._contentArea.domNode);

            // Subscribe to tabbed view selected event and let the view drive the
            // contents of the related info area.  "this._contentArea.tabs.id" is
            // the id of the TabContainer that we subscribe to.
            //
            dojo.subscribe(this._contentArea._tabs.id+"-selectChild", this, "onSelectTab");
        	//unfortunately, this onload event is triggered by other conditions than a true unload. 
        	// removing it for the time being.  fmcgrath 17Aug2009
//            dojo.addOnUnload(this, "_onWindowUnload");
            
            PreferenceClient.getCurrentUserPreferences(this, this.showActionBar, Constants.USER_UI_CUSTOMISE_ACTIONBAR_CATEGORY.key);
        },
        
        uninitialize: function(){
//        	console.debug("--------HomePageview uninitialize");
        	if (this._actionBar){
        		this._actionBar.destroyRecursive();
        		this._actionbar = null;
        	}
        	if (this.homePage) {
        		this.homePage.destroy();
        		this.homePage = null;
        	}
        	this.blankRelatedInfo.destroy();
        },
        //_onWindowUnload: function(){
        //	this.destroyRecursive();
        //},
        
        showRelatedInfo: function(userPreference) {
            var args = {
                open: true,
                parent: this
            }
            if (userPreference.key == Constants.USER_UI_CUSTOMISE_ACTIONBAR_RELATEDINFO_CATEGORY.key) {
                args.open = (userPreference.value == true);
            }
            this.openRelatedInfo = args.open;
            
            this._relatedInfo = new com.ibm.asq.common.web.ui.internal.view.common.RelatedInfo(args);
            this._relatedInfoArea.appendChild(this._relatedInfo.domNode);

            // create a blank related info panel
            this.blankRelatedInfo = new RelatedInfoPanel();
            this._relatedInfo.setCurrentPanel("_BLANK", this.blankRelatedInfo);
			
			dojo.subscribe(GlobalEvents.RelatedSitesUpdated, this, "_getRelatedLinks");
            this._getRelatedLinks();               
        },
        
        _getRelatedLinks: function(infoPanel) {
            infoPanel = infoPanel ? infoPanel : this._relatedInfo;
            //set default related links
            var self = this;  
            this._relatedLinks = Constants.RELATED_LINKS_PREFERENCE_DEFAULTS.concat([]);  //copy the array                          
            var handlerObj = {
                success: function(preference) {
                    if (preference != null) {
                        self._relatedLinks = dojo.fromJson(preference.value);
                    }
                    self._addRelatedLinks(infoPanel);
                },
                
                error: function(error) {
                    console.error(error);                   
                    self._addRelatedLinks(infoPanel);
                    self._relatedInfo.addAction(Constants.getMessage("labelRelatedSites"), (function(){}), "Error Loading...", {});
                }
            }

            var option = new com.ibm.asq.common.web.client.internal.option();
            var handler = new ServiceResponseHandler(handlerObj, "success", "error");
            option.getProjectPreferences(handler, getCurrentProjectArea().itemId, Constants.RELATED_LINKS_PREFERENCE_KEY);            
        },
        
        _addRelatedLinks: function(infoPanel) {
            infoPanel = infoPanel ? infoPanel : this._relatedInfo;
			var currentPanel = null;
			if(infoPanel instanceof com.ibm.asq.common.web.ui.internal.view.common.RelatedInfo){
				currentPanel = infoPanel.getCurrentPanel();
			} else {
				currentPanel = infoPanel;
			}
			if(currentPanel != null && dojo.isFunction(currentPanel.destroyInfoGroup)){
				currentPanel.destroyInfoGroup(Constants.getMessage("labelRelatedSites"));
			}
            for (var i = 0; i < (this._relatedLinks ? this._relatedLinks.length : 0); i++) {
                infoPanel.addLink(Constants.getMessage("labelRelatedSites"), this._relatedLinks[i].name, this._relatedLinks[i].url);                
            }
        },
        
        showActionBar: function(userPreference)
        {
            var dispatcherName = root + "actionDispatcher";
            
            this.actionBarIsHorizontal = false;
            if(userPreference.key == Constants.USER_UI_CUSTOMISE_ACTIONBAR_CATEGORY.key){
                this.actionBarIsHorizontal = (userPreference.value == "actionBarHorizontal");
            }

            if (this.actionBarIsHorizontal) {
                // horizontal action bar is in the common banner area (QMPage) and not in this page view
                // set the content area of this view for the action entries in the horizontal action bar
                dojo.setObject("com-ibm-rqm-planning-web-page-content-area", this._contentArea);
            } else {
                // create the vertical action bar
                this._actionBar = new com.ibm.rqm.planning.web.ui.internal.view.common.ActionBar();
                this._actionBar.initialize(this._contentArea, this._popupMenuArea, dispatcherName);
                this._actionBarArea.appendChild(this._actionBar.domNode);
            }
            
            //set rtl attribute:
            if(dojo.isFF == 2)
                this.switchBidiContentArea(this.openRelatedInfo);
        },
    
        showCurrentQuery: function()
        {
            window.location.hash = "#action=" + root + Dispatcher + "&subAction=" + HomeViewAction;
        },
        
		showUserDashboard: function( data )
		{
			var self = this;
			var serviceObj = {
				success: function(/* ResponseDTO */ responseDTO)
				{
					if (responseDTO.personalDashboards && responseDTO.personalDashboards[0])
					{
						var dashboardItemId = responseDTO.personalDashboards[0].itemId;
						self._viewDashboard(dashboardItemId);
					}
					else
					{
						self._createDashboard();
					}
				},
				failure: function(errorObj)
				{
					self._createDashboard();
					console.error(errorObj.message);
				}
			};
			
			var srh = new ServiceResponseHandler(serviceObj, "success", "failure");
			var projectAreaName = com.ibm.team.process.web.client.projectarea.getCurrentProjectArea().name;
				
			DashboardClient.getLeftNavInfo(projectAreaName, srh);
		},
		
		_viewDashboard: function(dashboardItemId)
		{
            if (!this._homePageCreated)
			{
                // adjust the vertical action bar top right corner cap position here because we
                // have to make sure the action bar is added to the DOM tree to determine its width
                if (!this.actionBarIsHorizontal) {
                    // vertical action bar only not horizontal
                    var verticalActionBarCap = dojo.byId("rqm-vertical-actionbar-cap");
                    // the corner cap is defined in the header banner of QMPage
                    if (verticalActionBarCap) {
                        var actionBarWidth = this._actionBar._actionBar.clientWidth;
                        // set left offset of the corner cap for the banner product icon on its left
                        verticalActionBarCap.style.marginLeft = (actionBarWidth - 49) + "px";
                        // show it, the default is hidden for horizontal action bar
                        verticalActionBarCap.style.display = "block";
                    }
                }

				var projectAreaName = com.ibm.team.process.web.client.projectarea.getCurrentProjectArea().name;
				this.homePage = new com.ibm.team.dashboard.web.ui.Dashboard({
												scope: DashboardConstants.SCOPE_CONTRIBUTOR,
												scopeItem: {id: dashboardItemId},
												projectArea: projectAreaName
											   });

                var args = {
                    		name: Constants.getMessage("labelDashboards"),
                    		uri: "#action=" + root + Dispatcher + "&subAction=" + HomeViewAction,
                    		noSelect: true,
                    		content: this.homePage
                };                    
                
                var page = this._contentArea.addPage(args, 0);
                
                page.homePage = this.homePage;
                
                this._homePageCreated = true;
            }
			
            this.updateHomeButton(true);
			
			setTimeout(dojo.hitch(this, this._viewDashboard2), 0);
		},
		
		_viewDashboard2: function()
		{
			if(this.homePage._contentWidget.metaNav._deleteButton)
			{
				this.homePage._contentWidget.metaNav._deleteButton.domNode.style.display = "none";
			}
			else
			{
				setTimeout(dojo.hitch(this, this._viewDashboard2), 10);
			}
		},
		
		_createDashboard: function()
		{
			var self = this;
			var serviceObj = {
				success: function(/* ResponseDTO */ responseDTO)
				{
					if (responseDTO.data && responseDTO.data.dashboard)
					{
						var dashboardItemId = responseDTO.data.dashboard.itemId;
						self._viewDashboard(dashboardItemId);
					}
					else
					{
						console.error("Error on DashboardClient.createDashboard call");
						console.debug(responseDTO);
					}
				},
				failure: function(errorObj)
				{
					console.error(errorObj.message);
				}
			};
			
			var srh = new ServiceResponseHandler(serviceObj, "success", "failure");
			var projectAreaItemId = com.ibm.team.process.web.client.projectarea.getCurrentProjectArea().itemId;
            var userItemId = dojo.getObject("com.ibm.team.repository.web.client.internal.AUTHENTICATED_CONTRIBUTOR").itemId;
				
			DashboardClient.createDashboard(projectAreaItemId, DashboardConstants.SCOPE_CONTRIBUTOR, userItemId, null, true, srh);
		},
		
        onTabContainerStartup: function() {
            window.resizeBy(0, 1);
            window.resizeBy(0, -1);
        },
        
        updateHomeButton: function(homeTabSelected) {
            // run this once to locate the banner RQM dashboard button
            if (!this.bannerDashboardButton && !this.bannerDashboardButtonNotFound) {
                var headerButtons = jazz.app.currentApplication.ui._banner.buttons;
                for (var i = 0; i < headerButtons.length; i++) {
                    if (headerButtons[i].label == Constants.getMessage("labelDashboards")) {
                        this.bannerDashboardButton = headerButtons[i]._widget;
                        break;
                    }
                }
                this.bannerDashboardButtonNotFound = this.bannerDashboardButton == null;
            }
            
            // update the style of the banner RQM dashboard button
            if (this.bannerDashboardButton) {
                if (homeTabSelected) {
                    if (!dojo.hasClass(this.bannerDashboardButton.domNode, "selected")) {
                        dojo.addClass(this.bannerDashboardButton.domNode, "selected");
                    }
                } else {
                    dojo.removeClass(this.bannerDashboardButton.domNode, "selected");
                }
            }
            
            // save if the dashboard tab is selected to restore when navigate back from a non RQM page
            dojo.setObject("com-ibm-rqm-planning-web-dashboard-selected", homeTabSelected);
            
            var activeHomeButton = dojo.getObject("com-ibm-rqm-planning-web-home-widget");
            if (activeHomeButton) {
                activeHomeButton.attr('disabled', homeTabSelected);
                if (!homeTabSelected) {
                    // Dojo button "_focused" flag is set when set disabled from clicking
                    // the home button.  Need to clear it when set enabled.
                    activeHomeButton._focused = false;
                }
            }
        },

        // Handler that is called when a page (a view in the tabbed content area)
        // is selected.
        //
        onSelectTab: function(page) {
            if (!page) {
                return;
            }
            
            if( dojo.isIE && page.domNode.childNodes.length == 1 )
            {
                //For some reason hiding the non-selected tabs does not
                //work for the dashboard page, when the dashboard as been
                //added to it.  If the dashboard page is also not displayed, then
                //the tab to display can be set correctly by the widget.
                //Unhiding the homePage (dashboard page)
                page.domNode.childNodes[ 0 ].style.display = "";
            }
            
            var staticPanel = null;
            
            // clear the related info with blank panel
            //
            this._relatedInfo.setCurrentPanel("_BLANK", this.blankRelatedInfo);
            
            // check the page if it use static related info content pane
            var widget = page.contentWidget;
            if (widget && dojo.isFunction(widget.getStaticRelatedInfo)) {
                // there is static related info pane for the page
                staticPanel = widget.getStaticRelatedInfo();                
                if (staticPanel) {
                    if (!staticPanel.addedDefalutRelatedLinks) {
                        // If the 'Related Sites' group exists, do not clear it out.  Duplicate links will be ignored.
                        // Add the default related sites links from the preference to the static panel.
                        this._addRelatedLinks(staticPanel);
                        //this._getRelatedInfo(); //TODO - auto refresh from admin pref. every time ?
                        
                        // add the default related info links only once from preference
                        staticPanel.addedDefalutRelatedLinks = true;
                    }
                    
                    // put up the static related info panel as current panel
                    var id = dojo.isFunction(widget.getStaticRelatedInfoId) ? widget.getStaticRelatedInfoId() : null;
                    this._relatedInfo.setCurrentPanel(id ? id : page.title, staticPanel);
//                    console.debug(" - used static related info panel from page");
                }
            }

            // check the page if it use method to set up the related info only if there is no static panel
            if (!staticPanel) {
                if (widget && dojo.isFunction(widget.setupRelatedInfo)) {
                    var dynamicPanel = this._relatedInfo.getDynamicPanel(true);

                    // pass the blank dynamic info panel to the page to set up
                    widget.setupRelatedInfo(dynamicPanel);
//                    console.debug(" - page is setting up the dynamic related info panel");
                    // ensure there is something in the panel before setting it into the related info area
                    if (!dynamicPanel.isEmpty()) {
                        this._relatedInfo.setCurrentDynamicPanel();
                    } else {
//                        console.debug(" - but nothing is added, skip to use the default panel");
                    }
                }
            }
            
            // If a widget has the onActivated method then call it. This gives
            // the content notification to refresh, or to 'wakeup'.
            if(widget && dojo.isFunction(widget.onActivated)) {
                widget.onActivated();
            }
            else if(page instanceof dijit._Widget) {
                // refresh any table viewer descendants of the page.
                // If a page was not in focus and update is made to
                // a table in that page, the table would not render its content
                // properly. Refresh while it's being shown corrects the 
                // problem. Call getDescendants from the page widget, because
                // it is a container widget and would have a containerNode
                // set.
                var descendants = page.getDescendants();
                dojo.forEach(descendants, function(child) {
                    if(child instanceof com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer) {
                        child.refresh();
                    }
                });
            }
            if( page.homePage )
            {
                //Put back the body click handler that was removed when moving away from the dashboard
                //See DashboardPage.navigateAwayEvent.  This also will add back the class that is needed
                //for the dashboard functionality to work properly.
                if( page.homePage._checkNavigateAwayHandle )
                    page.homePage._checkNavigateAwayHandle();
                
                net.jazz.ajax.ui.PlatformUI.getWorkbench().setTitle(page.homePage.getTitle());
                net.jazz.ajax.ui.PlatformUI.getWorkbench().browserTitle = document.title;
                // update the home button
                this.updateHomeButton(true);
            }else if (page.browserTitle) {
                net.jazz.ajax.ui.PlatformUI.getWorkbench().setTitle(page.browserTitle);
                net.jazz.ajax.ui.PlatformUI.getWorkbench().browserTitle = page.browserTitle;
                // update the home button
                this.updateHomeButton(false);
            }            
        },
                
        switchBidiContentArea: function(hasRelatedInfo) {
            if (EditorUtil.isDirectionRtl()) {
                var wide = dojo.marginBox(this.domNode).w;
                this._centerArea.className = "contentarea-rtl"
                if(this.actionBarIsHorizontal){
                    if(hasRelatedInfo) {
                        this._centerArea.style.width = wide - 222 + "px";
                    }
                    else {
                        this._centerArea.style.width = wide - 22 + "px";
                    }
                }
                else {
                    if(hasRelatedInfo) {
                        this._centerArea.style.width = wide - 293 + "px";
                    }
                    else {
                        this._centerArea.style.width = wide - 93 + "px";
                    }
                }
            }
        }
    });
})();
