/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
 // Summary:
 //   Provide definitions for the support globally published/subscribed events for 
 //   the RQM application.
 //
(function() {

var GlobalEvents = dojo.provide("com.ibm.asq.common.web.ui.internal.util.GlobalEvents");

// Use (publish) this event to change the Tab Page's URI. This is used when
// a page's URI signature is changed, for example, from a new artifact item to
// a saved artifact with the proper artifact id, etc.
//   For example:
//     dojo.publish(GlobalEvents.UpdateTabUri, ["tabUri", "new-uri"]);
//
GlobalEvents.UpdateTabUri = "RQM-Event-MainPage-Tab-Container-Update-Tab-URI";

// Use (publish) this event to change the Tab Page's label and optioanlly, an icon.
//   For example:
//     dojo.publish(GlobalEvents.UpdateTabLabel, ["tabUri", "new-label", /*optional*/"icon-class", /*optional*/dirty, /*optional*/skipCompactLabel]);
// 
GlobalEvents.UpdateTabLabel = "RQM-Event-MainPage-Tab-Container-Update-Tab-Label";

// Use (publish) this event to notify other tabs that artifacts are updated.  Tabs that have
// reference to the artifacts should be updated as well.  The optional "event from uri" is the
// URI of the page that post the event so the subscriber can skip notifying that page.
//   For example:
//     dojo.publish(GlobalEvents.ArtifactsUpdated, ["artifact type", [array of artifacts], /*optional*/"event from uri"]);
// 
GlobalEvents.ArtifactsUpdated = "RQM-Event-MainPage-Tab-Container-Artifacts-Updated";

// Use (publish) this event to notify other tabs that artifacts are added.  The optional
// "event from uri" is the URI of the page that post the event so the subscriber can skip
// notifying that page.
//   For example:
//     dojo.publish(GlobalEvents.ArtifactsAdded, ["artifact type", [array of artifacts], /*optional*/"event from uri"]);
// 
GlobalEvents.ArtifactsAdded = "RQM-Event-MainPage-Tab-Container-Artifacts-Added";

// Use (publish) this event to notify other tabs that artifacts are deleted.  Tabs that have
// reference to the artifacts should be deleted or updated.  The optional "event from uri" is
// the URI of the page that post the event so the subscriber can skip notifying that page.
//   For example:
//     dojo.publish(GlobalEvents.ArtifactsDeleted, ["artifact type", [array of artifacts], /*optional*/"event from uri"]);
// 
GlobalEvents.ArtifactsDeleted = "RQM-Event-MainPage-Tab-Container-Artifacts-Deleted";

// Use (publish) this event to notify other tabs that artifacts are un-deleted.  Tabs that have
// reference to the artifacts should be updated.  The optional "event from uri" is
// the URI of the page that post the event so the subscriber can skip notifying that page.
//   For example:
//     dojo.publish(GlobalEvents.ArtifactsUndeleted, ["artifact type", [array of artifacts], /*optional*/"event from uri"]);
// 
GlobalEvents.ArtifactsUndeleted = "RQM-Event-MainPage-Tab-Container-Artifacts-Undeleted";

// Use (publish) this event to refresh the tab with the specified URI.
//   For example:
//     dojo.publish(GlobalEvents.RefreshTab, ["tab-uri"]);
//
GlobalEvents.RefreshTab = "RQM-Event-MainPage-Tab-Container-Refresh-Tab";

// Use (publish) this event to close the tab with the specified URI.
//   For example:
//     dojo.publish(GlobalEvents.CloseTab, ["tab-uri"]);
//
GlobalEvents.CloseTab = "RQM-Event-MainPage-Tab-Container-Close-Tab";

// Use (publish) this event to refresh "MyTasks" viewlet.
//   For example:
//     dojo.publish(GlobalEvents.RefreshMyTasks, []);
//
GlobalEvents.DashboardFocus = "RQM-Event-MainPage-Tab-Container-Dashboard-Focus";

// Use (publish) this event to add "Created Test Cases Table" tab.
//   For example:
//     dojo.publish(GlobalEvents.TestCasesCreated, ["testcases-args"]);
//
GlobalEvents.TestCasesCreated = "RQM-Event-MainPage-Tab-Container-TestCases-Created";

// Use (publish) this event to update "Related Sites" panel in related info panel. 
//   For example:
//     dojo.publish(GlobalEvents.RelatedSitesUpdated, []);
//
GlobalEvents.RelatedSitesUpdated = "RQM-Event-MainPage-Related-Sites-Updated";

})();