/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.asq.common.web.ui.internal.util.TooltipBuilder");

dojo.require("com.ibm.asq.common.web.ui.internal.util.FunctionalTooltip");
//xojo.require("dijit.Tooltip");
dojo.require("jazz.ui.HoverPopup");

(function(){

    com.ibm.asq.common.web.ui.internal.util.TooltipBuilder = {
    
        addTooltip: function(html, elementToConnect){
			/*
            var span = document.createElement("span");
            span.innerHTML = html;
            elementToConnect.appendChild(span);
            */
			var span = dojo.doc.createElement("span");
            //var tip = new com.ibm.asq.common.web.ui.internal.util.FunctionalTooltip({connectId: elementToConnect, label: html}, span);
			var tip = new jazz.ui.HoverPopup({html: html, around: [elementToConnect]});
			//{label: tooltipText, connectId:[node]}
            return tip;
        },
        
        addLinkTip: function(/*LinkTypeDTO*/ linkType, /* LinkDTO */ link, elementToConnect){
            var html = this.getLinkTipHTML(linkType, link);
            return this.addTooltip(html, elementToConnect);
        },
        
        getLinkTipHTML: function(/*LinkTypeDTO*/ linkType, /* LinkDTO */ link){
            var html = "<table style=\"font-size: smaller; font-family:Verdana;\" border=0>";
            html += "<tr><td align=right><b>Id:</b></td><td>" + link.id + "</td></tr>";
            html += "<tr><td align=right><b>Name:</b></td><td>" + link.comment + "</td></tr>";
            
            if (link.section != null) {
                html += "<tr><td align=right><b>Section:</b></td><td>" + link.section + "</td></tr>";
            }
            else 
                if (link.field != null) {
                    html += "<tr><td align=right><b>Field:</b></td><td>" + link.field + "</td></tr>";
                }
            html += "</table>";
            return html;
        },
        
        addWorkItemSummaryTip: function(/* WorkItemSummaryDTO */ wiSummary, elementToConnect){
            var html = this.getWorkItemSummaryTipHTML(wiSummary);
            return this.addTooltip(html, elementToConnect);
        },
        
        getWorkItemSummaryTipHTML: function(/* WorkItemSummaryDTO */ wiSummary){
            var html = "<table style=\"font-size: smaller; font-family:Verdana;\" border=0>";
            html += "<tr><td align=right><b>Id:</b></td><td>" + wiSummary.id + "</td></tr>";
            html += "<tr><td align=right><b>Name:</b></td><td>" + wiSummary.summary + "</td></tr>";
            html += "<tr><td align=right><b>Type:</b></td><td>" + wiSummary.typeName + "</td></tr>";
            html += "<tr><td align=right><b>Owner:</b></td><td>" + wiSummary.ownerName + "</td></tr>";
            html += "<tr><td align=right><b>State:</b></td><td>" + wiSummary.stateName + "</td></tr>";
            html += "<tr><td align=right><b>Originator:</b></td><td>" + wiSummary.creatorName + "</td></tr>";
            html += "</table>";
            return html;
        },
        
        addWorkItemTip: function(/* WorkItemDTO */ workItem, elementToConnect){
            var html = this.getWorkItemTipHTML(workItem);
            return this.addTooltip(html, elementToConnect);
        },
        
        getWorkItemTipHTML: function(/* WorkItemDTO */ wi){
            var html = "<table style=\"font-size: smaller; font-family:Verdana;\" border=0>";
            html += "<tr><td align=right><b>Name:</b></td><td>" + wi.summary.content + "</td></tr>";
            html += "<tr><td align=right><b>Id:</b></td><td>" + wi.id + "</td></tr>";
            html += "<tr><td align=right><b>Description:</b></td><td>" + wi.description.content + "</td></tr>";
            html += "<tr><td align=right><b>Type:</b></td><td>" + wi.workItemType.label + "</td></tr>";
            html += "<tr><td align=right><b>Owner:</b></td><td>" + wi.owner.name + "</td></tr>";
            html += "<tr><td align=right><b>State:</b></td><td>" + wi.state.label + "</td></tr>";
            html += "<tr><td align=right><b>Originator:</b></td><td>" + wi.creator.name + "</td></tr>";
            html += "</table>";
            return html;
        },
		
		addLabelTooltip: function(html, labelSpan, widget){
			var span = dojo.doc.createElement("span");
            widget.tooltip = new com.ibm.asq.common.web.ui.internal.util.FunctionalTooltip({connectId: labelSpan,label: html}, span);
		}
        
    };
    
})();
