/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.requirement.web.ui.internal.util.XMLParser");

(function(){
    /*
     * TODO: support IE6+ & Firefox1.5+
     */
    dojo.declare("com.ibm.rqm.requirement.web.ui.internal.util.XMLParser", null, {
    
        ELEMENT_NODE_TYPE: 1,
        ATTRIBUTE_NODE_TYPE: 2,
        TEXT_NODE_TYPE: 3,
        
        constructor: function(/*XML document type*/doc){
            this.doc = doc;
            this.oEvaluator = new XPathEvaluator();
            this.nsResolver = this._getNSResolver;
        },
        
        _getNSResolver: function(prefix){
            var ns = {
                'a': 'http://www.w3.org/2005/Atom',
                'rqm': 'http://schema.ibm.com/rqm/2007'
            };
            return ns[prefix] || null;
        },
        
        getElementsByXPath: function(/*XPath*/xPath){
            var oResult = null;
            try {
                oResult = this.oEvaluator.evaluate(xPath, this.doc, this.nsResolver, XPathResult.ANY_TYPE, null);
            } 
            catch (e) {
                console.debug(e);
            }
            var aNodes = new Array();
            if (oResult != null) {
                var oElement;
                while ((oElement = oResult.iterateNext())) {
                    aNodes.push(oElement);
                }
            }
            return aNodes;
        },
        
        updateElementByXPath: function(/*XPath*/xPath, nodeType, value){
            var element = this.getElementsByXPath(xPath);
            if (element == null || element.length == 0) {
                alert("No returned nodes on" + xPath);
            }
            else 
                if (element.length > 1) {
                    alert("More than one nodes returned on" + xPath);
                }
                else {
                    var node = element[0];
                    if (node.nodeType != nodeType) {
                        alert("Type of returned node on " + xPath + " doesn't mach " + nodeType);
                    }
                    switch (node.nodeType) {
                        case this.ELEMENT_NODE_TYPE:
                            node = value;
                        case this.ATTRIBUTE_NODE_TYPE:
                            node.textContent = value;
                        case this.TEXT_NODE_TYPE:
                            node.textContent = value;
                    }
                }
        }
    });
})();
