/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading com.ibm.rqm.planning.web.ui.internal.view.actionbarentries.PlanningActionBarEntry");
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.actionbarentries.PlanningActionBarEntry");

dojo.require("com.ibm.team.repository.web.client.session.Session");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.asq.common.web.ui.internal.util.CSHelp");
dojo.require("com.ibm.asq.common.web.client.internal.PermissionsClient");
dojo.require("com.ibm.asq.common.web.ui.internal.util.GlobalEvents");

dojo.require("com.ibm.rqm.planning.web.client.internal.planning.PlanningPageClient");
dojo.require("com.ibm.rqm.planning.web.client.internal.mapper.TestPlanMapper");
dojo.require("com.ibm.rqm.planning.web.client.internal.QueryClient");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.EditorFactory");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.table.TestPlanTableView");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.table.SearchResultTableView");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.planning.TestPlanEditor");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.ActionBarEntry");
dojo.require("com.ibm.rqm.planning.web.ui.internal.page.ArtifactEditorPageController");
dojo.require("com.ibm.rqm.planning.web.ui.internal.model.ArtifactModel");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.jrs.Uploader");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.TestPlanConfigSelector");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.itemtemplates.TemplatesView");
dojo.require("com.ibm.rqm.planning.web.client.internal.planning.PlanningPageClient");
dojo.require("com.ibm.rqm.planning.web.client.internal.mapper.ScoredResultMapper");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.properties.SelectCategoryPopup");

(function() 
{
	var PlanningPageClient 			= com.ibm.rqm.planning.web.client.internal.planning.PlanningPageClient;
	var TestPlanMapper				= com.ibm.rqm.planning.web.client.internal.mapper.TestPlanMapper;
    var QueryClient                 = com.ibm.rqm.planning.web.client.internal.QueryClient;
	var TestPlanTableView  			= com.ibm.rqm.planning.web.ui.internal.view.table.TestPlanTableView;
	var SearchResultTableView       = com.ibm.rqm.planning.web.ui.internal.view.table.SearchResultTableView;
	var ArtifactEditorPageController = com.ibm.rqm.planning.web.ui.internal.page.ArtifactEditorPageController;
	var ArtifactModel               = com.ibm.rqm.planning.web.ui.internal.model.ArtifactModel;	
	var Constants          			= com.ibm.rqm.planning.web.client.internal.Constants;
	var EditorFactory 	   			= com.ibm.rqm.planning.web.ui.internal.util.EditorFactory;
	var getAuthenticatedContributor	= com.ibm.team.repository.web.client.session.getAuthenticatedContributor;
	var CSHelp                      = com.ibm.asq.common.web.ui.internal.util.CSHelp;
    var PermissionsClient           = com.ibm.asq.common.web.client.internal.PermissionsClient;
	var ServiceResponseHandler		= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
    var GlobalEvents                = com.ibm.asq.common.web.ui.internal.util.GlobalEvents;
    var TestPlanConfigSelector      = com.ibm.rqm.planning.web.ui.internal.view.common.TestPlanConfigSelector;
	var PlanningClient              = com.ibm.rqm.planning.web.client.internal.planning.PlanningPageClient;
	var ScoredResultMapper          = com.ibm.rqm.planning.web.client.internal.mapper.ScoredResultMapper;
	
	
	dojo.declare(
		"com.ibm.rqm.planning.web.ui.internal.view.actionbarentries.PlanningActionBarEntry",
		[com.ibm.rqm.planning.web.ui.internal.view.common.ActionBarEntry],
		{
			constructor: function()
			{
			},
	
			postCreate: function(args)
			{
			},
			
			initialize: function(args)
			{
				//com.ibm.rqm.planning.web.ui.internal.view.actionbarentries.PlanningActionBarEntry.superclass.initialize.call(this, args);
				this.inherited('initialize', arguments);
				
                var planPermission = PermissionsClient.getStoredPermission(PermissionsClient.OP_TEST_PLAN);
                var canCreatePlan = (!planPermission || planPermission.create);
                
                if(canCreatePlan) {
                    this._addMenuEntry(Constants.getMessage("labelNewTestPlan"), dojo.hitch(this, "_onClickNewTestPlan"), false, {'subAction':"newTestPlan", 'tq':""});
//                    this._addMenuSeparator();
//                    this._addMenuEntry(Constants.getMessage("labelMyTestPlan"), dojo.hitch(this, "_onClickMyTestPlans"), false, {'subAction':"viewMyTestPlans"});
                }
                
				this._addMenuEntry(Constants.getMessage("labelAllTestPlan"), dojo.hitch(this, "_onClickAllTestPlans"), false, {'subAction':"viewTestPlans"});
//				this._addMenuSeparator();
                
                if (canCreatePlan) {
                    this._addMenuEntry(Constants.getMessage("labelImportTestPlan"), dojo.hitch(this, "_onClickImportTestPlan"), false, {
                        'subAction': "importTestPlans"
                    });
                }
//				this._addMenuEntry(Constants.getMessage("labelExportTestPlan"), dojo.hitch(this, "_onClickExportTestPlan"), false, {'subAction':"exportTestPlans"});

                if(this.actionDispatcher) {
                    this.actionDispatcher.registerDispatchAction("doSearch", dojo.hitch(this, "doSearch"));
					this.actionDispatcher.registerDispatchAction("viewTestPlan", dojo.hitch(this, "viewTestPlan"));
                    this.actionDispatcher.registerDispatchAction("copyTestPlan", dojo.hitch(this, "copyTestPlan"));
                }
				
				var templatePermission = PermissionsClient.getStoredPermission(PermissionsClient.OP_TEMPLATE);
				var canManage = (!templatePermission || templatePermission.create);
				if (canManage) { //TODO update when template permissions added
					this._addMenuSeparator();
					this._addMenuEntry(Constants.getMessage("labelManageTemplates"), dojo.hitch(this, "showTemplates"), false, {
						'subAction': "showTemplates"
					});
                    if (this.actionDispatcher) {
                        this.actionDispatcher.registerDispatchAction("showTemplates", dojo.hitch(this, "showTemplates"));
                    }
				}
				
			},
			
		   /*
			* Provide access to an EditorFactory instance.
			*/
			getEditorFactory: function()
			{
				return EditorFactory;
			},
			
			_onClickNewTestPlan: function()
			{
				var artifactModel = new ArtifactModel(Constants.TYPE_PLAN);
				var editor = new com.ibm.rqm.planning.web.ui.internal.view.planning.TestPlanEditor({
                    parentController: this,
                    model: artifactModel					
				});
				//editor.setArtifactModel(artifactModel);
				//editor.initialize({ parentController: this, plan: null });
				var view = this._addPage({name: Constants.getMessage("labelNewTestPlan"), content: editor, closable: true});
                var controller = new ArtifactEditorPageController(artifactModel, view);
                controller.updateTab();
			},
			
			_onClickMyTestPlans: function()
			{
				var browserTitle = Constants.getMessage("labelTestPlan") + Constants.getMessage("labelColen") +" " + Constants.getMessage("labelMyView");
                this._loadTestPlans(Constants.getMessage("labelMyTestPlan"), browserTitle, {authenticatedContributor: getAuthenticatedContributor().itemId});		
			},
            
            _onClickAllTestPlans: function()
            {
				var browserTitle = Constants.getMessage("labelTestPlan") + Constants.getMessage("labelColen") +" " + Constants.getMessage("labelAllView");
				this._loadTestPlans(Constants.getMessage("labelAllTestPlan"), browserTitle, {});			
            },        
            
			_loadTestPlans: function(name, browserTitle, queryArgs)
            {
				//load class in Risk component
				jazz.core.internal.loader.load_async("com.ibm.rqm.risk.web.ui.internal.view.assessment.RiskProfileTemplateDialog", function(){});
				jazz.core.internal.loader.load_async("com.ibm.rqm.risk.web.client.internal.risk.RiskClient", function(){});
		
                queryArgs = queryArgs ? queryArgs : {};

                var permission = PermissionsClient.getStoredPermission(PermissionsClient.OP_TEST_PLAN);
				                
                var args = {
					parent: this,
                    plans: [], 
//                    showInitLoadProgress: true,
                    queryName: name,
//                    refreshCallback: dojo.hitch(this, "_refreshTestPlanList", queryArgs),
                    showFilters: true,
                    enableRowEditable: (!permission || permission[PermissionsClient.ACTION_EDIT])              
                }                
	            var planTableViewer = new TestPlanTableView(args);
				this._planTableViewer = planTableViewer;

                // set the reference to the tabs container to allow checking for opened artifact editors
                planTableViewer.artifactsDisplayContainer = this._contentArea;
				this._addPage({name: name, content: planTableViewer, closable: true, browserTitle:browserTitle});       
            },                
			
			_TestPlanHeaderColumnActionInvoked: function(tableViewer, columnIndex, actionId){
				var planTV = this._planTableViewer;
				var categoryType;
				if (actionId == Constants.getMessage("labelRiskAssessment")) {
					//handle risk assessment
					var profileDialog = new com.ibm.rqm.risk.web.ui.internal.view.assessment.RiskProfileTemplateDialog({
						artifactType: Constants.MODEL_TYPE_PLAN,
						actionId: actionId,
						okCallback: dojo.hitch(this, "_handleRiskProfile")
					});
				}
				else {
					for (var i = 0; i < planTV.categoryTypes.length; i++) {
						var categoryName = Constants.getMessage(planTV.categoryTypes[i].name);
						if (categoryName == actionId) {
							categoryType = planTV.categoryTypes[i];
							break;
						}
					}
					var args = {
						categoryType: categoryType,
						actionId: actionId,
						okCallback: dojo.hitch(this, "_handleBulkChanged")
					}
					var dlg = new com.ibm.rqm.planning.web.ui.internal.view.common.properties.SelectCategoryPopup();
					dlg.initialize(args);
				}
			},
		    
		    _handleBulkChanged: function(args){
		    	var self=this;
		        var planTV = this._planTableViewer;
		        var handler = {
		            success: function(plans) {
						var content = planTV.tableViewer.getContent();
						for(var i in plans){
							for(var j in content){
								var c = content[j];
								var p = plans[i];
								if(c.id == p.id){
									c.modified = p.modified;
									c.categories = p.categories;
								}
							}
						}
						planTV.tableViewer.refresh();					
		            },
		            error: function(e) {
		                self._error(e);
		            }
		        }
		    			
				var params = { uid:[], categories:[]};
				var selectedItems = planTV.tableViewer.getCheckedRows();
				var iLength=selectedItems.length;
		        for(var i=0; i<iLength; i++){
					var categories = [];
					var si = selectedItems[i];
					var categ = si.categories;
					if (categ) {
						var cLength=categ.length;
						for (var k = 0; k < cLength; k++) {
							categories.push(categ[k].itemId);
						}
					}
		            categories = planTV._mergeCategory(categories, args.categoryTypeItemId, args.categoryValueItemId);
		            params.categories.push(categories.join());
					params.uid.push(si.itemId);
		        }
		
		        var responseHandler = new ServiceResponseHandler(handler, "success", "error");          
		        PlanningClient.postBulkChangeTestPlan(responseHandler, params);        
		    },
			
			_handleRiskProfile: function(args) {
				if(args && args.selectedProfile) {
					var planTV = this._planTableViewer;
					var selectedItems = planTV.tableViewer.getCheckedRows();	
					
					var self = this;
                    var handler = {
                        success: function(riskAssessments){
                            var content = planTV.tableViewer.getContent();
                            for (var i in selectedItems) {
                                for (var j in content) {
                                	var c=content[j];
                                    if (c.id == selectedItems[i].id) {
                                        c.risk = self._refreshPlanRisk(c, riskAssessments);
                                    }
                                }
                            }
                            planTV.tableViewer.refresh();
                        },
                        error: function(e){
                            self._error(e);
                        }
                    }
					var itemIds = [];
					for(var i = 0; i < selectedItems.length; i++) {
						itemIds.push(selectedItems[i].versionableItemId);
					}
                    var params = {
                        artifactType: Constants.MODEL_TYPE_PLAN,
                        riskProfileId: args.selectedProfile.id,
                        operation: args.handleAction,
                        artifactItemIds: itemIds
                    };
                    
                    var responseHandler = new ServiceResponseHandler(handler, "success", "error");
                    com.ibm.rqm.risk.web.client.internal.risk.RiskClient.postSwitchRiskProfile(responseHandler, params);
				}  
			},
			
			_refreshPlanRisk: function(plan, riskAssessments) {
				var newSystemRiskLevel = "0";
				for(var i = 0; i < (riskAssessments?riskAssessments.length:0); i++) {
					if(plan.versionableItemId == riskAssessments[i].targetArtifactItemId){
						newSystemRiskLevel = riskAssessments[i].riskLevel;
						break;
					}
				}
				var newRisk = "";
				var oldRisk = plan.risk;
				if(oldRisk != "") 
					newRisk = oldRisk.slice(0, oldRisk.indexOf("calculatedRisk")+15) + newSystemRiskLevel;
				else 
					newRisk = "communityRisk:0 calculatedRisk:"+newSystemRiskLevel;
				return newRisk;
			},
			
            _refreshTestPlanList: function(queryArgs, tableView) {
                var self = this;
                var handler = {
                    success: function(plans) {
                        if (tableView) {
                            tableView.refresh(plans ? plans : []);
                        }
                    },
                    error: function(e) {
                        self._error(e);
                    }
                }
                
                var responseHandler = new TestPlanMapper(handler, "success", "error");
                PlanningPageClient.getTestPlansSummary(responseHandler, queryArgs);
            },             
			
			_onClickImportTestPlan: function()
			{
                var importer = new com.ibm.asq.common.web.ui.internal.widgets.jrs.Uploader({
					title: Constants.getMessage("labelImportTestPlan"),
					artifactType: "testplan",
                    importPrompt: Constants.getMessage("msgImportTestPlan"),
                    contextHelpId: "rqm_import_test_plan.html",
                    cshelpLabel: Constants.getMessage("labelImportTestPlanHelp")
				});
				
				importer._header.setCSHelpButtonLabel(Constants.getMessage("labelImportTestPlanHelp"));
				var browserTitle = Constants.getMessage("labelTestPlan") + Constants.getMessage("labelColen") +" " + Constants.getMessage("labelImport");
				this._addPage( {name: Constants.getMessage("labelImportTestPlan"), content: importer, closable: true, browserTitle:browserTitle});
			},
			
			_onClickExportTestPlan: function()
			{
				var browserTitle = Constants.getMessage("labelTestPlan") + Constants.getMessage("labelColen") +" " + Constants.getMessage("labelExport");
				this._addPage( {name: Constants.getMessage("labelExportTestPlan"), content: "This is the work area for exporting a Test Plan.", closable: true, browserTitle:browserTitle});
			},
			
			viewTestPlan: function(kwArgs)
            {
				var artifactModel = new ArtifactModel(Constants.TYPE_PLAN);
                var editor = new com.ibm.rqm.planning.web.ui.internal.view.planning.TestPlanEditor({
					parentController: this,
					model: artifactModel,
					kwArgs: kwArgs
				});
				//editor.setArtifactModel(artifactModel);
                //editor.initialize({ parentController: this, plan: plans[0] });
                var view = this._addPage({name: Constants.getMessage("labelLoading"), content: editor, closable: true});
                var controller = new ArtifactEditorPageController(artifactModel, view);
                controller.updateTab();
            },  
            
			copyTestPlan: function(kwArgs)
            {              
				var artifactModel = new ArtifactModel(Constants.TYPE_PLAN);
                var editor = new com.ibm.rqm.planning.web.ui.internal.view.planning.TestPlanEditor({
                    parentController: this,
                    model: artifactModel,
					copy: true,
                    kwArgs: kwArgs					
				});
				//editor.setArtifactModel(artifactModel);
                //editor.initialize({ parentController: this, plan: plans[0], isCopy: true });
                var view = this._addPage({name: Constants.getMessage("labelLoading"), content: editor, closable: true});
                var controller = new ArtifactEditorPageController(artifactModel, view);
                controller.updateTab();
            },             
			
			//SEARCH
            doSearch: function(args) {
                // create a search result tab and show search in progress
                var resultsTable = new SearchResultTableView({
                    results: null,
                    searchText: args.searchText
                });
                var page = this._addPage({
                               name: Constants.getMessage("labelSearchingText", args.searchText), 
                               content: resultsTable, 
                               closable: true
                           });
                resultsTable.setInProgress(Constants.getMessage("labelSearchingText", args.searchText));
                
				var self = this;
				var handlerObj = {
					success: function(results) {
						self._showSearchResults(results, args.searchText, resultsTable, page);
					},
					failure: function(error) {
						self._error(error);
                        self._showSearchResults(null, args.searchText, resultsTable, page);
					}
				} 
				
                var responseHandler = new ScoredResultMapper(handlerObj, "success", "failure");
                QueryClient.getGenericSearch(responseHandler, args.searchText);
            },
			
			_showSearchResults: function(results, searchText, resultsTable, page) {
                // update search result table
				resultsTable.refresh(results);
                resultsTable.stopInProgress();
                
                if (searchText.length > 20) {
                    // compact search text for label of the tab
                    searchText = searchText.substring(0, 8) + "..." + searchText.substring(searchText.length - 5);
                }
                // update page tab button label
                dojo.publish(GlobalEvents.UpdateTabLabel, [
                                    window.location.hash,
                                    Constants.getMessage("labelSearchResult", searchText, results ? results.length : 0),
                                    null,  // no icon
                                    false, // no dirty indicator
                                    true   // don't compact the label, already taken care of
                                ]);
			},
			
            showTemplates: function() {            
                var templatesView = new com.ibm.rqm.planning.web.ui.internal.view.itemtemplates.TemplatesView();
				var browserTitle = Constants.getMessage("labelTestPlan") + Constants.getMessage("labelColen") +" " + Constants.getMessage("labelTemplates");
                var view = this._addPage({
                    name: Constants.getMessage("labelManageTemplates"),
                    content: templatesView.domNode,
                    closable: true,
					browserTitle: browserTitle
                });             
            },			

			_error: function(error) 
			{
				console.debug("PlanningActionBarEntry: Error invoking service; message: " + error.message);
			}
		}
	);
}
)();
