/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.administration.AdapterSelectionContentArea");

dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");

dojo.require("com.ibm.asq.common.web.ui.internal.util.CSHelp");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.administration.AbstractPreferenceContentArea");
dojo.require("dijit.form.CheckBox");

(function(){
	var ServiceResponseHandler		= com.ibm.team.repository.web.transport.ServiceResponseHandler;
	var Constants 					= com.ibm.rqm.planning.web.client.internal.Constants;
	
    dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.administration.AdapterSelectionContentArea", com.ibm.rqm.planning.web.ui.internal.view.administration.AbstractPreferenceContentArea, {
        templateString: '<div>' +
					        '<table>' +
					        	'<tr><td class="content-name"><span dojoAttachPoint="_name"></span><span dojoAttachPoint="_cshelp"></span></td>'+
								'</tr>' +
						        '<tr><td><div dojoAttachPoint="_content">' +
							        '<table>' +
							        	'<tr><td width="16px" style="vertical-align: top;">' +
							        		'<input type="radio" value="labelShowAdapter" id="showAdapter" dojoAttachPoint="checkBoxShowAdapter" name="adapter" dojoType="dijit.form.CheckBox"/>'+
										'</td><td><label for="showAdapter"> ${labelShowAdapter}</label>' +
							        	'</td></tr>' +
										'<tr><td colspan="2" style="padding-top: 5px;padding-bottom: 10px">' +
							        		'<label class="note-text">${labelNote}</label><label class="note-text">${labelShowAdapterWarning}</label>' +
							        	'</td></tr>' +
							        	'<tr><td width="16px" style="vertical-align: top;">' +
							        		'<input type="radio" value="labelSearchAdapterWithinCell" id="searchadapter" dojoAttachPoint="checkBoxSearchAdapterWithinCell" name="searchadapter" dojoType="dijit.form.CheckBox"/>'+
										'</td><td><label for="searchadapter"> ${labelSearchAdapterWithinCell}</label>' +
							        	'</td></tr>' +

							        '</table>' +
						        '</div></td></tr>' +
					        '</table>' +
				        '</div>',
        
		key: Constants.USER_UI_CUSTOMISE_ACTIONBAR_ADAPTERSELECTION_CATEGORY.key,
		widgetsInTemplate: true,
		
		labelNote: Constants.getMessage("labelNote"),
		labelShowAdapter: Constants.getMessage("labelShowAdapter"),
		labelShowAdapterWarning: Constants.getMessage("labelShowAdapterWarning"),
		labelSearchAdapterWithinCell: Constants.getMessage("labelSearchAdapterWithinCell"),
		
		postCreate: function(){
			this.csHelpId = "rqm_auto_adapter.html";
            this.csHelpLabel = Constants.getMessage("labelAdapterPreferenceHelp");
            
			this.inherited("postCreate", arguments);
			this.connect(this.checkBoxShowAdapter, "onChange", "onChange");
			this.connect(this.checkBoxSearchAdapterWithinCell, "onChange", "onChange");
		},
		
		// @override for AbstractContentArea
        setName: function(){
            dojox.data.dom.removeChildren(this._name);
            this._name.appendChild(document.createTextNode(Constants.getMessage("labelAdapterPreference")));
        },

		// @overrie for AbstractPreferenceContentArea
        getValues: function(){
            return [{
                key: this.key,
                value: {
						showAdapter: this.checkBoxShowAdapter.checked,
						searchAdapterWithinCell: this.checkBoxSearchAdapterWithinCell.checked
					}
            }];
        },
		
		// @overrie for AbstractPreferenceContentArea
		displayUserPreference: function(userPreferences){
			var length = userPreferences.length;
			for(var i = 0; i < length; i++){
				var userPreferenceValue = userPreferences[i].value;
                this.checkBoxShowAdapter.setChecked(userPreferenceValue.showAdapter);
				this.checkBoxSearchAdapterWithinCell.setChecked(userPreferenceValue.searchAdapterWithinCell);
			}
		},
		
		// @overrie for AbstractPreferenceContentArea
		isHotSwitchable: function(){
			return true;
		}
    });
    
})();
