/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.administration.ArtifactEditorContentArea");

dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");

dojo.require("com.ibm.asq.common.web.ui.internal.util.CSHelp");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.administration.AbstractPreferenceContentArea");

(function(){
	var ServiceResponseHandler		= com.ibm.team.repository.web.transport.ServiceResponseHandler;
	var Constants 					= com.ibm.rqm.planning.web.client.internal.Constants;
	
    dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.administration.ArtifactEditorContentArea", com.ibm.rqm.planning.web.ui.internal.view.administration.AbstractPreferenceContentArea, {
        templateString: '<div>' +
				        '<table>' +
				        '<tr><td class="content-name"><span dojoAttachPoint="_name"></span><span dojoAttachPoint="_cshelp"></span></td></tr>' +
				        '<tr><td><div dojoAttachPoint="_content">' +
				        '<table style="border-spacing: 5px;">' +
				        '    <tr><td>' +
				        '    <label><input type="radio" value="TOCSingleSection" dojoAttachPoint="TOCSingleSection" name="toc" dojoType="dijit.form.RadioButton"/> ${labelShowSingleSection}</label>' +
				        '    </td></tr>' +
						'    <tr><td>' +
						'        <div style="margin-left:16px"><span style="float:left" class="pref-singlesect-icon-24"></span><span><label>${labelShowSingleSectionDescription}</label></span></div>' + 
						'    </td></tr>' +
						'    <tr><td>' +
				        '        <label><input type="radio" value="TOCAllSection" dojoAttachPoint="TOCAllSection" name="toc" dojoType="dijit.form.RadioButton"/> ${labelShowAllEditorSections}</label>' +
				        '    </td></tr>' +
						'    <tr><td>' +
						'        <div style="margin-left:16px"><span style="float:left" class="pref-allsections-icon-24"></span><span><label>${labelShowAllSectionsDescription}</label></span></div>' + 
						'    </td></tr>' +
						'    <tr><td style="padding-top: 10px;">' +
				        '        <label class="note-text">${labelNote}</label><label class="note-text">${labelArtifactEditorTOCNote}</label>' +
				        '    </td></tr>' +
				        '</table>' +
				        '</div></td></tr>' +
				        '</table>' +
				        '</div>',
        
		key: Constants.USER_UI_CUSTOMISE_ACTIONBAR_TOC_CATEGORY.key,
		widgetsInTemplate: true,
		
		labelShowAllEditorSections: Constants.getMessage("labelShowAllEditorSections"),
		labelShowSingleSection: Constants.getMessage("labelShowSingleSection"),
		labelShowAllSectionsDescription: Constants.getMessage("labelShowAllSectionsDescription"),
		labelShowSingleSectionDescription: Constants.getMessage("labelShowSingleSectionDescription"),
		labelNote: Constants.getMessage("labelNote"),
		labelArtifactEditorTOCNote: Constants.getMessage("labelArtifactEditorTOCNote"),
		
		postCreate: function(){
			this.csHelpId = "rqm_pref_editor_toc.html";			
            this.csHelpLabel = Constants.getMessage("labelEditorTOCHelp");
            
			this.inherited("postCreate", arguments);
			dojo.connect(this.TOCSingleSection, "onChange", this, "onChange");
			dojo.connect(this.TOCAllSection, "onChange", this, "onChange");
		},
		
		// @override for AbstractContentArea
        setName: function(){
            dojox.data.dom.removeChildren(this._name);
            this._name.appendChild(document.createTextNode(Constants.getMessage("labelArtifactEditorTOC")));
        },
        
		// @overrie for AbstractPreferenceContentArea
        getValues: function(){
			var TOCAllSection = this.TOCAllSection;
            return [{
                key: this.key,
                value: TOCAllSection.checked == true ? TOCAllSection.getValue() : this.TOCSingleSection.getValue()
            }];
        },
		
		// @overrie for AbstractPreferenceContentArea
		isHotSwitchable: function(){
			return true;
		}
    });
    
})();
