/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.administration.EditorTextDirectionContentArea");

dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");

dojo.require("com.ibm.asq.common.web.ui.internal.util.CSHelp");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.administration.AbstractPreferenceContentArea");

(function(){
	var ServiceResponseHandler		= com.ibm.team.repository.web.transport.ServiceResponseHandler;
	var Constants 					= com.ibm.rqm.planning.web.client.internal.Constants;
	
    dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.administration.EditorTextDirectionContentArea", com.ibm.rqm.planning.web.ui.internal.view.administration.AbstractPreferenceContentArea, {
        templateString: '<div>' +
				        '<table>' +
				        '<tr><td class="content-name"><span dojoAttachPoint="_name"></span><span dojoAttachPoint="_cshelp"></span></td></tr>' +
				        '<tr><td><div dojoAttachPoint="_content">' +
				        '<table>' +
				        '	<tr><td width="16px" style="vertical-align: top;">' +
				        '			<input type="radio" value="LTR" dojoAttachPoint="LTR" name="direction" dojoType="dijit.form.RadioButton"/>'+
						'    </td><td><label>${labelLeftToRight}</label>' +
				        '	</td></tr>' +
						'	<tr><td width="16px" style="vertical-align: top;">' +
				        '			<input type="radio" value="RTL" dojoAttachPoint="RTL" name="direction" dojoType="dijit.form.RadioButton"/>'+
						'    </td><td><label>${labelRightToLeft}</label>' +
				        '	</td></tr>' +
						'	<tr><td colspan="2" style="padding-top: 10px;">' +
				        '			<label class="note-text">${labelNote}</label><label class="note-text">${labelArtifactEditorTOCNote}</label>' +
				        '	</td></tr>' +
				        '</table>' +
				        '</div></td></tr>' +
				        '</table>' +
				        '</div>',
        
		key: Constants.USER_UI_CUSTOMISE_EDITOR_TEXT_DIRECTION_CATEGORY.key,
		widgetsInTemplate: true,
		
		labelLeftToRight: Constants.getMessage("labelLeftToRight"),
		labelRightToLeft: Constants.getMessage("labelRightToLeft"),
		labelNote: Constants.getMessage("labelNote"),
		labelArtifactEditorTOCNote: Constants.getMessage("labelArtifactEditorTOCNote"),
		
		postCreate: function(){
			this.csHelpId = "rqm_pref_editor_text_direction.html";			
            
			this.inherited("postCreate", arguments);
			dojo.connect(this.LTR, "onChange", this, "onChange");
			dojo.connect(this.RTL, "onChange", this, "onChange");
		},
		
		// @override for AbstractContentArea
        setName: function(){
            dojox.data.dom.removeChildren(this._name);
            this._name.appendChild(document.createTextNode(Constants.getMessage("labelEditorTextDirection")));
        },
        
		// @overrie for AbstractPreferenceContentArea
        getValues: function(){
            return [{
                key: this.key,
                value: this.LTR.checked == true ? this.LTR.getValue() : this.RTL.getValue()
            }];
        },
		
		// @overrie for AbstractPreferenceContentArea
		isHotSwitchable: function(){
			return true;
		},

        // @overrie for AbstractPreferenceContentArea in the case that the preference is not set from 
        // version upgrade that does not contain this preference previously
        displayUserPreference: function(userPreference){
            if (!userPreference || (userPreference.length == 0)) {
                // checking the radio button will trigger change event to enable
                // the OK button on the dialog to save the preference on close.
                this.LTR.setChecked(true);
            } else {
                this.inherited('displayUserPreference', arguments);
            }
        }
    });
    
})();
