/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.administration.ExecutionUserPreferenceContentArea");
/*
 * This widget contains multiple user preferences for execution page.
 * author: vasrivas
 */

dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");
dojo.require("com.ibm.asq.common.web.ui.internal.util.CSHelp");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.administration.AbstractPreferenceContentArea");
dojo.require("dijit.form.CheckBox");
dojo.require("com.ibm.asq.common.web.client.internal.option");
dojo.require("com.ibm.team.process.web.client.projectarea");

(function(){
	var ServiceResponseHandler		= com.ibm.team.repository.web.transport.ServiceResponseHandler;
	var Constants 					= com.ibm.rqm.planning.web.client.internal.Constants;
	var getCurrentProjectArea		= com.ibm.team.process.web.client.projectarea.getCurrentProjectArea;
    dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.administration.ExecutionUserPreferenceContentArea", com.ibm.rqm.planning.web.ui.internal.view.administration.AbstractPreferenceContentArea, {
        templateString: '<div>' +
					        '<table>' +
					        	'<tr><td class="content-name"><span dojoAttachPoint="_name"></span><span dojoAttachPoint="_cshelp"></span></td>'+
								'</tr>' +
						        '<tr><td><div dojoAttachPoint="_content">' +
							        '<table>' +
							        	'<tr><td width="16px" style="vertical-align: top;">' +
							        		'<input type="radio" value="labelConfirmBeforeApplyAll" dojoAttachPoint="checkBoxApplyAll" name="applyAll" dojoType="dijit.form.CheckBox"/>'+ 
										'</td><td><label>${labelConfirmBeforeApplyAll}</label>' +
							        	'</td></tr>' +
										'<tr><td width="16px" style="vertical-align: top;">' +
							        		'<input type="radio" value="labelHideAnimationOnApplyAll" dojoAttachPoint="checkBoxAnimation" name="animation" dojoType="dijit.form.CheckBox"/>'+
											'</td><td><label>${labelHideAnimationOnApplyAll}</label>' +
							        	'</td></tr>' +
										'<tr><td width="16px" style="vertical-align: top;">' +
							        		'<input type="radio" value="labelAssociateManual" dojoAttachPoint="checkBoxAssociateManualWithKeyword" name="associatemanual" dojoType="dijit.form.CheckBox"/>'+
											'</td><td><label>${labelAssociateManualScriptWithKeyword}</label>' +
							        	'</td></tr>' +
										'<tr><td width="16px" style="vertical-align: top;">' +
							        		'<input type="radio" value="labelAskOnFail" dojoAttachPoint="checkBoxAskOnFail" name="askonfail" dojoType="dijit.form.CheckBox"/>'+
											'</td><td><label>${labelAskOnFail}</label>' +
							        	'</td></tr>' +
										'<tr><td width="16px" style="vertical-align: top;">' +
							        		'<input type="radio" value="labelShowLastRunScript" dojoAttachPoint="checkBoxShowLastRunScript" name="lastrun" dojoType="dijit.form.CheckBox"/>'+
											'</td><td><label>${labelShowLastRunScript}</label>' +
							        	'</td></tr>' +
							        '</table>' +
						        '</div></td></tr>' +
					        '</table>' +
				        '</div>',
        
		key: Constants.USER_UI_CUSTOMISE_EXECUTION_PREF_CATEGORY.key,
		widgetsInTemplate: true,
		
		labelAssociateManualScriptWithKeyword: Constants.getMessage("labelAssociateManualScriptWithKeyword"),
		labelConfirmBeforeApplyAll: Constants.getMessage("labelConfirmBeforeApplyAll"),
		labelHideAnimationOnApplyAll: Constants.getMessage("labelHideAnimationOnApplyAll"),
		labelAskOnFail: Constants.getMessage("labelAskOnFail"),
		labelShowLastRunScript: Constants.getMessage("labelShowLastRunScript"),

		postCreate: function(){
			this.csHelpId = "rqm_exec_user_pref.html";
            this.csHelpLabel = Constants.getMessage("labelExecPrefHelp");
            
			this.inherited("postCreate", arguments);
			this.connect(this.checkBoxApplyAll, "onChange", this.onChange);
			this.connect(this.checkBoxAnimation, "onChange", this.onChange);
			this.connect(this.checkBoxAssociateManualWithKeyword, "onChange", this.onChange);
			this.connect(this.checkBoxAskOnFail, "onChange", this.onChange);
			this.connect(this.checkBoxShowLastRunScript, "onChange", this.onChange);
			
			//Check if system Admin has disbaled the functinality, disable user pref also.
			var option = new com.ibm.asq.common.web.client.internal.option();
			var handler = new ServiceResponseHandler(this, "successFetchAdminPref", "failedFetchAdminPref");
			option.getProjectPreferences(handler, getCurrentProjectArea().itemId, Constants.EXECUTION_SYSTEM_CONSTRAINTS);
		},
		
		successFetchAdminPref: function(adminSetting){
			if(adminSetting && adminSetting.value){
				var value = dojo.fromJson(adminSetting.value);
				if(value.disableApplyAll){
					this.checkBoxApplyAll.setDisabled(true);
					this.checkBoxAnimation.setDisabled(true);
				}
			}
		},
		
		failedFetchAdminPref: function(){
			console.error("failed to fetch admin pref under user pref");
		},
		
		// @override for AbstractContentArea
        setName: function(){
            dojox.data.dom.removeChildren(this._name);
            this._name.appendChild(document.createTextNode(Constants.getMessage("labelExecutionPreferences")));
        },

		// @override for AbstractPreferenceContentArea
        getValues: function(){
			return [{
                key: this.key,
                value: {
						applyall: this.checkBoxApplyAll.checked, 
						animation: this.checkBoxAnimation.checked,
						associatemanual: this.checkBoxAssociateManualWithKeyword.checked,
						askonfail: this.checkBoxAskOnFail.checked,
						showlastrunscript : this.checkBoxShowLastRunScript.checked 
					   }
            }];
        },
		
		// @override for AbstractPreferenceContentArea
		displayUserPreference: function(userPreferences){
			var length = userPreferences.length;
			for(var i = 0; i < length; i++){
				var userPreferenceValue = userPreferences[i].value;
                this.checkBoxApplyAll.setChecked(userPreferenceValue.applyall);
				this.checkBoxAnimation.setChecked(userPreferenceValue.animation);
				this.checkBoxAssociateManualWithKeyword.setChecked(userPreferenceValue.associatemanual);
				this.checkBoxAskOnFail.setChecked(userPreferenceValue.askonfail);
				this.checkBoxShowLastRunScript.setChecked(userPreferenceValue.showlastrunscript);
			}
		},
		
		// @override for AbstractPreferenceContentArea
		isHotSwitchable: function(){
			return true;
		}
    });
    
})();
