//debug listcellrenderer

/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.administration.ListCellRenderer");

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellRenderer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.Button");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.administration.ListCellWidget");


(function() {

dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.administration.ListCellRenderer", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellRenderer,
{    
	cellModifier: null,
	rowObject: null,
	columnIndex: 0,
	
    // Summary:
    //    Renders the image cell content. The following cellData can be expected. 
    //    
    renderCell: function(viewer, cellData, extendedDisplayInfo, /*table.CellModifier*/ cellModifier, rowObject, columnIndex){
		this.rowObject = rowObject;
		this.columnIndex = columnIndex;
		this.cellModifier = cellModifier;	
		var args = {
                validateCallback: dojo.hitch(this, "_onValidate"),
                changedCallback: dojo.hitch(this, "_onChanged"),
				cellData: cellData,
				rowObject:rowObject
        };
		var lcw = new com.ibm.rqm.planning.web.ui.internal.view.administration.ListCellWidget(args);
        this.cellNodes.push(lcw);
		return lcw.domNode;
	},
	
	_onValidate: function(oldList, newList, action, rowObject)
	{
		return this.cellModifier.cellValueValidate(oldList, newList, rowObject, this.columnIndex, action);		
	},
	
	_onChanged: function(oldList, newList, action, rowObject)
	{
		this.cellModifier.cellValueChanged(oldList, newList, rowObject, this.columnIndex, action);
	},
    
    disconnectAll: function()
    {
        //console.debug("================CheckboxCellRenderer disconnectAll");
        this.inherited(arguments);
        var cellNodes = this.cellNodes;
        var len = cellNodes.length;
        for(var i = 0; i < len; i++) {
            var node = cellNodes[i];
            if(node.destroy)
                node.destroy();
        } 
        this.cellNodes = [];
    }


});

})();
