//debug PartAttributeTableDialog
/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.administration.PartAttributeTableDialog");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.asq.common.web.ui.internal.util.CSHelp");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.administration.PartAttributeTableView");

(function() {
var Constants               = com.ibm.rqm.planning.web.client.internal.Constants;
var CSHelp                  = com.ibm.asq.common.web.ui.internal.util.CSHelp;
var PartAttributeTableView	= com.ibm.rqm.planning.web.ui.internal.view.administration.PartAttributeTableView;


dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.administration.PartAttributeTableDialog",[dijit._Widget, dijit._Templated],
	{
        templateString: '<div class="com-ibm-rqm-test-common-select-item-table">' +
		                '    <div dojoAttachPoint="_msgArea" class="NormalStatus"></div>' +
						'    <div dojoAttachPoint="_itemListArea" class="ItemList"></div>' +
                        '</div>',
        width: "700px",   //default dialog width
		showHidden: "off",  // show hidden attribute
		templates: null,		
		postCreate: function() {
		},
		
        _showAsDialog: function(part) {
            var dialogArgs = {
                primaryTitle: this.title ? this.title : Constants.getMessage("labelManageAttrs" , part.getName()),
                okCallback: dojo.hitch(this, "_onOK"),
                cancelCallback: dojo.hitch(this, "_onCancel"),
				_truncate: function() {},  //disable the Dialog's '_truncate'
				zIndex:998,
            	forceZIndex:true
            };
            this._dialog = new com.ibm.asq.common.web.ui.internal.widgets.SelectionDialog(dialogArgs);
            var cshelp = new CSHelp({contextID: "rtlm_edit_attributes.html"});
            cshelp.setButtonLabel(Constants.getMessage("labeEditAttributeCSHelp"));
            this._dialog.setSecondaryTitleNode(cshelp.domNode);
            this._dialog.setWidth(this.width);
            this._dialog.contentContainer.appendChild(this.domNode);
			this._dialog.open(false);
			this._dialog.updatePosition();
			this._dialog.getOkButton().disabled = false;
        },		
		
        repositionDialog: function() {
            if (this._dialog) {
                // set timeout to allow the browser to render dialog
                setTimeout(dojo.hitch(this._dialog, "updatePosition"), 100);
            }
        },

        show: function(/*PartContainer*/item){
			if(item){			
				var part = item.part;			
				if (!this._dialog) {
                	this._showAsDialog(part);
            	}
				if (this._viewer == null) {
					this._viewer = new PartAttributeTableView({okButton:this._dialog.getOkButton(),  showHidden: this.showHidden, templates: this.templates, containingPart: part});
				}
				var names = part.getNonInheritedAttributeNames();
				var attributes  = [];
				for(var i = 0; i < names.length; i++){
					var attr = part.getAttribute(names[i]);
					if(attr)
						attributes.push(attr);
				}
				this._viewer.refresh(attributes);          
            	dojox.data.dom.removeChildren(this._itemListArea);
            	this._itemListArea.appendChild(this._viewer.domNode);
            	this._dialog.updatePosition();
            }
		},
		
        _onCancel: function() {
            this.onCancelClicked();          
        },
        
        _onOK: function() {
			var hasModified = this._viewer.hasModified();
			this._viewer.save();
			this.onOkClicked(hasModified);		
			return true;	
        },		
		

		// public methods to receive notification of the dialog's actions.
		onOkClicked: function(hasModified)
		{
			// summary: 
			//    Called when the dialog's ok button is clicked.
			//    'hasModified' parameter indicates whether the user
			//    had made changes to the part's attributes.
		},
        onCancelClicked: function()
        {
        }
	}
);

})();
