/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Load: com.ibm.rqm.planning.web.ui.internal.view.administration.StateTransitionConstraintTableView");
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.administration.StateTransitionConstraintTableView");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");

dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");

(function(){
	var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
    var TableConstants = com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;
	var ImageCache     = com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
	var AlertDialog = com.ibm.asq.common.web.ui.internal.widgets.AlertDialog;
	var ConfirmationDialog = com.ibm.asq.common.web.ui.internal.widgets.ConfirmationDialog;
	
    dojo.declare("StateTransitionConstraintTableView.TableListener", com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableListener, {
        parentView: null,
    
    	tableContentActionInvoked: function(tableViewer, actionId, callbackData, callback)
    	{
        	if (callback != null && dojo.isFunction(callback)) {
		        callback();
		   	}  
    	}
    });
    
    dojo.declare("StateTransitionConstraintTableView.CellModifier", com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier, {
        tableViewer: null,
		
		constructor: function(parentView)	{
	        	this.parentView = parentView;
	    },
        
        cellValueChanged: function(oldValue, newValue, rowObject, columnIndex){
//			alert(newValue);
            if(columnIndex > 0){
				rowObject.state = newValue;
//				this.parentView.saveActionNode.setDisabled(false);
				this.parentView.parent.setDirty(true);
			}
        },
		
		cellActionInvoked: function(rowObject, columnIndex)
	    {
//			if(columnIndex == 2) {
//				this.parentView._handleStopSynchronization(rowObject);
//			}
	    }
    });
    
    dojo.declare("StateTransitionConstraintTableView.TableProvider", com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider, {
        getNumColumns: function(content){
            return 2;
        },
        
        getColumnHeading: function(content, index){
			if(index == 0){
				return Constants.getMessage("LabelConstraint");
			}
			if (index == 1)
				return(Constants.getMessage("LabelEnabled"));
        },
        
		getIsColumnGroupable: function(content, atColumnIndex)
	    {
	        return false;     
	    },
		
        getIsColumnSortable: function(content, atColumnIndex){
            return false;
        },
		
        getColumnWidth: function(content, atColumnIndex){
			if(atColumnIndex == 0){
				return 90;
			}
			if (atColumnIndex == 1)
				return 10;
        },
		
        getIsCellEditable: function(rowData, atColumnIndex){
				return true;
        },
        
        // Summary:
        //    The only assumptions the table have on the data that it displays
        //    is that it's an array contents. These are the data content/object that
        //    will be displayed in the table rows.
        //
        getContentObjects: function(content){
            // our content is already an array of objects
            return content;
        },
        
        getRowDataId: function(rowData){
            return rowData.id;
        },
        
        // Summary:
        //    Returns the type of the cell to be displayed. By default, the TableViewer
        //    will support a set of cell types. The type of the cell will map to a specific
        //    cell renderer (to be discussed).
        getCellDisplayType: function(rowData, atColumnIndex){
			if(atColumnIndex > 0){
				return TableConstants.RENDER_TYPE_CHECKBOX;
			}else{
				return TableConstants.RENDER_TYPE_TEXT;
			}
        },
        
        // Summary:
        //    Returns the display data of the cell. For cell renderer type of TEXT, this will
        //    be the string. Others cell render type would be Date, or integer value, etc. If the 
        //    cell renderer type is image, the client can also supply cell data that can be sortable/groupable. 
        //    The TableViewer's default sorter, filter operates on this returned data. For "complex" 
        //    cell types such as image where it could have multiple values for different states, the 
        //    client also needs to implement the next method.
        //    
        //    Client must implement this method to provide the cell data.
        //    
        getCellDisplayData: function(rowData, atColumnIndex){
			switch (atColumnIndex){
				case 0: return Constants.STATETRANSITION_PREFERENCE_DEFAULT[(rowData.id-1)].description;
						break;
			}
            return "";
        },
		
		getCellDisplayExtendedInfo: function(rowData, atColumnIndex)
	    {  
	        var val = {};
	        if(atColumnIndex > 0){
				val.state = rowData.state;
			}
	        return val;
	    }  
    });
    
    dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.administration.StateTransitionConstraintTableView", [dijit._Widget, dijit._Templated], {
        templateString: '<div dojoAttachPoint="domNode" tabindex="-1"></div>',
        widgetsInTemplate: true,
        
		content: null,
		
        constructor: function(args){

        },
        
        postCreate: function(){
            this.inherited("postCreate", arguments);
        },
        
        initialize: function(args){
//			this.parentController = args.parentController;
            var tableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer();
            this.domNode.appendChild(tableViewer.domNode);
            this.tableViewer = tableViewer;
			
            var contentProvider = new StateTransitionConstraintTableView.TableProvider();
            
            tableViewer.setContentPageSize(20);
			
			for (var i = 0; i < (this.actions ? this.actions.length : 0); i++) {
				var action = this.actions[i];
//				if(action.actionId == "save"){
//					this.saveActionNode = tableViewer.addAction(action.actionId, action.label, null, action.iconClass, action.actionHandler);	
//					this.saveActionNode.setDisabled(true);
//				}else{
					tableViewer.addAction(action.actionId, action.label, null, action.iconClass, action.actionHandler);	
//				}
	        }
            
			tableViewer.setContent(this.content);
            tableViewer.setContentProvider(contentProvider);
			tableViewer.setTableRowsCheckable(false, /* isSingleSelect */ false);  
			tableViewer.setTableListener(new StateTransitionConstraintTableView.TableListener(this));
			tableViewer.setCellModifier(new StateTransitionConstraintTableView.CellModifier(this));
            tableViewer.show();
            tableViewer.setEditable(this.parent.isEditable());
        },
		
		refresh: function() {
			this.tableViewer.refresh();
		},
		
		_displayAlertDialog: function(title, message){
            var alertDialog = new AlertDialog({
                'message': message
            });
            alertDialog.setSecondaryTitle(title);
            alertDialog.open();
        },
		
		_displayConfirmationDialog: function(args){
            var dialog = new ConfirmationDialog(args);
            dialog.setSecondaryTitle(args.title);
            dialog.open();
        },
		
        _error: function(errorObj){
            alert(errorObj.message);
        }
    });
    
})();
