//MainReview
/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.process.web.ui.internal.view.approval.MainReview");
dojo.provide("com.ibm.rqm.process.web.ui.internal.view.approval.MainReview");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojox.data.dom");

dojo.require("com.ibm.asq.common.web.ui.internal.util.Utility");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.rqm.planning.web.client.internal.UserClient");

dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.EditorUtil");
dojo.require("com.ibm.rqm.process.web.ui.internal.view.approval.ApprovalTable");
dojo.require("com.ibm.rqm.process.web.client.internal.approval.ProcessClient");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.process.web.ui.internal.view.common.CollapseExpand");
dojo.require("com.ibm.rqm.process.web.ui.internal.view.approval.HistoryPopup");
dojo.require("com.ibm.rqm.process.web.ui.internal.view.approval.SummaryPopup");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.CollapsibleSubSection");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");

(function(){
    var ImageCache = com.ibm.rqm.planning.web.ui.internal.view.common.ImageCache;
    var ServiceResponseHandler = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
    var UserClient = com.ibm.rqm.planning.web.client.internal.UserClient;
    var ProcessClient = com.ibm.rqm.process.web.client.internal.approval.ProcessClient;
    var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
    var EditorUtil = com.ibm.rqm.planning.web.ui.internal.util.EditorUtil;
	var AlertDialog = com.ibm.asq.common.web.ui.internal.widgets.AlertDialog;
	
    var owners = new Array();
    
    dojo.declare("com.ibm.rqm.process.web.ui.internal.view.approval.MainReview", [dijit._Widget, dijit._Templated], {
        templatePath: dojo.moduleUrl("com.ibm.rqm.process.web", "ui/internal/view/templates/approval/MainReview.html"),
        
		labelHistory: Constants.getMessage("labelHistory"),
		
        constructor: function(){
			this.isEditable = null;
            this._itemId = null;
            this.parentController = null;
            this.planSummary = null;
            this._itemType = null;
            this.originator = null;
            this.hideDialog = null;
            this.parentSection = null;
            this.ownerChoices = null;
			this.currentUser = null;
			this.approveWidget = null;
            this._approvalDTO = null;
			this.role = Constants.ROLE_GUEST;
			this.artifactOwner = null;
        },
        
        postCreate: function(){
        
        },
        
        initialize: function(args){
            this.parentController = args.parentController;
            this._itemId = args.itemId;
            this._itemType = args.itemType;
	        this.isEditable = args.isEditable;
            this.parentSection = args.parentSection ? args.parentSection : null;
			this._sectionContainer = args.sectionContainer;
			this.section = args.section;
			this.currentUser = EditorUtil.getCurrentContributor();
            this.initCompleteCallback = args.initCompleteCallback;
            
			var responseHandler = new ServiceResponseHandler(this, "_doInitContributors", "_error");
			UserClient.getContributors(responseHandler);
        },
        
        _doInitContributors: function(contributors){
            this.ownerChoices = new Array();
			if(contributors && contributors.length > 0) {
				for (var i = 0; i < contributors.length; i++) {
					var choiceObj = {
						'text': contributors[i].name,
						'value': contributors[i].itemId
						//'archived' : contributors[i].archived
					};
					if (com.ibm.asq.common.web.ui.internal.util.Utility.isUnassignedUserId(contributors[i].itemId)) {
						choiceObj.text = Constants.getMessage("labelUnassigned");
					}
					this.ownerChoices.push(choiceObj);
				}
			}
            this._initialContent();
        },
        
        getApprovalWidget: function() {
           return this.approveWidget;
        },
        
        _initialContent: function(){
            dojox.data.dom.removeChildren(this._mainContent);            
            if (this._itemId != null) {
                var params = {
                    artifactItemTypeName: this._itemType,
                    artifactPackageUri: Constants.PACKAGE_URI,
                    artifactItemId: this._itemId
                }
                var responseHandler = new ServiceResponseHandler(this, "_addMainContent", "_error");
                ProcessClient.getApprovalDTO(responseHandler, params);
            }
            else {
                this._addMainContent(null);
            }
        },
        
        _addMainContent: function(approvalDTO){
            this._approvalDTO = approvalDTO;		
			this._addActions(approvalDTO);	
			
			if (this.currentUser.name != Constants.APPROVAL_GUEST) {
				var approvalOriginator = this._approvalDTO ? this._approvalDTO.originator : null;
                if (this.originator == null || this.originator.itemId == this.currentUser.itemId || approvalOriginator.itemId == this.currentUser.itemId) {
                    this.role = Constants.ROLE_OWNER; //0: manager; 1: approver/reviewer; 2: others
                }
            }			
			
            this.approveWidget = new com.ibm.rqm.process.web.ui.internal.view.approval.ApprovalTable();
            var self = this;
            this.approveWidget.initialize({
                itemType: this._itemType,
                itemId: this._itemId,
                role: this.role,
				parentSection: this.parentSection != null ? this.parentSection : null,
                printable: this.parentSection != null ? this.parentSection.isPrintView() : false,
				currentUser: this.currentUser,
				ownerChoices: this.ownerChoices,
                approvals: approvalDTO == null ? null : approvalDTO.approvalResults,
				sectionContainer: this._sectionContainer,
				mainReview: self,
                isEditable: this.isEditable
            });
            
            this.approveWidget.changeRowEditable(this.isEditable);
            dojox.data.dom.removeChildren(this._mainContent);
            this._mainContent.appendChild(this.approveWidget.domNode);
			
			this._addSummarySubSection();

            // we're done initializing our contents, if a completion callback
            // is specified, call it.
            if(this.initCompleteCallback) {
                this.initCompleteCallback();
                // remove it. don't need it anymore.
                delete this.initCompleteCallback;
            }            
		},
		
		_addSummarySubSection: function() {
			var needSummary = false;
			if (this._approvalDTO && this._approvalDTO.childrenApprovalDTO) {
				for(var i=0; i<this._approvalDTO.childrenApprovalDTO.length; i++) {
					var summary = this._approvalDTO.childrenApprovalDTO[i].summary;
					if(summary.approveNum!=0||summary.rejectNum != 0||summary.reviewNum != 0){
						needSummary = true;
						break;
					}
				}
			}	
			if (needSummary) {
				var containerArgs = {
					title: "Review Summary",
					titleEditable: false,
					hideToolbarOnReadOnly: false,
					editable: false
				};
				var summaryTable = new com.ibm.rqm.process.web.ui.internal.view.approval.SummaryPopup();
				summaryTable.initialize({
					childrenApprovalDTO: this._approvalDTO.childrenApprovalDTO
				});
				var subSection = new com.ibm.asq.common.web.ui.internal.view.common.CollapsibleSubSection(containerArgs);
				subSection.containerNode.appendChild(summaryTable.domNode);
				this._mainContent.appendChild(subSection.domNode);
			}
        },
        
		_addActions: function(appResults){
            dojox.data.dom.removeChildren(this._history);
            var actionLink = document.createElement("a");
            actionLink.innerHTML = Constants.getMessage("labelHistory");
            this.connect(actionLink, "onclick", this._handleHistory);
            this._history.appendChild(actionLink);
        },
		
		_handleHistory: function(){
            if (this._itemId != null) {
                var params = {
                    artifactItemTypeName: this._itemType,
                    artifactPackageUri: Constants.PACKAGE_URI,
                    artifactItemId: this._itemId
                }
                var responseHandler = new ServiceResponseHandler(this, "_showHistoryContent", "_error");
                ProcessClient.getApprovalHistoryDTO(responseHandler, params);
            }
            else {
                this._showHistoryContent(null);
            }
        },
        
        _showHistoryContent: function(histories){
			if (histories != null) {
				var whole = document.createElement("div");
				for(var i=0; i<histories.length; i++) {
					var hisDom = document.createElement("div");
					var historyTable = new com.ibm.rqm.process.web.ui.internal.view.approval.HistoryPopup();
					historyTable.initialize({history: histories[i]});
					var collapsableAreaWidget = new com.ibm.rqm.process.web.ui.internal.view.common.CollapseExpand();
					collapsableAreaWidget.initialize({ label: histories[i].name, 
												sectionWidgets: [historyTable], 
												showBorder: true, 
												flagStatus: 1, 
												editorOpen: false,
												editorAvailable: true});
					hisDom.appendChild(collapsableAreaWidget.domNode);
					whole.appendChild(hisDom);
				}
				this._processDialog(Constants.APPROVAL_REVIEW_HISTORY_APPROVAL, whole);
			}
			else {
				this._displayAlertDialog(Constants.getMessage("labelInformation"), Constants.APPROVAL_NO_HISTORY_Yet_APPROVAL);
			}
        },
        
        _processDialog: function(title, popNode){
			var historyDialog = new AlertDialog({
                isClosable: true,
				width: "70%",
                contentNode: popNode
            });
            historyDialog.setTitle(title);
            historyDialog.open();
        },
      
		isAllowSave: function() {
			if(this._approvalDTO && this.getApprovalWidget().identity==0) {
				var summary = this._approvalDTO.summary;
				if(summary.approvalTotal!=summary.rejectNum+summary.approveNum)
					return false;
				else	
					return true;
			}
			else
				return true;
		},
		
		_handleAddNewClick: function() {
			this.approveWidget._handleAddNewClick();
		},
        
        _handleRemoveClick: function() {
			this.approveWidget._handleDeleteClick();
		},
        
        _handleCheckClick: function() {
			this._editable = !this._editable;
			this.approveWidget.changeRowCheckbox(this._editable);
		},
		
		_error: function(e){
            this._displayAlertDialog(Constants.getMessage("labelError"), e.message);

            // if we have a completion callback, we're still in initialize state.
            // we still have to call it to notify our 'completion'.
            if(this.initCompleteCallback) {
                this.initCompleteCallback();
                delete this.initCompleteCallback;
            }            
        },
		
		_displayAlertDialog: function(title, message){
            var alertDialog = new AlertDialog({
                'message': message
            });
            alertDialog.setSecondaryTitle(title);
            alertDialog.open();
        },
		
		validateStateTransition: function(initialState, action, endState)
		{
			//We only care about attempting to approve an artifact
			if (action == Constants.STATETRANSITION_ACTION_APPROVE && EditorUtil.applyTransactionConstraint(Constants.STATETRANSITION_PREFERENCE_ALLAPPROVED)) 
			{
				//Can only approve if all the approvals are approved.
				var results = this._approvalDTO;
				if (results == null) 
					return null;
				
				var approvals = results.approvalResults;
				if (approvals == null || approvals.length == 0) 
					return null;
				
				//loop over all the approvals to be sure they are all approved
				for (var i = 0; i < approvals.length; i++) 
					if (approvals[i].status != Constants.TYPE_APPROVED) 
					{
						return Constants.getMessage("msgCannotTransitionApprovalsWaiting", EditorUtil.getStateNameFromID(endState));
					}
			}
			//If we got here than nothing offensive happened so return null which indicates that it is ok to transition			
			return null;
		}
    });
    
})();
