/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.process.web.ui.internal.view.approval.UserSelectionDialog");
dojo.provide("com.ibm.rqm.process.web.ui.internal.view.approval.UserSelectionDialog");

dojo.require("com.ibm.team.process.web.ui.internal.TeamContributorSelectionDialog");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.client.internal.UserClient");

//dojo.require("net.jazz.ajax.ui.internal.Dialog");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");

dojo.require("com.ibm.team.repository.web.client.internal.AdminClient");
dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");

(function(){
	
	var DELAY = 500;
	var RUNNING_SEARCH_MSG = "Running search...";
	var FETCH_ERR_MSG = "Error running query";
	var KEY_ESCAPE = 27;
	var KEY_RETURN = 13;
	var KEY_ENTER = 14;
	var KEY_SPACE = 32;
	var MAX_INT = 2147483647;
	var SEARCH_LIMIT = 250;
	
	var AdminClient = com.ibm.team.repository.web.client.internal.AdminClient;
	var ServiceResponseHandler = com.ibm.team.repository.web.transport.ServiceResponseHandler;
	
	var UserClient = com.ibm.rqm.planning.web.client.internal.UserClient;
    var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
	var UserClient = com.ibm.rqm.planning.web.client.internal.UserClient;
	var SelectContributorDialog = com.ibm.team.process.web.ui.internal.TeamContributorSelectionDialog;
	    
    dojo.declare("com.ibm.rqm.process.web.ui.internal.view.approval.UserSelectionDialog", SelectContributorDialog, {
        templatePath: dojo.moduleUrl("com.ibm.rqm.process.web", "ui/internal/view/templates/approval/UserSelectionDialog.html"),
        
		labelApprovalApprovalTable: Constants.getMessage("labelApprovalApprovalTable"),
		labelReviewerApprovalTable: Constants.getMessage("labelReviewerApprovalTable"),
		labelRunningSearch: Constants.getMessage("labelRunningSearch"),
		labelShowAll: Constants.getMessage("labelShowAll"),
		labelEnterName: Constants.getMessage("labelEnterName"),
		labelUseWildcard: Constants.getMessage("labelUseWildcard"),
		labelMatchingUsers: Constants.getMessage("labelMatchingUsers"),
		labelShowArchivedUsers: Constants.getMessage("labelShowArchivedUsers"),
		labelTypes: Constants.getMessage("labelTypes"),
		
        constructor: function (args) {
			this._searchLimit = 250;
			this.parent = args.parent;
			this.currentChooseType = Constants.TYPE_APPROVER;
			this.ownerChoices = args.ownerChoices;
			com.ibm.rqm.process.web.ui.internal.view.approval.UserSelectionDialog.superclass.constructor.apply(this, arguments);
		},
		
		postCreate: function(args){
			
			this.searchCount = 0;
			this.userSelector.size = 15;
			// MUST use dojo.connect, as base class TeamContributorSelectionDialog uses
			// dojo.disconnect.
			this.keyStrokeFilter = dojo.connect(document, "onkeypress", this, function (e) {
				if (e.keyCode === 8 && e.target !== this.searchText) {
					dojo.stopEvent(e);
				}
			});
			if (this.useOkCancel) {
				this.addCloseButton.appendChild(document.createTextNode(Constants.getMessage("labelOk")));
				this.closeButton.appendChild(document.createTextNode(Constants.getMessage("labelCancel")));
				this.addCloseButton.style.display = "";
				this.closeButton.style.display = "";
			}
			else {
				this.addCloseButton.appendChild(document.createTextNode(Constants.getMessage("labelAddAClose")));
				this.addButton.appendChild(document.createTextNode(Constants.getMessage("labelAdd")));
				this.closeButton.appendChild(document.createTextNode(Constants.getMessage("labelClose")));
				this.addCloseButton.style.display = "";
				this.addButton.style.display = "";
				this.closeButton.style.display = "";
			}
			this.userSelector.multiple = this.allowMultiple;
			if (!this.allowArchivedUsers) {
				this.filtersDiv.style.display = this.allowArchivedUsers ? "" : "none";
			}
			/*this.dialog = new net.jazz.ajax.ui.internal.Dialog({
				contentNode: this.contentNode,
				primaryTitle: this.dialogTitle,
				width: this.width,
				isClosable: this.isClosable
			});*/
			this.dialog = new com.ibm.asq.common.web.ui.internal.widgets._CommonDialog({
				contentNode: this.contentNode,
				primaryTitle: this.dialogTitle,
				width: this.width,
				isClosable: this.isClosable
			});
			this.dialog.open();
			this.dialog.afterUpdatePositionHandler=dojo.hitch(this,this.focusSearchText);
			this.connect(this.searchText,"onkeypress","handleSearchChange");
			this.connect(this.searchText,"onchange","handleSearchChange");
			this.connect(this.showAllLink,"onclick", function (e) {
				dojo.stopEvent(e);
				this.searchText.value = "*";
				this._doSearch();
			});
			this.connect(this.closeButton,"onclick", function (e) {
				dojo.stopEvent(e);
				this.dialog.close();
			});
			this.connect(this.addCloseButton,"onclick","_onAddClose");
			this.connect(this.addButton,"onclick","_onAdd");
			this.connect(this.userSelector,"ondblclick","_handleDoubleClick");
			this.connect(this.userSelector,"onkeydown","_handleKeyDown");
			// compensate for the IE bug that prevents us from disabling options
			if (dojo.isIE) {
				this.connect(this.userSelector,"onchange", function(e) {
					var selectedIndices = [];
					var disabledSelected = false;
					if (this.allowMultiple) {
						for (var i=0; i < this.userSelector.options.length; i++) {
							if (this.userSelector.options[i].selected) {
								if (this.userSelector.options[i].disabled) {
									disabledSelected = true;
									this.userSelector.options[i].selected = false;
								}
								else {
									selectedIndices.push(i);
								}
							}
						}
						if (disabledSelected) {
							if (selectedIndices.length > 0) {
								this.userSelector.savedSelected = selectedIndices;
							}
							else {
								for (var i=0; i < this.userSelector.savedSelected.length; i++) {
									this.userSelector.options[this.userSelector.savedSelected[i]].selected = true;
								}
							}
						}
						else {
							this.userSelector.savedSelected = selectedIndices;
						}
					}
					else {
						if (this.userSelector.selectedIndex >= 0) {
							if (this.userSelector.options[this.userSelector.selectedIndex].disabled) {
								if (this.userSelector.savedSelectedIndex >= 0) {
									this.userSelector.selectedIndex = this.userSelector.savedSelectedIndex;
								}
								else {
									this.userSelector.selectedIndex = -1;
								}
							}
							else {
								this.userSelector.savedSelectedIndex = this.userSelector.selectedIndex;
							}
						}
					}
				});
			}
			this.connect(this.userSelector,"onchange", function () {
				var selected = false;
				this.selectedUsers = [];
				for (var i=0; i < this.userSelector.options.length; i++) {
					if (this.userSelector.options[i].selected) {
						selected = true;
						this.selectedUsers.push({
							itemId: this.userSelector.options[i].itemId,
							name: this.userSelector.options[i].userName,
							userId: this.userSelector.options[i].userId,
							emailAddress: this.userSelector.options[i].emailAddress,
							archived: this.userSelector.options[i].archived
						});
					}
				}
				this.addCloseButton.disabled = !selected;
				this.addButton.disabled = !selected;
			});
			this.connect(this.filterArchivedCheckbox,"onclick","_doSearch");
			this.connect(this.dialog,"onClose","onClose");	
			//this.searchText.focus();
			if (this.disableUsersWithLicense) {
				var srh = new ServiceResponseHandler(this, "_disableUsersCallback", "_disableUsersErrorCallback");
				AdminClient.getContributors({searchTerm: this.disableUsersWithLicense, isLicenseSearch: true, pageSize: MAX_INT, hideGuest: true, hideUnassigned: true, pageNum: 0}, srh);
			}
			
			this.searchLimitMsg.appendChild(document.createTextNode(Constants.getMessage("labelShowingMatchingUsers", this._searchLimit)));			
		},
		
        _selectionChange: function(){
            this.currentChooseType = this._typeSelect.value == 0 ? Constants.TYPE_APPROVER : Constants.TYPE_REVIEWER;
        },

        onOK: function(selectedUsers){
            if (selectedUsers && selectedUsers.length > 0) {
                for (var i = 0; i < selectedUsers.length; i++) {
					var currentUser = {
						text: selectedUsers[i].name,
						value: selectedUsers[i].itemId
					}
                    var obj = {
                        approvalType: this.currentChooseType,
                        owner: currentUser,
                        status: null,
                        comment: null,
                        date: null,
                        ownerItem: selectedUsers[i].itemId,
                        role: [Constants.ROLE_OWNER],
                        isNew: true,
                        id: (new Date()).getTime()
                    };
                    this.parent.content.push(obj);
                }
            }
            this.parent.tableViewer.setContent(this.parent.content);
            this.parent.tableViewer.show();
			if(this.parent.parentSection){
				this.parent.parentSection.setDirty();
			}
        },
		
		/*
		 * rewrite it. Getting users in current project. 
		 */
		runContribSearch: function (params, srh) {
            var closureSearchCount = this.searchCount;
            var self = this;
            var serviceObj = {
                success: function(obj){
                    if (closureSearchCount === self.searchCount) {
						obj = self._filterProjectAreaUsers(obj || []);
                        self._loadQueryResults(obj);
                    }
                },
                failure: function(errorObj){
                    self._queryError(errorObj);
                }
            }
            var newSRH = new ServiceResponseHandler(serviceObj, "success", "failure");
			AdminClient.getContributors(params, newSRH);
		},
		
		/*
		 * Filter all users, remove those not in current projectArea
		 */
		_filterProjectAreaUsers: function(obj) {
			var newObj = [];
			var oldElements = obj.elements || [];
			for(var i = 0; i < oldElements.length; i++) {
				for(var j = 0; j < (this.ownerChoices ? this.ownerChoices.length : 0); j++) {
					if(!this.ownerChoices[j].archived && (oldElements[i].itemId == this.ownerChoices[j].value)) {
						newObj.push(oldElements[i]);
						break;
					}
				}
			}
			obj.elements = newObj;
			obj.count = newObj.length;
			return obj;
		},
		
		focusSearchText: function(){
			this.searchText.focus();
		}
		
    });
})();
