/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.risk.web.ui.internal.view.assessment.CommunityRisk");
dojo.provide("com.ibm.rqm.risk.web.ui.internal.view.assessment.CommunityRisk");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

// Require local widgets
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.rqm.risk.web.ui.internal.view.assessment.RiskUtil");

(function(){ // module container

    var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
	var ImageCache = com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
	var RiskUtil = com.ibm.rqm.risk.web.ui.internal.view.assessment.RiskUtil;
	
    dojo.declare("com.ibm.rqm.risk.web.ui.internal.view.assessment.CommunityRisk", [dijit._Widget, dijit._Templated], {
        templatePath: dojo.moduleUrl("com.ibm.rqm.risk.web", "ui/internal/view/templates/assessment/CommunityRisk.html"),
        
        labelVeryHigh: Constants.getMessage("labelVeryHighWithColon"),
        labelHigh: Constants.getMessage("labelHighWithColon"),
        labelNeutral: Constants.getMessage("labelNeutralWithColon"),
        labelLow: Constants.getMessage("labelLowWithColon"),
        labelVeryLow: Constants.getMessage("labelVeryLowWithColon"),
		
        // object initializer
        constructor: function(args){
			this.risks = null;
        },
        
		postCreate: function() {
	        this._initialize();			
		},	
		
        _initialize: function(){
			var totalNum = this.risks.veryHighAmount+this.risks.highAmount+this.risks.neutralAmount+this.risks.lowAmount+this.risks.veryLowAmount;
			
			this.veryHighNum.appendChild(document.createTextNode(this.risks.veryHighAmount));
			this.highNum.appendChild(document.createTextNode(this.risks.highAmount));
			this.neutralNum.appendChild(document.createTextNode(this.risks.neutralAmount));
			this.lowNum.appendChild(document.createTextNode(this.risks.lowAmount));
			this.veryLowNum.appendChild(document.createTextNode(this.risks.veryLowAmount));
			
			if(totalNum > 0) {
				this.veryHighPercent.appendChild(document.createTextNode('(' + dojo.number.round(100*this.risks.veryHighAmount/totalNum, 1) + "%)"));
				this.highPercent.appendChild(document.createTextNode('(' + dojo.number.round(100*this.risks.highAmount/totalNum, 1) + "%)"));
				this.neutralPercent.appendChild(document.createTextNode('(' + dojo.number.round(100*this.risks.neutralAmount/totalNum, 1) + "%)"));
				this.lowPercent.appendChild(document.createTextNode('(' + dojo.number.round(100*this.risks.lowAmount/totalNum, 1) + "%)"));
				this.veryLowPercent.appendChild(document.createTextNode('(' + dojo.number.round(100*this.risks.veryLowAmount/totalNum, 1) + "%)"));
			} else {
				totalNum =1;
			}
			
			this.veryHighImg.width = 60*this.risks.veryHighAmount/totalNum;
			this.highImg.width = 60*this.risks.highAmount/totalNum;
			this.neutralImg.width = 60*this.risks.neutralAmount/totalNum;
			this.lowImg.width = 60*this.risks.lowAmount/totalNum;
			this.veryLowImg.width = 60*this.risks.veryLowAmount/totalNum;
			
			this.veryHighBackImg.width = 60- 60*this.risks.veryHighAmount/totalNum;
			this.highBackImg.width = 60- 60*this.risks.highAmount/totalNum;
			this.neutralBackImg.width = 60- 60*this.risks.neutralAmount/totalNum;
			this.lowBackImg.width = 60- 60*this.risks.lowAmount/totalNum;
			this.veryLowBackImg.width = 60- 60*this.risks.veryLowAmount/totalNum;
			
			this.veryHighImg.src = ImageCache.COMMU_LEVEL;   
			this.highImg.src = ImageCache.COMMU_LEVEL;   
			this.neutralImg.src = ImageCache.COMMU_LEVEL;   
			this.lowImg.src = ImageCache.COMMU_LEVEL;   
			this.veryLowImg.src = ImageCache.COMMU_LEVEL;   
			
			this.veryHighBackImg.src = ImageCache.NO_COMMU_LEVEL;   
			this.highBackImg.src = ImageCache.NO_COMMU_LEVEL;   
			this.neutralBackImg.src = ImageCache.NO_COMMU_LEVEL;   
			this.lowBackImg.src = ImageCache.NO_COMMU_LEVEL;   
			this.veryLowBackImg.src = ImageCache.NO_COMMU_LEVEL; 
			
			if(this.veryHighImg.width) {
				this.veryHighRightBorder.src = ImageCache.RISK_BORDER;
				this.veryHighLeftBorder.src = ImageCache.RISK_BORDER;
				this.veryHighRightBorder.style.display = "inline";
				this.veryHighLeftBorder.style.display = "inline";
				//display border, so reduce image width
				this.veryHighImg.width = this.veryHighImg.width > 2 ? this.veryHighImg.width-2 : 1;
			}
        	if(this.highImg.width) {
				this.highRightBorder.src = ImageCache.RISK_BORDER;
				this.highLeftBorder.src = ImageCache.RISK_BORDER;
				this.highRightBorder.style.display = "inline";
				this.highLeftBorder.style.display = "inline";
				this.highImg.width = this.highImg.width > 2 ? this.highImg.width- 2 : 1;
			}
			if(this.neutralImg.width) {
				this.neutralRightBorder.src = ImageCache.RISK_BORDER;
				this.neutralLeftBorder.src = ImageCache.RISK_BORDER;
				this.neutralRightBorder.style.display = "inline";
				this.neutralLeftBorder.style.display = "inline";
				this.neutralImg.width = this.neutralImg.width > 2 ? this.neutralImg.width- 2 : 1;
			}
			if(this.lowImg.width) {
				this.lowRightBorder.src = ImageCache.RISK_BORDER;
				this.lowLeftBorder.src = ImageCache.RISK_BORDER;
				this.lowRightBorder.style.display = "inline";
				this.lowLeftBorder.style.display = "inline";
				this.lowImg.width = this.lowImg.width > 2 ? this.lowImg.width- 2 : 1;
			}
			if(this.veryLowImg.width) {
				this.veryLowRightBorder.src = ImageCache.RISK_BORDER;
				this.veryLowLeftBorder.src = ImageCache.RISK_BORDER;
				this.veryLowRightBorder.style.display = "inline";
				this.veryLowLeftBorder.style.display = "inline";
				this.veryLowImg.width = this.veryLowImg.width > 2 ? this.veryLowImg.width- 2 : 1;
			}
        },
		
        _error: function(e){
            alert("An error occurred: [" + e.message + "] @ CommunityRisk#_error");
        }
    });
    
})();
