/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.risk.web.ui.internal.view.assessment.OverviewCommunityRiskPane");
dojo.provide("com.ibm.rqm.risk.web.ui.internal.view.assessment.OverviewCommunityRiskPane");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

// Require local widgets
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.rqm.risk.web.ui.internal.view.assessment.CommunityRisk");
dojo.require("com.ibm.rqm.risk.web.ui.internal.view.assessment.RiskAssessmentStar");
dojo.require("com.ibm.rqm.risk.web.ui.internal.view.assessment.RiskUtil");
dojo.require("com.ibm.rqm.risk.web.ui.internal.view.assessment.RiskDiscussionWidget");

(function(){ // module container

    var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
	var ImageCache = com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
    var RiskAssessmentStar = com.ibm.rqm.risk.web.ui.internal.view.assessment.RiskAssessmentStar;
	var RiskUtil = com.ibm.rqm.risk.web.ui.internal.view.assessment.RiskUtil;
	
    dojo.declare("com.ibm.rqm.risk.web.ui.internal.view.assessment.OverviewCommunityRiskPane", [dijit._Widget, dijit._Templated], {
        templatePath: dojo.moduleUrl("com.ibm.rqm.risk.web", "ui/internal/view/templates/assessment/OverviewCommunityRiskPane.html"),
        
		labelAverage: Constants.getMessage("labelAverage"),
		labelAllComments: Constants.getMessage("labelAllComments"),
        labelRateThis: Constants.getMessage("labelRateMine"),
		
        // object initializer
        constructor: function(args){
			this.risks = null;
			this.allComments = null;
        },
        
		postCreate: function() {
	        this._initialize();			
		},	
		
        _initialize: function(){
			var community = new com.ibm.rqm.risk.web.ui.internal.view.assessment.CommunityRisk({
				risks: this.risks
			});
			this.communityRisk.appendChild(community.domNode);
			
			//community risk level
			this._commuRiskStar = this._createStarWidget(this.risks.averageLevel, false);
			this._averageImage.appendChild(this._commuRiskStar.domNode);
			this.averageLabel.appendChild(document.createTextNode(RiskUtil.getRiskLabel(this.risks.averageLevel)));
			RiskUtil.resetLevelLabelTextColor(this.averageLabel, RiskUtil.getRiskLabel(this.risks.averageLevel));
			
			if(this.allComments && this.allComments.length > 0)
				this.connect(this.comments, "onclick", "_onCommentsClick");
			else
				this.comments.style.display = "none";
        },
		
		_createStarWidget: function(value, editable) {
			var star = new RiskAssessmentStar({
				value: value,
				editable: editable
			});
			return star;
		},
		
		_onCommentsClick: function() {
			var comments = this.allComments ? this.allComments : [];
            var commentsWidget = new com.ibm.rqm.risk.web.ui.internal.view.assessment.RiskDiscussionWidget({
                comments: comments,
				commentsNum: comments.length,
                editable: false,
                isCollapsible: false,
                isHideAllComments: false
            });
            
            var dialogArgs = {
                primaryTitle: Constants.getMessage("labelAllCommentsTitle"),
                width: "40%"
            };
            
            var dialog = new com.ibm.asq.common.web.ui.internal.widgets.AlertDialog(dialogArgs);
            dialog.contentContainer.appendChild(commentsWidget.domNode);
            dialog.open();
		},
        
        _error: function(e){
            alert("An error occurred: [" + e.message + "] @ OverviewCommunityRiskPane#_error");
        }
    });
    
})();
