/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.risk.web.ui.internal.view.assessment.RiskAssessmentStar");
dojo.provide("com.ibm.rqm.risk.web.ui.internal.view.assessment.RiskAssessmentStar");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.form.Slider");

// Require the common widgets needed
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");

// Require local widgets
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.risk.web.ui.internal.view.assessment.RiskUtil");

(function(){ // module container
    /* Jazz objects */
    var ServiceResponseHandler = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
    /* QM objects */
    var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
    var ImageCache = com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
	var RiskUtil = com.ibm.rqm.risk.web.ui.internal.view.assessment.RiskUtil;
	var MaxValue = 5;
	
    dojo.declare("com.ibm.rqm.risk.web.ui.internal.view.assessment.RiskAssessmentStar", [dijit._Widget, dijit._Templated], {
        templateString: '<div dojoAttachPoint="assessmentNode" class="com-ibm-rqm-risk-assessment">' +
                    '  <img dojoAttachPoint="star1"></img>' +
                    '  <img dojoAttachPoint="star2"></img>' +
					'  <img dojoAttachPoint="star3"></img>' +
					'  <img dojoAttachPoint="star4"></img>' +
					'  <img dojoAttachPoint="star5"></img>' +
                    '</div>',
        
//		widgetsInTemplate: true,
		editable: true,
		value: 0, //0 1 2 3 4 5
		isRiskWidget: true,  //true: orange color;  false: blue color 
		
        // object initializer
        constructor: function(args){
			this.value = args.value;
			this.editable = args.editable;
			this.onChangeHandler = args.onChangeHandler;
        },
        
		postCreate: function() {
			this.images = [];
			this.images.push(this.star1);
			this.images.push(this.star2);
			this.images.push(this.star3);
			this.images.push(this.star4);
			this.images.push(this.star5);
			if(this.editable) {
				for(var i = 0; i < this.images.length; i++) {
					dojo.addClass(this.images[i], "riskStarEditable");
					this.images[i].onclick = dojo.hitch(this, "_onStarClick", i);
//					this.images[i].onmouseenter = dojo.hitch(this, "_onMouseEnter", i);
//					this.images[i].onmouseleave = dojo.hitch(this, "_onMouseLeave", i);
				}
			}
	        this._initialize();			
		},	
		
        _initialize: function(){
			if(this.value > MaxValue)
				this.value = MaxValue;
			for(var i = 0; i < this.value; i++) {
					this.images[i].src = this.isRiskWidget ? ImageCache.RISK_SELECTED : ImageCache.RISK_IMPORT_SELECTED;
					if(this.editable)
						this.images[i].title = RiskUtil.getRiskLabel(i + 1);
			}
			for(var i = this.value; i < this.images.length; i++) {
				if(this.editable)
					this.images[i].title = RiskUtil.getRiskLabel(i + 1);
				if(this.isRiskWidget)
					this.images[i].src = this.editable ? ImageCache.RISK_UNSELECT : ImageCache.RISK_READONLY;
				else 
					this.images[i].src = ImageCache.RISK_IMPORT_UNSELECTED;
			}
        },
        
		setValue: function(value) {
			this.value = value;
			this._initialize();
		},
		
		getValue: function() {
			return this.value;
		},
		
		_onStarClick: function(i) {
			this.value = i+1;
			if(this.onChangeHandler && dojo.isFunction(this.onChangeHandler)) {
				this.onChangeHandler(this.value);
			}
			this._initialize();
		},
		
//		_onMouseEnter: function(i) {
//			for(var i = 0; i < i+1; i++) {
//					this.images[i].src = ImageCache.RISK_SELECTED;
//			}
//			for(var i = i+1; i < this.images.length; i++) {
//				this.images[i].src = ImageCache.RISK_UNSELECT;
//			}
//		},
//		
//		_onMouseLeave: function(i) {
//			for(var i = 0; i < this.value; i++) {
//					this.images[i].src = ImageCache.RISK_SELECTED;
//			}
//			for(var i = this.value; i < this.images.length; i++) {
//				this.images[i].src = ImageCache.RISK_UNSELECT;
//			}
//		},

        _error: function(e){
            alert("An error occurred: [" + e.message + "] @ RiskAssessmentStar#_error");
        }
    });
    
})();
