/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.risk.web.ui.internal.view.assessment.RiskUtil");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
(function() {
	var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
	
	com.ibm.rqm.risk.web.ui.internal.view.assessment.RiskUtil = {
		getRiskLabel: function(riskLevel) {
			switch(riskLevel) {
				case 1:
					return Constants.getMessage("labelVeryLow"); 
				case 2: 
					return Constants.getMessage("labelLow");
				case 3: 
					return Constants.getMessage("labelNeutral");
				case 4: 
					return Constants.getMessage("labelHigh");
				case 5: 
					return Constants.getMessage("labelVeryHigh");
			}
			return Constants.getMessage("msgNoRiskShort");
		},
		
		resetLevelLabelTextColor: function(node, label) {
			if(label == Constants.getMessage("msgNoRiskShort")) {
				node.className = "no-risk-label";
			}
			else
				node.className = "risk-label";
		},
		
		getLikelyhoodText: function(value) {
			switch(value) {
				case "1":
					return Constants.getMessage("labelShortLow"); 
				case "2": 
					return Constants.getMessage("labelShortMid");
				case "3": 
					return Constants.getMessage("labelShortHigh");
			}
			return Constants.getMessage("labelNone");
		},
		
		getCostText: function(value) {
			switch(value) {
				case "1":
					return Constants.getMessage("labelShortLow"); 
				case "2": 
					return Constants.getMessage("labelShortMid");
				case "3": 
					return Constants.getMessage("labelShortHigh");
			}
			return Constants.getMessage("labelNone");
		}
	}
})();
