/***************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.buildintegration.web.ui.internal.view.build.BuildDefList");
dojo.provide("com.ibm.rqm.buildintegration.web.ui.internal.view.build.BuildDefList");
 
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");

dojo.require("com.ibm.asq.common.web.client.internal.PermissionsClient");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.rqm.buildintegration.web.ui.internal.BuildUiUtil");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");
dojo.require("com.ibm.asq.common.web.ui.internal.util.GlobalEvents");
dojo.require("com.ibm.rqm.buildintegration.web.client.internal.build.BuildClient");
dojo.require("com.ibm.rqm.buildintegration.web.ui.internal.view.table.BuildDefTableView");
(function() {

var BuildUiUtil 			= com.ibm.rqm.buildintegration.web.ui.internal.BuildUiUtil;
var BuildClient 			= com.ibm.rqm.buildintegration.web.client.internal.build.BuildClient;
var PermissionsClient       = com.ibm.asq.common.web.client.internal.PermissionsClient;
var ViewHeaderLayout		= com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout;
var GlobalEvents   			= com.ibm.asq.common.web.ui.internal.util.GlobalEvents;
var BuildTableView			= com.ibm.rqm.buildintegration.web.ui.internal.view.table.BuildDefTableView;
/* Jazz objects */
var ServiceResponseHandler 	= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;

dojo.declare("com.ibm.rqm.buildintegration.web.ui.internal.view.build.BuildDefList", 
    [dijit._Widget, dijit._Templated],
{    
    templateString: '<div class="com-ibm-rqm-test-artifact-table-view" tabindex="-1">' +
                    '  <div dojoAttachPoint="viewHeaderNode"></div>' +
                    '  <div dojoAttachPoint="buildTableNode" class="com-ibm-rqm-test-artifact-table-view" tabindex="-1"></div>' +
                    '</div>',

    constructor: function() {
	 	
	 },

    postCreate: function(){
        var headerArg = {
			title: BuildUiUtil.getMessage("labelAllBuildDefs"),
            contextHelpId: "rqm_viewblddefs.html"
        };
		this.viewHeader = new com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout(headerArg);
		this.viewHeader.setCSHelpButtonLabel(BuildUiUtil.getMessage("labelBuildsHelp"));
		this.viewHeaderNode.appendChild( this.viewHeader.domNode );
		this.initialize();
	},
	
	initialize:function(){
		var responseHandler = new ServiceResponseHandler(this, "_showTable", "_error");
		BuildClient.getBuildDefinitionsDTO(responseHandler, {});
	},
    _showTable:function(builds){
		if(!this.buildTable){
			this.buildTable = new BuildTableView({parentController:this,builds:builds});
			this.buildTableNode.appendChild(this.buildTable.domNode);
			this.buildTable.show();
		}else{
			this.buildTable.refreshTable(builds);
		}        	
	},
	
	_error: function(e){
		console.error("An error occurred: [" + e.message + "] @ BuildList#Error");
	}
});

})();
