/***************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.buildintegration.web.ui.internal.view.build.BuildList");
dojo.provide("com.ibm.rqm.buildintegration.web.ui.internal.view.build.BuildList");
 
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("jazz.core.loader");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");

dojo.require("com.ibm.asq.common.web.client.internal.PermissionsClient");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.rqm.buildintegration.web.ui.internal.BuildUiUtil");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");
dojo.require("com.ibm.asq.common.web.ui.internal.util.GlobalEvents");
dojo.require("com.ibm.rqm.buildintegration.web.ui.internal.view.table.BuildTableView");
dojo.require("com.ibm.rqm.buildintegration.web.ui.internal.view.build.SelectItemTableDialog");

(function() {

var BuildUiUtil 			= com.ibm.rqm.buildintegration.web.ui.internal.BuildUiUtil;
var PermissionsClient       = com.ibm.asq.common.web.client.internal.PermissionsClient;
var ViewHeaderLayout		= com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout;
var GlobalEvents   			= com.ibm.asq.common.web.ui.internal.util.GlobalEvents;
var BuildTableView			= com.ibm.rqm.buildintegration.web.ui.internal.view.table.BuildTableView;
var SelectItemTableDialog   = com.ibm.rqm.buildintegration.web.ui.internal.view.build.SelectItemTableDialog;

/* Jazz objects */
var ServiceResponseHandler 	= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;

dojo.declare("com.ibm.rqm.buildintegration.web.ui.internal.view.build.BuildList", 
    [dijit._Widget, dijit._Templated],
{    
    templateString: '<div class="com-ibm-rqm-test-artifact-table-view" tabindex="-1">' +
                    '  <div dojoAttachPoint="viewHeaderNode"></div>' +
                    '  <div dojoAttachPoint="buildTableNode" class="com-ibm-rqm-test-artifact-table-view" tabindex="-1"></div>' +
                    '</div>',
	consoleNode:false,
	parent:null,
	buildDefId:null,
    constructor: function(args) {
		args = args ? args : {};
		this.parent = args.parent;
		this.consoleNode = args.consoleNode;
		this.buildDefId = args.buildDefId;
	 },

    postCreate: function(){
		if(!this.consoleNode){
	        var headerArg = {
				title: BuildUiUtil.getMessage("labelAllBuilds"),
	            contextHelpId: "rqm_all_builds.html"
	        };
			this.viewHeader = new com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout(headerArg);
			this.viewHeader.setCSHelpButtonLabel(BuildUiUtil.getMessage("labelBuildsHelp"));
			this.viewHeaderNode.appendChild( this.viewHeader.domNode );
		}
		if (this.clientLoaded) 
			this.initialize();
		else {
			jazz.core.loader.load_async("com.ibm.rational.test.lm.sequencer.web.client.internal.sequence.SequenceClient", dojo.hitch(this, "initialize"));
		}
	},
	
	initialize:function(){
		this.clientLoaded = true;
		this.removedBuildRecs = [];
		var args = {};
		if(this.consoleNode){
			if(this.buildDefId == null)
				this.buildDefId = -1;	
			args.buildDefinitionId = this.buildDefId;
		}
		var responseHandler = new ServiceResponseHandler(this, "_showTable", "_error");
		com.ibm.rational.test.lm.sequencer.web.client.internal.sequence.SequenceClient.getBuildRecordsWithStatisticsDTO(responseHandler, args);
	},
	_showTable:function(builds){
		this.builds = builds?builds:[];
		if (!this.buildTable) {
			var actions = [];
			if (this.consoleNode) {
				actions.push({
					name: "addBuildRec",
					label: BuildUiUtil.getMessage("labelAddBuildRec"),
					context: this,
					icon: "add-icon-image",
					callback: dojo.hitch(this, "addBuildRec")
				});
				actions.push({
					name: "removeBuildRec",
					label: BuildUiUtil.getMessage("labelRemoveBuildRec"),
					context: this,
					icon: "delete-icon-image",
					callback: dojo.hitch(this, "removeBuildRec")
				});
			}
			var buildTableArgs = {
				parentController: this,
				builds: this.builds,
				actions: actions,
				tableRowsCheckable: (this.rowCheckable ? this.rowCheckable : this.consoleNode),
				consoleNode: this.consoleNode
			};
			if (this.singleSelectable) 
				buildTableArgs.singleSelectable = this.singleSelectable;
			if (this.parent) 
				buildTableArgs.editable = this.parent.editable;
			this.buildTable = new BuildTableView(buildTableArgs);
			this.buildTableNode.appendChild(this.buildTable.domNode);
			this.buildTable.show();
		}else {
			this.buildTable.refreshTable(this.builds);
		}
	},
	addBuildRec:function(){
		var params = {
            title: BuildUiUtil.getMessage("labelAddBuildRec"),
            exclusionList: this.builds,                    
            onOk: dojo.hitch(this, "_handleAddedItems")
        };
        var itemListWidget = new SelectItemTableDialog(params);
        itemListWidget.show();
	},
	_handleAddedItems:function(buildRecs){
		buildRecs = buildRecs? buildRecs:[];
		for(var i=0;i<buildRecs.length;i++){
			this.builds.push(buildRecs[i]);
		}
		this.buildTable.refreshTable(this.builds);
		this._onChange();
	},
	removeBuildRec:function(){
		var buildRecs = this.buildTable.getSelectedRows();
		for(var i=0;i<buildRecs.length;i++){
			for(var j=0;j<this.builds.length;j++){
				if(this.builds[j].id == buildRecs[i].id){
					this.builds.splice(j,1);
					if(buildRecs[i].buildRecord)
						this.removedBuildRecs.push(buildRecs[i].buildRecord.id);
					else
						this.removedBuildRecs.push(buildRecs[i].id);
					break;
				}
			}
		}
		this.buildTable.refreshTable(this.builds);
		this._onChange();
	},
	
	getSelectedBuildRecord: function(){
		return this.buildTable.getSelectedRows();;
	},
	
	getBuildRecs:function(){
		
		return this.builds;
	},
	getRemovedBuildRecs:function(){
		return this.removedBuildRecs;
	},
	clearRemovedBuildRecs:function(){
		this.removedBuildRecs = [];
	},
	_error: function(e){
		console.error("An error occurred: [" + e.message + "] @ BuildList#Error");
	},
	_onChange:function(){
		if(this.parent && this.parent._onChange){
			this.parent._onChange();
		}
	}
});

})();
