/***************EditBuildDef*************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.buildintegration.web.ui.internal.view.build.EditBuildDef");
dojo.provide("com.ibm.rqm.buildintegration.web.ui.internal.view.build.EditBuildDef");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojox.data.dom");

dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.rqm.buildintegration.web.ui.internal.BuildUiUtil");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.asq.common.web.ui.internal.util.CSHelp");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.CollapsibleSection");
dojo.require("net.jazz.ajax.ui.PlatformUI");
dojo.require("com.ibm.team.repository.web.client.session.Session");
dojo.require("com.ibm.asq.common.web.ui.internal.util.GlobalEvents");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.buildintegration.web.client.internal.build.BuildClient");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.EditorUtil");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.datetimepicker.DateTimePicker");
dojo.require("com.ibm.rqm.buildintegration.web.ui.internal.view.build.BuildList");
dojo.require("com.ibm.rqm.buildintegration.web.client.internal.build.BuildStatesClient");
dojo.require("com.ibm.asq.common.web.ui.internal.util.SelectUtility");
dojo.require("com.ibm.asq.common.web.client.internal.PermissionsClient");

(function() { // module container

var ServiceResponseHandler		   	= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var Constants    				   	= com.ibm.rqm.planning.web.client.internal.Constants;
var BuildUtil 						= com.ibm.rqm.buildintegration.web.ui.internal.BuildUiUtil;
var YesNoDialog						= com.ibm.asq.common.web.ui.internal.widgets.YesNoDialog;
var CSHelp							= com.ibm.asq.common.web.ui.internal.util.CSHelp;
var ViewHeaderLayout				= com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout;
var getAuthenticatedContributor		= com.ibm.team.repository.web.client.session.getAuthenticatedContributor;
var GlobalEvents                    = com.ibm.asq.common.web.ui.internal.util.GlobalEvents;
var BuildClient 					= com.ibm.rqm.buildintegration.web.client.internal.build.BuildClient;
var BuildStatesClient 				= com.ibm.rqm.buildintegration.web.client.internal.build.BuildStatesClient;
var EditorUtil						= com.ibm.rqm.planning.web.ui.internal.util.EditorUtil;
var SelectUtility 					= dojo.getObject( "com.ibm.asq.common.web.ui.internal.util.SelectUtility" );
var CommonImageCache				= com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
var HasEditPermission				= null; // initilater

dojo.declare("com.ibm.rqm.buildintegration.web.ui.internal.view.build.EditBuildDef", [dijit._Widget, dijit._Templated],
{
		templatePath: dojo.moduleUrl("com.ibm.rqm.buildintegration.web", "ui/internal/view/templates/build/EditBuildDef.html"),
		widgetsInTemplate: true,
		buildDefId:null,
		dateTimeField:null,
		editable:true,

		constructor: function(){
		},		

		postCreate: function(){
			var type = com.ibm.asq.common.web.client.internal.PermissionsClient.OP_BUILD_DEFINITION;
            var perm = com.ibm.asq.common.web.client.internal.PermissionsClient.getStoredPermission(type);
			
			if (perm){
				HasEditPermission = perm.edit;
			}
			this._createHeader();
			this._startLoading();
			this._buildDef = null;
			if(this.buildDefId){
				var responseHandler = new ServiceResponseHandler(this, "initialize", "_error");
				BuildClient.getBuildDefinitionsDTO(responseHandler, {id:this.buildDefId});
			}else		
				this.initialize(null);	
		},
		_setBuildStates:function(providers){
			dojox.data.dom.removeChildren(this._BuildStatus);
			var provider = providers? providers[0] : [];
			var states = provider?provider.buildRecordStatuses:[];
			var buildState = (this._buildDef && this._buildDef.state) ? this._buildDef.state.stateId : null;
			for(var i=0;i<states.length;i++){
				var option = new Option(BuildUtil.getDisplayName(states[i].stateId,states[i].displayName), states[i].stateId);
				if(buildState && buildState == states[i].stateId){
					option.selected = true;
				}
				SelectUtility.add( this._BuildStatus, option );
			}
			this.onStateChange();//Set initial values 
			
		},
		initialize: function(buildDef){
			this._buildDef = buildDef? buildDef[0]:this._buildDef;
			this.providerTp = buildDef? this._buildDef.providerTypeId : "com.ibm.rqm.buildintegration.common.manualProvider";
			var responseHandler = new ServiceResponseHandler(this, "_setBuildStates", "_error");
			BuildStatesClient.getBuildStates(responseHandler, {providerTypeId:this.providerTp});
			if(this._buildDef)
				this._isNew =false;
			else
				this._isNew = true;
            this._dirty = false;
			if (this._buildDef) {
				this._header.setTitle(this._buildDef.name);
				this._header.setSummary(this._buildDef.description);
				SelectUtility.select( this._BuildStatus, this._buildDef.state.stateId );
			}
			if (this._buildDef && this._buildDef.providerTypeId != "com.ibm.rqm.buildintegration.common.manualProvider") {
				this.editable = false;
				this._BuildStatus.disabled = true;
				this._header.setSummaryEditable(false);
				this._header.setTitleEditable(false);
				this._header.setTypeLabel(BuildUtil.getMessage("labelExternalBuildDef"));
			}else {
				this.connect(this._BuildStatus, "onchange",dojo.hitch(this, "onStateChange"));
			}
			
			this.detailSection.setDisplayTitle(BuildUtil.getMessage("labelBuildRecords"));
			this.buildRecordTable = new com.ibm.rqm.buildintegration.web.ui.internal.view.build.BuildList({
				parent:this,consoleNode:true,buildDefId:this.buildDefId});
			dojox.data.dom.removeChildren(this._BuildRecordTable);
			this._BuildRecordTable.appendChild(this.buildRecordTable.domNode);
			
			this._endLoading();
			this.updateSaveable();
			this._updateBrowserTitle();
		},

		isDirty:function(){
			if(!HasEditPermission)
				return false;
			return this._dirty;
		},
		
		initializeBuildDetails:function(){
			if(this._buildDef){
				SelectUtility.select( this._BuildStatus, this._buildDef.state.stateId );
				this._header.setSummary(this._buildDef.description);
			}
		},
		
		
		setDirty:function(value){
			if (this._dirty != value && HasEditPermission) {
				dojo.publish(GlobalEvents.UpdateTabLabel, [window.location.hash, "", null, value]);
				if(!value)
					this._header.clearStatus();
				this._dirty = value;
			}
		},
		updateSaveable: function() {
            if (this._saveButton) {
                this._saveButton.setDisabled(!this.isDirty());
            }
            if (this._cancelButton) {
                this._cancelButton.setDisabled(!this.isDirty());
            }
        },
		onCancel: function(){
			var self = this;
			var args = {
				title: "",
				message: Constants.getMessage("msgConfirmCancel"),
				yesCallback: function(){
					self.setDirty(true);
					self.initialize(null);
					return true;          
				},
				noCallback: function() {
					return false;
				}
			};
			var dialog = new YesNoDialog(args);
	        dialog.setTitle(args.title);
	        dialog.open();
		},
		onSave: function(){
			if(this._header.getTitle() == ""){
				this._header.setStatus(Constants.VALIDATION_ERROR, Constants.HEADER_STATUS_ERROR, Constants.getMessage("msgNameRequired"));
				return;
			}	
			this._setLastSaved(Constants.STATUS_SAVING);
			this.setDirty(false);
			this.updateSaveable();
			this._onSave();
		},
		_onSave: function(){
			var buildName = this._header.getTitle();
			var params = {
				name:buildName,
				description:this._header.getSummary(),
				state:this._BuildStatus.value,
				providerTypeId:"com.ibm.rqm.buildintegration.common.manualProvider"
			};
			if(this._isNew)
				params.newBuildDefinition = true;
			else{
				params.id = this._buildDef.id;
				params.stateId = this._buildDef.stateId;
			}
			var buildRecords = this.buildRecordTable.getBuildRecs();
			var buildRecIds = [];
			buildRecords = buildRecords? buildRecords:[];
			for(var i=0;i<buildRecords.length;i++){
				if(buildRecords[i].buildRecord)
					buildRecIds.push(buildRecords[i].buildRecord.id);
				else
					buildRecIds.push(buildRecords[i].id);
			}
			params.removeBuildRecords = this.buildRecordTable.getRemovedBuildRecs();
			params.buildRecords = buildRecIds;
			var responseHandler = new ServiceResponseHandler(this, "_saveSuccess", "_error");
			BuildClient.postBuildDefinitionDTO(responseHandler, params);
		},
		_saveSuccess: function(buildDef){
			this._buildDef = buildDef;
			this.buildDefId = buildDef.id;
			this.buildRecordTable.buildDefId = this.buildDefId;
			this._setLastSaved(Constants.STATUS_SUCCESS);
            this.wasNew = this._isNew;
			this._isNew = false;
			if (this._buildDef.state && this._buildDef.state.stateId) {
				SelectUtility.select(this._BuildStatus, this._buildDef.state.stateId);
				this.onStateChange();
			}
			var artifactUri = BuildUtil.getBuildDefURI(this.buildDefId);
			dojo.publish(GlobalEvents.UpdateTabUri, [window.location.hash, artifactUri]); 
			dojo.publish(GlobalEvents.UpdateTabLabel, [window.location.hash, this._buildDef? this._buildDef.name : "", "build-def-icon-16-inTab",this._dirty]);
			this._updateBrowserTitle();
			this.buildRecordTable.clearRemovedBuildRecs();
		},
		_setLastSaved: function(status, error) {   
            var st_code = -1; // none, no status icon
            var text = "";
            var detail_msg = null;
            if ( status == Constants.STATUS_SUCCESS ) {
                st_code = ViewHeaderLayout.SUCCESS;
                text = Constants.getCommonMessage("statusSaveSuccess", EditorUtil.getTimeString());  
            } 
            else if ( status == Constants.STATUS_FAILURE ) {
                if(error && error.message && error.message.toLowerCase().indexOf('license') > -1) {
                    var licenseMsg = Constants.getCommonMessage("serverLicenseErrMsg");
                    EditorUtil.showServerErrorMessage(licenseMsg);
                }
                st_code = ViewHeaderLayout.ERROR;
                text = Constants.getCommonMessage("statusSaveFail", EditorUtil.getTimeString());  
                
                if(error && error.message) {
                    detail_msg = "<b>" + Constants.getCommonMessage("labelError") + "</b><br/>" + error.message;
                    if (error.caughtAt) {
                        detail_msg += "<br/><br/><b>" + Constants.getCommonMessage("labelErrorCaughtAt") + "</b> " + error.caughtAt;
                    }                
                }
            } 
            else if ( status == Constants.STATUS_SAVING ) {
                st_code = ViewHeaderLayout.INFO;
                text = Constants.getCommonMessage("statusSaving");
            } 
            else if ( status == Constants.STATUS_NEW ) {
                st_code = ViewHeaderLayout.INFO;
                text = Constants.getCommonMessage("statusNewNeedSave");
            } 
            else if ( status == Constants.STATUS_DIRTY ) {
                st_code = ViewHeaderLayout.INFO;
                text = Constants.getCommonMessage("statusDirty");
            }
            
            if(st_code > -1)
                this._header.setStatus(text, st_code, detail_msg);
            else
                this._header.clearStatus();
        },
		_createHeader: function(title) {
			var iconClass = "build-def-icon-48";
			this._header.setCSHelpId("rqm_viewblddefs.html");
			this._header.setCSHelpButtonLabel(BuildUtil.getMessage("labelBuildDefHelp"));
			this._header.setIconClass(iconClass);  
            this._header.setNoValueEditableTitleLabel(BuildUtil.getMessage("labelEnterNewBuildDefTitle"));
			this._header.setTypeLabel(BuildUtil.getMessage("labelBuildDef"));
			
			dojo.style(this._header.artifactContainer,"marginLeft","9px");
			this._cancelButton = this._header.addRightViewAction(Constants.getMessage("labelDiscardChanges"), dojo.hitch(this, "onCancel"), null, null);
			this._saveButton = this._header.addRightViewAction(Constants.getMessage("labelSave"), dojo.hitch(this, "onSave"), null, null);

			if (HasEditPermission){
				this._saveButton.setDisabled(false);
			} else {
				this._saveButton.setDisabled(true);
				var text = Constants.getCommonMessage("statusNoEditPerm");
                var details = Constants.getCommonMessage("msgNoEditPermDetails", BuildUtil.getMessage("labelBuildDef"));
                this._header.setStatus(text, ViewHeaderLayout.WARNING, details);
			}
			this._header.setSummaryLabel(BuildUtil.getMessage("labelDescription")+BuildUtil.getMessage("labelColen"));
            this._header.setSummaryEditable(true);
			this._header.onSummaryEdited = dojo.hitch(this, "_onChange");
			this._header.onTitleEdited = dojo.hitch(this, "_onChange");
			dojox.data.dom.removeChildren(this._header.getInfoAttributesNode());
			this.labelNode = document.createElement("label");
			this.labelNode.innerHTML = BuildUtil.getMessage("labelStatus")+BuildUtil.getMessage("labelColen");
			this.labelNode.setAttribute("for", "status-select");
			var spanNode = document.createElement("span");
			this._statusIcon = document.createElement("img");
			this._statusIcon.className = "status-img";
			spanNode.appendChild(this._statusIcon);
			this._BuildStatus = document.createElement("select");
			this._BuildStatus.name = "status-select";
			this._BuildStatus.className = "select";
			spanNode.appendChild(this._BuildStatus);
			this._header.addInfoAttribute(this.labelNode,spanNode);
            return this._header;          
        }, 
		_onChange: function() {
			if (HasEditPermission) {
				this.setDirty(true);
				this.updateSaveable();
			}
        },
		
	    onArtifactChanged: function(changeType, artifactType, artifactArray) {
		},
        
        _startLoading: function()
        {
            this._header.setProgressStart(Constants.getMessage("labelLoading"), /*hideContent*/true);
            dojo.style(this.detailSection.domNode, "visibility", "hidden");
        },

        _endLoading: function()
        {
			if(this._header) {
            	this._header.setProgressEnd();
           		dojo.style(this.detailSection.domNode, "visibility", "visible");
			}
        },
        
		onStateChange: function(e){
			var selection = this._BuildStatus.value;
			if(selection == "com.ibm.rqm.buildintegration.buildstatus.ok"){
				this._statusIcon.src = CommonImageCache.PASS_ICON;
			}else if(selection == "com.ibm.rqm.buildintegration.buildstatus.error"){
				this._statusIcon.src = CommonImageCache.ERROR_ICON;
			}else
				this._statusIcon.src = CommonImageCache.NOIMAGE;
			if(e)
				this._onChange();
		},
		
		_error: function(errorObj){
			console.error("Error: (message: '" + errorObj.message + "') from EditBuildDef _error");
		},
					
		_updateBrowserTitle: function(){
			if (this.page) {
				var name="";
				if (this._isNew) {
					name = BuildUtil.getMessage("labelNewBuildDef");
				}else if (this._buildDef && this._buildDef.name){
					name = this._buildDef.name;
				}
				// update browser title
				dojo.publish(GlobalEvents.UpdateTabLabel, [window.location.hash, name, "build-def-icon-16-inTab",this._dirty]);
				this.page.browserTitle = BuildUtil.getMessage("labelBuildDef") + BuildUtil.getMessage("labelColen") +" " + name;
				net.jazz.ajax.ui.PlatformUI.getWorkbench().setTitle(this.page.browserTitle);
				net.jazz.ajax.ui.PlatformUI.getWorkbench().browserTitle = this.page.browserTitle;
				this.labelNode.style.display = "inline";
				this.labelNode.style.width = this._header.viewSummaryLabel.offsetWidth+"px";
				dojo.style(this.labelNode,"float","left");
				this.labelNode.style.margin = "0px";
			}
		}
	}
);
}
)();
