/***************EditBuildRecord*************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.buildintegration.web.ui.internal.view.build.EditBuildRecord");
dojo.provide("com.ibm.rqm.buildintegration.web.ui.internal.view.build.EditBuildRecord");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojox.data.dom");

dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");

dojo.require("com.ibm.rqm.buildintegration.web.ui.internal.BuildUiUtil");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.asq.common.web.ui.internal.util.CSHelp");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.CollapsibleSection");
dojo.require("net.jazz.ajax.ui.PlatformUI");
dojo.require("com.ibm.team.repository.web.client.session.Session");
dojo.require("com.ibm.asq.common.web.ui.internal.util.GlobalEvents");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.buildintegration.web.client.internal.build.BuildClient");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.EditorUtil");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.datetimepicker.DateTimePicker");
dojo.require("com.ibm.rqm.buildintegration.web.ui.internal.view.table.BVTTableView");
dojo.require("com.ibm.rqm.buildintegration.web.client.internal.build.BuildStatesClient");
dojo.require("com.ibm.asq.common.web.ui.internal.util.SelectUtility");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.rqm.buildintegration.web.ui.internal.view.build.ImageCache");
dojo.require("com.ibm.asq.common.web.client.internal.PermissionsClient");

(function() { // module container

var ServiceResponseHandler		   	= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var Constants    				   	= com.ibm.rqm.planning.web.client.internal.Constants;
var BuildUtil 						= com.ibm.rqm.buildintegration.web.ui.internal.BuildUiUtil;
var YesNoDialog						= com.ibm.asq.common.web.ui.internal.widgets.YesNoDialog;
var CSHelp							= com.ibm.asq.common.web.ui.internal.util.CSHelp;
var ViewHeaderLayout				= com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout;
var getAuthenticatedContributor		= com.ibm.team.repository.web.client.session.getAuthenticatedContributor;
var GlobalEvents                    = com.ibm.asq.common.web.ui.internal.util.GlobalEvents;
var BuildClient 					= com.ibm.rqm.buildintegration.web.client.internal.build.BuildClient;
var BuildStatesClient 				= com.ibm.rqm.buildintegration.web.client.internal.build.BuildStatesClient;
var EditorUtil						= com.ibm.rqm.planning.web.ui.internal.util.EditorUtil;
var SelectUtility 					= dojo.getObject( "com.ibm.asq.common.web.ui.internal.util.SelectUtility" );
var CommonImageCache 				= com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
var ImageCache						= com.ibm.rqm.buildintegration.web.ui.internal.view.build.ImageCache;
var ManualProviderType				= "com.ibm.rqm.buildintegration.common.manualProvider";
var HasEditPermission				= null; // initilater

dojo.declare("com.ibm.rqm.buildintegration.web.ui.internal.view.build.EditBuildRecord", [dijit._Widget, dijit._Templated],
{
		templatePath: dojo.moduleUrl("com.ibm.rqm.buildintegration.web", "ui/internal/view/templates/build/EditBuildRecord.html"),
		widgetsInTemplate: true,
		
		labelBVTResult: BuildUtil.getMessage("labelBVTResult"),
		labelTestsRun: BuildUtil.getMessage("labelBvtStatus"),
		labelTestsPassed: BuildUtil.getMessage("labelTestsRun"),
		buildId:null,
		dateTimeField:null,
		editable:true,
		constructor: function(){
		},		

		postCreate: function(){
			var type = com.ibm.asq.common.web.client.internal.PermissionsClient.OP_BUILD_DEFINITION;
            var perm = com.ibm.asq.common.web.client.internal.PermissionsClient.getStoredPermission(type);
			
			if (perm){
				HasEditPermission = perm.edit;
			}
			this._createHeader();
			this._startLoading();
			if(this.buildId){
				var responseHandler = new ServiceResponseHandler(this, "initialize", "_error");
				BuildClient.getBuildRecordsDTO(responseHandler, {id:this.buildId});
			}else		
				this.initialize(null);
		},
		
		_setBuildStates:function(providers){
			dojox.data.dom.removeChildren(this._BuildState);
			var provider = providers?providers[0]:[];
			var buildState = (this._buildRecord && this._buildRecord.state) ? this._buildRecord.state.stateId : null;
			var len = provider.buildRecordStates.length;
			for(var i=0;i<len;i++){
				var state = provider.buildRecordStates[i];
				var option = new Option(BuildUtil.getDisplayName(state.stateId,state.displayName),state.stateId);
				if(buildState && buildState == state.stateId){
					option.selected = true;
				}
				SelectUtility.add( this._BuildState, option );	
			}
			this.onStateChange();//Set initial values
			dojox.data.dom.removeChildren(this._BuildStatus);
			var buildStatus = (this._buildRecord && this._buildRecord.status) ? this._buildRecord.status.stateId : null;
			var len2 = provider.buildRecordStatuses.length;
			for(var i=0;i<len2;i++){
				var status = provider.buildRecordStatuses[i];
				var option = new Option(BuildUtil.getDisplayName(status.stateId,status.displayName), status.stateId);
				if(buildStatus && buildStatus == status.stateId){
					option.selected = true;
				}
				SelectUtility.add( this._BuildStatus, option );	
			}
			this.onStatusChange();//Set initial values
		},
		
		initialize: function(buildRecords){
			this._buildRecord = buildRecords ? buildRecords[0] : null;
			this._providerType = buildRecords ? buildRecords[0].providerTypeId : ManualProviderType;
			var responseHandler = new ServiceResponseHandler(this, "_setBuildStates", "_error");
			BuildStatesClient.getBuildStates(responseHandler, {providerTypeId:this._providerType});
			if(this._buildRecord)
				this._isNew =false;
			else
				this._isNew = true;
            this._dirty = false;
			this.detailSection.setDisplayTitle(BuildUtil.getMessage("labelDeployment"));
			var bvtTable = new com.ibm.rqm.buildintegration.web.ui.internal.view.table.BVTTableView({parentController:this, buildRecord: this._buildRecord});
			dojox.data.dom.removeChildren(this.BVTTable);
			this.BVTTable.appendChild(bvtTable.domNode);
			if(this._buildRecord)
				this._header.setTitle(this._buildRecord.name);
			if (this._buildRecord && this._buildRecord.providerTypeId != "com.ibm.rqm.buildintegration.common.manualProvider") {
				this.editable = false;
				this._BuildStatus.disabled = true;
				this._BuildState.disabled = true;
				this._header.setSummaryEditable(false);
				this._header.setTitleEditable(false);
				this._header.setTypeLabel(BuildUtil.getMessage("labelExternalBuildRecord"));
			}
			else {
				this.connect(this._BuildStatus, "onchange",dojo.hitch(this, "onStatusChange"));
				this.connect(this._BuildState, "onchange",dojo.hitch(this, "onStateChange"));
			}
			this.initializeBuildDetails();
			this._endLoading();
			this.updateSaveable();
			this._updateBrowserTitle();
		},

		isDirty:function(){
			if(!HasEditPermission)
				return false;
			return this._dirty;
		},
		
		initializeBuildDetails:function(){
			dojox.data.dom.removeChildren(this._BuildCompletedAt);
			var endTime = new Date();
			if(this._buildRecord){
				this._BuildState.value = this._buildRecord.state? this._buildRecord.state.displayName:"";
				this._BuildStatus.value = this._buildRecord.status? this._buildRecord.status.displayName:"";
				this._header.setSummary(this._buildRecord.description);
				if(this._buildRecord.endTime != 0)
					endTime.setTime(this._buildRecord.endTime);								
			}
			if (!this.editable) {
				var completedAt = dojo.date.locale.format(endTime, {formatLength: "medium"});
				this._buildCompletedLabel = document.createElement("label");
				this._buildCompletedLabel.innerHTML = BuildUtil.getMessage("labelCompletedAt")+BuildUtil.getMessage("labelColen");
				dojo.addClass(this._buildCompletedLabel,"attributes-entry-label");
				this._BuildCompletedAt.appendChild(this._buildCompletedLabel);
				this._BuildCompletedAt.appendChild(document.createTextNode(completedAt));
			}else {
				this.datePicker = new com.ibm.asq.common.web.ui.internal.widgets.datetimepicker.DateTimePicker({
					label:BuildUtil.getMessage("labelCompletedAt")+BuildUtil.getMessage("labelColen"),
					date: endTime,
					time: endTime
				});
				dojo.addClass(this.datePicker.labelNode,"attributes-entry-label");
				this._BuildCompletedAt.appendChild(this.datePicker.domNode);
				this.datePicker.onDateChange = dojo.hitch(this, "_onChange");
				this.datePicker.timeField.onChange = dojo.hitch(this, "_onChange");
			}
		},
		
		
		setDirty:function(value){
			if (this._dirty != value && HasEditPermission) {
				dojo.publish(GlobalEvents.UpdateTabLabel, [window.location.hash, "", null, value]);
				if(!value)
					this._header.clearStatus();
				this._dirty = value;
			}
		},
		updateSaveable: function() {
            if (this._saveButton) {
                this._saveButton.setDisabled(!this.isDirty());
            }
            if (this._cancelButton) {
                this._cancelButton.setDisabled(!this.isDirty());
            }
        },
		onCancel: function(){
			var self = this;
			var args = {
				title: "",
				message: Constants.getMessage("msgConfirmCancel"),
				yesCallback: function(){
					self.setDirty(true);
					if(self._buildRecord)
						self.initialize([self._buildRecord]);
					else
						self.initialize();
					return true;          
				},
				noCallback: function() {
					return false;
				}
			};
			var dialog = new YesNoDialog(args);
	        dialog.setTitle(args.title);
	        dialog.open();
		},
		onSave: function(){
			if(this._header.getTitle() == ""){
				this._header.setStatus(Constants.VALIDATION_ERROR, Constants.HEADER_STATUS_ERROR, Constants.getMessage("msgNameRequired"));
				return;
			}	
			this._setLastSaved(Constants.STATUS_SAVING);
			this.setDirty(false);
			this.updateSaveable();
			this._onSave();
		},
		_onSave: function(){
			var buildName = this._header.getTitle();
			var completedAt = this.datePicker.getValue();
			var params = {
				name:buildName,
				endTime:completedAt.getTime(),
				description:this._header.getSummary(),
				state:this._BuildState.value,
				status:this._BuildStatus.value,
				providerTypeId:"com.ibm.rqm.buildintegration.common.manualProvider"
			};
			if(this._isNew)
				params.newBuildRecord = true;
			else{
				params.id = this._buildRecord.id;
				params.stateId = this._buildRecord.stateId;
			}
			var responseHandler = new ServiceResponseHandler(this, "_saveSuccess", "_error");
			BuildClient.postBuildRecordDTO(responseHandler, params);
		},
		_saveSuccess: function(buildRecords){
			this._buildRecord = buildRecords;
			this._setLastSaved(Constants.STATUS_SUCCESS);
            this.wasNew = this._isNew;
			this._isNew = false;
			var artifactUri = BuildUtil.getBuildRecordURI(this._buildRecord.id);
			dojo.publish(GlobalEvents.UpdateTabUri, [window.location.hash, artifactUri]);
			dojo.publish(GlobalEvents.UpdateTabLabel, [window.location.hash, this._buildRecord? this._buildRecord.name : "", "build-rec-icon-16-inTab",this._dirty]);
			this._updateBrowserTitle();
		},
		_setLastSaved: function(status, error) {   
            var st_code = -1; // none, no status icon
            var text = "";
            var detail_msg = null;
            if ( status == Constants.STATUS_SUCCESS ) {
                st_code = ViewHeaderLayout.SUCCESS;
                text = Constants.getCommonMessage("statusSaveSuccess", EditorUtil.getTimeString());  
            } 
            else if ( status == Constants.STATUS_FAILURE ) {
                if(error && error.message && error.message.toLowerCase().indexOf('license') > -1) {
                    var licenseMsg = Constants.getCommonMessage("serverLicenseErrMsg");
                    EditorUtil.showServerErrorMessage(licenseMsg);
                }
                st_code = ViewHeaderLayout.ERROR;
                text = Constants.getCommonMessage("statusSaveFail", EditorUtil.getTimeString());  
                
                if(error && error.message) {
                    detail_msg = "<b>" + Constants.getCommonMessage("labelError") + "</b><br/>" + error.message;
                    if (error.caughtAt) {
                        detail_msg += "<br/><br/><b>" + Constants.getCommonMessage("labelErrorCaughtAt") + "</b> " + error.caughtAt;
                    }                
                }
            } 
            else if ( status == Constants.STATUS_SAVING ) {
                st_code = ViewHeaderLayout.INFO;
                text = Constants.getCommonMessage("statusSaving");
            } 
            else if ( status == Constants.STATUS_NEW ) {
                st_code = ViewHeaderLayout.INFO;
                text = Constants.getCommonMessage("statusNewNeedSave");
            } 
            else if ( status == Constants.STATUS_DIRTY ) {
                st_code = ViewHeaderLayout.INFO;
                text = Constants.getCommonMessage("statusDirty");
            }
            
            if(st_code > -1)
                this._header.setStatus(text, st_code, detail_msg);
            else
                this._header.clearStatus();
        },
		_createHeader: function(title) {
			var doc = document;
			var iconClass = "build-rec-icon-48";
			this._header.setCSHelpId("rqm_crebuildrec.html");
			this._header.setCSHelpButtonLabel(BuildUtil.getMessage("labelBuildRecordHelp"));
			this._header.setIconClass(iconClass);  
            this._header.setNoValueEditableTitleLabel(BuildUtil.getMessage("labelEnterNewBuildTitle"));
			this._header.setTypeLabel(BuildUtil.getMessage("labelBuildRecord"));
			
			dojo.style(this._header.artifactContainer,"marginLeft","9px");
			this._cancelButton = this._header.addRightViewAction(Constants.getMessage("labelDiscardChanges"), dojo.hitch(this, "onCancel"), null, null);
			this._saveButton = this._header.addRightViewAction(Constants.getMessage("labelSave"), dojo.hitch(this, "onSave"), null, null);
			
			
			this._header.onTitleEdited = dojo.hitch(this, "_onChange");
			this._header.setSummaryLabel(BuildUtil.getMessage("labelDescription")+BuildUtil.getMessage("labelColen"));
			this._header.setSummaryEditable(true);
			if (HasEditPermission){
				this._saveButton.setDisabled(false);
				this._header.onSummaryEdited = dojo.hitch(this, "_onChange");
				this._header.onTitleEdited = dojo.hitch(this, "_onChange");
			} else {
				this._saveButton.setDisabled(true);
				var text = Constants.getCommonMessage("statusNoEditPerm");
                var details = Constants.getCommonMessage("msgNoEditPermDetails",BuildUtil.getMessage("labelBuildRecord"));
                this._header.setStatus(text, ViewHeaderLayout.WARNING, details);
			}
            
			dojox.data.dom.removeChildren(this._header.getInfoAttributesNode());
			this.labelNode2 = doc.createElement("label");
			this.labelNode2.innerHTML = BuildUtil.getMessage("labelStatus")+BuildUtil.getMessage("labelColen");
			this.labelNode2.setAttribute("for", "status-select");
			var spanNode2 = doc.createElement("span");
			this._statusIcon = doc.createElement("img");
			this._statusIcon.className = "status-img";
			spanNode2.appendChild(this._statusIcon);
			this._BuildStatus = doc.createElement("select");
			this._BuildStatus.name = "status-select";
			this._BuildStatus.className = "select";
			spanNode2.appendChild(this._BuildStatus);
			this._header.addInfoAttribute(this.labelNode2,spanNode2);
			
			var labelNode = doc.createElement("label");
			labelNode.innerHTML = BuildUtil.getMessage("labelState")+BuildUtil.getMessage("labelColen");
			labelNode.setAttribute("for", "state-select");
			var spanNode = doc.createElement("span");
			this._stateIcon = doc.createElement("img");
			this._stateIcon.className = "status-img";
			spanNode.appendChild(this._stateIcon);
			this._BuildState = doc.createElement("select");
			this._BuildState.name = "state-select";
			this._BuildState.className = "select";
			spanNode.appendChild(this._BuildState);
			this._header.addInfoAttribute(labelNode,spanNode);
			
			var labelNode3 = doc.createElement("label");
			var spanNode3 = doc.createElement("span");
			this._BuildCompletedAt = doc.createElement("div");
			spanNode3.appendChild(this._BuildCompletedAt);
			this._header.addInfoAttribute(labelNode3,spanNode3);
            return this._header;          
        }, 
		_onChange: function() {
			if (HasEditPermission) {
				this.setDirty(true);
				this.updateSaveable();
			}
        },
		
	    onArtifactChanged: function(changeType, artifactType, artifactArray) {
		},
        
        _startLoading: function()
        {
            this._header.setProgressStart(Constants.getMessage("labelLoading"), /*hideContent*/true);
            dojo.style(this.detailSection.domNode, "visibility", "hidden");
        },

        _endLoading: function()
        {
			if(this._header) {
            	this._header.setProgressEnd();
           		dojo.style(this.detailSection.domNode, "visibility", "visible");
			}
        },
        
		_error: function(errorObj){
			console.error("Error: (message: '" + errorObj.message + "') from EditBuildRecord _error");
		},
		
		onStatusChange: function(e){
			var selection = this._BuildStatus.value;
			if(selection == "com.ibm.rqm.buildintegration.buildstatus.ok"){
				this._statusIcon.src = CommonImageCache.PASS_ICON;
			}else if(selection == "com.ibm.rqm.buildintegration.buildstatus.error"){
				this._statusIcon.src = CommonImageCache.ERROR_ICON;
			}else
				this._statusIcon.src = CommonImageCache.NOIMAGE;
			if(e)
				this._onChange();
		},
		
		onStateChange: function(e){
			var selection = this._BuildState.value;
			if(selection == "com.ibm.rqm.buildintegration.buildstate.complete"){
				this._stateIcon.src = ImageCache.BUILD_COMPLETED;
			}else if(selection == "com.ibm.rqm.buildintegration.buildstate.running"){
				this._stateIcon.src = ImageCache.BUILD_RUNNING;
			}else if(selection == "com.ibm.rqm.buildintegration.buildstate.inprogress"){
				this._stateIcon.src = ImageCache.BUILD_RUNNING;
			}else if(selection == "com.ibm.rqm.buildintegration.buildstate.queued"){
				this._stateIcon.src = ImageCache.BUILD_QUEUED;
			}else if(selection == "com.ibm.rqm.buildintegration.buildstate.cancelled"){
				this._stateIcon.src = ImageCache.BUILD_CANCELLED;
			}else
				this._stateIcon.src = CommonImageCache.NOIMAGE;
			if(e)
				this._onChange();
		},
		
					
		_updateBrowserTitle: function(){
			if (this.page) {
				var name="";
				if (this._isNew) {
					name = BuildUtil.getMessage("labelNewBuildRecord");
				}else if (this._buildRecord && this._buildRecord.name){
					name = this._buildRecord.name;
				}
				// update browser title
				dojo.publish(GlobalEvents.UpdateTabLabel, [window.location.hash, name ? name : "", "build-rec-icon-16-inTab",this._dirty]);
				this.page.browserTitle = BuildUtil.getMessage("labelBuildRecord") + BuildUtil.getMessage("labelColen") +" " + name;
				net.jazz.ajax.ui.PlatformUI.getWorkbench().setTitle(this.page.browserTitle);
				net.jazz.ajax.ui.PlatformUI.getWorkbench().browserTitle = this.page.browserTitle;	
				var width = 0;
				if (this.datePicker) {
					width = this.datePicker.labelNode.offsetWidth;
				}
				else if (this._buildCompletedLabel) {
					width = this._buildCompletedLabel.offsetWidth;
				}else
					width = 80;	
				if (this._header.viewSummaryLabel.offsetWidth > width) 
					width = this._header.viewSummaryLabel.offsetWidth;
				this.labelNode2.style.display = "inline";
				this.labelNode2.style.width = width+"px";
				dojo.style(this.labelNode2,"float","left");
				this.labelNode2.style.margin = "0px"; 
				this._header.viewSummaryLabel.style.width = width+"px";
				this._header.viewSummaryLabel.style.padding = "0px";
				if(this.datePicker)
					this.datePicker.labelNode.style.width = width+"px";
				else if(this._buildCompletedLabel)
					this._buildCompletedLabel.style.width = width+"px";
			}
		}
	}
);
}
)();
