/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading com.ibm.rqm.planning.web.ui.internal.view.common.GlobalTaskBar");
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.common.GlobalTaskBar");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.Menu");
dojo.require("dijit.form.Button");

dojo.require("net.jazz.ajax.ui.PlatformUI");
dojo.require("dojo.i18n"); 
dojo.requireLocalization("net.jazz.ajax.ui.internal", "JAFMessages");

dojo.require("net.jazz.ajax.ui.internal.PageRegistry");
dojo.require("com.ibm.team.repository.web.ui.internal.admin.server.LicenseEditor");
dojo.require("com.ibm.team.repository.web.client.init.InitializationData");

dojo.require("com.ibm.asq.common.web.ui.internal.util.Utility");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");

dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.client.internal.PreferenceClient");
dojo.require("com.ibm.asq.common.web.client.internal.PermissionsClient");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.administration.PreferencesEditor");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.administration.CatalogEditor");

(function() 
{
	var PageRegistry = net.jazz.ajax.ui.internal.PageRegistry;
	var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
    var Utility = com.ibm.asq.common.web.ui.internal.util.Utility;
    var InitializationData = com.ibm.team.repository.web.client.init.InitializationData;
    var PreferenceClient = com.ibm.rqm.planning.web.client.internal.PreferenceClient;
	var PermissionsClient = com.ibm.asq.common.web.client.internal.PermissionsClient;
    var PlatformUI  = net.jazz.ajax.ui.PlatformUI;

    var ACTION_ROOT         = "com.ibm.rqm.planning.home.";
    var DISPATCHER          = "actionDispatcher";
    var HOME_ACTION         = "viewUserHome";
	var SEARCH_ACTION       = "doSearch";
	var DEFAULT_SEARCH_MSG  = Constants.getMessage("msgTypeToSearch");

    var JAZZ_ADMIN_PAGE_ID_SERVER = "com.ibm.team.repository.server";
    var JAZZ_ADMIN_PAGE_ID_PROJECTS = "com.ibm.team.process.ProjectAreaManagement";
    var JAZZ_ADMIN_PAGE_ID_USERS = "com.ibm.team.repository.users";
    
    var SERVER_ADMIN_PAGE_ID = "com.ibm.team.process.ProjectAreaManagement";
	
	dojo.declare(
		"com.ibm.rqm.planning.web.ui.internal.view.common.GlobalTaskBar", [dijit._Widget, dijit._Templated],
		{
			templatePath: dojo.moduleUrl("com.ibm.rqm.planning.web", "ui/internal/view/templates/common/GlobalTaskBar.html"),		

			constructor: function()
			{
                this._isAdmin = false;
                this._isProjAdmin = false;
			},
	
			postCreate: function(args)
			{
                // create a globally accessible off screen span that will used
                // to do string measurement for string wrapping and clipping.
                //
                var doc = document;
                var bdy = doc.body;
                var ruler = doc.createElement("span");
                ruler.style.position = "absolute";
                ruler.style.left = "-3000px";
                ruler.id = "com-ibm-rqm-app-ruler-node";
                bdy.insertBefore(ruler, bdy.firstChild);
                this.ruler = ruler;
			},
			
			initialize: function(args)
			{
                // NOTE: These objects are constructed by the base jazz application class, jazz.app._JazzApplication.
                // They're a part of the application's 'ui' object which is of the the type jazz.app.JazzUI defined 
                // in net.jazz.web.app. 
                this.navbar = args.navbar;
                this.containerLeft = args.containerLeft;
                this.containerRight = args.containerRight;

                // NOTE: Construct the global search box in this intialize path.
                // Otherwise, if this is a non-admin user, the search box would
                // get created in a callback and thus change the element flow of
                // the parent, i.e., the search box would be created later and thus
                // changed the flow.
                
                // create the search box
                var outerDiv = document.createElement("div");
                outerDiv.id = "search-outer-div";
                var innerDiv = document.createElement("div");
                innerDiv.id = "search-inner-div";
                var inputDiv = document.createElement("div");
                inputDiv.id = "search-input-div";
                var input = document.createElement("input");
                input.id = "search-input";
                input.name = "search-input";
                dojo.addClass(input, "global-search-input");
                dojo.addClass(input, "search-input-disabled-text");
                input.type = "text";
                input.value = DEFAULT_SEARCH_MSG;
                var inputLabel = document.createElement("label");
                inputLabel.setAttribute("for", "search-input");
                var inputLabelInfo = document.createElement("span");
                inputLabelInfo.style.display = "none";
                inputLabelInfo.appendChild(document.createTextNode(Constants.getMessage("labelGlobalSearchInput")));
                inputLabel.appendChild(inputLabelInfo);
                inputDiv.appendChild(inputLabel);
                inputDiv.appendChild(input);

                this._searchText = input;
                this.connect(input, "onfocus", function() {
                    var value = this._searchText.value;
                    this._searchText.value = value && value == DEFAULT_SEARCH_MSG ? "" : value;
                });
                this.connect(input, "onblur",function() {
                    var value = this._searchText.value;
                    this._searchText.value = value && dojo.trim(value) != "" ? value : DEFAULT_SEARCH_MSG;
                });
                this.connect(input, "onkeyup", function(event) {
                    event = event || window.event;
                    if (event.keyCode == dojo.keys.ENTER) this.doSearch();
                });
                
                var searchLabel = Constants.getMessage("labelGlobalSearchButton");
                var button = document.createElement("button");
                button.id = "search-button";
                button.title = searchLabel;
                button.name = searchLabel;
                this.connect(button, "onclick", "doSearch");
                
                innerDiv.appendChild(inputDiv);
                innerDiv.appendChild(button);
                outerDiv.appendChild(innerDiv);
                this.searchLi.appendChild(outerDiv);
                this.containerRight.appendChild(this.domNode);

                // if this is CJK locale add in our cjk locale specific CSS
                if(Utility.isCJKLocale()) {
                    //dojo.addClass(this.ui.bannerRightText , "jazz-app-Navbar-cjk");
                    dojo.addClass(input, "global-search-input-cjk");
                    dojo.addClass(this.navbar.pageListContainer, "jazz-app-Navbar-cjk");
                }                

                // check the user for admin or project admin permission
                this.initializeAdmin();
			},
			
			_initializeView: function() {
                if (this._isAdmin || this._isProjAdmin) {
                    // create the admin menu if the user is admin - the provider will
                    // restrict the menu options based on the user type
                    var adminMenu = this.navbar._createItem({
                        label: Constants.getMessage("labelAdmin"),
                        align: "right",
                        menuProvider: dojo.hitch(this, this._adminMenuProvider)
                    });
                    dojo.style(adminMenu, "marginLeft", "5px");
                }

                // create the preference button
                var prefButton = this.navbar._createItem({
                    label: Constants.getMessage("labelPreferences"),
                    align: "right"
                });
                dojo.style(prefButton, "marginLeft", "5px");
                this.connect(prefButton, "onclick", "displayPreferences");

                // keep track of the home link node to control display when navigate in and out between RQM page and Jazz pages
                PreferenceClient.getCurrentUserPreferences(this, this.addPrefHomeLink, Constants.USER_UI_CUSTOMISE_ACTIONBAR_CATEGORY.key);
            },
            
            // check preference to see if action bar is horizontal or vertical to use home link as a button or link
            //
            addPrefHomeLink: function(userPreference) {
                this.actionBarIsHorizontal = false;
                if (userPreference.key == Constants.USER_UI_CUSTOMISE_ACTIONBAR_CATEGORY.key){
                    this.actionBarIsHorizontal = (userPreference.value == "actionBarHorizontal");
                }

                if (this.actionBarIsHorizontal) {
                    // create a button link in the global nav bar of the common banner
//                    this.homeButton = this.navbar._createItem({
//                        label: Constants.getMessage("labelDashboards"),
//                        align: "left"
//                    });
//                    this.connect(this.homeButton, "onclick", "showHomePage");
//                    dojo.setObject("com-ibm-rqm-planning-web-home-widget", this.homeButton);
                    // manage button in homeContainer only if global nav bar of the common banner is not used
                    this.homeButton = new dijit.form.Button({
                        label: Constants.getMessage("labelDashboards"),
                        showLabel: true,
                        "class": "com-ibm-rqm-planning-home-link",
                        onClick: dojo.hitch(this, "showHomePage")
                    });
                    dojo.style(this.homeButton.domNode, "float", "left");
                    dojo.style(this.homeButton.domNode, "marginTop", "0px");
                    dojo.style(this.homeButton.domNode, "marginRight", "10px");
                    dojo.setObject("com-ibm-rqm-planning-web-home-widget", this.homeButton);
                    this.containerLeft.appendChild(this.homeButton.domNode);
                } else {
                    this.homeLink = document.createElement("a");
                    this.homeLink.innerHTML = Constants.getMessage("labelBackRQMHome");
                    this.homeLink.id = "return-rqm-home-link";
                    this.connect(this.homeLink, "onclick", "showPrevPage");
                    this.homeLink.style.visibility = "hidden";
					this.homeLink.setAttribute("href", "javascript:{}");
                    dojo.addClass(this.homeLink, "com-ibm-rqm-planning-home-link");
                    dojo.setObject("com-ibm-rqm-planning-web-home-link", this.homeLink);
                    this.containerLeft.appendChild(this.homeLink);
                }
            },
            
            // provider to populate the admin menu based on the user type
            //
            _adminMenuProvider: function() {
                if (this._isAdmin || this._isProjAdmin) {
                    // admin will see all menu actions but project admin won't see Jazz admin menu options
                    var menu = new dijit.Menu();
                    dojo.addClass(menu.domNode, "com-ibm-rqm-planning-web-nav-bar-override");
                    
                    var sysProp = new dijit.MenuItem({
                        label: Constants.getMessage("labelSystemProperties"),
                        onClick: dojo.hitch(this, this._onClickSystemProperties)
                    });
                    dojo.addClass(sysProp.domNode, "com-ibm-rqm-planning-web-nav-bar-override");
                    menu.addChild(sysProp);
                    
                    var separator = new dijit.MenuSeparator();
                    // TODO: remove class after 2.0 to adopt style from Jazz Foundation
                    dojo.addClass(separator.domNode, "com-ibm-rqm-planning-web-menu-bar");
                    
                    if (this._isAdmin) {
						menu.addChild(separator);
                        var serverAdmin =new dijit.MenuItem({
                            label: Constants.getMessage("labelJazzServerAdmin"),
                            onClick: dojo.hitch(this, this._onClickJazzServerAdmin)
                        });
                        dojo.addClass(serverAdmin.domNode, "com-ibm-rqm-planning-web-nav-bar-override");
                        menu.addChild(serverAdmin);

                        var ProjectAdmin = new dijit.MenuItem({
                            label: Constants.getMessage("labelJazzProjectAdmin"),
                            onClick: dojo.hitch(this, this._onClickJazzProjectAdmin)
                        });
                        dojo.addClass(ProjectAdmin.domNode, "com-ibm-rqm-planning-web-nav-bar-override");
                        menu.addChild(ProjectAdmin);

                        var userAdmin = new dijit.MenuItem({
                            label: Constants.getMessage("labelJazzUserAdmin"),
                            onClick: dojo.hitch(this, this._onClickJazzUserAdmin)
                        });
                        dojo.addClass(userAdmin.domNode, "com-ibm-rqm-planning-web-nav-bar-override");
                        menu.addChild(userAdmin);

// add a separator only if feedView is needed
//                        var separator = new dijit.MenuSeparator();
//                        // TODO: remove class after 2.0 to adopt style from Jazz Foundation
//                        dojo.addClass(separator.domNode, "com-ibm-rqm-planning-web-menu-bar");
//                        menu.addChild(separator);
                    }
                    
//                    var feedView = new dijit.MenuItem({
//                        label: Constants.getMessage("labelFeedViews"),
//                        onClick: dojo.hitch(this, this._onClickFeedViews)
//                    });
//                    dojo.addClass(feedView.domNode, "com-ibm-rqm-planning-web-nav-bar-override");
//                    menu.addChild(feedView);
                    
                    return menu;
                } else {
                    // no admmin menu if the user is neither admin nor project admin
                    return null;
                }
            },
    
			showInfoCtr: function() {
                var infoCtrWindow = window.open("/help/index.jsp", "_help");
                infoCtrWindow.focus();
            },
            
            displayPreferences: function(e) {
				var preferencesEditor = new com.ibm.rqm.planning.web.ui.internal.view.administration.PreferencesEditor();
	            var dialogArgs = {
					primaryTitle: Constants.getMessage("labelPreferences"),
	                isClosable: true,
	                showActions: false
	            };                
	            this._prefsDialog = new com.ibm.asq.common.web.ui.internal.widgets.SelectionDialog(dialogArgs);
				dojo.connect(preferencesEditor, "onCloseParentDialog", this._prefsDialog, "close");
	            //this._prefsDialog.setWidth(this.WIDTH);
	            this._prefsDialog.contentContainer.appendChild(preferencesEditor.domNode);
	            this._prefsDialog.open();		
            },

			doSearch: function() {
				var searchText = this._searchText.value;	
				if (searchText && dojo.trim(searchText) != "" && searchText != DEFAULT_SEARCH_MSG) {
					//do the search
					var uri = "#action=" + ACTION_ROOT + DISPATCHER + "&subAction=" + SEARCH_ACTION + "&searchText=" + searchText;
					window.location.href = uri;
				} else {
					alert(Constants.getMessage("promptEnterSearch"));
					this.searchText.focus();
				}
			},			
			
            showHomePage: function() {
                window.location.hash = Utility._getPlanningActionUri("viewUserHome");
                this._updateHomeLinkButton(true);
			},
            
            showPrevPage: function(e) {
                // Mimic the beforeunload callback and bring up a message before 
                // setting the URI. We need to do this before we change the URI
                // otherwise, the URI change would still get processed. 
                //
                var workbench = PlatformUI.getWorkbench();
                var messages = dojo.i18n.getLocalization("net.jazz.ajax.ui.internal", "JAFMessages");
                
                // Get the msessage from the workbench. It queries all registered handlers for
                // any unsaved change messages.
                var message = workbench._getOnBeforeUnloadMessage();
                var canGoBack = true;
                
                // There are Jazz editors that have edits, and would ask the user
                // to reconsider moving away. Show the beforeunload message.
                if (message !== false) {
                    //fake the onBeforeUnload dialog
                    if (!confirm(messages.onBeforeUnloadPrefix + message + messages.onBeforeUnloadSuffix)) {
                        canGoBack = false;
                    }
                } 
                // The workbench also has a body onclick handler. In any case we need to 
                // stop the event from bubbling up to the workbench's handler.
                // Otherwise it will show this fake message again if there're unsaved
                // editings.
                 dojo.stopEvent(e);
                
                if(!canGoBack) {
                    return;
                }
                    
                // We're going back to QM pages, clear all unload/onclick handlers
                // Note: Jazz's process pages (exposed thru our admin menus) registers
                // its body clicked handler to veto any navigate away. Since we
                // handle the vetoing here, we can remove all handler when we leave.
                // Otherwise, these handlers would still be around the next time the
                // user navigate to Jazz pages again and would falsely popup confirm
                // dialogs to 'are you sure you want to move away' message. 
                workbench._onBeforeUnloadHandlers = new Array(); 
                workbench._bodyClickHandlers = new Array();
                
                // previous page URI is set prior to showing the home link
                if (this.homeLink.backURI) {
                    window.location.hash = this.homeLink.backURI;
                } else {
                    window.location.hash = Utility._getPlanningActionUri("viewUserHome");
                }
                this._updateHomeLinkButton(true);
            },
            
            // check the user for admin or project admin permission
            //
            initializeAdmin: function()
            {
                var permissionInitializer = InitializationData.get("com.ibm.team.repository.service.canGrantPermissionInitializer");
                
				if (permissionInitializer && permissionInitializer.canGrantPermission)
				{
					this._isAdmin = true;
	                var pages = PageRegistry.getPages();
	                this._jazzPageUri = "";
	                for(var i=0; i<pages.length; i++)
	                {
	                    if (pages[i].id == JAZZ_ADMIN_PAGE_ID_SERVER) 
	                    {
	                        this._jazzServerPageUri = pages[i].getUri();
	                    }
	                    if (pages[i].id == JAZZ_ADMIN_PAGE_ID_PROJECTS)
	                    {
	                        this._jazzProjectPageUri = pages[i].getUri();
	                    }
	                    if (pages[i].id == JAZZ_ADMIN_PAGE_ID_USERS)
	                    {
	                        this._jazzUsersPageUri = pages[i].getUri();
	                    }                   
	                }
					this._isProjAdmin = true;
					this._initializeView();
                }
				else
				{
					// check if user is a Project Area Admin
					this._isAdmin = false;
			        var responseHandler = new com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper(this, "_isProjAdminCheck", "_notProjAdmin");
					PermissionsClient.checkIsProjectAreaAdmin(responseHandler);
                }
			},
			
			_isProjAdminCheck: function(response) {
                this._isProjAdmin = (response == "true");
				this._initializeView();
            },
			
			_notProjAdmin: function() {
                this._isProjAdmin = false;
				this._initializeView();
			},

            _onClickJazzServerAdmin: function() {
                window.location.hash = this._jazzServerPageUri;
                this._updateHomeLinkButton(false);
            },
            
            _onClickJazzProjectAdmin: function() {
                window.location.hash = this._jazzProjectPageUri;
                this._updateHomeLinkButton(false);
            },

            _onClickJazzUserAdmin: function() {
                window.location.hash = this._jazzUsersPageUri;
                this._updateHomeLinkButton(false);
            },

            _onClickSystemProperties: function() {
                window.location.hash = Utility._getPlanningActionUri("viewSystemProperties");
            },
            
//            _onClickFeedViews: function() {
//                window.location.hash = Utility._getPlanningActionUri("viewFeedViews");
//            },
            
			// NOTE: NOT USED AT THIS POINT. THE CATALOG EDITOR LIVES INSIDE THE 
			// SYSTEM PROPERTIES EDITOR PAGE.
            _onClickEditCatalog: function() {
                window.location.hash = Utility._getPlanningActionUri("viewCatalogEditor");
            },

            _updateHomeLinkButton: function(inRQM) {
                if (this.homeLink)
                    this.homeLink.style.visibility = inRQM ? "hidden" : "visible";
                if (this.homeButton) {
                    this.homeButton.attr('disabled', inRQM);
                    if (!inRQM)
                        this.homeButton._focused = false;
                }
            }
		}
	);
}
)();
