/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.common.ProjectAreaDialog");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.asq.common.web.ui.internal.util.SelectUtility");

(function(){
	
	var Constants				= com.ibm.rqm.planning.web.client.internal.Constants;
	var SelectUtil  			= com.ibm.asq.common.web.ui.internal.util.SelectUtility;
	
    dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.common.ProjectAreaDialog", [dijit._Widget, dijit._Templated], {
        templatePath: dojo.moduleUrl("com.ibm.rqm.planning.web", "ui/internal/view/templates/common/ProjectArea.html"),

    	//STYLE: "position: absolute; top: 30%; left: 30%; width: 30%; height:40%",
		width: "400px",
    	title: Constants.getMessage("labelProjectAreaTitle"),
		labelSelectProjectArea: Constants.getMessage("labelSelectProjectArea"),
		labelDefaultProjectArea: Constants.getMessage("labelDefaultProjectArea"),
				            
        constructor: function(args){
            this.onOk = function(){};
			this.projectAreas = [];
        },
		
		postCreate: function() {          
		    var dialogArgs = {
				primaryTitle: this.title,
				okCallback: dojo.hitch(this, "_onOk"),
		        closable: false
		    };                
		    this._dialog = new com.ibm.asq.common.web.ui.internal.widgets.SelectionDialog(dialogArgs);
		    this._dialog.setWidth(this.width);
			this._dialog.getOkButton().disabled = false;
			this._dialog.getCancelButton().style.display = "none";
		    this._dialog.contentContainer.appendChild(this.domNode);
			this._dialog.open();			
			
			this._showProjectAreas();	
		},
		
		_onOk: function() {
			var pa = this._getProjectArea(this._projectAreaSelect.value);
			if (dojo.isFunction(this.onOk)) { 
				this.onOk(pa);
			}
		},
		
		_showProjectAreas: function(){
			dojox.data.dom.removeChildren(this._projectAreaSelect)
			for (var i = 0; i < this.projectAreas.length; i++) {
				var pa = this.projectAreas[i];
				SelectUtil.add(this._projectAreaSelect, new Option(pa.name, pa.itemId));
		   	}
        },
		
		_getProjectArea: function(itemId) {
			for (var i = 0; i < this.projectAreas.length; i++) {
				if (this.projectAreas[i].itemId == itemId) {
					return this.projectAreas[i];
				}
		   	}			
		},
		
		_error: function(e){
            console.error(this.declaredClass + ": error: " + (e ? e.message : ""));          
        }
	
    });
      
})();
