/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.execution.web.ui.internal.view.common.TestCaseConfigSelector");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojo.parser");

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.widgets.FilteredListChooser");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.client.internal.planning.PlanningPageClient");
dojo.require("com.ibm.rqm.process.web.client.internal.timebox.TimeboxClient");
dojo.require( "com.ibm.asq.common.web.ui.internal.util.SelectUtility" );
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
(function() {
var ServiceResponseHandler 			= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var Constants 						= com.ibm.rqm.planning.web.client.internal.Constants;
var TimeBoxClient					= com.ibm.rqm.process.web.client.internal.timebox.TimeboxClient;
var PlanClient						= com.ibm.rqm.planning.web.client.internal.planning.PlanningPageClient;
var SelectUtility 					= dojo.getObject( "com.ibm.asq.common.web.ui.internal.util.SelectUtility" );
var ImageCache						= com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
dojo.declare("com.ibm.rqm.execution.web.ui.internal.view.common.TestCaseConfigSelector",
			 [dijit._Widget, dijit._Templated], 
{
		
	templatePath: dojo.moduleUrl("com.ibm.rqm.execution.web", "ui/internal/view/templates/common/TestCaseConfigSelector.html"),
    widgetsInTemplate:true,

	labelAddTestCase: Constants.getMessage("labelAddTestCase"),
	labelSetConfigDefault: Constants.getMessage("labelAssociateResultsToPlan"),
	labelOk: Constants.getMessage("labelOk"),
	labelCancel: Constants.getMessage("labelCancel"),

    height: "450px", 
    width: "450px", 
	
	postCreate: function(){
		this._configTitle.innerHTML = Constants.getMessage("msgChangeExecProp");
		this._labelTestEnvironment.innerHTML = Constants.getMessage("labelConfiguration"); 
	},
	
	initialize: function(args){
		if(args.selectedItem){
			this.selectedItem = args.selectedItem;			
			dojo.style(this.messagesNode, "display", "none");
		}else{
			this.selectedItem = null;
		}
		this.testCases = args.testCases;
		var testCases = args.testCases;
		this.configs = args.configs;
		var configs = args.configs;
		if(!testCases || !configs){
			dojo.style(this._overrideSection, "display", "none");
			dojo.style(this._configNode, "display", "none");
			dojo.style(this._planIterationSection, "display", "none");
			this.messagesNode.innerHTML = Constants.getMessage("labelCreateTCorConfiguration"); 
			dojo.style(this.messagesNode, "display", "inline");
			this._showAsDialog();
			return;
		}
		this.allPlans = [];
		this.testPlansForTestCaseReceivedCount = 0;
		this._TPLabel.innerHTML = Constants.getMessage("labelTestPlan");
		this._IterationLabel.innerHTML = Constants.getMessage("labelIteration");
		if(testCases && testCases.length >0){
			var testCasesLength  = testCases.length ;
			for(var i=0;i<testCasesLength;i++){
				var responseHandler = new ServiceResponseHandler(this, "_fillPlans", "_error");
				PlanClient.getRelatedTestPlanByCaseMinimalSummary(responseHandler, {uuid: testCases[i].versionableItemId});
			}
		}	
		var configsLength = configs.length;
		for(var i=0;i<configsLength;i++){
			this.addListItem(this._configSection, configs[i].id,configs[i].name);
            if(args.defaultConfigId != null && configs[i].id == args.defaultConfigId)
                this._configSection.selectItem(i);
			else
				this._configSection.selectItem(0);
		}
		
		dojo.style(this._configSection.fsButtonTableNode, "display", "none");
		this._configSection.setMultiSelect(false);
		this._configSection.selectionList.size="6";
		
		this._showAsDialog();
	},
	
	_fillPlans: function(plans){
		var allPlans = this.allPlans;
		var allPlansLength = allPlans.length;
			if(plans && plans.length > 0){
			var plansLength = plans.length;
			for(var i=0;i<plansLength;i++){
				var found = false;
				var planId = plans[i].id;
				for(j=0;j<allPlansLength;j++){
					if(allPlans[j].plan.id == planId){
						found = true;
						break;
					}
				}
				if(found){
					allPlans[j].count = allPlans[j].count + 1; 
				}else{
					allPlans[j] = {};
					allPlans[j].count = 1;
					allPlans[j].plan = plans[i];
				}
			}
		}
		this.testPlansForTestCaseReceivedCount++;
		allPlansLength = allPlans.length; //The allPlans array changes in the steps above and the allPlans length needs to be re-calculated. Work item 21386
		var globalTestCasesLength=this.testCases.length;
		if(this.testPlansForTestCaseReceivedCount == globalTestCasesLength){
			this.plansToShow = [];
			var plansToShow = this.plansToShow;
			index = 0;
			for(var i=0;i<allPlansLength;i++){
				if(allPlans[i].count == globalTestCasesLength){
					plansToShow[index] = allPlans[i].plan;
					var self = this;
					var callbackObj = {
						index:index,
						success: function(results){
							self.plansToShow[this.index].configurations = results;
						},
						failure: function(e){
							self._error(e);
						}
					}
					var responseHandler2 = new ServiceResponseHandler(callbackObj, "success", "failure");
					PlanClient.getConfigurations(responseHandler2,plansToShow[i].versionableItemId);
					index++;					
				}
			}
			this._fillTPCombo(plansToShow);
			var responseHandler= new ServiceResponseHandler(this, "_appendIterations", "_error");
			TimeBoxClient.getTestPhasesSummaryDTO(responseHandler, {});
		}
	},
	
	_fillTPCombo:function(plans){
		dojox.data.dom.removeChildren(this._TP);
		if(!plans || plans.length == 0){
			var option = new Option("", "global");
			SelectUtility.add(this._TP, option);
		}else{
			var option = new Option(Constants.getMessage("labelUnassigned"), "global");
			SelectUtility.add(this._TP, option);
		}	
		if (plans && plans.length > 0) {
			var plansLength = plans.length;
			for (var i = 0; i < plansLength; i++) {
				var planoption = new Option(plans[i].name, plans[i].id);
				SelectUtility.add(this._TP, planoption);
			}
		}
	},
	
	_appendIterations: function(iterations){
		if(iterations && iterations.length > 0){
			var iterationsLength = iterations.length;
			var plansToShow = this.plansToShow;
			var plansToShowLength = plansToShow.length;
			for(var j=0;j<iterationsLength;j++){
				for(var i=0;i<plansToShowLength;i++){
					if(!plansToShow[i].iterations)
						plansToShow[i].iterations = [];
					if(plansToShow[i].versionableItemId === iterations[j].targetTestPlanUUID){
						plansToShow[i].iterations.push(iterations[j]);
					}	
				}
			}
		}
	},
	
	_updateIterationCombo: function(){
		var planId = this._TP.value;
		dojox.data.dom.removeChildren(this._Iteration);
		if(planId ==="global"){
			this._Iteration.disabled = true;
			return;
		}
		this._Iteration.disabled = false;
		var plansToShow = this.plansToShow;
		var plansToShowLength = plansToShow.length;
		for(var i=0;i<plansToShowLength;i++){
			var id = parseInt(planId, 10);
			if(plansToShow[i].id === id){
				var planIterations = plansToShow[i].iterations;
				if(planIterations){
					var planIterationsLength = planIterations.length;
					for(var j=0;j<planIterationsLength;j++){
						var opt = new Option(planIterations[j].name, planIterations[j].itemId);
						SelectUtility.add( this._Iteration, opt );
					}
					break;	
				}else
					this._Iteration.disabled = true;
			}
		}
	},
	
    _showAsDialog: function(){
        if (!this._dialog) {
            var dialogArgs = {
                okCallback: dojo.hitch(this, "_okAction"),
                cancelCallback: dojo.hitch(this, "_cancelAction")
            };
            
            this._dialog = new com.ibm.asq.common.web.ui.internal.widgets.SelectionDialog(dialogArgs);
            this._dialog.setWidth(this.width);
            this._dialog.contentContainer.appendChild(this.domNode);
			if (this.selectedItem) {
				this._dialog.setSecondaryTitle(Constants.getMessage("labelChangeExecProps"));
			} else {
				this._dialog.setSecondaryTitle(this.labelAddTestCase);
			}
            this._dialog.getOkButton().disabled = false;                                
        }
        this._dialog.open(false);
    },	
	updateConfigSection:function(){
		var planId = this._TP.value;
		var configs = [];
		if (planId === "global") {
			configs = this.configs;
		}else {
			configs.push({
				name: Constants.getMessage("labelUnassigned"),
				id: null,
				stateId: null,
				configuration: null
			});
			var plansToShow = this.plansToShow;
			var plansToShowLength = plansToShow.length;
			var globalConfigs = this.configs;
			var globalConfigsLen = globalConfigs.length;
			for (var i = 0; i <plansToShowLength; i++) {
				var id = parseInt(planId, 10);
				var plan = plansToShow[i];
				if (plan.id === id) {
					if (plan.configurations) {
						var plansToShowConfigurationsLength = plan.configurations.length;
						for (var k = 0; k < plansToShowConfigurationsLength; k++) {
							for (var j = 0; j < globalConfigsLen; j++) {
								if (globalConfigs[j].id == plan.configurations[k]) {
									configs.push(globalConfigs[j]);
								}
							}
						}
					}
					break;
				}
			}
		}
		this._configSection._clearList();
		var configsLength = configs.length;
		for(var i=0;i<configsLength;i++){
			this.addListItem(this._configSection, configs[i].id,configs[i].name);
		}
		this._configSection.selectItem(0);
	},
	addListItem :function(domNode, id, displayValue){
		domNode.addOption(id, displayValue);
	},
	
	_okAction: function(){
		var args = {};
		args.selectedTC = !this.selectedItem ? this._testCasesSection.getSelectedItems(): [this.selectedItem];
		args.selectedConfig = this._configSection.getSelectedItems();
		args.testPlanId = this._TP.value != "global" ? this._TP.value : null;
		args.testPlanName = this._TP.value != "global" ? this.getPlanInfo(this._TP.value, "name") : "";
		args.testPlanVersionableItemId = this._TP.value != "global" ? this.getPlanInfo(this._TP.value, "vItemId") : "";
		args.testPhaseItemId = args.testPlanId && !this._Iteration.disabled? this._Iteration.value : null;
		args.testPhaseName = args.testPhaseItemId != null ? this.getPhaseInfo(this._TP.value, this._Iteration.value, "name") : "";
		if (this.okCallback) {
			this.okCallback(args);
		}
	},
	
	getPlanInfo: function(planId, attributeName){
		var plansToShow = this.plansToShow;
		var plansToShowLength = plansToShow.length;
		for(var i=0;i<plansToShowLength; i++){
			if(plansToShow[i].id == planId){
				if(attributeName == "name"){//non-nls
					return plansToShow[i].name;
				}else if(attributeName == "vItemId"){ //non-nls
					return plansToShow[i].versionableItemId;
				}//Add more if need be
			}
		}
	},
	
	getPhaseInfo: function(planId, iterationItemId, attributeName){
		var plansToShow = this.plansToShow;
		var plansToShowLength = plansToShow.length;
		for(var i=0;i<plansToShowLength; i++){
			if(plansToShow[i].id == planId){
				var iterations = this.plansToShow[i].iterations;
				var iterationsLength = iterations.length;
				for(var j=0;j<iterationsLength;j++){
					if(iterations[j].itemId == iterationItemId){
						if(attributeName == "name"){//non-nls
							return iterations[j].name;
						}//Add more if need be
					}	
				}
			}
		}		
	},
	
	_cancelAction: function(){
		if (this.cancelCallback) {
			this.cancelCallback();
		}
	},
	
	_checkBoxStateChanged: function(){
		if(this.allowChangingOfPlanIteration){
			//Enable Section, else keep disabled
		}
	},
	
	onSelectTP: function(){
		this._updateIterationCombo();
		this.updateConfigSection();
		if(this.versionableTestPlanItemId && this.getPlanInfo(this._TP.value, "vItemId") != this.versionableTestPlanItemId){
			dojo.style(this.footer, "display", "inline");
			this.statusText.innerHTML = Constants.getMessage("msgTestPlanAssociatedWithDiffSuite");
			this.statusImg.src = ImageCache.WARNING_ICON;
		}else{
			dojo.style(this.footer, "display", "none");
		}
	},
	
	_error: function(errorObj){
		console.error("Error in TestCaseConfigSelector " + errorObj.message);
	}
	
});
})();
	
