/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.common.properties.SelectTestPlanPopup");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojo.parser");

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.client.internal.planning.PlanningPageClient");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.properties.FilterListPanel");

(function() {
var Constants           = com.ibm.rqm.planning.web.client.internal.Constants;
var FilterListPanel		= com.ibm.rqm.planning.web.ui.internal.view.common.properties.FilterListPanel;
var UNASSIGNED_TESTPLAN	= Constants.getMessage("labelUnassigned");

dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.common.properties.SelectTestPlanPopup",
             [dijit._Widget, dijit._Templated], 
{
        
    templateString: '<div dojoAttachPoint="_content">' +
        '<span dojoAttachPoint="_area"></span>' +
        '</div>',                    

	width: "300px",
    height: "450px", 
	
    postCreate: function(){  
		
    },
    
    initialize: function(args){
 		this.okCallback = args.okCallback;
        this.actionId = args.actionId;
		this.plans = args.plans;
		this.title = args.title ? args.title : null;
 		this.filterListPanel = new FilterListPanel();
		this.filterListPanel.addChangeLisner(dojo.hitch(this, "_validate"));
        this.filterListPanel.addOption(UNASSIGNED_TESTPLAN, UNASSIGNED_TESTPLAN, UNASSIGNED_TESTPLAN);
        for (var j = 0; j < (this.plans ? this.plans.length : 0); j++) {
            this.filterListPanel.addOption(this.plans[j].versionableItemId, this.plans[j].name, this.plans.name);
        }
		
        dojox.data.dom.removeChildren(this._area);
        this._area.appendChild(this.filterListPanel.domNode);
		
		this._showAsDialog();
    },
	

    _showAsDialog: function()
    {
        if (!this._dialog) {
            var dialogArgs = {
                okCallback: dojo.hitch(this, "_okAction"),
                cancelCallback: dojo.hitch(this, "_cancelAction")
            };
            
            this._dialog = new com.ibm.asq.common.web.ui.internal.widgets.SelectionDialog(dialogArgs);
			this._dialog.setTitle(this.title ? this.title : Constants.getMessage("labelChangeProperties", this.actionId));
            this._dialog.setWidth(this.width);
            this._dialog.contentContainer.appendChild(this.domNode);
            this._dialog.getOkButton().disabled = true;                                
        }
        this._dialog.open(false);
    },  
	
	_okAction: function(){
		
		var args = {};
		
 		args.actionId = this.actionId;
 		
		var selectedItems = this.filterListPanel.getSelectedItems();
 
		args.testPlanVersionableItemId = this.filterListPanel.getFirstSelectedValue() == UNASSIGNED_TESTPLAN ? null : this.filterListPanel.getFirstSelectedValue();
		args.testPlanName = selectedItems && selectedItems[0] && selectedItems[0].name != UNASSIGNED_TESTPLAN ? selectedItems[0].name : null;
        if (this.okCallback) {
            this.okCallback(args);
        }
    },
  
    _validate: function(){
        var currentValues = this.filterListPanel ? this.filterListPanel.getSelectedItems() : [];
        if (currentValues.length != 1) 
            this._dialog._yesButton.disabled = true;
        else 
            this._dialog._yesButton.disabled = false;
    },
			
	_cancelAction: function(){
        if (this.cancelCallback) {
            this.cancelCallback();
        }
    },
  
    _error: function(errorObj){
        console.error("Error in TestPlanConfigSelector " + errorObj.message);
    }
    
});
})();
    
