/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.configuration.web.ui.internal.view.configuration.AbstractWizard");
dojo.provide("com.ibm.rqm.configuration.web.ui.internal.view.configuration.AbstractWizard");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");

(function(){
    dojo.declare("com.ibm.rqm.configuration.web.ui.internal.view.configuration.AbstractWizard", [dijit._Widget, dijit._Templated], {
        templateString: "<div dojoAttachPoint=\"_wizardRootNode\" class=\"com-ibm-rqm-configuration-web-ui-internal-view-configuration-GenerateEWIWizard\"></div>",
        
		width: "95%",
		height: "90%",
		
        constructor: function(args, frag){
            if (args.parentController == null) {
                throw new Error("AbstractWizard#constructor: Missing required parameter 'args.parentController'");
            }
            this.controller = args.parentController;
            this.callback = args.callback ? args.callback : null;
			this.title = "";
        },
        
        postCreate: function(){
			this.setTitle(this.title);
            this.showCurrentStep();
        },
        
        //@Abstract - override if necessary, but default behavior should be sufficient
		doPrevious: function(params){
            this.currentStep -= 1;
            this.showCurrentStep(params);
        },
        
		//@Abstract - override if necessary, but default behavior should be sufficient
        doNext: function(params){
            this.currentStep += 1;
            this.showCurrentStep(params);
        },
        
		//@Abstract - override if necessary, but default behavior should be sufficient
        doFinish: function(args){
            this._wizardDialog.close();
			this.destroyRecursive();
            if (this.callback) {
                if (dojo.isObject(this.callback.context) && dojo.isFunction(this.callback.method)) {
                    this.callback.method.apply(this.callback.context, [args]);
                }
            }
        },
		
		//@Abstract - override if necessary, for example, to unsubscribe dojo event.
		uninitialize: function(){
			return;
		},
		
		//@Abstract - override it, set every step heading title of the dialog window
        setTitle: function(title){
			return;
        },
		
		getTitle: function(){
			return this.title;
		},
        
		//@Abstract - override it, set every step panel of the dialog
        showCurrentStep: function(args){
			return;
        },
        
        _setDialogContent: function(node){
			if (!this._wizardDialog) {
				var dialogArgs = {
					isClosable: true,
					showActions: false,
					style: "z-index: 1000;",
					zIndex: 999
				};
				
				this._wizardDialog = new com.ibm.asq.common.web.ui.internal.widgets.SelectionDialog(dialogArgs);
				dojo.connect(this._wizardDialog._close, "onclick", this, "destroyRecursive");
				this._wizardDialog.setWidth(this.width);
				this._wizardDialog.setHeight(this.width);
	            this._wizardDialog.setSecondaryTitle(this.getTitle());
	            this._wizardDialog.open();
			}
			dojox.data.dom.removeChildren(this._wizardDialog.contentContainer);
            this._wizardDialog.contentContainer.appendChild(node);
		
        }
        
    });
    
})();
