/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.configuration.web.ui.internal.view.configuration.GenerateCFGEnvironmentSection");
dojo.provide("com.ibm.rqm.configuration.web.ui.internal.view.configuration.GenerateCFGEnvironmentSection");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.rqm.configuration.web.ui.internal.view.configuration.EnvironmentSection");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");

(function(){
	Constants = com.ibm.rqm.planning.web.client.internal.Constants;
    
    dojo.declare("com.ibm.rqm.configuration.web.ui.internal.view.configuration.GenerateCFGEnvironmentSection", [dijit._Widget, dijit._Templated, com.ibm.rqm.configuration.web.ui.internal.view.configuration.EnvironmentSection], {
        
		labelEnvironment: Constants.getMessage("labelEnvironment"),
		labelEnvironmentInlineHelp: Constants.getMessage("labelEnvironmentInlineHelp", Constants.getMessage("labelTestEnvironments")),
		
		constructor: function(args, frag){
            if (args.controller == null) {
                throw new Error("Create GenerateCFGEnvironmentSection#constructor: Missing required parameter 'args.controller'");
            }
			this.testPlan = args.testPlan;
        },
        
        initialize: function(){
			this._initEnvironmentSection();
			this._initAdvancedProperties();
			this._loadTestPlanEnvironment(this.testPlan.id);
			this._topic = dojo.subscribe("TESTPLAN_CHANGED", this, "_reloadEnvironment");
        },
		
		uninitialize: function(){
			dojo.unsubscribe(this._topic);
			if(this.advancePropertiesDialog && dojo.isFF){
				this.advancePropertiesDialog.close();
				this.advancePropertiesDialog = null;
			}
		}
		
    });
    
})();
