/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.configuration.web.ui.internal.view.configuration.GenerateEWIEnvironmentSection");
dojo.provide("com.ibm.rqm.configuration.web.ui.internal.view.configuration.GenerateEWIEnvironmentSection");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojox.data.dom");

dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");

dojo.require("com.ibm.rqm.configuration.web.ui.internal.view.configuration.EnvironmentSection");
dojo.require("com.ibm.rqm.configuration.web.ui.internal.view.table.ConfigurationTableView");
dojo.require("com.ibm.rqm.configuration.web.client.internal.configuration.WHITCHClient");
dojo.require("com.ibm.rational.test.lm.web.client.internal.config");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.ContentArea");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.MultiTabContainer");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.client.internal.planning.PlanningPageClient");
dojo.require("com.ibm.rqm.configuration.web.util.TestConfigurationUtil");
dojo.require("com.ibm.asq.common.web.ui.internal.util.SelectUtility");

(function(){
    
	var ServiceResponseHandler = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
	var MultiTabContainer = com.ibm.rqm.planning.web.ui.internal.view.common.MultiTabContainer;
	var ContentAreas = com.ibm.rqm.planning.web.ui.internal.view.common.ContentArea;
	var ConfigurationTableView = com.ibm.rqm.configuration.web.ui.internal.view.table.ConfigurationTableView;
	var WHITCHClient = com.ibm.rqm.configuration.web.client.internal.configuration.WHITCHClient;
	var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
	var TestConfigurationUtil = com.ibm.rqm.configuration.web.util.TestConfigurationUtil;
	var SelectUtility = com.ibm.asq.common.web.ui.internal.util.SelectUtility;
	var PlanningPageClient = com.ibm.rqm.planning.web.client.internal.planning.PlanningPageClient;
	
    dojo.declare("com.ibm.rqm.configuration.web.ui.internal.view.configuration.GenerateEWIEnvironmentSection", [dijit._Widget, dijit._Templated, com.ibm.rqm.configuration.web.ui.internal.view.configuration.EnvironmentSection], {
        templateString: '<div class="com-ibm-rqm-configuration-web-conf">' +
						'<div class="head-title"><span dojoAttachPoint="_environmentLabel">${labelEnvironment}</span><span dojoAttachPoint="_cshelp"></span></div>' +
						'<div dojoAttachPoint="_tabContainer">' +
						'</div>' +
						'<div dojoAttachPoint="_environmentlist">' + 
						'   <div><span style="color:gray" dojoAttachPoint="_inlineHelp">${labelEnvironmentInlineHelp}</span></div>' +
						'   <div dojoAttachPoint="_tables"></div>' +
						'   <div>' +
						'   <span dojoAttachPoint="_advancedP" class="apEnable">' +
						'   </span>' +
						'   </div>' +
						'   <br>'+
						'   <br>'+
						'</div>' +
						'<div dojoAttachPoint="_configurationListContainer">' + 
						'   <div><span style="color:gray" dojoAttachPoint="_inlineHelp">${labelConfigurationListInlineHelp}</span></div>' +
						'   <table class="table" style = "width:300px">' +
						'   <tr>' +
						'       <td width="40%" >' +
						'           <label for="_scheduleTestPlan">${labelTestPlan}</label>'+
						'       </td>' +
						'       <td width="60%">' +
						'           <select id="_scheduleTestPlan" dojoAttachPoint="_scheduleTestPlan"></select>' +
						'       </td>' +
						'   </tr>' +
						'   </table>' +		
						'   <div><span dojoAttachPoint="_loadingLabel"></span></div>' +
						'   <div dojoAttachPoint="_configurationList"/>' +
						'</div>' +
						'</div>',
		
		labelEnvironment: Constants.getMessage("labelEnvironment"),
		labelEnvironmentInlineHelp: Constants.getMessage("labelEnvironmentInlineHelp", Constants.getMessage("labelTestExecutionRecords")),
		labelConfigurationListInlineHelp: Constants.getMessage("labelConfigurationListInlineHelp"),
		labelTestPlan: Constants.getMessage("labelTestPlan"),
				
        constructor: function(args){
            if (args.controller == null) {
                throw new Error("Create GenerateEWIEnvironmentSection#constructor: Missing required parameter 'args.controller'");
            }
			this.testCases = args.testCases;
			this.parentTestPlan = args.parentTestPlan;
			
			//existing configuration list
			this._existingConfigurations = [];
        },
        
        initialize: function(){
			this._initTabContainer();
			this._initConfigurationListContainer();
			this._initEnvironmentSection();
			this._initAdvancedProperties();
            if(this.parentTestPlan == null){
				this._loadCatalogEnvironment();
				this._getExistingConfigurations(TestConfigurationUtil.NO_ASSOCIATED_TEST_PLAN);
			}
			else{
				this._loadTestPlanEnvironment(this.parentTestPlan.id);
				this._getExistingConfigurations(this.parentTestPlan.versionableItemId);
			}			
			this._reloadEnvironmentTopic = dojo.subscribe("TESTPLAN_CHANGED", this, "_reloadEnvironment");
			this._doInitScheduleTestPlan();
        },
		
		uninitialize: function(){
//			console.debug("===============GenerateEWIEnvironmentSection Uninitialize");
			dojo.unsubscribe(this._reloadEnvironmentTopic);
			if(this.advancePropertiesDialog && dojo.isFF){
				this.advancePropertiesDialog.close();
				this.advancePropertiesDialog = null;
			}
		},
		
		//API
		getExistingConfigurations: function(){
			return this.configurationTableWidget.getSelectedConfigs();
		},
		
		_initTabContainer: function(){
			this._contentArea = new ContentAreas();
			this._contentArea.initialize({tabContainerStyle: "min-height: 100px"});
			
		    this._tabContainer.appendChild(this._contentArea.domNode);
			
			var args = {
				name: Constants.getMessage("labelReuseConfigurations"),
				noSelect: true,
				content: this._configurationListContainer
			};
			this._contentArea.addPage(args);
			
			var args = {
				name: Constants.getMessage("labelGenerateConfigurations"),
				noSelect: true,
				content: this._environmentlist
			};
			this._contentArea.addPage(args);
		},
		
		_initConfigurationListContainer: function(){
			var self = this;
			var oncheckListener = {
				context: this,
				method: function(tableViewer, rowObject, state){
					if(self.enableNextButton != null && (state == true || self.configurationTableWidget.getSelectedConfigs().length > 0)){
						self.enableNextButton(false, null);
					}else{
						self.enableNextButton(true, null);
					}
				}
			};
			this.configurationTableWidget = new ConfigurationTableView({oncheckListener: oncheckListener});
			this._configurationList.appendChild(this.configurationTableWidget.domNode);
		},
		
		_reloadExistingConfigurations: function(testPlanId, testPlanUUID){
			this._existingConfigurations = [];
			if (testPlanUUID == TestConfigurationUtil.NO_ASSOCIATED_TEST_PLAN){
				this._getExistingConfigurations(TestConfigurationUtil.NO_ASSOCIATED_TEST_PLAN);
			}else{
				this._getExistingConfigurations(testPlanUUID);
			}
		},
		
		_getExistingConfigurations: function(parentTestPlanUUID){
			this._loadingLabel.appendChild(document.createTextNode(Constants.getMessage("labelLoading")));
			
            var responseHandler = new ServiceResponseHandler(this, "_showConfigurations", "_error");
            WHITCHClient.getConfigurationsByTestPlan(responseHandler, {testsPlanUUID: parentTestPlanUUID});
		},
		
		/**
		 * adds given AssetConfigurationDTO[] to local storage of configurations and refreshes table viewer
		 */		
		_showConfigurations: function(dtos) { //AssetConfigurationDTO[]
			dtos = dtos || [];
            var catalog = new com.ibm.asq.common.web.client.internal.Catalog();
			for (var i = 0; i < dtos.length; i++) {
				var config = this._fromDTO(dtos[i], catalog);
	            this._existingConfigurations.push(config);
			}
			dojox.data.dom.removeChildren(this._loadingLabel);
			this.configurationTableWidget.refresh(this._existingConfigurations);
        },		
		
		_fromDTO: function(dto, catalog) { //AssetConfigurationDTO
			catalog = catalog || new com.ibm.asq.common.web.client.internal.Catalog();
			var configuration = new com.ibm.asq.common.web.client.internal._catalog.Configuration(dto.configuration);
			var attributeIds = catalog.getDisplayTypes();
			var config = [];
			for (var j = 0; j < attributeIds.length; j++) {
				var value = configuration.getValue(attributeIds[j]);
				if (value) {
					config.push({
						key: attributeIds[j],
						value: value
					});
				}
			}
			config.config = dto;
			config.isExist = true;
			return config;		
		},		
		
		_activateTab: function(tabIndex){
			if(!this._contentArea){
				console.error("this._contentArea has not been initialized.");
				return;
			}
			var tabs = this._contentArea._tabs.getChildren();
			if(tabIndex >= tabs.length){
				throw new Error("The specified tabIndex " + tabIndex + " is out of range.");
			}else{
				this._contentArea._tabs.selectChild(tabs[tabIndex]);
			}
		},
		
		_doInitScheduleTestPlan: function(){
			var self = this;
	        this.connect(this._scheduleTestPlan, "onchange", function(e){
	            this._reloadExistingConfigurations(e.currentTarget.options[e.currentTarget.selectedIndex].id, 
					e.currentTarget.options[e.currentTarget.selectedIndex].value);
	        });
	        var handler = {
	            success: function(testPlans){
	                dojox.data.dom.removeChildren(self._scheduleTestPlan);
	                self._scheduleTestPlan.disabled = false;
	                var option = new Option(Constants.getMessage("labelUnassigned"), TestConfigurationUtil.NO_ASSOCIATED_TEST_PLAN);
	                option.id = TestConfigurationUtil.NO_ASSOCIATED_TEST_PLAN;
					SelectUtility.add( self._scheduleTestPlan, option );
	                if (dojo.isArray(testPlans) && testPlans.length > 0) {
	                    for (var i = 0; i < testPlans.length; i++) {
	                        var option = new Option(testPlans[i].name, testPlans[i].versionableItemId);
	                        option.id = testPlans[i].id;
							//when there is a specified parent test plan, disable this selection
	                        if (self.parentTestPlan!=null && self.parentTestPlan.versionableItemId == option.value) {
	                            option.selected = true;
	                            self._scheduleTestPlan.disabled = true;
	                        }
							SelectUtility.add( self._scheduleTestPlan, option );
	                    }
	                }
	            },
	            error: function(e){
	                self._error(e);
	            }
	        };
	        var responseHandler = new ServiceResponseHandler(handler, "success", "error");
	        com.ibm.rqm.planning.web.client.internal.planning.PlanningPageClient.getRelatedTestPlanByCaseMinimalSummary(responseHandler, {uuid: this.testCases[0].versionableItemId});

    	},
		
		_reloadEnvironment: function(id){
			this.inherited("_reloadEnvironment", arguments);
			var configurationTableWidget = this.configurationTableWidget;
			var enableNextButton = this.enableNextButton;
			if(enableNextButton != null){
				if(configurationTableWidget.getSelectedConfigs().length > 0) {
					enableNextButton(false, true);
				} else {
					enableNextButton(true, true);
				}
			}
			this._activateTab(1);
		}, 
		
		_error: function(error) {
			console.error(this.declaredClass + ": " + error);
		}
    });
    
})();
