/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.configuration.web.ui.internal.view.configuration.GenerateEWIWizard");
dojo.provide("com.ibm.rqm.configuration.web.ui.internal.view.configuration.GenerateEWIWizard");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.rqm.configuration.web.ui.internal.view.configuration.GenerateEWIConfigurationListPanel");
dojo.require("com.ibm.rqm.configuration.web.ui.internal.view.configuration.GenerateEWIConfigurationPanel");
dojo.require("com.ibm.rqm.configuration.web.ui.internal.view.configuration.EWIListPanel");
dojo.require("com.ibm.rqm.configuration.web.ui.internal.view.configuration.AbstractWizard");
dojo.require("com.ibm.rqm.configuration.web.util.TestConfigurationUtil");
dojo.require("com.ibm.rqm.configuration.web.client.internal.configuration.WHITCHClient");

dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");

(function(){

    var GenerateEWIConfigurationPanel = com.ibm.rqm.configuration.web.ui.internal.view.configuration.GenerateEWIConfigurationPanel;
    var GenerateEWIConfigurationListPanel = com.ibm.rqm.configuration.web.ui.internal.view.configuration.GenerateEWIConfigurationListPanel;
    var TestConfigurationUtil = com.ibm.rqm.configuration.web.util.TestConfigurationUtil;
	var WHITCHClient = com.ibm.rqm.configuration.web.client.internal.configuration.WHITCHClient;
    var EWIListPanel = com.ibm.rqm.configuration.web.ui.internal.view.configuration.EWIListPanel;
	var ServiceResponseHandler = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
	var Constants  = com.ibm.rqm.planning.web.client.internal.Constants;
	
    var STEP_CONFIGURE = 1;
    var STEP_CONFIG_PREVIEW = 2;
	var STEP_EWI_PREVIEW = 3;
    
    dojo.declare("com.ibm.rqm.configuration.web.ui.internal.view.configuration.GenerateEWIWizard", [dijit._Widget, dijit._Templated, com.ibm.rqm.configuration.web.ui.internal.view.configuration.AbstractWizard], {
        
        constructor: function(args, frag){
            this.testCases = args.testCases;
			this.parentTestPlan = args.parentTestPlan;
            this.currentStep = STEP_CONFIGURE;
			//Configurations which need to be created and which already exist
			this.allConfigs = {};
        },
		
		//override for AbstractWizard
		uninitialize: function(){
//			console.debug("===============GenerateEWIWizard Uninitialize");
			this._generateEWIWidget.destroyRecursive();
			if(this._configurationListView){
				this._configurationListView.destroyRecursive();
			}
			if(this._ewiListView){
				this._ewiListView.destroyRecursive();
			}
		},
        
		//override for AbstractWizard
        setTitle: function(title){
			this.title = Constants.getMessage("labelGenerateEWI");
        },
		
		//override for AbstractWizard
        showCurrentStep: function(args){
			switch (this.currentStep) {
                case STEP_CONFIGURE:
                    this._showGenerateConfiguration(args);
                    break;
                case STEP_CONFIG_PREVIEW:
                    this._showTestConfigurationList(args);
                    break;
				case STEP_EWI_PREVIEW:
                    this._showGeneratedEWIList(args);
                    break;
                default:
                    throw new Error(Constants.getMessage("labelInvalidStep") + " (" + this.currentStep + ")");
            }
        },
		
		_showGenerateConfiguration: function(){
            if (!this._generateEWIWidget) {
                var args = {
                    controller: this
                };
                args.testCases = this.testCases;
                args.parentTestPlan = this.parentTestPlan;
                this._generateEWIWidget = new GenerateEWIConfigurationPanel(args);
				this._setDialogContent(this._generateEWIWidget.domNode);
				this._generateEWIWidget.initialize();
            }else{
				this._setDialogContent(this._generateEWIWidget.domNode);
			}
        },
        
        _showTestConfigurationList: function(params){
			if(params.createNewList != null && params.createNewList == false ){
				this._setDialogContent(this._configurationListView.domNode);
				return;
			}
			
            params.controller = this;
            this._configurationListView = new GenerateEWIConfigurationListPanel(params);
            this._setDialogContent(this._configurationListView.domNode);
        },
		 
        _showGeneratedEWIList: function(params){
            params.controller = this;
            this._ewiListView = new EWIListPanel(params);
            this._setDialogContent(this._ewiListView.domNode);
        },
		
		commit: function(ewis){
//			this.ewis = ewis;
//			this.createTestConfigurations(ewis);
			var args = {
				ewis: ewis,
				parentTestPlanUUID: this._ewiListView.parentTestPlanUUID,
				configurationAppliedTestPlanUUID: this._configurationListView.configurationAppliedTestPlanUUID
			}
			this.doFinish(args);
		}
    });
    
})();
