/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.configuration.web.ui.internal.view.configuration.ReassignPopup");
dojo.provide("com.ibm.rqm.configuration.web.ui.internal.view.configuration.ReassignPopup");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojox.data.dom");

//xojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.team.repository.web.client.internal.RepositoryClient");

dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");

(function() { // module container

//var ServiceResponseHandler	= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var RepositoryClient            = com.ibm.team.repository.web.client.internal.RepositoryClient;
var Constants = com.ibm.rqm.planning.web.client.internal.Constants;

dojo.declare(
	"com.ibm.rqm.configuration.web.ui.internal.view.configuration.ReassignPopup",
	[dijit._Widget, dijit._Templated],
	{
		templatePath: dojo.moduleUrl("com.ibm.rqm.configuration.web", "ui/internal/view/templates/configuration/ReassignPopup.html"),

		constructor: function(args) {
			this._data=[];
			this._filteredData = [];
			this._filterText = "";
			this._objectScope = args.objectScope
			this._callbackFunction = args.callbackFunction;
			this._valueType = args.valueType;
		},
		
		postCreate: function(){
			this._loadingLabel.appendChild(document.createTextNode(Constants.getMessage("labelLoading")));	
		},
		
		initData:function(args){
			this._data = args.datas;
			this._type = args.type;
			this._show();
		},
		
		_show:function(){
			dojox.data.dom.removeChildren(this._displayControl);
			var table = document.createElement("table");
			var tbody = document.createElement("tbody");
			table.appendChild(tbody);
			if(dojo.isArray(this._data) && this._data.length > 0){
				var list = (this._filterText == "") ? this._data : this._filteredData;
				for (var i = 0; i < list.length; i++)
				{
					var data = list[i];	
					var tr = document.createElement("tr");
					var td = document.createElement("td");
					if(data.value == "Unassigned"){
						data.value = Constants.getMessage("labelUnassigned");
					}
					td.appendChild(document.createTextNode(data.value));
					td.setAttribute("value", data.id);
					tr.appendChild(td);
					tbody.appendChild(tr);
					this.connect(td, "onclick", this._onNameClick);	
				}
			}else{
				tr = document.createElement("tr");
				td = document.createElement("td");
				if(this._type == "Iteration"){
					td.appendChild(document.createTextNode(Constants.getMessage("labelNoIteration")));
				}else if(this._type == "User"){
					td.appendChild(document.createTextNode(Constants.getMessage("labelNoUser")));
				}
				
				tr.appendChild(td);
				tbody.appendChild(tr);
			}
			this._displayControl.appendChild(table);
		},
		
		_onNameClick: function(e) {
			var value = e.currentTarget.getAttribute("value");	
		    this.selectedItemId = value;
			for (var i = 0; i < this._data.length; i++){
				if(this._data[i].id == value){
					this.selectedItem = this._data[i].item;
					break;
				}
			}
			this._filterControl.value = e.currentTarget.innerHTML;
		},
		
		_onSetFilterValue: function() {		
			this._filterText = this._filterControl.value;
			this._filterValueEntered = true;		
			this._applyFilter();		
			this._show();				
		},
		
		_applyFilter: function() {		
			this._filteredData = [];
								
			for (var i=0; i<this._data.length; i++)
			{
				var row = this._data[i];
				if (row.value.toLowerCase().indexOf(this._filterText.toLowerCase()) !== -1)
				{
					this._filteredData.push(row);					
				}
			}
		},
		
 		_onFilterFocus: function() {		
			this._filterControl.value = "";
			//this._filterControl.className = "";
		},
		
		_onFilterBlur: function() {		
			var filterVal = dojo.trim(this._filterControl.value);
				
			if (filterVal.length === 0)
			{
				
			}
			else
			{
				this._filterText = filterVal;
				this._filterControl.value = filterVal;
			}
		},
		
		getReAssignedItemId: function(){
			return this.selectedItemId;
		},
		
		getReAssignedItem: function(){
			return this.selectedItem;
		},
		
		onOK: function(){
			var id = this.getReAssignedItemId();
			var typeValue = {
				valueType: this._valueType,
				value: id,
				item: this.getReAssignedItem() 
			};
			this._objectScope[this._callbackFunction].call(this._objectScope, typeValue);
		},
			
		_error: function(errorObj) {
			alert("Error: (message: '" + errorObj.message + "') from Environment#_error");
		}
	}
);

})();
