/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
//console.debug("Loading: com.ibm.rqm.planning.web.ui.internal.view.construction.AbstractArtifactEditor");

dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.construction.AbstractArtifactEditor");

dojo.require("jazz.core.loader");

dojo.require("dojox.data.dom");
dojo.require("dojox.fx.easing"); 
dojo.require("dojox.fx.scroll");

dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.Button");

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.DirectoryPane");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.EditorSection");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.EditorSectionPrintView");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.EditorSubSection");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");
dojo.require("com.ibm.asq.common.web.ui.internal.util.GlobalEvents");
dojo.require("com.ibm.asq.common.web.client.internal.PermissionsClient");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.asq.common.web.ui.internal.auth.ESignatureDialog");

dojo.require("com.ibm.asq.common.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.EditorUtil");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.client.internal.WorkItemUtils");
dojo.require("com.ibm.rqm.planning.web.client.internal.template.TemplateClient");
dojo.require("com.ibm.rqm.planning.web.ui.internal.model.ArtifactModel");
dojo.require("com.ibm.rqm.planning.web.ui.internal.model.SaveParticipant");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.extension.DynamicSection");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.extension.DynamicGridSection");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.extension.SectionGroup");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.ManageSectionsDialog");
dojo.require("com.ibm.team.process.web.client.projectarea");
dojo.require("com.ibm.asq.common.web.ui.internal.util.SelectUtility" );
dojo.require("com.ibm.rqm.planning.web.client.internal.PreferenceClient");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.MenuPopup");

(function(){ // module container    
    var Utility = com.ibm.asq.common.web.ui.internal.util.Utility;
    var EditorUtil = com.ibm.rqm.planning.web.ui.internal.util.EditorUtil;
    var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
    var WorkItemUtils = com.ibm.rqm.planning.web.client.internal.WorkItemUtils;
    var ArtifactModel = com.ibm.rqm.planning.web.ui.internal.model.ArtifactModel;
    var SaveParticipant = com.ibm.rqm.planning.web.ui.internal.model.SaveParticipant;
	var DynamicSection = com.ibm.rqm.planning.web.ui.internal.view.extension.DynamicSection;
	var DynamicGridSection = com.ibm.rqm.planning.web.ui.internal.view.extension.DynamicGridSection;
	var DirectoryPane = com.ibm.asq.common.web.ui.internal.widgets.DirectoryPane;
    var EditorSection = com.ibm.asq.common.web.ui.internal.view.common.EditorSection;
	var EditorSectionPrintView = com.ibm.asq.common.web.ui.internal.view.common.EditorSectionPrintView;
    var EditorSubSection = com.ibm.asq.common.web.ui.internal.view.common.EditorSubSection;
    var SectionGroup = com.ibm.rqm.planning.web.ui.internal.view.extension.SectionGroup;
    var GlobalEvents = com.ibm.asq.common.web.ui.internal.util.GlobalEvents;
	var ManageSectionsDialog = com.ibm.rqm.planning.web.ui.internal.view.construction.ManageSectionsDialog;
    var TemplateClient = com.ibm.rqm.planning.web.client.internal.template.TemplateClient;
    var ServiceResponseHandler = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
    var PermissionsClient = com.ibm.asq.common.web.client.internal.PermissionsClient;
	var getCurrentProjectArea = com.ibm.team.process.web.client.projectarea.getCurrentProjectArea;
	var SelectUtility = dojo.getObject( "com.ibm.asq.common.web.ui.internal.util.SelectUtility" );
	var PreferenceClient = com.ibm.rqm.planning.web.client.internal.PreferenceClient;
	var YesNoDialog = com.ibm.asq.common.web.ui.internal.widgets.YesNoDialog;
	var ViewHeaderLayout = com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout;
	var ESignatureDialog = com.ibm.asq.common.web.ui.internal.auth.ESignatureDialog;
	var WorkingLabel = Constants.getCommonMessage("tableViewer_working");
    
	//State Management - Hard Coded	
	var APPROVED = "Approved";
	var RETIRED = "Retired";
    
    dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.construction.AbstractArtifactEditor", [SaveParticipant], {
        constructor: function(){
//		   	console.debug("++++++++++++++++++++AbstractArtifactEditor Constructor");
			this._isLoading = false;
            this._artifactModel = null;
			this._artifactOptions = null;
            this._isReadOnly = false;
            this._rolePermitsEdit = true;
            this._rolePermitsArchive = true;
            this._isCopy = false;
			this._isArchived = false;
            this._isNew = true;
			this._isSaving = false;
			this._isSnapshot = false;
			this._isPrintView = false;
			this._printViewURI = null;
			this._dirty = false;
            this._artifact = null;
            this._templateId = null; 
			this._template = null;  /* ITemplate */
            this._sections = []; //the contributed section widgets
            this._sectionsRemoved = [];  //string array, list of sections to remove from this plan
            this._sectionMap = {}; //maps section configs by id for easier access from group (sectionId: section)
			this._sectionsNode = null; // dom node where sections are added
			this._tocNode = null; // dom node where sections are added
			this._titleModified = false;
			this._cshelpId = null;	
            this._editorRegistry = dojo.getObject(Constants.EDITOR_REGISTRY_OBJECT_ID);
			this._editorConfig = this._editorRegistry.getEditor(this);			
			this._uri = null;
			this._projectAlias = Utility.getCurrentProjectAreaAlias();
			this._menus = [];
            // customize locale specific preferred width for TOC panel
            this.tocWidth = 140;
            switch (dojo.locale.split('-')[0]) {
                case "ja":
                    this.tocWidth = 165;
                    break;
            }

            // The editor is not completely initialized until the dynamic sections (according to the tempalte) are loaded.
            // Default with no dynamic sections required and these flags are set upon invoking the sections loading method.
            this._getTemplatedComplete = true;
            this._loadSectionsComplete = true;
			
			//A confirmation dialog is displayed only if the artifact is changed.
			this._isAlertWhenChangeTemplate = false;
			
			//State Management
			this._stateChanged = false;
			
			// listen for section changes via URI
            this._updateTabUriTopic = dojo.subscribe(GlobalEvents.UpdateTabUri, this, "_onUpdateTabUri");
        },
        
        postCreate: function() {
			//connect state setters to updatSaveable
			//this will enable/disable the save/cancel buttons appropriately
			this.connect(this, "setReadOnly", "updateSaveable");
			this.connect(this, "setSaving", "updateSaveable");
			this.connect(this, "setDirty", "updateSaveable");
			this.connect(this, "setLoading", "updateSaveable");
			this.connect(this, "setArtifactType", "_initPermissionsAndPreferences");
			
			this.setUri(window.location.hash);
        },
        
        // unsubscribe from pub/sub
        uninitialize: function() {
            //console.debug("-------------------AbstractArtifactEditor Uninitialize");
			dojo.unsubscribe(this._updateTabUriTopic);
            
            this.destroySections();
            this._artifactModel.uninitialize();
            this._header = null;
            this._artifactModel = null;
            this._artifact = null;
            this._templateId = null; 
            this._template = null; 
            this._sections = null;
            this._sectionsRemoved = null;
            this._sectionMap = null;
            this._sectionsNode = null;
			dojo.forEach(this._menus, function(menu){ 
				if(menu.destroyRecursive){
					menu.destroyRecursive();
				}
			});
			this._menus = [];
			
            var relatedInfo = this.getStaticRelatedInfo();
			if (relatedInfo){
				relatedInfo.destroy();
			}
        },
        getStaticRelatedInfo: function() {
			return null;
        },
        // Clean up the to be discarded editor sections. The editor could
        // unload all of the sections and recreate them. The old sections
        // needs to be cleaned up before being unloaded.
        cleanUpSectionsBeforeReload: function() {
            Utility.destroyWidgetsFromNode(this._sectionsNode);
            this.destroySections();
        },
        
        // Clean up section contents. Section contents may not have
        // attached to the section's container. Need to explicitly destroy
        // them.
        destroySections: function() {
            var sections = this._sections;
            var len = sections ? sections.length : 0;
            for(var i = 0; i < len; i++) {
                var sw = sections[i];
                sections[i] = null;
                if(sw.destroy) {
                    //console.debug("destroying section widget: " + sw.id);
                    sw.destroy();
                    sw.sectionContainer = null;
                    sw.parentController = null;
                    sw.parentEditor = null;
                }
            }            
        },
        
        getArtifactModel: function(){
            return this._artifactModel;
        },
		
        setArtifactModel: function(artifactModel){
            if(this._artifactModel) {
                this._artifactModel.uninitilize();
            }
            this._artifactModel = artifactModel;
			if (this.isRolePermitsEdit() || this.isRolePermitsArchive() || this.isRolePermitsLock()) {
				this._artifactModel.getSaveContext().addParticipant(this);
				this._artifactModel.setArtifact(this.getArtifact());
			}
        },
		
        getSaveContext: function() {
            var artifactModel = this.getArtifactModel();
            if (artifactModel == null) {
                console.error("AbstractArtifactEditor:getSaveContext() - artifact model is null");
                artifactModel = new ArtifactModel();
            }
            return artifactModel.getSaveContext();            
        },
        
        isReadOnly: function(){
            return this._isReadOnly;
        },
        
		//State Management
		isSaveableState: function()
		{
			//If not initialized yet then sure, we're saveable.
			if (this.getStateValue() == null)
				return true;
			
			//State Management - Hard Coded
			//If the state has changed then saveable is true.
			//if the state has NOT changed and the current state is Approved or Retired then saveable is false
			if (this.getStateChanged() ==  true)
				return true;

			//No state change so return false if in Approved or Retired and we the no edit in those constraints is in effect
			//Otherwise return true
			var currentState = this.getStateValue();
			if ((currentState == Constants.STATETRANSITION_STATE_APPROVED || currentState == Constants.STATETRANSITION_STATE_RETIRED) 
					&& EditorUtil.applyTransactionConstraint(Constants.STATETRANSITION_PREFERENCE_NOEDITAPPROVED))
				return false;
			else
				return true;
		},
		
		//State Management
		//If the state has changed then the user should be allowed to save
		setStateChanged: function(changed)
		{
			this._stateChanged = changed;
		},
        
		//State Management 
		getStateChanged: function()
		{
			return(this._stateChanged);
		},

        setReadOnly: function(readOnly){
            this._isReadOnly = readOnly;
        },

        isRolePermitsEdit: function(){
            return this._rolePermitsEdit;
        },
        
        setRolePermitsEdit: function(permits){
            this._rolePermitsEdit = permits;
        },
        
        isRolePermitsArchive: function(){
            return this._rolePermitsArchive;
        },
        
        setRolePermitsArchive: function(permits){
            this._rolePermitsArchive = permits;
        },
		
        isRolePermitsLock: function(){
            return this._rolePermitsLock;
        },
        
        setRolePermitsLock: function(permitsLock){
			this._rolePermitsLock = permitsLock ? (permitsLock === true) : false; 
        },		
		
        isRolePermitsCreateSection: function(){
            return this._rolePermitsCreateSection;
        },
				
        setRolePermitsCreateSection: function(permission) {
            this._rolePermitsCreateSection = permission ? (permission === true) : false; 
        },		
        
        isCopy: function(){
            return this._isCopy;
        },
        
        setCopy: function(copy){
            this._isCopy = copy;
        },
		
		/*
		 * Since 1.0.1
		 */
		setArchived: function(value){
			this._isArchived = value;
		},
		
		isArchived: function(){
			return this._isArchived;
		},
		
		//@Overriden from SaveParticipant
		setDirty: function(dirty){
			if(!this.isArchived()){
				this.inherited("setDirty", arguments);
			
				this._isAlertWhenChangeTemplate = dirty;
				
				//Do not allow editing of an "Approved" or "Retired" artifact
				if(!this.isNew() && dirty == true && this.isSaveableState()){
					dojo.publish(GlobalEvents.UpdateTabLabel, [this._uri ? this._uri : window.location.hash, "", this.getArtifactModel().getTabClass(), dirty]);
				}
	            
	            // if our header is already created, update the save status.
	            if(this.getHeader()) {
	                if (dirty) {
						if(this.isSaveableState())
							this.setLastSaved(Constants.STATUS_DIRTY);
						else
						   this.setHeaderStatus(Constants.OPERATION_WARNING, Constants.HEADER_STATUS_WARNING, Constants.getMessage("labelConstraintDescription1"));
					}
					else 
						this.getHeader().clearStatus();
	            }
			}
		},
		
		isSaving: function() {
			return this._isSaving;
		},
		
		setSaving: function(saving) {
			this._isSaving = saving;
		},
		
        isLoading: function() {
            return this._isLoading;
        },
        
        setLoading: function(loading) {
            this._isLoading = loading;
			if (this.getHeader()) {
				if (loading === true) {
                    // hide UI items while loading to minimize flickering 
                    if (this._tableOfContentsNode)      
                        dojo.style(this._tableOfContentsNode, "visibility", "hidden");
                    
					this.getHeader().setProgressStart(Constants.getMessage("labelLoadingArtifact", this.getArtifactType()), /*hide content*/true);
				} else {
                    if (this._tableOfContentsNode)      
                        dojo.style(this._tableOfContentsNode, "visibility", "visible");
					this.getHeader().setProgressEnd();
				}
			}
        },		
		
        setLoadingArtifactComplete: function() {
            if (this._getTemplatedComplete && this._loadSectionsComplete) {
                this.setLoading(false);

                if (this.isNew() || this.isCopy()) {
                    if (this.getHeader()) {
                        this.getHeader().setEditableTitleFocus();
                    }
                }
            }
			
			this._isAlertWhenChangeTemplate = false;
			this.updateSaveable();
        },

        isArchived: function() {
            return (this.getArtifact() && this.getArtifact().archived);
        },
		        
        isSnapshot: function() {
            return (this._isSnapshot || (!this.isCopy() && this.getArtifact() && this.getArtifact().snapshotInfo));
        },
		
		setIsSnapshot: function(isSnapshot) {
			this._isSnapshot = isSnapshot;
		},
		
		isPrintView: function() {
			return this._isPrintView;
		},
		
        setPrintView: function(printView) {
            this._isPrintView = printView;
        },		

        getPrintViewURI: function() {
            return this._printViewURI;
        },
        
        setPrintViewURI: function(uri) {
            this._printViewURI = uri;
        },		
		
		supportsPrintView: function() {
			return (this.getPrintViewURI() != null);
		},
        
        isEditable: function() {
            return !(this.isReadOnly() || this.isSnapshot());
        },
        
        isNew: function(){
            return this._isNew;
        },
        
        setNew: function(newx){
            this._isNew = newx;
        },
        
        getArtifact: function(){
            return this._artifact;
        },
        
        setArtifact: function(artifact){
            this._artifact = artifact;
			
			if (this.isCopy()) {
				this._artifact.name = Constants.getMessage("labelCopyOf", this._artifact.name);
			} 
			if (this._artifact && this._artifact.snapshotInfo != null) {
                this.setReadOnly(true);
            }
			var options = this.getArtifactOptions();
            if (this._artifact && this._artifact.locked == true && options && options.lockingEnabled) {
                this.setReadOnly(true);
            }
			
			var model = this.getArtifactModel();
			if (model!=null) {
				model.setArtifact(this._artifact);
			}
        },
        
        getArtifactType: function(){
            return this._artifactType;
        },        
        
        setArtifactType: function(artifactType){
            this._artifactType = artifactType;
        },   
		
        getArtifactOptions: function(){
            return this._artifactOptions;
        },        
        
        setArtifactOptions: function(opts){
            this._artifactOptions = opts;
        }, 		 
		
		getTemplate: function() {
            return this._template;		      			
		},	

        setTemplate: function(template) {
            this._template = template;                      
        },		
		
		getTemplateId: function() {
			if (this._templateId) {
				return this._templateId;
			} else if (this.isNew() && this.getTemplate()) {
				return this.getTemplate().itemId;
			} else if (this.getArtifact()) {
				return this.getArtifact().templateItemId;
			}
			return null;
		},
		
        setTemplateId: function(templateId) {
            this._templateId = templateId;                      
        },		
		
		getEditorId: function() {
			if (this._editorConfig) {
				return this._editorConfig.id;
			}
			return null;
		},
		        
		getArtifactSection: function(id) {
            if (this.getArtifact()) {
				var sections = this.getArtifact().sections;
				var secLen = sections ? sections.length : 0;
				for (var i = 0; i < secLen; i++) {
					var s = sections[i];
					if (s.id == id) return s;
				}
			}
			return null;
        },
        
        // @override for SaveParticipant
        getItemId: function(){
            if (this.isCopy() || this.isNew()) 
                return null;
            return this.getArtifact().itemId;
        },
		
        // @override for SaveParticipant
        getStateId: function(){
            if (this.isCopy() || this.isNew()) 
                return null;        
            return this.getArtifact().stateId;
        },		
        
        // @override for SaveParticipant
        getVersionableItemId: function(){
            if (this.isCopy() || this.isNew()) 
                return null;
            return this.getArtifact().versionableItemId;
        },

        // @override for SaveParticipant
        saveFinished: function(savedArtifact){
            var wasNew = this.isNew();
            this.setNew(false);
            this.setCopy(false);
			            
            savedArtifact = WorkItemUtils.fixupArtifactWorkItems(savedArtifact);
            this.setArtifact(savedArtifact);

            
            //update header
            this.updateHeader();              
            //update Sections
            this.updateSections();
            //update TOC
            this.updateTableOfContents();  
            
            this.getHeader().setProgressEnd();
            this.getHeader().clearStatus();
            
            // update the state, just in case that the state had changed.
            this._updateState();
            
            // this was a new artifact. Need to update its URI to a saved artifact one.
            // This allows any new navigation to this artifact to reuse the same editor page. 
            if(wasNew) {
                this._publishArtifactUriChanged();
                this._publishArtifactAdded();
            }
            
            // if the title is changed, the listing view, "My" and "All" artifacts query result view,
            // need to be updated.
            //
            if (this._titleModified) {
                this._titleModified = false;
            }
			//Publish artifact on update
			if (!wasNew) {
                    // notify other tabs is it is not new
                    this._publishArtifactUpdated();
            }
			this.setSaving(false);
			this.setDirty(false);						

            this.setLastSaved(Constants.STATUS_SUCCESS);
			
			this.setUri(window.location.hash);
        },
		
		setUri: function(uri){
			this._uri = uri;
		},
                
        // @override for SaveParticipant
        saveFailed: function(status){
            this.getHeader().setProgressEnd();
            if (status != null && status.ok != true) {
                this._saveError(status);
            }
			this.setSaving(false);
        },
        
        onSave: function(){
			//protect against keyboard shortcut save when save shouldn't be available
			if (!this._isSaveable()) {
				return;
			}
			//clean Header Status: 
			this.getHeader().clearStatus();
			
			if(this.isEditable() && this.validate() == false) {
				return false;
			}     
            //HACK - section level validation
            //SHOULD BE REMOVED - See RQM WI 2562
            var sections = this.getSections();
			var secLen = sections ? sections.length : 0;
            for (var i = 0; i < secLen; i++) {
				var s = sections[i];
				if (s.isEditable() && s.validate() == false) return false;
            
            }
			
			//can we save yet or is esig required ?
            var esigRequired = false;
            for (var i = 0; i < secLen; i++) {
				var s = sections[i];
                if (s.isEditable() && s.saveRequiresSignature() == true) {
                    esigRequired = true;
                }
            }
			
			if (esigRequired) {
	            //re-authenticate the user
	            var esig = new ESignatureDialog({
	                onSuccess: dojo.hitch(this, "_doSave"),
	                onFailure: dojo.hitch(this, function(){})
	            });				
			} else {
				this._doSave();
			}
        },
		
		_doSave: function() {
            //set save in progress
            if (this.isSaving()) {
                return; //protects against multiple save button clicks
            } else {
                this.setSaving(true);
            }
            
			//if not saving the overall artifact (saving section(s) only)
			//we must add a  
			if (this.isReadOnly() && this._hasEditableSections()) {
				this.getSaveContext().setOnSaveFinished(dojo.hitch(this, "saveFinished", this.getArtifact()));
			}
			
            //invoke the global save transaction        
            this.getHeader().setProgressStart(Constants.getMessage("labelSavingArtifact", this.getArtifactType())); 
            //HACK: FIX 6663, give a new focus after the Save button is disabled
            dijit.focus(this.getHeader().domNode);          
            var status = this.getSaveContext().commit();
            if (status != Constants.STATUS_SAVING) {
                this.setSaving(false);
                this.getHeader().setProgressEnd();
                this.setLastSaved(status);
            }			
		},
                                
        onCancel: function(){
			var self = this;
			var artifact = this.getArtifact();
			var args = {
				title: Constants.getMessage("labelConfirmation"),
				message: Constants.getMessage("msgConfirmCancel"),
				yesCallback: function(){   
				    //reset to default template (if templated)
                    self.setTemplateId(null);
                    self.setTemplate(null);	
					//reset savecontext
					if (self.isEditable()) {
						self.getArtifactModel().discardChanges();
						self.getArtifactModel().getSaveContext().addParticipant(self);
					}	
					//re-initialize	         	                  
					self.initialize({
                    	isCopy: self.isCopy(),
						artifact: artifact
					});
					return true;
				},
				noCallback: function() {
					return false;
				}
			}
			var dialog = new YesNoDialog(args);
	        dialog.setSecondaryTitle(args.title);
	        dialog.open();
        },
		
		onPrintView: function() {
			if (this.supportsPrintView()) {
				window.location.hash = this.getPrintViewURI();
			}
		},
		
		onPDFView: function() {
			var identifier = this._printType + "/urn:com.ibm.rqm:" + this._printType +":"+ this.getArtifact().id;
			var locale = djConfig.locale;
			if (locale.length != 2 && locale != "en-us" && locale != "pt-br" && locale != "zh-hk" && locale != "zh-tw" && locale != "en-zz") {
				locale = locale.substring(0,2);
			}
			if (locale != "de" && locale != "es" && locale != "fr" && locale != "it" && locale != "ja" && locale != "ko" && locale != "pt-br" && locale != "zh" && locale != "zh-hk" && locale != "zh-tw"){
				locale = "en-us";
			}
			var data = "<printReq><mimeType>application/pdf</mimeType><fileExtension>pdf</fileExtension>";
			data += "<resources>";
			data += "<resource>";
			data += "<identifier>" + identifier + "</identifier>";
			data += "<transformArgs>";
			var url = window.location.href;
			url = url.replace(/&/g,"&amp;");
			data += "<originUrl>" + url + "</originUrl>";
			data += "<reqNumber>0</reqNumber>";
			data += "<componentType>STAND_ALONE</componentType>";
			data += "<containsTable>0</containsTable>";
			data += "<locale>" + locale + "</locale>";
			data += "<history>" + this._history + "</history>";
			data += "<recursive>" + this._recursion + "</recursive>";
			data += "<partialRecursion>" + this._partialRecursion + "</partialRecursion>";
			data += "</transformArgs>";
			data += "</resource>";
			data += "</resources></printReq>";
			if (printFormDiv == null){
			var printFormDiv = document.createElement("div");
			var printForm = document.createElement("form");
			printForm.setAttribute("name","printViewForm");
			printForm.setAttribute("action","/jazz/secure/service/com.ibm.rqm.integration.service.IIntegrationService/fop/" + this._projectAlias);
			printForm.setAttribute("method","POST");
			var printFormData = document.createElement("input");
			printFormData.setAttribute("name","printData");
			printFormData.setAttribute("type","hidden");
			printFormData.setAttribute("value","");
			printForm.appendChild(printFormData);
			printFormDiv.appendChild(printForm);
			document.body.appendChild(printFormDiv);}
			printFormData.value = data;
			printForm.submit();
		},
		
		printPdfNormal: function() {
			this._recursion = false;
			this._partialRecursion = false;
			this._history = false;
			this.onPDFView();
		},
		
		printPdfPartial: function() {
			this._recursion = true;
			this._partialRecursion = true;
			this._history = false;
			this.onPDFView();
		},
		
		printPdfDeep: function() {
			this._recursion = true;
			this._partialRecursion = false;
			this._history = false;
			this.onPDFView();
		},
		
		printPdfHistory: function() {
			this._recursion = false;
			this._partialRecursion = false;
			this._history = true;
			this.onPDFView();
		},
		
		_onLock: function() {
			//re-authenticate the user
			var esig = new ESignatureDialog({
				onSuccess: dojo.hitch(this, "_doLock"),
				onFailure: dojo.hitch(this, "_authFailed")
			});
		},
		
		//@Override if locking is supported
		lock: function(serviceResponseHandler) {
			this.getHeader().setProgressEnd();
			this.getHeader().setStatus("Inconsistent Editor Behavior", ViewHeaderLayout.WARNING, "X Model indicates locking supported but editor does not implement doLock()");
		},
		
		_doLock: function() {
			//successful esig; lock the artifact
			var action = this.getArtifact().locked ? Constants.getMessage("labelUnlocking") : Constants.getMessage("labelLocking");
			this.getHeader().setProgressStart(action + " " + this.getArtifactType() + "..."); 
			this.lock(new ServiceResponseHandler(this, "_lockSuccess", "_lockFailure"));
		},
		
		_lockSuccess: function(newArtifact) {
            //reset the editor
			this.getHeader().setProgressEnd();                  
            //reset savecontext
            this.getArtifactModel().discardChanges();   
            this.getArtifactModel().getSaveContext().addParticipant(this);  
            //re-initialize editor           
			this.setReadOnly(newArtifact.locked);                   
            this.initialize({
                isCopy: this.isCopy(),
                artifact: newArtifact
            });         
		},
		
		_lockFailure: function(e) {
            //locking server operation failed
            this.getHeader().setProgressEnd();
			var action = this.getArtifact().locked ? Constants.getMessage("labelUnlock") : Constants.getMessage("labelLock");
            this.getHeader().setStatus(Constants.getMessage("msgLockFailure", action, this.getArtifactType()), ViewHeaderLayout.ERROR, e.message);			
		},
		
        _authFailed: function(e) {
            //e-signature failed
			var action = this.getArtifact().locked ? Constants.getMessage("labelUnlock") : Constants.getMessage("labelLock");
			this.getHeader().setStatus(Constants.getMessage("msgEsigFailure"), ViewHeaderLayout.ERROR, 
                Constants.getMessage("msgEsigFailureDetail", action, this.getArtifactType(), e.message));
        },
		
		
		//@Override for SaveParticipant
        getAttributes: function(){
            var attributes = {};
			//add attributes from sections into main args
			var sectionsOrder = [];
            var sections = this.getSections(); 
			var secLen = sections ? sections.length : 0;
            for (var i = 0; i < secLen; i++) {
               var s = sections[i];
               var sectionAttributes = s.getAttributes();
               dojo.mixin(attributes, sectionAttributes);
			   sectionsOrder.push(s.getConfig().id);
            }            
			
			if (sectionsOrder) {
				//TODO send up an array instead of this comma delimited string
				attributes.sectionsOrder = sectionsOrder.join();
			}
            attributes.workItemsJsonString = this.getWorkItemsJSON();
            attributes.sectionJsonString = this.getSectionsJSON();	
            if (this._sectionsRemoved != null && this._sectionsRemoved.length > 0) {
                //TODO send up an array instead of this comma delimited string
                attributes.sectionsRemoved = this._sectionsRemoved.join();
            }
            // Inform the service to perform WIs approved check. The client
            // cannot authoratatively validate the state transition on its own.
            // Let the server validate and if failed, the save will failed and
            // the proper message will return.
            if(this.getStateValue() == Constants.STATETRANSITION_STATE_UNDERREVIEW && 
               EditorUtil.applyTransactionConstraint(Constants.STATETRANSITION_PREFERENCE_ALLWIAPPROVED)) {
                attributes.checkWIsApproved = true; 
            }                        
			return attributes;		
		},
		
		//@Abstract - override if necessary, but default behavior should be sufficient
        getWorkItemsJSON: function(){
            var workItemList = [];
            var sections = this.getSections(); 
			var secLen = sections ? sections.length : 0;
            for (var i = 0; i < secLen; i++) {
               var sectionWorkItemInfo = sections[i].getWorkItemInfo();
               if (sectionWorkItemInfo) {
                  workItemList.push(sectionWorkItemInfo);
               }
            }           
            return dojo.toJson(workItemList);
        },
        
        //@Abstract - override if necessary, but default behavior should be sufficient
		getSectionsJSON: function(){
            var sectionList = [];
            var sections = this.getSections(); 
			var secLen = sections ? sections.length : 0;
            for (var i = 0; i < secLen; i++) {			              
               var sectionInfo = sections[i].getSectionInfo();
               if (sectionInfo) {
                  sectionList.push(sectionInfo);
               }
            }           
            return dojo.toJson(sectionList);
        },		

        ////////////////////////////////////////////////////////////////////////////////////////////////////
        //                                   EDITOR VIEW HEADER API                                       //
        ////////////////////////////////////////////////////////////////////////////////////////////////////        
        createHeader: function(iconClass, contentNode, snapshotsNode) {
            var artifact = this.getArtifact();
			var args = {
                title: this.getHeaderTitle(),
                titleEditable: !(this.isReadOnly()),
                noTitleLabel: Constants.getMessage("labelNewPageNoTitlePrompt", this.getArtifactType()),
                subTitle: this.getHeaderSubTitle(),
                useDualContents: (!this.isPrintView() && contentNode && snapshotsNode),
                mainContentSelectedLabel: Constants.getMessage("labelArtifactOverview", this.getArtifactType()),
                mainContentDeselectedLabel: Constants.getMessage("labelArtifactOverview", this.getArtifactType()),               
                altContentSelectedLabel: Constants.getMessage("labelViewSnapshots"),
                altContentDeselectedLabel: Constants.getMessage("labelViewSnapshots"),
                typeLabel: this.getArtifactType(),
                iconClass: iconClass,
                summary: artifact ? artifact.description : ""
            }
                 
            this._header = new ViewHeaderLayout(args);    
            
            //create the save & cancel buttons          
            if (!this.isSnapshot()) {
				this._header.onTitleEdited = dojo.hitch(this, "_onTitleChange");
				//dojo.connect(this._header, "onTitleEdited", this, "_onChange");
                if (!this.isPrintView()) {
					if (this.supportsPrintView()) {
                        //this._printButton = this._header.addRightViewAction(Constants.getMessage("labelPrintView"), dojo.hitch(this, "onPrintView"));
						this._printButton = this._header.addLeftViewAction(Constants.getMessage("labelPrintView"), dojo.hitch(this, "onPrintView"), null, "print-icon-image");
					}
					// any artifact wishing to use the PDF button must have this._doesPrint set to true in its constructor
					// it must also set this._printType set to the way that the type appears in the feed
					if (this._doesPrint == true) {
					if(this._printsHistory == true && this._printsRecursive == true)
					{
						var printMenu = new dijit.Menu({ style: "display: none;"});
						var normalOption = new dijit.MenuItem({
							label: Constants.getMessage("printLabelCAR"),
							onClick: dojo.hitch(this, "printPdfNormal")
						});
						printMenu.addChild(normalOption);
						var partialOption = new dijit.MenuItem({
							label: Constants.getMessage("printLabelTPDR"),
							onClick: dojo.hitch(this, "printPdfPartial")
						});
						printMenu.addChild(partialOption);
						var deepOption = new dijit.MenuItem({
							label: Constants.getMessage("printLabelTPCR"),
							onClick: dojo.hitch(this, "printPdfDeep")
						});
						printMenu.addChild(deepOption);
						var historyOption = new dijit.MenuItem({
							label: Constants.getMessage("printLabelHistory"),
							onClick: dojo.hitch(this, "printPdfHistory")
						});
						printMenu.addChild(historyOption);
						this._menus.push(printMenu);
						this._pdfButton = this._header.addLeftViewAction(Constants.getMessage("labelPDFView"), dojo.hitch(this, "onPDFView"), null, "pdf-icon-image", printMenu);
					}
					else
					if (this._printsRecursive == true) {
						var printMenu = new dijit.Menu({ style: "display: none;"});
						var normalOption = new dijit.MenuItem({
							label: Constants.getMessage("printLabelCAR"),
							onClick: dojo.hitch(this, "printPdfNormal")
						});
						printMenu.addChild(normalOption);
						var partialOption = new dijit.MenuItem({
							label: Constants.getMessage("printLabelTPDR"),
							onClick: dojo.hitch(this, "printPdfPartial")
						});
						printMenu.addChild(partialOption);
						var deepOption = new dijit.MenuItem({
							label: Constants.getMessage("printLabelTPCR"),
							onClick: dojo.hitch(this, "printPdfDeep")
						});
						printMenu.addChild(deepOption);
						this._menus.push(printMenu);
						this._pdfButton = this._header.addLeftViewAction(Constants.getMessage("labelPDFView"), dojo.hitch(this, "onPDFView"), null, "pdf-icon-image", printMenu);
					} else
						if (this._printsHistory == true)
						{
							var printMenu = new dijit.Menu({ style: "display: none;"});
							var normalOption = new dijit.MenuItem({
								label: Constants.getMessage("labelShowNormalView"),
								onClick: dojo.hitch(this, "onPDFView")
							});
							printMenu.addChild(normalOption);
							
							var historyOption = new dijit.MenuItem({
								label: Constants.getMessage("printLabelHistory"),
								onClick: dojo.hitch(this, "printPdfHistory")
							});
							printMenu.addChild(historyOption);
							this._menus.push(printMenu);
						this._pdfButton = this._header.addLeftViewAction(Constants.getMessage("labelPDFView"), dojo.hitch(this, "onPDFView"), null, "pdf-icon-image", printMenu);
					} else {
						this._pdfButton = this._header.addLeftViewAction(Constants.getMessage("labelPDFView"), dojo.hitch(this, "onPDFView"), null, "pdf-icon-image");
					}
					}
					if (this.getArtifactModel().isLockSupported()) {
						this._lockButton = this._header.addLeftViewAction(Constants.getMessage("labelLock"), dojo.hitch(this, "_onLock"), null,  "unlock-icon-image");
						this._updateLockAction();
					}					
	                this._cancelButton = this._header.addRightViewAction(Constants.getMessage("labelDiscardChanges"), dojo.hitch(this, "onCancel"));
	                this._saveButton = this._header.addRightViewAction(Constants.getMessage("labelSave"), dojo.hitch(this, "onSave"));
				}
                this.updateSaveable();
				
            } else {
                var onCurrentRev = dojo.hitch(this, "_onCurrentRevisionClick");
                this._currentRevisionButton = this._header.addRightViewAction(Constants.getMessage("labelGotoCurrentRevision"), onCurrentRev);                
            }
            
            // if the user doesn't have permission to edit,
            // put up a warning in the header to give the user
            // a heads up.
            if(!this.isRolePermitsEdit()) {
                var text = Constants.getCommonMessage("statusNoEditPerm");
                var details = Constants.getCommonMessage("msgNoEditPermDetails", this.getArtifactType());
                this._header.setStatus(text, ViewHeaderLayout.WARNING, details);    
            }
            
            //append buttons if appropriate
            if (contentNode) {
                dojox.data.dom.removeChildren(contentNode);
                this._header.getContentNode().appendChild(contentNode);
                this.connect(this._header, "_selectMainContent", "_contentSelected");
            }
            if (snapshotsNode) {
                dojox.data.dom.removeChildren(contentNode);
                this._snapshotButton = this._header.addRightViewAction(Constants.getMessage("labelCreateNewSnapshot"), dojo.hitch(this, "onSnapshot"));
                this._header.getAltContentNode().appendChild(snapshotsNode);
                this.connect(this._header, "_selectAltContent", "_snapshotsSelected");
            }                
            
			this._contentSelected();
            return this._header;          
        },     
		
		updateContentSelectVisibility: function() {
            var header = this.getHeader();
            if (header && header.useDualContents) {
				dojo.style(this._header.contentSelectorNode, "display", (this.isNew() ? "none" : "inline"));
				dojo.style(this._header.typeNode, "display", (this.isNew() ? "inline" : "none"));
			}
		},
        
        updateHeader: function() {
            var header = this.getHeader();
            if (header) {         
                var artifact = this.getArtifact();       
                header.setTitle(this.getHeaderTitle());
                header.setSubTitle(this.getHeaderSubTitle());
                header.setSummary(artifact && artifact.description ? artifact.description : "");
				if (!this.isNew() && this._templateSelectContainer) {
					dojo.addClass(this._templateSelectContainer, "hidden");
				}
				this._updateLockAction();
				this.updateContentSelectVisibility();
            }             
        },
		
        _updateLockAction: function() {
			if (!this.getArtifactModel().isLockSupported() || this.isPrintView() || this.isSnapshot()) {
				return;
			};
			this._lockButton.addClass("hidden");
			
            //display the lock button if user has proper permissions to lock/unlock
			var artifact = this.getArtifact();
			var options = this.getArtifactOptions();
			var lockingEnabled = options && options.lockingEnabled;
            if (artifact && lockingEnabled && (this.isRolePermitsLock() || EditorUtil.isAdmin() || EditorUtil.isProjectAreaAdmin())) {
				if (artifact.locked != true) {
				    this._lockButton.removeClass("hidden");
				    this._lockButton.setLabel(Constants.getMessage("labelLock"));
					this._lockButton.addIconClass("unlock-icon-image");
					this._lockButton.removeIconClass("lock-icon-image");
				} else { 
                    var contributor = EditorUtil.getCurrentContributor();
					var type = this.getArtifactType();
					//can current contrib unlock ? only if they locked it or are an admin
					var lockedByMe = contributor.itemId == artifact.modifiedBy.itemId;
					if (lockedByMe || EditorUtil.isAdmin() || EditorUtil.isProjectAreaAdmin()) {
						this._lockButton.removeClass("hidden");
						this._lockButton.setLabel(Constants.getMessage("labelUnlock"));
	                    this._lockButton.addIconClass("lock-icon-image");
	                    this._lockButton.removeIconClass("unlock-icon-image");	
	                    this.getHeader().setStatus(Constants.getMessage("msgLocked", type), ViewHeaderLayout.INFO, 
	                         Constants.getMessage(lockedByMe ? "msgLockedByMe" : "msgLockedByOther" , type, artifact.modifiedBy.name));
					} else {
						//otherwise just display that its locked
                        this.getHeader().setStatus(Constants.getMessage("msgLocked", type), ViewHeaderLayout.INFO, 
                             Constants.getMessage("msgLockedByOther", type, artifact.modifiedBy.name));						
					}
                }
            }		
		},		
        
        getHeader: function() {
            return this._header;
        },
        
        getHeaderTitle: function() {
            var title = "";
            var artifact = this.getArtifact(); 
			if (this.isNew() && !this.isCopy()) {
//                title = new String(Constants.NEW_PAGE_TITLE);
//                title = title.replace(/_type/, this.getArtifactType());
    
            } else if (artifact) {
	            if (artifact.snapshotInfo) {
					title = artifact.name + " (" + artifact.snapshotInfo.name + ")";
				} else if (artifact.archived) {
					title = artifact.name + " (" + Constants.getMessage("labelDeleted") + ")";
				} else {
					title = artifact.name;
				}
            }
            return title;
        },
        
        getHeaderSubTitle: function() {
            var subTitle = "";
            var artifact = this.getArtifact();    
            if (artifact && artifact.snapshotInfo != null) {
                subTitle = Constants.getMessage("labelArtifactSnapshot", artifact.snapshotInfo.name);
            }
            return subTitle;
        },        
		
        addHeaderButton: function(label, iconClass, onClick) {            
            var arg = {
                label: label,
                showLabel: false,
                iconClass: iconClass,
                onClick: onClick
            };
            var button = new com.ibm.asq.common.web.ui.internal.widgets.Button(arg);
            button.callback = onClick;
            button.setDisabled(false);
            this._header.getRightActionsContainer().appendChild(button.domNode);
            return button;          
        },		     
		
		addHeaderDropDownButton: function(label, iconClass, onClick, dropDown) {            
            var arg = {
                label: label,
                showLabel: false,
                iconClass: iconClass,
                dropDown: dropDown
            };
            var button = new dijit.form.DropDownButton(arg);
            button.callback = onClick;
            button.setDisabled(false);
            this._header.getRightActionsContainer().appendChild(button.domNode);
            return button;
        },
        setState: function(state) {

        	//Error check.  If we try to set the state to null then fall back to the default state.
        	//There was a bug with Chrome and IE that was causing null state.  This handles any more of those types of bugs
        	if (state == null || state == "")
        		state = Constants.STATETRANSITION_STATE_DRAFT;
        		
			this._stateValue = state;
			this.previousState = this.getStateValue();
			
			this._state = EditorUtil.getStateNameFromID(state);
			
			if (this.isReadOnly() || !this.isRolePermitsEdit()) {
				var stateLabel = document.createElement("span");
				stateLabel.innerHTML = Constants.getMessage("labelStateLabel");
				
				this._stateTxt = document.createTextNode(this._state);
												
				//Add the state to the ui
				var attributeEntry = this.getHeader().addInfoAttribute(stateLabel, this._stateTxt);
				attributeEntry.style.minWidth = "150px";
			}
			else {
				//If not read only, create the action combo now so it stays
				//next to the state text field in the ui

				//Create the actions label
				var actionLabel = document.createElement("label");
				actionLabel.setAttribute("for", "action-select");
				actionLabel.innerHTML = Constants.getMessage("LabelAction");
				
				//Create the actions combo box
				this._action = document.createElement("select");
				this._action.id = "action-select";
				this._action.name = "action-select";
				
				//Add the change handler.
				//The handler will need to update the state field and reload the combo box based on the actions available in the new current state
				this.connect(this._action, "onchange", "_onActionChange");
				

				

				//Add in the state text field
				var img = document.createElement("img");
				img.src = dojo.moduleUrl("com.ibm.asq.common.web", "ui/internal/images/icons/obj16/qm_rtarrow.gif");
				dojo.addClass(img, "attributes-entry-label");
				img.style.marginRight = "1px";
                img.style.verticalAlign = "text-top";
				
				var stateLabel = document.createElement("span");
				stateLabel.innerHTML = Constants.getMessage("labelStateLabel");
				
				this._stateTxt = document.createTextNode(this._state);
				
                //Add the combo box to the ui
                var attributeEntry = this.getHeader().addInfoAttribute(actionLabel, this._action);
                attributeEntry.style.minWidth = "200px";
                
				//Add the state to the ui
				var attributeEntry = this.getHeader().addInfoAttribute(stateLabel, this._stateTxt);	
				attributeEntry.insertBefore(img, attributeEntry.firstChild);
				attributeEntry.style.minWidth = "150px";							
				
				//MFV This is a HACK
				//The loading of states/actions/transitions should be a via a single service method call but because
				//of where we are in the project I had to take the faster route.  So, behind the scenes this call
				//to initArtifactStates will make numerous service calls to load all the data.
				//so in order to ensure the Actions combo box is filled after all the data is loaded we pass 
				//that method in here and it will get called when all the data is loaded.
	 			EditorUtil.initArtifactStates(dojo.hitch(this, "setActions"));
			}
        },
        
        getState: function() {
            return this._state;  
        },
        
        getStateValue: function() {
            return this._stateValue;
        },
		
		getActionValue: function()
		{
			return this._action.value;
		},
		
		setActions: function()
		{
			var currentState = this.getStateValue();
			
			//Load the actions combo box with the appropriate actions
			//The actions are based on the current state so pass that into the method
   			EditorUtil.loadArtifactActions(this._action, currentState);			
			
			this.updateSaveable();			
		},
		
		//Handle the user changing the actions
		_onActionChange: function()
		{
			var artifactState = this.getArtifact() == null ? Constants.STATETRANSITION_STATE_DRAFT : this.getArtifact().state;
			//If the artifact state is bad, use DRAFT.  This should be expanded to validate the state (not just against null and "" in 2.0)
			if (artifactState == null || artifactState == "")
				artifactState = Constants.STATETRANSITION_STATE_DRAFT;
	        
            var isValid = this._validateStateChange(artifactState, this.getActionValue());	
			if (isValid == Constants.EDITORSECTION_STATE_VALIDATION_FETCHING) {
                // We're going to fetch certain data for the validation. Disable
                // the action combo and put up a working message.
                this._header.setStatus(WorkingLabel, ViewHeaderLayout.INFO);
                this._action.disabled = true;
            }
            else {
                // we have all of the validations, we can just 
                // present it.
                this._handleStateChangeCheckCallback(null);
            }
		},

        _handleStateChangeCheckCallback: function(message)
        {
            if(message && dojo.isString(message))
                this.stateValidateMessages.push(message);
                
            this.waitForCheck--;
            if(this.waitForCheck <= 0) {
                this.getHeader().clearStatus();
                this._action.disabled = false;
                
                // there are validation errors, disallow the state change action
                // and present the messages.
                if (this.stateValidateMessages.length > 0) {
                    var errorStr = this.stateValidateMessages.join("<br />");
                    this._header.setStatus(Constants.getMessage("cantapplyaction", this.pendingActionName), ViewHeaderLayout.WARNING, errorStr);
                    this._resetActionCombo();                    
                }
                else {
                    // no validation error, allow the state to change.
                    this._changeState(this.artifactState, this.getActionValue());
                }
                // we're done collecting results, delete temp attributes.
                delete this.stateValidateMessages;
                delete this.waitForCheck;
                delete this.pendingActionName;
                delete this.artifactState;
            }
        },

        // Summary:
        //    Dalegates the validations to sections that care about state changes.
        //    Culmulates all of the messages that failed the validations from the
        //    sections. Certain section might need not have the data at hand to do
        //    the validation and would need to fetch it. In those cases, we'll have'
        //    wait for their results before we allow/disallow the state change.         
		_validateStateChange: function(currentState, action)
		{
            if(this.waitForCheck) {
                return;
            }
			var nextState = EditorUtil.getNextState(currentState, action);
			var actionName = EditorUtil.getActionNameFromID(action);
			var sections = this.getSections();
            var section_len = sections.length;
            var callback = dojo.hitch(this, "_handleStateChangeCheckCallback");
            
            this.waitForCheck = 0;
            this.stateValidateMessages = [];
            this.pendingActionName = actionName;
            this.artifactState = currentState;
            
            for (var i = 0; i < section_len; i++) {
				var section = sections[i];
				if (section["validateStateTransition"]) {
					var errorStr = section.validateStateTransition(currentState, action, nextState, this.isEditable(), callback);   /*need editble state in case we have to initialize the section*/

                    // There's a returned value, if it's fetching, increment the counter,
                    // or the valiation already produced a message, we'll store 
                    // that.
					if (errorStr != null) {
                        if (errorStr == Constants.EDITORSECTION_STATE_VALIDATION_FETCHING) {
                            this.waitForCheck++;
                        }
                        else {
                            this.stateValidateMessages.push(errorStr);
                        }
					}
				}
			}
            if(this.waitForCheck > 0) {
                return Constants.EDITORSECTION_STATE_VALIDATION_FETCHING;
            }
            return null;       
			//Now check the Work Item status to be sure we can change to the next state
			//Only applies to the Ready For Review action
			//Note, we could push this check into the individual sections to which the WI applies.
			//	However, that could mean needlessly initializing ALL the sections.  This will be faster.
            
            // WI 6349 - Remove this client side validation. We cannot authoratatively
            // validates this, since the work item states can be modified, etc. Let the server
            // do this validation. 
            /*
			if (action == Constants.STATETRANSITION_ACTION_READYFORREVIEW && EditorUtil.applyTransactionConstraint(Constants.STATETRANSITION_PREFERENCE_ALLWIAPPROVED)) 			
				if (this._artifact && this._artifact.workItems && this._artifact.workItems.length > 0)
				{
					var workItems = this._artifact.workItems;
					for (var i = 0; i < workItems.length; i++)
					{
						var workItem = workItems[i].workItem;
						//If it is an "Task-Quality" work item and the state is not resoved "3" then disallow the transition
						//Note that the authoring string and ID should NOT be hard coded here but I didn't find definitions for these anywhere in RQM.
						if (workItem.workItemType.id == "authoring" && workItem.state.id != "authoring.s3") 
						{
							this._header.setStatus(Constants.getMessage("cantapplyaction", actionName), ViewHeaderLayout.WARNING, Constants.getMessage("msgNotReadyForReviewWIsNotApproved", this._artifactType, workItem.id, workItem.summary.content));
							return false;
						}
					}					
				}
		      */
		},
		
		_changeState: function(currentState, action)
		{
			//If the user selected the change state prompt then just return
			//This should not happen since we remove the state change prompt below
			if (action == "NULL") 
				return;
 
			//Remember that we have changed state.
			//This used to help decide whether the save button should be enabled
			this.setStateChanged(true);
			
			//Do change stuff like marking the artifact as dirty
			this._onChange();
			
			//Update the save and discard buttons.
			this.updateSaveable();
			
			//If the action is to return to the previous state	
			var actionLen = this._action.length;
			if (action == currentState) {
				//Remove the "Return to State" Action				
				for (var i = 0; i < actionLen; i++)
					if (this._action.options[i].value == currentState) {
						this._action.remove(i);
						break;
					}				

				//add "select action" and select it
				var option = new Option(Constants.getMessage("labelSelectAction"), "NULL");  
				option.style.color = "gray";
				SelectUtility.add(this._action, option);
				SelectUtility.select(this._action, "NULL");
				
				//Set the state to be the previous state
				this._stateValue = currentState;
			}
			else{  //A "real" action other than return to previous state
					// remove "select action" if needed
					for (var i = 0; i < actionLen; i++) {
						if (this._action.options[i].value == "NULL") {
							this._action.remove(i);
							break;
						}
					}
					
					// add "return to <last state>" if needed
					if (this._action.options[this._action.options.length - 1].value != currentState) {
						var option = new Option(Constants.getMessage("com.ibm.rqm.planning.common.return", Constants.getMessage(this._stateValue)), this._stateValue);
						SelectUtility.add(this._action, option);
				}				
				
				//Determine the next state to show in the artifact
				this.previousState = this.getStateValue();
				this._stateValue = EditorUtil.getNextState(currentState, action);
			}
 
 			//update next state
            this._stateTxt.nodeValue = EditorUtil.getStateNameFromID(this._stateValue);
		},
		
		//Load the new actions based on the current state
        _updateState: function()
        {
            //Reload the combo box with the actions for this new state
			if (!this.isReadOnly()) {
				EditorUtil.loadArtifactActions(this._action, this.getStateValue(), null);
			}
        },
        
		_resetActionCombo: function()
		{
			this._action.options[0].selected = true;
		},		
		
        setOriginator: function(originator) {
            if (originator == null && (this.isNew() || this.isCopy())) {
                originator = EditorUtil.getCurrentContributor().name;
            }
						
            var originatorlabel = document.createElement("span");
            originatorlabel.innerHTML = Constants.getMessage("labeloriginatorLabel");
            
            this._originator = document.createTextNode(originator);
            this._originatorContainer = this.getHeader().addInfoAttribute(originatorlabel, this._originator);
        },
        
        getOriginator: function() {
            return this._originator;  
        },
        
        getOriginatorValue: function() {
            return this._originator.textContent;  
        },
        
        setOwner: function(owner) {
            var ownerlabel = document.createElement("label");
            ownerlabel.innerHTML = Constants.getMessage("labelowner");
			ownerlabel.setAttribute("for", "owner-select");
            
            if (this.isReadOnly()) {
                this._owner = document.createElement("span");
				this._owner.innerHTML = owner;
            } else {
                this._owner = document.createElement("select");
				this._owner.id = "owner-select";
				this._owner.name = "owner-select";
				this.connect(this._owner, "onchange", "_onChange");
                EditorUtil.initContributors(this._owner, owner);
            }           

            this.getHeader().addInfoAttribute(ownerlabel, this._owner);
        },
        
        getOwner: function() {
            return this._owner;  
        },
        
        getOwnerValue: function() {
            if (this.isReadOnly()) {
                return this._owner.textContent;
            } else {
                return this._owner.value;
            }
        },
        
        setLastSaved: function(status, error) {   
            var st_code = -1; // none, no status icon
            var text = "";
            var detail_msg = null;
            
            // don't change the status message if this is not editable.                                 
            if (!this.isRolePermitsEdit()) {
                return;
            }
			switch(status) {				
	            case Constants.STATUS_SUCCESS: 
	                st_code = ViewHeaderLayout.SUCCESS;
	                text = Constants.getCommonMessage("statusSaveSuccess", EditorUtil.getTimeString());
					break;  
                case Constants.STATUS_FAILURE:
	                if(error && error.message && error.message.toLowerCase().indexOf('license') > -1) {
	                    var licenseMsg = Constants.getCommonMessage("serverLicenseErrMsg");
	                    EditorUtil.showServerErrorMessage(licenseMsg);
	                }
	                st_code = ViewHeaderLayout.ERROR;
	                text = Constants.getCommonMessage("statusSaveFail", EditorUtil.getTimeString());  
	                
	                if(error && error.message) {
	                    detail_msg = "<b>" + Constants.getCommonMessage("labelError") + "</b><br/>" + error.message;
	                }
					break;
                case Constants.STATUS_SAVING:
	                st_code = ViewHeaderLayout.INFO;
	                text = Constants.getCommonMessage("statusSaving");
		            break;
	            case Constants.STATUS_NEW:
	                st_code = ViewHeaderLayout.INFO;
	                text = Constants.getCommonMessage("statusNewNeedSave");
                    break;	               
	            case Constants.STATUS_DIRTY:
	                st_code = ViewHeaderLayout.INFO;
	                text = Constants.getCommonMessage("statusDirty");
                    break;
                case Constants.STATUS_NOT_NECESSARY:
                    st_code = ViewHeaderLayout.SUCCESS;
                    text = Constants.getCommonMessage("statusSaveNotNecessary");
                    break;									                   
			}
            
            if(st_code > -1)
                this.getHeader().setStatus(text, st_code, detail_msg);
            else
                this.getHeader().clearStatus();
        },
		
        updateSaveable: function() {
            if (this._saveButton) {
                this._saveButton.setDisabled(!this._isSaveable());
            }
            if (this._cancelButton) {
                this._cancelButton.setDisabled(!this._isDiscardable());
            }
			if (this._printButton) {
				this._printButton.setDisabled((this.isSaving() || this.isLoading() || this.isNew()));
			}
			if (this._pdfButton) {
				this._pdfButton.setDisabled((this.isSaving() || this.isLoading() || this.isNew() || this._isSaveable()));
			}
        },		
		
		_isSaveable: function() {
			//once dirty detection is fully implemented, this should check this.isDirty()
			//to disallow saves of non-dirty items for editors using save context (see RQM WorkItem #5222)
			if (this.getSaveContext() != null && !this.isDirty()) {
                return false;			 	
			}
			var canEdit = (this.isRolePermitsEdit() && !this.isReadOnly()) || this._hasEditableSections();
			var saveable = (canEdit && !this.isSaving() && !this.isLoading() && this.isSaveableState());
			//console.debug(this.declaredClass + ": _isSaveable: canEdit: " + canEdit + "; saveable: " + saveable);
			return saveable; 
			
		},
		
		_isDiscardable: function() {
			if (this.getSaveContext() != null && !this.isDirty()) {
                return false;			 	
			}
			var canEdit = (this.isRolePermitsEdit() && !this.isReadOnly()) || this._hasEditableSections();
			var discardable = (canEdit && !this.isSaving() && !this.isLoading());
			return discardable;
		},
		
		_hasEditableSections: function() {
			var sections = this.getSections() || []; 
			var secLen = sections.length;
            for (var i = 0; i < secLen; i++) {
               	if (sections[i].isEditable()) {
					return true;
			   	}
            }
			return false;	
		},
        ////////////////////////////////////////////////////////////////////////////////////////////////////
        //                                   EDITOR VIEW HEADER INTERNAL                                  //
        ////////////////////////////////////////////////////////////////////////////////////////////////////        
        _contentSelected: function() {
            if (this._pdfButton) {
                this._pdfButton.removeClass("hidden");
            }
            if (this._printButton) {
                this._printButton.removeClass("hidden");
            }
            if (this._saveButton && this._cancelButton) {
                this._saveButton.removeClass("hidden");
                this._cancelButton.removeClass("hidden");
            }
            if (this._currentRevisionButton) {
                this._currentRevisionButton.removeClass("hidden");
            }
            if (this._snapshotButton) {                
                this._snapshotButton.addClass("hidden");
            }
            this._updateLockAction();

            //show the infoNode if necessary            
            var infoNode = this.getHeader().getInfoAttributesNode();
            if (infoNode && dojo.hasClass(infoNode, "hidden")) {
                dojo.removeClass(infoNode, "hidden");
            }  
            //show the summaryNode if necessary   
            var summaryNode = this.getHeader().getSummaryNode();
            if (summaryNode && dojo.hasClass(summaryNode, "hidden")) {
                dojo.removeClass(summaryNode, "hidden");
            }
			//show the table of contents if necessary
			if (this._tableOfContentsNode && dojo.hasClass(this._tableOfContentsNode, "hidden"))      
				dojo.removeClass(this._tableOfContentsNode, "hidden");
			
			// restore cshelp id that was temporarily replaced
			// by snapshot help id
			var originalCSHelpId = this.getCSHelpId();
			this.setCSHelpId(originalCSHelpId);
            
            // restore the no edit permisssion status.
            if(!this.isRolePermitsEdit()) {
                var text = Constants.getCommonMessage("statusNoEditPerm");
                var details = Constants.getCommonMessage("msgNoEditPermDetails", this.getArtifactType());
                this._header.setStatus(text, ViewHeaderLayout.WARNING, details);    
            }
            else if(!this.isRolePermitsArchive()) {
                this._header.clearStatus();
            }           
        },
        
        _snapshotsSelected: function() {
			this.refreshSnapshots();
			if (this._printButton) {
                this._printButton.addClass("hidden");
            }
            if (this._pdfButton) {
                this._pdfButton.addClass("hidden");
            }
            if (this._saveButton && this._cancelButton) {
                this._saveButton.addClass("hidden");
                this._cancelButton.addClass("hidden");
            }
            if (!this.isSnapshot() && !this.isArchived() && this._currentRevisionButton) {
                this._currentRevisionButton.addClass("hidden");
            }
			
            if (this._lockButton) {
                this._lockButton.addClass("hidden");
            }
						
            if (!this.isSnapshot() && this._snapshotButton) {                
                this._snapshotButton.removeClass("hidden");
                
                if(!this.isRolePermitsArchive()) {
                    this._snapshotButton.setDisabled(true);
                    var text = Constants.getCommonMessage("statusNoArchivePerm");
                    var details = Constants.getCommonMessage("msgNoArchivePermDetails", this.getArtifactType());
                    this._header.setStatus(text, ViewHeaderLayout.WARNING, details);    
                }
            } 
            //hide the infoNode if necessary
            var infoNode = this.getHeader().getInfoAttributesNode();
            if (infoNode && !dojo.hasClass(infoNode, "hidden")) {
                dojo.addClass(infoNode, "hidden");
            } 
            //hide the summaryNode if necessary   
            var summaryNode = this.getHeader().getSummaryNode();
            if (summaryNode && !dojo.hasClass(summaryNode, "hidden")) {
                dojo.addClass(summaryNode, "hidden");
            }
			//hide the table of contents if necessary
			if (this._tableOfContentsNode && !dojo.hasClass(this._tableOfContentsNode, "hidden"))      
				dojo.addClass(this._tableOfContentsNode, "hidden");

            this.getHeader().setCSHelpId("rqm_snapshots.html");
        },
                                             
        ////////////////////////////////////////////////////////////////////////////////////////////////////
        //                                   PLUGGABLE SECTION SUPPORT                                    //
        ////////////////////////////////////////////////////////////////////////////////////////////////////
        getSections: function(){
            return this._sections;
        },
        
        getSection: function(id) {
			var secLen = this._sections ? this._sections.length : 0;
            for (var i = 0; i < secLen; i++) {
				var s = this._sections[i];
                if (s.getConfig().id == id) return s;
                
            }
            return null;
        },
        
        getSectionGroup: function(id) {
			var secLen = this._sections ? this._sections.length : 0;
            for (var i = 0; i < secLen; i++) {
				var s = this._sections[i];
                var config = s.getConfig();
                if (config.sections && config.id == id) {
                    return s;
                }
            }
            return null;
        },              
        
        loadSections: function(/* REQUIRED */ sectionsNode, /* OPTIONAL */ tocNode){
            this._getTemplatedComplete = false;
			// save the sections & table of contents node
			this._sectionsNode = sectionsNode;
			this._tocNode = tocNode;

            if (this.getTemplate() != null) {
				this._loadSectionModules();
			
			} else {			
				//get the template for this artifact
				var self = this;
				var handler = {
					success: function(template){
						//set the template, and then display sections
                        self._getTemplatedComplete = true;
                        self._loadSectionsComplete = false;
						self.setTemplate(template);
						self._loadSectionModules();						
					},
					failure: function(e){
						console.error("Unable to load template: (" + self.getTemplateId() + ")")
                        self._getTemplatedComplete = true;
                        self.setLoadingArtifactComplete();
					}
				}
				
				//get the specified template, or the default template if none specified
				var srh = new ServiceResponseHandler(handler, "success", "failure");
				if (!this.getTemplateId()) {
					TemplateClient.getDefaultTemplate(srh, this.getEditorId());
				} else {
					TemplateClient.getTemplate(srh, {itemId: this.getTemplateId()});										
				}
			}
			
        },		
		
		_loadSectionModules: function() {
            var editorConfig = this._editorConfig;            
            if (this._sectionsLoaded) {
                //sections have already been loaded, just show them
                this._displaySections();
                this._loadSectionsComplete = true;
                this.setLoadingArtifactComplete();
            } else {
                //dynamically load contributed section widgets
                var modulesToLoad = [];
				var secLen = editorConfig.sections.length
                for (var i = 0; i < secLen; i++) {
                    var jsClass = editorConfig.sections[i].jsClass;
					if (jsClass && dojo.getObject(jsClass) == null) {
                        modulesToLoad.push(jsClass);
                    }
                }
				if (modulesToLoad.length > 0) {
					this._loadStarted = new Date().getTime();
	                var callback = dojo.hitch(this, "_modulesLoaded", modulesToLoad);
	                jazz.core.loader.batch_load_async(modulesToLoad, callback);					
				} else {
					//console.debug(this.declaredClass + "._loadSectionModules: No section modules require loading...");
					this._displaySections();
                    this._loadSectionsComplete = true;
                    this.setLoadingArtifactComplete();
				}
            }			
		},
		
		_modulesLoaded: function(modules) {
			//log any errors (modules that were to be loaded but are not available)
			var failures = [];
			var modLen = dojo.isArray(modules) ? modules.length : 0;
			for (var i = 0; i < modLen; i++) {
				var mod = modules[i];
				if (dojo.getObject(mod) == null) {
					failures.push(mod); 
				}
			}  
			//log errors or success
			var elapsed = new Date().getTime() - this._loadStarted;
            var message = this.declaredClass + "._modulesLoaded: ";
            message += "Contributed module load Completed (in " + elapsed + "ms): ";
            message += "Total/Loaded/Failed: [" + modLen + "/" + (modLen - failures.length) + "/" + failures.length + "]";
            console.info(message);		
			
			this._displaySections();	
            this._loadSectionsComplete = true;
            this.setLoadingArtifactComplete();
		},
        
        _displaySections: function() {                                   			   
            //create and append the section widgets to the editor           
            var sectionDefinitions = this._getDisplayable();
            var defLen = sectionDefinitions ? sectionDefinitions.length : 0;
			
            // Ensure that we clean up any previously created sections widgets
            // before we unload them and recreate the sections.
            this.cleanUpSectionsBeforeReload();
            
			dojox.data.dom.removeChildren(this._sectionsNode);     
            this._sections = [];       
            for (var i = 0; i < defLen; i++) {
                this.appendSection(sectionDefinitions[i], i == 0);
            }     
			//show the table of contents, if the implementor has specified a domNode for it
			if (this._tocNode != null) {
				if (!this.getTableOfContents()) {
					this.loadTableOfContents(this._tocNode);
				} else {
					this.updateTableOfContents(true);
				}
			} else {
				//if no table of contents, must show all sections
				this.setSectionDisplayMode(true);
			}
			// create skip to TOC link
			var div = document.createElement("div");
			div.style.position = "absolute";
			div.style.display = "inline";
			div.style.visibility = "hidden";
			
			var skipToTOC = document.createElement("a");
			skipToTOC.innerHTML = "Skip to table of content";
			skipToTOC.href = "javascript:{}";
			this.connect(skipToTOC, "onclick", "_skipToTOC");
 
 			div.appendChild(skipToTOC);
			this._header.domNode.appendChild(div);
		},
		
		_skipToTOC: function()
		{
			var hrefs = dojo.query("a", this._tocWidget.domNode);
			if (hrefs.length > 0){
				dijit.focus(hrefs[0]);
			} 
		},
		
		_getDisplayable: function() {
            //which set of sections is the display based on
			var sections = [];		
			var artifact = this.getArtifact();	
			//for new (& not copied) artifacts or artifacts that do not contain sections, 
			//load the section defs from the template / editor config		
			if ((this.isNew() && !this.isCopy()) || (artifact && !artifact.sections)) {
				var editor = this._editorConfig;
				if (editor.isTemplated) {
					//for new arifacts, use the sections defined by the template
					sections = this.getTemplate().sections;
				} else {
					return editor.sections;
				}
			} else {
				//for existing arifacts, use the sections persisted on the artifact
				sections = artifact.sections;
			}

            //get the definitions for each from the EditorRegistry
            var definitions = [];
			var secLen = sections ? sections.length : 0;
            for (var i = 0; i < secLen; i++) {
				var section = sections[i];
                var def = this._editorRegistry.getSection(this, section.id);
				if (def != null) {
					definitions.push(def);
				} else { 
				    //but allow for custom sections
					definitions.push(section);
				}
            }
			return definitions;
		},
       
        appendSection: function(sectionConfig, expanded) {
            
            //create the widget for this section
            var sectionImpl = this._createSectionProvider(sectionConfig);
			if (sectionImpl == null) {
				return;
			}
            var sectionContainer = this._createSectionWidget(sectionImpl);
            sectionImpl.setContainer(sectionContainer);
            
            this._sections[this._sections.length] = sectionImpl;            
            if (this._isTopLevelSection(sectionConfig)) {
                var bookmark = document.createElement("div");
                bookmark.id = sectionConfig.id;
                this._sectionsNode.appendChild(bookmark);
                this._sectionsNode.appendChild(sectionImpl.getContainer().domNode);
                if (expanded && sectionContainer) {
                    sectionContainer._onTitleClick();
                }
            } else {
                var sectionGroup = this.getSectionGroup(sectionConfig.groupId);
                sectionGroup.addSection(sectionImpl);
            }
			return sectionImpl;
        },
        
        removeSection: function(sectionId) {
			var self = this;
			var args = {
				title: Constants.getMessage("labelConfirmation"),
				message: Constants.getMessage("msgConfirmRemoveSection"),
				yesCallback: function(){
					 //set the section to not visible
            		var section = self.getSection(sectionId);
            		section.setVisible(false);
					
            		//add to the list to be removed
            		self._sectionsRemoved.push(sectionId);
            
            		//update the table of contents
            		self.updateTableOfContents(true); 
					self.setDirty(true);
					return true;          
				},
				noCallback: function() {
					return false;
				}
			}
			var dialog = new YesNoDialog(args);
	        dialog.setSecondaryTitle(args.title);
	        dialog.open();
        },
        
        updateSections: function(){
            var sections = this.getSections();
			var secLen = sections ? sections.length : 0;
            for (var i = 0; i < secLen; i++) {
                var section = sections[i];
                if (section["saveFinished"]) {
                    section.saveFinished();
                    this._updateEditorSection(section);
                } else {
                    console.warn("Section Widget DOES NOT extend AbstractArtifactEditorSection! (" + section.id + ")")
                }
            }
        },
        
        loadTableOfContents: function(/* REQUIRED */ domNode) {
			var self = this;
			var displayTableOfContents =  function(showAll){
				//table of contents
				self._tocNode = domNode;
	            var entries = self.getTocEntries();
	            var args = {
	                entries: entries,
	                showAll: showAll ? showAll : false,
	                showAllCallback: dojo.hitch(self, "setSectionDisplayMode")
	            }
	            self._tocWidget = new DirectoryPane(args);
	            dojox.data.dom.removeChildren(domNode);
	            //add new section button
	            if (self.isEditable() && self._editorConfig.isTemplated) {
	                self._addManageSectionsButton(domNode);
	            }
				
				domNode.appendChild(self._tocWidget.domNode);
				self._tocWidget.selectEntry(0);   //select/highlight the first section
				self._resizeMaxCount = 10;
                self._doneResizeTOC = false;
				self._resizeTOC();
			};
			
			var contextObject = {
				callBack: function(userPreference){
					if(userPreference && userPreference.key && userPreference.value && userPreference.value == "TOCAllSection"){
						displayTableOfContents(true);
					}else{
						displayTableOfContents(false);
					}
				}
			};
			PreferenceClient.getCurrentUserPreferences(contextObject, contextObject.callBack, Constants.USER_UI_CUSTOMISE_ACTIONBAR_TOC_CATEGORY.key);  
        },
        
        _resizeTOC: function() {
            // make sure resize is only perform once
            if (!this._doneResizeTOC) {
                if (dojo.isDescendant(this._tocWidget.focusNode, document)) {
                    // check if the HTML document object is the parent which means
                    // are we added to the DOM tree yet or is the dimension set yet
                    var totalWidth = this._tocWidget.focusNode.scrollWidth;
                    // minimum width is 140px or customized locale preferred width
                    if (totalWidth > this.tocWidth) {
                        // include 16px for the "pin" image and 5px each on both sides of the round corner header
                        this._tableOfContentsNode.style.width = (totalWidth + 26) + "px";
                        this._tocWidget.domNode.style.width = (totalWidth + 26) + "px";
                    } else {
                        this._tableOfContentsNode.style.width = this.tocWidth + "px";
                        this._tocWidget.domNode.style.width = this.tocWidth + "px";
                    }
                    
                    // load the TOC entries after we've added to the dom tree
                    // This ensures that entries are wrapped correctly based on
                    // the proper size of the TOC.
                    this.updateTableOfContents(true);
                    
                    // resize once and only once
                    this._doneResizeTOC = true;
                } else {
                    // not yet added to the DOM tree, try again in half a second
                    // unless it exceed the max count
                    if (this._resizeMaxCount && (this._resizeMaxCount-- > 0)) {
                        setTimeout(dojo.hitch(this, "_resizeTOC"), 500);
                    }
                }
            }
        },
    
        updateTableOfContents: function(selectFirst) {
            var tocWidget = this.getTableOfContents();
            var entries = this.getTocEntries();
            tocWidget.setEntries(entries);
            if (!selectFirst && tocWidget.selectedIndex && tocWidget.selectedIndex < entries.length ) {
                tocWidget.selectEntry(tocWidget.selectedIndex);
            } else {
				var hash = window.location.hash;
				var matches = /[\#&]sectionId=([^&]+)/.exec(hash);
				if (matches && matches.length>1) {
					var sectionId = matches[1];
	        		tocWidget.selectEntryByTag(sectionId);
				} else {
	                tocWidget.selectEntry(0);
				}
            }            
        },
        
        _onUpdateTabUri: function(oldUri, newUri){
			// remove sectionid from current id if present
			var currentUri = this._uri.replace(/&?sectionId=[^&]+/,"");
        	if (newUri!=null && newUri.indexOf(currentUri)==0) {
	            var tocWidget = this.getTableOfContents();
				var matches = /&?sectionId=([^&]+)/.exec(newUri);
				if (matches && matches.length>1) {
					var sectionId = matches[1];
					tocWidget.selectEntryByTag(sectionId);
				}
        	}
        },
        
		getTocEntries: function() {
            var entries = [];
			//if no sections, the editor is loading...show appropriate entry
			if (!this._sections || this._sections.length == 0) {
                entries.push({
                    title: Constants.getMessage("labelLoading"),
                    callback: function(){}
                });	
				return entries;			
			}
			
			//create entries for each section, callback will set focus to the entry's node 
			var secLen = this._sections ? this._sections.length : 0;
            for (var i = 0; i < secLen; i++) {
                var section = this._sections[i];
                var sectionConfig = section.getConfig();
                if (this._isTopLevelSection(sectionConfig) && section.isVisible()) {
                    entries.push({
                        title: section.getContainer() ? section.getContainer().getDisplayTitle() : section.getDisplayTitle(),
                        tag: sectionConfig.id,
                        node: section.getContainer().domNode,
                        callback: dojo.hitch(this, "setSectionFocus", sectionConfig.id)
                    });
                }
            }
			return entries;
		},
        
        getTableOfContents: function() {        
            return this._tocWidget;
        },
        
        setSectionFocus: function(sectionId) {
            //set display mode
            this.setSectionDisplayMode(this._tocWidget.showAll, sectionId);
            
            //expand the selected section, if necessary
            var section = this.getSection(sectionId);            
            var container = section.getContainer();            
            if (container && !container.open) {
                container._onTitleClick();
            }
			
			if( container )
			{
				setTimeout( function() {
                    container.setDisplayTitle( container.getDisplayTitle() );
                    
                    // call the section's activated method for any processing
                    // when it's being made active.
                    if(section.onActivated && dojo.isFunction(section.onActivated))
                        section.onActivated();
                }, 200 );
			}
			
            //do not select/focus section if main content is not selected
            if (!this.getHeader().isMainContentSelected()) {
                return;
            }			
			
            this.scrollToSection(sectionId);  
            
            //If header title is not editing, then focus to Section  
			if (!this.getHeader().viewEditableTitle.editing) {
				container.setFocus();
			}
        },
        
        setSectionDisplayMode: function(showAll, selectedSectionId) { 
			this._selectedSectionId = selectedSectionId;     
			var secLen =  this._sections ? this._sections.length : 0;
            for (var i = 0; i < secLen; i++) {
                var section = this._sections[i];
                var config = section.getConfig();
                if (!showAll && selectedSectionId != config.id && this._isTopLevelSection(config)) {
                    dojo.addClass(section.getContainer().domNode, "hidden");
                } else if (!section.isVisible()) {
                    dojo.addClass(section.getContainer().domNode, "hidden");
                } else {
                    dojo.removeClass(section.getContainer().domNode, "hidden");
                }
            }
            this.scrollToSection(selectedSectionId);
        },
		
		getSelectedSection: function() {
			return this._selectedSectionId || null;
		},

        scrollToSection: function(sectionId) {
            //focus on the section
            if (this._tocWidget && this._tocWidget.showAll) {
                var scroll = dojox.fx.smoothScroll({
                    node: dojo.byId(sectionId),
                    win: window,
                    duration: 1000,
                    easing: dojox.fx.easing.easeOut
                });
                scroll.play();
            }            
        },   
        
        isCustomSection: function(/* REQUIRED */sectionId) {
            //is the section id part of the template ? if not, its custom
            var sections = this._editorConfig.sections;
			var secLen =  sections ? sections.length : 0;
            for (var i = 0; i < secLen; i++) {                
                if (sections[i].id == sectionId) {
                    return false;
                }
            }
            return true;
        },
		
		setSCHelpButtonLabel: function(/* REQUIRED */ cshelpLabel) {
			this.getHeader().setCSHelpButtonLabel(cshelpLabel);
		},

        setCSHelpId: function(/* REQUIRED */ cshelpId) {
			this._cshelpId = cshelpId;
            this.getHeader().setCSHelpId(this._cshelpId);
		},

        getCSHelpId: function() {
			return this._cshelpId;
		},
		
		// Summary:
    	//    set the status message in the header. Optionally, provide a type "1", "2",
    	//    or "3" parameter to qualify the status. 
		// "1" means "Success"; "2" means "Error"; "3" means "Info"
		setHeaderStatus: function(status, type, /*optional*/details) {
			this.getHeader().setStatus(status, type, details);
		},
		
		clearStatus: function() {
			this.getHeader().clearStatus();
		},
		
        showTemplateSelect: function() {
            if (!this.isNew() || this.isCopy()) {
                return;
            }

            //Ensure the template attribute in a separate line in the header.
            this.getHeader().addInfoLineBreak();
            				
			if (this._templateSelectContainer) {
				//template container has simply been removed from the dom; add it back
				this.getHeader().getInfoAttributesNode().appendChild(this._templateSelectContainer);
			} else {            
				//create the label
	            var templateLabel = document.createElement("label");
	            templateLabel.innerHTML = Constants.getMessage("labelTemplateLabel");
	            templateLabel.setAttribute("for", "template-select");
				
				//create the selection box
	            this._templateSelect = document.createElement("select");
	            this.connect(this._templateSelect, "onchange", "_onTemplateChange");          
	            this._templateSelect.id = "template-select";
				this._templateSelect.name = "template-select";			

                //add to the header                
				this._templateSelectContainer = this.getHeader().addInfoAttribute(templateLabel, this._templateSelect);
			}
			
            var self = this;
            var handler = {
                success: function(templates) {
					dojox.data.dom.removeChildren(self._templateSelect);
					var tempLen = templates ? templates.length : 0;
                    for (var i = 0; i < tempLen; i++) {				
					    var template = templates[i];
                        var option = new Option(Constants.getExtensionDisplayMessage(template.name), template.itemId);
						var current = self.getTemplate();
                        option.selected = (current && (current.itemId == template.itemId));
						SelectUtility.add(self._templateSelect, option);
                    }
                },
                failure: function(e) {
                    self._error(e);
                }
            }
            var srh = new ServiceResponseHandler(handler, "success", "failure");
            TemplateClient.getTemplates(srh, {editorId: this.getEditorId()});                       
        },
        
        _onTemplateChange: function() {
            if (this._templateSelect && this._templateSelect.value) {
                var itemId = this._templateSelect.value;
                if (itemId != this.getTemplate().itemId) {
					if (this._isAlertWhenChangeTemplate) {
						var self = this;
						var args = {
							title: Constants.getMessage("labelConfirmation"),
							message: Constants.getMessage("msgConfirmChangeTemplate"),
							yesCallback: function(){
								//otherwise, reset editor with new template
								self.setTemplateId(itemId);
								self.setTemplate(null);
								self.initialize();
								return true;
							},
							noCallback: function(){
								if (self.isDirty()) 
									SelectUtility.select(self._templateSelect, self.getTemplate().itemId);
								return false;
							}
						}
						var dialog = new YesNoDialog(args);
						dialog.setSecondaryTitle(args.title);
						dialog.open();
					}
					else {
						//reset editor with new template directly
						this.setTemplateId(itemId);
						this.setTemplate(null);
						this.initialize();
						return true;
					}
                }
            }
        },		
		
        ////////////////////////////////////////////////////////////////////////////////////////////////////
        //                                   INTERNAL SECTION UTILITIES                                   //
        ////////////////////////////////////////////////////////////////////////////////////////////////////        
		_addManageSectionsButton: function(/* REQUIRED */ domNode) {
			//only add the button if this editor is templated
			//button for adding new sections
			var button = document.createElement("div"); //new dijit.form.Button(args);
            dojo.addClass(button, "small-yellow-button-image-l");
            dojo.addClass(button, "add-section-button");
            var buttonR = document.createElement("div");
            buttonR.tabIndex = -1;
            dojo.addClass(buttonR, "small-yellow-button-image-r");
            button.appendChild(buttonR);
            var buttonL = document.createElement("div");
            buttonL.tabIndex = -1;
            dojo.addClass(buttonL, "small-yellow-button-image-m");
            buttonR.appendChild(buttonL);
            buttonL.innerHTML = Constants.getMessage("labelManageSections");
			button.setAttribute("tabindex", "0");
            this.connect(button, "onclick", "_showManageSectionsDialog");
            this.connect(button, "ondblclick", "_showManageSectionsDialog");
			this.connect(button, "onkeypress", "_doKeypress");
			
			// add the new section button inside the TOC so it auto-scrolls with it
            domNode.appendChild(button); //button.domNode);
		},
		
		_doKeypress: function(e) {
			if (e.keyCode == dojo.keys.ENTER) {
                //perform the open new section dialog on ENTER pressed 
                this._showManageSectionsDialog();
            }
		},
		
        _showManageSectionsDialog: function() {
			var editorSections = this._editorConfig.sections;
            var templateSections = this.getTemplate() ? this.getTemplate().sections : [];
            var customSections = this._getCustomSections();
			
            var allAvailable = editorSections.concat(customSections);
            var templateAvailable = templateSections.concat(customSections);
			
			var selectedSections = [];
			var allSections = this.getSections();
			var secLen = allSections ? allSections.length : 0;
			var removedSectionIds = this._sectionsRemoved;
			if (secLen) {
				for (var i = 0; i < secLen; i++) {
					var section = allSections[i];
					var removed = false;
					var removedLen = removedSectionIds ? removedSectionIds.length : 0;
					if (removedLen) {
						for (var j = 0; j < removedLen; j++) {
							if (section.getConfig().id == removedSectionIds[j]) {
								removed = true;
								break;
							}
						}
					}
					if (!removed) {
						selectedSections.push(section.getConfig());
					}
				}
			}
			
            this.sectionDialog = new ManageSectionsDialog({
                onOk: dojo.hitch(this, "_manageSectionsDialogOnOK"),
                allSections: allAvailable, 
				templateSections: templateAvailable,
                selectedSections: selectedSections,
				enableCreate: this.isRolePermitsCreateSection()        
            });           
        },
		
        _manageSectionsDialogOnOK: function(newSections) {
			var existingSections = this.getSections();	
			var getExisting = function(sectionId) {         
			    var secLen = existingSections ? existingSections.length : 0; 
	            for (var i = 0; i < secLen; i++) {
					var section = existingSections[i]; 
	                if (section.getSection().id == sectionId) {
	                    return section;
	                }
	            }
            }
			var templateSections = this.getTemplate().sections;
            var getTemplateSection = function(sectionId) {    
			    var secLen = templateSections ? templateSections.length : 0;
                for (var i = 0; i < secLen; i++) {
					var section = templateSections[i];
                    if (section.id == sectionId) {
                        return section;
                    }
                }
            }		
            //remove sections        
			this._sectionsRemoved = []; 
			var existLen = existingSections ? existingSections.length : 0; 
            for (var i = 0; i < existLen; i++){
                //this section been removed if 'newSections' does not contain it
				var section = existingSections[i];
                if (!this._contains(newSections, section.getSection())) {
					section.setVisible(false);
                    this._sectionsRemoved.push(section.getSection().id);
                }
            }
							
			//re-display the sections, using existing widgets if available
            this._sections = [];       
			dojox.data.dom.removeChildren(this._sectionsNode);        
			var newLen = newSections ? newSections.length : 0;
            for (var i = 0; i < newLen; i++) {
				var newSection = newSections[i];
                var existingWidget = getExisting(newSection.id);
				if (existingWidget) {
					existingWidget.setVisible(true);
					this._sections.push(existingWidget);
	                var bookmark = document.createElement("div");
	                bookmark.id = newSection.id;
	                this._sectionsNode.appendChild(bookmark);
	                this._sectionsNode.appendChild(existingWidget.getContainer().domNode);
	                if (i == 0 && !existingWidget.getContainer().open) {
	                    existingWidget.getContainer()._onTitleClick();
	                }
					if(existingWidget.reset)
						existingWidget.reset();
				} else {
					var templateSection = getTemplateSection(newSection.id);
					this.appendSection(templateSection ? templateSection : newSection);
				}
            }    
            if (this._tocNode != null) {
                this.loadTableOfContents(this._tocNode);
            }		
			this.setDirty(true);
        },
        
        /*
         * Determines whether the given Section/SectionGroup DTO is a top level
         *    section.  Groups and Sections that are not associated with a 
         *    Group are considered top level sections, and will be displayed
         *    in a full EditorSection as opposed to a sub section. 
         */        
        _isTopLevelSection: function(/* Section/Group DTO*/ sectionConfig) {
            return (sectionConfig.sections || !sectionConfig.groupId);  
        },
        
        _isSectionGroup: function(/* Section/Group DTO*/ sectionConfig) {
            return (sectionConfig.sections && !sectionConfig.groupId);  
        },        
        
        //NOTE: assumes js class already loaded (via load_async)
		//but handles missing classes (somewhat) gracefully (logs error to console) 
        _createSectionProvider: function(/* Section/Group (DTO) */sectionConfig) {
            //determine the proper widget for this section
			var sectionConstructor = null;
            if (this._isSectionGroup(sectionConfig)) {
                sectionConstructor = SectionGroup;
				
            } else if (sectionConfig.jsClass) {
                sectionConstructor = dojo.getObject(sectionConfig.jsClass);
				if (!sectionConstructor || sectionConstructor == null) {
					console.error("Unable to load contributed section for: [" + sectionConfig.jsClass + "]");
					return null;
				}
				
            } else  {
				var attLen = sectionConfig && sectionConfig.attributes ? sectionConfig.attributes.length : 0;
				var propLen = sectionConfig && sectionConfig.properties ? sectionConfig.properties.length : 0;
				if (attLen > 0) {
					//From the template, atributes tell you if this is grid type or rich text type
					for (var i = 0; i < attLen; i++) {
						if (sectionConfig.attributes[i].attributeType == "GRID"){
							sectionConstructor = DynamicGridSection;
							break;
						}
					}
				} else if (propLen > 0){
					//From the section, properties has entry for type					
					for (var i = 0; i < propLen; i++) {
						var property = sectionConfig.properties[i];
						if (property.key == "type" && property.value == "GRID"){
							sectionConstructor = DynamicGridSection;
							break;
						}
					}
				}
				//Default is Rich text
				if (sectionConstructor == null) sectionConstructor = DynamicSection
            }
			//create the contributed section widget
            var contributedWidget = null;
			try {
	            var parentEditor = this;
	            var widgetArgs = {
	                parentController: parentEditor.parentController,
	                parentEditor: parentEditor,
	                config: sectionConfig
	            };
				contributedWidget = new sectionConstructor(widgetArgs);	
			} catch(e) {
				console.error(this.declaredClass + ": Error loading widget for section: [Id: " + sectionConfig.id + "; WidgetClass: " + sectionConfig.jsClass + "] --> " + e.message);
			}
			//log status of loading the contributed widget
		    if (contributedWidget != null) {
                //console.debug(this.declaredClass + ": Successfully loaded section widget: [Id: " + sectionConfig.id + "; WidgetClass: " + sectionConfig.jsClass + "]");
            }   else {
                console.error(this.declaredClass + ": Unable to load widget for section: [Id: " + sectionConfig.id + "; WidgetClass: " + sectionConfig.jsClass + "]");
            }
            return contributedWidget;
            
        },        
        
        /*
         * Creates a new EditorSection container widget instance based on the given
         * AbstractArtifactEditorSection.  Uses the AbstractArtifactEditorSection's API
         * to set up the various sections of the container.
         */
        _createSectionWidget: function(/* AbstractArtifactEditorSection */ sectionProvider){
            var args = {
                title: sectionProvider.getDisplayTitle(),
                titleValue: sectionProvider.getTitle(),
                titleEditable: this.isEditable(),
				onTitleEdited: dojo.hitch(this, function() {
		            this.setDirty(true);
		            this.updateTableOfContents(false);					
				}),
                actionDisplay: EditorSection.ACTION_LABEL_AND_ICON,
                hideToolbarOnReadOnly: false,
                editable: this.isEditable(),
				sectionProvider: sectionProvider
            };
            var sectionConfig = sectionProvider.getConfig(); 
            if (this._isTopLevelSection(sectionConfig)) {
                return this.isPrintView() ? new EditorSectionPrintView(args) : new EditorSection(args);    
            } else {
                return new EditorSubSection(args);
            }
        },
        
        /*
         * Called by the 'updateSections' method, which is typically called during
         * saveFinshed, to allow sections the opportunity to update themselves based on
         * the result of the global save operation.
         */
        _updateEditorSection: function(/* AbstractArtifactEditorSection */ sectionProvider){
            if (sectionProvider.getContainer()) {
                sectionProvider.getContainer().renderContent();			 
			}            
        },
        
        _getCustomSections: function() {
            var sections = [];
			var predefSections = this.getTemplate() ? this.getTemplate().sections : this._editorConfig.sections;
            if (this.getArtifact()) {
                var persisted = this.getArtifact().sections;
				var persistLen = persisted ? persisted.length : 0;
                for (var i = 0; i < persistLen; i++) {
					var section = persisted[i];
                    if (!this._contains(predefSections, section)) {
                        sections.push(section);
                    }
                }
            }
			// add new added and not saved custom section 
			var secLen = this._sections ? this._sections.length : 0;
			for (var i = 0; i < secLen; i++) {
				var section = this._sections[i].getSection();
				if (!this._contains(predefSections, section) && !this._contains(sections, section)) {
                    sections.push(section);
                }
			}
            return sections;
        },        
        
        _hasPersistedSection: function(/* REQUIRED */sectionId) {
            if (this.getArtifact()) {
                var persisted = this.getArtifact().sections;
				var persistLen = persisted ? persisted.length : 0;
                for (var i = 0; i < persistLen; i++) {
                    if (sectionId == persisted[i].id) {
                        return true;
                    }
                }
            }
            return false;
        },        
        
        _contains: function(/* REQUIRED */sections, /* REQUIRED */ section) {
			var secLen = sections ? sections.length : 0;
            for (var i = 0; i < secLen; i++) {                
                if (sections[i].id == section.id) {
                    return true;
                }
            }
            return false;
        },
        
        _pushAll: function(/* REQUIRED */array, /* REQUIRED */ elements) {
            array = array ? array : [];
			var len = elements ? elements.length : 0;
            for (var i = 0; i < len; i++) {
                array.push(elements[i]);
            }
        },
        
        _publishArtifactUriChanged: function() {
            var artifactUri = this._getArtifactUri();
            
            if(artifactUri) {
                dojo.publish(GlobalEvents.UpdateTabUri, [window.location.hash, artifactUri]);                    
            }
            else {
                console.debug("Unknown artifact type - " + this.getArtifactModel().getArtifactType() + " Cannot update the artifact URI");
            }
        },
        
        _publishArtifactAdded: function() {
            dojo.publish(GlobalEvents.ArtifactsAdded, [ this.getArtifactType(), [ this.getArtifact() ], this._getArtifactUri() ]);
        },
        
       
        _publishArtifactUpdated: function() {
            dojo.publish(GlobalEvents.ArtifactsUpdated, [ this.getArtifactType(), [ this.getArtifact() ], this._getArtifactUri() ]);
        },
        
        _publishSelfClosing: function() {
            var artifactUri = this._getArtifactUri();
            
            if (artifactUri) {
                dojo.publish(GlobalEvents.CloseTab, [artifactUri]);
            } else {
                console.debug("Unknown artifact type - " + this.getArtifactModel().getArtifactType() + " Cannot close artifact");
            }
        },
        
        _getArtifactUri: function() {
            var artifactType = this.getArtifactModel().getArtifactType();
            
            switch(artifactType){
                case Constants.TYPE_PLAN:
                    return Utility.getTestPlanURI({id: this.getArtifact().id});   
                case Constants.TYPE_CASE:
                    return Utility.getTestCaseURI(this.getArtifact().id);
                case Constants.TYPE_SCRIPT:
                    return Utility.getTestScriptURI(this.getArtifact().id);
				case Constants.TYPE_SUITE:
                    return Utility.getTestSuiteURI(this.getArtifact().id);	
                default:
                    break;
            }
            return null;      
        },
		
		_onChange: function() {
			//console.debug("dirty");
            this.setDirty(true);
		},
        
        _onTitleChange: function() {
            this._titleModified = true;
            this._onChange();
        },
		
        _onCurrentRevisionClick: function() {
            if (dojo.isFunction(this.onCurrentRevision) && this.getArtifact()) {
				this.onCurrentRevision(this.getArtifactType(), this.getArtifact().id);
			}
        },		
        
        _initPermissionsAndPreferences: function() {
            var artifactType = this.getArtifactType();
            var permissionType = null;
            
			//determine which operation to check permissions
            switch(artifactType){
                case Constants.TYPE_PLAN:
                    permissionType = PermissionsClient.OP_TEST_PLAN;  
                    break;
                case Constants.TYPE_CASE:
                    permissionType = PermissionsClient.OP_TEST_CASE;
                    break;
                case Constants.TYPE_DATAPOOL:
                    permissionType = PermissionsClient.OP_DATAPOOL;
                    break;                
                case Constants.TYPE_SCRIPT:
                    permissionType = PermissionsClient.OP_TEST_SCRIPT;
                    break;                
                case Constants.TYPE_SUITE:
                    permissionType = PermissionsClient.OP_TEST_SUITE;
                    break;                
                default:
                    break;
            }
			
			//load permissions
            if(permissionType) {
                var permission = PermissionsClient.getStoredPermission(permissionType);                
                if (permission) {
                    this.setRolePermitsEdit(permission[PermissionsClient.ACTION_EDIT]);
                    this.setRolePermitsArchive(permission[PermissionsClient.ACTION_EDIT]);
					this.setRolePermitsLock(permission[PermissionsClient.ACTION_LOCK]);
					this.setRolePermitsCreateSection(permission[PermissionsClient.ACTION_CREATE_SECTION]);
					this.setReadOnly(!this.isRolePermitsEdit());
                }
            }
			
			//load any artifact editor options
			EditorUtil.getArtifactOptions(dojo.hitch(this, "_setOptions"), this.getArtifactType());
        },
		
		_setOptions: function(options) {
            if (options instanceof Error) {
                this._loadError(options);
            } else {
				this.setArtifactOptions(options);
			}
		},
        
        _loadError: function(e) {
            com.ibm.asq.common.web.ui.internal.util.Utility.handleArtifactLoadError(this.getArtifactType(), e.message);
        }
        
    });
    
})();