/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008,2009. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
CommentsPlugin = dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.construction.manualscripteditor.CommentsPlugin");
CommentsPlugin.PLUGIN_ID = 'comments';

dojo.require("dijit._editor._Plugin");
dojo.require("dijit.form.Button");
dojo.requireLocalization("dijit._editor", "LinkDialog");

dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.properties.CommentView");
dojo.require("com.ibm.asq.common.web.ui.internal.util.CSHelp");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");

(function(){
    var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
    dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.construction.manualscripteditor.CommentsPlugin", [dijit._editor._Plugin], {

        buttonClass: dijit.form.Button,
        useDefaultCommand: false,
        _onCloseDialog: function(){
            if (this.editor.iframe.contentDocument) {
                if (dojo.isIE) {
                    if ("_savedSelection" in this) {
                        var b = this._savedSelection;
                        delete this._savedSelection;
                        this.editor.focus();
                        var range = this.editor.document.selection.createRange();
                        range.moveToBookmark(b);
                        range.select();
                    }
                }else
                    this.editor.focus();
            }else
                this.editor.toolbar.focus();
            this.editor.parentWidget._updateCommentProperty(this.commentWidget.getData());
			if(this.commentWidget)
				this.commentWidget.destroyRecursive();
			this.commentWidget = null;
        },
        _onOpenDialog: function(){
            var a = dojo.withGlobal(this.editor.window, "getAncestorElement", dijit._editor.selection, [this.tag]);
            if (dojo.isIE)
                this._savedSelection = this.editor.document.selection.createRange().getBookmark();
            this.commentWidget = new com.ibm.rqm.planning.web.ui.internal.view.construction.properties.CommentView();
            var allProperties = this.editor.parentWidget._getProperties();
            this.commentWidget.setData(allProperties[0]);
			var args = {
                primaryTitle: Constants.getMessage("labelComments"),
                isClosable: true,
				okCallback:dojo.hitch(this, "_onCloseDialog")
            }
            var dialog = new com.ibm.asq.common.web.ui.internal.widgets.ConfirmationDialog(args);
			dialog.setWidth('600px');
			dialog.contentContainer.appendChild(this.commentWidget.domNode);
            dialog.open();
			this.commentWidget.setFocus();			
        },
        _initButton: function(){
            this.command = 'inserthtml';
			this.button = new this.buttonClass({
                label: Constants.getMessage("labelComments"),
                showLabel: false,
                iconClass: "CommentsIcon CommentsIconIconPos",
                onClick: dojo.hitch(this, "_onOpenDialog"),
                tabIndex: "-1"
            });            
        },
		updateState: function(){
			if (this.editor.parentWidget) {
				var enabled = this.editor.parentWidget.stepBeingEdited !== -1;
				if (this.enabled !== enabled) {
					this.enabled = enabled;
					this.button.attr('disabled', !enabled);
				}
			}
		}
    });
    dojo.subscribe("dijit.Editor.getPlugin", null, function(o){
        if (o.plugin)
            return;
        switch (o.args.name) {
            case CommentsPlugin.PLUGIN_ID:
                o.plugin = new com.ibm.rqm.planning.web.ui.internal.view.construction.manualscripteditor.CommentsPlugin({
                    command: o.args.name
                });
        }
    });
})();
