/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
CompactPlugin = dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.construction.manualscripteditor.CompactPlugin");
CompactPlugin.PLUGIN_ID = 'compact';

dojo.require("dijit._editor._Plugin");
dojo.require("dijit.form.Button");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("dijit.Menu");
(function(){
    var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
    dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.construction.manualscripteditor.CompactPlugin", [dijit._editor._Plugin], {
        useDefaultCommand: false,
		fClick: function(){
			switch(this.item){
				case "compact":
					this.callback.compactMode._setCheckedAttr(true);
					this.callback.normalMode._setCheckedAttr(false);
					break;
				case "normal":
					this.callback.normalMode._setCheckedAttr(true);
					this.callback.compactMode._setCheckedAttr(false);
					break;
			}
			this.callback.editor.parentWidget._showCompactView(this.item);			
		},
        _initButton: function(){
            this.command = 'inserthtml';
			this.menu = new dijit.Menu({_contextMenuWithMouse:true});
			this.compactMode = new dijit.CheckedMenuItem({label:Constants.getMessage("labelShowCompactView"),
				callback: this, item:"compact",onClick:this.fClick});
			dojo.addClass(this.compactMode.iconNode,"CompactMenuEntryIcon");
			this.menu.addChild(this.compactMode);
			this.normalMode = new dijit.CheckedMenuItem({label:Constants.getMessage("labelShowNormalView"), 
				callback: this,item:"normal", onClick:this.fClick, checked:true});
			dojo.addClass(this.normalMode.iconNode,"CompactMenuEntryIcon");
            this.menu.addChild(this.normalMode);
			this.menu.startup();            
            this.button = new dijit.form.DropDownButton({
                label: Constants.getMessage("labelCompact"),
                showLabel: false,
				dropDown: this.menu,
                iconClass: "CompactIcon CompactIconPos",
                tabIndex: "-1"
            });            
        },
		updateState: function(){}
    });
    dojo.subscribe("dijit.Editor.getPlugin", null, function(o){
        if (o.plugin)
            return;
        switch (o.args.name) {
            case CompactPlugin.PLUGIN_ID:
                o.plugin = new com.ibm.rqm.planning.web.ui.internal.view.construction.manualscripteditor.CompactPlugin({
                    command: o.args.name
                });
        }
    });
})();
