/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
ManageImagesPlugin = dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.construction.manualscripteditor.ManageImagesPlugin");
ManageImagesPlugin.PLUGIN_ID = "manageimages"

dojo.require("dijit._editor._Plugin");

dojo.require("dijit.Dialog");
dojo.require("dijit.form.Button");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("dijit.Menu");

( function() {

	var Constants = com.ibm.rqm.planning.web.client.internal.Constants;   
    dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.construction.manualscripteditor.ManageImagesPlugin", dijit._editor._Plugin, {
    
        useDefaultCommand: false,
		fClick: function(){
			switch(this.item){
				case "FS":
					this.callback.thumbNailItem._setCheckedAttr(false);
					this.callback.linkItem._setCheckedAttr(false);
					break;
				case "TN":
					this.callback.fullSizeItem._setCheckedAttr(false);
					this.callback.linkItem._setCheckedAttr(false);
					break;
				case "LK":
					this.callback.fullSizeItem._setCheckedAttr(false);
					this.callback.thumbNailItem._setCheckedAttr(false);
					break;
			}
			this.callback.editor.parentWidget._changeImageDisplay(this.item);
			
		},

        _initButton: function(){
            this.command = 'inserthtml';
            var messages = dojo.i18n.getLocalization("dijit._editor", "LinkDialog", this.lang);
			this.menu = new dijit.Menu({_contextMenuWithMouse:true});
			this.fullSizeItem = new dijit.CheckedMenuItem({label:Constants.getMessage("labelFullSize"),
				callback: this, item:"FS",onClick:this.fClick});
			dojo.addClass(this.fullSizeItem.iconNode,"ManageImagesMenuEntryIcon");	 
			this.menu.addChild(this.fullSizeItem);
			this.thumbNailItem = new dijit.CheckedMenuItem({label:Constants.getMessage("labelThumbNail"), 
				callback: this,item:"TN", onClick:this.fClick});
            dojo.addClass(this.thumbNailItem.iconNode,"ManageImagesMenuEntryIcon");
			this.menu.addChild(this.thumbNailItem);
            this.linkItem = new dijit.CheckedMenuItem({label:Constants.getMessage("labelLink"), 
				callback: this,item:"LK", onClick:this.fClick});
			dojo.addClass(this.linkItem.iconNode,"ManageImagesMenuEntryIcon");
			this.menu.addChild(this.linkItem);
            this.menu.startup();            
            this.button = new dijit.form.DropDownButton({
                label: Constants.getMessage("labelManageImages"),
                showLabel: false,
                dropDown: this.menu,
                iconClass: "ManageImagesIcon ManageImagesIconPos",
                tabIndex: "-1"
            });
        },
        
        setToolbar: function(){
            this.inherited("setToolbar", arguments);
        },
		updateState: function(){
		}
    });
})();

dojo.subscribe("dijit.Editor.getPlugin", null, function(o){
    if (o.plugin) {
        return;
    }
    switch (o.args.name) {
        case ManageImagesPlugin.PLUGIN_ID:
            o.plugin = new com.ibm.rqm.planning.web.ui.internal.view.construction.manualscripteditor.ManageImagesPlugin({
                command: o.args.name
            });
    }
});
