/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
ShowHideCommentsPlugin = dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.construction.manualscripteditor.ShowHideCommentsPlugin");
ShowHideCommentsPlugin.PLUGIN_ID = 'showhidecomments';

dojo.require("dijit._editor._Plugin");
dojo.require("dijit.form.Button");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("dijit.Menu");

(function(){
    var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
    dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.construction.manualscripteditor.ShowHideCommentsPlugin", [dijit._editor._Plugin], {
        useDefaultCommand: false,
		fClick: function(){
			switch(this.item){
				case "show":
					this.callback.showComment._setCheckedAttr(true);
					this.callback.hideComment._setCheckedAttr(false);
					break;
				case "hide":
					this.callback.hideComment._setCheckedAttr(true);
					this.callback.showComment._setCheckedAttr(false);
					break;
			}
			this.callback.editor.parentWidget._toggleCommentsColumn(this.item);			
		},
        _initButton: function(){
            this.command = 'inserthtml';
			this.menu = new dijit.Menu({_contextMenuWithMouse:true});
			this.hideComment = new dijit.CheckedMenuItem({label:Constants.getMessage("labelHideComments"),
				callback: this, item:"hide",onClick:this.fClick, checked:true});
			dojo.addClass(this.hideComment.iconNode,"ShowHideCommentsIconEntryIcon");
			this.menu.addChild(this.hideComment);
			this.showComment = new dijit.CheckedMenuItem({label:Constants.getMessage("labelShowComments"), 
				callback: this,item:"show", onClick:this.fClick});
			dojo.addClass(this.showComment.iconNode,"ShowHideCommentsIconEntryIcon");
            this.menu.addChild(this.showComment);
			this.menu.startup();            
            this.button = new dijit.form.DropDownButton({
                label: Constants.getMessage("labelShowHideComments"),
                showLabel: false,
				dropDown: this.menu,
                iconClass: "ShowHideCommentsIcon ShowHideCommentsIconIconPos",
                tabIndex: "-1"
            });            
        },
		updateState: function(){}
    });
    dojo.subscribe("dijit.Editor.getPlugin", null, function(o){
        if (o.plugin)
            return;
        switch (o.args.name) {
            case ShowHideCommentsPlugin.PLUGIN_ID:
                o.plugin = new com.ibm.rqm.planning.web.ui.internal.view.construction.manualscripteditor.ShowHideCommentsPlugin({
                    command: o.args.name
                });
        }
    });
})();
