/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.construction.manualscripteditor.StatementEditor");

/*
 * This widget extends the Common RichText Editor widget of Quality Manager
 * Usage in Manual Test Editor.
 * author: vasrivas
 */

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.richtext.RichTextEditor");
dojo.require("dijit._editor.range");
dojo.require("dijit._editor.selection");
dojo.require("dijit._editor.RichText");

dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.manualscripteditor.CommentsPlugin");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.manualscripteditor.AttachmentsPlugin");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.manualscripteditor.ComparePlugin");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.manualscripteditor.DataPoolPlugin");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.manualscripteditor.ShowHideCommentsPlugin");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.manualscripteditor.ManageImagesPlugin");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.manualscripteditor.CompactPlugin");
(function(){

dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.construction.manualscripteditor.StatementEditor", [com.ibm.asq.common.web.ui.internal.widgets.richtext.RichTextEditor], {
	//@Overridden postCreate of dijit.Editor
	plugins:[],
	postCreate: function(){
			/*
			 * Here we are directly calling dijitEditor super class since
			 * StatementEditor needs direct access to dijit.RichText
			 *
			 * Need to remove EnterKeyHandling plugin which is default in Dojo Editor
			 */
		if(this.plugins && !this.plugins.length)	
			this.plugins=["undo","redo","|","cut","copy","paste","|","bold","italic","underline","strikethrough","|",
				"insertOrderedList","insertUnorderedList","indent","outdent","|",
				"justifyLeft","justifyRight","justifyCenter","justifyFull","|",
				'fontSize', 'fontName', 'foreColor', 'hiliteColor', 'dijit._editor.plugins.AlwaysShowToolbar',
				 "|",'insertimage','manageimages',"|",'comments','showhidecomments',
				 "|",'attachments','pastecompare','datapool','compact'];
		if(this.customUndo){
			dojo['require']("dijit._editor.range");
			this._steps=this._steps.slice(0);
			this._undoedSteps=this._undoedSteps.slice(0);
		}
		dijit.Editor.superclass.postCreate.apply(this, arguments);
		this.commands = dojo.i18n.getLocalization("dijit._editor", "commands", this.lang);
		if(!this.toolbar){
			// if we haven't been assigned a toolbar, create one
			var toolbarNode = dojo.doc.createElement("div");
			dojo.place(toolbarNode, this.editingArea, "before");
			this.toolbar = new dijit.Toolbar({}, toolbarNode);
		}
		dojo.forEach(this.plugins, this.addPlugin, this);
		this.onNormalizedDisplayChanged(); //update toolbar button status
	},
	queryCommandAvailable: function(/*String*/command){
		var supportedBy = null;
		switch(command.toLowerCase()){
			case "attachments": 
			case "comments": 
			case "pastecompare" : 
			case "datapool" :
			case "manageimages" : 
			case "showhidecomments" : 
			case "compact" :
				if (dojo.isMoz || dojo.isIE) {
					return true;
				}else {
					return false;
				}
		}
		return this.inherited('queryCommandAvailable', arguments);
	},
	setupDefaultShortcuts: function(){
		this.inherited('setupDefaultShortcuts', arguments);
		var exec = function(cmd, arg){
			if (cmd == "backspaceKeyHandler" || cmd == "upKeyHandler" || cmd == "downkeyHandler" ) {
				return function(){
					return this.execCommand(cmd, arguments);
				};
			}
			return arguments.length == 1 ? function(){ return this.execCommand(cmd); } :
				function(){ return this.execCommand(cmd, arg); };
		};
		
		this.addKeyHandler("13", false,false,exec("enterkeyHandler"));
		this.addKeyHandler("13", true,false, exec("ctrlEnterKeyHandler"));
		this.addKeyHandler("13", true,true, exec("ctrlShiftEnterKeyHandler"));
		this.addKeyHandler("8", false,false, exec("backspaceKeyHandler"));
		this.addKeyHandler("38", false,false, exec("upKeyHandler"));
		this.addKeyHandler("40", false,false, exec("downkeyHandler"));
	},
	//@Overridden events of dijit.RichText
	execCommand: function(/*String*/command, argument){
		var returnValue;
		this.focus();
		command = this._normalizeCommand(command);
		if(command == "backspacekeyhandler"){
			returnValue = false;
			if(argument[0].keyCode != dojo.keys.BACKSPACE)
				return true;
			else{
				if (this.parentWidget && this.parentWidget.handleRowDelete) {
					if (!this.handlingBkSpace) {
						this.handlingBkSpace = true;
						var startingPoint = false;
						try {
							var selection = dijit.range.getSelection(this.window);
							var parent = dojo.withGlobal(this.window, "getParentElement", dijit._editor.selection);
							var header = dijit.range.getAncestor(parent, /^(?:LI)$/);
							if (selection.getRangeAt(0).endOffset == 0 && !header) {
								startingPoint = true;
								returnValue = true;
							}
						}catch (e) {console.debug("StatementEditor backspace key error: - > " + e);}
						if (startingPoint) {
							this.endEditing(true);
							setTimeout(dojo.hitch(this, function(){
								this.parentWidget.handleRowDelete(this.domNode.id, dojo.byId(this.parentNodeId));
								this.handlingBkSpace = false;
							}), 0);
						}else {
							this.handlingBkSpace = false;
							return true;
						}
					}else //we are processing backspace, dont do anything and dont allow browser to do anything as well
						return false;
				}else { //let browser handle it
					this.handlingBkSpace = false;
					return true;
				}
			}
		}else if(command == "upkeyhandler"){
			if(argument[0].charCode == argument[0].keyCode && dojo.isIE) //this came from onKeyDown of dojo for IE
				return true;
			if(this.parentWidget && this.parentWidget.handleRowDelete){
				var sel = dijit.range.getSelection(this.window);
				var range = sel.getRangeAt(0);
				this.upKeyStartContainer = range.startContainer;
				this.rangeStartOffset = range.startOffset;
				this.rangeEndOffset = range.endOffset;
			}
			//let browser handle it
			return true;
		}else if(command == "downkeyhandler"){
			if(argument[0].charCode == argument[0].keyCode && dojo.isIE) //this came from onKeyDown of dojo for IE
				return true;
			if(this.parentWidget && this.parentWidget._handleAddClick){
					var sel = dijit.range.getSelection(this.window);
					var range = sel.getRangeAt(0);
					this.dnKeyStartContainer = range.startContainer;
					this.rangeStartOffset = range.startOffset;
					this.rangeEndOffset = range.endOffset;
			}
			//let browser handle it
			return true;
		}else if(command == "enterkeyhandler"){
			// See if you are currently within an ordered/unordered list
			if(this.parentWidget && this.parentWidget._handleAddClick){
				try{
					var parent = dojo.withGlobal(this.window, "getParentElement", dijit._editor.selection);
					var header = dijit.range.getAncestor(parent,/^(?:LI)$/);
				}catch(e){
					console.debug("StatementEditor enter key error: - > "+e);
				}	
				if(header)//let browser handle it
					return true;
				else{
					// Creates or moves to the next step
					this.endEditing(true);
					setTimeout(dojo.hitch(this, function(){
						this.parentWidget._handleAddClick(null, dojo.byId(this.parentNodeId));
					}),0);
					returnValue=true;
				}
			}else
				return true;
		}else if(command == "ctrlenterkeyhandler"){
			this.endEditing(true);
			if(this.parentWidget && this.parentWidget._handleRowInsert){
				setTimeout(dojo.hitch(this, function(){
					try{
						this.parentWidget._handleRowInsert(dojo.byId(this.parentNodeId));
					}catch(e){
						console.debug("StatementEditor ctrl+enter key error: - > "+e);
					}
				}),0);
			}else
				return true;	
			returnValue=true;	
		}else if(command == "ctrlshiftenterkeyhandler"){
			this.endEditing(true);
			if(this.parentWidget && this.parentWidget._handleRowInsert){
				setTimeout(dojo.hitch(this, function(){
					try{
						this.parentWidget._handleRowInsert(dojo.byId(this.parentNodeId),true);
					}catch(e){
						console.debug("StatementEditor ctrl+shift+enter key error: - > "+e);
					}
				}),0);
			}else
				return true;	
			returnValue=true;
		}
		if(!returnValue)	
			this.inherited('execCommand', arguments);
	},
	
	//@Overridden events of dijit.RichText
	open: function(/*DomNode?*/element){
		//BUG in RTE,doesnt disconnect events on close but re-registers on open
		dojo.forEach(this._connects, function(array){
			dojo.forEach(array, dojo.disconnect);
		});
		this._connects=[];
		this.inherited('open', arguments);
		if(dojo.isIE){
			if(this.iframe)
				this.iframe.style.height = this.minHeight; 
		}else if(dojo.isMoz){
			//Bug in RTE the editor does not expand properly _getIframeDocTxt() has height set to 100%
			if(this.document)
				dojo.style(this.document.body,"height","auto");
		}
	},

	_error: function(errorObj){
		console.error("Error: (message: '" + errorObj.message + "') from Statement Editor#_error");
	},
	//Get the toolbar state for the editor
	getState: function(){
		var plugins = this._plugins;
		var valueMap = {};
		var len = plugins.length;
		for(var i=0;i<len;i++){
			var plugin = plugins[i];
			var command = plugin.command;
			var value = "";
			switch(command){
				case "bold": case "italic": case "underline": case "strikethrough":
					//Toggle button only
					value = plugin.button.checked;
					break;
				case "fontSize": case "fontName":
					//Filtering Select only	
					value = plugin.button.valueNode.value;
					break;
				case "foreColor": case "hiliteColor":
					//DropDown only	
					value = plugin.dropDown.value;
					break;		
				default:
					//Rest any property will not be passed to the next editor inline
					command =""; 
					break;
			}
			if(command != "" && value && value != ""){
				valueMap[command] = value;
			}	
		}
		return valueMap;
	},
	
	//Set the toolbar state for the editor
	setState: function(valueMap){
		var plugins = this._plugins;
		var len = plugins.length;
		for(var i=0;i<len;i++){
			var plugin = plugins[i];
			var command = plugin.command;
			var value = valueMap[command];
			if(value != null && value != undefined){
				switch(command){
					case "bold": case "italic": case "underline": case "strikethrough":
						//Directly on the document only
						if(value)
							this.execCommand(command);
						break
					case "fontSize": case "fontName":
						//Filtering Select Buttons only	
						this.execCommand(command, value);
						plugin.button._setValueAttr(value);
						break
					case "foreColor": case "hiliteColor":
						//DropDown Buttons only	
						plugin.dropDown.value = value;
						plugin.dropDown.onChange(value);
						break;	
					default:
						//Should not reach here, map to above options
						break;
				}
			}
		}
	},
	onKeyDown: function(e){
		if(e.keyCode == dojo.keys.TAB && !this.isTabIndent){
			if(this.parentWidget && this.parentWidget._preserveEditedContent)
				this.parentWidget._preserveEditedContent(true);
		}
		this.inherited('onKeyDown',arguments);
		this.onChange();
		// summary: Fired on keyup
		return;
	},
	onChange: function(newContent){
		if(this.parentWidget && this.parentWidget.setParentDirty)
			this.parentWidget.setParentDirty();
	},
	onKeyPressed: function(){
		// we record the range where the user used the up/down arrow key in their key handlers 
		// and then let the browser handle it
		// we reach here after the browser has handled it and now we compare the range with that recorded range
		//if they are same and the start and end offsets are same, we have to move to next cell
		var dnKeyStartContainer = this.dnKeyStartContainer;
		var upKeyStartContainer =  this.upKeyStartContainer;
		if (this.dnKeyStartContainer || this.upKeyStartContainer) {
			var startContainer = dnKeyStartContainer?dnKeyStartContainer:upKeyStartContainer;
			var sel = dijit.range.getSelection(this.window);
			var range = sel.getRangeAt(0);
			if(this.rangeStartOffset == range.startOffset && this.rangeEndOffset == range.endOffset && startContainer == range.startContainer){
				this.endEditing(true);
				if (dnKeyStartContainer) {
					setTimeout(dojo.hitch(this, function(){
						this.parentWidget._handleAddClick(null, dojo.byId(this.parentNodeId));
					}), 0);
				}else{
					setTimeout(dojo.hitch(this, function(){
						this.parentWidget.handleRowDelete(this.domNode.id, dojo.byId(this.parentNodeId));
					}),0);
				}
			}
			this.dnKeyStartContainer = null;
			this.upKeyStartContainer = null;
		}
		this.inherited('onKeyPressed',arguments);
	}

});
})();
