/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.planning.web.ui.internal.view.construction.properties.DataPoolTableView");
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.construction.properties.DataPoolTableView");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("dojox.data.dom");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.ListRowRenderer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableListener");

dojo.require("com.ibm.team.workitem.web.client.util");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.TooltipBuilder");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.EditorUtil");
//xojo.require("com.ibm.rqm.process.web.ui.internal.view.approval.Constants");
//xojo.require("com.ibm.rqm.process.web.ui.internal.util.PermissionControlUtil");
//xojo.require("com.ibm.rqm.process.web.ui.internal.view.approval.UserSelectionDialog");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");

(function(){
    var TableConstants = com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;
    var EditorUtil = com.ibm.rqm.planning.web.ui.internal.util.EditorUtil;
    var TooltipBuilder = com.ibm.rqm.planning.web.ui.internal.util.TooltipBuilder;
    var util = com.ibm.team.workitem.web.client.util;
	var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
	
	dojo.declare("DataPoolTableView.TableListener", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableListener, {
    	parentView: null,
        
        constructor: function(testView){
            this.parentView = testView;
        },
    
	     rowCheckStateChanged: function(tableViewer, rowObject, state){
            rowObject.selected = state;
			var selectionCount = tableViewer.getCheckedRows().length;
        	if (this.parentView.dialog)
            	this.parentView.dialog.getOkButton().disabled = (selectionCount == 0);
        }
	});

    dojo.declare("DataPoolTableView.TableProvider", com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider, {

        getNumColumns: function(content){
            return 2;
        },
        
        getColumnHeading: function(content, index){
            var headings = [Constants.getMessage("labelName"), Constants.getMessage("labelType")];
            return headings[index];
        },
        
        getColumnWidth: function(content, atColumnIndex){
            var width = 1;
            switch (atColumnIndex) {
                case 0:
                    width = 40;
                    break;
                case 1:
                    width = 40;
                    break;
            }
            return width;
        },
        getIsCellEditable: function(rowData, atColumnIndex){
            return false;
        },
        
        getContentObjects: function(content){
            return content;
        },
        
        getRowDataId: function(rowData){
            return rowData.id;
        },
        
        getCellDisplayType: function(rowData, atColumnIndex){
            var type = TableConstants.RENDER_TYPE_TEXT;
            return type;
        },
        
        getCellDisplayData: function(rowData, atColumnIndex){
            var val = "data";
            switch (atColumnIndex) {
                case 0:
                    val = rowData.col1;
                    break;
                case 1:
                    val = this._transforDatapoolType(rowData.col2);
                    break;
            }
            return val;
        },
		
		_transforDatapoolType: function(typeNum) {
			switch(typeNum) {
				case "0": return "String";
				case "1": return "Number";
				case "2": return "Boolean";
				case "3": return "Enumeration";
				case "4": return "Complex";
				default: return "";
			}
		}
    });
    
    dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.construction.properties.DataPoolTableView", [dijit._Widget, dijit._Templated], {
        templateString: '<div dojoAttachPoint="domNode" tabindex="-1"></div>',
        widgetsInTemplate: true,
        
        constructor: function(args){
            this.variable = null;
        },
        
        postCreate: function(){
            this.inherited("postCreate", arguments);
        },
        
        initialize: function(args){
            this.variable = args.variable;
			this.dialog = args.dialog;
            var tableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer();
            this.domNode.appendChild(tableViewer.domNode);
            this.content = this.createContent();
            var contentProvider = new DataPoolTableView.TableProvider();
			tableViewer.setContentPageSize(5);
			tableViewer.setShowingPagingRangeControl(false);
            tableViewer.setContent(this.content);
			tableViewer.setTableListener(new DataPoolTableView.TableListener(this));
            tableViewer.setContentProvider(contentProvider);
			tableViewer.setTableRowsCheckable(true, false);
			this.tableViewer = tableViewer;
            tableViewer.show();
        },
		
		   
        createContent: function(){
            var rows = [];
            if (this.variable == null) {
                return rows;
            }
			var variable = this.variable;
			var len = this.variable.length;
            for (var i = 0; i < len; i++) {
                var res = variable[i];
                var obj = {
                    col1: res.name,
                    col2: res.suggestedType,
                    id: res.itemId
                };
                rows.push(obj);
            }
            return rows;
        },
		
        _error: function(errorObj){
            alert(errorObj.message);
        }
    });
    
})();
