/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading.. com.ibm.rqm.planning.web.ui.internal.view.construction.properties.DefectView");
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.construction.properties.DefectView");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojo.date.stamp");
dojo.require("dojox.data.dom");

dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.team.workitem.web.client.util");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.editor.WorkItemEditor");
dojo.require("com.ibm.team.workitem.web.ui.internal.page.WorkItemPageView");
dojo.require("com.ibm.rqm.planning.web.client.internal.WorkItemClient");
dojo.require("com.ibm.team.workitem.web.ui.internal.page.EventTopics");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.properties._workItem.QMWorkItemEditor");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.properties._workItem.QMWorkItemPageView");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.properties._workItem.QMQueryResults");
dojo.require("com.ibm.team.process.web.client.projectarea");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.query.Search");
(function() { // module container

var ServiceResponseHandler	= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var WorkItemUtil			= com.ibm.team.workitem.web.client.util;
var WorkItemClient          = com.ibm.rqm.planning.web.client.internal.WorkItemClient;	
var EventTopics			    = com.ibm.team.workitem.web.ui.internal.page.EventTopics;
var Search                  = com.ibm.team.workitem.web.ui.internal.view.query.Search;


var DEFECT_VIEW             ="defectView";
var getCurrentProjectArea	= com.ibm.team.process.web.client.projectarea.getCurrentProjectArea;
var QMWorkItemEditor        = com.ibm.rqm.planning.web.ui.internal.view.construction.properties._workItem.QMWorkItemEditor;
var QMWorkItemPageView      = com.ibm.rqm.planning.web.ui.internal.view.construction.properties._workItem.QMWorkItemPageView;
var QMQueryResults          = com.ibm.rqm.planning.web.ui.internal.view.construction.properties._workItem.QMQueryResults;
var DEFECT_URL 				= "#action=com.ibm.team.workitem.viewWorkItem&id=";
var NON_NUMERIC_REGEX       = /[^0-9]/;
var Constants 				= com.ibm.rqm.planning.web.client.internal.Constants;

dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.construction.properties.DefectView",[dijit._Widget, dijit._Templated],
	{
		templatePath: dojo.moduleUrl("com.ibm.rqm.planning.web", "ui/internal/view/templates/construction/properties/DefectView.html"),

		labelAddSelectedDefect: Constants.getMessage("labelAddSelectedDefect"),
		labelAddThisDefect: Constants.getMessage("labelAddThisDefect"),
		labelId: Constants.getMessage("labelId"),
		labelSummary: Constants.getMessage("labelSummary"),
		labelShowRelatedDefects: Constants.getMessage("labelShowRelatedDefects"),
        labelShowQueryDefects: Constants.getMessage("labelShowQueryDefects"),
		
		constructor: function(args){
            this.relatedDefectList = [];
			this._isBlocking = args.isBlocking ? args.isBlocking : false;
		},
		
		postCreate: function(){
            if (this.parentEditor) {
                this.relatedDefectList = this.parentEditor.relatedDefects;
			}
			this.defectList = [];
			this._initializeView();
            this.searchInputWidget = /* createWidget */ new Search({
				container:this, 
				actionHandler: dojo.hitch(this,this._handleAssociateDefect),
				DROP_DOWN_ICON_CLASS: "defect-workItemsIcon",
				ACTIVE_SEARCH_ICON_CLASS: "defect-search-button-active",
				_searchAllWorkItems: function() {
					if(this.container._wiView && this.container._wiView.getController()){
						this.container._wiView.getController().resetLastQueryString();
					}
					this.openOnly = false;
				},
				_searchAllOpenWorkItems: function() {
					if(this.container._wiView && this.container._wiView.getController()){
						this.container._wiView.getController().resetLastQueryString();
					}
					this.openOnly = true;
				}
			});
			this._searchDefect.appendChild(this.searchInputWidget.domNode);			
            // need to get to the form within the searchInputWidget for enablement
			this.searchInputWidgetForm = this.searchInputWidget.domNode.getElementsByTagName("form")[0];
		},
		
		hideAddOption: function(){
			dojox.data.dom.removeChildren(this._message);
			dojox.data.dom.removeChildren(this._addContainer);
		},

		setData: function(elements){
			this.defectList= [];
			dojox.data.dom.removeChildren(this._defectsTableBody);
			if(elements.length >0){
				var len = elements.length;
				for(var i=0;i<len;i++){
					var name = elements[i].propertyName;
					var value = elements[i].propertyValue;
					var handler= new ServiceResponseHandler(this, "receiveDefect", "_error");
					WorkItemClient.getWorkItemDTO(handler, {id: value} );
				}
			}	
		},
		
		receiveDefect: function(workItem){
            if(this.defectList && this.defectList.length>0){
                var i=0;
                while((defect = this.defectList[i++])){
                    if(workItem.id == defect.id)
                        return;
                }
            }
			var defect = {
				id: workItem.id,
				summary: workItem.summary.content,
				status: workItem.state.label,
				statusId:workItem.state.id
			}
			this.defectList.push(defect);
			this._updateTable(defect, false);
		},
		
		getData: function(){
			var returnData = new Array();
			var defectList = this.defectList;
			var len = defectList.length;
			for(var i=0;i<len;i++){
				returnData.push(DEFECT_VIEW);
				returnData.push("id:"+defectList[i].id);
				returnData.push(defectList[i].id);
			}
			return returnData;	
		},
		
		isBlockingDefect: function(){
			return this._isBlocking;			
		},
		
        // Set up the defect view to display the appropriate contents. If the
        // type is 'new' and a detail parameter is passed, the defect form
        // will be pre-filled with the supplied values. The param must be an object
        // with attribute names identifying the values to be pre-filled in the form.
        // Supported defect attributes are:
        //   { 
        //      summary: "value",
        //      description: "value",
        //      requirement: "value",
        //      testCase: "value",
        //      testEnvironment: "value",
        //      buildId: "value",
        //      verificationPoint: "value",
        //   }
		setViewType:function(type, details){
			this.type = type;
			dojo.style(this._searchContainer,"display","none");
			dojo.style(this._defectsContainer,"display","none");
			dojo.style(this._addThisDefect,"display","none");
			dojo.style(this.statusErrorNode,"display","none");
			dojo.style(this._addSelectedDefect,"display","none");
            dojo.style(this._relatedDefectsContainer,"display","none");
			dojo.style(this._workItemContainer,"display","none");
			this.msgLabel.innerHTML = "";
			switch (type){
				case "new":
					this._handleAddDefect(details);
					break;
				case "existing":
					dojo.style(this._searchContainer,"display","inline");
                    // default to show the list of related defects
					this.relatedRadio.checked = true;
                    this._checkRelatedDefects();
					break;
				case "list":
					dojo.style(this._defectsContainer,"display","inline");
					break;
			}
		},
		setParentDialog:function(dlg){
			this.parentDialog = dlg;
			if (this._wiView != null)
				this._wiView.setDialog(dlg);
		},
		
		_initializeView: function(){
			dojox.data.dom.removeChildren(this._defectsTableBody);
			var len = this.defectList.length;
			for(var i=0;i<len;i++)
				this._updateTable(this.defectList[i]);
		},
		

        _showRelatedDefects: function() {
			// save current query defects settings
			this._savedNonNumericSearch = this._nonNumericSearch;
			this._nonNumericSearch = true;
            var relatedDefectsQuery = { name: Constants.getMessage("labelRelatedDefects") };
            var rowsOfDefects = this._defectListToQueryResultRows(this.relatedDefectList);
            if (!this.relatedDefectsWidget) {
				this.relatedDefectsWidget = new QMQueryResults();
				this._relatedDefectsContainer.appendChild(this.relatedDefectsWidget.domNode);
			}
            this.relatedDefectsWidget.setQueryResultsTable(relatedDefectsQuery, rowsOfDefects);
            dojo.style(this._workItemContainer, "display", "none");
            dojo.style(this._relatedDefectsContainer, "display", "inline");
            dojo.style(this._addThisDefect, "display", "none");
            dojo.style(this._addSelectedDefect, "display", "inline");
        },


        _checkRelatedDefects: function(e) {
            this.addRelatedDefects = true;
            dojo.style(this.searchInputWidgetForm, "opacity", "0.5");
            this.searchInputWidgetForm.disabled = true;
			dojo.query("input", this.searchInputWidgetForm).forEach(function(i) { i.disabled = true; });
            dojo.query("a", this.searchInputWidgetForm).forEach(function(i) { i.disabled = true; });
            dojo.query("button", this.searchInputWidgetForm).forEach(function(i) { i.disabled = true; });
            this._showRelatedDefects();
		},
		
        _checkQueryDefects: function(e) {
			dojox.data.dom.removeChildren(this._workItemContainer);
            this.addRelatedDefects = false;
            dojo.style(this.searchInputWidgetForm, "opacity", "1");
            this.searchInputWidgetForm.disabled = false;
            dojo.query("input", this.searchInputWidgetForm).forEach(function(i) { i.disabled = false });
            dojo.query("a", this.searchInputWidgetForm).forEach(function(i) { i.disabled = false; });
            dojo.query("button", this.searchInputWidgetForm).forEach(function(i) { i.disabled = false });
			// swap back work item container if it is not empty
            this._nonNumericSearch = this._savedNonNumericSearch;
            dojo.style(this._relatedDefectsContainer, "display", "none");
            dojo.style(this._workItemContainer, "display", "inline");
			if (this._workItemContainer.firstChild) {
                dojo.style(this._addSelectedDefect, "display", this._nonNumericSearch ? "inline" : "none");
                dojo.style(this._addThisDefect, "display", this._nonNumericSearch ? "none" : "inline");
			} else {
				// no action button is presented if the _workItemContainer is empty
                dojo.style(this._addSelectedDefect, "display", "none");
                dojo.style(this._addThisDefect, "display", "none");
			}
        },
        
		_defectListToQueryResultRows: function(defectList) {
			// convert work item list to request result rows for the table viewer
			var queryResultRows = [];
			var len = defectList.length;
			for (var i = 0; i < len; i++) {
                var defectAttr = defectList[i].workItem.attributes;
				var labels = new Array(8);
				var attributesSet = 0;
				var len2 = defectAttr.length;
                for (var j = 0; j < len2; j++) {
                    switch (defectAttr[j].key) {
                        case "workItemType":
                            labels[0] = defectAttr[j].value.label;
                            attributesSet++;
                            break;
                        case "id":
                            labels[1] = defectAttr[j].value.id;
							attributesSet++;
                            break;
                        case "summary":
                            labels[2] = defectAttr[j].value.content;
                            attributesSet++;
                            break;
                        case "owner":
                            labels[3] = defectAttr[j].value.name;
                            attributesSet++;
                            break;
                        case "internalState":
                            labels[4] = defectAttr[j].value.label;
                            attributesSet++;
                            break;
                        case "internalPriority":
                            labels[5] = defectAttr[j].value.label;
                            attributesSet++;
                            break;
                        case "internalSeverity":
                            labels[6] = defectAttr[j].value.label;
                            attributesSet++;
                            break;
                        case "modified":
						    // convert ISO date time string to date object
                            var modDate = dojo.date.stamp.fromISOString(defectAttr[j].value.id);
							if (modDate) {
								labels[7] = modDate.getTime();
							} else {
								// fail to get date object, use date time string for display 
								labels[7] = defectAttr[j].value.label;
							}
                            attributesSet++;
                            break;
                    }
                    if (attributesSet >= 8) {
                        // break out if we get all attributes that we need
                        break;
                    }
                }
                queryResultRows.push({id: labels[1], labels: labels});
			}
			return {rows: queryResultRows};
		},
		
		_updateTable: function(defect, remove){
			if(remove){
				//TODO: Add remove functionlity
				//var row = dojo.dojo.byId("tr"+ defect.id);
				//var tb = row.parentNode;
				//dojox.data.dom.removeChildren(imgCellCurr);
			} else {
				var targetRow = this._getEmptyRow();
				targetRow.id = "tr"+ defect.id;
				this._defectsTableBody.appendChild(targetRow);
				dojox.data.dom.removeChildren(targetRow);
				
				var td1 = this._getEmptyCell();
				var anchor = document.createElement("a");
				anchor.style.cursor = "pointer";
				anchor.href = "javascript:{}";
				anchor.onclick = dojo.hitch(this,function(){
					this._handleAssociateDefect(defect.id);
				});
				anchor.appendChild(document.createTextNode(defect.id));
				td1.appendChild(anchor);
				targetRow.appendChild(td1);

				var td2 = this._getEmptyCell();
				var summary = this._restoreTags(defect.summary);
				td2.appendChild(document.createTextNode(summary));
				targetRow.appendChild(td2);
			}
		},
		// function from com.ibm.team.workitem.web.ui.internal.view.editor.EditorUtil
		_restoreTags: function(value) {
			var rawText = value;
			rawText= rawText.replace(/\&gt;/gi,">");
			rawText= rawText.replace(/\&lt;/gi,"<");
			rawText= rawText.replace(/\&amp;/gi,"&");
			rawText= rawText.replace(/\&tilde;/gi,"~");
			rawText= rawText.replace(/\&quot;/gi,"\"");
			rawText= rawText.replace(/\&circ;/gi,"^");
			rawText= rawText.replace(/\&nbsp;/gi," ");
			rawText= rawText.replace(/<br\/>/gi,"\n");
			rawText= rawText.replace(/\&#09;/g, "\t");
			return rawText
		},
		_getEmptyRow: function(){
			var row = document.createElement("tr");
			row.className = "item-table-row";
			return row;
		},
		
		_getEmptyCell: function(span, align){
			var cell = document.createElement("td");
			cell.className = "table-cell";
			if ( span != null )
				cell.colSpan = span;
			if ( align != null )
				cell.align = align;
			return cell;
		},
		_handleAssociateDefect:function (searchText, openOnly){
			if(this.processing)
				return;
			this.processing = true;
			if (!this._wiView)
            	this._wiView = new QMWorkItemPageView(); 
			this._wiView.setParent(this);
            this._wiView.setDialog(this.parentDialog);
	        if (NON_NUMERIC_REGEX.test(searchText)){
                this._nonNumericSearch = true;
				dojo.style(this._addThisDefect,"display","none");
				dojo.style(this.statusErrorNode,"display","none");
				dojo.style(this._addSelectedDefect,"display","inline");
				this.msgLabel.innerHTML = "";
                var operation= this._wiView.getController().createOperation("Searching Work Items", "searchWorkItem");
                this._wiView.getController().startOperation(operation);
                var query = {q:searchText,o:openOnly};
                this._wiView.getController().search(query);
                if (operation) {
                    this._wiView.getController().finishOperation(operation);
                }
				var self = this;
				this._wiView._getQueryResultsWidget().setCallback(
					function(){
						self._workItemContainer.appendChild(self._wiView._multipaneContentWidget.domNode);
						dojo.style(self._workItemContainer,"display","inline");
                        dojo.style(self._relatedDefectsContainer,"display","none");
						if(self.parentDialog && self.parentDialog.updatePosition)
							self.parentDialog.updatePosition();
						self.processing = false;
					});
            } else {
                this._nonNumericSearch = false;
                dojo.style(this._addSelectedDefect,"display","none");
				var operation= this._wiView.getController().createOperation("Opening Work Item", "showWorkItem");
                this._wiView.getController().startOperation(operation);
                var self = this;
                var handlerObj= {
                    showWorkItemHandler: function(workItem) {
                        self._workItem = workItem;
                        dojo.style(self._addThisDefect,"display","none");
                        dojo.style(self._workItemContainer,"display","none");
                        dojo.style(self.statusErrorNode,"display","none");
                        if(workItem){
							if(workItem.workItemType.id != "defect"){
								dojo.style(self.statusErrorNode,"display","inline");
								self.statusErrorNode.src = dojo.moduleUrl("com.ibm.asq.common.web", "ui/internal/view/layout/images/error_obj.gif");
								self.msgLabel.innerHTML = Constants.getMessage("labelNotADefect",searchText);
							} else {
								dojo.style(self._addThisDefect, "display", "inline");
								self._addThisDefect.disabled = false;
								self.msgLabel.innerHTML = "";
                                self._wiView.setNewWorkItemInitialValues(null);   
                                self._wiView.showWorkItemEditor(workItem.id, "overview", false);
                                self._workItemContainer.appendChild(self._wiView._multipaneContentWidget.domNode);
                           	    dojo.style(self._workItemContainer,"display","inline");
								if(self.parentDialog && self.parentDialog.updatePosition)
									self.parentDialog.updatePosition();
							}	
                        } else {
							dojo.style(self.statusErrorNode,"display","inline");
							self.statusErrorNode.src = dojo.moduleUrl("com.ibm.asq.common.web", "ui/internal/view/layout/images/error_obj.gif");
                            self.msgLabel.innerHTML = Constants.getMessage("labelWINotFound",searchText);
                        }
						self.processing = false;
                        if (operation)
                            self._wiView.getController().finishOperation(operation);
                    },
                    error: function(error) { 
                        self._wiView.getController().handleError(error, "Error searching work item");
						self.processing = false;
                    }
                };
                var responseHandler = new ServiceResponseHandler(handlerObj, "showWorkItemHandler", "error");            
                WorkItemClient.getWorkItemDTO(responseHandler, { id: searchText});
            }
        },

        _getSelectedDefects:function(){
            if(this._nonNumericSearch){
				var rows = this.addRelatedDefects ? 
				            this.relatedDefectsWidget.tableViewer.getCheckedRows() :
				            this._wiView._getQueryResultsWidget().tableViewer.getCheckedRows();
                if(rows && rows.length>0){
                    for(var i=0;i<rows.length;i++){
                        var defect = {
                            id: rows[i].labels[1],
                            summary:rows[i].labels[2],
							status:rows[i].labels[4]
                        }
                        var found = false;
                        if(this.defectList.length>0){
                            var j=0;
							var existingDefect;
                            while((existingDefect = this.defectList[j++])){
                                if(defect.id == existingDefect.id){
                                    found = true;
                                    break;
                                }
                            }
                        }                        
                        if(!found){
							if(defect.status == "Closed")
								defect.statusId = 5;
							else
								defect.statusId = 1;
                            this.defectList.push(defect);
                            this._updateTable(defect, false);
                        }                
                    }
                }
            }else{
                if(this._workItem.workItemType.id == "defect"){                
 					this.receiveDefect(this._workItem);
                    this._workItem = undefined;  
 				}
            }
			if(this.parentDialog)
				this.parentDialog.close();
        },
		
		_handleAddDefect: function(/*e,*/ details){
			var self = this;
            var callbackObj = dojo.hitch(self, "addDefect");//self.addDefect;
			if (!this._wiView)
				this._wiView = new QMWorkItemPageView({callback: callbackObj});
            this._wiView.setNewWorkItemInitialValues(details);   
			this._wiView.setParent(this);
            this._wiView.setDialog(this.parentDialog);            
			var operation= this._wiView.getController().createOperation("Opening New Work Item", "newWorkItem");
			this._wiView.getController().startOperation(operation);
			var handlerObj= {
				newWorkItemHandler: function(workItem) {
					self._wiView.getController()._promoteAttributes(workItem);
					self._wiView.showNewWorkItemEditor("defect", workItem.id, "overview");
					self._workItemContainer.appendChild(self._wiView._multipaneContentWidget.domNode);
					dojo.style(self._workItemContainer,"display","inline");
					if(self.parentDialog && self.parentDialog.updatePosition)
						self.parentDialog.updatePosition();
					if (operation) {
						self._wiView.getController().finishOperation(operation);
					}
					dojo.publish(EventTopics.INITIALIZE_QUERIES, []);
				},
				error: function(error) { 
					self._wiView.getController().handleError(error, "Error creating new work item");
					dojo.publish(EventTopics.INITIALIZE_QUERIES, []);
				}
			};
			var responseHandler = new ServiceResponseHandler(handlerObj, "newWorkItemHandler", "error");			
			WorkItemClient.getWorkItemDTO(responseHandler, { newWorkItem: "true", typeId: "defect" });	
            	
		},

		_addInline: function(){
			dojox.data.dom.removeChildren(this._defectsTableBody);
			var len = this.defectList.length;
			for(var j=0;j<len;j++)
				this._updateTable(this.defectList[j], false);
		},
		
		handleCancelClick: function(){
			if(this.parentDialog)
				this.parentDialog.close();
		},
		
		addDefect: function(workItemId){
            var self = this;
            var handlerObj = {
                success: function(workItemDTO) {
                    self.receiveDefect(workItemDTO);
                    if(self.parentDialog)
						self.parentDialog.close();
                },
                error: function(e) {
                  self._error(e);   
                }
            }
            var responseHandler = new ServiceResponseHandler(handlerObj, "success", "error");
            WorkItemClient.getWorkItemDTO(responseHandler, { id: workItemId });
        },
		uninitialize: function(){
			if(this._wiView)
				this._wiView.destroy();
				
			if (this.searchInputWidget){
				this.searchInputWidget.destroy();
			}	
			this._wiView = null;
		},
		_error: function(errorObj){
			console.error("Error: (message: '" + errorObj.message + "') from DefectView#_error");
		}
}
);

})();	
