/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005-2006. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.construction.properties._workItem.QMQueryResults");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.team.workitem.web.client.internal.ImageClient");
dojo.require("net.jazz.ajax.toolbox.lang.internal.Lang");
dojo.require("com.ibm.team.workitem.web.client.util");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
(function() { // module container

var Constants 				= com.ibm.rqm.planning.web.client.internal.Constants;
var checkNotNull 			= net.jazz.ajax.toolbox.lang.checkNotNull;
var WorkItemUtil			= com.ibm.team.workitem.web.client.util;

var ImageClient				= com.ibm.team.workitem.web.client.internal.ImageClient;
var ImageCache              = com.ibm.asq.common.web.ui.internal.view.common.ImageCache;

var ROW_WORK_ITEM_ID_PROP	= "_jazzRowWorkItemId";
var ROW_QUERY_PROP			= "_jazzRowQuery";
var ROW_LINKS_PROP			= "_jazzRowLinks";

// constant for stripping hyperlinks
var STRIP_HYPERLINK_REGEX	= /(<a.*?>)(.*?)(<\/a>)/gi;
var TableConstants = com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;
var Utility        = com.ibm.rqm.planning.web.ui.internal.util.Utility;
dojo.declare("QMQueryResults.TableProvider", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider,
{
    
    getNumColumns: function(content){
        return 7;
    },
    
    
    getColumnHeading: function(content, index){
        var headings = [
            Constants.getMessage("labelId"),
            Constants.getMessage("labelSummary"),
            Constants.getMessage("labelOwnedBy"),
            Constants.getMessage("labelstatus"),
            Constants.getMessage("labelPriority"),
            Constants.getMessage("labelSeverity"),
            Constants.getMessage("labelModifiedDate")
        ];
        return headings[index];
    },

    getIsColumnGroupable: function(content, atColumnIndex){
        return (atColumnIndex == 3);     
    },

    getIsColumnSortable: function(content, atColumnIndex){
        switch(atColumnIndex) {
            case 0:
                return true;
        }
        return false;   
    },
    
    getColumnWidth: function(content, atColumnIndex){
        switch(atColumnIndex) {
            case 0: 
                return 10;
            case 1: 
                return 40;
            case 2: 
                return 10;
            case 3: 
                return 10;
            case 4: 
                return 10;
            case 5: 
                return 10;                  
            case 6: 
                return 10;                                   
        }
        return 0;
    },
    
    getContentObjects: function(content){
        return content;
    },
    
    getRowDataId: function(rowData){
        return "_table_row_for_execution_result_" + rowData.id;
    },
    
    getCellDisplayType: function(rowData, atColumnIndex){
        var type = TableConstants.RENDER_TYPE_TEXT;
        switch(atColumnIndex) {
            case 5: 
                type = TableConstants.RENDER_TYPE_IMAGE;
                break;
            case 6: 
                type = TableConstants.RENDER_TYPE_DATE;
                break;               
                               
        }
        return type;
    },

    getCellDisplayData: function(rowData, atColumnIndex){
        var val = "";
        switch(atColumnIndex) {
            case 0: 
                val = rowData.labels[1];
                break;
            case 1: 
                val = rowData.labels[2];
                break;
            case 2: 
                val = rowData.labels[3];
                break;
            case 3: 
                val = rowData.labels[4];
                break;          
            case 4: 
                val = rowData.labels[5];
                break;  
            case 5: 
                val = rowData.labels[6];
                break;  
            case 6: 
                var nonNumericRegex= /[^0-9]/;
                if (nonNumericRegex.test(rowData.labels[7])) {
					val = rowData.labels[7];
				} else {
                    val = Utility.formatDateFromLong(rowData.labels[7]);
				}
                break; 
        }
        return val;
    },

    getCellDisplayExtendedInfo: function(rowData, atColumnIndex){  
        var val = null;
		switch(atColumnIndex) {
            case 5: 
                val = {
					tooltip: rowData.labels[6],
					image: ImageCache["SEVERITY_" + rowData.labels[6].toUpperCase()]
				};
                break;
        }
        return val;
    }
    
    
});
	dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.construction.properties._workItem.QMQueryResults",
	[dijit._Widget, dijit._Templated],
	{
        templateString: '<div dojoAttachPoint="_tableViewerNode" class="com-ibm-rqm-test-artifact-table-view">' +
                          '      <div dojoAttachPoint="_queryName" class="query-name"></div>' +
                          '</div>',

        widgetsInTemplate: true,
		
		constructor: function() {
			this._rowCache= [];
			this.callback = null;
		},
        
		postCreate: function(){
            this.inherited("postCreate", arguments);
        },
		
		/*
		 *  Return the results of the last query
		 */ 
		getResults: function() {
			return this._rowCache;
		}, 
		
		/*
		 * Methods for table population and clearing.
		 */
		
		setQueryResultsTable: function(query, queryResultsSummaryPage, orderByAttribute, direction) {
			checkNotNull(query, "query");
			checkNotNull(queryResultsSummaryPage, "queryResultsSummaryPage");
            this._queryName.innerHTML = query.name;
            if(!this.tableViewer)
			{
				this.tableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer();        
            	this._tableViewerNode.appendChild(this.tableViewer.domNode);
	            this.tableViewer.setContentProvider(new QMQueryResults.TableProvider());
	            this.tableViewer.setTableListener(new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableListener());
				this.tableViewer.setContentPageSize(20);
				this.tableViewer.setTableRowsCheckable(true, /* isSingleSelect */false);
			}
            var defectRows = [];                      
            var i=0;
            //show only results which are defects.
            if(queryResultsSummaryPage.rows){
				var row;
                while((row=queryResultsSummaryPage.rows[i++])){
                    if(row.labels[0] == "Defect"){
						row.labels[2] = this._restoreTags(row.labels[2]);
                        defectRows.push(row);
                    }
                }
            }
            this.tableViewer.setContent(defectRows);
            this.tableViewer.show();
			if(this.callback)
				this.callback();
		},

		clearSelection: function() {
			if(this.tableViewer){
				this.tableViewer.rowCheckedHandler.clearRowStates();
	            this.tableViewer.rowRenderer.clearRowStates();
			}
			if(this.callback)
				this.callback();
        },
		
		setCallback: function(callback){
			this.callback = callback;
		},
		_restoreTags: function(value) {
			var rawText= value;
			rawText= rawText.replace(/\&gt;/gi,">");
			rawText= rawText.replace(/\&lt;/gi,"<");
			rawText= rawText.replace(/\&amp;/gi,"&");
			rawText= rawText.replace(/\&tilde;/gi,"~");
			rawText= rawText.replace(/\&quot;/gi,"\"");
			rawText= rawText.replace(/\&circ;/gi,"^");
			rawText= rawText.replace(/\&nbsp;/gi," ");
			rawText= rawText.replace(/<br\/>/gi,"\n");
			rawText= rawText.replace(/\&#09;/g, "\t");
			return rawText;
		}
	}
);

})();