/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading.. com.ibm.rqm.planning.web.ui.internal.view.construction.properties._workItem.QMWorkItemPageView");
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.construction.properties._workItem.QMWorkItemPageView");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.team.workitem.web.client.util");
dojo.require("com.ibm.team.workitem.web.ui.internal.page.WorkItemPageView");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.common.MultipaneContentView");

dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.properties._workItem.QMWorkItemEditor");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.properties._workItem.QMWorkItemPageController");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.properties._workItem.QMMultipaneContentView");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.properties._workItem.QMRecentWorkItemView");

dojo.require("net.jazz.ajax.toolbox.lang.internal.Lang");
dojo.require("net.jazz.ajax.ui.SideNavigationLayout");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.properties._workItem.QMQueryResults");

(function(){ // module container
    var checkNotNull = net.jazz.ajax.toolbox.lang.checkNotNull;
    var WorkItemUtil = com.ibm.team.workitem.web.client.util;
	var QMWorkItemEditor = com.ibm.rqm.planning.web.ui.internal.view.construction.properties._workItem.QMWorkItemEditor;
	var QMWorkItemPageController = com.ibm.rqm.planning.web.ui.internal.view.construction.properties._workItem.QMWorkItemPageController;
	var QMMultipaneContentView = com.ibm.rqm.planning.web.ui.internal.view.construction.properties._workItem.QMMultipaneContentView;
	var QMRecentWorkItemView = com.ibm.rqm.planning.web.ui.internal.view.construction.properties._workItem.QMRecentWorkItemView;
	
    var WORK_ITEM_EDITOR_ID = "__jazzWorkItemEditor";
    var checkNotNull        = net.jazz.ajax.toolbox.lang.checkNotNull;
    var checkNonNegative    = net.jazz.ajax.toolbox.lang.checkNonNegative;
    var QUERY_BUILDER_ID    = "__jazzQueryBuilder";
    var QUERY_RESULTS_ID    = "__jazzQueryResults";

    
    dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.construction.properties._workItem.QMWorkItemPageView", [com.ibm.team.workitem.web.ui.internal.page.WorkItemPageView], {
    
        postCreate: function(){
        	this.dialog = null;
			this.childWidgets = [];
            this.controller = new QMWorkItemPageController(this);
            
            //To avoid multiple creation
            //this.id = "com.ibm.rqm.planning.web.ui.internal.view.construction.properties._workItem.QMWorkItemPageView";
            
            // Initialize the multipane content widget
            var parms = {
                parentController: this.controller
            };
            this._multipaneContentWidget = /* createWidget */ new QMMultipaneContentView(parms);
            
            this._leftNavigationLayout = new net.jazz.ajax.ui.SideNavigationLayout({}, this._appContainer);
            
            // lazily initialize the ActionRegistry alias
            //			ActionRegistry = PlatformUI.getWorkbench().getActionRegistry();
            
            // register actions
            //			ActionRegistry.registerAction("com.ibm.team.workitem._showDefaultView", this.controller, "_showDefaultView");
            
            //			var validActions = ["search", "simpleQuery", "runSavedQuery", "runNewQuery", "newQuery", "editQuery", "newWorkItem", "viewWorkItem" ];
            //			var self = this;
            //			dojo.forEach(validActions,
            //				function(x) {
            //					ActionRegistry.registerAction("com.ibm.team.workitem." + x, self.controller, x); 
            //				}
            //			);         
            
            this._initializeNavigation();
        },
        
        uninitialize: function(){
			var multipaneController = this._multipaneContentWidget.controller;
			var widgets = multipaneController._widgetCache;
			dojo.forEach(widgets, function(child) {
				try {
					var w = child.widget;
					var id = w.id;
					if (w.destroyWidget){
						w.destroyWidget();
					}
					if(w.destroyRecursive) {
						w.destroyRecursive();
					} else {
						if(w.destroy) {
							w.destroy();
						}
					}
				} catch(e) {
					console.debug('Error destroying: ' + child);// ignore
				}
			});
			if(multipaneController._multipaneContentView && multipaneController._multipaneContentView.destroy)
				multipaneController._multipaneContentView.destroy();
			multipaneController._widgetCache=[];
			var rwi = this._recentWorkItemWidget;
			if ( rwi && rwi.destroy) {
				rwi.destroy();
			}
			rwi = this._unfinishedWorkItemWidget;
			if ( rwi && rwi.destroy) {
				rwi.destroy();
			}
			if(this._leftNavigationLayout)
				this._leftNavigationLayout.destroy();
        },
        
        _handleDialogBeforeClose: function() {
            var editor = this.workItemEditor;
            
            // our dialog is about to close, inform the editor to
            // prepare for destroying non-visible widgets.
            if(editor && editor.preDestroyWidget) {
                editor.preDestroyWidget();
            }
        },
        
        setNewWorkItemInitialValues: function(initValues) {
            this.initWorkItemData = initValues;
        },
        
		//@Overridden
        _initializeNavigation: function(){
//            this.inherited(arguments);
			this._recentWorkItemWidget = new QMRecentWorkItemView( 
						{parentController: this.controller, heading: "Recently Viewed"});
			this._unfinishedWorkItemWidget = new QMRecentWorkItemView( 
						{parentController: this.controller, heading: "Unsaved Work", hasSectionCount: true});
			this._recentWorkItemWidget.navSection = this._leftNavigationLayout.addNavigationSection(this._recentWorkItemWidget, this._recentWorkItemWidget.heading, true);
			this._unfinishedWorkItemWidget.navSection = this._leftNavigationLayout.addNavigationSection(this._unfinishedWorkItemWidget, this._unfinishedWorkItemWidget.heading, true);
        },

        //@Overridden
        // To show our augmented implementation of the work item editor.
        _showWorkItemEditor: function(parms) {
            var id = parms.id || parms.tempId;
            var workItemEditorWidget = this._multipaneContentWidget.getCachedWidget(WORK_ITEM_EDITOR_ID, id);
            if(!workItemEditorWidget) {
                workItemEditorWidget = /* createWidget */ new QMWorkItemEditor({
                    isNew:true,
                    parentController: this.controller,
                    multipaneContentWidget: this._multipaneContentWidget
                });
            }
            
            parms.onSuccess= dojo.hitch(this,this._showWorkItemEditorComplete);
            parms.onError= dojo.hitch(this,this._showWorkItemEditorError)

            if (this.callback) {
                workItemEditorWidget.setCallback(this.callback);
            }
            
            if(this.initWorkItemData) {
                workItemEditorWidget.setInitialValues(this.initWorkItemData);
            }
			if(this.parentWidget && this.parentWidget.workItemTypeId) 
				parms.type = this.parentWidget.workItemTypeId;
            workItemEditorWidget.initializeWorkItemEditor(parms);
            this.workItemEditor = workItemEditorWidget;
        },
        
		//@Overridden
        _getWorkItemEditorWidget: function(workItem, initialTab){
            checkNotNull(workItem, "workItem");
            
            var workItemEditorWidget = this._multipaneContentWidget.getCachedWidget(WORK_ITEM_EDITOR_ID, workItem.id);
            if (!workItemEditorWidget) {
                workItemEditorWidget =                /* createWidget */
                new QMWorkItemEditor({
                    parentController: this.controller,
					multipaneContentWidget: this._multipaneContentWidget
                });
            }
            
            if (this.callback) {
                workItemEditorWidget.setCallback(this.callback);
            }
            
            return workItemEditorWidget;
        },
        
		//@Overridden
        showQueryResults: function(query, queryResultsSummaryPage, orderByAttrib, orderDirection, keepEditor) {
            checkNotNull(query, "query");
            checkNotNull(queryResultsSummaryPage, "queryResultsSummaryPage");
            
            checkNonNegative(queryResultsSummaryPage.totalCount, "queryResultsSummaryPage.totalCount");
            checkNonNegative(queryResultsSummaryPage.startIndex, "queryResultsSummaryPage.startIndex");

            if (!keepEditor)
                this._getQueryCompositeWidget().clearContent(QUERY_RESULTS_ID);
                
            var pageControlParms= {
                query: query,
                queryResultsSummaryPage: queryResultsSummaryPage,
                queryResultsWidget: this._getQueryResultsWidget(),
                queryOrderBy: orderByAttrib ? orderByAttrib : null,
                queryOrderDirection: orderDirection ? orderDirection : null};
                        
            this._setCompositeContent(
                    QUERY_RESULTS_ID,
                    this._getQueryResultsWidget().domNode);
                    
            var results = this._getQueryResultsWidget();
            results.setQueryResultsTable(query, queryResultsSummaryPage, orderByAttrib, orderDirection);    
        },
        
		//@Overridden
        _getQueryResultsWidget: function() {
            if (!this.queryResultsWidget) {
                var parms= {parentController: this.controller, parentView: this};
                this.queryResultsWidget = /* createWidget */ new com.ibm.rqm.planning.web.ui.internal.view.construction.properties._workItem.QMQueryResults(parms);
            }
            return this.queryResultsWidget;
        },
		
		//@Overridden
        _setMainContent: function(widgetId, mainAreaWidget, metaAreaWidgetDomNode, instanceId, /* updateNav */ skipNavUpdate) {
            this._currentMainWidgetId= widgetId;
            
            // Display the mainAreaWidget in the multi-pane content area
            this._multipaneContentWidget.showContent(widgetId, mainAreaWidget, instanceId, skipNavUpdate);
            
            
            // Set the content to display the multi-pane content area
            //this._leftNavigationLayout.setMainContent(this._multipaneContentWidget.domNode, metaAreaWidgetDomNode);
        },		

        _updateParentDialogPos: function() {
            var dialog = this.dialog;
            
            // tickle the dialog to recalculate the placement position with
            // our content's height.
            if(dialog && dialog.updatePosition) {
                dialog.updatePosition();
            }              
        },
        
        //@Overridden - to update the parent dialog position once the editor widget has been fully
        // loaded. This is necessary to get an accurate position calculation with the full content's
        // height.
        _showWorkItemEditorComplete: function() {
            this.inherited(arguments);
            this._updateParentDialogPos();
        },

        //@Overridden - to update the parent dialog position once the editor widget has been fully
        // loaded. This is necessary to get an accurate position calculation with the full content's
        // height.
        _showWorkItemEditorError: function() {
            this.inherited(arguments);
            this._updateParentDialogPos();            
        },
        
        setParent: function(parent){
            this.parentWidget = parent;
        },
        
        addDefect: function(defectId, summary){
            if (this.parentWidget != null) 
                this.parentWidget.addDefect(defectId, summary);
        },
		
		removeEditorTab: function(id, /* show next tab */ showNext) {
			this._multipaneContentWidget.removeCachedWidget(WORK_ITEM_EDITOR_ID, id);
//			if(showNext) {
//				if(!this._multipaneContentWidget.showNextView()) {
//					this.controller._openDefaultView();
//				}
//			}
			//TODO: This becomes specific to Defect view, need to update this code to handle callbackObj
			if(this.parentWidget)
				this.parentWidget.handleCancelClick();
		},
		
		setDialog: function(dialog) {
			this.dialog = dialog;
            dialog.onBeforeClose = dojo.hitch(this, "_handleDialogBeforeClose");
		},
		
        _error: function(errorObj){
            alert("Error: (message: '" + errorObj.message + "') from QMWorkItemPageView#_error");
        }
        
    });
    
})();
