//EPB
/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.execution.web.ui.internal.view.execution.ExecutionPageBody");
dojo.provide("com.ibm.rqm.execution.web.ui.internal.view.execution.ExecutionPageBody");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojox.data.dom");
dojo.require("jazz.app.ResourceLink");

dojo.require("net.jazz.ajax.ui.PlatformUI");
dojo.require("jazz.core.loader");

//Clients
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionWorkItemClient");
dojo.require("com.ibm.rqm.planning.web.client.internal.construction.TestScriptClient");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultClient");
//Local widget
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.RelatedInfo");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.execution.EnvironmentContainer");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.CollapsibleSection");
dojo.require("com.ibm.asq.common.web.ui.internal.util.GlobalEvents");
dojo.require("com.ibm.rqm.execution.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultStates");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.execution.MachineDetails");
dojo.require("com.ibm.rqm.execution.web.client.internal.mapper.ExecutionResultMapper");
dojo.require("com.ibm.rqm.defects.web.client.ChangeRequestManager");
dojo.require("com.ibm.rqm.defects.web.client.internal.CmIntegrationClient");
dojo.require("com.ibm.rqm.execution.web.client.internal.mapper.EWIMapper");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");

(function() { // module container

var TestScriptClient				= com.ibm.rqm.planning.web.client.internal.construction.TestScriptClient;
var ServiceResponseHandler 			= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var ExecutionWorkItemClient 		= com.ibm.rqm.execution.web.client.internal.execution.ExecutionWorkItemClient;
var ImageCache						= com.ibm.rqm.execution.web.ui.internal.view.common.ImageCache;
var ResultClient					= com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultClient;
var Constants                       = com.ibm.rqm.planning.web.client.internal.Constants;
var GlobalEvents 					= com.ibm.asq.common.web.ui.internal.util.GlobalEvents;
var Utility							= com.ibm.rqm.execution.web.ui.internal.util.Utility;
var ResultStates					= com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultStates;
var ViewHeaderLayout 				= com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout;
var MachineDetailSection			= com.ibm.rqm.execution.web.ui.internal.view.execution.MachineDetails;
var ChangeRequestManager			= com.ibm.rqm.defects.web.client.ChangeRequestManager;
var CmIntegrationClient				= com.ibm.rqm.defects.web.client.internal.CmIntegrationClient;
var DEFECT_URL                      = "#action=com.ibm.team.workitem.viewWorkItem&id=";
var PrintViewBaseURI 				= "action=com.ibm.rqm.planning.printview.execution&";
var ExecutionResultMapper			= com.ibm.rqm.execution.web.client.internal.mapper.ExecutionResultMapper;
var EWIMapper						= com.ibm.rqm.execution.web.client.internal.mapper.EWIMapper;
var RelatedInfoPanel				=com.ibm.asq.common.web.ui.internal.view.common.RelatedInfoPanel;
var AlertDialog 					= com.ibm.asq.common.web.ui.internal.widgets.AlertDialog;

dojo.declare("com.ibm.rqm.execution.web.ui.internal.view.execution.ExecutionPageBody",[dijit._Widget, dijit._Templated],
	{
		templatePath: dojo.moduleUrl("com.ibm.rqm.execution.web", "ui/internal/view/templates/execution/ExecutionPageBody.html"),
		
		ewiItemId: null,
		runScriptId: null,
		parentController: null,
		widgetsInTemplate: true,
		fetchingScript: false,
		
		constructor: function() {
			this._editorRegistry = dojo.getObject(Constants.EDITOR_REGISTRY_OBJECT_ID);
            this.relatedDefects = [];
		},

		postCreate: function() {		
			this.ewiItemId = this.ewi;
			Utility.initExecutionPreference();//Initialize exec pref to be used by execution widgets
			this.runScriptId = this.runScript !="null"?this.runScript:null;
			if(this.runScriptId == null && this.ewi.defaultScript)
				this.runScriptId = this.ewi.defaultScript.versionableItemId;
			
			if(this._resultId != null){
				var args = {
					resultItemId: this._resultId
				}
				this.fetchingScript = true;
				var responseHandler=new ServiceResponseHandler(this, "_updateScriptId", "_error");
		    	ResultClient.getExecutionResultDTO(responseHandler, args);
			}
			else{
				if(this.runScriptId != null){
					this.fetchingScript = true;
					var args = {
						versionableItemId: this.runScriptId,
						includeArchived: true
					};
					var responseHandler = new ServiceResponseHandler(this, "_preInitialize", "_error");			
					TestScriptClient.getTestScripts(responseHandler, args);
				}
				else{
					this._preInitialize(null);
				}
			}
            this._relatedDefectInfo = new RelatedInfoPanel();
            this._relatedDefectInfo.getInfoGroup(Constants.getMessage("labelRelatedDefects"), true);
		},
		
        getStaticRelatedInfo: function() {
            return this._relatedDefectInfo;
        },
        
        getStaticRelatedInfoId: function() {
            if (this.ewiItemId){
                return this.declaredClass + this.ewiItemId;
            } else {
                var date = new Date();
                return this.declaredClass + date.toString();
            }
        },
        
        _addRelatedInfo: function() {
            if (this._ewi) {
                var responseHandler = new ServiceResponseHandler(this, "_addrelatedDefectsInfo", "_error");
                ExecutionWorkItemClient.getRelatedDefects(responseHandler, {uuid_ewi: this._ewi.itemId, ewiStateId: this._ewi.stateId});
            }
        },
        
        _addrelatedDefectsInfo: function(relatedDefects) {
            if(!relatedDefects) {
                return;
            } 
            var group = this._relatedDefectInfo.getInfoGroup(Constants.getMessage("labelRelatedDefects"));
            dojox.data.dom.removeChildren(group._actionListNode);

            // combine defects from same test scripts and same test case and remove duplicates
            var allRelatedDefects = {};
            var defects = [];
            this.relatedDefects = [];
            if (relatedDefects.defectsByTestScript && dojo.isArray(relatedDefects.defectsByTestScript)) {
				var len = relatedDefects.defectsByTestScript.length;
                for (var j = 0; j < len ; j++) {
                    var workitemId = relatedDefects.defectsByTestScript[j].workItem.itemId;
                    allRelatedDefects[workitemId] = relatedDefects.defectsByTestScript[j];
                }
            }
            if (relatedDefects.defectsByTestCase && dojo.isArray(relatedDefects.defectsByTestCase)) {
				var len2 = relatedDefects.defectsByTestCase.length;
                for (var k = 0; k < len2; k++) {
                    var workitemId = relatedDefects.defectsByTestCase[k].workItem.itemId;
                    allRelatedDefects[workitemId] = relatedDefects.defectsByTestCase[k];
                }
            }
            for (var key in allRelatedDefects) {
                defects.push(allRelatedDefects[key]);
            }

            // limit the number of display items
            var length = defects.length;
            if (length > Constants.MAX_INFO_PANEL_DEFECTS) 
                length = Constants.MAX_INFO_PANEL_DEFECTS;

            for (var i = 0; i < length; i++) {
                // extract the attributes needed
                var defectAttr = defects[i].workItem.attributes;
                var id = null;
                var summary = null;
                var state = null;
				var len3 = defectAttr.length;
                for (var j = 0; j < len3; j++) {
                    switch (defectAttr[j].key) {
                        case "id":
                            id = defectAttr[j].value.id;
                            break;
                        case "summary":
                            summary = defectAttr[j].value.content;
                            break;
                        case "internalState":
                            state = defectAttr[j].value.label;
                            break;
                    }
                    if (id && summary && state) {
                        // break out if we get all attributes that we need
                        break;
                    }
                }

                // add defect to the related defects panel
                this.relatedDefects.push(defects[i]);
                var defectText = "";
                if (summary.length > 20) 
                    defectText = id + " : " + summary.substr(0, 15) + "... - " + state;
                else 
                    defectText = id + " : " + summary + " - " + state;
                var defectUrl = DEFECT_URL + id;
                this._relatedDefectInfo.addLink(Constants.getMessage("labelRelatedDefects"), defectText, defectUrl);
            }
        },   
		
		_addRelatedExternalInfo: function(){
            if (this.ewiItemId) {
                CmIntegrationClient.getReferencedDefects({ewiItemId: this.ewiItemId}, dojo.hitch(this, function(status, result){
					if(status.isOK()){
						this._addRelatedExternalDefectsInfo(result);
					}else{
						this._getRelatedDefectsError(result);
					}
				}));
            }
		},
		
		_addRelatedExternalDefectsInfo: function(relatedDefectsArray){
			var group = this._relatedDefectInfo.getInfoGroup(Constants.getMessage("labelRelatedDefects"));
            dojox.data.dom.removeChildren(group._actionListNode);
            if(!relatedDefectsArray) {
                return;
            }

            // combine defects from same test scripts and same test case and remove duplicates
            var allRelatedDefects = {};
            var defects = [];
            this.relatedDefects = [];
			var len = relatedDefectsArray.length;
			for (var i = 0; i < len; i++) {
				allRelatedDefects[relatedDefectsArray[i].uri] = relatedDefectsArray[i];
			}
            for (var key in allRelatedDefects) {
				defects.push(allRelatedDefects[key]);
			}

            // limit the number of display items
            var length = defects.length;
            if (length > Constants.MAX_INFO_PANEL_DEFECTS) 
                length = Constants.MAX_INFO_PANEL_DEFECTS;
            for (var i = 0; i < length; i++) {
                // skip the defect if it is already one of the blocking defects
                if (this.blockingDefects && dojo.isArray(this.blockingDefects)) {
					var len2 = this.blockingDefects.length
                    var skipAlreadyAdded = false;
                    for (var k = 0; k < len2; k++) {
                        if (this.blockingDefects[k].id == defects[i].id) {
                            skipAlreadyAdded = true;
                            break;
                        }
                    }
                    if (skipAlreadyAdded) {
                        continue;
                    }
                }
				
                // add defect to the related defects panel
                this.relatedDefects.push(defects[i]);
				var link = this._relatedDefectInfo.addLink(Constants.getMessage("labelRelatedDefects"), defects[i].id, defects[i].uri, null, true);
				var resourceLinkArgs= { 
						uri: defects[i].uri,
						presentationUri: defects[i].uri,
						label: ""
					};
				new jazz.app.ResourceLink(resourceLinkArgs, link);
            }
		},  
        
		_updateScriptId: function(result){
			this._preInitialize(result.script);
		},
		
		_preInitialize: function(testScript){
			if(this.fetchingScript && (!testScript || testScript.length > 1)){
				this._displayAlertDialog(Constants.getMessage("errRetrieveTestScript"));
                return;
			}
			
			this.fetchingScript = false;
			if(testScript){
				if(testScript.length > 0)
					this.testScript = testScript[0];
				else
					this.testScript = testScript;	
					
				this.runScriptId =  this.testScript.versionableItemId;
			}
			
			var responseHandler = new EWIMapper(this, "_intializeValues", "_error");			
			ExecutionWorkItemClient.getExecutionWorkItemByItemId(responseHandler, {itemId: this.ewiItemId, resolveResults: false});
		},

		_intializeValues: function(ewi)	{
			if(!ewi || ewi.length > 1)	{
				this._displayAlertDialog(Constants.getMessage("errRetrieveEWI"));
                return;
			}
			this._ewi = ewi.length?ewi[0]:ewi;
			this._ewiStateId = ewi.stateId;
			this.updateStatus(this._ewi.testCase.name + " "+Constants.getMessage("labelExecution"), ImageCache.PROGRESS_START)
			var args={
					parentController: this.parentController,
					tsName: this.testScript? this.testScript.name:"",
					showEnvDetails: false,
					showProgressBar: (this.printView ? false : true),
					ewi: this._ewi
				}
			dojox.data.dom.removeChildren(this._envWidget);
			this.envWidget= new com.ibm.rqm.execution.web.ui.internal.view.execution.EnvironmentContainer(args);
			var params = {
				title: Constants.getMessage("labelTestEnvironment"),
				summary: this.envWidget.domNode
			}
			var envContainer = this._createCollapsibleSection(params)
			this._envWidget.appendChild(envContainer.domNode);

			var pointsArgs = {maxPoints: this._ewi.weight};
			
			this._initTypeSpecificSection();
			if(ChangeRequestManager.INIT_INITIALIZED){
				this._addRelatedExternalInfo();
			} else {
				this._addRelatedInfo();
			}
		},
		
		onStop: function(){
			this._typeSpecificSectionWidget.onStop();
		},
		
		onCancel: function(){
			if(this._typeSpecificSectionWidget.onCancel())
				setTimeout(dojo.hitch(this, "publishClosure"), 1500);
		},
		
		//This function should be called by child widget to update the status in Title
		updateStatus: function(status, image){
			if(!this._header){
				dojox.data.dom.removeChildren(this.headerNode)
				var type = this.testScript.scriptType.name == "Manual" ? Constants.getMessage("labelManual"):Constants.getExtensionDisplayMessage(this.testScript.scriptType.name);
				this.headerNode.appendChild(this._createHeader(status, type).domNode)
			}	
			else{
				//Since status will be Executing or paused
				this._header.setTitle(status+" "+this._ewi.testCase.name);
			}
			this._updateBrowserTitle();
		},
		
		//Update ProgressBar on Environment Widget
		updateProgress: function(percent){
			if(this.envWidget)
				this.envWidget.updateProgress(percent)
		},
		
		getProperties: function(){
			return [];
		},
		
		setProperties: function(properties)	{
		},
		
		onShowResult: function(){
			this._typeSpecificSectionWidget.onEndOfExecution();
			setTimeout(dojo.hitch(this, "publishClosure"), 1500);
		},
		
		setHeaderStatus: function(message, code, error){
			/*
			ViewHeader.ERROR   = 1;
			ViewHeader.SUCCESS = 2;
			ViewHeader.INFO    = 3;
			ViewHeader.WARNING = 4;
			 */
			var details = "";
			if(error && error.message)
				details = "<b>" + Constants.getCommonMessage("labelError") + "</b><br/>" + error.message;
			if(this._header){
				this._header.setStatus(message, code, details);
				if(message == Constants.getMessage("msgExeOverFailed")){//See workitem 7128
					this._header.statusErrorNode.src = ImageCache.FAIL_ICON;
				}else{
					this._header.statusErrorNode.src = dojo.moduleUrl("com.ibm.asq.common.web", "ui/internal/view/layout/images/error_obj.gif");
				}
			}
		},
		
		clearHeaderStatus: function(){
			this._header.clearStatus();
		},
		
		enableNavigationToResultPage: function(){
			if(!this.printView)
			this.cancelButton.setDisabled(true);
			if(!this._enabledResultButton){
				this._enabledResultButton = true;
				var self = this;
				var callbackObj = {
					success: function(results){
						if(results && results.length > 0){
							var result = results[0];
							var verdict = result.state ? result.state.id : null; //This has the verdict id
							if(verdict && verdict == ResultStates.ERROR)
								self.setHeaderStatus(Constants.getMessage("msgExeOverWithError"),ViewHeaderLayout.ERROR);
							else if(verdict && verdict == ResultStates.FAILED)
								self.setHeaderStatus(Constants.getMessage("msgExeOverFailed"),ViewHeaderLayout.ERROR);	
							else
								self.setHeaderStatus(Constants.getMessage("msgExeOver"), ViewHeaderLayout.SUCCESS);	
							self._ewi.currentResult = result;//Do update here	
							if(!self.printView){
								self.showResultButton.setDisabled(false);
							}
							dojo.publish(GlobalEvents.ArtifactsUpdated, [Constants.TYPE_EWI, [self._ewi]]);
							dojo.publish(GlobalEvents.ArtifactsUpdated, [Constants.TYPE_EXE_LOG, [result]]);	
						}	
					},
					failure: function(){
						if(!self.printView){
							self.showResultButton.setDisabled(false);
						}
						console.error("failed to fetch result after execution was over, allowing navigation to result");
					}
				}
				var responseHandler = new ExecutionResultMapper(callbackObj, "success", "failure");			
				ResultClient.getExecutionResultSummaryDTOs(responseHandler, {resultItemId: this._resultId});
			}	
		},
		
		publishClosure: function(){
			var uri = Utility.startExecution(this.ewi, this.runScript, this._resultId, this.requestId, this.ergId);//This will return the URI of this widget.
			dojo.publish(GlobalEvents.CloseTab, [uri]);
		},
		
		setRequestId: function(requestId){
			this.requestId = requestId;
		},
		
		getRequestId: function(){
			return this.requestId;
		},
	  /////////////////////////////////////////////////////////////////////////////////////////////////////
      //                                   PLUGGABLE SECTION SUPPORT                                   //
      ////////////////////////////////////////////////////////////////////////////////////////////////////      
      _initTypeSpecificSection: function() {
         if (!this._sectionConfig) {
            this._sectionConfig = this._editorRegistry.getEditor(this);  
         }      
         dojox.data.dom.removeChildren(this._executionWidget);
         this._typeSpecificSectionWidget = this._getTypeSpecificSectionWidget();
         this._executionWidget.appendChild(this._typeSpecificSectionWidget.domNode);  
         this._typeSpecificSectionWidget.initialize(); 
      },
      
      _getTypeSpecificSectionWidget: function() {
         var scriptType =  this.testScript ? this.testScript.scriptType : {id:"com.ibm.rqm.planning.common.scripttype.noscript"};
         this._typeSpecificSectionConfig = this._getTypeSectionConfig(scriptType);
         console.info("Dynamic Widget loading...ScriptType: [" + scriptType.id + "]; Widget Id: [" + this._typeSpecificSectionConfig.jsClass + "]");
         jazz.core.loader.load_sync(this._typeSpecificSectionConfig.jsClass);
         var sectionConstructor = dojo.getObject(this._typeSpecificSectionConfig.jsClass);
         var widgetArgs = { parentController: this.parentController, 
							 parentEditor: this,
							 ewiItemId: this.ewiItemId, 
							 script: this.testScript, 
							 _resultId: this._resultId, /*Only useful if paused scripts are supported*/
							requestId: this.requestId,
							ewiConfigId: this._ewi.configuration,
							printView: this.printView, 
							__ewiObject: this._ewi,
							__scriptObject: this.testScript,
							ergId: this.ergId/*useful in suite updation*/
						};
		 					
         var contributedWidget = new sectionConstructor(widgetArgs);     
         return contributedWidget;
      },
      
      _getTypeSectionConfig: function(scriptType) {
         var found = null;
         var isDefault = false;
         var sections = this._sectionConfig.sections;
		 var len = sections.length;
         for (var i = 0; i < len; i++) {
            var section = sections[i];
			var properties = section && dojo.isArray(section.properties) ? section.properties : [];
			var len2 = properties.length;
            for (var j = 0; j < len2; j++) {
               var attribute = properties[j];
               if (attribute.id == "com.ibm.rqm.planning.common.executionScriptType" && attribute.value == scriptType.id) {
                  return section;
               } else if (attribute.id == "default" && attribute.value == "true") {
                  found = section;
                  isDefault = true;
               }
            }
         }
         if (found != null && isDefault) {
            console.info("No widget found for ScriptType: [" + scriptType.id + "]; Using default Section: [" + found.id + "]");
         }
         return found;          
      },

        _createHeader: function(title, scriptType) {
			var iconClass = "ewi-icon-48";
			var args = {
                title: title,
                typeLabel: Constants.getMessage("labelScriptSuffix", scriptType),
                iconClass: iconClass,
                summary: "",
                isDisplayBottomButton: false
            }
            this._header = new ViewHeaderLayout(args);            
			if(!this.printView){
				if(this._typeSpecificSectionWidget){
					this._createButtons();
				}else{
					this._createButtonsTimer = setInterval(dojo.hitch(this, "_createButtons"), 1);
				}
			}	
            return this._header;          
        }, 
		
		_createButtons: function(){
			if(this._typeSpecificSectionWidget){
				if(this._createButtonsTimer){
					console.debug("deleting buttonTimer");
					clearInterval(this._createButtonsTimer) 
					this._createButtonsTimer = null;
					delete this._createButtonsTimer;
				}
				if(this._typeSpecificSectionWidget.isPrintable()){
					var arg = {
		                label: Constants.getMessage("labelPrintView"),
		                showLabel: false,
		                iconClass: "print-icon-image",
		                onClick: dojo.hitch(this, "onPrintView")
		            };
		            var button = new com.ibm.asq.common.web.ui.internal.widgets.Button(arg);
					button.callback = dojo.hitch(this, "onPrintView");
		            button.setDisabled(false);
		            this._printButton = this._header.getRightActionsContainer().appendChild(button.domNode);
				}
				if(this._typeSpecificSectionWidget.isStopAllowed()){
					this.stopButton = this._header.addRightViewAction(Constants.getMessage("labelStop"), dojo.hitch(this, "onStop"), null, null);
					this.stopButton.setDisabled(true);
				}
				this.cancelButton = this._header.addRightViewAction(Constants.getMessage("labelCancel"), dojo.hitch(this, "onCancel"), null, null);
				this.cancelButton.setDisabled(true);
				if(this.ergId)
					this.showResultButton = this._header.addRightViewAction(Constants.getMessage("labelClose"), dojo.hitch(this, "onShowResult"), null, null);
				else
					this.showResultButton = this._header.addRightViewAction(Constants.getMessage("labelCloseAndShowResult"), dojo.hitch(this, "onShowResult"), null, null);
				this.showResultButton.setDisabled(true);
			}	
		},
		
		_createCollapsibleSection: function(args){
			var expando = new com.ibm.asq.common.web.ui.internal.view.common.CollapsibleSection({open: true, collapsible: false});
	        expando.domNode.name = "first-section";
	        expando.setTitle(args.title ? args.title : "");
	        expando.infoNode.innerHTML = args.info ? args.info: "" ;
			if(args.summary)
				expando.summaryNode.appendChild(args.summary);
			else
				expando.summaryNode.innerHTML = "";
	        if(args.headerRight)
				expando.headerRightNode.appendChild(args.headerRight);
			else
				expando.headerRightNode.innerHTML = "";
			expando.containerHeaderNode.innerHTML = "";
        	var content = document.createElement('div');
			content.innerHTML = "";
        	expando.containerNode.appendChild(content);
			expando.headerCollapsNode.style.display = "none";
		   	return expando;
		},

		onPrintView: function(){
			var uri = PrintViewBaseURI + "ewi="+this.ewi+"&runScript="+this.runScript;
			if(this._resultId){
				uri += "&_resultId="+this._resultId;
			}
			if(this.requestId){
				uri+="&requestId="+this.requestId;
			}
			if(this.ergId){
				uri+="&ergId="+this.ergId;
			}
			window.location.hash = uri+"&printView=true";
		},
		
		// handler on artifacts changed
        onArtifactChanged: function(changeType, artifactType, artifactArray) {
			var len = artifactArray.length;
			var _ewi = this._ewi;
            if ((changeType == GlobalEvents.ArtifactsDeleted) && (artifactType == Constants.TYPE_EWI)) {
                for (var i = 0; i < len; i++) {
                    if (_ewi && (_ewi.id == artifactArray[i].id)) {
                        this.setHeaderStatus(Constants.getMessage("msgViewerEWIDeleted"), ViewHeaderLayout.ERROR);
                        return;
                    }
                }
            }
			if ((changeType == GlobalEvents.ArtifactsDeleted) && (artifactType == Constants.TYPE_SCRIPT)) {
				var runScriptId = this.runScriptId;
                for (var i = 0; i < len; i++) {
                    if (runScriptId && (runScriptId == artifactArray[i].versionableItemId)) {
                        this.setHeaderStatus(Constants.getMessage("msgViewerEWITestScriptDeleted"), ViewHeaderLayout.ERROR);
                        return;
                    }
                }
            }
			if ((changeType == GlobalEvents.ArtifactsDeleted) && (artifactType == Constants.TYPE_CASE)) {
                for (var i = 0; i < len; i++) {
                    if (_ewi && (_ewi.testCase.id == artifactArray[i].id)) {
                        this.setHeaderStatus(Constants.getMessage("msgViewerEWITestCaseDeleted"), ViewHeaderLayout.ERROR);
                        return;
                    }
                }
            }
        },

		_createDetailSection: function(){
			this.machineSection = new MachineDetailSection();
			dojox.data.dom.removeChildren(this._machineDetailSection);
			this._machineDetailSection.appendChild(this.machineSection.domNode);
		},
		
		updateDetailSection: function(adapter){
			if(!this.machineSection){
				this._createDetailSection();
			}
			this.machineSection.initialize({adapter: adapter});
		},
		
		//Override from contentPane and do customCleanup here
		isDirty: function(){
			//Do cleanup call here
			if(this._typeSpecificSectionWidget && dojo.isFunction(this._typeSpecificSectionWidget.cleanUp)){
				return this._typeSpecificSectionWidget.cleanUp();
			}
			return false;
		},
		
		_error: function(errorObj) {
			console.error("Error: (message: '" + errorObj.message + "') from Execution Page Body#_error");
		},
		
		_updateBrowserTitle: function(){
			if (this.page) {
				if (this._ewi && this._ewi.testCase && this._ewi.testCase.name){
					this.page.browserTitle = this._ewi.testCase.name + " "+ Constants.getMessage("labelExecution");
					dojo.publish(GlobalEvents.UpdateTabLabel, [window.location.hash, this._ewi.testCase.name + " "+ Constants.getMessage("labelExecution"), "",false]);
				} else{
					this.page.browserTitle =  Constants.getMessage("labelExecution");
				}
				var workbench=net.jazz.ajax.ui.PlatformUI.getWorkbench();
				workbench.setTitle(this.page.browserTitle);
				workbench.browserTitle = this.page.browserTitle;	
			}
		},
		_displayAlertDialog: function(message){
            var args = {
				message: message
			}
			var alertDialog = new AlertDialog( args );
            alertDialog.open();
        },
		uninitialize: function(){
			if(this._relatedDefectInfo)
				this._relatedDefectInfo.destroy();
		}
	});

})();		
