/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.execution.web.ui.internal.view.execution.KeywordExecution");
dojo.provide("com.ibm.rqm.execution.web.ui.internal.view.execution.KeywordExecution");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
//Dojo widget
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionClient");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");

dojo.require("com.ibm.rqm.execution.web.ui.internal.view.common.ExecutionViewer");

(function() { 

var ExecutionClient 				= com.ibm.rqm.execution.web.client.internal.execution.ExecutionClient;
var ServiceResponseHandler			= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var ACTUALNAME						= "actualName";
var DATASTOREPATH					= "datastore";
var getAuthenticatedContributor		= com.ibm.team.repository.web.client.session.getAuthenticatedContributor;
var ExecutionViewer    				= com.ibm.rqm.execution.web.ui.internal.view.common.ExecutionViewer;

dojo.declare("com.ibm.rqm.execution.web.ui.internal.view.execution.KeywordExecution",[dijit._Widget, dijit._Templated,ExecutionViewer],
	{	
		EXECUTE: 0,
		
		postCreate: function(){},
		
		initialize: function(script)
		{
			this.script = script;
			this.scriptInfo = {
					itemId: this.script.versionableItemId  ? this.script.versionableItemId : this.script.itemId,
					type: this.script.scriptType.id
				};
	        if (this.script != null) {
			  if(this.script.properties)
			  {
				for(var i=0;i<this.script.properties.length; i++)
				{
					if(this.script.properties[i].propertyName === ACTUALNAME)
						this.scriptInfo.actualName = this.script.properties[i].propertyValue;
					if(this.script.properties[i].propertyName === DATASTOREPATH)
						this.scriptInfo.dataStoreLocation = this.script.properties[i].propertyValue;	
				}
			  }
	        }
			this.inherited("initialize", arguments);

		},
		createExecutionRequest: function()
		{			
			var props = [];
			if (this.script.properties) {
				for (var i = 0; i < this.script.properties.length; i++) {
					props.push(this.script.properties[i])
				}
			}
			props.push({propertyName: "ewiItemId", propertyValue: this.ewiItemId+"", propertyType: "link"});
			props.push({propertyName: "scriptTypeName", propertyValue: this.script.scriptType.name, propertyType: "String"});
			props.push({propertyName: "scriptType", propertyValue: this.script.scriptType.id, propertyType: "String"});
			props.push({propertyName: "scriptId", propertyValue: this.script.id+"", propertyType: "String"});
			props.push({propertyName: "scriptItemId", propertyValue: this.script.versionableItemId ? this.script.versionableItemId : this.script.itemId, propertyType: "link"});
			props.push({propertyName: "machine", propertyValue: this.selectedAdapter.hostName, propertyType: "String"});
			props.push({propertyName: "owner", propertyValue: getAuthenticatedContributor().userId, propertyType: "String"});
			props.push({propertyName: "isKeyword", propertyValue: "true", propertyType: "String"});
			if(this.parentWidget)
			{
				if(this.parentWidget._resultId)
					props.push({propertyName: "resultItemId", propertyValue: this.parentWidget._resultId, propertyType: "link"});
				props.push({propertyName: "resultId", propertyValue: this.resultId, propertyType: "String"});
				if(this.parentWidget.ewi.testPlan){
					var shareLocation = this.getLocation(this.parentWidget.ewi.testPlan.sections, this.script.scriptType.name);
					props.push({propertyName: "testPlan", propertyValue: this.parentWidget.ewi.testPlan.name, propertyType: "String"});
					props.push({propertyName: "sharePrefix", propertyValue: shareLocation, propertyType: ""});
				}
				props.push({propertyName: "testPhase", propertyValue: (this.parentWidget.ewi.phase ? this.parentWidget.ewi.phase.name: ""), propertyType: "String"});
				if(this.ewiConfigId)
					props.push({propertyName: "configId", propertyValue: this.ewiConfigId, propertyType: "String"});
				if(this.ewiConfiguration)
					props.push({propertyName: "configuration", propertyValue: this.ewiConfiguration, propertyType: "String"});
				props.push({propertyName: "stepResultItemId", propertyValue:this.stepResultItemId, propertyType:"link"});
				props.push({propertyName: "ewiId", propertyValue: this.parentWidget.ewi.id, propertyType: "link"});
				props.push({propertyName: "testCaseName", propertyValue: this.parentWidget.ewi.testCase.name, propertyType: "string"});
			}
			
			var param = {
				selectedAdapterId: this.selectedAdapter.id,
				properties: props,
				requestType: this.EXECUTE,
				isNew: true
			}
				
			var responseHandler = new ServiceResponseHandler(this, "_updateRequestId", "_error");
			ExecutionClient.postCreateRequest(responseHandler, param);
		},
		
		_updateRequestId:function(request)
		{
            if(this.parentWidget)
			    this.parentWidget._updateKeywordRequestId(request.id);
			this.setRequestId(request);
		},

		updateProgressBar: function(percent /*eg. 5 */)
		{
			if(this.parentWidget)
				this.parentWidget._updateKeywordProgress(percent);

		},
		setCurrentRequest: function(/*Object*/ request)
		{
			var percent =request.progress+"%";
			if(percent=="100%")
			{
				var properties = request.response.properties;
				var resultStateId = "";
				for(var i=0;i<properties.length;i++)
				{
					if (properties[i].propertyName === "resultStateId") {
                        resultStateId = properties[i].propertyValue;
                        break;
                    }                                        
				}
				this._finalizeForLog(resultStateId);
				return;
			}
		},

		_finalizeForLog: function(resultStateId)
		{
            if(this.parentWidget)
			    this.parentWidget.updateCurrentKeywordResult(resultStateId);
		},
		_cancelButtonClicked: function(){
			this._adapterDialog.close();
			this._refreshCancelState();
		},
		onCancel: function(/*Boolean*/showAlertMessage, /*String*/message)
		{
			if(showAlertMessage)
			{	var msg = ""
				if(message)
					msg=message;
				alert(Constants.getMessage("msgExeCancel")+"\n"+msg);
			}
			
			var instructions = [];
			instructions.push({requestId: this.requestId, instructionType: "CANCEL"});

			var params = {
				externalId: this.selectedAdapter.externalId,
				instructions: instructions,
				isNew: false,
				projectAreaItemId: com.ibm.team.process.web.projectArea.itemId
			}
			
			var responseHandler = new ServiceResponseHandler(this, "_refreshCancelState", "_error");
			ToolAdapterRegistrationClient.postRegister(responseHandler, params);
		},
		_onHide: function()
		{
			if(this.selectedAdapter == null)
				alert(Constants.getMessage("msgExeCancel"));
			this._refreshCancelState();
		},
		_refreshCancelState: function() {
			this.parentWidget._toggleApplyButton(false);
		},
		
		_error: function(errorObj) {
			if(this.__timer)
			{
				console.error("Error: (message: '" + errorObj.message + "') from Keyword Execution#_error");
				clearTimer(this.__timer);
				delete this.__timer;
			}
		}
});
})();	
