//ManualExecution
/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.execution.web.ui.internal.view.execution.ManualExecution");
dojo.provide("com.ibm.rqm.execution.web.ui.internal.view.execution.ManualExecution");

//Dojo widget
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojox.data.dom");
dojo.require("dojo.parser");
dojo.require("dijit.Toolbar");
dojo.require("dijit.Menu");
dojo.require("com.ibm.team.repository.web.foundation.Status");
dojo.require("com.ibm.team.repository.web.client.session.Session");

dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.asq.common.web.ui.internal.util.SelectUtility");
dojo.require("com.ibm.asq.common.web.client.internal.CommonPreferenceClient");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.asq.common.web.ui.internal.util.GlobalEvents");

dojo.require("com.ibm.rqm.planning.web.client.internal.RegistryClient");
dojo.require("com.ibm.rqm.planning.web.client.internal.construction.TestScriptClient");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.manualscripteditor.StatementEditor");

dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultGroupClient");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionClient");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionElementResultStates");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultStates");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.execution.ApplyAllConfirmationDialog");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultClient");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionWorkItemClient");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.rqm.execution.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.execution.KeywordExecution");
dojo.require("com.ibm.rqm.execution.web.client.internal.mapper.ExecutionResultGroupMapper");
dojo.require("com.ibm.rqm.datapool.web.client.internal.datapool.DatapoolClient");
dojo.require("com.ibm.rqm.keyword.web.client.internal.keyword.KeywordClient");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.execution.ManualExecutionProperties");
dojo.require("com.ibm.rqm.execution.web.client.internal.mapper.EWIMapper");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.execution.FailConfirmationDialog");

(function() { // module container
var ServiceResponseHandler 			= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var GlobalEvents 					= com.ibm.asq.common.web.ui.internal.util.GlobalEvents;
var getAuthenticatedContributor		= com.ibm.team.repository.web.client.session.getAuthenticatedContributor;
var getCurrentProjectArea 			= com.ibm.team.process.web.client.projectarea.getCurrentProjectArea;
var Constants                       = com.ibm.rqm.planning.web.client.internal.Constants;
var ResultClient					= com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultClient;
var ExecutionWorkItemClient 		= com.ibm.rqm.execution.web.client.internal.execution.ExecutionWorkItemClient;
var ImageCache						= com.ibm.rqm.execution.web.ui.internal.view.common.ImageCache;
var Utility							= com.ibm.rqm.execution.web.ui.internal.util.Utility;
var ExecutionClient					= com.ibm.rqm.execution.web.client.internal.execution.ExecutionClient;
var StepResultStates				= com.ibm.rqm.execution.web.client.internal.execution.ExecutionElementResultStates;
var ResultStates					= com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultStates;
var ManualExecutionProperties 		= com.ibm.rqm.execution.web.ui.internal.view.execution.ManualExecutionProperties;
var SelectUtility 					= dojo.getObject( "com.ibm.asq.common.web.ui.internal.util.SelectUtility" );
var COMMENT_VIEW_TYPE				= "commentView";
var KEYWORD_TYPE					= "keyword";
var Status                          = "com.ibm.team.repository.web.foundation.Status";
var CommonPreferenceClient 			= com.ibm.asq.common.web.client.internal.CommonPreferenceClient;
dojo.declare("com.ibm.rqm.execution.web.ui.internal.view.execution.ManualExecution",[dijit._Widget, dijit._Templated , ManualExecutionProperties],{
		templatePath: dojo.moduleUrl("com.ibm.rqm.execution.web", "ui/internal/view/templates/execution/ManualExecution.html"),
		labelStep:Constants.getMessage("labelStep"),
		labelType: Constants.getMessage("labelType"),
		labelResult: Constants.getMessage("labelResult"),
		labelDescription: Constants.getMessage("labelDescription"),
		labelAttachmentsView: Constants.getMessage("labelAttachmentsView"),
		labelComments: Constants.getMessage("labelComments"),
		labelDefectsView: Constants.getMessage("labelDefectsView"),
		labelCommentsView: Constants.getMessage("labelCommentsView"),
		labelExpectedResult: Constants.getMessage("labelExpectedResult"),
		labelActualResult: Constants.getMessage("labelActualResult"),
		
		widgetsInTemplate:true,
		disableApplyAll: false,
		ewi: null,
		script: null, 
		testcase: null,
		scriptId: null,
		_steps: [],
		_results: [],
		_stepTypes: [],
		_actualResults: [],	
		_startTime: null,
		_endTime: null,
		_currentStepNumber: 0,
		_currentIterNumber: 0,
		_resultId: null,
		_resultTypes: [],		
		parentController: null,
		kwScripts: [],
		inProgress: false,
		originalStepNum: null,
		isExecutionOver: false,
		stopTestRequested: false,
		_haltRequested: false,
		//for Datapool: 
		_cells: [],

		postCreate: function() {		
			this.stepProperties = [];
			this.stepEERArray = [];
			this.uncommittedProperty = [];
			this._menus = [];
			this.move_pointer_here = [];
			this.move_pointer_here_by_enter = [];
			this._stepTitle.innerHTML = Constants.getMessage("labelScriptSteps");
			if(!this.printView){
				this._attachment.src = ImageCache.ATTACHMENT_VIEW;
				this._comment.src = ImageCache.COMMENT_VIEW;
				this._defect.src = ImageCache.NEW_DEFECT;
				this._associateDefect.src = ImageCache.DEFECT_VIEW; 
				this._pause.src = ImageCache.PAUSE_ICON;
				this._togglecomment.src = ImageCache.TOGGLE_COMMENT;
				this._resultDropDownButton.src = ImageCache.DROPDOWN_ARROW;
				this._pause.title = Constants.getMessage("labelClickToPauseExe");
				this._resume.title = Constants.getMessage("labelClickToResumeExe");
				this._resume.style.display = 'none';
				this._attachment.title = Constants.getMessage("labelShowAttach");
				this._comment.title =Constants.getMessage("labelComments");
				this._defect.title = Constants.getMessage("labelAddNewDefect");
				this._associateDefect.title = Constants.getMessage("labelAddExistingDefect");
				this._togglecomment.title = Constants.getMessage("labelShowHideComments");
				this._stepsTable.className = "item-table";
				this._stepsHaveVerdict = Utility.getStepsHaveVerdict();
							
				this._passButton.src = ImageCache.PASS_ICON;
				this._passButton.title = Constants.getMessage("labelPass");
				this._passButton.alt = Constants.getMessage("labelPass");
				this._passButtonClickEvent = this.connect(this._passButton, "onclick", this.handleResultSelected);
				this._passButtonEnterEvent = this.connect(this._passButton, "onkeypress",dojo.hitch(this,this._onEnterResultSelected,""));
				
				this._failButton.src = ImageCache.FAIL_ICON;
				this._failButton.title = Constants.getMessage("labelFail");
				this._failButton.alt = Constants.getMessage("labelFail");
				this._failButtonClickEvent = this.connect(this._failButton, "onclick", 
					dojo.hitch(this,this.handleResultSelected,{identifier: StepResultStates.FAILED}));
				this._failButtonEnterEvent = this.connect(this._failButton, "onkeypress", 
					dojo.hitch(this,this._onEnterResultSelected,StepResultStates.FAILED));
				
				this._otherResultButton.src = ImageCache.STEP_VERDICT_ICONS.ENABLED[StepResultStates.INCONCLUSIVE];
				this._otherResultButton.title = Constants.getMessage("labelInconclusive");
				this._otherResultButton.alt = Constants.getMessage("labelInconclusive");
				this._otherResultButtonIdentifier = StepResultStates.INCONCLUSIVE;
				this._otherResultButtonClickEvent = this.connect(this._otherResultButton, "onclick", 
					dojo.hitch(this,this.handleResultSelected,{identifier:this._otherResultButtonIdentifier}));
				this._otherResultButtonEnterEvent = this.connect(this._otherResultButton, "onkeypress",  
					dojo.hitch(this,this._onEnterResultSelected,this._otherResultButtonIdentifier));

				if(Utility.getExecutionPreferences().disableApplyAll){
					dojox.data.dom.removeChildren(this._applyAllNode);
					this.disableApplyAll = true;
					this._richTextNode.width = "37%";
					this._applyAllNode.width = "0%";
					this._applyAllButton = null;
					this.tableRowNode.deleteCell(4);
				}else{
					this._applyAllButton.src = ImageCache.APPLY_ALL;
					this._applyAllButton.title = Constants.getMessage("labelApplyAll");
					this._applyAllButton.alt = Constants.getMessage("labelApplyAll");
					this.applyAllButtonClickEvent = this.connect(this._applyAllButton, "onclick", this._applyVerdictForAllStepsRemaining);
					this.applyAllButtonEnterEvent = this.connect(this._applyAllButton, "onkeypress", this._onEnterApplyAll);
				}
				this.showCommentsCol = false;
			}else{
				this.hideToolBar();
			}
			this.ID_KW_TYPE= this.id+"_kwType";
			this.ID_KW_SUMMARY= this.id+"_kwSummary";
			this.TR_ID=this.id + "_tr";
			this.IMG_ID = this.id+"_img";
			this.STEP_DESC_ID = this.id+"_stepDesc";
			this.RESULT_ID = this.id+"_results";
			this.PROPS_ID = this.id+"_prop";
			this.DEFECT_ICON = this.id+"_defectIcon";
			this.DEFECT_ID	= this.id+"_defect";
			this.ATTACH_ICON = this.id+"_attachIcon";
			this.ATTACH_ID = this.id+"_attach";
			this.COMMENT_ICON = this.id+"_commentIcon";
			this.COMMENT_ID = this.id+"_comment";
			this.COMPARE_ICON = this.id+"_compareIcon";
			this.COMPARE_ID = this.id+"_compare";
			this._resultDropDownButton.id = this.id+"resultDropdownIcon";
			this.STEP_EXP_RES_ID = this.id + "_expRes";
			this.STEP_ACT_RES_ID = this.id + "_actRes";
			this.ID_COMMENT_COL_AREA = this.id+"_commentColArea";
			this.ID_COMMENT_COL_CELL = this.id+"_commentColCell";
			this.stepNumber = 1;
			if(!this.__ewiObject){
				var responseHandler = new com.ibm.rqm.execution.web.client.internal.mapper.EWIMapper(this, "_setInitialValues", "_error");			
				ExecutionWorkItemClient.getExecutionWorkItemByItemId(responseHandler, {itemId: this.ewiItemId, resolveResults: false});
			}else{
				this._setInitialValues([this.__ewiObject]);
			}
			setTimeout(dojo.hitch(this, "_connectMouseListeners"), 200);	
		},

		hideToolBar: function(){
			this.toolbarNode.style.display = "none";
			this.tableContentNode.style.height = "auto";
			this.showCommentsCol = true;
			dojo.style(this.comments_col_header, 'display', '');
			dojo.style(this.comments_col, 'display', '');
		},
		
		_setInitialValues: function(ewi){
			this.ewi = ewi.length?ewi[0]:ewi;
			if(this.ewi.testCase !== null)
				this.testcase = this.ewi.testCase.name;
			if(this.runScriptId === null)
				this.runScriptId = this.ewi.defaultScript.versionableItemId;
			//Get the ExecutionElementResultStates from the controller (EABE)
			this._initStateTypes(this.parentController.getElementResultStates());
		},
		
		_initStateTypes: function(types){
			this._resultTypes = types;
			if(this._resultId === null){
				if(!this.__scriptObject){
					var responseHandler = new ServiceResponseHandler(this, "_initializeLog", "_error");			
					com.ibm.rqm.planning.web.client.internal.construction.TestScriptClient.getTestScripts(responseHandler, {versionableItemId: this.runScriptId,
						includeArchived: true});
				}else{
					this._initializeLog([this.__scriptObject]);
				}	
			}else{
				var args = { resultItemId: this._resultId };
				var responseHandler = new ServiceResponseHandler(this, "_getResult", "_error");
		    	ResultClient.getExecutionResultDTO(responseHandler, args);
			}
		},
		_getResult: function(result){
            this._ER = result;
			this._resultStateId = result.stateId;
			this._initializeLog([result.script]);
		},
		_initializeLog: function(params){
			this.script = params[0];
			if(!this.script.elements){
				this.parentSection._displayAlertDialog(Constants.getMessage("msgNoStepInScript"));
				this._toggleApplyButton(true);
				this._disableImages();
				this._pause.src = ImageCache.NOIMAGE;
				this.script.elements = [];
				return;
			}
			// find the related datapool
			var self = this;
			var callbackObj = {
				success: function(results){
					self._datapool = results && results.length == 1 ? results[0] : null;
					self._iterations = (self._datapool && self._datapool.records && self._datapool.records.length > 0) ? self._datapool.records.length: 1;
					self.initIteration();
					self.initialise();
				},
				failure: function(e){
					console.error("Failed to find related Test Data");
				}
			}
			var responseHandler = new ServiceResponseHandler(callbackObj, "success", "failure");
			com.ibm.rqm.datapool.web.client.internal.datapool.DatapoolClient.getDatapoolDTOs(responseHandler, {
				linkedTestScriptUUID: this.script.itemId,
				linkedTestScriptStateUUID: this.script.stateId,
				isIterationRequired: true,
				isDataRequired: true
			});
		},
	
	    initIteration: function(){
            if (this._datapool && this._datapool.records && this._datapool.records.length > 0) {
				var len = this._iterations;
                for (var i = 1; i <= len ; i++) {
                    var opt = new Option(i, i);
                    SelectUtility.add(this._iterationSelect, opt);
                }
                SelectUtility.select(this._iterationSelect, this._iterations);
                this._iterationSelect.style.display = "inline";
            } 
        },
		
		initialise: function(){
			this.kwScripts =  [];
			this.keywordsToFetch = [];
			var elements = this.script.elements;
			var len = elements.length;
			for (var i = 0; i < len; i++) {
				if (elements[i] && elements[i].elementType && elements[i].elementType.name == "Keyword") {
					this.keywordsToFetch.push(i);
				}
			}
			this.numberOfKeywords = this.keywordsToFetch.length;
			this.numberOfKeywordsFetched = 0;
			if(this.numberOfKeywords === 0)
				this._mergeKeywordsAndSteps();
			else{
				var keywordsToFetch = this.keywordsToFetch;
				var len2 = this.keywordsToFetch.length;
				for(var j=0;j<len2;j++){
					this.fetchKeyword(keywordsToFetch[j]);
				}
			}
		},
		fetchKeyword:function(index){
			var keywordId = this._getKeywordId(index,false);
			var keywordExternalId = this._getKeywordId(index,true);
			if(!keywordId && !keywordExternalId)
				return;
			this.script.elements[index].keywordId = keywordId;
            if(this.kwScripts && keywordId && this.kwScripts[keywordId]){
            	this.numberOfKeywordsFetched++;
            	if(this.numberOfKeywordsFetched == this.numberOfKeywords)
            		this._mergeKeywordsAndSteps();
                return;
            }
            var self = this;
			var callbackObj = {
				success: function(items){
					self.kwScripts[items[0].id] = {};
                    self.kwScripts[items[0].id].name = items[0].name;
                    self.kwScripts[items[0].id].script = items[0].defaultScript ? items[0].defaultScript:items[0].manualScript;
                    self.kwScripts[items[0].id].manualScript = items[0].manualScript;
                    self.numberOfKeywordsFetched++;
                    if(!self.script.elements[index].keywordId)
                    	self.script.elements[index].keywordId = items[0].id+"";
                    if(self.numberOfKeywordsFetched == self.numberOfKeywords)
            			self._mergeKeywordsAndSteps();
				},
				failure: function(e){
					self._error(e);
					self.numberOfKeywordsFetched++;
					if(self.numberOfKeywordsFetched == self.numberOfKeywords)
            			self._mergeKeywordsAndSteps();
				}				
			}
			var responseHandler = new ServiceResponseHandler(callbackObj, "success", "failure");
			if (keywordId != null) {
				com.ibm.rqm.keyword.web.client.internal.keyword.KeywordClient.getKeywordDTO(responseHandler, {
					id: keywordId,
					includeArchived: true
				});
			}else if(keywordExternalId != null)	{
				com.ibm.rqm.keyword.web.client.internal.keyword.KeywordClient.getKeywordDTO(responseHandler, {
					externalId: keywordExternalId,
					includeArchived: true
				});
			}
		},
		_mergeKeywordsAndSteps:function(){
			this._steps =[];
			this._stepTypes = [];
			this._results = [];
			this._actualResults = [];
			this.stepProperties = [];
			this._paused = false;
			var len = this._iterations;
			var elements = this.script.elements;
			var len2 = elements.length;
			var nestedKeyword = false;
			for(var k=0;k<len;k++){
				for (var i = 0; i < len2; i++){
					if(elements[i].elementType && elements[i].elementType.name == "Keyword"){
						this.keywordElementType = elements[i].elementType;
						var kwScript = this.kwScripts[elements[i].keywordId].manualScript;
						var script = this.kwScripts[elements[i].keywordId].script;
						var isManual = true;
						if(script.scriptType.id != "com.ibm.rqm.planning.common.scripttype.manual")
							isManual = false;
						if(kwScript && kwScript.elements && isManual){
							var kwScriptElements = kwScript.elements;
							var len3 = kwScriptElements.length;
							for(var j=0;j<len3;j++){
								this._stepTypes.push(kwScriptElements[j].elementType);
								if(!nestedKeyword && kwScriptElements[j].elementType.name == "Keyword")
									 nestedKeyword = true;
								this._steps.push({
									content: kwScriptElements[j].content,
									isKeywordStep:true,
									keywordName:this.kwScripts[elements[i].keywordId].name,
									stepNum:i+k*len2,
									isManual:isManual,
									expectedResult:kwScriptElements[j].expectedResult
								});
								this._results.push("");
								if(kwScriptElements[j].properties != null){
									var prop = kwScriptElements[j].properties;
									if(j==0){
										prop.push({propertyName:"scriptId",propertyType:KEYWORD_TYPE,propertyValue:script.id+""});
										prop.push({propertyName:"scriptStateId",propertyType:KEYWORD_TYPE,propertyValue:script.stateId});
										prop.push({propertyName:"keywordId",propertyType:KEYWORD_TYPE,propertyValue:elements[i].keywordId});
										prop.push({propertyName:"keywordName",propertyType:KEYWORD_TYPE,propertyValue:this.kwScripts[elements[i].keywordId].name});
									}
									this.stepProperties.push(prop);
								}else{
									var prop = [];
									if(j==0){
										prop.push({propertyName:"scriptId",propertyType:KEYWORD_TYPE,propertyValue:script.id+""});
										prop.push({propertyName:"scriptStateId",propertyType:KEYWORD_TYPE,propertyValue:script.stateId});
										prop.push({propertyName:"keywordId",propertyType:KEYWORD_TYPE,propertyValue:elements[i].keywordId});
										prop.push({propertyName:"keywordName",propertyType:KEYWORD_TYPE,propertyValue:this.kwScripts[elements[i].keywordId].name});
									}
									this.stepProperties.push(prop);
								}
							}
						}else {
							this._stepTypes.push(this.keywordElementType); 
							this._steps.push({
								content: escape(this.kwScripts[elements[i].keywordId].name),
								isKeywordStep:true,
								keywordName:this.kwScripts[elements[i].keywordId].name,
								stepNum:i+k*len2,
								isManual:isManual,
								expectedResult:"",
								noSteps:true
							});
							this._results.push("");
							var prop = [];
							prop.push({propertyName:"scriptId",propertyType:KEYWORD_TYPE,propertyValue:script.id+""});
							prop.push({propertyName:"scriptStateId",propertyType:KEYWORD_TYPE,propertyValue:script.stateId});
							prop.push({propertyName:"keywordId",propertyType:KEYWORD_TYPE,propertyValue:elements[i].keywordId});
							prop.push({propertyName:"keywordName",propertyType:KEYWORD_TYPE,propertyValue:this.kwScripts[elements[i].keywordId].name});
							this.stepProperties.push(prop);
						}
					}else{
						this._stepTypes.push(elements[i].elementType); 
						this._steps.push({
							content: elements[i].content, 
							isKeywordStep:false,
							stepNum:i+k*len2,
							expectedResult:elements[i].expectedResult
						});
						this._results.push("");
						if(elements[i].properties != null && elements[i].properties.length != 0)
							this.stepProperties.push(elements[i].properties);
						else
							this.stepProperties.push([]);						
					}
				}
				if(k==0)
					this.numberOfSteps = this._steps.length;
			}
            if(this._ER && this._ER.elementResults){
				var elementResults = this._ER.elementResults;
				var len4 = elementResults.length;
                for(var j=0;j<len4;j++){
					this.stepProperties[j] = elementResults[j].properties;
					this._actualResults[j] = elementResults[j].actualResult;
				}
            }
			this._setColWidths();
			if (nestedKeyword) {				
				this._displayAlertDialog(Constants.getMessage("msgNestedKeywordPresent"));
			}
			this._layoutUI();
		},
		_layoutUI:function(){
			this._disableResultSelectBox(false);
			if(this._resultId == null)
				this._collectDateTime("start");
            this._resume.style.display = 'none';    
			dojox.data.dom.removeChildren(this._stepsTableBody);
			this.currentKeywordStepNum = null;
			var numberOfSteps = this.numberOfSteps;
			var _currentIterNumber = this._currentIterNumber;
			//Add for print view
			if(this.printView && this._iterations > 1){
				var len = this._iterations;
				for(var j=0;j<len ;j++){
					var total = j*numberOfSteps;
					for(var i = 0; i < numberOfSteps; i++){
						this._createStepRow(null, i + total, this._steps[i+total], j);
					}
					if(j<this._iterations)
						_currentIterNumber++;
				}
			}else{
				// present the initial iteration
				var total = _currentIterNumber * this.numberOfSteps;
				for(var i = 0; i < numberOfSteps; i++){
					var index = i + total;
					this._createStepRow(null, index, this._steps[index], _currentIterNumber);
				}
				if (this._iterations > 1) {
					this._updateIteration();
				}
			}

			if ((_currentIterNumber + 1) == this._iterations) {
				//Add one extra row for pointer to move after execution
				this._createStepRow(null, this.numberOfSteps * this._iterations, null, 1);	
			}
			if (this._resultId != null) {
                this._updateTableForIncompleteExecution(this._ER);
            }else {
                this.setProperties(this.stepProperties[0]);
                if (this._currentStepNumber == 0 && this._steps[0].isKeywordStep) {
                    if(!this._steps[0].isManual) {
                        this._createKeywordDialog();
                    }else{
						this._disableResultSelectBox(false);
					}
                }
            }
			this._destroyEditor();
			this._updateActualResultSection(this._currentStepNumber);
		},
		
		_updateTableForIncompleteExecution: function(result){
			this._resultStateId = result.stateId;
			this._elementResults = result.elementResults ? result.elementResults : [];
            this._resultIdInt = result.id;
			var count = this._elementResults.length;
			var _currentStepNumber = 0;
			var _elementResults = this._elementResults;
			for(var i = 0; i < count; i++){
                this.stepEERArray[i] = _elementResults[i];
				this._updateResult(_elementResults[i].result, _currentStepNumber);
				this._moveStepPointer(true,_currentStepNumber,_currentStepNumber+1);
				_currentStepNumber += 1;
			}
			this._currentStepNumber = _currentStepNumber;
            if (_currentStepNumber == this.numberOfSteps * this._iterations) {
				this.parentWidget.updateProgress(100);
				var resultStateId = _elementResults[count-1].resultStateId? _elementResults[count-1].resultStateId:this._resultStateId;
                this._setCurrentResult(resultStateId,false);
                return;
            }
			this._updateProgressBar();
			//Update Properties for only last execution element result
			this.setProperties(this.stepProperties[_currentStepNumber]);
			this._startTime = result.startTime;
			this._disableResultSelectBox(false);
			if( this._steps[_currentStepNumber].isKeywordStep && !this._steps[_currentStepNumber].isManual){
				this._createKeywordDialog();
			}
		},
		
        ////////////////////////////////
		// Layout 
		////////////////////////////////		
		
		_createStepRow: function(targetRow, step, stepObj, iteration){
			var doc = document;
            var stepNum = step;
			if(stepObj && stepObj.isKeywordStep && stepObj.isManual && !stepObj.noSteps)
				this._insertKeywordNameRow(stepObj);
			if ( targetRow == null ){
				targetRow = this._getEmptyRow(doc);
				targetRow.id = this.TR_ID+step;
				this._stepsTableBody.appendChild(targetRow);
			}
			dojox.data.dom.removeChildren(targetRow);
			//Step image
			var stepCell = this._getEmptyCell(doc);
			var stepImg = doc.createElement("img");
			stepImg.title = "";
			stepImg.alt= "";
			if((stepNum < this._iterations * this.numberOfSteps) && (stepNum % this.numberOfSteps == 0)){
				stepImg.src = this.printView ? ImageCache.NO_IMAGE : ImageCache.EXECUTION_ARROW;
				dojo.addClass(targetRow, "selected-row");
			}
			else
				stepImg.src= ImageCache.NOIMAGE;	
			stepImg.className = "type-image";
			stepImg.id = this.IMG_ID+ stepNum;
			
			stepCell.appendChild(stepImg);			
			targetRow.appendChild(stepCell);
			
			//step number cell
			var numCell = this._getEmptyCell(doc);
            if(!stepObj || (stepObj.isKeywordStep && stepObj.isManual && !stepObj.noSteps))
                numCell.appendChild(doc.createTextNode(""));
            else 
			    numCell.appendChild(doc.createTextNode(stepObj.stepNum+1));
			targetRow.appendChild(numCell);
			
			//step type cell
			var typeCell = this._getEmptyCell(doc);
			var typeImg = doc.createElement("img");
            if (!stepObj) 
                typeImg.src = ImageCache.NOIMAGE;
            else if(stepObj.isKeywordStep && stepObj.isManual && !stepObj.noSteps){
				typeImg.src = ImageCache.NOIMAGE;
			}else{
                typeImg.title = this._stepTypes[stepNum].name;
                typeImg.alt = this._stepTypes[stepNum].name;
                typeImg.src = ImageCache.getTypeIconURL(this._stepTypes[stepNum]);
            }
			typeImg.className = "type-image";
			typeCell.appendChild(typeImg);
			targetRow.appendChild(typeCell);
            
			//result type cell
			var resultCell = this._getEmptyCell(doc);
			var resultSelect = doc.createElement("img");
			resultSelect.title = "";
			resultSelect.alt = "";
			resultSelect.src = ImageCache.NOIMAGE;
			resultSelect.className = "";
			resultSelect.id = this.RESULT_ID + stepNum;
			resultSelect.className = "type-image";
			resultCell.appendChild(resultSelect);			
			targetRow.appendChild(resultCell);
			
			//step name / description cell
			var descriptionCell = this._getEmptyCell(doc);
			var descriptionInput = doc.createElement('div');
			dojo.addClass(descriptionInput,"step-detail-col");
			if(this.descMaxWidth)
				descriptionInput.style.width = this.descMaxWidth+"px";
            if (!stepObj) {
				descriptionInput.innerHTML = "";
				this.execOverField = descriptionInput;
			}
			else {
				descriptionInput.innerHTML = unescape(this._steps[stepNum].content);
			}
			descriptionInput.id = this.STEP_DESC_ID + stepNum;
			if (stepObj && stepObj.isKeywordStep && stepObj.isManual && !stepObj.noSteps) {
				var stepTypeImg = doc.createElement("img");
				stepTypeImg.title = this._stepTypes[stepNum].name;
                stepTypeImg.alt = this._stepTypes[stepNum].name;
                stepTypeImg.src = ImageCache.getTypeIconURL(this._stepTypes[stepNum]);
				descriptionInput.innerHTML = "";
				descriptionInput.appendChild(stepTypeImg);
				descriptionInput.innerHTML = descriptionInput.innerHTML+unescape(this._steps[stepNum].content);
			}
			descriptionCell.appendChild(descriptionInput);	
			targetRow.appendChild(descriptionCell);
			if(!stepObj){
				var emptyTD = doc.createElement('td');
				emptyTD.colSpan = 6;
				targetRow.appendChild(emptyTD);
			}			
			if(stepObj){
				//deal with Datapool value: 
				this._replaceVariable(descriptionInput, iteration);
				//Expected result
				var expectedCell = this._getEmptyCell(doc);
				var expectedDiv = doc.createElement('div');
				dojo.addClass(expectedDiv,"step-detail-col");
			    expectedDiv.innerHTML = stepObj.expectedResult ? unescape(stepObj.expectedResult) : "";
				expectedDiv.id = this.STEP_EXP_RES_ID + stepNum;
				if(this.expMaxWidth)
					expectedDiv.style.width = this.expMaxWidth+"px";
				
				expectedCell.appendChild(expectedDiv);	
				targetRow.appendChild(expectedCell);
				//deal with Datapool value: 
				this._replaceVariable(expectedDiv, iteration);
				//Actual result
				var actualCell = this._getEmptyCell(doc);
				var actualDiv = doc.createElement('div');
				dojo.addClass(actualDiv,"step-detail-col");
			    actualDiv.innerHTML = stepObj && this._actualResults[stepNum] ? unescape(this._actualResults[stepNum]) : "";
				actualDiv.id = this.STEP_ACT_RES_ID + stepNum;
				if(this.actMaxWidth)
					actualDiv.style.width = this.actMaxWidth+"px";
				actualCell.appendChild(actualDiv);	
				targetRow.appendChild(actualCell);
                //Changes for Properties 
                var properties = [];
                if(stepObj)
                    properties = this.stepProperties[stepNum];
                var propshtml = this._createPropertiesHtml(stepNum, properties);
                
                var commentColCell = this._getEmptyCell(doc);
				if(!this.printView){
					var commentArea = doc.createElement("textarea");
					commentArea.id = this.ID_COMMENT_COL_AREA+stepNum;
					var commentProp = this.updateCommentProperty(null,stepNum);
					commentArea.value = commentProp?commentProp.propertyValue:"";
					this.connect(commentArea,'onblur',dojo.hitch(this,function(stepNum,e){
						this.updateCommentProperty({propertyType:COMMENT_VIEW_TYPE,propertyName:"comment",propertyValue:e.target.value},stepNum);
						if(stepNum == this._currentStepNumber){
							this.propertiesMap[COMMENT_VIEW_TYPE].elements =[{
								propertyType:COMMENT_VIEW_TYPE,
								propertyName:"comment",
								propertyValue:e.target.value}];
							this._updateCurrentStepProps(COMMENT_VIEW_TYPE);
						}
					},stepNum));
					commentColCell.appendChild(commentArea);
				}	
				commentColCell.align = "right";
				dojo.style(commentColCell,"width","15%");
				targetRow.appendChild(commentColCell);
				commentColCell.id = this.ID_COMMENT_COL_CELL+stepNum;
				if(!this.showCommentsCol)
					dojo.style(commentColCell,'display','none');
					
                targetRow.appendChild(propshtml[0]);
                targetRow.appendChild(propshtml[1]);
                targetRow.appendChild(propshtml[2]);
                targetRow.appendChild(propshtml[3]);
            }
			var ruleRow = doc.createElement("tr");
			var ruleCell = doc.createElement("td");
			ruleCell.colSpan=12;
			var hr = doc.createElement("hr");
			hr.color="#D6D6D6";
			hr.size="1";
			hr.style.margin="0px";
			ruleCell.appendChild(hr);
			ruleRow.appendChild(ruleCell);
			this._stepsTableBody.appendChild(ruleRow);                
		},
		_insertKeywordNameRow:function(stepObj){
			var doc = document;
			if(this.currentKeywordStepNum == stepObj.stepNum)
				return;
			else
				this.currentKeywordStepNum = stepObj.stepNum;
			var stepRow = doc.createElement("tr");
			var stepCell = this._getEmptyCell(doc);
			var stepImg = doc.createElement("img");
			stepImg.title = "";
			stepImg.alt= "";
			stepImg.src = ImageCache.NOIMAGE;
			stepRow.appendChild(stepCell);
			var numCell = this._getEmptyCell(doc);
			numCell.appendChild(doc.createTextNode(stepObj.stepNum+1));
			stepRow.appendChild(numCell);
			var typeCell = this._getEmptyCell(doc);
			var typeImg = doc.createElement("img");            
            typeImg.title = this._stepTypes[stepObj.stepNum].name;
            typeImg.alt = this._stepTypes[stepObj.stepNum].name;
            typeImg.src = ImageCache.getTypeIconURL(this.keywordElementType);
			typeImg.className = "type-image";
			typeCell.appendChild(typeImg);
			stepRow.appendChild(typeCell);
			var resultCell = this._getEmptyCell(doc);
			var resultSelect = doc.createElement("img");
			resultSelect.title = "";
			resultSelect.alt = "";
			resultSelect.src = ImageCache.NOIMAGE;
			resultSelect.className = "";
			resultCell.appendChild(resultSelect);
			stepRow.appendChild(resultCell);
			var nameCell = this._getEmptyCell(doc);
			nameCell.appendChild(doc.createTextNode(stepObj.keywordName));
			nameCell.colSpan=9;
			stepRow.appendChild(nameCell);
			this._stepsTableBody.appendChild(stepRow);
			var ruleRow = doc.createElement("tr");
			var ruleCell = doc.createElement("td");
			ruleCell.colSpan=12;
			var hr = doc.createElement("hr");
			hr.color="#D6D6D6";
			hr.size="1";
			ruleCell.appendChild(hr);
			ruleRow.appendChild(ruleCell);
			this._stepsTableBody.appendChild(ruleRow);  
		},
		
		////////////////////////////////
		// Main Execution related stuff
		////////////////////////////////
		onSelectIteration: function(){
			this._iterations = this._iterationSelect.value;
			this._layoutUI();
		},
		_applyAll:function(){
			this.parentSection.setCancelDisabled(true);
			this.parentSection.setStopDisabled(true);
			var args = {id:this._resultIdInt,resultStateId:this._resultStateId };
			var steps = [];
			var attachmentIds = [];
			var defectIds = [];
			var removeDefectIds = [];
			var removeAttachmentItemIds = [];
			this.stepProperties[this._currentStepNumber] = this.getProperties();
			var len = this.numberOfSteps * this._iterations;
			var stepEERArray = this.stepEERArray;
			for(var i=0;i<len;i++){
				var step = {};
				var stepEERArrayItem = stepEERArray[i];
				if(stepEERArrayItem){
					step.startTime = stepEERArrayItem.startTime+"";
					step.endTime = stepEERArrayItem.endTime+"";
					step.actualResult = stepEERArrayItem.actualResult;
					step.properties = this.stepProperties[i]? this.stepProperties[i]:[];
					var addAttachmentItemIds = this._buildAttachmentIdList(step.properties);
					attachmentIds = attachmentIds.concat(addAttachmentItemIds);
					removeAttachmentItemIds = removeAttachmentItemIds.concat(addAttachmentItemIds);
					var defectIdList = this._buildDefectIdList(step.properties);
					defectIds = defectIds.concat(defectIdList);
					removeDefectIds = removeDefectIds.concat(defectIdList);
					step.result = stepEERArrayItem.result.id;
				}else{
					step.startTime = this._startTime+"";
					step.endTime = this._startTime+"";
					step.actualResult = "";
					step.properties = this.stepProperties[i];
					var addAttachmentItemIds = this._buildAttachmentIdList(step.properties);
					attachmentIds =	attachmentIds.concat(addAttachmentItemIds);
					var defectIdList = this._buildDefectIdList(step.properties);
					defectIds = defectIds.concat(defectIdList);
					step.result = this._getStepResult(i).id;
				}
				steps.push(step);
			}
			args.elementResultJsonString = dojo.toJson(steps);
			if(attachmentIds.length > 0)
				args.addAttachmentItemIds = attachmentIds;
			if(defectIds.length>0)
				args.defectIds = defectIds;
			if(removeAttachmentItemIds.length>0)
				args.removeAttachmentItemIds = removeAttachmentItemIds;
			if(removeDefectIds.length>0)
				args.removeDefectIds = removeDefectIds;
			this._collectDateTime("stop");
			args.startTime = this._startTime? parseInt(this._startTime): null;
			args.endTime =  parseInt(this._endTime);
			args.machine =  Constants.getMessage("labelLocalComputer");
			args.owner = getAuthenticatedContributor().userId;
			args.ewiItemId = this.ewi.itemId;//This sets EWI's currentResult.
			var self = this;
			var callback = {
				success:function(result){
					self._resultId = result.itemId;
					self._ER = result;
					self._currentIterNumber = 0;
					self._layoutUI();
					self.oneStepExecution = false;
					self._resultStateId = result.stateId;
					self._setCurrentResult(self._resultStateId,true);
				},
				failure:function(errorObj){
					self._saveError(errorObj);
				}
			}
			var responseHandler=new ServiceResponseHandler(callback, "success", "failure");
	    	ResultClient.postExecutionResultDTO(responseHandler, args);
		},
		onApply: function(returnToKeyword, callback){
			if(!this._iterationSelect.disabled){
				this._iterationSelect.disabled = true;
			}
			if(this._haltRequested){
				return;//Either stop or cancel was requested, dont process the request. Do not process any update on this stage
			}else{
				this._updateInProgress = true;
			}
			
			if(this._resultId != null){
				if(returnToKeyword == true)
					return;
				if (this.oneStepExecution && CommonPreferenceClient.getExecutionPreference().animation) {
					this._applyAll();
					return;
				}
				this._toggleApplyButton(true);
				this._pause.src = ImageCache.PAUSE_ICON;
				if(this._currentStepNumber == this.numberOfSteps * this._iterations){
					this.parentWidget.enableNavigationToResultPage();
					return;
				}
				this.parentSection.setCancelStopDisabled(false);
                var result = this._getStepResult(this._currentStepNumber);
				//Call service to store the result: service needs index from 1
				var args = {
					stepIndex: this._currentStepNumber,
					executionResult: this._resultId,
					resultElementStateTypeId: result.id,
					resultStateId:this._resultStateId
				}
				if(this._currentStepNumber == 1){
					args.startTime = parseInt(this._startTime);
					args.endTime = parseInt(this._startTime);	
				}
                if (this.stepEERArray[this._currentStepNumber]) {
                    args.stepItemId = this.stepEERArray[this._currentStepNumber].internalId;
                    args.resultElementStateTypeId = this._getStepResult(this._currentStepNumber).id;
                    var removeAttachmentItemIds = this._buildAttachmentIdList(this.stepEERArray[this._currentStepNumber].properties);
                    if(removeAttachmentItemIds.length>0)
                        args.removeAttachmentItemIds = removeAttachmentItemIds;
                }
    			var properties = this.getProperties();
                if(properties.length > 0)
                    args.addProperties = properties;
                var addAttachmentItemIds = this._buildAttachmentIdList(properties);
                if(addAttachmentItemIds.length > 0)
                    args.addAttachmentItemIds = addAttachmentItemIds;
				var value = this.editor ? this.editor.getValue() : "";
				if(value == '<br />' || value == '<br/>')
					value = "";
				else 
					value = escape(value);
				args.actualResult = value;
				var defectIdList = this._buildDefectIdList(properties);
                if(defectIdList.length>0)
                    args.defectIds = defectIdList;
                if(this._currentStepNumber == this.numberOfSteps * this._iterations -1){
				    this._collectDateTime("stop");
					args.startTime = this._startTime? parseInt(this._startTime): null;
					args.endTime =  parseInt(this._endTime);
					args.machine =  Constants.getMessage("labelLocalComputer");
					args.owner = getAuthenticatedContributor().userId;
					args.ewiItemId = this.ewi.itemId;//This sets EWI's currentResult.
                }
                else {
                    args.resultState = ResultStates.IN_PROGRESS;
				}
				args.iterations = this._iterations;
				var responseHandler=new ServiceResponseHandler(this, "isEndOfExecution", "_saveError");
	    		ResultClient.postApplyResult(responseHandler, args);
			}
			else{
				this._toggleApplyButton(true);
				this._collectDateTime("start");
				var par = {
					ewiItemId: this.ewi.itemId,
					testScriptItemid: this.script.versionableItemId  ? this.script.versionableItemId: this.script.itemId,
					owner: getAuthenticatedContributor().userId,
					ewiStateId:this.ewi.stateId,
					startTime:this._startTime
				}
				if(this.requestId){
					par.requestId = this.requestId;
				}
				var self = this;
				var callbackObj ={
					success: function(result){
						self._resultId = result.itemId;
						self._resultIdInt = result.id;
						self._resultStateId = result.stateId;
						self.ewi.stateId = result.ewiStateId;
						self.ewi.currentResult = result;
						if(result.requestStateId && dojo.trim(result.requestStateId).length > 0){
							//Update if valid
							self.requestStateId = result.requestStateId;
						}
						self.parentWidget._resultId = self._resultId;//Update resultID in EPB for tabclosure
						self.parentSection._resultId = self._resultId;//Update resultID in MES for consistant data.	
						dojo.publish(GlobalEvents.UpdateTabUri, [window.location.hash, Utility.startExecution(self.ewiItemId, self.runScriptId, self._resultId, self.requestId, self.ergId)]);
						dojo.publish(GlobalEvents.ArtifactsAdded, [Constants.TYPE_EXE_LOG, [result]]);
						dojo.publish(GlobalEvents.ArtifactsUpdated, [Constants.TYPE_EWI, [self.ewi]]);
						self._updateInProgress = false; 
						if(returnToKeyword && returnToKeyword == true ){
					        if (callback) {
								callback();
							}
						}else
				            self.onApply();
					},
					error: function(e){
						self._updateInProgress = false;
						self._saveError(e);
					}	
				}	
				var responseHandler = new ServiceResponseHandler(callbackObj, "success", "error");			
				ExecutionWorkItemClient.postExecute(responseHandler, par);
			}			
		},
		
		_updateActualResultSection: function(current, next){
			if(!this._paused && this.oneStepExecution){
				this._destroyEditor();
				return;
			}
			var content = "";
			if(this.printView){
				var index = this.isExecutionOver ? next : current;
				var attachNode = dojo.byId(this.STEP_ACT_RES_ID+index);
				if(attachNode)
					attachNode.innerHTML = this._actualResults[index] ? unescape(this._actualResults[index]) : ""; 
				return;
			}else if(!this.editor){
					var index = this.isExecutionOver ? next : current;
					var attachNode = dojo.byId(this.STEP_ACT_RES_ID+index);
					if(!attachNode) 
						return;
					if(!this.toolbar || !this.toolbar.domNode){
						//toolbar domnode becomes null when editor cannot be destroyed completely.
						this.toolbar = new dijit.Toolbar();
						dojox.data.dom.removeChildren(this._richToolbar);
						dojo.removeClass(this.toolbar.domNode,"dijitToolbar");
						this._richToolbar.appendChild(this.toolbar.domNode);
					}
					var args = {
						height: '',
						minHeight: '25px',
						focusOnLoad: true,
						parentWidget: this,
						plugins: ["bold","italic","underline","strikethrough",
								"insertOrderedList","insertUnorderedList",'foreColor', 'hiliteColor', 'dijit._editor.plugins.AlwaysShowToolbar',
								 'insertimage'],
						toolbar: this.toolbar
					};
					this.editor = new com.ibm.rqm.planning.web.ui.internal.view.construction.manualscripteditor.StatementEditor(args, attachNode);
					content = this._actualResults[index] ? unescape(this._actualResults[index]) : "";
				}else{
					var editorNode = this.editor.domNode;
					var currentEditorValue = null;
					var value = this.editor.getValue();
					if(value == '<br />' || value == '<br/>')
						value = "";
					else
						currentEditorValue = escape(value);
					this._actualResults[current] = currentEditorValue ? currentEditorValue : "";
					var nextNode = dojo.byId(this.STEP_ACT_RES_ID+next);
					if(nextNode){
						this.editor.endEditing(true);
						//Change prev node from editor to div
						this.editor.srcNodeRef = nextNode;
						this.editor.open(nextNode);
						content = this._actualResults[next] ? unescape(this._actualResults[next]) : "";
					}
				}
				if(content != "")	
					this.editor.replaceValue(content);
				if(next == this.numberOfSteps * this._iterations){
					//For the last step in the script
					var currentParentNode = this.editor.domNode.parentNode;
						this._destroyEditor();
					var actualDiv = dojo.byId(this.STEP_ACT_RES_ID + current);
					if(!actualDiv){
						actualDiv = document.createElement('div');
						actualDiv.id = this.STEP_ACT_RES_ID + current;
						currentParentNode.appendChild(actualDiv);
					}
			    	actualDiv.innerHTML = this._actualResults[current] ? unescape(this._actualResults[current]) : "";
				}
		},
		
		_destroyEditor: function(){
			if(this.editor){
				this.editor.endEditing(true);
				this.editor.destroyRecursive();
			}
			this.editor = null;	
		},
		
		_moveStepPointer: function(updateProps, currentStep, nextStep){
			//make image go to next line
			try{
			var current = "";
			var next = "";
			if(!isNaN(currentStep) && !isNaN(nextStep))	{
				current = currentStep;
				next = nextStep;
			}else{
				current = this._currentStepNumber;
				next = this._currentStepNumber + 1;
			}
			var tr = dojo.byId(this.TR_ID + current);
			if(tr && dojo.hasClass(tr, "selected-row")){
				dojo.removeClass(tr, "selected-row");
			}
			if (next > current) {
				// present the next iteration
				var numberOfSteps = this.numberOfSteps;
				var _currentIterNumber = this._currentIterNumber;
				if ((_currentIterNumber + 1) < this._iterations && (current + 1) == (_currentIterNumber + 1) * numberOfSteps) {
					_currentIterNumber +=1;
					this._currentIterNumber += 1;
					this._updateIteration();
					
					// erase last iteration
					dojo.forEach(this.move_pointer_here, dojo.hitch(this,function(evt){
						this.disconnect(evt);
					}));
					dojo.forEach(this.move_pointer_here_by_enter, dojo.hitch(this,function(evt){
						this.disconnect(evt);
					}));
					this.move_pointer_here = [];
					this.move_pointer_here_by_enter = [];
					dojox.data.dom.removeChildren(this._stepsTableBody);
					this._destroyEditor();
					
					var total = _currentIterNumber*numberOfSteps;
					for (var i = 0; i < numberOfSteps; i++) {
						this._createStepRow(null, i + total, this._steps[i + total], _currentIterNumber);
					}
					if ((_currentIterNumber + 1) == this._iterations) {
						//Add one extra row for pointer to move after execution
						this._createStepRow(null, numberOfSteps * this._iterations, null, 1);
					}
				}
			}
			var imgCurr = dojo.byId(this.IMG_ID + current);
			if (imgCurr) {
				var imgCellCurr = imgCurr.parentNode;
				dojox.data.dom.removeChildren(imgCellCurr);
				var stepImgCurr = document.createElement("img");
				stepImgCurr.title = "";
				stepImgCurr.alt = "";
				stepImgCurr.src = ImageCache.NOIMAGE;
				stepImgCurr.className = "type-image";
				stepImgCurr.id = this.IMG_ID + current;
				imgCellCurr.appendChild(stepImgCurr);
			}
			
			var trNext = dojo.byId(this.TR_ID + next);
			if(trNext && !dojo.hasClass(trNext, "selected-row")){
				dojo.addClass(trNext, "selected-row");
			}
			if (tr) {
				if(!this.move_pointer_here[current])
					this.move_pointer_here[current] = this.connect(tr, "onclick", this._changeStepPointer);
				if (!this.move_pointer_here_by_enter[current]) {
					this.move_pointer_here_by_enter[current] = this.connect(tr, "onkeypress", function(e){
						var charCode = (e.which) ? e.which : e.keyCode;
						if (charCode == 13 && this._changeStepPointer) 
							this._changeStepPointer(e);
					});
				}
				if (dojo.isIE) {
					//for accessibility issue: when tab to focus, the row has no dashed border when tab to focus. 
					//changing text color to identify focused row
					this.add_focus_handle = this.connect(tr, "onfocus", function(e){
						tr.style.color = "#8A9084";
					});
					this.add_blur_handle = this.connect(tr, "onblur", function(e){
						tr.style.color = "#000";
					});
				}
				tr.setAttribute("tabIndex", 0);
				tr.style.cursor = "pointer";
			}
			var img = dojo.byId(this.IMG_ID + next);
			var imgCell = img.parentNode;
			dojox.data.dom.removeChildren(imgCell);
			
			var stepImg = document.createElement("img");
			stepImg.title = "";
			stepImg.alt= "";
			stepImg.src= this.printView ? ImageCache.NOIMAGE : ImageCache.EXECUTION_ARROW;
			stepImg.className = "type-image";
			stepImg.id = this.IMG_ID+ next;
			imgCell.appendChild(stepImg);
			if(updateProps == true){	
				var properties= this.stepProperties[current];	
				var attachCurr = dojo.byId(this.ATTACH_ID  + current);
				var defectCurr = dojo.byId(this.DEFECT_ID  + current);
				var commentCurr = dojo.byId(this.COMMENT_ID  + current);
				var compareCurr = dojo.byId(this.COMPARE_ID  + current);
				var propshtml = this._createPropertiesHtml(current,properties);
				if(attachCurr)
					attachCurr.parentNode.replaceChild(propshtml[0],attachCurr);
				if(defectCurr)
					defectCurr.parentNode.replaceChild(propshtml[1],defectCurr);
				if(commentCurr)
					commentCurr.parentNode.replaceChild(propshtml[2],commentCurr);					
			}
			if(this.editor)
				this._updateActualResultSection(current, next);
			else if(!this.isExecutionOver)
				this._updateActualResultSection(next);
			else
				this._updateActualResultSection(null,next);
			}catch(e){
				console.debug("Error in Move step Pointer");
			}
		},
		
		_updateIteration: function() {
			dojox.data.dom.removeChildren(this._iterationNode);
			this._iterationNode.innerHTML = Constants.getMessage("msgRunningDatapoolIteartion", this._currentIterNumber + 1);
		},
		
		_updateProgressBar: function(){
			if (!this.updatingProgress) {
				this.updatingProgress = true;
				var percent = (parseFloat(parseFloat(this._currentStepNumber) / parseFloat(this.numberOfSteps * this._iterations)) * 100);
				this.parentWidget.updateProgress(percent);
				var self = this;
				if (this.requestId) {
					var innerCallback = {
						callSuccess: function(obj){
							self.updatingProgress = false;
							self.requestStateId = obj.stateId
							dojo.publish(GlobalEvents.ArtifactsUpdated, [Constants.TYPE_REQUEST, [obj]]);
						},
						callFailure: function(errorObj){
							self.updatingProgress = false;
							self._saveError(errorObj);
						}
					}
					if(percent != 100 && !this._haltRequested){//Halt updates the request, this would lead to race condition so dont allow update
						var responseHandler = new ServiceResponseHandler(innerCallback, "callSuccess", "callFailure");
						ExecutionClient.postResponse(responseHandler, {
							requestId: this.requestId,
							stateId: this.requestStateId,
							message: "",
							progress: parseInt(percent),
							statusCode: "200",
							projectAreaItemId: getCurrentProjectArea().itemId,
							data: "dummy"
						});
					}else{
						this.updatingProgress = false;
					}	
				} else
					this.updatingProgress = false;
			}
		},
		
		isEndOfExecution: function(resultElement){
			this.uncommittedProperty.splice(this._currentStepNumber,1);
			if(resultElement)
				this._resultStateId = resultElement.resultStateId;
			this.stepEERArray[this._currentStepNumber] = resultElement;
            this.stepProperties[this._currentStepNumber] = resultElement.properties?resultElement.properties:[];
			var result = this._getStepResult(this._currentStepNumber);
			this._updateResult(result, this._currentStepNumber);
			this._moveStepPointer(false);
			this._currentStepNumber = this._currentStepNumber+1;
			if(!this.oneStepExecution || this._currentStepNumber != this.numberOfSteps * this._iterations)
				this._updateProgressBar();
			//Updating Properties
			this.setProperties(this.stepProperties[this._currentStepNumber]);
			this._updateInProgress = false;
			if(this._currentStepNumber == this.numberOfSteps * this._iterations)	    	
                this._setCurrentResult(resultElement.resultStateId,true);
			else if(!this._paused && this._steps[this._currentStepNumber].isKeywordStep && !this._steps[this._currentStepNumber].isManual ){
               	this._createKeywordDialog();
			}
			else if(!this._paused && this.oneStepExecution){
				this.onApply();
			}else if (this.stopTestRequested){
				this.stopTestRequested = false;
				this.onStop();
			}else{
				this._toggleApplyButton(false);
				this._disableResultSelectBox(false);
			}
		},
        
		_applyVerdictForAllStepsRemaining: function(){
			//Check in the user pref if we should show the dialog or not.
			if(!this.currentResultId){
				this.currentResultId = StepResultStates.PASSED;
			}
			if(CommonPreferenceClient.getExecutionPreference().applyall){
				//Value is true so confirm before proceeding.
					var args = {
					parentEditor: this, 
					okCallback: dojo.hitch(this, this._afterConfirmation),
					verdictTypes: this._resultTypes,
					selectedVerdictId: this.currentResultId
					};
				this.confirmationDialog = new com.ibm.rqm.execution.web.ui.internal.view.execution.ApplyAllConfirmationDialog(args);
				this.confirmationDialog.initialize();
			}else{
				this._afterConfirmation({verdict: this.currentResultId});//Apply the current verdict to following steps.
			}
			
		},
		
		_afterConfirmation: function(args){
			this._updateResultCombo(args.verdict);
			this.oneStepExecution = true;
			this.onApply();
		},
		
		_onEnterApplyAll: function(e) {
			var charCode = (e.which) ? e.which : e.keyCode
			if (charCode == 13 && this.applyAllButtonClickEvent) 
			 	this._applyVerdictForAllStepsRemaining();
		},
        ////////////////////////////////
		// Keyword related stuff
		////////////////////////////////
		_createKeywordDialog: function(){
			if(this._resultId == null){
				this.onApply(true, dojo.hitch(this,"_createKeywordDialog"));
				return;
			}
			this._toggleApplyButton(true);
			if (this.stepEERArray[this._currentStepNumber]) {
                if(this.stepEERArray[this._currentStepNumber].result.id == StepResultStates.INCONCLUSIVE )
				    this._executeKeyword();
				return;
			}
			var verdictName = Constants.getMessage("labelInconclusive");
			var verdictId = null;
			var _resultTypes = this._resultTypes;
			var len = _resultTypes.length;
			for(var count =0;count<len;count++){
				if(verdictName === _resultTypes[count].name){
					verdictId = _resultTypes[count].id;
					break;
				}	
			}
			var args = {	
					stepIndex: this._currentStepNumber,
					executionResult: this._resultId,
					resultElementStateTypeId: verdictId,
					resultStateId:this._resultStateId
				}
				if(this._currentStepNumber == 1){
					args.startTime = parseInt(this._startTime);
					args.endTime = parseInt(this._startTime);	
				}
				args.iterations = this._iterations;
				var responseHandler=new ServiceResponseHandler(this, "_executeKeyword", "_saveError");
	    		ResultClient.postApplyResult(responseHandler, args);
		},
		
		_executeKeyword:function(eer){
			var eerInternalId = "";
			if(eer){
				this.stepEERArray[this._currentStepNumber] = eer;
				this._resultStateId = eer.resultStateId;
			}
			else 
				eerInternalId = this.stepEERArray[this._currentStepNumber].internalId;
			var requestIdValue = null;
            var keywordId = null;
			var keywordProps = this.propertiesMap[KEYWORD_TYPE].elements;
			var stepNum = this._steps[this._currentStepNumber].stepNum % this.script.elements.length;				
			var keywordId = this.script.elements[stepNum].keywordId;
			var len = keywordProps.length;
			for(var j=0;j<len;j++){
				if (keywordProps[j].propertyName == "requestId")
					requestIdValue = keywordProps[j].propertyValue;
			}
            if (keywordId) {
                var widgetArgs = {
                    parentWidget: this,
                    ewiItemId: this.ewiItemId,
                    parentEditor: this.parentSection.parentEditor,
                    stepResultItemId: eer ? eer.internalId : eerInternalId,
                    resultId: this._resultIdInt + ""
                }
                if (requestIdValue != null) 
                    widgetArgs.requestId = requestIdValue;
                this._keywordExecutionViewer = new com.ibm.rqm.execution.web.ui.internal.view.execution.KeywordExecution(widgetArgs);
                this._keywordExecutionViewer.initialize(this.kwScripts[keywordId].script);
            }
            else
                this._toggleApplyButton(false);
		},
		
		updateCurrentKeywordResult: function(resultStateId){
			this._resultStateId = resultStateId;
            var eer = this.stepEERArray[this._currentStepNumber];
            var args = {
				stepItemId: eer.internalId,
				executionResult: this._resultId,
				resultStateId:this._resultStateId			 
			};
			args.iterations = this._iterations;			
			var responseHandler=new ServiceResponseHandler(this, "finishKeywordExecution", "_saveError");
		    ResultClient.postApplyResult(responseHandler, args);
		},
        
		finishKeywordExecution:function(eer){
			this._resultStateId = eer.resultStateId;
            this.stepEERArray[this._currentStepNumber] = eer;
            if(eer.properties){
				var len = eer.properties.length;
				for(var i=0;i<len ;i++)
					this.propertiesMap[eer.properties[i].propertyType].elements.push(eer.properties[i]);
			}
            this._updateCurrentStepProps();
            this._updateResultCombo(eer.result.id);
			var keywordProps = this.propertiesMap[KEYWORD_TYPE].elements;
			var newKeywordProps = [];
			var len2 = keywordProps.length;
			//remove the requestId property
			for(var j=0;j<len2;j++){
				if(keywordProps[j].propertyName != "requestId")
					newKeywordProps.push(keywordProps[j]);
			}
			this.propertiesMap[KEYWORD_TYPE].elements = newKeywordProps;
			this.onApply();
		},
		_updateKeywordProgress:function(percent){
			var percentMin = (parseFloat(parseFloat(this._currentStepNumber)/parseFloat(this.numberOfSteps * this._iterations))*100);
			var percentMax = (parseFloat((parseFloat(this._currentStepNumber+1))/parseFloat(this.numberOfSteps * this._iterations))*100);
			var scriptPercent = 0;
			if (percentMax > percentMin) {
				scriptPercent = percentMin + (((percentMax - percentMin) * (parseFloat(percent))) / 100);
			}
			this.parentWidget.updateProgress(scriptPercent);
			
		},
		
		_updateKeywordRequestId:function(requestId){
			this.propertiesMap[KEYWORD_TYPE].elements.push({ 
				propertyType:KEYWORD_TYPE,
				propertyName:"requestId",
				propertyValue:requestId
			});
			this._onStaleStepUpdate(this._currentStepNumber);
				
		},
		
        _getKeywordId: function(stepNum,getExternalId){
            var keywordId = null;
            var keywordExternalId = null;
			var properties = this.script.elements[stepNum].properties;
			var len = properties?properties.length:0;
			for (var j = 0; j < len; j++) {
				var prop = properties[j];
				if (prop.propertyType == KEYWORD_TYPE) {
					if (prop.propertyName == "keywordId") 
						keywordId = prop.propertyValue;
					else 
						if (prop.propertyName == "keywordExternalId") 
							keywordExternalId = prop.propertyValue;
					break;
				}
			}
            if(getExternalId)
                return keywordExternalId;
            else
                return keywordId;
        },

        ////////////////////////////////
		// Misc Functions
		////////////////////////////////
        _collectDateTime: function(arg){
			var currentTime = new Date();
			if(arg == "start")
				this._startTime = Utility._convertDateToLong(currentTime);
			else
				this._endTime = Utility._convertDateToLong(currentTime);	
		},
		_setColWidths:function(){
			var mb = dojo.marginBox(this.desc_col_header);
			var mb2 = dojo.marginBox(this.exp_col_header);
			var mb3 = dojo.marginBox(this.act_col_header);
			this.descMaxWidth = mb.w;
			this.expMaxWidth = mb2.w;
			this.actMaxWidth = mb3.w;
		},
		
		_updateResultCombo: function(resultId){
			this.currentResultId = resultId;
		},
		 _createResultContextMenu: function(node){
			var callback = this;
			var pMenu = new dijit.Menu({_contextMenuWithMouse:true, targetNodeIds:[node.id]});
            
			var childBlocked = new dijit.MenuItem({label:Constants.getMessage("labelBlocked"), onClick:dojo.hitch(this,this.handleResultSelected,{identifier: StepResultStates.BLOCKED, label:Constants.getMessage("labelBlocked")},{identifier: StepResultStates.BLOCKED})});
			var blockedImg = document.createElement('img');
			blockedImg.src = ImageCache.STEP_VERDICT_ICONS.ENABLED[StepResultStates.BLOCKED];
			childBlocked.iconNode.appendChild(blockedImg);
			pMenu.addChild(childBlocked);
			
			var inconclusiveChild = new dijit.MenuItem({label:Constants.getMessage("labelInconclusive"),onClick:dojo.hitch(this,this.handleResultSelected,{identifier: StepResultStates.INCONCLUSIVE, label:Constants.getMessage("labelInconclusive")},{identifier: StepResultStates.INCONCLUSIVE})})
			var inconclusiveChildImg = document.createElement('img');
			inconclusiveChildImg.src = ImageCache.STEP_VERDICT_ICONS.ENABLED[StepResultStates.INCONCLUSIVE];
			inconclusiveChild.iconNode.appendChild(inconclusiveChildImg);
            pMenu.addChild(inconclusiveChild);
			
			var errorChild = new dijit.MenuItem({label:Constants.getMessage("labelError"),onClick:dojo.hitch(this,this.handleResultSelected,{identifier: StepResultStates.ERROR, label:Constants.getMessage("labelError")},{identifier: StepResultStates.ERROR})})
			var errorChildImg = document.createElement('img');
			errorChildImg.src = ImageCache.STEP_VERDICT_ICONS.ENABLED[StepResultStates.ERROR];
			errorChild.iconNode.appendChild(errorChildImg);
            pMenu.addChild(errorChild);
            pMenu.startup();

			//Enable the same menu for left click also			
			this.resultMenu = pMenu;
			this._menus.push(pMenu);
			return this.connect(node, "onclick", function(e){this.resultMenu._openMyself(e);});
		},
		
		_setCurrentResult: function(resultStateId,updateProgress){
			this.parentSection._resultItemId = this._resultId;
			this._resultStateId = resultStateId;			
			this.isExecutionOver = true;
			this.parentSection.setCancelStopDisabled(true);
			if(this.execOverField)
				this.execOverField.innerHTML = Constants.getMessage("msgExeOver");
			this._setPointerOnFinalStep(this._currentStepNumber);
			if(updateProgress && (this._currentStepNumber == this.numberOfSteps * this._iterations)){
				var self = this;
				if(self.ergId){
					var innerCallback2 = {
						callSuccess: function(obj){
							self.ergStateId = obj.stateId;
						},
						callFailure: function(errorObj){
							console.debug("failure in fetchin object message " +errorObj.message);
							self._saveError(errorObj);
						}
					}
					
					var responseHandler2=new com.ibm.rqm.execution.web.client.internal.mapper.ExecutionResultGroupMapper(innerCallback2, "callSuccess", "callFailure");
					var ergArgs = {id: self.ergId, addResults: [self._resultIdInt]};
					if(self.ergStateId)
						ergArgs.stateId = self.ergStateId;							
					com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultGroupClient.postExecutionResultGroupSummaryDTO(responseHandler2, ergArgs)
				}
				if(self.requestId){
					var innerCallback = {
						callSuccess: function(obj){
							self.requestStateId = obj.stateId;
						},
						callFailure: function(errorObj){
							console.debug("failure in fetchin object message " +errorObj.message);
						}
					}
					var responseHandler=new ServiceResponseHandler(innerCallback, "callSuccess", "callFailure");

					var requestArgs = {isNew: false, id: self.requestId, progress: 100};
					if(self.requestStateId)
						requestArgs.stateId = self.requestStateId;
					requestArgs.state = "com.ibm.rqm.executionframework.common.requeststate.complete";	
					ExecutionClient.postCreateRequestDTO(responseHandler, requestArgs);
				}

			}
			if (updateProgress) {
				var self = this;
				if (this.updatingProgress) {
					this.progressUpdateInterval = setInterval(function(){
						if (!self.updatingProgress) {
							clearInterval(self.progressUpdateInterval);
							delete self.progressUpdateInterval;
							self._updateProgressBar();
							self.parentWidget.enableNavigationToResultPage();
						}
					}, 500);
				}
				else {
					this._updateProgressBar();
					this.parentWidget.enableNavigationToResultPage();
				}
			}else {
				this.parentWidget.enableNavigationToResultPage();
			}
		},
		
		_updateResult: function(result, stepIndex){
			var resultValue = dojo.byId(this.RESULT_ID + stepIndex);
			var resultCell = resultValue.parentNode;
			dojox.data.dom.removeChildren(resultCell);
			var img = document.createElement('img');
			img.src = Utility.getImageForResult(result);
			img.title = result.name;
			img.alt = result.name;
			img.className = "type-image";
			img.id = this.RESULT_ID + stepIndex;
			resultCell.appendChild(img);
//			if(this._stepsHaveVerdict || this._stepTypes[stepIndex]!= "Execution Step")
//				resultCell.appendChild(document.createTextNode(result.name));
            this._results[stepIndex] = result.id;
		},
        
        _disableResultSelectBox: function(disable){
        	if(this._failButtonClickEvent)
        		this.disconnect(this._failButtonClickEvent);
			if(this._failButtonEnterEvent)
				this.disconnect(this._failButtonEnterEvent);
			if(this._otherResultButtonClickEvent)
				this.disconnect(this._otherResultButtonClickEvent);
			if(this._otherResultButtonEnterEvent)
				this.disconnect(this._otherResultButtonEnterEvent);
			this._failButtonClickEvent = null;
			this._failButtonEnterEvent = null;
			this._otherResultButtonClickEvent = null;
		    this._otherResultButtonEnterEvent = null;
			
			if(disable){
				this.disconnect(this._passButtonClickEvent);
				this.disconnect(this._passButtonEnterEvent);
                this.disconnect(this.resultDropdownEvent);
				this.disconnect(this.resultDropdownEnterEvent);
				this._passButtonClickEvent = null;
				this._passButtonEnterEvent = null;
	            this.resultDropdownEvent = null;
	            this.resultDropdownEnterEvent = null;
			}else if(!this._stepsHaveVerdict && this._stepTypes[this._currentStepNumber] == "Execution Step" ){
                this.disconnect(this.resultDropdownEvent);
				this.disconnect(this.resultDropdownEnterEvent);
	            this.resultDropdownEvent = null;
	            this.resultDropdownEnterEvent = null;
			}else{
				if(this._passButtonClickEvent)
                	this.disconnect(this._passButtonClickEvent);
				if(this._passButtonEnterEvent)
                    this.disconnect(this._passButtonEnterEvent);
                
				this._passButtonClickEvent = this.connect(this._passButton, "onclick", this.handleResultSelected);
				this._passButtonEnterEvent = this.connect(this._passButton, "onkeypress", dojo.hitch(this,this._onEnterResultSelected,""));
				this._failButtonClickEvent = this.connect(this._failButton, "onclick", 
					dojo.hitch(this,this.handleResultSelected,{identifier: StepResultStates.FAILED}));
				this._failButtonEnterEvent = this.connect(this._failButton, "onkeypress",
					dojo.hitch(this,this._onEnterResultSelected,StepResultStates.FAILED));
				this._otherResultButtonClickEvent = this.connect(this._otherResultButton, "onclick",
					dojo.hitch(this,this.handleResultSelected,{identifier:this._otherResultButtonIdentifier}));
				this._otherResultButtonEnterEvent = this.connect(this._otherResultButton, "onkeypress", 
					dojo.hitch(this,this._onEnterResultSelected,this._otherResultButtonIdentifier));
				if(this.resultDropdownEvent)
					this.resultDropdownEvent = this.connect(this._resultDropDownButton, "onclick", function(e){this.resultMenu._openMyself(e);});
				else
					this.resultDropdownEvent = this._createResultContextMenu(this._resultDropDownButton);
				this.resultDropdownEnterEvent = this.connect(this._resultDropDownButton, "onkeypress", 
					function(e){
						var charCode = (e.which) ? e.which : e.keyCode;
						if (charCode == 13 && this.resultDropdownEvent) 	
							this.resultMenu._openMyself(e);
					});
			} 
		},
				
		handleResultSelected: function(e){
			var identifier = e.identifier ? e.identifier : "";
			if(identifier != "" && identifier != StepResultStates.FAILED){//From the menu
				this._otherResultButton.src = ImageCache.STEP_VERDICT_ICONS.ENABLED[identifier];
				this._otherResultButton.title = e.label;
				this._otherResultButtonIdentifier  = identifier;
			}
			this.currentResultId = identifier != "" ? identifier : StepResultStates.PASSED;
			if(!this.originalStepNum){
				if(this.currentResultId == StepResultStates.FAILED){
					var askOnFail = CommonPreferenceClient.getExecutionPreference().askonfail;
					if(askOnFail){
						var args ={
							okCallback: dojo.hitch(this, "markStepFailedWithProperties"),
							actualResultContent: this.editor ? this.editor.getValue() : "",
							newDefectActionCallback: dojo.hitch(this,this._defectIconClicked,"new",null)
						} 
					var promptDialog = new com.ibm.rqm.execution.web.ui.internal.view.execution.FailConfirmationDialog(args);
					promptDialog.initialize();
					}else{
						this.onApply();
					}
				}
				else{
					this.onApply();
				}
			} 
			else
				this._onStaleStepVerdictUpdate();
		},
		
		markStepFailedWithProperties: function(params){
			if(params.actualResultContent){
				this.editor.setValue(params.actualResultContent);
			}
			if(params.stopTestChecked){
				this.stopTestRequested = true;
			}
			this.onApply();
		},
		
		_onEnterResultSelected: function(identifier,e){
			var charCode = (e.which) ? e.which : e.keyCode
			if (charCode == 13) {
				this.handleResultSelected({identifier: identifier});
			}
		},
		
		_toggleApplyButton: function(disable){
			if(!this.disableApplyAll)
				this._applyAllButton.disabled = disable;
			if(this._passButtonClickEvent)
				this.disconnect(this._passButtonClickEvent);
			if(this._passButtonEnterEvent)
				this.disconnect(this._passButtonEnterEvent);
			if(this._failButtonClickEvent)
				this.disconnect(this._failButtonClickEvent);
			if(this._failButtonEnterEvent)
				this.disconnect(this._failButtonEnterEvent);
			if(this._otherResultButtonClickEvent)
				this.disconnect(this._otherResultButtonClickEvent);
			if(this._otherResultButtonEnterEvent)
				this.disconnect(this._otherResultButtonEnterEvent);
			if(this.applyAllButtonClickEvent)
				this.disconnect(this.applyAllButtonClickEvent);
			if(this.applyAllButtonEnterEvent)
				this.disconnect(this.applyAllButtonEnterEvent);
		    this._passButtonClickEvent = null;
			this._passButtonEnterEvent = null;
			this._failButtonClickEvent = null;
			this._failButtonEnterEvent = null;
			this._otherResultButtonClickEvent = null;
			this._otherResultButtonEnterEvent = null;
			this.applyAllButtonClickEvent = null;
			this.applyAllButtonEnterEvent = null;			
			if(!disable){
				this._passButton.src = ImageCache.PASS_ICON;
				this._passButton.setAttribute("tabIndex", 0);
				this._failButton.src = ImageCache.FAIL_ICON;
				this._failButton.setAttribute("tabIndex", 0);
				this._resultDropDownButton.src = ImageCache.DROPDOWN_ARROW;
				this._otherResultButton.src = ImageCache.STEP_VERDICT_ICONS.ENABLED[this._otherResultButtonIdentifier];
				this._resultDropDownButton.setAttribute("tabIndex", 0);
				if(!this.disableApplyAll)
					this._applyAllButton.src = ImageCache.APPLY_ALL;

				this._passButtonClickEvent = this.connect(this._passButton, "onclick",this.handleResultSelected);
				this._passButtonEnterEvent = this.connect(this._passButton, "onkeypress",dojo.hitch(this,this._onEnterResultSelected,""));
				this._failButtonClickEvent = this.connect(this._failButton, "onclick",  
						dojo.hitch(this,this.handleResultSelected,{identifier: StepResultStates.FAILED}));
				this._failButtonEnterEvent = this.connect(this._failButton, "onkeypress",
					dojo.hitch(this,this._onEnterResultSelected,StepResultStates.FAILED));
				this._otherResultButtonClickEvent = this.connect(this._otherResultButton, "onclick",
					dojo.hitch(this,this.handleResultSelected,{identifier:this._otherResultButtonIdentifier}));
				this._otherResultButtonEnterEvent = this.connect(this._otherResultButton, "onkeypress", 
					dojo.hitch(this,this._onEnterResultSelected,this._otherResultButtonIdentifier));
				if(this.resultDropdownEvent)
						this.resultDropdownEvent = this.connect(this._resultDropDownButton, "onclick", function(e){this.resultMenu._openMyself(e);});
					else
						this.resultDropdownEvent = this._createResultContextMenu(this._resultDropDownButton);
					this.resultDropdownEnterEvent = this.connect(this._resultDropDownButton, "onkeypress",  
						function(e){
							var charCode = (e.which) ? e.which : e.keyCode;
							if (charCode == 13 && this.resultDropdownEvent) 	
								this.resultMenu._openMyself(e);
						});
				if(!this.disableApplyAll){
					this.applyAllButtonClickEvent = this.connect(this._applyAllButton, "onclick", this._applyVerdictForAllStepsRemaining);
					this.applyAllButtonEnterEvent = this.connect(this._applyAllButton, "onkeypress",  this._onEnterApplyAll);
				}	
			}else{
				this._passButton.setAttribute("tabIndex", -1);
				this._failButton.setAttribute("tabIndex", -1);
				this._otherResultButton.setAttribute("tabIndex", -1);
				this._resultDropDownButton.setAttribute("tabIndex", -1);
				this._passButton.src = ImageCache.PASS_ICON_DISABLED;
				this._failButton.src = ImageCache.FAIL_ICON_DISABLED;
				this._otherResultButton.src = ImageCache.STEP_VERDICT_ICONS.DISABLED[this._otherResultButtonIdentifier];
				
				if(!this.disableApplyAll)
					this._applyAllButton.src = ImageCache.APPLY_ALL_DISABLED;
				this.disconnect(this.resultDropdownEvent);
				this.disconnect(this.resultDropdownEnterEvent);
				this.resultDropdownEvent = null;
				this.resultDropdownEnterEvent = null;
			}
		},
        
        _getStepResult: function(stepNum){
            var result = null;
            if(!stepNum)
                stepNum = this._currentStepNumber;
			var selectedResult = this.currentResultId;
			if(!this._stepsHaveVerdict && this._stepTypes[stepNum ] == "Execution Step")
				selectedResult = StepResultStates.COMPLETE;
			var _resultTypes = this._resultTypes;
			var len = _resultTypes.length;
			for (var i = 0; i < len; i++) {
				if(_resultTypes[i].id == selectedResult){
					result = _resultTypes[i];
                    break;
				}
			}
			return result;
		},

        _enableImages: function(){
			this._attachment.src = ImageCache.ATTACHMENT_VIEW;
			this._attachment.setAttribute("tabIndex", 0);
			this._attachment.alt = Constants.getMessage("labelShowAttach");
			this._comment.src = ImageCache.COMMENT_VIEW;
			this._comment.setAttribute("tabIndex", 0);
			this._comment.alt = Constants.getMessage("labelComments");
			this._defect.src = ImageCache.NEW_DEFECT;
			this._defect.setAttribute("tabIndex", 0);
			this._defect.alt = Constants.getMessage("labelAddNewDefect");
			this._associateDefect.src = ImageCache.DEFECT_VIEW;
			this._associateDefect.setAttribute("tabIndex", 0);
			this._associateDefect.alt = Constants.getMessage("labelAddExistingDefect");
			this._togglecomment.src = ImageCache.TOGGLE_COMMENT;
			this._togglecomment.setAttribute("tabIndex", 0);
			this._togglecomment.alt = Constants.getMessage("labelShowHideComments");
			this._pause.src = ImageCache.PAUSE_ICON;
			this._pause.alt = Constants.getMessage("labelClickToPauseExe");
			this._resume.alt = "";
			this._stepsTable.className = "item-table";
			this._disableResultSelectBox(false);
            this._connectMouseListeners();
            this._richToolbar.style.display = "";
		},
		
		_disableImages: function(){
			this._attachment.src = ImageCache.ATTACHMENT_VIEW_DISABLED;
			this._attachment.setAttribute("tabIndex", -1);
			this._comment.src = ImageCache.COMMENT_VIEW_DISABLED;
			this._comment.setAttribute("tabIndex", -1);
			this._defect.src = ImageCache.DEFECT_VIEW_DISABLED;
			this._defect.setAttribute("tabIndex", -1);
			this._associateDefect.src = ImageCache.DEFECT_VIEW_DISABLED;
			this._associateDefect.setAttribute("tabIndex", -1);
			this._togglecomment.src = ImageCache.TOGGLE_COMMENT_DISABLED;
			this._togglecomment.setAttribute("tabIndex", -1);
			this._pause.src = "";
			this._pause.alt = "";
			this._resume.src = ImageCache.RESUME_ICON;
			this._resume.setAttribute("tabIndex", 0);
			this._resume.alt = Constants.getMessage("labelClickToResumeExe");
			this._disableResultSelectBox(true);
			this._stepsTable.className = "item-table-disabled";
			this._richToolbar.style.display = "none";
			if(!this.resumeEvent)
			    this.resumeEvent = this.connect(this._resume, "onclick", this._handleResumeClick);
			if(!this.resumeEnterEvent)
			    this.resumeEnterEvent = this.connect(this._resume, "onkeypress", function(e){
					var charCode = (e.which) ? e.which : e.keyCode;
					if (charCode == 13 && this.resumeEvent) 	
						this._handleResumeClick(e);
				});		
			//Disconnect events from icons except for Resume
			this.disconnect(this.addDefectEvent);
            this.addDefectEvent = null;
			this.disconnect(this.associateDefectEvent);
            this.associateDefectEvent = null;
			this.disconnect(this.pauseEvent);
            this.pauseEvent = null;
			this.disconnect(this.attachmentImg);
            this.attachmentImg = null;
			this.disconnect(this.attachmentEnterEvent);
            this.attachmentEnterEvent = null;
			this.disconnect(this.commentImg);
            this.commentImg = null;
			this.disconnect(this.commentEnterEvent);
            this.commentEnterEvent = null;
			this.disconnect(this._toggleCommentHandle);
			this._toggleCommentHandle = null;
			this.disconnect(this._togglecommentEnterEvent);
			this._togglecommentEnterEvent = null;
		},
		
		_connectMouseListeners: function(){
            //Connect events to icons
			if(!this.printView){
	            if(!this.addDefectEvent)
				    this.addDefectEvent = this.connect(this._defect, "onclick", dojo.hitch(this,this._defectIconClicked,"new",null));
				if(!this.addDefectEnterEvent)
				    this.addDefectEnterEvent = this.connect(this._defect, "onkeypress", function(e){
						var charCode = (e.which) ? e.which : e.keyCode;
						if (charCode == 13 && this.addDefectEvent) 	
							this._defectIconClicked("new",null);
					});
				if(!this.associateDefectEvent)
				    this.associateDefectEvent = this.connect(this._associateDefect, "onclick", dojo.hitch(this,this._defectIconClicked,"existing",null));
				if(!this.associateDefectEnterEvent)
				    this.associateDefectEnterEvent = this.connect(this._associateDefect, "onkeypress", function(e){
						var charCode = (e.which) ? e.which : e.keyCode;
						if (charCode == 13 && this.associateDefectEvent) 	
							this._defectIconClicked("existing",null);
					});		
	            if(!this.attachmentImg)
				    this.attachmentImg = this.connect(this._attachment, "onclick", this._attachmentIconClicked);
				if(!this.attachmentEnterEvent)
				    this.attachmentEnterEvent = this.connect(this._attachment, "onkeypress", function(e){
						var charCode = (e.which) ? e.which : e.keyCode;
						if (charCode == 13 && this.attachmentImg) 	
							this._attachmentIconClicked();
					});		
	            if(!this.commentImg)
				    this.commentImg = this.connect(this._comment, "onclick", this._commentIconClicked);
				if(!this.commentEnterEvent)
				    this.commentEnterEvent = this.connect(this._comment, "onkeypress", function(e){
						var charCode = (e.which) ? e.which : e.keyCode;
						if (charCode == 13 && this.commentImg) 	
							this._commentIconClicked();
					});
				if(!this._toggleCommentHandle)
				    this._toggleCommentHandle = this.connect(this._togglecomment, "onclick", this._toggleCommentsColumn);
				if(!this._togglecommentEnterEvent)
				    this._togglecommentEnterEvent = this.connect(this._togglecomment, "onkeypress", function(e){
						var charCode = (e.which) ? e.which : e.keyCode;
						if (charCode == 13 && this._toggleCommentHandle) 	
							this._toggleCommentsColumn();
					});	
	            if(!this.pauseEvent)
				    this.pauseEvent = this.connect(this._pause, "onclick", this._handlePauseClick);
				if(!this.pauseEnterEvent)
				    this.pauseEnterEvent = this.connect(this._pause, "onkeypress", function(e){
						var charCode = (e.which) ? e.which : e.keyCode;
						if (charCode == 13 && this.pauseEvent) 	
							this._handlePauseClick();
					});
				this.disconnect(this.resumeEvent);
	            this.resumeEvent = null;    
				this.disconnect(this.resumeEnterEvent);
	            this.resumeEnterEvent = null;
			}	            
		},
		
        ////////////////////////////////
		// Icon clicks handling
		////////////////////////////////
		onEndOfExecution:function(){
			if(this._staleStepUpdated)
				this._onStaleStepUpdate(this._currentStepNumber);
		},
		
		isDirty:function(){
			if(this.uncommittedProperty.length>0)
				return true;
			else 
				return false;
		},
		
		onCancel:function(){
			if(this.uncommittedProperty.length>0){
				var self = this;
				var args = {
					title: Constants.getMessage("labelConfirmation"),
					message: Constants.getMessage("labelUnSavedProperties"),
					yesCallback: function(){
						self._onCancel();
					},
					noCallback: null
				}
				var dialog = new com.ibm.asq.common.web.ui.internal.widgets.YesNoDialog(args);
	            dialog.setSecondaryTitle(args.title);
	            dialog.open();
			}else{
				this._onCancel();
			}
			return false;
		},
		
		clearWaitTimer: function(){
			if(this._waitTimer){
				clearTimeout(this._waitTimer);
				delete this._waitTimer;
				console.debug("deleting timer as no update in progress");
			}	
		},
		
		_onCancel: function(){
			this.parentSection.setCancelDisabled(true);
			this.parentSection.setStopDisabled(true);
			this._haltRequested = true;
			if(this._updateInProgress){
				this.clearWaitTimer();
				this._waitTimer = setTimeout(dojo.hitch(this, "_onCancel"), 200);//Wait for in progress update to finish and then come back
				console.debug("creating timer since updating in progress");
				return;
			}else if(this._waitTimer){
				this.clearWaitTimer();
			}
			if(this._keywordExecutionViewer)
                this._keywordExecutionViewer.parentWidget = null;
			//Set state of request to cancelled.
			var requestArgs = {isNew: false, id: this.requestId};
			if(this.requestStateId)
				requestArgs.stateId = this.requestStateId;
			var self = this;		
			var innerCallback = {
				callSuccess: function(obj){
					self.requestStateId = obj.stateId;
				},
				callFailure: function(error){
					console.debug("ME: could not cancel Manual request, reason: "+error.message);
				}
			}
			var responseHandler=new ServiceResponseHandler(innerCallback, "callSuccess", "callFailure");
			requestArgs.state = "com.ibm.rqm.executionframework.common.requeststate.cancelled";	
			ExecutionClient.postCreateRequestDTO(responseHandler, requestArgs);
			//Set the result state to incomplete.
			var self = this;
			if(this._currentStepNumber != 0){
				//Only in this case the result exists.
				this.onStop();
			}else{
				this.parentWidget.publishClosure();
			}
		},

		//On cancel and on stop state of the result is set to incomplete.
		onStop: function(){
			this._haltRequested = true;
			this.parentSection.setStopDisabled(true);
			this.parentSection.setCancelDisabled(true);
			if(this._updateInProgress){
				this.clearWaitTimer();
				this._waitTimer = setTimeout(dojo.hitch(this, "onStop"), 200);//Wait for in progress update to finish and then come back
				console.debug("creating timer since updating in progress");
				return;
			}else if(this._waitTimer){
				this.clearWaitTimer();
			}
			var self = this;
			var callback = {
				callSuccess: function(results){
					dojo.publish(GlobalEvents.ArtifactsUpdated, [Constants.TYPE_EXE_LOG, results]);
					self.ewi.currentResult = results[0];
					dojo.publish(GlobalEvents.ArtifactsUpdated, [Constants.TYPE_EWI, [self.ewi]]);
					self.parentWidget.publishClosure();
				},
				callFailure: function(error){
					console.debug("ME: failed to update result" + error.message);
					self.parentWidget.publishClosure();
				}
			}
			var args = {
				executionResult: this._resultId,
				resultStateId: this._resultStateId,
				resultState: ResultStates.INCOMPLETE,
				stepIndex: this._currentStepNumber,
				skipStepUpdate: true
			}
			var value = this.editor ? this.editor.getValue() : "";
			if(value == '<br />' || value == '<br/>')
				value = "";
			else 
				value = escape(value);
			args.actualResult = value;
			args.iterations = this._iterations;
			var responseHandler=new ServiceResponseHandler(callback, "callSuccess", "callFailure");
		    ResultClient.postApplyResult(responseHandler, args);
		},
		
		_handlePauseClick: function(e){
			if(e)
				e.preventDefault();
			this._pause.style.display = 'none';
			this._resume.style.display = 'inline';
			this._resume.setAttribute("tabIndex", 0);
			this._toggleApplyButton(true);
            if(this._keywordExecutionViewer)
                this._keywordExecutionViewer.parentWidget = null;
			this._disableImages();
			this._paused = true;
			this._resume.focus();
		},
		
		_handleResumeClick: function(e){
			if(e)
				e.preventDefault();
			this._pause.style.display = 'inline';
			this._resume.style.display = 'none';
			this._toggleApplyButton(false);
            if(this._keywordExecutionViewer)
                this._keywordExecutionViewer.parentWidget = this;	
			this._enableImages();
			if(this._paused)
				this._paused = false;
			this._pause.focus();
		},

        ////////////////////////////////
		// Going back to already executed stuff
		////////////////////////////////
		_setPointerOnFinalStep: function(stepNum){
			if(this.isExecutionOver && (parseInt(stepNum,10) == (this.numberOfSteps*this._iterations))){
				//disable all buttons properties
				this._toggleApplyButton(true);
				this._disableImages();
				if(dojo.hasClass(this._stepsTable, "item-table-disabled"))
					dojo.removeClass(this._stepsTable, "item-table-disabled")
				this._stepsTable.className = "item-table";	
				this._resume.src = "";
				this._resume.setAttribute("tabIndex", -1);
				this._disableResultSelectBox(true);
				this.disconnect(this.resumeEvent);
                this.resumeEvent = null;
				this.disconnect(this.resumeEnterEvent);
                this.resumeEnterEvent = null;
				this.disconnect(this.pauseEvent);
                this.pauseEvent = null;
				this.disconnect(this.pauseEnterEvent);
                this.pauseEnterEvent = null;
			}else {
				//disable and then re-enable buttons (avoid multiple event attaching)
				this._toggleApplyButton(false);
				this._disableImages();
				this._enableImages();
			}
			if(this.isExecutionOver){
				this._resume.src = "";
				this._resume.setAttribute("tabIndex", -1);
				this._pause.src = ImageCache.NOIMAGE;
				this._pause.setAttribute("tabIndex", -1);
				if (this.resumeEvent) {
                    this.disconnect(this.resumeEvent);
                    this.resumeEvent = null;
                }
				if (this.resumeEnterEvent) {
                    this.disconnect(this.resumeEnterEvent);
                    this.resumeEnterEvent = null;
                }
				if (this.pauseEvent) {
                    this.disconnect(this.pauseEvent);
                    this.pauseEvent = null;
                }	
				if (this.pauseEnterEvent) {
                    this.disconnect(this.pauseEnterEvent);
                    this.pauseEnterEvent = null;
                }	
			}
		},
		
		_changeStepPointer: function(e){
			try{
				if(!e.currentTarget || !e.currentTarget.id)
					return;
				var stepNum = e.currentTarget.id.split(this.TR_ID)[1];				
				
				if(this._currentStepNumber == parseInt(stepNum,10))//Same step clicked twice
					return;
                if(this._staleStepUpdated)
                    this._onStaleStepUpdate(this._currentStepNumber);
				//Since we start with zero we should check for element length
				this._setPointerOnFinalStep(stepNum);
				if(!this.stepEERArray[this._currentStepNumber])
					this.originalStepNum = this._currentStepNumber;
				if(stepNum == this.originalStepNum)	{
					//Enable Apply / Apply All, Pause remove verdict change listener
					this.originalStepNum = null;
					if(!this.isExecutionOver)
						this._toggleApplyButton(false);
					this.pauseEvent = this.connect(this._pause, "onclick", this._handlePauseClick);
					this.pauseEnterEvent = this.connect(this._pause, "onkeypress", function(e){
						var charCode = (e.which) ? e.which : e.keyCode;
						if (charCode == 13 && this.pauseEvent) 	
							this._handlePauseClick();
					});	
					this._pause.title = Constants.getMessage("labelClickToPauseExe");
				}else {
					//Disable Apply and ApplyAll and Pause buttons
					if(this.pauseEvent){
						this.disconnect(this.pauseEvent);
						this.pauseEvent = null;
					}	
					if(this.pauseEnterEvent){
						this.disconnect(this.pauseEnterEvent);
						this.pauseEnterEvent = null;
					}	
					this._pause.title = "";
                    this._updateResultCombo(this._results[stepNum]);	
				}
				this.stepProperties[this._currentStepNumber] = this.getProperties();
				if(this.inProgress)
					return;
				this.inProgress = true;
				this._moveStepPointer(true, this._currentStepNumber, parseInt(stepNum, 10))
				this.inProgress = false;
				this._currentStepNumber = parseInt(stepNum, 10);
			    this._disableResultSelectBox(false);
				this.setProperties(this.stepProperties[this._currentStepNumber]);
				
				if(this.isExecutionOver && (parseInt(stepNum,10) == (this.numberOfSteps*this._iterations)))
					this._disableResultSelectBox(true);
			
			}catch(e){
				console.debug("----error changing step--- "+ stepNum)
			}
		},
		setParentDirty:function(){
			if(this.originalStepNum != null)
                this._staleStepUpdated = true;
		},
		_onStaleStepUpdate: function(stepNum){
            var args = {};
			var properties = this.getProperties();
            if(properties.length > 0)
                args.addProperties = properties;
            var removeAttachmentItemIds = this._buildAttachmentIdList(this.stepEERArray[stepNum].properties);
            if(removeAttachmentItemIds.length>0)
                args.removeAttachmentItemIds = removeAttachmentItemIds;
            var defectIdList = this._buildDefectIdList(properties);
            if(defectIdList.length>0)
                args.defectIds = defectIdList;
            var addAttachmentItemIds = this._buildAttachmentIdList(properties);
            if(addAttachmentItemIds.length > 0)
                args.addAttachmentItemIds = addAttachmentItemIds;
            args.resultElementStateTypeId = this._results[stepNum];
			this._callUpdate(args,stepNum);
		},
		
		_onStaleStepVerdictUpdate: function(){
			var result = this._getStepResult(this._currentStepNumber);
			this._updateResult(result, this._currentStepNumber);
            this._staleStepUpdated = true;
		},
		
		_callUpdate: function(args,stepNum){
			var eerInternalId = this.stepEERArray[stepNum].internalId;
			args.stepItemId =  eerInternalId;
			args.executionResult =  this._resultId;
			args.resultStateId = this._resultStateId;
			var value = this.editor ? this.editor.getValue() : "";
			if(value == '<br />' || value == '<br/>')
				value = "";
			else 
				value = escape(value);
			args.actualResult = value;
            if (this.isExecutionOver && args.resultElementStateTypeId) {
				this._collectDateTime("stop");
				args.startTime = this._startTime ? parseInt(this._startTime) : null;
				args.endTime = parseInt(this._endTime);
				args.machine = Constants.getMessage("labelLocalComputer");
				args.owner = getAuthenticatedContributor().userId;
				args.ewiItemId = this.ewi.itemId;
			}else {
				args.resultState = ResultStates.IN_PROGRESS;
			}
            var self = this;
			var callbackObj ={
				success: function(eer){
					self.uncommittedProperty.splice(stepNum,1);
					self.stepEERArray[stepNum] = eer;
                    self.stepProperties[stepNum] = eer.properties;
					self._resultStateId = eer.resultStateId;
                    self._staleStepUpdated = false;
				},
				error: function(errorObj){
					console.error("Error updating step details ["+errorObj.message+ "] _onStaleStepUpdate")
					self._saveError(errorObj);
				}
			}
			args.iterations = this._iterations;
			var responseHandler=new ServiceResponseHandler(callbackObj, "success", "error");
		    ResultClient.postApplyResult(responseHandler, args);
		},
		
		///////////////////////////////////////////////////////////////////////////////
		// replace placeholder by real cell value
		///////////////////////////////////////////////////////////////////////////////
		_replaceVariable: function(desDiv, iteration){
			var children = desDiv.getElementsByTagName("BUTTON");//desDiv.childNodes;
			var newArray = [];
			var len  = children ? children.length : 0;
			for(var i=0; i<len; i++) {
				newArray.push(children[i]);
			}
			if(newArray && newArray.length) {
				var newDiv = document.createElement("div");
				var len2 = newArray.length;
				var datapool = this._datapool
				for(var i=0; i<len2; i++) {
					var child = newArray[i];
					if (child.name == "variable") {
						var itemId = child.id;
						var preString = this._getButtonHTML(desDiv.innerHTML, itemId);
						var cell = this._getCellFromExist(datapool,itemId, iteration);
						if (!cell) {
							cell = "";
						}
						var preContent = desDiv.innerHTML;
						var newString = preContent.replace(preString, cell);
						desDiv.innerHTML = newString;
					}
				}
			}
			return desDiv;
		},
		
		_getButtonHTML: function(whole, itemId) {
			var hasMore = true;
			while(hasMore) {
				var tmpWhole = whole.toLowerCase(); 
				var start = tmpWhole.indexOf("<button ");
				var end = tmpWhole.indexOf("</button>");
				var tmpString = whole.substring(start, end+9);
				var idSite = tmpString.indexOf(itemId);
				if(idSite > 0){
					return tmpString;
				}
				whole = whole.substring(end+9, whole.length);
				hasMore = (whole.indexOf("<button ") > 0)?true: false;
			}
			return "";
		},
		
		_getCellFromExist: function(datapool,variableItemId, iteration) {
			if (!datapool || !datapool.variables || !datapool.records) {
				return null;
			}
			var _datapoolVariables = datapool.variables;
			var len = _datapoolVariables.length;
			var cells = datapool.records[iteration].cells;
			for(var i = 0; i < len; i++){
				if (_datapoolVariables[i].itemId == variableItemId || _datapoolVariables[i].id == variableItemId) 
					return "<div style=\"display: inline-block\"><b>" + cells[i].value + "</b></div>";			
			}
			return null;
		},

        ////////////////////////////////
		// Error handling
		////////////////////////////////
		_saveError:function(errorObj){
			this.parentSection._displayAlertDialog(errorObj.message);
		},
		_error: function(errorObj) {
			if(this.__timer){
				clearInterval(this.__timer);
				delete this.__timer;
			}
			console.error("Error: (message: '" + errorObj.message + "') from Manual Execution#_error");
		},
		
		isExecutionComplete: function(){
			return this.isExecutionOver;
		},
		uninitialize: function(){
			dojo.forEach(this._menus, function(menu){ 
				if(menu.destroyRecursive){
					menu.destroyRecursive();
				}
			});
			this._menus = [];
			if(this.confirmationDialog)
				this.confirmationDialog.destroyRecursive();
			this.confirmationDialog = null;
			this._destroyEditor();
			this.clearWaitTimer();
			this.inherited(arguments);
		}
});
})();
