/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.execution.web.ui.internal.view.execution.ManualExecutionLog");
dojo.provide("com.ibm.rqm.execution.web.ui.internal.view.execution.ManualExecutionLog");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojox.data.dom");

// Utlities
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.rqm.execution.web.ui.internal.util.Utility");
dojo.require("com.ibm.team.reports.web.client.internal.ReportsClient");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.rqm.planning.web.client.internal.construction.TestScriptClient");
dojo.require("com.ibm.team.repository.web.transport.TeamServerClient");
dojo.require("com.ibm.team.repository.web.transport.ServiceRequest");
dojo.require("jazz.ui.HoverPopup");
dojo.require("com.ibm.team.process.web.client.projectarea");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.datapool.web.client.internal.datapool.DatapoolClient");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.properties.CompareView");
//dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.properties.DefectView");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.rqm.defects.web.ui.workitems.AssociatedWorkItemViewer");
dojo.require("com.ibm.rqm.defects.web.client.ChangeRequestManager");
dojo.require("com.ibm.rqm.defects.web.client.internal.CmIntegrationClient");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionElementResultStates");

(function() { // module container

var ImageCache				= com.ibm.rqm.execution.web.ui.internal.view.common.ImageCache;
var Utility					= com.ibm.rqm.execution.web.ui.internal.util.Utility;
var ServiceResponseHandler 	= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var ReportsClient 			= com.ibm.team.reports.web.client.internal.ReportsClient;
var TeamServerClient 		= com.ibm.team.repository.web.transport.TeamServerClient;
var ServiceRequest 			= com.ibm.team.repository.web.transport.ServiceRequest;
var HoverPopup 				= jazz.ui.HoverPopup;
var getCurrentProjectArea 	= com.ibm.team.process.web.client.projectarea.getCurrentProjectArea;
var Constants               = com.ibm.rqm.planning.web.client.internal.Constants;
var CompareView				= com.ibm.rqm.planning.web.ui.internal.view.construction.properties.CompareView;
//var DefectView				= com.ibm.rqm.planning.web.ui.internal.view.construction.properties.DefectView;
var AssociatedWorkItemViewer		= com.ibm.rqm.defects.web.ui.workitems.AssociatedWorkItemViewer;
var ChangeRequestManager			= com.ibm.rqm.defects.web.client.ChangeRequestManager;
var CmIntegrationClient				= com.ibm.rqm.defects.web.client.internal.CmIntegrationClient;
var DEFECT_URL 						= "#action=com.ibm.team.workitem.viewWorkItem&id=";
var DOWNLOAD_SERVICE_URI 			= "com.ibm.rqm.planning.service.internal.rest.IAttachmentRestService/";
var REPORT_REST_SERVICE_URI 		= "com.ibm.team.reports.common.internal.service.IReportRestService";
var COMMENT_VIEW_TYPE				= "commentView";
var DEFECT_VIEW_TYPE				= "defectView";
var RTC_DEFECT_VIEW_TYPE			= "rtcdefectView";
var ATTACHMENT_VIEW_TYPE			= "attachmentView";
var RESULT_ATTACTMENT_VIEW_TYPE		= "result AttachmentView";
var COMPARE_VIEW_TYPE				= "compareView";
var KEYWORD_STEP_COMPARE			= "keyword step";
var ExecutionElementResultStates	= com.ibm.rqm.execution.web.client.internal.execution.ExecutionElementResultStates;

dojo.declare("com.ibm.rqm.execution.web.ui.internal.view.execution.ManualExecutionLog",[dijit._Widget, dijit._Templated],
	{
		templatePath: dojo.moduleUrl("com.ibm.rqm.execution.web", "ui/internal/view/templates/execution/ManualExecutionLog.html"),
		labelStep:Constants.getMessage("labelStep"),
		labelType: Constants.getMessage("labelType"),
		labelResult: Constants.getMessage("labelResult"),
		labelDescription: Constants.getMessage("labelDescription"),
		labelExpectedResult: Constants.getMessage("labelExpectedResult"),
		labelActualResult: Constants.getMessage("labelActualResult"),
		result: null,
		_verdict: null,
		_itemId: null,
		_scriptName: null,
		_scriptDesc: null,
		_testcase: null,
		_scriptOwner: null,
		_scriptId: null,
		_scriptElements: null,
		_startTime: null,
		_endTime: null,
		_logName: null,
		stepAttachments: [],
		widgetsInTemplate: true,
		//for Datapool: 
		_cells: [],
		defectTooltipMap: {},
		
		reportUrlPrefix: "../../", /* Optional: If not specified, defaults to web ui prefix */
		
		// populate the template with data, connect events, and show initial
		// sub-tab
		postCreate: function() {		
			//Will receive this.resultItemId, this.ewiId
			this.lastClickedRow = "none";
			this._stepsHaveVerdict = Utility.getStepsHaveVerdict();
			this.DEFECT_ICON = this.id+"_defectIcon";
			this.DEFECT_ID	= this.id+"_defect";
			this.ATTACH_ICON = this.id+"_attachIcon";
			this.ATTACH_ID = this.id+"_attach";
			this.COMMENT_ICON = this.id+"_commentIcon";
			this.COMMENT_ID = this.id+"_comment";
			this.COMPARE_ICON = this.id+"_compareIcon";
			this.COMPARE_ID = this.id+"_compare";
			this.stepNumber = 1;
			this.tooltips = [];
		},
		
		initialize: function(){
			this.setResult(this.result);
		},
		
		setResult: function(result){
			this.result = result;
			if(this.result.itemId != null){
				this._itemId = this.result.itemId;
			}	
			this.kwScripts = [];
			this.keywordScriptsToFetch = [];
			if (this.result.elementResults != null) {
				var elementResults = this.result.elementResults;
				var len = elementResults.length;
				for (var i = 0; i < len; i++) {
					var props = elementResults[i].properties;
					if (props) {
						var scriptId = null;
						var scriptStateId = null;
						var keywordId = null;
						var keywordName =null;
						var len2 = props.length;
						for (var j = 0; j < len2; j++) {
							if (props[j].propertyName == "scriptId" && props[j].propertyType == "keyword") {
								scriptId = props[j].propertyValue;
							}
							if (props[j].propertyName == "scriptStateId" && props[j].propertyType == "keyword") {
								scriptStateId = props[j].propertyValue;
							}
							if (props[j].propertyName == "keywordId" && props[j].propertyType == "keyword") {
								keywordId = props[j].propertyValue;
							}
							if (props[j].propertyName == "keywordName" && props[j].propertyType == "keyword") {
								keywordName = props[j].propertyValue;
							}
							if(scriptId && scriptStateId && keywordId && keywordName)
								break;
						}
						if(scriptId && scriptStateId && keywordId){
							this.keywordScriptsToFetch.push({id:scriptId,stateId:scriptStateId,keywordId:keywordId, keywordName:keywordName});
						}
					}					
				}
			}
			// find the related datapool
			var self = this;
			var callbackObj = {
				success: function(results){
					self._datapool = results && results.length == 1 ? results[0] : null;
					self.fillDetails();
				},
				failure: function(e){
					console.error("Failed to find related Test Data");
				}
			}
			var responseHandler = new ServiceResponseHandler(callbackObj, "success", "failure");
			com.ibm.rqm.datapool.web.client.internal.datapool.DatapoolClient.getDatapoolDTOs(responseHandler, {
				linkedTestScriptUUID: this.result.script.itemId,
				linkedTestScriptStateUUID: this.result.script.stateId,
				isIterationRequired: true,
				isDataRequired: true
			});
							
			this._showReport();	 
		},
				
		fillDetails: function(){
			this.numberOfKeywords = this.keywordScriptsToFetch.length;
			this.numberOfKeywordsFetched = 0;
			if(this.numberOfKeywords === 0)
				this._mergeKeywordsAndSteps();
			else{
				var keywordScriptsToFetch = this.keywordScriptsToFetch;
				var len = keywordScriptsToFetch.length;
				for(var j=0;j<len;j++){
					this.fetchKeywordScript(keywordScriptsToFetch[j]);
				}
			}
		},
		fetchKeywordScript:function(script){
            if(this.kwScripts && this.kwScripts[script.keywordId]){
            	this.numberOfKeywordsFetched++;
            	if(this.numberOfKeywordsFetched == this.numberOfKeywords)
            		this._mergeKeywordsAndSteps();
                return;
            }
			var self = this;
			var callbackObj = {
				keywordId:script.keywordId,
				keywordName:script.keywordName,
				success: function(scripts){
					self.kwScripts[this.keywordId] = {};
					self.kwScripts[this.keywordId].script = scripts[0];
					self.kwScripts[this.keywordId].name = this.keywordName;
					self.numberOfKeywordsFetched++;
					if(self.numberOfKeywordsFetched == self.numberOfKeywords)
            			self._mergeKeywordsAndSteps();
				},
				failure: function(e){
					self._error(e);
					self.numberOfKeywordsFetched++;
					if(self.numberOfKeywordsFetched == self.numberOfKeywords)
            			self._mergeKeywordsAndSteps();
				}				
			}
			var args = {
				id: script.id,
				includeArchived: true,
				stateId: script.stateId
			};
			var responseHandler = new ServiceResponseHandler(callbackObj, "success", "failure");
			com.ibm.rqm.planning.web.client.internal.construction.TestScriptClient.getTestScripts(responseHandler, args);
			
		},
		_mergeKeywordsAndSteps:function(){
			this._steps = [];
			var elements= this.result.script.elements;
			var len = elements.length;
			for (var i = 0; i < len; i++){
				if(elements[i].elementType && elements[i].elementType.name == "Keyword"){
					this.keywordElementType = elements[i].elementType;
					var keywordId = this._getKeywordId(i);
					var kwScript = this.kwScripts[keywordId]?this.kwScripts[keywordId].script:null;
					if(kwScript && kwScript.elements && kwScript.scriptType.id == "com.ibm.rqm.planning.common.scripttype.manual"){
						var len2 = kwScript.elements.length;
						for(var j=0;j<len2;j++){
							var expRslt = kwScript.elements[j].expectedResult?unescape(kwScript.elements[j].expectedResult):"";
							var isFirstStep = (j === 0);
							this._steps.push({
								content: kwScript.elements[j].content,
								keywordName:this.kwScripts[keywordId].name,
								expectedResult:expRslt,
								stepType:kwScript.elements[j].elementType,
								isManual:true,
								isKeywordFirstStep:isFirstStep
							});
						}
					}else{
						this._steps.push({
							content: this.kwScripts[keywordId]?this.kwScripts[keywordId].name:"",
							keywordName:this.kwScripts[keywordId]?this.kwScripts[keywordId].name:"",
							expectedResult:"",
							stepType:this.keywordElementType,
							isManual:false
						});
					}
				}else{
					var expRslt = elements[i].expectedResult?unescape(elements[i].expectedResult):"";
					this._steps.push({
						content: elements[i].content, 
						expectedResult:expRslt,
						stepType:elements[i].elementType
					});
				} 	
			}
			this._layoutUI();
		},
		_layoutUI:function(){
			if(this.result.elementResults){
				this.actualResult = [];
				this.stepProperties = [];
				this.stepResults = [];
				var elementResults = this.result.elementResults;
				var len = elementResults.length;
				var steps = this._steps;
				var len2 = steps.length;
				var stepProperties = this.stepProperties;
				var actualResult = this.actualResult;
				var stepResults = this.stepResults;
				for(var i = 0; i < len; i++){
					var elementResult = elementResults[i];
					stepProperties[i] = elementResult.properties? dojo.clone(elementResult.properties):[];
					actualResult[i] = elementResult.actualResult?unescape(elementResult.actualResult):"";
					stepResults[i] = elementResult.result;
					this._appendEditableStepRow( i, steps[i%len2]);
				}
			}
		},
		_getKeywordId: function(stepNum){
            var keywordId = null;
			var properties = this.result.script.elements[stepNum].properties;
			if (properties) {
				var len = properties.length;
				for (var j = 0; j < len; j++) {
					if (properties[j].propertyType == "keyword") {
						if (properties[j].propertyName == "keywordId") 
							keywordId = properties[j].propertyValue;
						break;
					}
				}
			}
            return keywordId;
        },
		getHelpContextID: function(){
      		return "rqm_manual_execution_results_overview.html";
   		},
		
		getAttributes: function(){
			return null;
		},
		
		_createPropertiesHtml: function(stepNum,properties){
			var doc = document;
			var attachCell = this._getEmptyCell(doc);
			attachCell.id = this.ATTACH_ID+stepNum;
			attachCell.align = "right";  
			var defectCell = this._getEmptyCell(doc);
			defectCell.id = this.DEFECT_ID+stepNum;
			defectCell.align = "right"; 
			var commentCell = this._getEmptyCell(doc);
			commentCell.id = this.COMMENT_ID+stepNum;
			commentCell.align = "right"; 
			var compareCell = this._getEmptyCell(doc);
			compareCell.id = this.COMPARE_ID+stepNum;
			compareCell.align = "right"; 
			
			var defectFound = false; var attachmentFound = false; var commentFound = false;
			var attachmentCount= 0;
			var defectCount = 0;
			var attachmentsHtml = doc.createElement("span");
			var attachmentsHtmlTable = attachmentsHtml.appendChild(doc.createElement("table"));
			var attachmentsHtmlContent = attachmentsHtmlTable.appendChild(doc.createElement("tbody"));
			var commentsHtmlContent = doc.createElement("span"); 
			var defectsHtml = doc.createElement("span");
			var defectsHtmlTable = defectsHtml.appendChild(doc.createElement("table"));
			var defectsHtmlContent = defectsHtmlTable.appendChild(doc.createElement("tbody"));
			if(properties){
				var len = properties.length;
				for(var i=0;i<len;i++){
					switch(properties[i].propertyType){
						case DEFECT_VIEW_TYPE:
						case RTC_DEFECT_VIEW_TYPE:
							if(defectFound == false){
								var defectImg = doc.createElement("img");
								defectImg.alt= Constants.getMessage("labelDefects");
								defectImg.src = ImageCache.DEFECT;
								defectImg.className = "type-image";
								defectImg.setAttribute("tabIndex", 0);
								defectImg.id = this.DEFECT_ICON + stepNum;
								defectCell.appendChild(defectImg);
								dojox.data.dom.removeChildren(defectsHtmlContent);
								if (dojo.isIE) {
									defectImg.onkeypress = dojo.hitch(this, function(event){
										if(this.defectTooltipMap[stepNum])
											this.defectTooltipMap[stepNum].open();
									});
								}
								else {
									defectImg.onkeypress = this.connect(defectImg, "onkeypress", function(e){
										if(this.defectTooltipMap[stepNum])
											this.defectTooltipMap[stepNum].open();
									});
								}
								defectFound = true;
							}							
							defectCount++;							
							var defectsHtmlContentRow = this._getEmptyRow(doc);
							var defectsHtmlContentCell = this._getEmptyCell(doc);
							var defectsAnchor = doc.createElement("a");
							var defectLabel;
							if(properties[i].propertyType == DEFECT_VIEW_TYPE){
                                defectLabel = doc.createTextNode(Constants.getMessage("labelDefectIdExecution",  properties[i].propertyValue));
								defectsAnchor.href = DEFECT_URL + properties[i].propertyValue;
                                defectsAnchor.target = "_blank";
							}else{
								defectsAnchor.target = "_blank";
								defectsAnchor.href = properties[i].propertyValue;
								defectLabel = doc.createTextNode(properties[i].propertyName);
							}
							defectsAnchor.setAttribute("tabIndex", 0);
							defectsAnchor.appendChild(defectLabel);	
							defectsHtmlContentCell.appendChild(defectsAnchor);
							defectsHtmlContentRow.appendChild(defectsHtmlContentCell);
							defectsHtmlContent.appendChild(defectsHtmlContentRow);
							break;
						
						
						case ATTACHMENT_VIEW_TYPE:
						case RESULT_ATTACTMENT_VIEW_TYPE:						
						if(attachmentFound == false){
								var attachImg = doc.createElement("img");
								attachImg.alt= Constants.getMessage("labelAttachment");
								attachImg.src = ImageCache.ATTACHMENT;
								attachImg.className = "type-image";
								attachImg.id = this.ATTACH_ICON + stepNum;								
								attachCell.appendChild(attachImg);
								attachmentFound = true;
								dojox.data.dom.removeChildren(attachmentsHtmlContent);
							}
							attachmentCount++;
							var attachmentsHtmlContentRow = this._getEmptyRow(doc);
							var attachmentsHtmlContentCell = this._getEmptyCell(doc);
							var attachmentsAnchor = doc.createElement("a");
							attachmentsAnchor.target = "_blank";
							var valueArr = properties[i].propertyValue.split(":");
							var attachmentsText = valueArr[0];
							attachmentsAnchor.appendChild(doc.createTextNode(attachmentsText));
							attachmentsAnchor.href = TeamServerClient._getServicePrefix()+ DOWNLOAD_SERVICE_URI + valueArr[3];
							attachmentsHtmlContentCell.appendChild(attachmentsAnchor);
							attachmentsHtmlContentRow.appendChild(attachmentsHtmlContentCell);
							attachmentsHtmlContent.appendChild(attachmentsHtmlContentRow);
							break;
						
						case COMMENT_VIEW_TYPE:
							if(properties[i].propertyValue && properties[i].propertyValue.length>0){
								commentFound = true;
								dojox.data.dom.removeChildren(commentsHtmlContent);
								commentsHtmlContent.appendChild(doc.createTextNode(properties[i].propertyValue));
								commentImg = doc.createElement("img");
								commentImg.alt= Constants.getMessage("labelComment");
								commentImg.src = ImageCache.COMMENT;
								commentImg.className = "type-image";
								commentImg.id = this.COMMENT_ICON + stepNum;
								commentCell.appendChild(commentImg);
							}
							break;
						case COMPARE_VIEW_TYPE:
							var compareButton = doc.createElement("button");
							if(dojo.isIE >= 7)
									compareButton.style.backgroundColor = '#FFFFFF';
								else
									compareButton.style.background = "inherit";
							compareButton.style.border="0pt";
							var compareImg = doc.createElement("img");
							compareImg.alt= Constants.getMessage("labelCompare");
							compareImg.src = ImageCache.COMPARE;
							compareImg.className = "type-image";
							compareButton.id = this.COMPARE_ICON + stepNum;
							compareButton.appendChild(compareImg);
							compareCell.appendChild(compareButton);
							this.connect(compareButton, "onclick", dojo.hitch(this,"_showCompareDialog",stepNum,null));
							break;
						default:
							//do Nothing
					}
				}	
			}
			if(attachmentCount>0){
				var _attachmentTooltipSpan = doc.createElement("span");
				attachCell.appendChild(_attachmentTooltipSpan);
				var attachmentCountText = doc.createTextNode("("+attachmentCount+")");
				dojo.style(attachCell,"fontSize","0.7em");
				attachCell.appendChild(attachmentCountText);
				var tooltip = new HoverPopup({around: [attachImg],html: attachmentsHtml.innerHTML}, _attachmentTooltipSpan);
				this.tooltips.push(tooltip);
			}
			if(defectCount>0){
				var _defectTooltipSpan = doc.createElement("span");
				defectCell.appendChild(_defectTooltipSpan);
				var defectCountText = doc.createTextNode("("+defectCount+")");
				dojo.style(defectCell,"fontSize","0.7em");
				defectCell.appendChild(defectCountText);
				var tooltip = new HoverPopup({
					around: [defectImg],
					html: defectsHtml.innerHTML
				});
				this.tooltips.push(tooltip);
				if(this.defectTooltipMap[stepNum])
					this.defectTooltipMap[stepNum].destroy();
				this.defectTooltipMap[stepNum] = tooltip;
			}	
			if(commentFound ===true){
				var _commentTooltipSpan = doc.createElement("span");
				commentCell.appendChild(_commentTooltipSpan);
				var tooltip = new HoverPopup({around: [commentImg],html:commentsHtmlContent.innerHTML}, _commentTooltipSpan);
				this.tooltips.push(tooltip);				
			}			
			return [attachCell,defectCell,commentCell,compareCell];
		},		
		_showCompareDialog:function(stepNum,properties){
			var stepProperties = properties ? properties:this.stepProperties[stepNum];
			if(!stepProperties){
				if(stepNum.indexOf('_')>0){
					var keywordStepNum = stepNum.split('_')[1];
					var keywordNum = stepNum.split('_')[0];
					keywordNum = parseInt(keywordNum,10);
					var props = this.stepProperties[keywordNum];
					var len = props.length;
					for(var i=0;i<len;i++){
						if(props[i].propertyName ==keywordStepNum && props[i].propertyType == KEYWORD_STEP_COMPARE){
							var propName = props[i].propertyValue.split('#')[0];
							var propValue = props[i].propertyValue.split('#')[1];
							stepProperties = [{propertyName:propName,propertyType:COMPARE_VIEW_TYPE,propertyValue:propValue}];
							break;
						}
					}
				}else
					return;
			}
			var compareButton = dojo.byId(this.COMPARE_ICON + stepNum);
			dijit.popup.close(this.compareView);
			if (!this.compareView) {
				this.compareView = new CompareView({
					hideActual: false,
					editable: false,
					callback:dojo.hitch(this,function(){
							dijit.popup.close(this.compareView);
						})
				});
				dojo.style(this.compareView.domNode,"background","white");
				dojo.style(this.compareView.domNode,"border","1px solid gray");
				dojo.style(this.compareView.domNode,"padding","5px");
				dojo.style(this.compareView.domNode,"width","200px");
			}
			this.compareView.setData(stepProperties);
			dijit.popup.open({ parent: compareButton,
				popup: this.compareView,
				around: compareButton,
				orient: {'BL':'TL', 'BR':'TR', 'TL':'BL', 'TR':'BR'},
				onExecute: function(){}
			});
			this.compareView.setFocus();
		},
		
//		_showDefect:function(stepNum, propertyType){
//			defectProps = [];
//			var props = this.stepProperties[stepNum];
//			if(props){
//				for(var i=0;i<props.length ;i++)
//					if(props[i].propertyType == propertyType)
//						defectProps.push(props[i]);
//			}
//			if(propertyType == DEFECT_VIEW_TYPE){
//				if(!this._defectView)
//					this._defectView = new DefectView({parentEditor: this.parentEditor});
//				this._defectView.setData(defectProps);			
//				var dialogArgs = {
//					primaryTitle: Constants.getMessage("labelDefectsView"),
//		            isClosable: true,
//					showActions:false,
//					zIndex : 100
//	            };
//				this._defectView.setViewType("list");
//	            this._defectsViewer = new com.ibm.asq.common.web.ui.internal.widgets.ConfirmationDialog(dialogArgs);
//	            this._defectsViewer.setWidth('800px');			
//				this._defectView.setParentDialog(this._defectsViewer);
//				this._defectsViewer.contentContainer.appendChild(this._defectView.domNode);
//				this._defectsViewer._onClose = function(){
//					this.destroy();//dont destroy recursive;
//				}
//				this._defectsViewer.open();
//			} else if (propertyType == RTC_DEFECT_VIEW_TYPE){
//				var draftUriFilter = [];
//				var ewiId = this.parentEditor.getEWI().itemId;
//				ewiId = ewiId ? ewiId : null;
//				for(var i = 0; i < defectProps.length; i++){
//					draftUriFilter.push(
//						defectProps[i].propertyValue
//					);
//				}
//				var listDialog= AssociatedWorkItemViewer.create(ewiId, CmIntegrationClient.RESULT_RELATEDTO_DEFECT, false, draftUriFilter);
//			}
//
//		},
		_appendEditableStepRow: function(stepNum, stepObj){
			if(stepObj && stepObj.isKeywordFirstStep)
				this._insertKeywordNameRow(stepObj,stepNum);
			var targetRow = this._getEmptyRow(document);
			targetRow.id = "_tr"+stepNum;
			this.attachmentEvent = this.connect(targetRow, "onclick", this._handleRowClick);
			this._stepsTableBody.appendChild(targetRow);
			this._insertStep(targetRow,stepNum,stepObj);
		},
		
		_insertStep:function(targetRow,stepNum,stepObj){
			var doc = document;
			dojox.data.dom.removeChildren(targetRow);
			//step number cell
			var numCell = this._getEmptyCell(doc);
			if(stepObj.isManual)
                numCell.appendChild(doc.createTextNode(""));
            else 
			    numCell.appendChild(doc.createTextNode(this.stepNumber++));
			targetRow.appendChild(numCell);
			//step type cell
			var typeCell = this._getEmptyCell(doc);
			var typeImg = doc.createElement("img");
			if (stepObj.isManual) {
				typeImg.src = ImageCache.NOIMAGE;
			}else {
				typeImg.src = ImageCache.getTypeIconURL(stepObj.stepType);
				typeImg.title = stepObj.stepType.name;
				typeImg.alt = stepObj.stepType.name;
			}
			typeImg.className = "type-image";
			typeCell.appendChild(typeImg);
			targetRow.appendChild(typeCell);
			
			//result type cell
			var resultCell = this._getEmptyCell(doc);
			var resultImg = doc.createElement("img");
			resultImg.src= Utility.getImageForResult(this.stepResults[stepNum]);
			resultImg.alt = ExecutionElementResultStates.LABELS[this.stepResults[stepNum].id];
			resultImg.id = "_results" + stepNum;
			resultCell.appendChild(resultImg);

			if(this.stepResults[stepNum]&& this.stepResults[stepNum].id != "com.ibm.rqm.execution.common.state.complete"){
				resultCell.appendChild(doc.createTextNode(ExecutionElementResultStates.LABELS[this.stepResults[stepNum].id]));
			}
			targetRow.appendChild(resultCell);
			//step name / description cell
			var descriptionCell = this._getEmptyCell(doc);
			var descriptionInput = doc.createElement('div');
			descriptionInput.innerHTML = unescape(stepObj.content);
			descriptionInput.id = "_stepDesc" + stepNum;
			if (stepObj.isManual) {
				var stepTypeImg = doc.createElement("img");
				stepTypeImg.title = stepObj.stepType.name;
                stepTypeImg.alt = stepObj.stepType.name;
                stepTypeImg.src = ImageCache.getTypeIconURL(stepObj.stepType);
				descriptionInput.innerHTML = "";
				descriptionInput.appendChild(stepTypeImg);
				descriptionInput.innerHTML = descriptionInput.innerHTML+unescape(stepObj.content);
			}
			descriptionCell.appendChild(descriptionInput);	
			targetRow.appendChild(descriptionCell);
			//expected Res
			var expCell = this._getEmptyCell(doc);
			var expDiv = doc.createElement('div');
			expDiv.innerHTML = stepObj.expectedResult;
			expCell.appendChild(expDiv);
			targetRow.appendChild(expCell);
			//Actual Res
			var actCell = this._getEmptyCell(doc);
			var actDiv = doc.createElement('div');
			actDiv.innerHTML = this.actualResult[stepNum];
			actCell.appendChild(actDiv);
			targetRow.appendChild(actCell);
			//deal with Datapool value: 
			this._replaceVariable(descriptionInput, Math.floor(stepNum/this._steps.length));
			this._replaceVariable(expDiv, Math.floor(stepNum/this._steps.length));
			
			//Changes for Properties
			var properties = this.stepProperties[stepNum];
			var propshtml = this._createPropertiesHtml(stepNum,properties);
			targetRow.appendChild(propshtml[0]);
			targetRow.appendChild(propshtml[1]);
			targetRow.appendChild(propshtml[2]);
			targetRow.appendChild(propshtml[3]);
		},
			
		_insertKeywordNameRow:function(stepObj,stepNum){
			var doc = document;
			var stepRow = this._getEmptyRow(doc);
			var numCell = this._getEmptyCell(doc);
			numCell.appendChild(doc.createTextNode(this.stepNumber++));
			stepRow.appendChild(numCell);
			var typeCell = this._getEmptyCell(doc);
			var typeImg = doc.createElement("img");            
            typeImg.title = this.keywordElementType.name;
            typeImg.alt = this.keywordElementType.name;
            typeImg.src = ImageCache.getTypeIconURL(this.keywordElementType);
			typeImg.className = "type-image";
			typeCell.appendChild(typeImg);
			stepRow.appendChild(typeCell);
			var resultCell = this._getEmptyCell(doc);
			var resultSelect = doc.createElement("img");
			resultSelect.title = "";
			resultSelect.alt = "";
			resultSelect.src = ImageCache.NOIMAGE;
			resultSelect.className = "";
			resultCell.appendChild(resultSelect);
			stepRow.appendChild(resultCell);
			var nameCell = this._getEmptyCell(doc);
			nameCell.appendChild(doc.createTextNode(stepObj.keywordName));
			nameCell.colSpan=9;
			stepRow.appendChild(nameCell);
			this._stepsTableBody.appendChild(stepRow);

		},
		
		_getEmptyRow: function(doc){
			var row = doc.createElement("tr");
			row.className = "steps-table-row";
			return row;
		},
		
		_getEmptyCell: function(doc,span, align){
			var cell = doc.createElement("td");
			cell.className = "steps-table-cell";
			if ( span != null ){
				cell.colSpan = span;
			}
			if ( align != null ){
				cell.align = align;
			}
			return cell;
		},
		
		_handleRowClick: function(e){
			e.preventDefault();
			var currentTarget = e.currentTarget.id
			var s = currentTarget.split("_tr")
			if(this.lastClickedRow != "none"){
				var row = document.getElementById("_tr"+this.lastClickedRow)
				row.className = "steps-table-row"
			}	
			this.lastClickedRow = s[1];
			var row = document.getElementById("_tr"+s[1])
			row.className = "selected-row"	
		},
		
		_showReport: function(){
			/*ReportUUID is static and defined for Manual Execution Status report as execution.manualStatus*/
			var self = this;
			var arguments = {
				projectAreaUUID: getCurrentProjectArea().itemId,
				reportUUID: "execution.manualStatus",
				parameterName: "resultId",
				parameterValue: self._itemId,
				showArchived: false,
				urlPrefix: self.reportUrlPrefix
			};
			var serviceObject = {
			// Service success
				success: function(html) {
					self._reportChart.innerHTML = html;
				},
			// Service failure
				failure: function(errorObject) {
					self._error(errorObject);
				}
			};
			var responseHandler = new ServiceResponseHandler(serviceObject, "success", "failure");
			var request = new ServiceRequest(REPORT_REST_SERVICE_URI,"getRenderedReport",arguments);
			// Invoke the service
			TeamServerClient.invokeService(request, responseHandler);
		},
		
		///////////////////////////////////////////////////////////////////////////////
		// replace placeholder by real cell value
		///////////////////////////////////////////////////////////////////////////////
		_replaceVariable: function(desDiv, iteration) {
			var children = desDiv.getElementsByTagName("BUTTON");//desDiv.childNodes;
			var newArray = [];
			var len = children ? children.length:0;
			for(var i=0; i<len; i++) {
				newArray.push(children[i]);
			}
			if(newArray && newArray.length) {
				var newDiv = document.createElement("div");
				var len2 = newArray.length;
				var datapool = this._datapool;
				for(var i=0; i<len2; i++) {
					var child = newArray[i];
					if (child.name == "variable") {
						var itemId = child.id;
						var preString = this._getButtonHTML(desDiv.innerHTML, itemId);
						var cell = this._getCellFromExist(datapool,itemId, iteration);
						if (!cell) {
							cell = "";
						}
						var preContent = desDiv.innerHTML;
						var newString = preContent.replace(preString, cell);
						desDiv.innerHTML = newString;
					}
				}
			}
			return desDiv;
		},
		
		_getButtonHTML: function(whole, itemId) {
			var hasMore = true;
			while(hasMore) {
				var tmpWhole = whole.toLowerCase(); 
				var start = tmpWhole.indexOf("<button ");
				var end = tmpWhole.indexOf("</button>");
				var tmpString = whole.substring(start, end+9);
				var idSite = tmpString.indexOf(itemId);
				if(idSite > 0){
					return tmpString;
				}
				whole = whole.substring(end+9, whole.length);
				hasMore = (whole.indexOf("<button ") > 0)?true: false;
			}
			return "";
		},
		
		_getCellFromExist: function(datapool,variableItemId, iteration) {
			if (!datapool || !datapool.variables || !datapool.records) {
				return null;
			}else{
				if(!this.parentEditor.isDatapoolValueUpdated()){
					this.parentEditor.showDatapoolUsage(datapool);
				}
			}
			var _datapoolVariables = datapool.variables; 
			var len = _datapoolVariables.length;
			var cells = datapool.records[iteration].cells;
			for(var i = 0; i < len; i++){
				if (_datapoolVariables[i].itemId == variableItemId || _datapoolVariables[i].id == variableItemId) 
					return "<div style=\"display: inline-block\"><b>" + cells[i].value + "</b></div>";			
			}
			return null;
		},
		
		_contains: function(items, itemId){
            if(items && items.length) {
				var len = items.length;
				for(var i = 0; i< len; i++) {
					if(items[i].itemId == itemId)
						return true;
				}
			}
			return false;
        },
		deleteDefect:function(defectList){
			var self = this;
			var args = {
				title: Constants.getMessage("labelConfirmation"),
				message: Constants.getMessage("msgRemoveDefectAssociation"),
				yesCallback: function(defectList){
					self.parentEditor._deleteDefects(defectList);
					self._deleteDefect(defectList);
					return true;          
				},
				yesCallbackData:defectList
			}
			var dialog = new com.ibm.asq.common.web.ui.internal.widgets.YesNoDialog(args);
	        dialog.setSecondaryTitle(args.title);
	        dialog.open();
		},
		_deleteDefect:function(defectList){
			var found = false;
			if(defectList && defectList.length){
				var len = defectList.length;
				var stepProperties = this.stepProperties;
				var len2 = stepProperties.length;
				for(var i=0;i<len;i++){
					var defectId = defectList[i].id+"";//convert int to string
					for(var j=0;j<len2;j++){
						var prop = stepProperties[j];
						var len3 = prop.length;
						for (var k = 0; k < len3; k++) {
							var property = prop[k];
							if((property.propertyType == DEFECT_VIEW_TYPE && property.propertyValue == defectId) ||
								(property.propertyType == RTC_DEFECT_VIEW_TYPE && property.propertyValue == defectList[i].defectItemUri))
							{
								prop.splice(k,1);
								found = true;
								break;
							}
						}
					}
				}
			}
			if(found){
				dojox.data.dom.removeChildren(this._stepsTableBody);
				this.stepNumber = 1;
				var len = this.result.elementResults.length;
				var steps = this._steps;
				var len2 = steps.length;
				for (var i = 0; i < len; i++) {
					this._appendEditableStepRow( i, steps[i%len2]);
				}
				this.setLogDirty(true);
			}
		},
		isLogDirty:function(){
			return this.dirty;
		},
		setLogDirty:function(dirty){
			this.dirty = dirty;
		},
		getMixInArgs:function(){
			var args = {};
			var steps = [];
			var stepResults = this.stepResults;
			var len = stepResults.length;
			var elementResults = this.result.elementResults;
			var actualResult = this.actualResult;
			var stepProperties = this.stepProperties;
			for(var i=0;i<len;i++){
				var step = {};
				step.startTime = elementResults[i].startTime+"";
				step.endTime = elementResults[i].endTime+"";
				step.actualResult = actualResult[i];
				step.properties = stepProperties[i]? stepProperties[i]:[];
				step.result = stepResults[i].id;
				steps.push(step);
			}
			args.elementResultJsonString = dojo.toJson(steps);
			return args;
		},
		_error: function(e){
			console.error("An error occurred: [" + e.message + "] @ ManualExecutionLog#_error");
		},
		uninitialize: function(){
			dojo.forEach(this.tooltips, function(tooltip){ 
				if(tooltip.destroyRecursive){
					tooltip.destroyRecursive();
				}
			});
			this.tooltips = [];
			if (this.compareView)
				this.compareView.destroyRecursive();
			this.compareView = null;
		}	
	}
);

}
)();
