/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.execution.web.ui.internal.view.execution.NoScriptExecution");
dojo.provide("com.ibm.rqm.execution.web.ui.internal.view.execution.NoScriptExecution");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojox.data.dom");

// Clients
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.rqm.planning.web.client.internal.RegistryClient");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultClient");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionWorkItemClient");
dojo.require("com.ibm.rqm.planning.web.client.internal.construction.TestScriptClient");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.properties.AttachmentView");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.execution.web.client.internal.mapper.EWIMapper");
// Require local widgets
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.rqm.execution.web.ui.internal.util.Utility");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.richtext.RichTextControl");
//Dojo widget
dojo.require("dijit.form.Button");
dojo.require("dojo.parser");
dojo.require( "com.ibm.asq.common.web.ui.internal.util.SelectUtility" );

djConfig="parseOnLoad: true, isDebug: true";

(function() { // module container

var ServiceResponseHandler 			= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var ResultClient					= com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultClient;
var ExecutionWorkItemClient 		= com.ibm.rqm.execution.web.client.internal.execution.ExecutionWorkItemClient;
var TestScriptClient				= com.ibm.rqm.planning.web.client.internal.construction.TestScriptClient;
var RegistryClient     				= com.ibm.rqm.planning.web.client.internal.RegistryClient;
var ImageCache						= com.ibm.rqm.execution.web.ui.internal.view.common.ImageCache;
var Utility							= com.ibm.rqm.execution.web.ui.internal.util.Utility;
var RichTextControl 				= com.ibm.asq.common.web.ui.internal.widgets.richtext.RichTextControl;
var Constants                       = com.ibm.rqm.planning.web.client.internal.Constants;
var SelectUtility 					= dojo.getObject( "com.ibm.asq.common.web.ui.internal.util.SelectUtility" );
var EWIMapper						= com.ibm.rqm.execution.web.client.internal.mapper.EWIMapper;

dojo.declare("com.ibm.rqm.execution.web.ui.internal.view.execution.NoScriptExecution",[dijit._Widget, dijit._Templated],
	{
		templatePath: dojo.moduleUrl("com.ibm.rqm.execution.web", "ui/internal/view/templates/execution/NoScriptExecution.html"),
		
		
		labelTestCaseDetails: Constants.getMessage("labelTestCaseDetails"),
		labelDescription: Constants.getMessage("labelDescription"),
		labelTestCaseDesign: Constants.getMessage("labelTestCaseDesign"),
		labelPreConditions: Constants.getMessage("labelPreConditions"),
		labelPostConditions: Constants.getMessage("labelPostConditions"),
		labelAcceptanceCriteria: Constants.getMessage("labelAcceptanceCriteria"),
		labelExpectedResult: Constants.getMessage("labelExpectedResult"),
		labelNotes: Constants.getMessage("labelNotes"),
		labelAttachments: Constants.getMessage("labelAttachments"),
		labelComments: Constants.getMessage("labelComments"),
		
		widgetsInTemplate:true,
		ewi: null,
		script: null, 
		testcase: null,
		_results: [],
		_startTime: null,
		_endTime: null,
		_EWIitemId: null,
		_resultId: null,
		_resultTypes: [],		
		parentController: null,
		
		postCreate: function() 
		{		
			//We will receive this.ewiItemId and this.runScriptId
			this._popOut.src = ImageCache.POP_OUT_EXECUTION_WINDOW;
			this._defect.src = ImageCache.DEFECT_VIEW;
			this._popOut.title =this._defect.title = Constants.getMessage("labelDummyIcon");
			this._descriptionRow.className = "item-table";
			
			var self = this;
			//Create button for Apply
			var applyParams = {
				label: Constants.getMessage("labelApply"),
				name: "applyButton",
				iconClass: "ButtonIcon ApplyButton",//Icons will be changed
				/*baseClass: "ButtonClass",*/
				onClick: function(){ self.onApply(); }
			};
			this.applyButton = new dijit.form.Button(applyParams, this._applyButton);

			var responseHandler = new EWIMapper(this, "_setInitialValues", "_error");			
			ExecutionWorkItemClient.getExecutionWorkItemByItemId(responseHandler, {itemId: this.ewiItemId, resolveResults: false});
		},

		_setInitialValues: function(ewi)
		{
			this.ewi = ewi.length?ewi[0]:ewi;
			if(this.ewi.testCase != null)
			{
				this.testcase = this.ewi.testCase;
				this.testcaseDescription = this.testcase.description;
				this.preCondition = this.testcase.preCondition;
				this.postCondition = this.testcase.preCondition;
				this.acceptanceCriteria = this.testcase.acceptanceCriteria;
				this.expectedResults = this.testcase.expectedResults;
				this.notes = this.testcase.notes;
			}
			if(this.runScriptId == null)
				this.runScriptId = this.ewi.defaultScript?this.ewi.defaultScript.versionableItemId:null;
			this._connectMouseListeners();
		},

		_enableImages: function()
		{
			this._popOut.src = ImageCache.POP_OUT_EXECUTION_WINDOW;
			this._defect.src = ImageCache.DEFECT_VIEW;
			document.getElementById("_resultSelected").disabled = false;
			//Connect events to icons
			this.addDefectEvent = this.connect(this._defect, "onclick", this._handleDefectClick);
			this.popOutEvent = this.connect(this._popOut, "onclick", this._handlePopOutExecutionWindowClick);
		},
		
		_disableImages: function()
		{
			this._popOut.src = ImageCache.POP_OUT_EXECUTION_WINDOW_DISABLED;
			this._defect.src = ImageCache.DEFECT_VIEW_DISABLED;
			document.getElementById("_resultSelected").disabled = true;
			this.disconnect(this.addDefectEvent);
			this.disconnect(this.popOutEvent);
		},
		
		_connectMouseListeners: function()
		{
			this.addDefectEvent = this.connect(this._defect, "onclick", this._handleDefectClick);
			this.popOutEvent = this.connect(this._popOut, "onclick", this._handlePopOutExecutionWindowClick);
			var handler= new ServiceResponseHandler(this, "_initStateTypes", "_error");
			RegistryClient.getAllExecutionElementResultStateTypes(handler);
		},
		
		_initStateTypes: function(types)
		{
			dojox.data.dom.removeChildren(this._resultSelectBox);
			
			var self = this;
			this._resultTypes = types;
			if(types != null)
			{
				for (var i = 0; i < types.length; i++) 
				{
					var opt = new Option(types[i].name, types[i].id);
					SelectUtility.add( this._resultSelectBox, opt );
				}
			}
			if(this._resultId == null)
			{
				var args = {
					versionableItemId: this.runScriptId,
					includeArchived: true
				};

				var responseHandler = new ServiceResponseHandler(this, "initialise", "_error");			
				TestScriptClient.getTestScripts(responseHandler, this.runScriptId);
			}else
			{
				var args = {
					resultItemId: this._resultId,
					resolveDefects:true
					}
				var responseHandler=new ServiceResponseHandler(this, "_getResult", "_error");
		    	ResultClient.getExecutionResultDTO(responseHandler, args);
			}
		},
		
		
		_getResult: function(result)
		{
			var arr = new Array();
			arr.push(result.script);
			this.initialise(arr);
		},
			
		initialise: function(params)
		{
			this.attachmentView = new com.ibm.rqm.planning.web.ui.internal.view.construction.properties.AttachmentView();
			this.attachmentView.initialize({});
			this._attachments.appendChild(this.attachmentView.domNode);
			if(!this._editor){
				this._editor = new RichTextControl({
						inEditMode: true
						});
				this._commentsEditor.appendChild(this._editor.domNode);
			}
			this._editor.show();
			this._collectDateTime("start");
			
			//get the info from the testcase and display it
			this._description.innerHTML = this.testcaseDescription;
			this._steps.innerHTML = this.ewi.testCase.steps;
			this._preCondition.innerHTML = this.preCondition;
			this._postCondition.innerHTML = this.postCondition;
			this._acceptanceCriteria.innerHTML =this.acceptanceCriteria;
			this._expectedResults.innerHTML = this.expectedResults;
			this._notes.innerHTML = this.notes;
			
		},
		
		
		_collectDateTime: function(arg)
		{
			//Date
			var currentTime = new Date();
			if(arg == "start")
				this._startTime = Utility._convertDateToLong(currentTime);//"111";month + "/" + day + "/" + year+ " "+hours + ":" + minutes + " :" + seconds +" "+ampm;
			else
				this._endTime = Utility._convertDateToLong(currentTime);// month + "/" + day + "/" + year+ " "+hours + ":" + minutes + " :" + seconds +" "+ampm;	
		},
		
				
		onApply: function()
		{
			if(this._resultId != null)
			{
				this._toggleApplyButton(true);
				
				if(this.parentWidget != null)
					this.parentWidget.updateStatus("Executing");
				
				this.isEndOfExecution(null);				
			}
			else 
			{
				this._toggleApplyButton(true);
				var par = {
					ewiItemId: this.ewi.itemId,
					testScriptItemid: null
				}
				var self = this;
				var callbackObj =
				{
					success: function(result) 
					{
						self._resultId = result.itemId; 
						self.onApply();
					},
					error: function(e) 
					{
						self._error(e);
					}				
				}
				var responseHandler = new ServiceResponseHandler(callbackObj, "success", "error");			
				ExecutionWorkItemClient.postExecute(responseHandler, par);
			}			
		},
				
		_toggleApplyButton: function(visible)
		{
			this.applyButton.setDisabled(visible);
		},
		_getAttachmentIds: function()
		{
			var attachmentsList = this.attachmentView.getData("attachmentView");
			var attachmentIdList = new Array();
			var attachmentValue = "";
			for(var i=0;i<attachmentsList.length;i=i+3)
			{
				attachmentValue = attachmentsList[i+2];
				var valueList = attachmentValue.split(':');
				if(valueList && valueList.length >3)
					attachmentIdList.push(valueList[3]);
			}
			return attachmentIdList;
		},
		isEndOfExecution: function(resultElement)
		{
			this._toggleApplyButton(false);
			//{
				alert(Constants.getMessage("msgExeOver"));
				var args = "stop";
				this._collectDateTime(args);
				var contentHTML = this._editor.getContentHTML();
				var verdict = dojo.byId("_resultSelected").value;
				var attachmentIdList = this._getAttachmentIds();
				var params ={
					workItemID: this._resultId,
					ewiItemId: this.ewi.itemId,
					startTime: parseInt(this._startTime),
					endTime: parseInt(this._endTime),
					machine: Constants.getMessage("labelLocalComputer"),
					state: verdict,					
					newExecutionResult: false,
					addAttachmentItemIds:attachmentIdList,
					content:contentHTML
				};
				//add points information to the execution result post params
				var points = this.parentWidget ? this.parentWidget.getPoints() : null;
				if (points != null) {
	                for (var element in points) {
	                  params[element] = points[element];
	                }
				}
				var responseHandler = new ServiceResponseHandler(this, "_getCurrentEWI", "_error");
		    	ResultClient.postExecutionResult(responseHandler, params);
			//}
		},
				
		_getCurrentEWI: function(result)
		{
			var param = {
				id: this.ewi.id
				};
			var responseHandler = new ServiceResponseHandler(this, "showLog", "_error");
			ExecutionWorkItemClient.getExecutionWorkItemDTOs(responseHandler, param);
		},
		
		showLog: function(ewi)
		{
			var result = ewi[0].currentResult;//results[ewi[0].results.length-1];
			
			var resultId = result.itemId;
			var args = {
				ewiId: this.ewi.id,
				resultItemId: resultId
			};
			//change this to util call 
			parent.location = Utility.getResultURI(args)
		},
		
		onCancel: function()
		{
			alert(Constants.getMessage("masCancelNewScript"));
			history.back();		
		},
		//Icon clicks are handled below
		
		_defectIconClicked: function(e)
		{
			if(this.propertiesViewer)
			{
				this.propertiesViewer.selectChild(e.currentTarget.title);
			}
		},
		
		_handleSaveAndExitClick: function(e)
		{
			e.preventDefault();
			alert(Constants.getMessage("labelDummyIcon"));	
		},
		
		_handleDefectClick: function(e)
		{
			e.preventDefault();
			alert(Constants.getMessage("msgFileDefect"));
		},
		
		_handlePopOutExecutionWindowClick: function(e)
		{
			this.minimize();
		},
		
		minimize: function()
		{
			alert("Dummy Icon");
//			window.innerWidth = 100;
//			window.innerHeight = 100;
//			window.screenX = screen.width;
//			window.screenY = screen.height;
//			var applyButton = document.getElementById("applyButton");
//			applyButton.disabled = true;
//			alwaysLowered = true;
		},

		maximize: function()
		{
			/*window.innerWidth = screen.width;
			window.innerHeight = screen.height;
			window.screenX = 0;
			window.screenY = 0;
			alwaysLowered = false;
			*/
		},
	
		_convertDateToLong: function (/*accepts Date*/date) {
			var output = date.getTime() + this._getTimeZoneOffset();
			return output;
		},
		
		_convertLongToDate: function(/*accepts long*/longDate){
			var date = new Date();
			//subtract time zone offset; January is month #0; year base is perhaps 1900
			date.setTime(longDate.longvalue.value - this._getTimeZoneOffset());
			var output = date.getDate() + "." + (date.getMonth()+1) + "." + (date.getYear()+ this._getYearOffset()) + " " + 
		 	((date.getHours() < 10) ? "0" + date.getHours() : date.getHours()) + ":" +
		 	((date.getMinutes() < 10) ? "0" + date.getMinutes() : date.getMinutes()) + ":" +
		 	((date.getSeconds() < 10) ? "0" + date.getSeconds() : date.getSeconds());
			return date;	
		},
		
		_getYearOffset: function ()
		{
			var dateNow = new Date();
			if (dateNow.getYear() < 1900)
				return 1900;
			else
				return 0;
		},

		// returns the local-specific time zone offset in milliseconds, ready to be
		// added to the long values
		_getTimeZoneOffset: function()
		{
			var dateNow = new Date();
			var tzo = dateNow.getTimezoneOffset();	//minutes!
			return (tzo * 60 * 1000);
		},
			
		_error: function(errorObj) {
			alert("Error: (message: '" + errorObj.message + "') from Manual Execution#_error");
		}
		
});
})();	
