/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005-2006. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
console.debug("Loading: com.ibm.rqm.adapter.testrt.web.ui.internal.view.execution.TestRTExecutionLog");
dojo.provide("com.ibm.rqm.adapter.testrt.web.ui.internal.view.execution.TestRTExecutionLog");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojox.data.dom");

// Utlities
//dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.rqm.execution.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.adapter.testrt.web.ui.internal.TestRTUtil");

//Clients
dojo.require("com.ibm.team.process.web.client.projectarea");
(function() { // module container

var ImageCache				= com.ibm.rqm.execution.web.ui.internal.view.common.ImageCache;
var Utility					= com.ibm.rqm.execution.web.ui.internal.util.Utility;
var DOWNLOAD_SERVICE_URI 		= "com.ibm.rqm.planning.service.internal.rest.IAttachmentRestService/"; //RQM Downaload Service
var TeamServerClient 			= com.ibm.team.repository.web.transport.TeamServerClient;
var getCurrentProjectArea		= com.ibm.team.process.web.client.projectarea.getCurrentProjectArea;
var TestRTUtil	= com.ibm.rqm.adapter.testrt.web.ui.internal.TestRTUtil;

dojo.declare("com.ibm.rqm.adapter.testrt.web.ui.internal.view.execution.TestRTExecutionLog",[dijit._Widget, dijit._Templated],
	{
		templatePath: dojo.moduleUrl("com.ibm.rqm.adapter.testrt.web", "ui/internal/view/templates/execution/TestRTExecutionLog.html"),
		postCreate: function() {		
		},
		
		initialize: function()
		{
			var result = this.result;
			var logMessage = null;
			
			if (result.properties)
			{
				var len =result.properties.length;
				for (var i = 0; i < len; i++)
				{
					if(result.properties[i].propertyName == "message")
					{
						logMessage = result.properties[i].propertyValue;
						break;
					}
				}
			}
						
			if(logMessage != null && logMessage.length > 0){
				var logMessageHeader = TestRTUtil.getMessage("logMessageHeader");
				this._TestRTLogMessageHeader.appendChild(document.createTextNode(logMessageHeader));
				// this._TestRTLogMessageHeader.appendChild(document.createElement("br"));
				this._TestRTLogMessageText.appendChild(document.createTextNode(logMessage));
			}else{
				this._TestRTLogMessageTable.deleteRow(0);
			}
								
			if (result.attachments) {
				this._TestRTLogReportText.appendChild(document.createTextNode(TestRTUtil.getMessage("availableReports")));
				this._addAttachments(result.attachments);
			}else{
				this._TestRTLogReportText.appendChild(document.createTextNode(TestRTUtil.getMessage("noReports")));
			}
			
			// var vpChart = new com.ibm.rqm.execution.web.ui.internal.view.execution.VPStackedBarChart( {pass: "0", fail: "0", inconclusive: "0"});
			// this._TestRTLogReport.appendChild(vpChart.domNode);					
		},
	
		_addAttachments: function(mAttachments){
			 for(var i in mAttachments){
			 	if (this._shouldShow(mAttachments[i])) {
					var listItem = document.createElement("li");
					listItem.appendChild(this._getDownloadAnchor(mAttachments[i]));
					this._TestRTLogReportList.appendChild(listItem);
				}
			 }
		},
		
		_shouldShow: function(attachment) {
			if(attachment.customField && attachment.customField.length > 0 && attachment.customField=="Show"){
				return true;
			}
			return false;
		},
			
		_getDownloadAnchor: function(attachment) {
			var saveAnchor= document.createElement("a");
			saveAnchor.className= "actionLink";
			saveAnchor.href = TeamServerClient._getServicePrefix() + DOWNLOAD_SERVICE_URI + attachment.itemId + "?attach=0";		
			saveAnchor.target="_blank";
			saveAnchor.appendChild(document.createTextNode(attachment.name));					
			return saveAnchor;
		}
	}
);

}
)();