/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.adapter.appscan.web.ui.internal.view.extension.ASEExecutionLogSection");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.rqm.planning.web.ui.internal.view.extension.AbstractArtifactEditorSection");
dojo.require("com.ibm.rqm.adapter.appscan.web.ui.internal.view.execution.ASEExecutionLog");

(function() { // module container

var   AbstractArtifactEditorSection    = com.ibm.rqm.planning.web.ui.internal.view.extension.AbstractArtifactEditorSection;

dojo.declare(
   "com.ibm.rqm.adapter.appscan.web.ui.internal.view.extension.ASEExecutionLogSection", 
   [dijit._Widget, dijit._Templated, AbstractArtifactEditorSection], 
   {
   templateString: "<div dojoAttachPoint=\"_functionalExecutionLogSection\" class=\"com-ibm-rqm-execution-web-ui-internal-view-extension-ASEExecutionLogSection\"></div>",
   
   constructor: function(args) {    
   },
   
   	postCreate: function() {
		this.inherited('postCreate', arguments);
	},

   initialize: function(){
    if(this.initialized)       
	   this.unloadContent(this._functionalExecutionLogSection);
	var widgetArgs = { 	parentController: this.parentController, 
						parentEditor: this,
						result: this.result
						};
	this._logViewer = new com.ibm.rqm.adapter.appscan.web.ui.internal.view.execution.ASEExecutionLog(widgetArgs);
	this._logViewer.initialize();
	this._functionalExecutionLogSection.appendChild(this._logViewer.domNode);
    this.initialized = true;
  },

   //@Overriden from AbstractArtifactEditorSection
   getHelpContextID: function(){
      return "rqm_ase_execution_result_details.html";
   }, 
   
   //@Overriden from AbstractArtifactEditorSection
   getActions: function(){
      return [];
   },   
      
   //@Overridden from AbstractArtifactEditorSection
   saveFinished: function(){
      //nothing right now            
   },
	
	update: function() {
	   this.initialize();
	}
});

})();