/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.execution.web.ui.internal.view.extension.ExecutionActionBarEntry");

dojo.require("com.ibm.team.repository.web.client.session.Session");

dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.asq.common.web.client.internal.PermissionsClient");

dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.Utility")
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.ActionBarEntry");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.suite.SuiteExecutionLog");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.suite.SuiteExecution");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultClient");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.execution.EWIList");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.execution.ExecutionPageBody");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.execution.ExecutionLogBody");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.execution.ResultHistory");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.common.ExecutionConsole");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.table.ExecutionLogTableView");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.table.AdapterConsoleTableView");
dojo.require("com.ibm.rqm.planning.web.client.internal.RegistryClient");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionElementResultStates");

(function() 
{
	var getAuthenticatedContributor		= com.ibm.team.repository.web.client.session.getAuthenticatedContributor;
    var Constants                       = com.ibm.rqm.planning.web.client.internal.Constants;
	var ServiceResponseHandler			= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
    var Utility                         = com.ibm.rqm.planning.web.ui.internal.util.Utility;
    var PermissionsClient          		= com.ibm.asq.common.web.client.internal.PermissionsClient;
	var RegistryClient					= com.ibm.rqm.planning.web.client.internal.RegistryClient;
	var ExecutionElementResultStates	= com.ibm.rqm.execution.web.client.internal.execution.ExecutionElementResultStates;

	dojo.declare(
		"com.ibm.rqm.execution.web.ui.internal.view.extension.ExecutionActionBarEntry",
		[com.ibm.rqm.planning.web.ui.internal.view.common.ActionBarEntry],
		{
			constructor: function()
			{
				this._executionElementResultStates = []; 			 
			},
	
			postCreate: function(args)
			{
                this.alreadyLoaded = [];
			},
			
			initialize: function(args)
			{
				//com.ibm.rqm.planning.web.ui.internal.view.actionbarentries.ExecutionActionBarEntry.superclass.initialize.call(this, args);
				this.inherited('initialize', arguments);
				
                var tcPerm = PermissionsClient.getStoredPermission(PermissionsClient.OP_TEST_CASE);
                var ewiPerm = PermissionsClient.getStoredPermission(PermissionsClient.OP_EXECUTION_EWI);
                var tsuitePerm = PermissionsClient.getStoredPermission(PermissionsClient.OP_TEST_SUITE);	
				var resultPerm = PermissionsClient.getStoredPermission(PermissionsClient.OP_EXECUTION_RESULT); 
				var seqPerm = PermissionsClient.getStoredPermission(PermissionsClient.OP_EXECUTION_SEQUENCE); 			

                //'All Test Execution Records' entry
				this._addMenuEntry(Constants.getMessage("labelAllEWI"), dojo.hitch(this, "_onClickAllExecutionWorkItems"), false, {'subAction':"viewExecutedItems"});
				this._addMenuSeparator();
				
				//'View Test Suites' entry
				this._addNonDispatchableMenuEntry(Constants.getMessage("labelAllTestSuite"), dojo.hitch(this, "_onClickAllTestSuites"), false, null);
				this._addMenuSeparator();

                //'View Execution Results' entry
				this._addMenuEntry(Constants.getMessage("labelAllExeResult"), dojo.hitch(this, "_onClickViewExecutionResults"), false, {'subAction': "viewResults"});
				this._addMenuSeparator();
                
                //'All Test Cases' entry
				this._addNonDispatchableMenuEntry(Constants.getMessage("labelAllTestCase"), dojo.hitch(this, "_onClickAllTestCases"), false, null);
				
				//Sequence				
				this._addMenuSeparator();
				this._loadClassAsync("com.ibm.rational.test.lm.sequencer.web.ui.internal.view.table.SequenceTableView", null);
				this._loadClassAsync("com.ibm.rational.test.lm.sequencer.web.ui.internal.view.sequence.SequenceEditor", null);
				if(!seqPerm || seqPerm.create)
					this._addMenuEntry(Constants.getMessage("labelNewSequence"), dojo.hitch(this, "_onClickNewSequence"), false, {'subAction': "newSequence", 'tq': ""});
				this._addMenuEntry(Constants.getMessage("labelViewSequences"), dojo.hitch(this, "_onClickAllSequence"), false, {'subAction': "viewSequences"});

				this._addMenuSeparator();
				
				//'Execution Console' entry
				this._addMenuEntry(Constants.getMessage("labelExecCon"), dojo.hitch(this, "_onClickShowExecutionConsole"), false, {'subAction':"viewExecutionConsole"});
				//'Adapter Status' entry
				this._addMenuEntry(Constants.getMessage("labelAdapterConsole"), dojo.hitch(this, "_onClickShowAdapterStatus"), false, {'subAction': "viewAdapterStatus"});
				
				this._loadClassAsync("com.ibm.rational.test.lm.sequencer.web.ui.internal.view.sequence.SequenceResultsPage", null);
				this._loadClassAsync("com.ibm.rational.test.lm.sequencer.web.ui.internal.view.sequence.SequenceLog", null);
				//register actions with the dispatcher
				if(this.actionDispatcher) {
                    this.actionDispatcher.registerDispatchAction("startExecution", dojo.hitch(this, "startExecution"));
                    this.actionDispatcher.registerDispatchAction("viewResult", dojo.hitch(this, "showResult"));
					this.actionDispatcher.registerDispatchAction("viewEWIResults", dojo.hitch(this, "showEWIResults"));
					this.actionDispatcher.registerDispatchAction("runSuite", dojo.hitch(this, "runSuite"));
					this.actionDispatcher.registerDispatchAction("showSuiteResult", dojo.hitch(this, "showSuiteResult"));
					this.actionDispatcher.registerDispatchAction("viewSequence", dojo.hitch(this, "viewSequence"));
					this.actionDispatcher.registerDispatchAction("viewSequenceResults", dojo.hitch(this, "viewSequenceResults"));
					this.actionDispatcher.registerDispatchAction("viewSequenceResult", dojo.hitch(this, "viewSequenceResult"));
                }
				var handler= new ServiceResponseHandler(this, "setElementResultStateTypes", "_error");
				RegistryClient.getAllExecutionElementResultStateTypes(handler);
			},
			
			setElementResultStateTypes: function(types){
				if(types && types.length > 0){
					var typesLength = types.length;
					for(var i=0;i<typesLength;i++){
						types[i].name = ExecutionElementResultStates.LABELS[types[i].id];
					}
					this._executionElementResultStates = types;
				}
			},
			
			getElementResultStates: function(){
				return this._executionElementResultStates;
			},
			
			_onClickNewSequence: function(){
				jazz.core.loader.load_async("com.ibm.rational.test.lm.sequencer.web.ui.internal.view.sequence.SequenceEditor", dojo.hitch(this, "_newSequence"));
			},
			
			_newSequence: function(){
				var editor = new com.ibm.rational.test.lm.sequencer.web.ui.internal.view.sequence.SequenceEditor({
                    parentController: this
                });
				editor.initialize();
				var view = this._addPage( {name: Constants.getMessage("labelNewSequence"), content: editor, closable: true, browserTitle:Constants.getMessage("labelNewSequence")});
			},
			
			_onClickAllSequence: function(){
				var queryName =  Constants.getMessage("labelViewSequences");
				try{
					var seqTable = new com.ibm.rational.test.lm.sequencer.web.ui.internal.view.table.SequenceTableView({
						queryName: queryName
					});
					seqTable.initialize();
					this._addPage( {name: queryName, content: seqTable, closable: true, browserTitle: queryName});
				}catch(e){
					console.error("failed to create sequence table in EABE");
				}
			},
						
			viewSequence: function(kwArgs){
				kwArgs.parentController = this;
				var editor = new com.ibm.rational.test.lm.sequencer.web.ui.internal.view.sequence.SequenceEditor(kwArgs);
				editor.initialize();
				var view = this._addPage( {name: Constants.getMessage("labelLoading"), content: editor, closable: true});
			},
			
			viewSequenceResults: function(args){
				var seqResultHistoryPage = new com.ibm.rational.test.lm.sequencer.web.ui.internal.view.sequence.SequenceResultsPage(args);
				args.name = Constants.getMessage("labelSequenceResultHistory");
				var browserTitle = Constants.getMessage("labelSequenceResultHistory");
				this._addPage({name: args.name, content: seqResultHistoryPage, closable: true, browserTitle: browserTitle});
			},
				
			viewSequenceResult: function(kwArgs){
				kwArgs.name = Constants.getMessage("labelSequenceResult");
				var seqLog = new com.ibm.rational.test.lm.sequencer.web.ui.internal.view.sequence.SequenceLog(kwArgs);
				var browserTitle = Constants.getMessage("labelSequenceResult");
				this._addPage({name: kwArgs.name, content: seqLog, closable: true, browserTitle: browserTitle});
			},
						
			_onClickAllTestSuites: function(){
                window.location.hash = Utility.getTestSuitesURI();
			},
			
			_onClickShowExecutionConsole: function(){
				var args = {}
				args.parentController = this;
				args.name = Constants.getMessage("labelExecCon");
				var execConsole = new com.ibm.rqm.execution.web.ui.internal.view.common.ExecutionConsole(args);
				var browserTitle = Constants.getMessage("labelExecCon");
				this._addPage({name: args.name, content: execConsole, closable: true, browserTitle: browserTitle});
			},
			
			runSuite: function(kwArgs){
				var args = {}
				args.parentController = this;
				args.name = "Test Suite Execution";
				if(kwArgs.groupId)
					args.groupId = kwArgs.groupId;
				if(kwArgs.itemId)
					args.itemId = kwArgs.itemId;	
				var suiteConsole = new com.ibm.rqm.execution.web.ui.internal.view.suite.SuiteExecution(args);
				var page = this._addPage({name: args.name, content: suiteConsole, closable: true});
				suiteConsole.page = page;
				suiteConsole._updateBrowserTitle(); 
			},
			
			showSuiteResult: function(kwArgs){
				var args = {}
				args.parentController = this;
				args.name = Constants.getMessage("labelSuiteResult");
				if(kwArgs.id)
					args.suiteId = kwArgs.id;
				if(kwArgs.itemId)
					args.itemId = kwArgs.itemId;	
				var suiteConsole = new com.ibm.rqm.execution.web.ui.internal.view.suite.SuiteExecutionLog(args);
				var page = this._addPage({name: args.name, content: suiteConsole, closable: true});
				suiteConsole.page = page;
				suiteConsole._updateBrowserTitle();
			},
			
			_onClickMyExecutionWorkItems: function()
			{
				var args = {}
				args.name = Constants.getMessage("labelMyEWI");
				args.owner = getAuthenticatedContributor().userId;
				args.browserTitle = Constants.getMessage("labelEWI") + Constants.getMessage("labelColen") +" " + Constants.getMessage("labelMyView");
				this._showEwiList(args);
			},
			
			_onClickAllExecutionWorkItems: function()
			{
				var args = {}
				args.name = Constants.getMessage("labelAllEWI");
				args.browserTitle = Constants.getMessage("labelEWI") + Constants.getMessage("labelColen") +" " + Constants.getMessage("labelAllView");
                args.showQueryFilters = true;
				this._showEwiList(args);
			},
			
			_showEwiList: function(args)
			{
				args.parentController = this;
				var list = new com.ibm.rqm.execution.web.ui.internal.view.execution.EWIList(args);
				this._addPage({name: args.name, content: list, closable: true, browserTitle: args.browserTitle});
			},
			
			_onClickViewExecutionResults: function()
			{
				var args= { 
				   name: Constants.getMessage("labelAllExeResult"),
				   browserTitle: Constants.getMessage("labelExeResult") + Constants.getMessage("labelColen") +" " + Constants.getMessage("labelAllView")
                };
                
                //create and display the results table viewer (empty)
                var _logTableViewer = new com.ibm.rqm.execution.web.ui.internal.view.table.ExecutionLogTableView({
                    results: [],
                    showQueryFilters: true,
                    queryName: args.name
                    //refreshCallback: dojo.hitch(this, function(){}) //"_refreshResultTable", args,suiteArgs) 
                });              
                this._addPage({name: args.name, content: _logTableViewer, closable: true, browserTitle: args.browserTitle});    								
			},
			
			startExecution: function(kwArgs)
			{
				var ewi = kwArgs.ewi;
				var runScript = kwArgs.runScript;
				var _resultId = null;
				var requestId = null;
				var ergId = null;
				if(kwArgs._resultId)
					_resultId =kwArgs._resultId; 
				if(kwArgs.requestId)
					requestId =kwArgs.requestId;
				if(kwArgs.ergId)
					ergId =kwArgs.ergId;
					
				var _manualExecPage =new com.ibm.rqm.execution.web.ui.internal.view.execution.ExecutionPageBody({ parentController: this, ewi: ewi, runScript: runScript, _resultId: _resultId, requestId: requestId, ergId: ergId});
				var page = this._addPage({name: Constants.getMessage("labelExecution"), content: _manualExecPage, closable: true});
				_manualExecPage.page = page;
				_manualExecPage._updateBrowserTitle();
			},
			
			showResult: function(kwArgs)
			{
				var args ={
					parentController: this,
					ewiId: kwArgs.ewiId,
					resultItemId: kwArgs.resultItemId
				}
				if(kwArgs.editable)
					args.editable = kwArgs.editable;
				var _executionLog = new com.ibm.rqm.execution.web.ui.internal.view.execution.ExecutionLogBody(args);
				this._addPage({name: Constants.getMessage("labelExeResult"), 
					content: _executionLog, 
					closable: true,
					browserTitle: Constants.getMessage("labelExeResult")	
				});
			},
			
			showEWIResults: function(args)
			{
				var _resultHistory = new com.ibm.rqm.execution.web.ui.internal.view.execution.ResultHistory({ parentController: this, ewiItemId: args.ewiItemId });
				this._addPage({name: Constants.getMessage("labelResultHist"), 
					content: _resultHistory, 
					closable: true,
					browserTitle: Constants.getMessage("labelResultHist")
				});
			},
			
			_onClickMyTestCases: function()
			{
                window.location.hash = Utility.getMyTestCasesURI();
			},
            
            _onClickAllTestCases: function()
            {
                window.location.hash = Utility.getTestCasesURI();
            },
			
			_onClickShowAdapterStatus: function(){
				var args = {}
				args.parentController = this;
				args.queryName = Constants.getMessage("labelAdapterConsole");
				args.hideReservationNode = true;
				var adapterConsole = new com.ibm.rqm.execution.web.ui.internal.view.table.AdapterConsoleTableView(args);
				adapterConsole.setInProgress(Constants.getMessage("msgQueryTableList", Constants.getMessage("labelAdapters")));
				
				var browserTitle = Constants.getMessage("labelAdapterConsole");
				this._addPage({name: args.queryName, content: adapterConsole, closable: true, browserTitle: browserTitle});
			},
			
			_error: function(error) 
			{
				console.debug(this.declaredClass + ": Error invoking service; message: " + error.message);
			}
		}
	);
}
)();
