/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.rqm.adapter.rpt.web.ui.internal.view.extension.PerformanceExecutionLogSection");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.rqm.planning.web.ui.internal.view.extension.AbstractArtifactEditorSection");
dojo.require("com.ibm.rqm.adapter.rpt.web.ui.internal.view.execution.PerformanceExecutionLog");

(function() { // module container

var   AbstractArtifactEditorSection    = com.ibm.rqm.planning.web.ui.internal.view.extension.AbstractArtifactEditorSection;
var PerformanceExecutionLog = com.ibm.rqm.adapter.rpt.web.ui.internal.view.execution.PerformanceExecutionLog;
dojo.declare(
   "com.ibm.rqm.adapter.rpt.web.ui.internal.view.extension.PerformanceExecutionLogSection", 
   [dijit._Widget, dijit._Templated, AbstractArtifactEditorSection], 
   {
   templateString: "<div dojoAttachPoint=\"_performanceExecutionLogSection\" class=\"com-ibm-rqm-execution-web-ui-internal-view-extension-PerformanceExecutionLogSection\"></div>",
   
   constructor: function(args) {    
   },
   
   	postCreate: function() {
		this.inherited('postCreate', arguments);
	},

   initialize: function(){       
	dojox.data.dom.removeChildren(this._performanceExecutionLogSection);
	var widgetArgs = { 	parentController: this.parentController, 
						parentEditor: this,
						result: this.result
						};
	var _logViewer = new PerformanceExecutionLog(widgetArgs);
	_logViewer.initialize();
	this._performanceExecutionLogSection.appendChild(_logViewer.domNode);
	this._logViewer = _logViewer;
			
  },

   //@Overriden from AbstractArtifactEditorSection
   getHelpContextID: function(){
      return "rqm_rpt_rst_execution_results_overview.html";
   }, 
   
   //@Overriden from AbstractArtifactEditorSection
   getActions: function(){
      return [];
   },   
      
   //@Overridden from AbstractArtifactEditorSection
   saveFinished: function(){
      //nothing right now            
   },
	
	update: function() {
	   this.initialize();
	},
	
	_error: function(errorObj)
	{
		console.error("Error: (message: '" + errorObj.message + "') from PerformanceExecutionLogSection#_error");
	}
});

})();