/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008,2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.requirement.web.ui.internal.view.extension.RequirementsActionBarEntry");

dojo.require("com.ibm.team.repository.web.client.session.Session");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");

dojo.require("com.ibm.asq.common.web.client.internal.PermissionsClient");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.asq.common.web.ui.internal.util.GlobalEvents");

dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.ActionBarEntry");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.table.TestCaseTableView");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.table.TestPlanTableView");

dojo.require("com.ibm.rqm.requirement.web.client.internal.requirement.RequirementWorkItemClient");
dojo.require("com.ibm.rqm.requirement.web.ui.internal.view.table.RequirementTableView");
dojo.require("com.ibm.rqm.requirement.web.ui.internal.view.requirement.RequirementsUploader");
dojo.require("com.ibm.rqm.requirement.web.ui.internal.view.requirement.NewTestCasesForReqs");

(function() 
{
    var Constants                   = com.ibm.rqm.planning.web.client.internal.Constants;
	var PermissionsClient           = com.ibm.asq.common.web.client.internal.PermissionsClient;
	var getAuthenticatedContributor	= com.ibm.team.repository.web.client.session.getAuthenticatedContributor;
	var TestCaseTableView           = com.ibm.rqm.planning.web.ui.internal.view.table.TestCaseTableView;
	var ServiceResponseHandler		= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
	var GlobalEvents   				= com.ibm.asq.common.web.ui.internal.util.GlobalEvents;
	var TestPlanTableView           = com.ibm.rqm.planning.web.ui.internal.view.table.TestPlanTableView;
    var RequirementWorkItemClient   = com.ibm.rqm.requirement.web.client.internal.requirement.RequirementWorkItemClient;
	
	dojo.declare(
		"com.ibm.rqm.requirement.web.ui.internal.view.extension.RequirementsActionBarEntry",
		[com.ibm.rqm.planning.web.ui.internal.view.common.ActionBarEntry],
		{
			constructor: function()
			{
			},
	
			postCreate: function(args)
			{
			},
			
			initialize: function(args)
			{
				//com.ibm.rqm.planning.web.ui.internal.view.actionbarentries.RequirementsActionBarEntry.superclass.initialize.call(this, args);
				this.inherited('initialize', arguments);
				this._addNonDispatchableMenuEntry(Constants.getMessage("labelCreateRequirement"), dojo.hitch(this, "_onClickCreateRequirement"), false, null);
				this._addMenuSeparator();
				var reqPermission = PermissionsClient.getStoredPermission(PermissionsClient.OP_REQ_WORKITEM);
				if (!reqPermission || reqPermission[PermissionsClient.ACTION_IMPORT]) {
                    this._addMenuEntry(Constants.getMessage("labelLaunchReqmtTool"), dojo.hitch(this, "_onClickLaunchRequirementTool"), false, {
                        'subAction': "importRequirements"
                    });
					this._addMenuSeparator();
				}
				this._addMenuEntry(Constants.getMessage("labelAllReqmt"), dojo.hitch(this, "_onClickAllRequirements"), false, {'subAction':"allRequirements"});
				if(this.actionDispatcher) {
                    this.actionDispatcher.registerDispatchAction("viewAssociatedTestCases", dojo.hitch(this, "viewAssociatedTestCases"));
					this.actionDispatcher.registerDispatchAction("viewAssociatedTestPlans", dojo.hitch(this, "viewAssociatedTestPlans"));
                }
				dojo.subscribe(GlobalEvents.TestCasesCreated, this, "openInNewTab");
			},
			
			_onClickCreateRequirement: function()
			{
				var timestamp = (new Date()).getTime();
				window.location.hash = "action=com.ibm.team.workitem.newWorkItem&type=requirement&ts="+timestamp;
			},
			
			_onClickAllRequirements: function()
            {
                this._loadRequirements(Constants.getMessage("labelAllReqmt"));
            },            

            _loadRequirements: function(name, queryArgs)
            {
                queryArgs = queryArgs ? queryArgs : {};
				var actions = [];
        		/*
				actions.push({
            		label: Constants.getMessage("labelRefresh"),
            		actionHandler: dojo.hitch(this, "_refreshRequirementList"),
            		iconClass: "refresh-icon-image",
            		disabledOnReadOnly: true
        		});
        		*/
                //add delete action
                var reqPermission = PermissionsClient.getStoredPermission(PermissionsClient.OP_REQ_WORKITEM);
                if (!reqPermission || reqPermission[PermissionsClient.ACTION_ARCHIVE]) {
                    actions.push({
                        label: Constants.getMessage("labelArchive"),
                        actionHandler: dojo.hitch(this, "_deleteRequirements"),
                        iconClass: "archive-icon-image",
                        disabledOnReadOnly: true
                    });
                }				
				actions.push({
	                label: Constants.getMessage("labelAssociatedTestPlans"),
	                actionHandler: dojo.hitch(this, "_handleFindAssociatedTestPlan"),
	                iconClass: "tplans-w-requirmt-icon-image",
	                disabledOnReadOnly: true
            	});
				actions.push({
	                label: Constants.getMessage("labelAssociatedTestCases"),
	                actionHandler: dojo.hitch(this, "_handleFindAssociatedTestCase"),
	                iconClass: "tcases-w-requirmt-icon-image",
	                disabledOnReadOnly: true
            	});
				
				//add "create test cases" button
				var tcPerm = PermissionsClient.getStoredPermission(PermissionsClient.OP_TEST_CASE);
				if (!tcPerm || tcPerm.create) {
					actions.push({
						label: Constants.getMessage("labelCreateTestCases"),
						actionHandler: dojo.hitch(this, "_handleCreateTestCases"),
						iconClass: "add-new-testcase-image",
						disabledOnReadOnly: true
					});
				}
				
                var tableViewArgs = {
					queryName: name ? name : Constants.getMessage("labelAllReqmt"),
                    requirements: [],
//                    showInitLoadProgress: true,
					actions: actions,
					showQueryFilters: true,
					refreshCallback: dojo.hitch(this, "_loadRequirements")
                }
	            var list = new com.ibm.rqm.requirement.web.ui.internal.view.table.ExtRequirementTableView(tableViewArgs);
//				list.setInProgress(Constants.getMessage("msgQueryTableList", name));
				var browserTitle = Constants.getMessage("labelRequirements") + Constants.getMessage("labelColen") + " " + Constants.getMessage("labelAllView");
				this._addPage( {name: name, content: list.domNode, closable: true, browserTitle:browserTitle});
				
				/*
                var self = this;
                var handler = {
                    success: function(requirements) {
						list.refresh(requirements ? requirements : []);
						list.stopInProgress();
                    },
                    error: function(e) {
                        self._error(e);
                    }
                }
                
                var responseHandler = new ServiceResponseHandler(handler, "success", "error");          
                RequirementWorkItemClient.getRequirementWorkItemDTOs(responseHandler, queryArgs);        
                */     
            }, 
			
			
			_refreshRequirementList: function(tableView){
            	var self = this;
            	var handler = {
                	success: function(requirements){
                    	if (tableView) {
                        	tableView.refresh(requirements || []);
                    	}
                	},
                	error: function(e){
                    	self._error(e);
                	}
           		}
            
           		var responseHandler = new ServiceResponseHandler(handler, "success", "error");
            	RequirementWorkItemClient.getRequirementWorkItemDTOs(responseHandler, {});
        	},
			
			
            _deleteRequirements: function(tableView) {
                var selectedReqs = tableView.getSelectedRows();
                if(!selectedReqs || selectedReqs.length==0) {
                    return;
                }
                var self = this;
                var dialogArgs = {
                    message: Constants.getMessage("msgConfirmDeleteRequirements"),
                    okCallback: function(args){
                        var delRequirements = [];
                        for(var i=0;i<selectedReqs.length;i++){
                            delRequirements.push({
                                workItemId: selectedReqs[i].id,
                                externalId: selectedReqs[i].externalId
                            });
                        }
                        var queryArgs={
                            delRequirements: delRequirements
                        };
                        var handler = {
                            success: function(msg) {
                                self._refreshRequirementList(tableView);
                                if(msg && msg!=""){
                                    msg = msg.replace(/\n/gi, "<br>");
                                    var alertDialog = new com.ibm.asq.common.web.ui.internal.widgets.AlertDialog({'message': msg});
                                    alertDialog.setSecondaryTitle(Constants.getMessage("labelAlert"));
                                    alertDialog.open();
                                }
                            },
                            error: function(e) {
                               self._error(e);
                            }
                        }
                                        
                        var responseHandler = new ServiceResponseHandler(handler, "success", "error");          
                        com.ibm.rqm.requirement.web.client.internal.requirement.RequirementWorkItemClient.postArchiveRequirements(responseHandler, queryArgs);
                    },
                    cancelCallback: function(args){
                        return;
                    }
                };
                
                var floatingPane = new com.ibm.asq.common.web.ui.internal.widgets.ConfirmationDialog(dialogArgs);
                floatingPane.setSecondaryTitle(Constants.getMessage("labelConfirmation"));
                floatingPane.open();                
            },			
			
			_handleFindAssociatedTestPlan: function(tableView) {
				var selectedReqs = tableView.getSelectedRows();
				if(!selectedReqs || selectedReqs.length != 1) {
					return;
				}
				var selectedReq = selectedReqs[0];
				var args = {};
				args.subAction = "viewAssociatedTestPlans";
				args.itemId = selectedReq.itemId;
				args.id = selectedReq.id;
				this._routeAction(args);
            }, 
			
			viewAssociatedTestPlans: function(args) {
				var queryArgs = {reqWorkItemUUID : args.itemId};
				var name = Constants.getMessage("labelAssociatedTestPlansTitle") + args.id;
				var tableViewArgs = {
                    plans: [], 
                    queryName: name
                }
                
	            var list = new TestPlanTableView(tableViewArgs);
				list.setInProgress(Constants.getMessage("msgQueryTableList", name));
                var pageName = name; 
				this._addPage( {name: pageName, content: list, closable: true});
				
                var self = this;
                var handler = {
                    success: function(plans) {
                        list.refresh(plans ? plans : []);
						list.stopInProgress();
                    },
                    error: function(e) {
                        self._error(e);
                    }
                }
                
                var responseHandler = new ServiceResponseHandler(handler, "success", "error");          
                RequirementWorkItemClient.getTestPlansByRequirement(responseHandler, queryArgs);             
			},
            
			_handleFindAssociatedTestCase: function(tableView) {
				var selectedReqs = tableView.getSelectedRows();
				if(!selectedReqs || selectedReqs.length != 1) {
					return;
				}
				var selectedReq = selectedReqs[0];
				var args = {};
				args.subAction = "viewAssociatedTestCases";
				args.itemId = selectedReq.itemId;
				args.id = selectedReq.id;
				this._routeAction(args);
            }, 
			
			viewAssociatedTestCases: function(args) {
				var queryArgs = {reqWorkItemUUID : args.itemId};
				if (args.testPlanItemId) {
					queryArgs.testPlanItemId = args.testPlanItemId;
				}
				var name = Constants.getMessage("labelAssociatedTestCasesTitle") + args.id;
				var tableViewArgs = {
                    testCases: [], 
                    queryName: name
                }
                
	            var list = new TestCaseTableView(tableViewArgs);
				list.setInProgress(Constants.getMessage("msgQueryTableList", name));
                var pageName = name; 
				this._addPage( {name: pageName, content: list, closable: true});
				
                var self = this;
                var handler = {
                    success: function(cases) {
						list.refresh(cases ? cases : []);
						list.stopInProgress();
                    },
                    error: function(e) {
                        self._error(e);
                    }
                }
                
                var responseHandler = new ServiceResponseHandler(handler, "success", "error");          
                RequirementWorkItemClient.getTestCasesByRequirement(responseHandler, queryArgs);             
			},
            
			_showTestCaseList: function(cases, name)
			{
                
			},
			
			_onClickLaunchRequirementTool: function()
			{
                this._showRequirementsUpload();
			},
			
			_showRequirementsUpload: function()
			{
                var importer = new com.ibm.rqm.requirement.web.ui.internal.view.requirement.RequirementsUploader({
					title: Constants.getMessage("labelUploadRequirements"),
					artifactType: "requirement",
                    contextHelpId: "rqm_import_requirements.html",
                    cshelpLabel: Constants.getMessage("labelImportReqHelp")
				});
				var browserTitle = Constants.getMessage("labelRequirements") + Constants.getMessage("labelColen") + " " + Constants.getMessage("labelImport");
				this._addPage( {name: Constants.getMessage("labelUploadRequirements"), content: importer, closable: true, browserTitle:browserTitle});
			},
			
			_handleCreateTestCases: function(tableView) {
				var selectedReqs = tableView.getSelectedRows();
				if(!selectedReqs) {
					return;
				}
				var newTCDislog = new com.ibm.rqm.requirement.web.ui.internal.view.requirement.NewTestCasesForReqs({
					requirments: selectedReqs,
					okCallBack: dojo.hitch(this, "openInNewTab")
				});
			},
			
			openInNewTab: function(args){
				if (args && args.length > 1) {
					var name = Constants.getMessage("labelNewCasesForReq");
					var tableViewArgs = {
						testCases: args,
						queryName: name,
						showQueryFilters: false,
						enableRowEditable: true
					}
					
					var list = new TestCaseTableView(tableViewArgs);
					this._addPage({name: name, content: list, closable: true});
				}
				else if(args && args.length == 1) {
					window.location.hash = "action=com.ibm.rqm.planning.home.actionDispatcher&subAction=viewTestCase&id=" + args[0].id;
				}
			}
		}
	);
}
)();
