/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.rqm.adapter.robot.web.ui.internal.view.extension.RobotExecutionLogSection");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.rqm.planning.web.ui.internal.view.extension.AbstractArtifactEditorSection");
dojo.require("com.ibm.rqm.adapter.robot.web.ui.internal.view.execution.RobotExecutionLog");

(function() { // module container

var   AbstractArtifactEditorSection    = com.ibm.rqm.planning.web.ui.internal.view.extension.AbstractArtifactEditorSection;
var RobotExecutionLog = com.ibm.rqm.adapter.robot.web.ui.internal.view.execution.RobotExecutionLog;
dojo.declare(
   "com.ibm.rqm.adapter.robot.web.ui.internal.view.extension.RobotExecutionLogSection", 
   [dijit._Widget, dijit._Templated, AbstractArtifactEditorSection], 
   {
   templateString: "<div dojoAttachPoint=\"_robotExecutionLogSection\" class=\"com-ibm-rqm-execution-web-ui-internal-view-extension-RobotExecutionLogSection\"></div>",
   
   constructor: function(args) {    
   },
   
   	postCreate: function() {
		this.inherited('postCreate', arguments);
	},

   initialize: function(){       
	dojox.data.dom.removeChildren(this._robotExecutionLogSection);
	var widgetArgs = { 	parentController: this.parentController, 
						parentEditor: this,
						result: this.result
						};
	var _logViewer = new RobotExecutionLog(widgetArgs);
	_logViewer.initialize();
	this._robotExecutionLogSection.appendChild(_logViewer.domNode);
	console.debug("Robot Execution Log->Initialize");
	this._logViewer = _logViewer; 
  },

   //@Overriden from AbstractArtifactEditorSection
   getHelpContextID: function(){
      return "rqm_robot_execution_results_overview.html";
   }, 
   
   //@Overriden from AbstractArtifactEditorSection
   getActions: function(){
      return [];
   },   
      
   //@Overridden from AbstractArtifactEditorSection
   saveFinished: function(){
   	
      //nothing right now            
   },
	
	update: function() {
	   this.initialize();
	}
});

})();