/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading com.ibm.rqm.process.web.ui.internal.view.extension.SizingSection");
dojo.provide("com.ibm.rqm.process.web.ui.internal.view.extension.SizingSection");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.form.DateTextBox");

dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.EditorUtil");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.extension.AbstractArtifactEditorSection");

dojo.require("com.ibm.rqm.process.web.ui.internal.view.sizing.SizingPopup");
(function(){ 

    var AbstractArtifactEditorSection = com.ibm.rqm.planning.web.ui.internal.view.extension.AbstractArtifactEditorSection;
	var EditorUtil = com.ibm.rqm.planning.web.ui.internal.util.EditorUtil;
	var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
	
    dojo.declare("com.ibm.rqm.process.web.ui.internal.view.extension.SizingSection", 
         [dijit._Widget, dijit._Templated, AbstractArtifactEditorSection], {
        templateString: "<div dojoAttachPoint=\"_sizingSection\"></div>",
		
        // object initializer
        constructor: function(args) {},
   
   		postCreate: function() {
            this.inherited('postCreate', arguments);
            this.addWorkItemSupport();			
		},
        
        initialize: function(isEditable){
			//this.artifact  this.parentEditor
            var args = {
               artifact:this.getArtifact(),
				isEditable: isEditable,
				parentSection : this
            }
            var parentEditor = this.getParentEditor();
            if (parentEditor.declaredClass == "com.ibm.rqm.planning.web.ui.internal.view.planning.TestPlanEditor") {
                args.type = "0";
            }
            else {
                args.type = "1";
            }
			this._widget = new com.ibm.rqm.process.web.ui.internal.view.sizing.SizingPopup(args);
            dojox.data.dom.removeChildren(this._sizingSection);
            this._sizingSection.appendChild(this._widget.domNode);
        },
		
		//@Overriden from AbstractArtifactEditorSection
        //Summary: provide section level validation; 
        validate: function(){
            if (this._widget && this._widget.getAttributes()) {
                var params = this._widget.getAttributes();
				var effort = params.effort;
				var estimatedEffort = params.estimatedEffort;
				if ((effort && (isNaN(effort) || dojo.number.parse(effort) < 0)) || 
					estimatedEffort && (isNaN(estimatedEffort) || dojo.number.parse(estimatedEffort) < 0)) {
					var msg = Constants.getMessage("msgSizingInvalidNum", this.getTitle());
					this.getParentEditor().setHeaderStatus(Constants.VALIDATION_ERROR, Constants.HEADER_STATUS_ERROR, msg);
					return false;
				}
			}	
            return true;
        },
		
		saveFinished: function(savedItem){
            this.inherited('saveFinished', arguments);
            var artifact = this.getArtifact();
			if (!this._widget) {
				return;
			}
            this._widget.artifact = artifact;
			this.addWorkItemSupport();
			var ownerId = (this.getWorkItem() != null)? this.getWorkItem().ownerItemId : EditorUtil.getCurrentContributor().itemId;
			this._widget._handleSaveClick(ownerId);
        }
 	});
    
})();