/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005-2006. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.rqm.adapter.testrt.web.ui.internal.view.extension.TestRTExecutionLogSection");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.rqm.planning.web.ui.internal.view.extension.AbstractArtifactEditorSection");
dojo.require("com.ibm.rqm.adapter.testrt.web.ui.internal.view.execution.TestRTExecutionLog");

(function() { // module container

var   AbstractArtifactEditorSection    = com.ibm.rqm.planning.web.ui.internal.view.extension.AbstractArtifactEditorSection;
var TestRTExecutionLog = com.ibm.rqm.adapter.testrt.web.ui.internal.view.execution.TestRTExecutionLog;
dojo.declare(
   "com.ibm.rqm.adapter.testrt.web.ui.internal.view.extension.TestRTExecutionLogSection", 
   [dijit._Widget, dijit._Templated, AbstractArtifactEditorSection], 
   {
   templateString: "<div dojoAttachPoint=\"_testrtExecutionLogSection\" class=\"com-ibm-rqm-execution-web-ui-internal-view-extension-TestRTExecutionLogSection\"></div>",
   
   constructor: function(args) {    
   },
   
   	postCreate: function() {
		this.inherited('postCreate', arguments);
	},

   initialize: function(){       
	dojox.data.dom.removeChildren(this._testrtExecutionLogSection);
	var widgetArgs = { 	parentController: this.parentController, 
						parentEditor: this,
						result: this.result
						};
	var _logViewer = new TestRTExecutionLog(widgetArgs);
	_logViewer.initialize();
	this._testrtExecutionLogSection.appendChild(_logViewer.domNode);
	this._logViewer = _logViewer;
			
  },

   //@Overriden from AbstractArtifactEditorSection
   getHelpContextID: function(){
      return "rqm_testrt_execution_results_overview.html";
   }, 
   
   //@Overriden from AbstractArtifactEditorSection
   getActions: function(){
      return [];
   },   
      
   //@Overridden from AbstractArtifactEditorSection
   saveFinished: function(){
      //nothing right now            
   },
	
	update: function() {
	   this.initialize();
	}
});

})();