/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.asq.common.web.ui.internal.view.layout.SecondaryActionsDropdownButton");

dojo.require("dijit.form.Button");
dojo.require("dijit.Menu");

dojo.declare("com.ibm.asq.common.web.ui.internal.view.layout.SecondaryActionsDropdownButton",
dijit.form.DropDownButton,
{

    templateString:'<div class="ally-border" dojoAttachPoint="domNode" dojoAttachEvent="onclick:_onArrowClick,onkeypress:_onKey,onmouseover:_onMouse,onmouseout:_onMouse,onmousedown:_onMouse">' +
                   '  <table class="com-ibm-asq-common-web-ui-secondary-actions-dropdown-button" border="0" cellpadd="0" cellspacing="0">' +
                   '    <tr>' +
                   '      <td valign="top"><div class="left-decor"></div></td>' +
                   '      <td valign="middle" align="left" width="100%" class="main-content">' +
                   '        <table class="label-text-container" border="0" cellpadd="0" cellspacing="0">' +
                   '          <tr class="main-content">' +
                   '            <td valign="middle" nowrap>' +
                   '              <button class="button-container" dojoAttachPoint="focusNode,titleNode" tabIndex="${tabIndex}" id="${id}" name="${name}" waiRole="button" waiState="haspopup-true,labelledby-${id}_label">' +
                   '                <span nowrap class="label-text" dojoAttachPoint="containerNode,popupStateNode" id=\"${id}_label\">${label}</span>' +
                   '              </button>' +
                   '            </td>' +
                   '            <td valign="middle" align="left" width="100%"></td>' +
                   '            <td valign="top" align="right">' +
                   '              <div class="down-arrow-label">&#9660;</div>' +
                   '            </td>' +
                   '            <td valign="top" align="right">' +
                   '              <div class="down-arrow-icon">&nbsp;</div>' +
                   '            </td>' +
                   '          </tr>' +
                   '        </table>' +
                   '      </td>' +
                   '      <td valign="top"><div class="right-decor"></div></td>' +
                   '    </tr>' +
                   '  </table>' +
                   '</div>',

    postCreate: function() {
        com.ibm.asq.common.web.ui.internal.view.layout.SecondaryActionsDropdownButton.superclass.postCreate.apply(this, arguments);
        dojo.addClass(this.domNode, "com-ibm-asq-common-web-ui-secondary-actions-dropdown-button");
        this.dropDown = new dijit.Menu();
    },
    
    addAction: function(handler, label, callbackData, /* optional */ iconClass) {
        var arg = {
            label: label,
            onClick: function() {
				this.clientCallback(this.callbackData);
			}
        };
        
        if (iconClass) {
            arg[iconClass] = iconClass;
        }
		var item = new dijit.MenuItem(arg);
		
		// store the client callback and data into the item.s
		item.clientCallback = handler;
		item.callbackData = callbackData;
        this.dropDown.addChild(item);
    }
    
});
