/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading com.ibm.rqm.planning.web.ui.internal.view.planning.environment.EnvironmentChooserDialog");
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.planning.environment.EnvironmentChooserDialog");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.OptionChooser");

dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require( "com.ibm.asq.common.web.ui.internal.util.SelectUtility" );
dojo.require("com.ibm.asq.common.web.ui.internal.util.CSHelp");

(function() 
{	
var OptionChooser  = com.ibm.asq.common.web.ui.internal.widgets.OptionChooser;
var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
var SelectUtility = dojo.getObject( "com.ibm.asq.common.web.ui.internal.util.SelectUtility" );
var CSHelp = com.ibm.asq.common.web.ui.internal.util.CSHelp;

dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.planning.environment.EnvironmentChooserDialog",
			 [dijit._Widget, dijit._Templated],
	{
		templateString: '<div class="com-ibm-rqm-test-planning-environment-environmentdialog">'+
						'    <div class="" dojoattachpoint="_typeSelectNode" style="padding-bottom: 0.5em">' +
						'        <label for="_typeSelectBox">${labelTypes}</label>' +
						'        <select id="_typeSelectBox" dojoAttachPoint="_typeSelect" dojoAttachEvent="onchange:_onTypeChange"></select>' +
						'    </div>'+
						'    <div class="" dojoattachpoint="_chooserNode"></div>'+
						'</div>',
						
		labelTypes: Constants.getMessage("labelEnvironmentTypes"),
		okClicked: false,
		width: "600px",
		title: Constants.getMessage("labelAvailableEnvironmentOptions"),
		
		constructor: function(args){
		},

		postCreate: function(){
		},
		
		_initialize: function(){				
            var dialogArgs = {
				primaryTitle: this.title,
                showActions: false,
				_truncate: function() {}  //disable the Dialog's '_truncate'
            };                
            this.dialog = new com.ibm.asq.common.web.ui.internal.widgets.SelectionDialog(dialogArgs);
            this.dialog.setWidth(this.width);
            this.dialog.contentContainer.appendChild(this.domNode);
			var cshelp = new CSHelp({contextID: "rqm_available_options.html"});
			cshelp.setButtonLabel(Constants.getMessage("labelEnvironmentChooserCSHelp"));
			this.dialog.setSecondaryTitleNode(cshelp.domNode);
		},
		
		_createChooser: function(){
			this.chooser = new OptionChooser({
				leftTitle: Constants.getMessage("labelLeftTitle"), 
				rightTitle:Constants.getMessage("labelRightTitle")
			});
			this.chooser.enableOkCancel();
			this.chooser.addOkListener( dojo.hitch( this, this.okAction ) );
			this.chooser.addCancelListener( dojo.hitch( this, this.cancelAction ) );
			this._chooserNode.appendChild(this.chooser.domNode);
		},
		
		updateOptions: function(id){
			if(!id)
				id = 0;
			//Changing internalValues since there is no public function to do this.
			this.chooser.options = {};
			this.chooser.chosenOptionsNode.options.length = 0;
			this.chooser.choosableOptionsNode.options.length = 0;
			this.chooser.numOptions = 0;
			//Changing internal Values Over
			var part = this.allParts[id];
			for(var i=0;i<part.catalogEntries.length;i++){
				if(part.selectedValues[i])
					this.chooser.addOption( part.catalogEntries[i], {name:part.catalogEntries[i], id: part.catalogEntries[i], selected: true}, true );
				else
					this.chooser.addOption( part.catalogEntries[i], {name:part.catalogEntries[i], id: part.catalogEntries[i], selected: false}, false );	
			}
		},
		
		setAllOptions: function(args){
			this.allParts = args;
			if(!this._typeCombo){
				this._initialize();
				this._createTypeSelectBox();
				this._createChooser();
				this.updateOptions();
				this.show();
			}
		},
		
		_createTypeSelectBox: function(){
            this._selectedCatalogTypeIndex = 0; 
            for(var i=0;i<this.allParts.length;i++){
                var typeName = Constants.getLmMessage(this.allParts[i].catalogType.name);
                var option = new Option(typeName, this.allParts[i].catalogType);
                if (dojo.isIE) {
                    this._typeSelect.add(option);
                } else {
                    this._typeSelect.add(option, null);
                }
            }
			this._typeCombo = true;			
		},
		
		_onTypeChange: function(){
			var selection = this._typeSelect.selectedIndex;
			var oldSelections = this.allParts[this._selectedCatalogTypeIndex].selectedValues;
			for(var i=0;i<oldSelections.length;i++){
				this.allParts[this._selectedCatalogTypeIndex].selectedValues[i] = false;
			}
			var values = this.chooser.getOptions();
			var shown = [];
			for( var elem in values ){
				if( values[ elem ] == true ){
					shown.push( elem );
				}
			}
			var opt = this.allParts[this._selectedCatalogTypeIndex].catalogEntries;
			for(var i=0;i<opt.length;i++){
				for(var j=0;j<shown.length;j++){
					if(opt[i] == shown[j])
						this.allParts[this._selectedCatalogTypeIndex].selectedValues[i] = true;	
				}
			}	
			this._selectedCatalogTypeIndex = selection;
			this.updateOptions(selection);
		},
		
		show: function(){
			this.dialog.open();
			this.okClicked = false;
		},
		
		_updateData: function(){
			var values = {};
			if(this.okClicked == true){
				this._onTypeChange();
				if(this.parentWidget){
					var recentConfig = [];
					for(var i=0;i<this.allParts.length;i++){
						var foundEntry = false;
						var catType = this.allParts[i].catalogType;
						var catEntries = []
						if(this.allParts[i].selectedValues && this.allParts[i].selectedValues.length > 0){
							for(var j=0;j<this.allParts[i].catalogEntries.length;j++){
								if(this.allParts[i].selectedValues[j] == true){
									foundEntry = true;
									catEntries.push(this.allParts[i].catalogEntries[j]);
								}
							}
							if(foundEntry)
								recentConfig.push({catalogType: catType, catalogEntries: catEntries});							
						}
					}
					this.parentWidget.appendConfig(this.allParts);
					this.parentWidget.updateEnvContainer(recentConfig);
				}	
			}
		},
		
		okAction: function(){
			this.okClicked = true;
			this._updateData();
			this.dialog.close();
		},
		
		cancelAction: function(){
			this.okClicked = false;
			this.dialog.close();
		},
		
		_error: function(){
			alert(Constants.getMessage("labelErrorEnvir"));
		}
	}
);
}
)();
