/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading com.ibm.rqm.requirement.web.ui.internal.view.requirement.NewTestCasesForReqs");
dojo.provide("com.ibm.rqm.requirement.web.ui.internal.view.requirement.NewTestCasesForReqs");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojox.data.dom");

dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.EditorUtil");
dojo.require("com.ibm.rqm.planning.web.client.internal.mapper.TestPlanMapper");
dojo.require("com.ibm.rqm.planning.web.client.internal.planning.PlanningPageClient");
dojo.require("com.ibm.rqm.planning.web.client.internal.template.TemplateClient");
dojo.require("com.ibm.asq.common.web.ui.internal.util.SelectUtility");
dojo.require("com.ibm.asq.common.web.ui.internal.util.CSHelp");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");

dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.NewTestCasePanel");
dojo.require("com.ibm.rqm.requirement.web.client.internal.requirement.RequirementWorkItemClient");
dojo.require("com.ibm.rqm.requirement.web.ui.internal.view.table.NewTestCaseByRequirementTableView");

(function(){
    var ServiceResponseHandler = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
    var CSHelp = com.ibm.asq.common.web.ui.internal.util.CSHelp;
    var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
    var EditorUtil = com.ibm.rqm.planning.web.ui.internal.util.EditorUtil;
    var SelectUtility = dojo.getObject("com.ibm.asq.common.web.ui.internal.util.SelectUtility");
    var RequirementWorkItemClient = com.ibm.rqm.requirement.web.client.internal.requirement.RequirementWorkItemClient;
	var TestPlanMapper = com.ibm.rqm.planning.web.client.internal.mapper.TestPlanMapper;
	var PlanClient = com.ibm.rqm.planning.web.client.internal.planning.PlanningPageClient;
	var ImageCache = com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
	var AlertDialog = com.ibm.asq.common.web.ui.internal.widgets.AlertDialog;
	var TemplateClient = com.ibm.rqm.planning.web.client.internal.template.TemplateClient;
	var RequirementSectionID = "com.ibm.rqm.requirements.editor.section.caseRequirements";
    /**
     *
     */
    dojo.declare("com.ibm.rqm.requirement.web.ui.internal.view.requirement.NewTestCasesForReqs", [dijit._Widget, dijit._Templated], {
    
        templatePath: dojo.moduleUrl("com.ibm.rqm.requirement.web", "ui/internal/view/templates/requirement/NewTestCasesForReqs.html"),
        
        labelMultiCases: Constants.getMessage("labelNewCasePerReq"),
        labelCasesName: Constants.getMessage("labelSameNameWithReq"),
        labelSingleCase: Constants.getMessage("labelNewOneCase"),
        labelOpenNewTab: Constants.getMessage("labelViewCasesTab"),
        labelplan: Constants.getMessage("labelTestPlan"),
		labelStep1: Constants.getMessage("labelStep1"),
		labelStep2: Constants.getMessage("labelStep2"),
		labelStepName: Constants.getMessage("labelNewCaseFromReq"),
		labelSaveArtifact: Constants.getMessage("labelSaveArtifact"),
		labelTemplate: Constants.getMessage("labelTemplate"),
		
        constructor: function(args){
            this.requirments = [];
			this.testPlans = [];
            this.isSingleReq = true;
			this.isOpenNewTab = false;
			this.isInSection = false;
			this.artifact = null;
			this.artifactEditor = null;
			this.isSaveTestPlan = false;
        },
        
        postCreate: function(){
            if (!this.requirments) {
                throw new Error("Parameter 'requirments' is REQUIRED!");
            }
            if (this.requirments && this.requirments.length > 1) 
                this.isSingleReq = false;
            
            if (this.isSingleReq) {
				this._singleReqDiv.style.display = "block";
				this._multiReqsDiv.style.display = "none";
			}
			else {
				this.connect(this._multiCasesRadio, "onclick", "_onMultiRadioSelect");
				this.connect(this._singleCaseRadio, "onclick", "_onSingleRadioSelect");
				this._loadTemplates();
			}
			if (this.isInSection && this.artifactEditor) {
				//if the test case is created from a test plan editor, won't load test plan
				this.artifact = this.artifactEditor.getArtifact();
				this._planDiv.style.display = "none";
				this._saveArtifactNode.style.display = "";
				this._initialize();
			}
			else {
				this._loadTestPlans();
			}
        },
		
		_loadTestPlans: function() {
			var responseHandler = new TestPlanMapper(this, "_initTP", "_error");
			PlanClient.getTestPlansSummary(responseHandler, {});
		},
		
		_initTP: function(plans){
			dojox.data.dom.removeChildren(this._plan);
			var option = new Option(Constants.getMessage("labelUnassigned"), "-1");
			option.selected = true;
			SelectUtility.add(this._plan, option);
			if (plans && plans.length > 0) {
				plans = plans.sort(function(c1, c2){
					var cSort1 = c1 && c1.name ? (c1.name).toLowerCase() : "";
					var cSort2 = c2 && c2.name ? (c2.name).toLowerCase() : "";
					if (cSort1 == cSort2) {
						return 0;
					}
					else 
						return cSort1 < cSort2 ? -1 : 1;//Ascending order
				});
				this.testPlans = plans;
				for (var i = 0; i < plans.length; i++) {
					var planoption = new Option(plans[i].name, plans[i].id);
					SelectUtility.add(this._plan, planoption);
				}
			}
			
			this._initialize();
		},
        
        _initialize: function(){
            this.newTCPanel = new com.ibm.rqm.planning.web.ui.internal.view.common.NewTestCasePanel({
				testPlans: this.testPlans,
				isInSection: this.isInSection,
				artifact: this.artifact
			});
			if (this.isSingleReq) {
                this._singleReqDiv.appendChild(this.newTCPanel.domNode);
            }
            else {
				this._createTCImg.src = ImageCache.ADD_NEW_CASE;
				this._createTCImg1.src = ImageCache.ADD_NEW_CASE;
                this._singleCasePanel.appendChild(this.newTCPanel.domNode);
            }
            
            this._showAsDialog();
        },
        
        _showAsDialog: function(){
            var dialogArgs = {
                primaryTitle:  Constants.getMessage("labelNewTestCase"),
				width: this.isSingleReq ? "430px": "470px",
                okCallback: dojo.hitch(this, "_onOK"),
                cancelCallback: dojo.hitch(this, "_onCancel"),
				csHelpID: this.isSingleReq ? "rqm_cre_one_tc_from_req.html" : "rqm_cre_tc_from_req.html",
				zIndex: 9998,
                _truncate: function(){
                } 
            };
            
            if (!this._dialog) {
                this._dialog = new com.ibm.asq.common.web.ui.internal.widgets.SelectionDialog(dialogArgs);
                this._dialog.contentContainer.appendChild(this.domNode);
                this._dialog.getOkButton().disabled = false;
            }
			if(!this._dialog._nextButton) {
                var nextButtonDiv = document.createElement("span");
                this._dialog._nextButton = document.createElement("button");
                this._dialog._nextButton.innerHTML = Constants.getMessage("labelRequirementNext");
                this._dialog._nextButton.tabIndex = "-1";
                this._dialog._nextButton.onclick = dojo.hitch(this, "_onStep2");
				this._dialog._nextButton.style.display="none";
                nextButtonDiv.appendChild(this._dialog._nextButton);
                nextButtonDiv.className = "button-div";
				var cancelBt = this._dialog.getCancelButton();
				cancelBt.parentNode.parentNode.insertBefore(nextButtonDiv, cancelBt.parentNode);
			}
            this._dialog.open();
			this.newTCPanel.setAlign();
        },
		
		_loadTemplates: function(){
            //load the templates
            SelectUtility.add(this._template, new Option(Constants.getMessage("labelLoading"), ""));
            var srh = new ServiceResponseHandler(this, "_setTemplates", "_error");
            TemplateClient.getTemplates(srh, {
                editorId: Constants.EDITOR_ID_CASE
            });
        },
        
        _setTemplates: function(templates){
            this._templates = templates || [];
            dojox.data.dom.removeChildren(this._template);
            for (var i = 0; i < this._templates.length; i++) {
				if(this._templateContainReq(this._templates[i])) {
                	var option = new Option(Constants.getExtensionDisplayMessage(this._templates[i].name), this._templates[i].itemId);
                	option.selected = this._templates[i].isDefault;
                	SelectUtility.add(this._template, option);
				}
            }
        },
		
		/*
		 * Check given template contains requirement section. Return true if it contains. 
		 */  
		_templateContainReq: function(template) {
			for(var i = 0; i < (template.sections ? template.sections.length : 0); i++) {
				if(template.sections[i].id == RequirementSectionID) {
					return true;
				}
			}
			return false;
		},
        
        _getTemplate: function(itemId){
            for (var i = 0; i < (this._templates ? this._templates.length : 0); i++) {
                if (this._templates[i].itemId == itemId) {
                    return this._templates[i];
                }
            }
            return null;
        },
        
		_onMultiRadioSelect: function() {
			this._singleCaseRadio.checked = false;
			this._plan.disabled = false;
			this._template.disabled = false;
			this._casesName.disabled = false;
			this.newTCPanel.setDisabled(true);
			dojo.removeClass(this._multiContentRow, "noselectedContentRow");
			dojo.addClass(this._multiContentRow, "selectedContentRow");
			dojo.removeClass(this._singleCasePanel, "selectedContentRow");
			dojo.addClass(this._singleCasePanel, "noselectedContentRow");
			
			this.togglerDialog(true);
		},
		
		_onSingleRadioSelect: function() {
			this._multiCasesRadio.checked = false;
			this._casesName.disabled = true;
			this._plan.disabled = true;
			this._template.disabled = true;
			this.newTCPanel.setDisabled(false);
			dojo.removeClass(this._singleCasePanel, "noselectedContentRow");
			dojo.addClass(this._singleCasePanel, "selectedContentRow");
			dojo.removeClass(this._multiContentRow, "selectedContentRow");
			dojo.addClass(this._multiContentRow, "noselectedContentRow");
			
			this.togglerDialog(false);
		},
		
		togglerDialog: function(isWizard) {
			this.isWizard = isWizard;
			if(isWizard) {
				this._step1.style.display = "block";
				this._titleRow.style.display = "block";
				this._dialog.getOkButton().style.display = "none";
				this._dialog._nextButton.style.display = "";
				//this._dialog.getOkButton().innerHTML = Constants.getMessage("labelRequirementNext");
				//this._dialog.yesCallback = dojo.hitch(this, "_onStep2");
				//this._dialog.getOkButton().onclick = dojo.hitch(this, "_onStep2");
				
			} else {
				this._step1.style.display = "none";
				this._titleRow.style.display = "none";
				this._dialog._nextButton.style.display = "none";
				this._dialog.getOkButton().style.display = "";
				this._dialog.getOkButton().innerHTML = Constants.getMessage("labelOk");
				this._dialog.getOkButton().onclick = dojo.hitch(this._dialog, "_yesAction");
			}
		},
		
        validate: function(){
            if (this.newTCPanel && ((!this.isSingleReq && this._singleCaseRadio.checked)) || this.isSingleReq) {
                var attr = this.newTCPanel.getAttributes();
                if (!attr.names || dojo.trim(attr.names[0]).length == 0) {
                    alert(Constants.getMessage("msgNameRequired"));
                    return false;
                }
                //validate the weight 
                if (!attr.weights || dojo.trim(attr.weights[0]).length == 0 || isNaN(dojo.number.parse(attr.weights[0]))) {
                    alert(Constants.getMessage("msgNumericWeightRequired"));
                    return false;
                }
            }
			return true;
        },
		
		_onStep2: function() {
			this._step2Div.style.display = "block";
			this._step1Div.style.display = "none";
			this._dialog.getOkButton().style.display = "none";
			if(this._dialog._nextButton) {
				this._dialog._nextButton.style.display = "none";
			}
			if(!this._dialog._backButton) {
                var backButtonDiv = document.createElement("span");
                this._dialog._backButton = document.createElement("button");
                this._dialog._backButton.innerHTML = Constants.getMessage("labelRequirementBack");
                this._dialog._backButton.tabIndex = "0";
                this._dialog._backButton.onclick = dojo.hitch(this, "_onBack");
                backButtonDiv.appendChild(this._dialog._backButton);
                backButtonDiv.className = "button-div";
				this._dialog.actionsContainer.appendChild(backButtonDiv);
			}
			if(!this._dialog._finishButton) {
                var finishButtonDiv = document.createElement("span");
                this._dialog._finishButton = document.createElement("button");
                this._dialog._finishButton.innerHTML = Constants.getMessage("labelFinish");
                this._dialog._finishButton.tabIndex = "0";
				this._dialog._finishButton.onclick = dojo.hitch(this._dialog, "_yesAction");
                finishButtonDiv.appendChild(this._dialog._finishButton);
                finishButtonDiv.className = "button-div";
				this._dialog.actionsContainer.appendChild(finishButtonDiv);
			}
			this._dialog._backButton.style.display = "";
			this._dialog._finishButton.style.display = "";
			
			this._displayTCTable();
		},
        
		_onBack: function() {
			this._step2Div.style.display = "none";
			this._step1Div.style.display = "block";
			this._dialog._backButton.style.display = "none";
			this._dialog._finishButton.style.display = "none";
			this._dialog._nextButton.style.display = "";
			this._dialog.getOkButton().style.display = "none";
		},
		
		_displayTCTable: function() {
			if(!this.testCasesTable) {
				this.testCasesTable = new com.ibm.rqm.requirement.web.ui.internal.view.table.NewTestCaseByRequirementTableView({
					testCases: []
				})
				this._step2Table.appendChild(this.testCasesTable.domNode);
			}
			this.testCasesTable.refresh(this._getInitialTCs());
		},
		
		_getInitialTCs: function() {
			var testCases = [];
			for(var i = 0; i < (this.requirments ? this.requirments.length : 0); i++) {
				var name = this._casesName.checked ? this.requirments[i].name : Constants.getMessage("labelCaseNameFromReq", this.requirments[i].name);
				testCases.push({
					id: this.requirments[i].id,
					name: name,
					weight: Constants.TEST_CASE_DEFAULT_WEIGHT,
					owner: {name: Constants.getMessage("labelUnassigned"), itemId: "-1"}
				});
			}
			return testCases;
		},
		
        _onOK: function(){
            this._dialog.getOkButton().disabled = true;
            if (!this.validate()) {
                this._dialog.getOkButton().disabled = false;
                return false;
            }
            else {
				var ids = [];
				for(var i = 0; i < (this.requirments ? this.requirments.length : 0); i++)
					ids.push(this.requirments[i].id);
				var args = {
					ids: ids
				}	
				if(this._multiCasesRadio.checked && !this.isSingleReq) {
					//one requirement for one case
					var planId = null;
					if(this.isInSection && this.artifact) {
						planId = this.artifact.id+"";
					}
					else 
						planId = this._plan.value;
					if(planId && planId != "-1") {
						args.planId = planId;
					}
					if (this._template.value != null) {
                		var template = this._getTemplate(this._template.value);
                		args.templateItemId = template.itemId;
                		args.templateStateId = template.stateId;
            		}
					if(this.testCasesTable) {
						var attr = this.testCasesTable.getAttribute();
						dojo.mixin(args, attr);
					}
					this.isOpenNewTab = this._openNewEditor.checked ? true : false;
					this.isSaveTestPlan = this._saveArtifactEditor.checked ? true : false;
				}
				else {
					//all requirements for one case
					var attr = this.newTCPanel.getAttributes();
					this.isOpenNewTab = attr.isOpenNewTab;
					this.isSaveTestPlan = attr.isSaveTestPlan;
					dojo.mixin(args, attr);
				}
				var self = this;
				var handler = {
                    success: function(cases) {
						if(self.isInSection && self.artifactEditor && self.isSaveTestPlan) {
							//for those requirements in a test plan, save test plan editor
							if(self.artifactEditor._saveButton && !self.artifactEditor._saveButton.disabled) {
								self.artifactEditor.onSave();
							}
						}
						if(self.okCallBack && self.isOpenNewTab)
                        	self.okCallBack(cases ? cases : []);
						else {
							var msg = "";
							if(cases && cases.length == 1) 
								msg = Constants.getMessage("msgCreatedCase", cases[0].name);
							else
								msg = Constants.getMessage("msgCreatedCasesNum", cases.length);
							 var alertDialog = new AlertDialog({'message': msg});
						   	 alertDialog.setSecondaryTitle(Constants.getMessage("labelAlert"));
						     alertDialog.open();	
						}	
                    },
                    error: function(e) {
                        self._error(e);
                    }
                }
                var responseHandler = new ServiceResponseHandler(handler, "success", "error");          
				RequirementWorkItemClient.postCreateTestCasesByRequirement(responseHandler, args)
            }
        },
        
        _onCancel: function(){
        },
        
        _error: function(e){
            console.debug(this.declaredClass + ": Error: " + e.message);
        }
        
    });
})();
