/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
/*
 * File Selector widget - Creates a text field to enter sharelocation and then creates FileBrwser in a dialog
 * Author: vasrivas
 */
dojo.provide("com.ibm.rqm.execution.web.ui.internal.view.resourcebrowser.FileSelector");

dojo.require("dojox.data.dom");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");

dojo.require("com.ibm.rqm.execution.web.ui.internal.view.resourcebrowser.FileBrowser");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.client.internal.PreferenceClient");
dojo.require("com.ibm.rqm.planning.web.client.internal.planning.PlanningPageClient");
dojo.require("com.ibm.team.process.web.client.projectarea");

(function(){ 
    
	var ImageCache					= com.ibm.rqm.execution.web.ui.internal.view.common.ImageCache;
	var FileBrowser					= com.ibm.rqm.execution.web.ui.internal.view.resourcebrowser.FileBrowser;
	var Constants					= com.ibm.rqm.planning.web.client.internal.Constants;
	var PreferenceClient			= com.ibm.rqm.planning.web.client.internal.PreferenceClient;
	var PlanClient					= com.ibm.rqm.planning.web.client.internal.planning.PlanningPageClient;
    var getCurrentProjectArea		= com.ibm.team.process.web.client.projectarea.getCurrentProjectArea;
	dojo.declare("com.ibm.rqm.execution.web.ui.internal.view.resourcebrowser.FileSelector", [dijit._Widget, dijit._Templated], {
        templateString: "<div class= \"com-ibm-rqm-execution-resourcebrowser-file-selector\" dojoAttachPoint=\"_fileContainer\">" +
							"<table><tr>"+
							"<!--td><label style=\"font-family:Arial;font-size:9pt;\" dojoAttachPoint=\"_lableTP\"></label></td><td><select style=\"width:100%;font-family:Arial;font-size:9pt;\" dojoAttachPoint=\"_TP\" dojoAttachEvent=\"onchange: _updateLocations\"></select></td>"+
							"</tr><tr>"+
							"<td><label style=\"font-family:Arial;font-size:9pt;\" dojoAttachPoint=\"_lableLocation\"></label></td><td><select style=\"width:100%;font-family:Arial;font-size:9pt;\" dojoAttachPoint=\"_sharedPath\"></select></td-->"+
							"<td><button dojoAttachPoint=\"_onBrowse\" style=\"font-family:Arial;font-size:9pt;\" dojoAttachEvent=\"onclick: _onBrowseClick\"></button></td>"+
							"</tr></table><table><tr>"+
							"<td><label style=\"font-family:Arial;font-size:9pt;\" dojoAttachPoint=\"_relLocationLabel\"></label></td><td colspan=\"2\"><label style=\"display: none;font-family:Arial;font-size:9pt;\" dojoAttachPoint=\"_relLocationValue\"></label></td>"+
							"</tr></table>"+
							"<div dojoAttachPoint=\"_browseDialogNode\"></div>"+
						"</div>",
        resources: [],
		singleSelect: false,
		allPlans: [],
		shareName: "",
		dialogWidth: "70%",
		
        constructor: function(args){
		},
        
        postCreate: function(){
			this._onBrowse.innerHTML = "<div style='white-space:nowrap'>"+Constants.getMessage("labelBrowse")+"</div>";
		},
		
		initialize: function(){
		},
		
		setScriptType: function(scriptType){
			this.scriptType = scriptType;
			if(this.fileBrowser)
				this.fileBrowser.setScriptInfo(this.script, this.scriptType)
		},
		
		_onBrowseClick: function(e){
			dojox.data.dom.removeChildren(this._browseDialogNode);
			var okCallbackFunc = dojo.hitch(this, "_simulateOkClick"); 			
			this.fileBrowser = new FileBrowser({singleSelect: this.singleSelect,callback:okCallbackFunc});
			
			//create the dialog
            var dialogArgs = {
                primaryTitle: Constants.getMessage("labelBrowseSharedResource"),
                showActions: true,
				contentNode: this.fileBrowser.domNode,
				okCallback: dojo.hitch(this, "_okButtonClicked"),
				cancelCallback: dojo.hitch(this, "_cancelButtonClicked")
            }
            this.browseDialog = new com.ibm.asq.common.web.ui.internal.widgets.SelectionDialog(dialogArgs);
            this.browseDialog.setWidth(this.dialogWidth);
			this.browseDialog.getOkButton().disabled = false;
			this.fileBrowser.setScriptInfo(this.script, this.scriptType);
			this.browseDialog.open(false);
		},
		_simulateOkClick:function(){
			this.browseDialog.close();
			this._okButtonClicked();
		},
		_okButtonClicked: function(){
			this.resources = this.fileBrowser.getResources();
			this.path = this.fileBrowser.getInitialPath();
			this.selectedPlanId = this.fileBrowser.getPlan().id;
			this.milestoneItemId = this.fileBrowser.getPhase().itemId;
			this.browseDialog = null;
			if(this.resources && this.resources.length >0)
				this._relLocationValue.innerHTML = this.resources[0].resourceURN;
			else
				this._relLocationValue.innerHTML = "";	
			if(dojo.isFunction(this.onClose))
				this.onClose();
		},
		
		_cancelButtonClicked: function(){
			this.browseDialog = null;
		},
		
		getResources: function(){
			return {
				initialPath: this.path,
				fileList: this.resources,
				testPlanId: this.selectedPlanId,
				milestoneItemId: this.milestoneItemId
				};
		},
		
		_error: function(errorObj){
			console.error("Error in File Selector "+ errorObj.message + " ");
		}        
    });
})();
