//AutomationSection
/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rational.test.lm.sequencer.web.ui.internal.view.section.AutomationSection");
dojo.provide("com.ibm.rational.test.lm.sequencer.web.ui.internal.view.section.AutomationSection");
/*
 * author: vasrivas
 */
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("jazz.core.loader");
dojo.require("com.ibm.rational.test.lm.sequencer.web.ui.internal.view.common._AbstractEditorSection");
dojo.require("com.ibm.rational.test.lm.sequencer.web.ui.internal.Constants");
(function() {
	var AbsractEditorSection = com.ibm.rational.test.lm.sequencer.web.ui.internal.view.common._AbstractEditorSection;
	var Constants 						= com.ibm.rational.test.lm.sequencer.web.ui.internal.Constants;
dojo.declare("com.ibm.rational.test.lm.sequencer.web.ui.internal.view.section.AutomationSection", [dijit._Widget, dijit._Templated, AbsractEditorSection],
{
		templatePath: dojo.moduleUrl("com.ibm.rational.test.lm.sequencer.web", "ui/internal/view/templates/section/AutomationSection.html"),
		
		widgetsInTemplate: true,
		details: null,
		postCreate: function(){		
			this.initialize();
		},
		
		initialize: function(){
			if(!dojo.getObject("com.ibm.rational.test.lm.web.ui.internal.views.inventory.AutomationsView"))
				jazz.core.loader.load_async("com.ibm.rational.test.lm.web.ui.internal.views.inventory.AutomationsView", dojo.hitch(this, "_loadSuccessful"));
			else
				this._loadSuccessful();	
		},
		
		_loadSuccessful: function(){
			this.automationView = new com.ibm.rational.test.lm.web.ui.internal.views.inventory.AutomationsView({insideEditor: true});
			this.automationView.viewHeaderNode.viewHeaderBackNode.style.display = 'none';
			this.automationView.viewHeaderNode.containerNode.style.padding = "0px";			
			this.formAreaNode.appendChild( this.automationView.domNode );
		},
		
		//Over-ridden from _AES
		validate: function(){
			if(this.details)
				return true;
			var currentSelection = this.automationView.getCurrentSelectionFromTables();
			if(currentSelection.jobs.length == 0 || currentSelection.machines.length == 0){
				this.getParentEditor().setHeaderStatus(Constants.VALIDATION_ERROR, Constants.HEADER_STATUS_ERROR,
						Constants.getMessage("msgRequiredField", Constants.getMessage("labelAutomation"), Constants.getMessage("labelExecutionSequence")));
				return false;
			}
			return true;
		},
		
		//Over-ridden from _AES
		getAttributes: function(){
			var currentSelection = null;
			var details = this.details;
			if(details){
				currentSelection = details.attributes.automation;
			}else{
				currentSelection = this.automationView.getCurrentSelectionFromTables();
			}
			var jobs = currentSelection.jobs[0];
			var props = jobs["parameters"];
			var parameters = [];
			var propsLength = props && props.length ? props.length : 0;
			for(var i=0;i<propsLength; i++){
				var prop = {name: props[i].name, value: props[i].value};
				var attr = {};
				dojo.mixin(attr, prop);
				parameters.push(attr);
				
			}
			var attributes = {
				type: Constants.TYPE_AUTOMATION,
				attributes: dojo.toJson({
								automationId: jobs.jobId, 
								assetId: currentSelection.machines[0]["machine.id"], 
								providerName: jobs.providerName, 
								providerInstance: jobs.providerInstance, 
								parameters: parameters
							})
			}
			return attributes;
		},
		//Over-ridden from _AES
		saveFinished: function(){
			
		},
		//Over-ridden from _AES
		saveError: function(){
			
		},
		
		_error: function(errorObj){
			console.error("Error: (message: '" + errorObj.message + "') from AutomationSection#_error");
		}
	}
);
}
)();
		
