/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rational.test.lm.sequencer.web.ui.internal.view.section.ExecutionSequenceSection");
dojo.provide("com.ibm.rational.test.lm.sequencer.web.ui.internal.view.section.ExecutionSequenceSection");
/*
 * author: vasrivas
 */
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("com.ibm.rational.test.lm.sequencer.web.ui.internal.view.common._AbstractEditorSection");
dojo.require("com.ibm.rational.test.lm.sequencer.web.ui.internal.view.table.SequenceStepsTableView");
dojo.require("com.ibm.rational.test.lm.sequencer.web.ui.internal.Constants");
dojo.require("com.ibm.rational.test.lm.sequencer.web.ui.internal.util.Utility");

(function() {
	var AbsractEditorSection = com.ibm.rational.test.lm.sequencer.web.ui.internal.view.common._AbstractEditorSection;
	var SequenceStepsTableView = com.ibm.rational.test.lm.sequencer.web.ui.internal.view.table.SequenceStepsTableView;
	var Constants = com.ibm.rational.test.lm.sequencer.web.ui.internal.Constants;
	var Utility = com.ibm.rational.test.lm.sequencer.web.ui.internal.util.Utility;
dojo.declare("com.ibm.rational.test.lm.sequencer.web.ui.internal.view.section.ExecutionSequenceSection", [dijit._Widget, dijit._Templated, AbsractEditorSection],
{
		templatePath: dojo.moduleUrl("com.ibm.rational.test.lm.sequencer.web", "ui/internal/view/templates/section/ExecutionSequenceSection.html"),
		
		postCreate: function(){		
			this.initialize();
		},
		
		initialize: function(){
			var steps = [];
			if(!this.stepsTable){
				this.stepsTable = new SequenceStepsTableView({steps:steps, mySection: this});
				this.stepsTable.initialize();
				this.tableNode.appendChild(this.stepsTable.domNode);
			}else{
				this.stepsTable.disableAllActions();
				this.stepsTable.refresh(steps);
			}
		},
		
		rowCheckChanged: function(args){
			this.parentEditor.updateContentArea(args);
		},
		
		modifySection: function( add_remove_modify, template){
			if(add_remove_modify == Constants.ADD_STEP){//Add section
				template.sectionIndex = this.parentEditor.getCurrentSectionIndex();
				if(template.id == Constants.AUTOMATION_ID){
					this.parentEditor._createAutomationSection(template.sectionIndex, {parentEditor: this.parentEditor, details: template.stepDetails}, true);
				}else{
					this.parentEditor._createTestRecordSection(template.sectionIndex, {parentEditor: this.parentEditor, details: template.stepDetails}, true);
				}
			}else if(add_remove_modify == Constants.REMOVE_STEP){//remove
				this.parentEditor.removeSection(template.sectionIndex);
				this.parentEditor.updateContentArea(null);
			}else{//modify
				this.parentEditor.updateSection(template.sectionIndex, template);
			}
		},
		
		addRowInStepTable: function(args/*{type: type, attributes: attributes}*/){
			if(this.stepsTable){
				this.stepsTable._addRow(args)
			}
		},
		
		getStepTableContent: function(){
			return this.stepsTable.getContent();
		},
		
		setStepTableContent: function(content){
			this.stepsTable.refresh(content);
		},
		
		//Over-ridden from _AES
		validate: function(){
			return true;
		},
		
		//Over-ridden from _AES
		getAttributes: function(){
			return null;
		},
		//Over-ridden from _AES
		saveFinished: function(){
			
		},
		//Over-ridden from _AES
		saveError: function(){
			
		},
		
		onActivated: function(){
			if(this.stepsTable)
				this.stepsTable.refresh();
		},
		
		_error: function(errorObj){
			console.error("Error: (message: '" + errorObj.message + "') from ExecutionSequenceSection#_error");
		}
	}
	
);
}
)();
		
