//SequenceEditor
/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rational.test.lm.sequencer.web.ui.internal.view.sequence.SequenceEditor");
dojo.provide("com.ibm.rational.test.lm.sequencer.web.ui.internal.view.sequence.SequenceEditor");
/*
 * author: vasrivas
 */
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.rational.test.lm.sequencer.web.ui.internal.view.common._AbstractEditor");
dojo.require("com.ibm.rational.test.lm.sequencer.web.ui.internal.view.section.SequenceOverviewSection");
dojo.require("com.ibm.rational.test.lm.sequencer.web.ui.internal.view.section.AutomationSection");
dojo.require("com.ibm.rational.test.lm.sequencer.web.ui.internal.view.section.ExecutionSequenceSection");
dojo.require("com.ibm.rational.test.lm.sequencer.web.ui.internal.view.sequence.TestRecordView");
dojo.require("com.ibm.rational.test.lm.sequencer.web.ui.internal.Constants");
dojo.require("com.ibm.rational.test.lm.sequencer.web.client.internal.sequence.SequenceClient");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");
dojo.require("com.ibm.asq.common.web.ui.internal.util.GlobalEvents");
(function() {
var ServiceResponseHandler		   	= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var AbstractEditor 					= com.ibm.rational.test.lm.sequencer.web.ui.internal.view.common._AbstractEditor;
var Constants 						= com.ibm.rational.test.lm.sequencer.web.ui.internal.Constants;
var SequenceClient					= com.ibm.rational.test.lm.sequencer.web.client.internal.sequence.SequenceClient;
var ViewHeaderLayout				= com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout;
var GlobalEvents 					= com.ibm.asq.common.web.ui.internal.util.GlobalEvents;
dojo.declare("com.ibm.rational.test.lm.sequencer.web.ui.internal.view.sequence.SequenceEditor", [dijit._Widget, dijit._Templated, AbstractEditor],
{
		templateString: '<div>' +
						'    <div dojoType="com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout" dojoAttachPoint="_header"' +
                	    '         summaryEditable="true" summaryAsDesc="true">' +
						'    <div dojoAttachPoint=\"overviewSection\"></div>'+
						'    <div dojoAttachPoint=\"sequenceSection\"></div>'+
						'    </div>' +
						'</div>',
		
		widgetsInTemplate: true,
		_initialized: false,
		_sequenceType: Constants.SEQUENCE_TYPE_SCHEDULE,
		
		postCreate: function(){
			this._itemsToTrack = {};
			this._itemsToTrack.tables = [];
			this._itemsToTrack.automations = [];
			this._itemsToTrack.sections = [];
		},
		
		initialize: function(){
			dojo.deprecated("com.ibm.rational.test.lm.sequencer.web.ui.internal.view.common._AbstractEditor is deprecated and will be removed post 2.0");
			this._initialized = false;
			if(this.sequenceId){
				var responseHandler = new ServiceResponseHandler(this, "_createLayout", "_error");
				SequenceClient.getExecutionSequencesDTO(responseHandler, {id: this.sequenceId});
			}else{
				this._createLayout();//New Sequence
			}
		},

		_createLayout: function(sequence){
			if(sequence && sequence.length == 1){
				this.setArtifact(sequence[0]);
			}
			this.sections = [];
			this.setArtifactType(Constants.TYPE_SEQUENCE);
			var artifact = this.getArtifact();
			this.setNew(artifact ? false : true);
			this._defaultName = Constants.getMessage("labelNewSequenceTitle");
			this.createHeader({title: (artifact ? artifact.name : ""),
												iconClass: "sequence-def-icon-48",
												csHelpId: "rqm_cre_exec_sequence.html",
												summary: artifact && artifact.description ? artifact.description : ""});
			this._header.setCSHelpButtonLabel(Constants.getMessage("labelExecutionSequence")+" "+Constants.getRQMMessage("labelHelp"));
            if(artifact &&
                artifact.scheduledStart == null && 
                artifact.associatedBuildDef) {            
                this.setSequenceType(Constants.SEQUENCE_TYPE_BVT);        
            }
												
			this.setOriginator(artifact ? artifact.originator.name : null);
			this.setOwner(artifact ? artifact.owner.itemId : null);
			var inputArguments = {parentEditor: this};
			this.overviewWidget = new com.ibm.rational.test.lm.sequencer.web.ui.internal.view.section.SequenceOverviewSection(inputArguments);
			this.overviewWidget.initialize();
			this.sequenceWidget = new com.ibm.rational.test.lm.sequencer.web.ui.internal.view.section.ExecutionSequenceSection(inputArguments);
			var csHelpLabel = Constants.getMessage("labelOverview")+" "+Constants.getRQMMessage("labelHelp");
			this.createSection(this.overviewSection, {title: Constants.getMessage("labelOverview"), info: Constants.getMessage("labelOverviewSummary"), widget: this.overviewWidget, csHelpId: "sequence_overview.html",csHelpLabel:csHelpLabel});
			var csHelpLabel1 = Constants.getMessage("labelExecSequence")+" "+Constants.getRQMMessage("labelHelp");
			var seqSection = this.createSection(this.sequenceSection, {title: Constants.getMessage("labelExecSequence"), info: Constants.getMessage("labelExecSequenceSummary"), widget: this.sequenceWidget, addPlaceHolder: true, csHelpId: "sequence_steps.html",csHelpLabel:csHelpLabel1});
			this.currentSectionNode = seqSection.appendableDomNode;
			
			if(artifact){
				var steps = artifact.steps;
				var stepLength = (steps ? steps.length : 0);
				for(var i=0;i< stepLength;i++){
					var sequenceStep = {}
					if(steps[i].stepType == Constants.TYPE_TEST){
						var record = this._convertToSuiteFormat(steps[i].executionRecord);
						record = this._createProxyResultGroup(record, steps[i]);//HACK should be done on server side.
						var attributes = {
							type: steps[i].executionRecordType,
							record: record
						}
						var args = {
							attributes: attributes,
							type: Constants.TYPE_TEST
						}
						this.sequenceWidget.addRowInStepTable(args);
					}else{//Automation
					
					var automation ={jobs: [], machines: []}
					var automationName = steps[i].automationName ? steps[i].automationName : Constants.getMessage("labelUnassigned");
					var machineName = steps[i].machineName ? steps[i].machineName : Constants.getMessage("labelUnassigned");
					automation.jobs.push({
											jobId: steps[i].jobId, 
											jobName: automationName, 
											providerInstance: steps[i].providerInstance, 
											providerName: steps[i].providerName, 
											parameters: steps[i].parameters
										});
					var machine = {};
					machine["machine.id"] = steps[i].assetId;
					machine["machine.name"] = machineName;
					automation.machines.push(machine);
					
					var attributes = {
							type: Constants.TYPE_AUTOMATION,
							automation: automation
						}
						var args = {
							attributes: attributes,
							type: Constants.TYPE_AUTOMATION
						}
						this.sequenceWidget.addRowInStepTable(args);
					}
				}
			}
			
			this._createContentArea(inputArguments);
			this.connect(this, "setSequenceType", "updateExecutionSequenceSection");
			this.updateBrowserTitle();
            this._initialized = true;
            // The saved test cell will be loaded asynchronously after it is fetched by id.      
            if(artifact && artifact.testCellId) {            
                this.overviewWidget.loadTestCell(artifact.testCellId);
            }
		},
				
		_createContentArea: function(inputArguments){
			dojox.data.dom.removeChildren(this.currentSectionNode);
		},
		
		_createAutomationSection: function(index, inputArguments, replaceCurrentNode){
			inputArguments.sectionIndex = index;
			var automation = new com.ibm.rational.test.lm.sequencer.web.ui.internal.view.section.AutomationSection(inputArguments); 
			this._itemsToTrack.automations.push(automation);
			if(replaceCurrentNode){
				dojox.data.dom.removeChildren(this.currentSectionNode);
			}
			this.concatSection(index, automation);
		},
		
		_createTestRecordSection: function(index, inputArguments, replaceCurrentNode){
			inputArguments.sectionIndex = index;
			var testRecord = new com.ibm.rational.test.lm.sequencer.web.ui.internal.view.sequence.TestRecordView(inputArguments);
			this._itemsToTrack.tables.push(testRecord);
			var node = null;
			if(replaceCurrentNode)
				node = this.currentSectionNode;
			var title = inputArguments && inputArguments.details && inputArguments.details.attributes && inputArguments.details.attributes.type == Constants.MODEL_TYPE_SUITE ? Constants.getMessage("labelTestSuite") : Constants.getMessage("labelTestExecutionRecord");
			var section = this.createSection(node, {title: title, info: Constants.getMessage("labelTestRecordSummary", title), widget: testRecord});
			this._itemsToTrack.sections.push(section);
			this.concatSection(index, testRecord);
		},
		
		getSequenceType: function(){
			return this._sequenceType;
		},
		
		setSequenceType: function(seqType){
			this._sequenceType = seqType;
		},
		
		updateExecutionSequenceSection: function(){
			this.sequenceWidget.initialize();
			this.sections = [];
			this._createContentArea({parentEditor: this});
		},
		
		updateContentArea: function(args){
			var section = null;
			if (!args) {
				dojox.data.dom.removeChildren(this.currentSectionNode);
				return;
			}
			if(args.sectionIndex || args.sectionIndex == 0){
				section = this.getSection(args.sectionIndex);
			}else if(args.sectionId){
				var sections = this.sections;
				var sectionsLength = sections.length;
				for(var i=0;i<sectionsLength;i++){
					if(sections[i].id == args.sectionId){
						section = sections[i];
						break;
					}
				}
			}
			if(section){
				dojox.data.dom.removeChildren(this.currentSectionNode);
				if(args.id == Constants.AUTOMATION_ID){
//					this.currentSectionNode.appendChild(section.domNode);
				}else{
					this.currentSectionNode.appendChild(section.containerSection.domNode);
					section.onActivated();
				}
			}
		},

		//Over-ridden from _AE
		validate: function(){
			var name = this.getHeader().getTitle();
            if (dojo.trim(name).length == 0) {
                if (this.isNew()) {
                    this.setHeaderStatus(Constants.VALIDATION_ERROR, Constants.HEADER_STATUS_ERROR,
						Constants.getMessage("msgRequiredField", Constants.getMessage("labelName"), Constants.getMessage("labelExecutionSequence")));
					return false;
                } else {
                    this.getHeader().setTitle(this.getArtifact().name);
                }
            } else if (this._defaultName && name == this._defaultName) {
				this.setHeaderStatus(Constants.VALIDATION_ERROR, Constants.HEADER_STATUS_ERROR,
					Constants.getMessage("msgRequiredField", Constants.getMessage("labelName"), Constants.getMessage("labelExecutionSequence")));
                return false;
            }
			if(this.getSequenceType() == Constants.SEQUENCE_TYPE_BVT && this.overviewWidget.getBuildUUID() == null){
				this.setHeaderStatus(Constants.VALIDATION_ERROR, Constants.HEADER_STATUS_ERROR, Constants.getMessage("msgInvalidBuildDef"));
				return false;
			}
            return true;
		},
		
		//Over-ridden from _AE
		getAttributes: function(){
			var testObj = this.inherited('getAttributes', arguments);
			if(this.isNew())
				testObj.isNewItem = true;
			else{
				var artifact = this.getArtifact();
				testObj.id = artifact.id;
				testObj.itemId = artifact.uuid;
				if(artifact.stateId)
					testObj.stateId = artifact.stateId;
			}	
			testObj.name = this.getHeader().getTitle();
			testObj.description = this.getHeader().getSummary();
			if(this.getOwner().value != Constants.getMessage("labelUnassigned")){
				testObj.owner = this.getOwner().value; 
			}
			if(this.getSequenceType() == Constants.SEQUENCE_TYPE_BVT){
				testObj.isBVTSequence = true;
				testObj.buildDefId = this.overviewWidget.getBuildUUID();
				testObj.runOnFailedBuild = this.overviewWidget.isRunOnFailedBuild();
			}else{
				testObj.isBVTSequence = false;
				testObj.scheduledExecutionTime = this.overviewWidget.getScheduledTime();
			}
			if (this.overviewWidget.testCellItemId != null) {
			    testObj.testCellId = this.overviewWidget.testCellItemId;
			}
			return testObj;
		},
		
		_convertToSuiteFormat: function(testSuite){
			 if(testSuite && testSuite.elements && testSuite.elements.length >0){
			 	var suiteLength = testSuite.elements.length;
			 	for(var i=0;i<suiteLength;i++){
					var element = testSuite.elements[i]
					element.workitem = {};
					element.workitem.id = element.ewiId;
					element.workitem.name = element.ewiName;
					element.workitem.itemId = element.ewiitemId;
					element.workitem.archived = element.ewiIsArchived;
					element.workitem.testCase = element.testCase;
					element.workitem.weight = element.ewiWeight;
					if(element.ewiPlanId){
						element.workitem.testPlan = {};
						element.workitem.testPlan.id = element.ewiPlanId;
						element.workitem.testPlan.name = element.ewiPlanName;
						element.workitem.testPlan.versionableItemId = element.ewiPlanVersionableItemId;
					}	
					if(element.ewiPhaseName){
						element.workitem.testPhase = {};
						element.workitem.testPhase.name = element.ewiPhaseName;
						element.workitem.testPhase.itemId = element.ewiPhaseItemId;
					}
					if(element.scriptId){
						element.script = {};
						element.script.id = element.scriptId;
						element.script.name = element.scriptName;
						element.script.itemId = element.scriptItemId;
						element.script.stateId = element.scriptStateId;
						element.script.scriptType = {};
						element.script.scriptType.id = element.scriptTypeId;
					}
					if(element.ewiDefaultScriptId){
						element.workitem.defaultScript = {};
						element.workitem.defaultScript.id = element.ewiDefaultScriptId;
						element.workitem.defaultScript.name = element.ewiDefaultScriptName;
						element.workitem.defaultScript.itemId = element.ewiDefaultScriptItemId;
						element.workitem.defaultScript.stateId = element.ewiDefaultScriptStateId;
						element.workitem.defaultScript.scriptType = {};
						element.workitem.defaultScript.scriptType.id = element.ewiDefaultScriptTypeId;
					}else{
						element.workitem.defaultScript = null;
					}	
					element.workitem.stateId = element.ewiStateId;
					element.workitem.configuration = element.ewiConfigurationItemId;
					
					delete element.ewiId;
					delete element.ewiName;
					delete element.ewiitemId;
					delete element.ewiIsArchived;
					delete element.testCase;
					delete element.ewiDefaultScriptId;
					delete element.ewiDefaultScriptName;
					delete element.ewiDefaultScriptItemId;
					delete element.ewiDefaultScriptStateId;
					delete element.ewiDefaultScriptTypeId;
					delete element.ewiConfigurationItemId;
					delete element.ewiStateId;
					delete element.ewiPlanId;
					delete element.ewiPlanName;
					delete element.ewiPlanVersionableItemId;
					delete element.ewiPhaseItemId;
					delete element.ewiPhaseName;
					delete element.ewiWeight;
					
					delete element.scriptId;
					delete element.scriptName;
					delete element.scriptItemId;
					delete element.scriptStateId;
					delete element.scriptTypeId;
				}
			 }
			return testSuite;
		},
		
		//This data will get passed on inSelectionPopup see TestRecordCView#_updateDetailsWith.. functions
		_createProxyResultGroup: function(suite, data){
			if(!(data.adapters && data.adapters.length > 0 )){
				data.adapters = [];
			}
			if(data && data.scripts && data.scripts.length > 0){
				suite.currentResultGroup = {};
				suite.currentResultGroup.description = "custom";
				suite.currentResultGroup.elements = [];
				var datascriptLength = data.scripts.length;
				for(var i=0;i<datascriptLength;i++){
					var index = i;
					var ewiId = null;
					if(suite.elements /*TER will not have elements*/){
						//Suite
						ewiId = suite.elements[i].workitem.id;
						index = suite.elements[i].index;
					}else{
						//TER
						ewiId = suite.id;//In this case the script will be one, index will be 0
					}
					//@Map back from SelectionPopUp#initialize()
					var element = {}
					suite.currentResultGroup.elements[i] = element;
					element.ewiId = ewiId;
					element.index = index;
					element.scriptItemId = data.scripts[i].versionableItemId;
					element.scriptTypeId = data.scripts[i].scriptTypeId;
					element.scriptName = data.scripts[i].name;
					element.adapterId = (data.adapters[i] && data.adapters[i].id) ? data.adapters[i].id : 0; 
				}
			}
			return suite;
		},
		
		onActivated: function(){
			this.inherited(arguments);
			if(this.sequenceWidget)
				this.sequenceWidget.onActivated();
		},
		
		// handler on artifacts changed
        onArtifactChanged: function(changeType, artifactType, artifactArray) {
            if (artifactType == Constants.TYPE_SEQUENCE) {
				var arrLength = artifactArray.length;
				var artifact = this.getArtifact();
                for (var i = 0; i < arrLength; i++) {
                    if (artifact && (artifact.id == artifactArray[i].id)) {
                        if (changeType == GlobalEvents.ArtifactsDeleted){
							this.getHeader().setStatus(Constants.getMessage("msgEditorExecSequenceDeleted"), ViewHeaderLayout.ERROR);
							this.setArchived(true);
	                        return;
						}		
                    }
                }
            }
        },
		
		getCell: function(){
			if(!this.overviewWidget)
				return null;
			return this.overviewWidget.getCellObject();
		},
		
		getStepTableContent: function(){
			if(this.sequenceWidget){
				return this.sequenceWidget.getStepTableContent();
			}
		},
		
		setStepTableContent: function(content){
			if(this.sequenceWidget){
				this.sequenceWidget.setStepTableContent(content);
			}
		},
		
		uninitialize: function(){
			//called on close of editor 
			var tableLength = this._itemsToTrack.tables.length;
			var automationLength = this._itemsToTrack.automations.length;
			var recTables = this._itemsToTrack.tables;
			var autoTables = this._itemsToTrack.automations;
			var sections = this._itemsToTrack.sections;
			var sectionLength = this._itemsToTrack.sections.length;
			for(var i=0;i<tableLength;i++){
				recTables[i].destroy();
				console.debug("SequenceEditor removing RecordTables");
			}
			for(var i=0;i<automationLength;i++){
				autoTables[i].destroy();
				console.debug("SequenceEditor removing AutomationTables");
			}
			for(var i=0;i<sectionLength;i++){
				sections[i].destroy();
				console.debug("SequenceEditor removing sections");
			}
			
		},
		
		_error: function(errorObj){
			console.error("Error: (message: '" + errorObj.message + "') from SequenceEditor#_error");
		}
	}
);
}
)();
		
