//SExecute
/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2010. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
/*
 * ExecutionView for Suite
 * Author: vasrivas
 */
dojo.provide("com.ibm.rqm.execution.web.ui.internal.view.suite.SuiteExecution");

dojo.require("net.jazz.ajax.ui.PlatformUI");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.TestExecutionSuiteClient");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultGroupClient");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.common.ExecutionConsole");
dojo.require("com.ibm.rqm.execution.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.table.ExecutionTableView");
dojo.require("com.ibm.asq.common.web.ui.internal.util.GlobalEvents");
dojo.require("com.ibm.rqm.execution.web.client.internal.mapper.ExecutionResultGroupMapper");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

(function(){ 
	
	var ServiceResponseHandler			= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
	var ERGClient 						= com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultGroupClient;
	var Constants                       = com.ibm.rqm.planning.web.client.internal.Constants;
	var Utility 						= com.ibm.rqm.execution.web.ui.internal.util.Utility;
	var GlobalEvents 					= com.ibm.asq.common.web.ui.internal.util.GlobalEvents;
	var ERGMapper						= com.ibm.rqm.execution.web.client.internal.mapper.ExecutionResultGroupMapper;
	var TestExecutionSuiteClient		= com.ibm.rqm.execution.web.client.internal.execution.TestExecutionSuiteClient;
	var ExecutionTableView 				= com.ibm.rqm.execution.web.ui.internal.view.table.ExecutionTableView;
	dojo.declare("com.ibm.rqm.execution.web.ui.internal.view.suite.SuiteExecution", [com.ibm.rqm.execution.web.ui.internal.view.common.ExecutionConsole], {
		
		buttonAdded: false,
		consoleNode: false,
		titleSet: false,
		ergName: "",
		initialized: false,
		myURI: null,
		fetchingRequestUpdates: false,
		
		initialize: function(){
			if(!this.initialized) {
				this.myURI = window.location.hash;
			}
			
			/* if our page is not in view, don't waste the cycle to update the progress.
        	 *  Suspend the refresh until we're in view again.
        	 */
			if(this.myURI != window.location.hash) {
				return;
			}
			
			if(!this.initialized){
				this._createExecutionTable();
				this.initialized = true;
				console.debug("creating timer");
				this._timer = setInterval(dojo.hitch(this, this._fetchRequestUpdates), this.getTimeout());
			}
			if(!this._timer){
				console.debug("creating timer from initialize");
				this._timer = setInterval(dojo.hitch(this, this._fetchRequestUpdates), this.getTimeout());
			}	
			var args = {}
			if(this.groupId) {
				args.id = this.groupId;
			} else if(this.itemId) {
				args.itemId = this.itemId;
			}
			args.includeResult = false;
			args.includeRequest = true;
			args.includeTestcase = false;
			var responseHandler = new ERGMapper(this, "_setERGroup", "_error");
			ERGClient.getExecutionResultGroupDTOs(responseHandler, args);
		},
		
		_createExecutionTable: function () {
		if(!this._executionTable){
			var actions = [{
		        actionId: "refresh",
		        label: Constants.getMessage("labelRefresh"),
		        actionHandler: dojo.hitch(this, "onRefresh"),
		        iconClass: "refresh-icon-image",
				disabled: false
	    	}];
			var args = {
				requests: [],				
				actions: actions,
				queryName: this.name,
                sortResult: false
        	}
			if(this.ergId){
				args.ergId = this.ergId;
			}
			var _executionTable = new ExecutionTableView(args);
            if(_executionTable.viewHeaderNode && _executionTable.viewHeaderNode.uninitialized){
				_executionTable.viewHeaderNode.setCSHelpId("rqm_exec_console.html");
				_executionTable.viewHeaderNode.setCSHelpButtonLabel(Constants.getMessage("labelExecutionTableViewHelp"));
			}
			_executionTable.setInProgress(Constants.getMessage("msgQueryTableList", this.name));
			dojox.data.dom.removeChildren(this._table);
			this._table.appendChild(_executionTable.domNode);
			this._executionTable = _executionTable;
		}
	},
	
		
		_setERGroup: function(resultGroup){
			var requests = [];
			if(resultGroup && resultGroup.length > 0 && resultGroup[0]){
				var requests = [];
				var len = resultGroup[0].elements ? resultGroup[0].elements.length: 0;
				for(var i=0; i < len;i++){
					 if (resultGroup[0].elements[i].request) {
					 	requests.push(resultGroup[0].elements[i].request);
					}
				}
				this.ergId = resultGroup[0].id;
				this.ergName = resultGroup[0].name;
				this.requests = requests;
				this._executionTable.setERGId(this.ergId);
				this._createTable(this.requests);
			} else {
				this._createTable([]);
			}
			
			if(this._executionTable && !this.buttonAdded){
				this.buttonAdded = true;
				this.showResultButton = this._executionTable.viewHeaderNode.addRightViewAction(Constants.getMessage("labelCloseAndShowResult"), dojo.hitch(this, "onShowResult"), null, null);
				this.showResultButton.setDisabled(true);
			}
			if(this._executionTable && !this.titleSet){
				this.titleSet = true;
				this._executionTable.viewHeaderNode.setTitle(Constants.getMessage("labelTestSuiteExecution", this.ergName));
				this._executionTable.viewHeaderNode.setCSHelpId("rqm_suite_execution_overview.html");
				this._executionTable.viewHeaderNode.setIconClass("ewi-icon-48");
			}
			
			//After creation check for completion
			if(resultGroup && resultGroup[0] && this.requests){
				this.resultGroup = resultGroup[0];
				this._checkForCompletion(this.resultGroup);
			}
			
			// update browser title
			this._updateBrowserTitle();
		},
		
		_checkForCompletion: function(resultGroup){
			var completion = true;
			var elements = resultGroup.elements ? resultGroup.elements : [];
			var elementsLength = elements.length;
			for(var i=0; i < elementsLength; i++){
				if(!elements[i].request || parseInt(elements[i].request.progress) < 100){
					completion = false;
				}
				else if(elements[i].request.state && elements[i].request.state.id == "com.ibm.rqm.executionframework.common.requeststate.cancelled" && resultGroup.sequentialExecution){
					completion = true;//Seq exec will not proceed after this, enable result nav.
					break;
				}
			}
			
			this.requestMap = {};//For request updates to be received on the UI
			var requestsLength  = this.requests.length ;
			for (var i=0; i < requestsLength ; i++){
				if(this.requests[i].progress == 100){
					this.requestMap[this.requests[i].id] = false;
				}else{
					this.requestMap[this.requests[i].id] = true;
				}
			}
			
			if(completion){
                this.resultGroupId = this.ergId;
                if (this._timer) {
                    clearInterval(this._timer);
                    delete this._timer;
                    console.debug("deleting timer");
                }
                this.showResultButton.setDisabled(false);
			}else{
				this.showResultButton.setDisabled(true);
			}
			this._updateTopSection();	
		},
		
		getTimeout: function(){
			return 10000;
		},
		
		onShowResult: function(){
			parent.location = Utility.showSuiteResult({id: this.resultGroupId});
			setTimeout(dojo.hitch(this, "publishClosure"), 1500);
		},
		
		publishClosure: function(){
			var args = {}
			if(this.groupId)
				args.groupId = this.groupId;
			if(this.itemId)
				args.itemId = this.itemId;
					
			var uri = Utility.runSuite(args);
			dojo.publish(GlobalEvents.CloseTab, [uri]);
		},
		
		_updateTopSection: function(){
			var doc = document;
			if(this.topSectionCreated){
				if(this.resultGroup.sequentialExecution){
					var requests = this.requests;
					var totalElements = this.resultGroup.elements ? this.resultGroup.elements.length : 0;
					var completed = 0; var running = 0; var notrun = 0;
					for(var i=0;i< (requests ? requests.length:0); i++){
						if(parseInt(requests[i].progress) < 100){
							running ++;
						}else if(parseInt(requests[i].progress) == 100){
							completed ++;
						}
					}
					
					var comp = doc.getElementById(this.id+"_completedValue");
					if(comp)	comp.innerHTML = completed + " " + Constants.getMessage("labelTestCases");
					var run = doc.getElementById(this.id+"_runningValue");
					if(run)		run.innerHTML = running +  " " + Constants.getMessage("labelTestCase");
					var notRun = doc.getElementById(this.id+"_notRunValue");
					if(notRun)	notRun.innerHTML = (totalElements - (completed + running)) + " " + Constants.getMessage("labelTestCases");
				}
			}else{
				var table = doc.createElement('table');
				table.width = "300px;"
				var tbody = doc.createElement('tbody');
				table.appendChild(tbody);
				this._executionTable.viewHeaderNode.getSummaryNode().appendChild(table);
				
				//testsuite name and link
				var trName = doc.createElement('tr');
				tbody.appendChild(trName);
				var tdName = doc.createElement('td');
				trName.appendChild(tdName);
				var nameLabel = doc.createElement('label');
				nameLabel.innerHTML = Constants.getMessage("labelTestSuite");
				tdName.appendChild(nameLabel);
				var tdNameValue = doc.createElement('td');
				trName.appendChild(tdNameValue);
				var anchorName = doc.createElement('a');
				anchorName.id = this.id+"_nameLink";//Placeholder fetch the suite summary and update
				tdNameValue.appendChild(anchorName);
				
				//Execution Mode
				var tr = doc.createElement('tr');
				tbody.appendChild(tr);
				var tdtype = doc.createElement('td');
				tr.appendChild(tdtype);
				var typeLabel = doc.createElement('label');
				typeLabel.innerHTML = Constants.getMessage("labelExecutionMode");
				tdtype.appendChild(typeLabel);
				var tdSeq = doc.createElement('td');
				tr.appendChild(tdSeq);
				var seqLabel = doc.createElement('label');
				seqLabel.innerHTML = this.resultGroup.sequentialExecution ? Constants.getMessage("labelSequential") : Constants.getMessage("labelParallel") ;
				tdSeq.appendChild(seqLabel);

				if(this.resultGroup.sequentialExecution){
					var tr1 = doc.createElement('tr');
					tbody.appendChild(tr1);
					//Completed
					var tdcompLabel = doc.createElement('td');
					tr1.appendChild(tdcompLabel);
					var compLabel = doc.createElement('label');
					compLabel.innerHTML = Constants.getMessage("labelCompleted");
					tdcompLabel.appendChild(compLabel);
					var tdcompVal = doc.createElement('td');
					tr1.appendChild(tdcompVal);
					var compVal = doc.createElement('label');
					compVal.innerHTML = "";
					tdcompVal.appendChild(compVal);
					compVal.id = this.id + "_completedValue";
					
					var tr2 = doc.createElement('tr');
					tbody.appendChild(tr2);
					//Running
					var tdrunningLabel = doc.createElement('td');
					tr2.appendChild(tdrunningLabel);
					var runningLabel = doc.createElement('label');
					runningLabel.innerHTML = Constants.getMessage("labelRunning");;
					tdrunningLabel.appendChild(runningLabel);
					var tdrunningVal = doc.createElement('td');
					tr2.appendChild(tdrunningVal);
					var runningVal = doc.createElement('label');
					runningVal.innerHTML = "";
					tdrunningVal.appendChild(runningVal);
					runningVal.id = this.id + "_runningValue";
					
					var tr3 = doc.createElement('tr');
					tbody.appendChild(tr3);
					//Not run
					var tdnotRunLabel = doc.createElement('td');
					tr3.appendChild(tdnotRunLabel);
					var notRunLabel = doc.createElement('label');
					notRunLabel.innerHTML = Constants.getMessage("labelNotRun");;
					tdnotRunLabel.appendChild(notRunLabel);
					var tdnotRunVal = doc.createElement('td');
					tr3.appendChild(tdnotRunVal);
					var notRunVal = doc.createElement('label');
					notRunVal.innerHTML = "";
					tdnotRunVal.appendChild(notRunVal);
					notRunVal.id = this.id + "_notRunValue";
				}
				this.topSectionCreated = true;
				this._updateTopSection();
				var args = {resultGroupId: this.resultGroup.id, includeArchive: true};
				var responseHandler = new ServiceResponseHandler(this, "_updateSuiteLink", "_error");
				TestExecutionSuiteClient.getTestExecutionSuiteMinimalSummaryDTOs(responseHandler, args);
			}
		},
		
		_updateSuiteLink: function(suiteSummarys){
			var suiteSummary = suiteSummarys ? suiteSummarys[0] : null;
			var anchorName = document.getElementById(this.id+"_nameLink");
			if(anchorName){
				var nameValue = document.createElement('label');
				nameValue.innerHTML = suiteSummary ? suiteSummary.name : this.ergName;
				anchorName.appendChild(nameValue);
				nameValue.className = 'content-selector-deselected';
				if (suiteSummary){
					anchorName.href = Utility.getTestSuiteURI(suiteSummary.id) 
				} else{
					anchorName.parentNode.replaceChild(nameValue,anchorName);
				}
			}
		},
	// handler on artifacts changed
    onArtifactChanged: function(changeType, artifactType, artifactArray) {
        // only care about requests
        if (artifactType == Constants.TYPE_REQUEST) {
            if (changeType == GlobalEvents.ArtifactsAdded) {
                // add requests to the table
                if (!this.requests) {
                    this.requests = artifactArray;
                } else {
                    this.requests = this.requests.concat(artifactArray);
                }
				if(this._executionTable)
                	this._executionTable.setContent(this.requests);
            } else {
                // iterate through the array of artifacts
				var len = artifactArray.length;
				var ele = this.resultGroup && this.resultGroup.elements ? this.resultGroup.elements : [];
                for (var i = 0; i < len; i++) {
					var mod = new Date();
					artifactArray[i].modified = mod.getTime();
					var len2 = this.requests.length;
                    // iterate through the array of requests in the table
                    for (var j = 0; j < len2; j++) {
                        // handle the matching requests
                        if (artifactArray[i].id == this.requests[j].id) {
                            if (changeType == GlobalEvents.ArtifactsUpdated) {
                                // swap requests on update
                                this.requests.splice(j, 1, artifactArray[i]);
                                if(this._executionTable)
								this._executionTable.setContent(this.requests);
								for(var p=0;p<ele.length;p++){
									if(ele[i].request && ele[i].request.id == artifactArray[i].id){
										ele[i].request = artifactArray[i];
										break;
									}
								}	
                            } else if (changeType == GlobalEvents.ArtifactsDeleted) {
                                // remove requests from table on delete
                                this.requests.splice(j, 1);
                                if(this._executionTable)
									this._executionTable.setContent(this.requests);
                            }
                            break;
                        }
                    }
                }
            }
			//additionally check if we can navigate to results
			this.resultGroup.requests = this.requests;
			this._checkForCompletion(this.resultGroup)
        }
    },
	
	//Override isDirty to clear Timer on tab close
	isDirty: function(){
		if(this._timer){
			clearInterval(this._timer);
			delete this._timer ;
			console.debug("deleting timer on tab close");
		}
		return false;
	},

	//Over-ride from ExecutionConsole
	_error: function(errorObj){
		if(this._timer){
				clearInterval(this._timer);
				delete this._timer ;
				console.debug("deleting timer");
			}
		this.fetchingRequestUpdates = false;	
		console.error("Error in Suite Execution "+ errorObj.message + " ");
	},
	
	_fetchRequestUpdates: function(){
		if(this.fetchingRequestUpdates || this.myURI != window.location.hash)
				return;
		this.fetchingRequestUpdates = true;
		var args = {}
		args.requestJsonString= dojo.toJson(this.requestMap);
		args.ergItemId = this.resultGroup.itemId;
		
		var responseHandler = new ERGMapper(this, "_receiveUpdatedRequests", "_error");
		ERGClient.getUpdatedRequests(responseHandler, args);
	},
	
	_receiveUpdatedRequests: function(requests){
		requests = requests ? requests : [];
		var requestsLength = requests.length;
		var reqs = this.requests;
		var reqsLen = reqs.length;
		var elesLen = this.resultGroup.elements ? this.resultGroup.elements.length : 0;
		for(var i=0;i<requestsLength;i++){
			var foundRequest = false;
			for(var j=0;j<reqsLen;j++){
				if(this.requests[j].id == requests[i].id){
					//Found updated request
					foundRequest = true;//We receive only these 4 values in update.
					this.requests[j].progress = requests[i].progress;
					this.requests[j].state = requests[i].state;
					this.requests[j].modified = requests[i].modified;
					this.requests[j].propertiesMap = requests[i].propertiesMap;
				}
			}
			if(!foundRequest)
				this.requests = this.requests.concat([requests[i]]);
				for(var p=0;p<elesLen;p++){
					if(this.resultGroup.elements[p].index == requests[i].suiteElementIndex){
					if(!this.resultGroup.elements[p].request)
						this.resultGroup.elements[p].request = {};
					this.resultGroup.elements[p].request.progress = requests[i].progress;
					this.resultGroup.elements[p].request.state = requests[i].state;
					this.resultGroup.elements[p].request.modified = requests[i].modified;
					this.resultGroup.elements[p].request.propertiesMap = requests[i].propertiesMap;
					break;
				}
			}
		}
		this.resultGroup.requests = this.requests;
		this._createTable(this.requests);
		this._checkForCompletion(this.resultGroup);
		this.fetchingRequestUpdates = false;
	},
	
	_updateBrowserTitle: function(){
		if (this.page){
			var name="";
		 	if (this.ergName) {
				name = this.ergName;
			}
			this.page.browserTitle =  Constants.getMessage("labelTestSuiteExecution", Constants.getMessage("labelColen") + " " + name);
			net.jazz.ajax.ui.PlatformUI.getWorkbench().setTitle(this.page.browserTitle);
			net.jazz.ajax.ui.PlatformUI.getWorkbench().browserTitle = this.page.browserTitle;	
		}
	}      
});
    
})();
