/******************************SuiteExecutionLog************************************************ 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
/*
 * Weight for Suite
 * Author: vasrivas
 */
dojo.provide("com.ibm.rqm.execution.web.ui.internal.view.suite.SuiteWeightSection");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");

(function(){ 
	var Constants 	= com.ibm.rqm.planning.web.client.internal.Constants;
	
	dojo.declare("com.ibm.rqm.execution.web.ui.internal.view.suite.SuiteWeightSection", [dijit._Widget, dijit._Templated], {
		
		templateString: '<div class="com-ibm-rqm-test-execution-points">'+
							'<table dojoAttachPoint="_pointsTable" class="points-table" >'+
								'<tr dojoAttachPoint="_pointsPassedRow" class="points-row">'+
									'<td class="points-label" width="50px">${labelPass}</td>'+
									'<td><label dojoAttachPoint="_passed" class="points-input" size="4"></label></td>'+
								'</tr>'+
								'<tr dojoAttachPoint="_pointsFailedRow" class="points-row">'+
									'<td class="points-label" width="50px">${labelFail}</td>'+
									'<td><label dojoAttachPoint="_failed" class="points-input" size="4"></label></td>'+
								'</tr>'+
								'<tr dojoAttachPoint="_pointsBlockedRow" class="points-row">'+
									'<td class="points-label" width="50px">${labelBlocked}</td>'+
									'<td><label dojoAttachPoint="_blocked" class="points-input" size="4"></label></td>'+
								'</tr>'+
								'<tr dojoAttachPoint="_pointsInconclusiveRow" class="points-row">'+
									'<td class="points-label" width="50px">${labelInconclusive}</td>'+
									'<td><label dojoAttachPoint="_inconclusive" class="points-input" size="4"></label></td>'+
								'</tr>'+
								'<tr dojoAttachPoint="_pointsAttemptedRow" class="points-row">'+
									'<td class="points-label" width="50px">${labelAttempted}</td>'+
									'<td><label dojoAttachPoint="_attempted" class="points-input" size="4"></label></td>'+
								'</tr>'+
								'<tr dojoAttachPoint="_pointsTotalRow" class="points-row">'+
									'<td class="points-label" width="50px">${labelTotalWeight}</td>'+
									'<td><label dojoAttachPoint="_total" class="points-input" size="4"></label></td>'+
								'</tr>'+
							'</table>'+
						'</div>',
		
		labelPass: Constants.getMessage("labelPass")+Constants.getMessage("labelColen"),
		labelFail: Constants.getMessage("labelFail")+Constants.getMessage("labelColen"),
		labelBlocked: Constants.getMessage("labelBlocked")+Constants.getMessage("labelColen"),
		labelInconclusive: Constants.getMessage("labelInconclusive")+Constants.getMessage("labelColen"),
		labelAttempted: Constants.getMessage("labelAttempted")+Constants.getMessage("labelColen"),
		labelTotalWeight: Constants.getMessage("labelTotalWeight")+Constants.getMessage("labelColen"),
		
		postCreate: function(){
		},
		
		initialize: function(erGroup){
			this.erGroup = erGroup;
			this._rollUpPoints();
			this.fillDetails();
		},
		
		_clearRollUp: function(){
			this.maxPoints = 0;
            this.totalPointsPassed = 0;
            this.totalPointsFailed = 0;
			this.totalPointsBlocked = 0;
			this.totalPointsInconclusive = 0;
            this.totalPointsAttempted = 0;
		},
		
		_rollUpPoints: function(){
			this._clearRollUp();
			var elements = this.erGroup.elements;
			var elementsLength=elements.length ? elements.length : 0;
			for(var i=0;i < elementsLength; i++){
				this.maxPoints = this.maxPoints + elements[i].workitem.weight;
				if (elements[i].result) {
					this.totalPointsPassed += elements[i].result.pointsPassed;
            		this.totalPointsFailed += elements[i].result.pointsFailed;
					this.totalPointsBlocked += elements[i].result.pointsBlocked;
					this.totalPointsInconclusive += elements[i].result.pointsInconclusive;
		            this.totalPointsAttempted += elements[i].result.pointsAttempted;
				}
			}
			
		},
		
		fillDetails: function(){
			this._passed.innerHTML = this.totalPointsPassed;
			this._failed.innerHTML = this.totalPointsFailed;
			this._blocked.innerHTML = this.totalPointsBlocked;
			this._inconclusive.innerHTML = this.totalPointsInconclusive;
			this._attempted.innerHTML = this.totalPointsAttempted;
			this._total.innerHTML = this.maxPoints;
		},
		
		_error: function(errorObj){
			console.error("Error in Suite Weight Section"+ errorObj.message + " ");
		}        
    });
})();
