/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.execution.web.ui.internal.view.table.AbstractFilteredExecutionTableView");
 

dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.table.AbstractFilteredTableView");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultStateClient");

(function() {

var ServiceResponseHandler      = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var Constants                   = com.ibm.rqm.planning.web.client.internal.Constants;
var AbstractFilteredTableView   = com.ibm.rqm.planning.web.ui.internal.view.table.AbstractFilteredTableView;
var ExecutionResultStateClient  = com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultStateClient;

dojo.declare("com.ibm.rqm.execution.web.ui.internal.view.table.AbstractFilteredExecutionTableView", [AbstractFilteredTableView],
{
	
    addExecutionStateFilter: function(filterObj, filtersCollection, callback) {
        // initlize the orginator filter with the list of contributors
        var self = this;
        var serviceObj = {
            success: function(executionStates) {
                if (dojo.isArray(executionStates) && (executionStates.length > 0)) {
					// sort the states by name
					function stateCompare(stateA, stateB){
						var a = stateA.name;
						var b = stateB.name;
						return a > b ? 1 : a < b ? -1 : 0;
					}
					executionStates.push({
						name: Constants.getMessage("labelNotRun"),
						id: "com.ibm.rqm.execution.common.state.notrun"
					});
					executionStates = executionStates.sort(stateCompare);
					var stateOptions = [];
					for (var i = 0; i < executionStates.length; i++) {
						stateOptions.push({
							name: executionStates[i].name,
							value: executionStates[i].id,
							checked: false
						});
					}
				}                
                var statesFilter = {
                    name: filterObj.name,  // must match key in the arg list of the API
                    title: filterObj.label,
                    promptTitle: filterObj.prompt,
                    type: filterObj.type,
                    defaultValue: [],
                    params: {options: stateOptions}
                };
                filtersCollection.push(statesFilter);
                callback();
            },
            
            failure: function(e) {
                self._error(e);
                callback();
            }
        };
        var responseHandler = new ServiceResponseHandler(serviceObj, "success", "failure");
        ExecutionResultStateClient.getExecutionResultStates(responseHandler, {includeHidden: false});
    }	
    
});

})();
