//AdapterConsoleTableView
/***************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
//MFV This was extracted from MachineAdapterTableView.  The use of the code in the Execution->Adapter Console
//was growing more and more divergent from the use for selecting machines and test cells so it made sense that
//there be separate classes.

dojo.provide("com.ibm.rqm.execution.web.ui.internal.view.table.AdapterConsoleTableView");
 
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.rqm.execution.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.asq.common.web.client.internal.PermissionsClient");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.ListRowRenderer");
dojo.require("com.ibm.asq.common.web.client.internal.Catalog");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ToolAdapterRegistrationClient");
dojo.require("com.ibm.rational.test.lm.web.client.internal.config");
dojo.require("com.ibm.asq.common.web.ui.internal.util.SelectUtility");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil");          //Using this for Date formatting.  Probably should use an RQM method
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.rqm.execution.web.ui.internal.util.Utility");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.pages.AssetUriUtil");

(function() {
	
var TableConstants 					= com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;
var ImageCache     					= com.ibm.rqm.execution.web.ui.internal.view.common.ImageCache;
var Constants      					= com.ibm.rqm.planning.web.client.internal.Constants;
var ServiceResponseHandler 			= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var getAuthenticatedContributor		= com.ibm.team.repository.web.client.session.getAuthenticatedContributor;
var SelectUtility					= com.ibm.asq.common.web.ui.internal.util.SelectUtility;
var RtlmUiUtil 						= com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil;
var CommonImageCache				= com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
var Utility        					= com.ibm.rqm.execution.web.ui.internal.util.Utility;
var ViewHeaderLayout				= com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout;
var AssetUriUtil					= com.ibm.rational.test.lm.web.ui.internal.pages.AssetUriUtil;
var MACHINE_SEARCH_COLUMNS = "machine.id, machine.name, machine.operatingsystem.hostname";

/*The data structure of the row data is
{
	machineID   
	machineName
	osName
	adapterInfo    (A structure defining the info for an adapter)
}
*/
dojo.declare("AdapterConsoleTableView.Sorter",
			com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableSorter,
{
	_sortComparator: function(obj1, obj2){
		if(this.sortCol == 4){
			if(obj1.statusValue == null || obj2.statusValue == null)
				return 0;
			if(this.sortDir == TableConstants.SORT_DIR_ASCEND){
				return obj1.statusValue - obj2.statusValue;
			}else{
				return obj2.statusValue - obj1.statusValue;
			} 
		}else 
			return this.inherited("_sortComparator",arguments);
	}
});

dojo.declare("AdapterConsoleTableView.TableProvider", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider,
{
    getNumColumns: function(content){
        return 8;
    },

    _columnHeadings: [
	            Constants.getMessage("labelId"),
				Constants.getMessage("labelMachineName"),
	            Constants.getMessage("labelAdapterType"),
				Constants.getMessage("labelAdapterStatus"),
				Constants.getMessage("labelHealth"),
				Constants.getMessage("labelHostname"),
				Constants.getMessage("labelIPAddress"),
				Constants.getMessage("labelPollingInterval")
    ],
    
    getColumnHeading: function(content, index){
        return this._columnHeadings[index];
    },
   
    getColumnHeadingImage: function(content, atColumnIndex){		  
        return null;
    },
	 
    getColumnHeadingAlignment: function(atColumnIndex){
        return this.getCellAlignment(null, atColumnIndex);
    },	 
    
    getIsColumnGroupable: function(content, atColumnIndex){
		//Group Machine, Adapter Type, or Status
        return (atColumnIndex == 1 || atColumnIndex == 2 || atColumnIndex == 3);     
    },

    getIsColumnSortable: function(content, atColumnIndex){
        return true;   
    },
    
    _columnWidths: [5,15,20,10,10,20,10,10],
    
    getColumnWidth: function(content, atColumnIndex){
        return this._columnWidths[atColumnIndex];
    },
	
    setServerTime: function(serverTime){
		this.serverTime = serverTime;
	},

    getContentObjects: function(content){
        return content;
    },
    
	getRowDataId: function(rowData){
        return rowData.adapterInfo.id;
    },
	
    getCellDisplayType: function(rowData, atColumnIndex){
        var type = TableConstants.RENDER_TYPE_TEXT;
        switch(atColumnIndex) {
			case 4: 
                type = TableConstants.RENDER_TYPE_IMAGE;
                break;					 
        }
		if(atColumnIndex == 1){
			type = TableConstants.RENDER_TYPE_LINK;
		}
        return type;
    },

    getCellAlignment: function(rowData, atColumnIndex){
		if(atColumnIndex == 4)
			return TableConstants.ALIGN_CENTER;
		else	
        	return TableConstants.ALIGN_LEFT;
    },
 
    getCellDisplayData: function(rowData, atColumnIndex){
        var val = "";
        switch(atColumnIndex) {
            case 0: 
                val = rowData.adapterInfo.id;
                break;
			case 1: 
                val = rowData.machineName;
                break;
            case 2: 
                val = rowData.adapterInfo.adapterType.adapterName;
                break;
			case 3:
					var engineStatus = Constants.getMessage("labelAvailable");
					rowData.statusValue = 0;
					if( (rowData.adapterInfo.serverTime - rowData.adapterInfo.lastHeartBeat) > 10*(rowData.adapterInfo.pollingInterval)){
						engineStatus = Constants.getMessage("labelUnAvailable");
						rowData.statusValue = 2;
					}else if( (rowData.adapterInfo.serverTime - rowData.adapterInfo.lastHeartBeat) > 2*(rowData.adapterInfo.pollingInterval)){
						engineStatus = Constants.getMessage("labelAvailable");
						rowData.statusValue = 1;
					}
				val = engineStatus;
				break;
            case 4: 
                this.engineStatus = Constants.getMessage("labelAvailable");
				this.engineStatusIcon = CommonImageCache.ENGINE_AVAILABLE;
				this.engineToolTip = Constants.getMessage("msgEngAvailable");
				rowData.statusValue = 0;
				if( (rowData.adapterInfo.serverTime - rowData.adapterInfo.lastHeartBeat) > 10*(rowData.adapterInfo.pollingInterval)){
					this.engineStatus = Constants.getMessage("labelUnAvailable");
					this.engineStatusIcon = CommonImageCache.ENGINE_NOTAVAILABLE;
					this.engineToolTip = Constants.getMessage("msgEngUnresponsive");
					rowData.statusValue = 2;
				}
				else if( (rowData.adapterInfo.serverTime - rowData.adapterInfo.lastHeartBeat) > 2*(rowData.adapterInfo.pollingInterval)){
					this.engineStatus = Constants.getMessage("labelAvailable");
					this.engineStatusIcon = CommonImageCache.ENGINE_NOTRESPONDED;
					this.engineToolTip = Constants.getMessage("msgEngRespondLate");
					rowData.statusValue = 1;
				}
				val = this.engineStatus;
                break;
			case 5:
					val = rowData.adapterInfo.hostName;
				break;
			 case 6: 
                val = rowData.adapterInfo.machine.ipAddress;
                break;
			case 7: 
                val = Utility.getTimeDifferenceInHrMinSec(rowData.adapterInfo.pollingInterval);
                break;		
        }
        return val;
    },

	getToolTip: function(adapter, avail){
		var reqInQueue = adapter.requestsInQueue ? adapter.requestsInQueue : 0; 
		var timeSinceLastContact = adapter.serverTime - adapter.modified;
		var str = [];
		str.push("<table><tr><td> </td><td> </td></tr>");
		str.push("<tr><td align=left>"+Constants.getMessage("labelstatus")+": "+"</td><td>"+avail+"</td></tr>");
		str.push("<tr><td> </td><td> </td></tr>");
		str.push("<tr><td align=left>"+Constants.getMessage("labelLastSinceLastContact")+": "+"</td><td>"+Utility.getTimeDifferenceInHrMinSec(timeSinceLastContact)+"</td></tr>");
		str.push("<tr><td> </td><td> </td></tr>");
		str.push("<tr><td align=left>"+Constants.getMessage("labelJobsInQueue")+": "+"</td><td>"+ reqInQueue +"</td></tr>");				
		str.push("<tr><td> </td><td> </td></tr>");
		if(adapter.name){
			str.push("<tr><td align=left>"+Constants.getMessage("labelName")+": "+"</td><td>"+ adapter.name +"</td></tr>");				
			str.push("<tr><td> </td><td> </td></tr>");
		}
		str.push("</table>");
		return str.join("");
	},

    getCellDisplayExtendedInfo: function(rowData, atColumnIndex){  
        var val = null;
        if (atColumnIndex == 4) {
			val = {image:this.engineStatusIcon,tooltip : this.getToolTip(rowData.adapterInfo, this.engineToolTip)};
		}else if(atColumnIndex == 1){
			val = {href: AssetUriUtil.getViewAssetDetailURI("Machine", rowData.machineID)};
		}		  
        return val;
    }
});

dojo.declare("com.ibm.rqm.execution.web.ui.internal.view.table.AdapterConsoleTableView", 
    [dijit._Widget, dijit._Templated],
{    
    templateString: '<div dojoAttachPoint="domNode" class="com-ibm-rqm-test-execution-machine-adapter-view">' +
	                '  <div dojoType="com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout" "noline"=true dojoAttachPoint="viewHeaderNode">' +
					'  </div>'+
					'    <div dojoAttachPoint="_tableViewerNode" class="com-ibm-rqm-test-artifact-table-view" tabindex="-1"> ' +
					'    </div>' +
					'</div>',

    widgetsInTemplate: true,
	allowMultiSelect: false,
    constructor: function(){
		//Expected to be supplied by the caller:
		//serverTime - the current time on the server - used to determine the state of the adapter
		//loadingCompleteCallback - Called when all the data is loaded into the table.
		//							returns the data that would show in the table
	},
	 
	postCreate: function(){
		this.inherited("postCreate", arguments);		
		this.results = null;
		this.theConfig = null;
		if(this.allowMultiSelect)
			this.selection = [];
		else
			this.selection={};
		this.theCatalog = new com.ibm.asq.common.web.client.internal.Catalog();
		this.initialLoad = true;  //Used to gate calls to the loadingComplete callback
		
        this.viewHeaderNode.setTitle(this.queryName);
		this.viewHeaderNode.setCSHelpId("rqm_adapter_console.html");
		this.viewHeaderNode.setCSHelpButtonLabel(Constants.getMessage("labelAdapterConsoleHelp"));

		//Create the table for showing the machines
		var tableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer({
            allowAdjustSettings: true,
            autoSaveSettings: true,
            sortByColumn: 3,
            sortDir: TableConstants.SORT_DIR_ASCEND,
            tableId: "RQM-EXE-MACH-ADAPTER-TABLEVIEWER"                                
        });
        
        this._tableViewerNode.appendChild(tableViewer.domNode);
        tableViewer.setContentPageSize(20);
		var tableProvider = new AdapterConsoleTableView.TableProvider();
		tableProvider.setServerTime(this.serverTime);
        tableViewer.setContentProvider(tableProvider);
        tableViewer.setTableListener(this);
		tableViewer.setTableRowsCheckable(true, /* isSingleSelect */false);
		tableViewer.setTableSummary(Constants.getMessage("labelTableSummary", Constants.getMessage("labelMachineAdapter")));
		var sorter = new AdapterConsoleTableView.Sorter();
		tableViewer.setSorter(sorter);
		var content = [];
		tableViewer.setContent(content);
        tableViewer.show();
		this.tableViewer = tableViewer;

        this.refreshAction = tableViewer.addAction("Refresh", Constants.getMessage("labelRefresh"), this, "refresh-icon-image", dojo.hitch(this, this.refreshMATV));
        var type = com.ibm.asq.common.web.client.internal.PermissionsClient.OP_ADAPTER;
        var perm = com.ibm.asq.common.web.client.internal.PermissionsClient.getStoredPermission(type);
        
        if (!perm || perm['delete']) {
            this.deleteAction = tableViewer.addAction("Delete", Constants.getMessage("labelDelete"), this, "delete-icon-image", dojo.hitch(this, this.deleteActionM));
            this.deleteAction.setDisabled(true);
        }

		this._loadTable();
	},
	
	//Here's how this goes.....
	//Start with all machines
	_loadTable: function(){
		//Load the machines
		this._loadMachines();
	},
	
	
	_loadMachines: function(config){
	   	var responseHandler = new ServiceResponseHandler(this, "_searchSuccess", "_searchError");
   	    config = this.theCatalog.createConfiguration("Machine"); 

		var searchParam = {configuration: config,
	                       columns: ( MACHINE_SEARCH_COLUMNS )
	                      };
	                this.theCatalog.search(responseHandler, searchParam);
	},
	
	_searchSuccess: function(response){
		//If no machines match then no sense continuing
		if (response == null || response.Data == null || response.Data.length == 0){
			this.tableViewer.setContent([]);
			this.tableViewer.refresh();
			//Perform the supplied callback to indicate loading is complete
			if (this.loadingCompleteCallback && this.initialLoad){
				this.initialLoad = false;
				this.loadingCompleteCallback([], this);
			}
		}else{
			//Save the data from this call.
			//Build objects out of each row in the response
			this.tableData = [];
			var len = response.Data.length;
			for (var i = 0; i < len; i++){
				var responseData = response.Data[i]; 
				if(responseData[0] && responseData[1]){
					var machineInfo = {};
					machineInfo.machineID = responseData[0];
					machineInfo.machineName = responseData[1];
					machineInfo.osName = responseData[1];
					this.tableData.push(machineInfo);					
				}	
			}
			var params = {};
			if(this.scriptType){
				params.type = this.scriptType;
			}
			var toolService = com.ibm.rqm.execution.web.client.internal.execution.ToolAdapterRegistrationClient;
			var responseHandler = new ServiceResponseHandler(this, "_searchAdapterSuccess", "_searchAdapterError");
			toolService.getAdaptersWithMachines(responseHandler, params);
		}
		this.stopInProgress();		
	},
	
	_searchError: function(response){
		//Perform the supplied callback to indicate loading is complete
		if (this.loadingCompleteCallback && this.initialLoad){
			this.initialLoad = false;
			this.loadingCompleteCallback([], this);
		}
		this.stopInProgress();
	},
	
	_searchAdapterSuccess:function(response){
		this.adapterData = response;
		this.mergedData = this._mergeAdapterDataWithMachines();
        this.tableViewer.setContent( this.mergedData );

        this.tableViewer.refresh();

		//Perform the supplied callback to indicate loading is complete
		if (this.loadingCompleteCallback && this.initialLoad){
			this.initialLoad = false;
			this.loadingCompleteCallback(this.mergedData, this);
		}
	},

	_searchAdapterError:function(response){
		//Perform the supplied callback to indicate loading is complete
		if (this.loadingCompleteCallback && this.initialLoad){
			this.initialLoad = false;
			this.loadingCompleteCallback([], this);
		}
	},
	

	
	_mergeAdapterDataWithMachines :function(){
		//Get the server time that was returned with the adapter data
		//We'll use that to show adapter availability
		if (this.adapterData != null && this.adapterData.length > 0){
			this.serverTime = this.adapterData[0].serverTime;
		}
		//Iterated over all the tableData which is the list of machines
		//Remove any machine from the list that is not in the adapter data
		//because that indicates that the machine is not running the necessary adapter
		//add the adapter info to the merged data for any matchine machine.
		this.mergedData = this.tableData;
		var resultData = [];
		var len = this.mergedData.length;
		for (var i = 0; i < len; i++){
			var mergedInstance = this.mergedData[i];
			var adapterArray = this._findAdaptersForMachine(mergedInstance.machineID, this.adapterData);
			if (adapterArray == null)  //no match for the machine so don't add it to the resulting merged data
				continue;
			//At least one adapter found for this machine
			//The adapter matches the machine so add the adapter info to this row
			var len2 = adapterArray.length;
			for (var j = 0; j < len2; j++){
				var resultInstance = this._cloneData(mergedInstance);
				resultInstance.adapterInfo = adapterArray[j];
				resultData.push(resultInstance);
			}
		}
		return resultData;
	},
	
	_findAdaptersForMachine: function(machineID, adapterData){
		if (machineID == null || adapterData == null)
			return null;
		var adapterArray = [];
		var len = adapterData.length;
		for (var i = 0; i < len; i++)
			if (adapterData[i].machine && adapterData[i].machine.itemId == machineID)
				adapterArray.push(adapterData[i]);
		return adapterArray;
	},

	getSelection :function(){
		return this.selection;
	},

	//Ideally should be in table listener
	rowCheckStateChanged: function(tableViewer, rowObject, state){
		if(this.deleteAction){
			if(tableViewer.getCheckedRows().length > 0)
				this.deleteAction.setDisabled(false);
			else
				this.deleteAction.setDisabled(true);
		}
		var selection = this.selection;
        if (state == true){
			if(this.allowMultiSelect){
				selection.push({
					machine:rowObject,machineID:rowObject.machineID,machineName:rowObject.machineName,adapter:rowObject.adapterInfo
				});
			}else{
				selection.machine = rowObject;
				selection.machineID = rowObject.machineID;
				selection.machineName = rowObject.machineName;
				selection.adapter = rowObject.adapterInfo;
			}
		}else{
			if(this.allowMultiSelect){
				var len = selection.length;
				for(var i=0;i<len;i++){
					if(selection[i].machineID == rowObject.machineID){
						selection.splice(i,1);
						break;
					}
				}
			}else{
				selection.machine = null;
				selection.machineID = null;
				selection.machineName = null;
				selection.adapterID = null;
				selection.adapter = null;
			}
		}
    },
	//Ideally should be in table listener
	tableContentActionInvoked: function(tableViewer, actionId, callbackData, callback){
        if (callback != null && dojo.isFunction(callback)) {
            if (callbackData != null) {
                callback(callbackData);
            } else {
                callback();
            }
        } 
    },
	
	//Methods for the callers to get selelcted info
	getSelectedAdapter: function(){
		return this.selection.adapter;
	},
	
	getSelectedInfo: function(){
		return this.selection;
	},
	
	//Return all the data that would show in the table
	getAllMachineAdapterInfo: function(){
		return(this.mergedData);
	},
	
	reInitialize: function(scriptType, configID, loadingCompleteCallback){
		this.scriptType = scriptType;
		this.configID = configID;
		this.loadingCompleteCallback = loadingCompleteCallback;
		this.initialLoad = true;
		this._loadTable();
	},
	
	refreshMATV: function(){
		this.reInitialize(this.scriptType, this.configID, this.loadingCompleteCallback);
		this.viewHeaderNode.clearStatus();
	},

	deleteActionM: function(){		
		var selectedItems = this.tableViewer.getCheckedRows();
		if (selectedItems && selectedItems.length >0 ){
			var messagespan = document.createElement("label");
            messagespan.innerHTML = Constants.getMessage("msgDeleteAdapter");
            var yesNoDialog = new com.ibm.asq.common.web.ui.internal.widgets.YesNoDialog({
				primaryTitle:Constants.getMessage("labelDelete")+" "+Constants.getMessage("labelAdapter"),
                yesCallback:dojo.hitch(this,"_deleteAdapter"),
                yesCallbackData:selectedItems,
				isClosable: true
            });
            yesNoDialog.contentContainer.appendChild(messagespan);
            yesNoDialog.open();
		}
	},
	_deleteAdapter:function(selectedItems){
		this.adaptersToDeleteCount = selectedItems.length;
		this.adaptersDeletedCount = 0;
		var toolService = com.ibm.rqm.execution.web.client.internal.execution.ToolAdapterRegistrationClient;
		var len = selectedItems.length;
		for(var i=0;i<len;i++){
			var params = { id: selectedItems[i].adapterInfo.id};
			var responseHandler = new ServiceResponseHandler(this, "_success", "_failure");
			toolService.postDelete(responseHandler, params);
		}
		
	},
	_success: function(object){
		this.adaptersDeletedCount++;
		if(this.adaptersDeletedCount == this.adaptersToDeleteCount){
			this.refreshMATV();
			this.deleteAction.setDisabled(true);
			this.viewHeaderNode.setStatus(Constants.getMessage("msgAdapterDeleteSuccess"),ViewHeaderLayout.INFO);
		}
	},
	
	_failure: function(object){
		this.adaptersDeletedCount++;
		if(this.adaptersDeletedCount == this.adaptersToDeleteCount){
			this.deleteAction.setDisabled(true);
			this.viewHeaderNode.setStatus(Constants.getMessage("msgAdapterDeleteFailed"),ViewHeaderLayout.ERROR,object.message);
		}
	},
	
	_cloneData:function(sourceObj){
		var destObject = {};
	    for (var i in sourceObj){
        	if (typeof sourceObj[i] == 'object'){
            	destObject[i] = this._cloneData(sourceObj[i]);
        	}else
            	destObject[i] = sourceObj[i];
    	}
		return destObject;
	},

 	setInProgress: function(msg) {
		this.viewHeaderNode.setProgressStart(msg);
	},
	
	stopInProgress: function() {
		this.viewHeaderNode.setProgressEnd();
	}
});

})();