/**BVTTable********************************************************************* 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.buildintegration.web.ui.internal.view.table.BVTTableView")
dojo.provide("com.ibm.rqm.buildintegration.web.ui.internal.view.table.BVTTableView");
 
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("jazz.core.loader");
dojo.require("com.ibm.rqm.buildintegration.web.ui.internal.BuildUiUtil");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
(function() {

var BuildUiUtil 			= com.ibm.rqm.buildintegration.web.ui.internal.BuildUiUtil;
var ServiceResponseHandler	= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;

dojo.declare("com.ibm.rqm.buildintegration.web.ui.internal.view.table.BVTTableView", 
    [dijit._Widget, dijit._Templated],
{    
    templateString: '<div><table width="30%"><tbody>'+ 
					'<tr><td><label class="name-label">${labelBVTResult}</label></td>'+
					'<td><b><label class="name-label" dojoAttachPoint="_BuildBVTResult"></label></b></td></tr>'+
					'<tr><td><label class="name-label">${labelTestsRun}</label></td>'+
					'<td><label class="name-label" dojoAttachPoint="_BuildTestsRun"></label></td></tr>'+
					'<tr><td><label class="name-label">${labelTestsPassed}</label></td>'+
					'<td><label class="name-label" dojoAttachPoint="_BuildTestsPassed"></label></td></tr>'+
					'</tbody></table>'+
					'<div dojoAttachPoint="_tableNode"'+
					'</div>'+
					'</div>',

	labelBVTResult : BuildUiUtil.getMessage("labelBVTResult"),
	labelTestsRun : BuildUiUtil.getMessage("labelTotalTestRun"),
	labelTestsPassed : BuildUiUtil.getMessage("labelTotalPassed"),
	parentController:null,
	tableLoaded: false,
	clientLoaded: false,
	
    constructor: function(args) {
		this.parentController = args.parentController;
	 },

    postCreate: function(){
		if(this.tableLoaded)
			this._loadedSection();
		else
			jazz.core.loader.load_async("com.ibm.rational.test.lm.sequencer.web.ui.internal.view.table.SequenceResultStepsTableView", dojo.hitch(this, "_loadedSection"));
    },
	
	_loadedSection: function(){
		this.tableLoaded = true;
		dojox.data.dom.removeChildren(this._tableNode);
		this.tableViewer = new com.ibm.rational.test.lm.sequencer.web.ui.internal.view.table.SequenceResultStepsTableView({parentSection:this});
		this.tableViewer.initialize({});
		this._tableNode.appendChild(this.tableViewer.domNode);
		if(this.clientLoaded)
			this._loadedClient();
		else
			jazz.core.loader.load_async("com.ibm.rational.test.lm.sequencer.web.client.internal.sequence.SequenceClient", dojo.hitch(this, "_loadedClient"));
	},

	_loadedClient: function(){
		this.clientLoaded = true;
		if(this.buildRecord){
			var args = {buildRecordItemId: this.buildRecord.itemId, onlyLatestResult: true};
			var responseHandler = new ServiceResponseHandler(this, "fillData", "_error");
			com.ibm.rational.test.lm.sequencer.web.client.internal.sequence.SequenceClient.getExecutionSequenceResultsDTO(responseHandler, args);
		}	
	},
	
	fillData: function(results){
		if(results && results.length > 0){
			this.result = results[0];
			this._BuildBVTResult.innerHTML = this.result.result;
			var stepCount = this.result.stepResults ? this.result.stepResults.length: 0;
			this._BuildTestsRun.innerHTML = stepCount;
			var passCount = 0;
			for(var i=0;i<stepCount; i++){
				if(this.result.stepResults[i].resultState == "PASS"){
					passCount++;
				}
			}
			this._BuildTestsPassed.innerHTML = passCount;
			this.tableViewer.initialize(this.result);
		}
	},
	
	_error: function(err){
		console.error("Error in BVTTableView " + err.message);
	}
});

})();
