/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.execution.web.ui.internal.view.table.BlockingPopUpDefectTableView");
 
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

 dojo.require("com.ibm.rqm.execution.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.properties.DefectView");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.rqm.defects.web.client.ChangeRequestManager");
dojo.require("com.ibm.rqm.defects.web.ui.workitems.WorkItemSelectionDialog");
dojo.require("com.ibm.team.repository.web.foundation.NullProgressMonitor");
dojo.require("com.ibm.rqm.defects.web.ui.view.common.ProgressDialog");
dojo.require("com.ibm.rqm.defects.web.ui.utils.WindowUtil");
dojo.require("com.ibm.rqm.defects.web.ui.view.common.RichHoverCellRenderer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.common.NewDefectDataInitializer");

dojo.require("com.ibm.rqm.defects.web.helper.RemoteItemPicker");
dojo.require("com.ibm.rqm.defects.web.util.ItemPickerUtil");
dojo.require("com.ibm.rqm.defects.web.client.internal.CmIntegrationClient");
dojo.require("com.ibm.rqm.defects.web.util.RichHoverUtil");
dojo.require("com.ibm.asq.common.web.ui.internal.util.CSHelp");

dojo.require("com.ibm.rqm.defects.web.ui.internal.LinksTableView");

(function() {

var TableConstants 	= com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;
var AlertDialog 	= com.ibm.asq.common.web.ui.internal.widgets.AlertDialog;
var Utility        	= com.ibm.rqm.execution.web.ui.internal.util.Utility;
var Constants      	= com.ibm.rqm.planning.web.client.internal.Constants;
var ImageCache		= com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
var DEFECT_URL		= "#action=com.ibm.team.workitem.viewWorkItem&id=";
var DefectView		= com.ibm.rqm.planning.web.ui.internal.view.construction.properties.DefectView;//Need DV here since same table used in EWIListing
var ChangeRequestManager 			= com.ibm.rqm.defects.web.client.ChangeRequestManager;
var WorkItemSelectionDialog			= com.ibm.rqm.defects.web.ui.workitems.WorkItemSelectionDialog;
var NullProgressMonitor				= com.ibm.team.repository.web.foundation.NullProgressMonitor;
var ProgressDialog					= com.ibm.rqm.defects.web.ui.view.common.ProgressDialog;
var WindowUtil						= com.ibm.rqm.defects.web.ui.utils.WindowUtil;
var NewDefectDataInitializer        = com.ibm.rqm.execution.web.ui.internal.view.common.NewDefectDataInitializer;
var RemoteItemPicker				= com.ibm.rqm.defects.web.helper.RemoteItemPicker;
var ItemPickerUtil					= com.ibm.rqm.defects.web.util.ItemPickerUtil;
var CmIntegrationClient				= com.ibm.rqm.defects.web.client.internal.CmIntegrationClient;
var RichHoverCellRenderer			= com.ibm.rqm.defects.web.ui.view.common.RichHoverCellRenderer;
var RichHoverUtil					= com.ibm.rqm.defects.web.util.RichHoverUtil;
var CSHelp 							= com.ibm.asq.common.web.ui.internal.util.CSHelp;

dojo.declare("PopUpDefectTableView.TableListener", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableListener,
{
	constructor: function(view){
		this.parentView = view;
	},
    rowCheckStateChanged: function(tableViewer, rowObject, state){
		var selectionCount = tableViewer.getCheckedRows().length;
		var p = this.parentView; 
        if (p.changeStatusActionNode){
			if(selectionCount > 0){
				p.deleteActionNode.setDisabled(false);
			}	
			else{
				p.deleteActionNode.setDisabled(true);
			}
			if(selectionCount != 1 || rowObject.statusId == 5)
            	p.changeStatusActionNode.setDisabled(true);
			else
				p.changeStatusActionNode.setDisabled(false);
		}
    },
    groupRowsCheckStateChanged: function(tableViewer, rowObjects, state){
        this.rowCheckStateChanged(tableViewer, rowObjects, state);
    },
    tableContentActionInvoked: function(tableViewer, actionId, callbackData, callback){
		if (callback != null && dojo.isFunction(callback)) {
            if (callbackData != null) {
                callback(callbackData);
            } else {
                callback();
            }
        } 
    } 
});

dojo.declare("PopUpDefectTableView.TableProvider", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider,
{
    getNumColumns: function(content){
        if(ChangeRequestManager.INIT_INITIALIZED){
			return 3;
		}else{
			return 4;
		}
    },
    
    _columnHeadings: [
        Constants.getMessage("labelBlockingStatus"),
        Constants.getMessage("labelId"),
        Constants.getMessage("labelSummary"),
        Constants.getMessage("labelState")
    ],
    
    getColumnHeading: function(content, index){
        return this._columnHeadings[index];
    },
    getColumnHeadingImage: function(content, atColumnIndex){
        return null;
    },
    getColumnHeadingAlignment: function(atColumnIndex){
        return this.getCellAlignment(null, atColumnIndex);
    },
    getIsColumnGroupable: function(content, atColumnIndex){
        return false;
    },
    getIsColumnSortable: function(content, atColumnIndex){
        return false;   
    },

    getColumnWidth: function(content, atColumnIndex){
        if(ChangeRequestManager.INIT_INITIALIZED){
			switch(atColumnIndex) {
	            case 0: 
	                return 20;
	            case 1: 
	                return 20;
	            case 2: 
	                return 60;
	        }
		}else{
			switch(atColumnIndex) {
	            case 0: 
	                return 20;
	            case 1: 
	                return 15;
	            case 2: 
	                return 40;
	            case 3: 
	                return 25;		 
	        }
		}
        return 0;
    },
    getContentObjects: function(content){
        return content;
    },    
    getRowDataId: function(rowData){
        return "_table_row_for_defect_" + (rowData.uri ? rowData.uri : rowData.id);
    },
    getCellDisplayType: function(rowData, atColumnIndex){
        var type = TableConstants.RENDER_TYPE_TEXT;
        switch(atColumnIndex) {
            case 0: 
                type = TableConstants.RENDER_TYPE_IMAGE;
                break;
			case 1: 
				if(ChangeRequestManager.INIT_INITIALIZED) {
					type = "RENDER_TYPE_RICHHOVERLINK";
				} else {
					type = TableConstants.RENDER_TYPE_LINK;
				}
                break;						 
        }
        return type;
    },
    getCellAlignment: function(rowData, atColumnIndex){
        if(atColumnIndex == 0)
            return TableConstants.ALIGN_CENTER;
        return TableConstants.ALIGN_LEFT;
    },
    getCellDisplayData: function(rowData, atColumnIndex){
        var val = "";
        switch(atColumnIndex) {
            case 0: 
                val = rowData.isBlocking;
                break;
            case 1: 
                val = rowData.id;
                break;
            case 2: 
                val = Utility._restoreTags(rowData.summary);
                break;   
            case 3: 
				val = rowData.status;
                break;  
        }
        return val;
    },
    getCellDisplayExtendedInfo: function(rowData, atColumnIndex){
        var val = null;  
        if (atColumnIndex == 0) {
           val = {};
			  val.image = rowData.isBlocking ? ImageCache.BLOCKING_DEFECT: ImageCache.NOIMAGE; 
			  val.tooltip = "";
		  }
		 if (atColumnIndex == 1) {
           val = {};
		   if(ChangeRequestManager.INIT_INITIALIZED){
				val.workItemUri = RichHoverUtil.getWorkItemUri(rowData.uri);
				val.workItemPresentationUri = RichHoverUtil.getWorkItemPresentationUri(rowData.uri);
				val.label = rowData.id;
				val.onclick = dojo.hitch(this, function(){
					WindowUtil.openArtifactInNewWindow(rowData.uri);
				});
		   }else if(this.popup && dojo.isFunction(this.popup._closePopupDialog)){
		   		val.onclick = dojo.hitch(this, function(){
					this.popup._closePopupDialog();					
					window.location.href = DEFECT_URL + rowData.id;
				});
		   }
		   else{
		   		val.href = DEFECT_URL + rowData.id; 
		   }
		  } 		  
        return val;
    }
});

dojo.declare("com.ibm.rqm.execution.web.ui.internal.view.table.BlockingPopUpDefectTableView", 
    [dijit._Widget, dijit._Templated],
{    
    templateString: '<div dojoAttachPoint="_tableViewerNode" class="com-ibm-rqm-test-artifact-table-view" tabindex="-1">' +
						  '</div>',

    widgetsInTemplate: true,
    constructor: function() {
	 },

    postCreate: function() {
        this.inherited("postCreate", arguments);
		ChangeRequestManager.getInstance().getServiceProviders(dojo.hitch(this, function(providers){
	        var tableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer();  
			tableViewer.registerCellRenderer("RENDER_TYPE_RICHHOVERLINK", new RichHoverCellRenderer());      
	        this._tableViewerNode.appendChild(tableViewer.domNode);
			          
	        var content = this.defects ? this.defects : [];
	        tableViewer.setContentPageSize(5);
	        tableViewer.setContent(content);
			var tableProvider = null;
			if (providers && providers.length > 0) {
				tableProvider = new com.ibm.rqm.defects.web.ui.internal.LinksTableProvider()
			}  else {
				tableProvider = new PopUpDefectTableView.TableProvider();
			}
			tableProvider.popup = this.parentEditor;
	        tableViewer.setContentProvider(tableProvider);
	        tableViewer.setTableListener(new PopUpDefectTableView.TableListener(this));
			tableViewer.setTableRowsCheckable(true, /* isSingleSelect */false);
			tableViewer.setTableSummary(Constants.getMessage("labelTableSummary", Constants.getMessage("labelDefects")));
	        tableViewer.show();
			this.actions = this.getTableActions();
			var len = this.actions ? this.actions.length : 0;
			for (var i = 0; i < len; i++) {
	            var action = this.actions[i];
	            var actionButton = tableViewer.addAction(action.actionId, action.label, null, action.iconClass, action.actionHandler);
	            if (action.disabled && action.disabled == true)
	                actionButton.setDisabled(true);
				if(action.actionId == "newdefect"){
					this.addNewActionNode = actionButton;
				}else if(action.actionId == "adddefect"){
					this.addExistingActionNode = actionButton;
				}else if(action.actionId == "changestatus"){
					this.changeStatusActionNode = actionButton;
				}else if(action.actionId =="remove"){
					this.deleteActionNode = actionButton;
				}	
	        }
		this.tableViewer = tableViewer;
		}));
    },
	
	setContent: function(content){
		var newContent = content ? content : [];
		this.tableViewer.setContent(newContent);
		this.tableViewer.refresh();
		if(this._defectView){
			this._defectView.defectList = [];
		}
	},
	
	getContent: function(){
		return this.tableViewer.getContent();
	},
	
	getTableActions: function(){
		var actions = [];       
            actions.push({
                actionId: "newdefect",
                label: Constants.getMessage("labelAddNewDefect"),
                actionHandler: dojo.hitch(this, "onCreateNewDefect"),
                iconClass: "new-defect-icon-image",
				disabled: false                  
            });
            actions.push({
                actionId: "adddefect",
                label: Constants.getMessage("labelAddExistingDefect"),
                actionHandler: dojo.hitch(this, "onAddDefect"),
                iconClass: "add-defect-icon-image",
                disabled: false              
            });
			actions.push({
                actionId: "changestatus",
                label: Constants.getMessage("labelChangeStatus"),
                actionHandler: dojo.hitch(this, "onChangeStatus"),
                iconClass: "change-blocked-defect-status-icon-image",
                disabled: true              
            });
			actions.push({
                actionId: "remove",
                label: Constants.getMessage("labelRemove"),
                actionHandler: dojo.hitch(this, "onRemove"),
                iconClass: "delete-icon-image",
                disabled: true              
            });
			return actions;
	},
	
	onRemove: function(){
		ChangeRequestManager.getInstance().getCurrentServiceProvider(dojo.hitch(this, function(currentProvider){
            if (currentProvider != null){
				this._unBlockDefectViaProvider();
			} else {
				var defects = this.tableViewer.getCheckedRows();
				var len = defects.length;
				var p = this.parentEditor;
				for(var i=0;i<len;i++){
					var defect = defects[i];
					if(dojo.isFunction(p._updateDefectStatus)){
						//remove is the same as unlinking the TER blocking with the TER.
						p._updateDefectStatus(defect.id,false/*removeDefect from blocking list*/);
					}
				}	
			}
        }));
	},
	
	onCreateNewDefect: function(){
		this._defectIconClicked("new",Constants.getMessage("labelAddNewDefect"));
	},
	
	onAddDefect: function(){
		this._defectIconClicked("existing",Constants.getMessage("labelAddExistingDefect"));
	},
	
	_defectIconClicked: function(contextMenuSelection, title){
		ChangeRequestManager.getInstance().getCurrentServiceProvider(dojo.hitch(this, function(currentProvider){
            if (currentProvider != null){
				this._dispatchDefectActionViaProvider(contextMenuSelection, currentProvider);
			} else {
				this._defectIconClicked2(contextMenuSelection,title);
			}
        }));
	},
	
	_dispatchDefectActionViaProvider: function(contextMenuSelection, currentProvider) {
		if (!contextMenuSelection || contextMenuSelection == "new") {
			this._addNewDefectViaPicker(currentProvider);
		} else if (contextMenuSelection == "existing") { 
			this._addExistingDefectViaPicker(currentProvider);
		} 
	},
	
	_addNewDefectViaPicker: function(currentProvider){
		var self = this;
		var desc;
		if(this.ewis.length == 1){
			var ewi = this.ewis[0];
			desc = (ewi.name && ewi.name != ewi.testCase.name) ? Constants.getMessage("labelFailingTestCaseWithEWI", ewi.testCase.name, ewi.name) : Constants.getMessage("labelFailingTestCaseWithoutEWI", ewi.testCase.name);
		}else{
			desc = Constants.getMessage("labelFailingRQMTestcase");
		}

    	var creationUrl = null;
        if (currentProvider.providerUris.defaultCreationDialogURI.indexOf("?") > -1) {
           	creationUrl = currentProvider.providerUris.defaultCreationDialogURI + "&" + ItemPickerUtil.getWICreationDialogParamString(desc, desc);
        } else {
			creationUrl = currentProvider.providerUris.defaultCreationDialogURI;	
		}		

		var params= {
            dialogTitle: Constants.getMessage("labelAddNewDefect"),
            secondaryTitle: " ",
			pickerURL: creationUrl,
			height: currentProvider.providerUris.creationDialog.height,
			width: currentProvider.providerUris.creationDialog.width,
			parentElement: this.domNode,
			onOk: dojo.hitch(this, function(result) {
				var workItems = currentProvider.linkType == ChangeRequestManager.PROVIDER_LINK_TYPE_CQREST ? ItemPickerUtil.parseFromCQ(result) : ItemPickerUtil.parseFromRTC(result);
				if (workItems.length > 0) {
					var workItem = workItems[0];
					
					var ewis = this.ewis;
					var counter = 0;
					var associateDefect = dojo.hitch(this, function(monitor, currentProvider){
						if (counter == ewis.length) {
							monitor.done();
							this._postLinkToTER(ewis, workItem);
							return;
						}
						else {
							var linkDescription = {};
							linkDescription.url = workItem.url;
		                    linkDescription.linkComment = (ewis[counter].name && ewis[counter].name != ewis[counter].testCase.name) ? Constants.getMessage("labelFailingTestCaseWithEWI", ewis[counter].testCase.name, ewis[counter].name) : Constants.getMessage("labelFailingTestCaseWithoutEWI", ewis[counter].testCase.name);
		                    linkDescription.rqmUrl = this._getEwiUri(ewis[counter]);
		                    linkDescription.linkType = ChangeRequestManager.LINK_TYPE_BLOCK_ER;
							currentProvider.postLink(linkDescription, dojo.hitch(this, function(status, draftLinkParams){
								counter++;
								associateDefect(monitor, currentProvider);
							}));
						}
					});
					ProgressDialog.doRunWithProgress(Constants.getMessage("labelCreatedefect"), dojo.hitch(this, function(monitor){
						ChangeRequestManager.getInstance().getCurrentServiceProvider(dojo.hitch(this, function(currentProvider){
	                        if(currentProvider != null){
								associateDefect(monitor, currentProvider);
							}
	                    }));
					}));
				}
			}),
			onClose: function() {
			    console.debug("close!");
			}

        };	            
        new RemoteItemPicker(params);
	},
	
	_addExistingDefectViaPicker: function(currentProvider){
		var self = this;
		var defectSelectionDialog = currentProvider.services.getSelectionDialog("defect", true);
		var params= {
            dialogTitle: Constants.getMessage("labelAddExistingDefect"),
            secondaryTitle: " ",
			pickerURL: defectSelectionDialog.uri,
			height: defectSelectionDialog.height,
			width: defectSelectionDialog.width,
			parentElement: this.domNode,
			onOk: dojo.hitch(this, function(result) {
				var workItems = currentProvider.linkType == ChangeRequestManager.PROVIDER_LINK_TYPE_CQREST ? ItemPickerUtil.parseFromCQ(result) : ItemPickerUtil.parseFromRTC(result);
				if (workItems.length > 0) {
					var workItem = workItems[0];
					var ewis = this.ewis;
					var counter = 0;
					var associateDefect = dojo.hitch(this, function(monitor, currentProvider){
						if (counter == ewis.length) {
							monitor.done();
							this._postLinkToTER(ewis, workItem);
							return;
						}
						else {
							var linkDescription = {};
							linkDescription.url = workItem.uri || workItem.url;
		                    linkDescription.linkComment = (ewis[counter].name && ewis[counter].name != ewis[counter].testCase.name) ? Constants.getMessage("labelFailingTestCaseWithEWI", ewis[counter].testCase.name, ewis[counter].name) : Constants.getMessage("labelFailingTestCaseWithoutEWI", ewis[counter].testCase.name);
		                    linkDescription.rqmUrl = this._getEwiUri(ewis[counter]);
		                    linkDescription.linkType = ChangeRequestManager.LINK_TYPE_BLOCK_ER;
							
							currentProvider.postLink(linkDescription, dojo.hitch(this, function(status, draftLinkParams){
								counter++;
								associateDefect(monitor, currentProvider);
							}));
						}
					});
					ProgressDialog.doRunWithProgress(Constants.getMessage("labelAssociateDefect"), dojo.hitch(this, function(monitor){
						ChangeRequestManager.getInstance().getCurrentServiceProvider(dojo.hitch(this, function(currentProvider){
	                        if(currentProvider != null){
								associateDefect(monitor, currentProvider);
							}
	                    }));
					}));
				}
			}),
			onClose: function() {
			}

        };	            
        new RemoteItemPicker(params);
	},
	
	_postLinkToTER: function(ewis, workItem){
		//Post local link to TER
		var i = 0;
		var postLinkToTER = dojo.hitch(this, function(monitor){
			if (i == ewis.length) {
				monitor.done();
				this.parentEditor.showDefects();
				return;
			}else{
				var linkParams = {
					itemId: ewis[i].itemId,
					cmUri: workItem.url,
					summary: workItem.summary,
					linkType: CmIntegrationClient.EWI_BLOCKING_DEFECT
				};
				CmIntegrationClient.postNewLink(linkParams, dojo.hitch(this, function(status){
					i++;
					postLinkToTER(monitor);
                }));
			}
		});
		ProgressDialog.doRunWithProgress("Associating Defect with Test Execution Record", dojo.hitch(this, function(monitor){
			postLinkToTER(monitor);
		}));
	},
	
	_getEwiUri: function(ewi) {
		var result= window.location.protocol + "//" + window.location.hostname + ":" + window.location.port;
		result+= window.location.pathname.match(/(.*)\/web\/console\/[^\/]*$/)[1];
		result+= "/resource/itemOid/com.ibm.rqm.execution.ExecutionWorkItem/" + ewi.itemId;
		return result;
	},
	
	_defectIconClicked2: function(contextMenuSelection, title){
		this._defectView = new DefectView({parentEditor: this.pageEditor});
		this.addNewActionNode.setDisabled(true);
		this.addExistingActionNode.setDisabled(true);
		var dialogArgs = {
			primaryTitle: title,
            isClosable: true,
			showActions:false,
			style: "z-index: 997;",
			zIndex: 997,//keep below 1000 for datepicker to show
			onClose: dojo.hitch(this, function(){
				this.addNewActionNode.setDisabled(false);
				this.addExistingActionNode.setDisabled(false);
				//ELB
				if(dojo.isFunction(this.parentEditor._appendInDefectList)){
					this.parentEditor._appendInDefectList(this._defectView.defectList,contextMenuSelection);
				}
			})
		}
		    
        this._defectsViewer = new com.ibm.asq.common.web.ui.internal.widgets._CommonDialog(dialogArgs);
		this._defectsViewer.blockerDiv.style.zIndex = 998;
		this._defectView.setParentDialog(this._defectsViewer);
		this._defectsViewer.contentContainer.appendChild(this._defectView.domNode);
        // this is a opening a new defect, get the initial seed values for the form.
        // Don't open the form until we've fetched all related data.
        if (contextMenuSelection == "new") {
            NewDefectDataInitializer.getDefectSeedValuesFromEWI(this.ewis[0], dojo.hitch(this, "_initNewDefectForm"));
			var cshelp = new CSHelp({contextID: "rqm_add_new_def.html"});
			cshelp.setButtonLabel(Constants.getMessage("labelAddNewDefectHelp"));
			this._defectsViewer.setSecondaryTitleNode(cshelp.domNode);
        }
        else {
            this._defectView.setViewType(contextMenuSelection);
			var cshelp = new CSHelp({contextID: "rqm_add_exist_def.html"});
			cshelp.setButtonLabel(Constants.getMessage("labelAddExistingDefectHelp"));
			this._defectsViewer.setSecondaryTitleNode(cshelp.domNode);
            this._defectsViewer.open();
            this._defectsViewer.setWidth('800px');
        }
	},

    _initNewDefectForm: function(seedValues) {
        this._defectView.setViewType("new", seedValues);    
        this._defectsViewer.open();
        this._defectsViewer.setWidth('800px');
    },
    
	
	onChangeStatus: function(){
		ChangeRequestManager.getInstance().getCurrentServiceProvider(dojo.hitch(this, function(currentProvider){
            if (currentProvider != null){
				this._unBlockDefectViaProvider();
			} else {
				this.onChangeStatus2();
			}
        }));
	},
	
	_unBlockDefectViaProvider: function(){
		var defects = this.tableViewer.getCheckedRows();
		var ewis = this.ewis;
		var counter = 0;
		if(dojo.isArray(defects) && defects.length > 0) { 
			var workItem = defects[0];
			var changeBlockStatus = dojo.hitch(this, function(monitor, currentProvider){
				if(counter == ewis.length){
					this._deleteLinkToTER(monitor);
					return;
				} else {
					var linkDescription = {};
					linkDescription.url = workItem.uri;
	                linkDescription.rqmUrl = this._getEwiUri(ewis[counter]);
	                linkDescription.linkType = ChangeRequestManager.LINK_TYPE_BLOCK_ER;
	                currentProvider.deleteLink(linkDescription, dojo.hitch(this, function(status, response){
	                    if (status.isOK()) {
	                        console.debug("remove back link succeed");
							counter++;
							changeBlockStatus(monitor, currentProvider);
	                    }
	                    else {
	                        console.debug("remove link error");
	                    }
	                }));
				}
			});
			ProgressDialog.doRunWithProgress(Constants.getMessage("labelUnBlockDefect"), dojo.hitch(this, function(monitor){
				ChangeRequestManager.getInstance().getCurrentServiceProvider(dojo.hitch(this, function(currentProvider){
                    if(currentProvider != null){
						changeBlockStatus(monitor, currentProvider);
					}
                }));
			}));
		}
	},
	
	_deleteLinkToTER: function(monitor){
		var defects = this.tableViewer.getCheckedRows();
		
		var ewis = this.ewis;
		var counter = 0;
		var changeBlockStatus = dojo.hitch(this, function(monitor){
			if(counter == ewis.length){
				monitor.done();
				this.parentEditor.showDefects();
				return;
			}else{
				var draftLinkParams= {
					defectURI: defects[0].uri,
					ewiItemId: ewis[counter].itemId,
					isBlocked: false
				};
				
				CmIntegrationClient.postBlockDefect(draftLinkParams, dojo.hitch(this, function(status, draftItemUri, draftLinkParams){
	                if (status.isOK()) {
						counter++;
						changeBlockStatus(monitor);
	                }
	                else 
	                    if (status.getSeverity() != Status.CANCEL) {
	                        status.log();
	                    }
	            }));
			}
		});
		changeBlockStatus(monitor);
	},
	
	onChangeStatus2: function(){
		var defects = this.tableViewer.getCheckedRows();
		var defect = defects[0];
		var blocking = true;
		if(defect.isBlocking)
			blocking = false;
		if(dojo.isFunction(this.parentEditor._updateDefectStatus)){
			this.parentEditor._updateDefectStatus(defect.id,blocking);
		}
	},
	
	getSelectedRows: function() {
	     return this.tableViewer.getCheckedRows();
 	},
	
	_displayAlertDialog: function(message){
        var alertDialog = new AlertDialog({
            'message': message
        });
        alertDialog.open();
    }
});
})();
