/**BuildTable***************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.buildintegration.web.ui.internal.view.table.BuildDefTableView")
dojo.provide("com.ibm.rqm.buildintegration.web.ui.internal.view.table.BuildDefTableView");
 
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");
dojo.require("com.ibm.rqm.buildintegration.web.ui.internal.BuildUiUtil");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableListener");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
(function() {

var TableConstants 		= com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;
var BuildUiUtil			= com.ibm.rqm.buildintegration.web.ui.internal.BuildUiUtil;
var CommonImageCache		= com.ibm.asq.common.web.ui.internal.view.common.ImageCache;

dojo.declare("BuildDefTableView.TableListener", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableListener,
{
    rowCheckStateChanged: function(tableViewer, rowObject, state)
    {},
	tableContentActionInvoked: function(tableViewer, actionId, callbackData, callback){                
        if (callback == null && callbackData != null && dojo.isFunction(callbackData))
            callbackData();		
		if (callback != null && dojo.isFunction(callback)) {
            if (callbackData != null)
                callback(callbackData);
            else
                callback();
        } 
    }
});
dojo.declare("BuildDefTableView.TableProvider", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider,
{
    getNumColumns: function(content){
        return 4;
    },
    
    _columnHeadings: [
		"",
        BuildUiUtil.getMessage("labelStatus"),
		BuildUiUtil.getMessage("labelBuild"),
		BuildUiUtil.getMessage("labelDescription")
    ],
    
    getColumnHeading: function(content, index){
        return this._columnHeadings[index];
    },
    getColumnHeadingImage: function(content, atColumnIndex){
        return null;
    },
    getColumnHeadingAlignment: function(atColumnIndex){
        return this.getCellAlignment(null, atColumnIndex);
    },	 
    getIsColumnGroupable: function(content, atColumnIndex){
	 	  return (atColumnIndex == 2||atColumnIndex == 3);
    },
    getIsColumnSortable: function(content, atColumnIndex){
        return (atColumnIndex == 2||atColumnIndex == 3);  
    },

    _columnWidths: [10,30,30,30],

    getColumnWidth: function(content, atColumnIndex){
        return this._columnWidths[atColumnIndex];
    },
    
    getContentObjects: function(content){
        return content;
    },
    
    getRowDataId: function(rowData){
        return "build_def_table_row_" + rowData.id;
    },
   
    getCellDisplayType: function(rowData, atColumnIndex){
        var type = TableConstants.RENDER_TYPE_TEXT;
		if (atColumnIndex == 1) {
			if (rowData.state) {
				if (rowData.state.stateId == "com.ibm.rqm.buildintegration.buildstatus.inprogress" || rowData.state == "In Progress") 
					return type;
				else if (rowData.state.stateId == "com.ibm.buildintegration.common.states.unassigned" || rowData.state == "Unassigned") 
						return type;
				else 
					type = TableConstants.RENDER_TYPE_IMAGE;
			}else
				return type;
		}else if (atColumnIndex == 2) {
			return TableConstants.RENDER_TYPE_LINK;
		}
        return type;
    },

    getCellAlignment: function(rowData, atColumnIndex){
        return TableConstants.ALIGN_LEFT;
    },
    
    getCellDisplayData: function(rowData, atColumnIndex){
		var val = "";
		switch (atColumnIndex) {
			case 1:
				val = rowData.state? BuildUiUtil.getDisplayName(rowData.state.stateId,rowData.state.displayName):"";
				break;
			case 2:
				val = rowData.name || "";
				break;
			case 3:
				val = rowData.description || "";
				break;
		}
        return val;				       
    },
    getCellDisplayExtendedInfo: function(rowData, atColumnIndex){  
        var val = {};
		switch(atColumnIndex){
			case 1:
				if(rowData.state && (rowData.state.stateId == "com.ibm.rqm.buildintegration.buildstatus.ok" || rowData.state == "OK")){
					val.image = CommonImageCache.PASS_ICON
					val.tooltip = BuildUiUtil.getMessage("msgBuildState", BuildUiUtil.getMessage("labelOK"));
				}else if(rowData.state && (rowData.state.stateId == "com.ibm.rqm.buildintegration.buildstatus.error" || rowData.state == "Error")){
					val.image = CommonImageCache.ERROR_ICON;
					val.tooltip = BuildUiUtil.getMessage("msgBuildState", BuildUiUtil.getMessage("labelError"));
				}else
					val.image = CommonImageCache.NOIMAGE;
				break;
			case 2:
				val.href = BuildUiUtil.getBuildDefURI(rowData.id);
		}
        return val;
    }
    
});

dojo.declare("com.ibm.rqm.buildintegration.web.ui.internal.view.table.BuildDefTableView", 
    [dijit._Widget, dijit._Templated],
{    
    templateString: '<div dojoAttachPoint="_tableViewerNode" class="com-ibm-rqm-test-artifact-table-view" tabindex="-1">' +
                    '</div>',

    widgetsInTemplate: false,
    constructor: function() {
	 },

    postCreate: function(){
		this.tableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer({autoSaveSettings:true,allowAdjustSettings:true});
		this.tableViewer.tableId = "RQM-BUILD-DEF-TABLEVIEWER";
        this._tableViewerNode.appendChild(this.tableViewer.domNode);	
        this.tableViewer.setContentPageSize(20);
        this.tableViewer.setContentProvider(new BuildDefTableView.TableProvider());
		this.tableViewer.setTableListener(new BuildDefTableView.TableListener());
		this.tableViewer.setTableSummary(BuildUiUtil.getMessage("labelTableSummary", BuildUiUtil.getMessage("labelAllBuildDefs")));
        this.tableViewer.setTableRowsCheckable(false, false);
		this.refreshBtn = this.tableViewer.addAction("refresh", BuildUiUtil.getMessage("labelRefresh"), 
					this, "refresh-icon-image", dojo.hitch(this, "refresh"));
		this.setContent(this.builds);
    },
	show:function(){
		this.tableViewer.show();
	},
	getSelectedRows:function(){
		return this.tableViewer.getCheckedRows();
	},
	setContent:function(content){
		this.builds = content? content:[];
		this.tableViewer.setContent(this.builds);	
	},
	refresh:function(){
		this.refreshBtn.setDisabled(true);
		this.parentController.initialize();
	},
	refreshTable:function(content){
		this.setContent(content);
		this.tableViewer.refresh();
		this.refreshBtn.setDisabled(false);
	}
	});

})();
