/**BuildTable***************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.buildintegration.web.ui.internal.view.table.BuildTableView")
dojo.provide("com.ibm.rqm.buildintegration.web.ui.internal.view.table.BuildTableView");
 
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableSorter");
dojo.require("com.ibm.rqm.buildintegration.web.ui.internal.BuildUiUtil");
dojo.require("com.ibm.rqm.buildintegration.web.ui.internal.view.build.ImageCache");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");

(function() {

var TableConstants 			= com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;
var BuildUiUtil				= com.ibm.rqm.buildintegration.web.ui.internal.BuildUiUtil;
var ImageCache				= com.ibm.rqm.buildintegration.web.ui.internal.view.build.ImageCache;
var CommonImageCache		= com.ibm.asq.common.web.ui.internal.view.common.ImageCache;

dojo.declare("BuildTableView.TableListener", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableListener,
{
	constructor: function(parentView) {
        this.parentView = parentView;
    },
    rowCheckStateChanged: function(tableViewer, rowObject, state){
		var selectionCount = tableViewer.getCheckedRows().length;
        if (this.parentView.deleteActionNode && this.parentView.editable)
            this.parentView.deleteActionNode.setDisabled(selectionCount == 0);
		//if table view has a rowCheckListener, invoke it
        var p = this.parentView;
        if (p && p.rowCheckedListener && dojo.isFunction(p.rowCheckedListener) && p.editable) {
            p.rowCheckedListener(rowObject, state);
        }	
		
	},
	tableContentActionInvoked: function(tableViewer, actionId, callbackData, callback){                
        if (callback == null && callbackData != null && dojo.isFunction(callbackData))
            callbackData();		
		if (callback != null && dojo.isFunction(callback)) {
            if (callbackData != null)
                callback(callbackData);
            else
                callback();
        } 
    }
});
dojo.declare("BuildTableView.Sorter",
			com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableSorter,
{
	_sortComparator: function(obj1, obj2){
		if(this.sortCol >-1 && this.sortCol == 4){
			if (this.sortDir == TableConstants.SORT_DIR_ASCEND) {
				if(obj1.buildRecord && obj2.buildRecord)
					return dojo.date.compare(obj1.buildRecord.endTime, obj2.buildRecord.endTime);
				else
					return dojo.date.compare(obj1.endTime, obj2.endTime);
			}else {
				if(obj1.buildRecord && obj2.buildRecord)
					return dojo.date.compare(obj2.buildRecord.endTime, obj1.buildRecord.endTime);
				else
					return dojo.date.compare(obj2.endTime, obj1.endTime);
			}
		}
		else 
			return this.inherited("_sortComparator",arguments);
	},
	_groupComparator: function(obj1, obj2){
		var val1 = this.viewer.getContentProvider().getCellDisplayData(obj1, this.groupCol);
		var val2 = this.viewer.getContentProvider().getCellDisplayData(obj2, this.groupCol);
		if(val1 == val2) {
		// there's a secondary sort and it's not the same as the group
		// sort column, sort by it.
		if(this.sortCol > -1 && this.groupCol != this.sortCol)
			return this._sortComparator(obj1, obj2);

		return 0;
		}
		if (this.groupCol == 4) {
			if(obj1.buildRecord && obj2.buildRecord)
				return dojo.date.compare(obj1.buildRecord.endTime, obj2.buildRecord.endTime);
			else
				return dojo.date.compare(obj1.endTime, obj2.endTime);
		}else 
			return this.inherited("_groupComparator", arguments);
	}
});

dojo.declare("BuildTableView.TableContentProvider", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider,
{
	constructor: function(min_profile) {
        this.min_profile = min_profile;
		this.pendingString = BuildUiUtil.getMessage("labelPending");
    },
    getNumColumns: function(content){
		if(this.min_profile != null)
			return 4;
        return 7;
    },
 
    _columnHeadings: [
        BuildUiUtil.getMessage("labelStatus"),
		BuildUiUtil.getMessage("labelState"),
		BuildUiUtil.getMessage("labelBuild"),
		BuildUiUtil.getMessage("labelDescription"),
		BuildUiUtil.getMessage("labelCompletionTime"),
		BuildUiUtil.getMessage("labelBvtStatus"),
		BuildUiUtil.getMessage("labelTestsRun")
    ],
 
    _columnHeadingsMin: [
        BuildUiUtil.getMessage("labelStatus"),
		BuildUiUtil.getMessage("labelState"),
		BuildUiUtil.getMessage("labelBuild"),
		BuildUiUtil.getMessage("labelDescription")
    ],

    getColumnHeading: function(content, index){
		var headings = this.min_profile ? this._columnHeadingsMin : this._columnHeadings;
        return headings[index];
    },
    
    getIsColumnGroupable: function(content, atColumnIndex){
		return (atColumnIndex != 3 && atColumnIndex != 6);
    },
    getIsColumnSortable: function(content, atColumnIndex){
        return (atColumnIndex != 3 && atColumnIndex != 6 );     
    },
    getColumnWidth: function(content, atColumnIndex){
		if(!this.min_profile){
			switch (atColumnIndex) {
				case 0:
					return 5;
				case 1:
					return 5;
				case 2:
					return 15;
				case 3:
					return 30;
				case 4:
					return 15;
				case 5:
					return 15;
				case 6:
					return 15;
			}
		}else{
			switch (atColumnIndex) {
				case 0:
					return 10;
				case 1:
					return 15;
				case 2:
					return 30;
				case 3:
					return 45;
			}
		}
        return 0;
    },
    
    getContentObjects: function(content){
        return content;
    },
    
    getRowDataId: function(rowData){
		if(rowData.buildRecord)
			return "build_table_row_" + rowData.buildRecord.id;
		return "build_table_row_" + rowData.id;
        
    },
   
    getCellDisplayType: function(rowData, atColumnIndex){
        var type = TableConstants.RENDER_TYPE_TEXT;
		if(atColumnIndex > 2)
			return type;
		var buildRecord = rowData.buildRecord?rowData.buildRecord:rowData;
		if (atColumnIndex == 0) {
			if (buildRecord.status) {
				if (buildRecord.status.stateId == "com.ibm.rqm.buildintegration.buildstatus.inprogress" || buildRecord.status == "In Progress")
					return type; 
				else if(buildRecord.status.stateId == "com.ibm.buildintegration.common.states.unassigned" || buildRecord.status == "Unassigned")
					return type;
				else
					type = TableConstants.RENDER_TYPE_IMAGE;
			}else
				return type;
		}
		else if (atColumnIndex == 1) {
			if (buildRecord.state) 
				type = TableConstants.RENDER_TYPE_IMAGE;
		}else{
			if (buildRecord.name) 
				type = TableConstants.RENDER_TYPE_LINK;
		}
        return type;
    },

    getCellAlignment: function(rowData, atColumnIndex){
        return TableConstants.ALIGN_LEFT;
    },
    
    getCellDisplayData: function(rowData, atColumnIndex){
		var val = "";
		var buildRecord = rowData.buildRecord?rowData.buildRecord:rowData;
		switch (atColumnIndex) {
			case 0:
				val = buildRecord.status && buildRecord.state ? BuildUiUtil.getDisplayName(buildRecord.status.stateId, buildRecord.status.displayName) : "";
				break;
			case 1:
				val = buildRecord.state ? BuildUiUtil.getDisplayName(buildRecord.state.stateId, buildRecord.state.displayName) : this.pendingString;
				break;
			case 2:
				val = buildRecord.name || this.pendingString;
				break;
			case 3:
				val = buildRecord.description || "";
				break;
			case 4:
				val = buildRecord.completedAt;
				break;
			case 5:
				val = BuildUiUtil.getResultString(rowData.rollupstate || "");
				break;
			case 6:
				val = rowData.totalPass && rowData.totalSteps ? rowData.totalPass + "/" + rowData.totalSteps : "";
				break;
		}
        return val;				       
    },
    getCellDisplayExtendedInfo: function(rowData, atColumnIndex){  
        var val = {};
		var buildRecord = rowData.buildRecord?rowData.buildRecord:rowData;
		switch(atColumnIndex){
			case 0:
				if(buildRecord.status && (buildRecord.status.stateId == "com.ibm.rqm.buildintegration.buildstatus.ok" || buildRecord.status == "OK")){
					val.image = CommonImageCache.PASS_ICON;
					val.tooltip = BuildUiUtil.getMessage("msgBuildState", BuildUiUtil.getMessage("labelOK"));
				}
				else if(buildRecord.status && (buildRecord.status.stateId == "com.ibm.rqm.buildintegration.buildstatus.error" || buildRecord.status == "Error")){
					val.image = CommonImageCache.ERROR_ICON;
					val.tooltip = BuildUiUtil.getMessage("msgBuildState", BuildUiUtil.getMessage("labelError"));
				}else
					val.image = CommonImageCache.NOIMAGE;
				break;
			case 1:
				val.image = CommonImageCache.NOIMAGE;
				if (buildRecord.state) {
					if (buildRecord.state.stateId == "com.ibm.rqm.buildintegration.buildstate.complete" || buildRecord.state.displayName == "Complete") {
						val.image = ImageCache.BUILD_COMPLETED;
						val.tooltip = BuildUiUtil.getMessage("msgBuildState", BuildUiUtil.getMessage("labelComplete"));
					}else if (buildRecord.state.stateId == "com.ibm.rqm.buildintegration.buildstate.running" || buildRecord.state.displayName == "Running") {							
						val.image = ImageCache.BUILD_RUNNING;
						val.tooltip = BuildUiUtil.getMessage("msgBuildState", BuildUiUtil.getMessage("labelRunning"));
					}else if (buildRecord.state.stateId == "com.ibm.rqm.buildintegration.buildstate.inprogress" || buildRecord.state.displayName == "In Progress") {							
						val.image = ImageCache.BUILD_RUNNING;
						val.tooltip = BuildUiUtil.getMessage("msgBuildState", BuildUiUtil.getMessage("labelInProgress"));
					}else if (buildRecord.state.stateId == "com.ibm.rqm.buildintegration.buildstate.queued" || buildRecord.state.displayName == "Queued") {
						val.image = ImageCache.BUILD_QUEUED;
						val.tooltip = BuildUiUtil.getMessage("msgBuildState", BuildUiUtil.getMessage("labelQueued"));
					}else if (buildRecord.state.stateId == "com.ibm.rqm.buildintegration.buildstate.cancelled" || buildRecord.state.displayName == "CANCELLED") {
						val.image = ImageCache.BUILD_CANCELLED;
						val.tooltip = BuildUiUtil.getMessage("msgBuildState", BuildUiUtil.getMessage("labelCancelled"));
					}
				}
				break;
			case 2:
				if(buildRecord.name)
					val.href = BuildUiUtil.getBuildRecordURI(buildRecord.id);
		}
        return val;
    }
    
});

dojo.declare("com.ibm.rqm.buildintegration.web.ui.internal.view.table.BuildTableView", 
    [dijit._Widget, dijit._Templated],
{    
    templateString: '<div dojoAttachPoint="_tableViewerNode" class="com-ibm-rqm-test-artifact-table-view" tabindex="-1">' +
                    '</div>',

    widgetsInTemplate: false,
	rowCheckedListener:null,
	tableRowsCheckable:null,
	min_profile:null,
	editable:true,
    constructor: function(args) {
		this.actions = args.actions?args.actions:[];
		this.tableRowsCheckable = args.tableRowsCheckable;
		this.min_profile = args.min_profile;
		this.editable = args.editable;
		this.consoleNode = args.consoleNode;
	 },

    postCreate: function(){
		var allowAdjustSettings = this.min_profile?false:true;
		var args = {autoSaveSettings:allowAdjustSettings,allowAdjustSettings:allowAdjustSettings}
		if(!this.min_profile){
			args.sortByColumn = 5;
			args.sortDir= TableConstants.SORT_DIR_DESCEND;
		}
		this.tableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer(args);
		if(allowAdjustSettings)
			this.tableViewer.tableId = this.consoleNode? "RQM-BUILD-RECORD-TABLEVIEWER":"RQM-BUILD-QUERY-TABLEVIEWER";
        this._tableViewerNode.appendChild(this.tableViewer.domNode);	
        this.tableViewer.showLoadingProgress();
		this.tableViewer.setContentPageSize(20);
        this.tableViewer.setContentProvider(new BuildTableView.TableContentProvider(this.min_profile));
		this.tableViewer.setTableListener(new BuildTableView.TableListener(this));
		this.tableViewer.setSorter(new BuildTableView.Sorter());
		this.tableViewer.setTableSummary(BuildUiUtil.getMessage("labelTableSummary", BuildUiUtil.getMessage("labelAllBuilds")));
        this.tableViewer.setTableRowsCheckable(this.tableRowsCheckable, (this.singleSelectable ? this.singleSelectable : false));
		this.refreshBtn = this.addAction({
				name:"refresh", label:BuildUiUtil.getMessage("labelRefresh"), 
				context:this, icon:"refresh-icon-image",callback: dojo.hitch(this, "refresh")});
		for(var i=0;i<this.actions.length;i++){
			var actionBtn = this.addAction(this.actions[i]);
			if(!this.editable)
				actionBtn.setDisabled(true);
		}
		this.setContent(this.builds);
		this.tableViewer.endLoadingProgress();
    },
	addAction:function(action){
		if(action.name == "removeBuildRec"){
			this.deleteActionNode = this.tableViewer.addAction(action.name,action.label,action.context,action.icon,action.callback); 
			this.deleteActionNode.setDisabled(true);
			return this.deleteActionNode;
		}else
			return this.tableViewer.addAction(action.name,action.label,action.context,action.icon,action.callback);
	},
	show:function(){
		this.tableViewer.show();
	},
	getSelectedRows:function(){
		return this.tableViewer.getCheckedRows();
	},
	setContent:function(content){
		this.builds = content? content:[];
		for(var i=0; i < this.builds.length;i++){
			var buildRecord = this.builds[i].buildRecord?this.builds[i].buildRecord:this.builds[i];
			if (buildRecord.endTime && Number(buildRecord.endTime) != NaN && buildRecord.endTime != 0) {
				buildRecord.completedAt = this._convertLongToDate(buildRecord.endTime);
				if (buildRecord.completedAt == "") 
					buildRecord.endTime = 0;
			}else {
				buildRecord.completedAt = "";
				buildRecord.endTime = 0;
			}
		}
		this.tableViewer.setContent(this.builds);	
	},
	refresh:function(){
		this.tableViewer.showLoadingProgress();
		if(this.parentController){
			this.refreshBtn.setDisabled(true);
			this.parentController.initialize();
		}
		this.tableViewer.endLoadingProgress();
	},
	refreshTable:function(content){
		this.setContent(content);
		this.tableViewer.refresh();
		this.refreshBtn.setDisabled(false);
	},
	_convertLongToDate: function(/*accepts long*/longDate){
		var date = new Date();
		date.setTime(longDate);
		if(date == "Invalid Date")
			return "";
		return dojo.date.locale.format(date, {formatLength: "medium"});
		
	},
	getSelectedRows:function(){
		return this.tableViewer.getCheckedRows();
	}
});

})();
