//ELTV
/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.execution.web.ui.internal.view.table.ExecutionLogTableView");
 
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");

dojo.require("com.ibm.asq.common.web.client.internal.PermissionsClient");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.ListRowRenderer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentFilterProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.util.GlobalEvents");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");

dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");

dojo.require("com.ibm.rqm.execution.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultClient");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultGroupClient");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultStateClient");
dojo.require("com.ibm.rqm.execution.web.client.internal.mapper.AllResultsMapper");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.table.AbstractFilteredExecutionTableView");
dojo.require("com.ibm.rqm.buildintegration.web.ui.internal.BuildUiUtil");

(function() {

var ServiceResponseHandler = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var TableConstants = com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;
var ImageCache     = com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
var Utility        = com.ibm.rqm.execution.web.ui.internal.util.Utility;
var Constants      = com.ibm.rqm.planning.web.client.internal.Constants;
var GlobalEvents   = com.ibm.asq.common.web.ui.internal.util.GlobalEvents;
var ViewHeaderLayout = com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout;
var AbstractFilteredExecutionTableView = com.ibm.rqm.execution.web.ui.internal.view.table.AbstractFilteredExecutionTableView;
var TableContentFilterProvider = com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentFilterProvider;
var ExecutionResultClient = com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultClient;
var ExecutionResultGroupClient = com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultGroupClient;
var ExecutionResultStateClient = com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultStateClient;
var AllResultsMapper = com.ibm.rqm.execution.web.client.internal.mapper.AllResultsMapper;

var LabelNA = Constants.getMessage("labelNA");
var LabelSuiteResult = Constants.getMessage("labelSuiteResult");
var LabelExecResult = Constants.getMessage("labelExeResult");

dojo.declare("ExecutionLogTableView.TableListener", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableListener,
{
    constructor: function(parentView) {
        this.parentView = parentView;
    },

    rowCheckStateChanged: function(tableViewer, rowObject, state){
        var selectionCount = tableViewer.getCheckedRows().length;
        if (this.parentView.deleteActionNode)
            this.parentView.deleteActionNode.setDisabled(selectionCount == 0);
        if (selectionCount == 1) {
        	this.parentView.printActionNode.setDisabled(false);
        	dojo.style(this.parentView.printActionNode.domNode, "opacity", 1.0);
        }
		else {
			this.parentView.printActionNode.setDisabled(true);
			dojo.style(this.parentView.printActionNode.domNode, "opacity", 0.3);
		}
    },
	
    groupRowsCheckStateChanged: function(tableViewer, rowObjects, state){
        this.rowCheckStateChanged(tableViewer, rowObjects, state);
    },
    
    tableContentActionInvoked: function(tableViewer, actionId, callbackData, callback){                
     	if (callback == null && callbackData != null && dojo.isFunction(callbackData)) {
            callbackData();
        }
		else if (callback != null && dojo.isFunction(callback)) {
            if (callbackData != null) {
                callback(callbackData);
            } else {
                callback();
            }
        } 
    },

    tableContentFilterActionInvoked: function(tableViewer, actionId, filters, callback, callbackData){
        if(callback) {
            callback(actionId, filters);
        }                     
    }
});

dojo.declare("ExecutionLogTableView.TableProvider", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider,
{    
    getNumColumns: function(content){
        return 14;
    },
 
 
    _columnHeadings: [
        Constants.getMessage("labelType"),
		Constants.getMessage("labelId"),
		Constants.getMessage("labelName"),
		Constants.getMessage("labelTestCase"),
        Constants.getMessage("labelTestScript"),
        Constants.getMessage("labelCompleted"),
		Constants.getMessage("labelState"),
		Constants.getMessage("labelEWINameLabel"),
		Constants.getMessage("labelBuild"),
		Constants.getMessage("labelPointsValue", Constants.getMessage("labelPass")),
		Constants.getMessage("labelPointsValue", Constants.getMessage("labelFail")),
		Constants.getMessage("labelPointsValue", Constants.getMessage("labelBlocked")),
		Constants.getMessage("labelPointsValue", Constants.getMessage("labelInconclusive")),
		Constants.getMessage("labelPointsValue", Constants.getMessage("labelAttempted"))
    ],
 
    getColumnHeading: function(content, index){
        return this._columnHeadings[index];
    },
 
    getColumnHeadingImage: function(content, atColumnIndex){
        return null;
    },

    getColumnHeadingAlignment: function(atColumnIndex){
        return this.getCellAlignment(null, atColumnIndex);
    },	 
    
	getIsColumnVisible: function(atColumnIndex){
		return ( ! (atColumnIndex >= 7));
	},
	
    getIsColumnGroupable: function(content, atColumnIndex){
        return (atColumnIndex >= 0 && atColumnIndex <= 8 && atColumnIndex != 4 && atColumnIndex != 1);     
    },

    getIsColumnSortable: function(content, atColumnIndex){
        return (atColumnIndex >= 0 && atColumnIndex <= 8 && atColumnIndex != 1);   
    },
    
    _columnWidths: [8,5,17,25,25,10,10,10,10,10,10,10,10,10],  //  170???

    getColumnWidth: function(content, atColumnIndex){
        return this._columnWidths[atColumnIndex];
    },
    
    getContentObjects: function(content){
        return content;
    },
    
    getRowDataId: function(rowData){
        return "_table_row_for_execution_result_" + rowData.itemId;
    },
    
    getCellDisplayType: function(rowData, atColumnIndex){
        var type = TableConstants.RENDER_TYPE_TEXT;

        switch(atColumnIndex) {
            case 0: 
                type = TableConstants.RENDER_TYPE_IMAGE;
                break;
			case 1: 
                type = TableConstants.RENDER_TYPE_TEXT;
                break;
            case 2: 
                type = TableConstants.RENDER_TYPE_LINK;
                break;
			case 3: 
                type = rowData.type == Constants.TYPE_SUITE ? TableConstants.RENDER_TYPE_TEXT: TableConstants.RENDER_TYPE_LINK;
                break;
			case 4: 
                type = rowData.type == Constants.TYPE_SUITE ? TableConstants.RENDER_TYPE_TEXT: TableConstants.RENDER_TYPE_LINK;
                break;
            case 5: 
                type = TableConstants.RENDER_TYPE_DATE;
                break;					 			 
            case 6: 
                type = TableConstants.RENDER_TYPE_LINK;
                break;
			case 8: 
                type = rowData.buildName ? TableConstants.RENDER_TYPE_LINK : TableConstants.RENDER_TYPE_TEXT;
                break;						 
        }
        return type;
    },

    getCellAlignment: function(rowData, atColumnIndex){
        if(atColumnIndex == 0)
            return TableConstants.ALIGN_CENTER;
        return TableConstants.ALIGN_LEFT;
    },

    getCellDisplayData: function(rowData, atColumnIndex){
        var val = "";
        switch(atColumnIndex) {
            case 0: 
                val = rowData.type == Constants.TYPE_SUITE ? LabelSuiteResult : LabelExecResult;
                break;
			case 1:
				val = rowData.id;
				break;
			case 2:
                var name = rowData.name ? rowData.name : "";
				val = Constants.getMessage("labelNamedResult", name);
				break;	
			case 3:
				val = rowData.testCase ? rowData.testCase.name: "";
				break;
            case 4: 
                val = rowData.script && rowData.script.name ? rowData.script.name:""; //Test Script Name
                break;
            case 5:
				val = LabelNA; 
                if (rowData.endTime > 0) {
                   val = new Date(); //Completed
                   val.setTime(rowData.endTime);
                }
                break;   
            case 6: 
                val = Utility.getStatusText(rowData); //State
                break;
			case 7: 
                // the name is the TER name. We tag on the result label (above in name column)
                // to indicate we're looking at the result of the TER execution.
                val = rowData.name ? rowData.name : ""; //EWIName
                break;	
			case 8: 
                val = rowData.buildName ? rowData.buildName : LabelNA; ; //Build name
                break;
			case 9: 
                val = rowData.pointsPassed; //Pass points
                break;
			case 10: 
                val = rowData.pointsFailed; //Fail points
                break;
			case 11: 
                val = rowData.pointsBlocked; //Blocked points
                break;
			case 12: 
                val = rowData.pointsInconclusive; //Inconclusive points
                break;
			case 13: 
                val = rowData.pointsAttempted; //Attempted points
                break;				 
        }
        return val;
    },
    getCellRawData: function(rowData, atColumnIndex)
    {
        // don't need to convert the long time value to Time object.
        // return the raw data for sorting/grouping operations.
        if(atColumnIndex == 5) {
            return rowData.endTime;
        }
        return this.getCellDisplayData(rowData, atColumnIndex);
    },
    
    getCellDisplayExtendedInfo: function(rowData, atColumnIndex){ 
        var val = {};
		if (atColumnIndex == 0) {
			//result type image
			val.href = this.getHref(rowData);
			val.image = ImageCache.EWI_LOG;//Default to execution result
			val.tooltip = Constants.getMessage("labelExeResult");
			if (rowData.type == Constants.TYPE_SUITE) {
				val.image = ImageCache.TEST_SUITE;				
				val.tooltip = Constants.getMessage("labelSuiteResult");
			}
		}
        // name column: attach to the result page.
		else if(atColumnIndex == 2) {
            val.href = this.getHref(rowData);
        }
		else if (atColumnIndex == 3 && rowData.testCase && rowData.testCase.id) {
			val.href = Utility.getTestCaseURI(rowData.testCase.id, Utility.CONSTRUCTION_PERSPECTIVE);
		}
        else if (atColumnIndex == 4 && rowData.script && rowData.script.id) {
			val.href = Utility.getTestScriptURI(rowData.script.id, Utility.CONSTRUCTION_PERSPECTIVE);
		}
        else if (atColumnIndex == 6) {
			val.href = this.getHref(rowData);
		}		  
		else if(atColumnIndex == 8 && rowData.buildId){
			val.href = com.ibm.rqm.buildintegration.web.ui.internal.BuildUiUtil.getBuildRecordURI(rowData.buildId);
		}
        return val;
    },
	
	getHref: function(rowData) {
		if (rowData.type == Constants.TYPE_SUITE) {
			return Utility.showSuiteResult({ id: rowData.id });
		} else if (rowData.type == Constants.TYPE_EWI) {
			return Utility.getResultURI({resultItemId: rowData.itemId});
		}
	}
});

dojo.declare("ExecutionLogTableView.TableFilterProvider", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentFilterProvider,
{
    constructor: function(tableView, openSection, defaultToMine) {
        this.tableView = tableView;
        this.initOpenFilter = openSection;
		this.defaultToMine = (defaultToMine === true);
		
        // define the static filters
        this.filters = [
            {
                name: "myItemsOnly",  // must match key in the arg list of the API
                title: Constants.getMessage("labelOnlyMyResults"),
                promptTitle: Constants.getMessage("labelOnlyMyResults"),
                type: TableContentFilterProvider.FIELD_CHECKBOX,
                defaultValue: this.defaultToMine,
                params: null
            }, {
                name: "name",  // must match key in the arg list of the API
                title: Constants.getMessage("labelname"),
                promptTitle: Constants.getMessage("labelName"),
                type: TableContentFilterProvider.FIELD_TEXT,
                defaultValue: null,
                params: null
            }
        ];
    },

    getTitle: function() {
        return Constants.getMessage("labelFilterTitle");    
    },
    
    getSummaryText: function() {
        return Constants.getMessage("labelFilterDescriptionAllVisible", Constants.getMessage("labelExeResults"));
    },
	
    getIsSectionOpenInitially: function() {
       return this.initOpenFilter; 
    },	
    
    getInitialVisibleFilterCount: function() {
        return 4;    
    },
	
    getFilters: function() {
        return this.filters;
    },	
    
    getFilterCount: function() {
        return this.filters.length;
    },
    
    getFilterName: function(index) {
        return this.filters[index].name;
    },
    
    getFilterTitle: function(index) {
        return this.filters[index].title;
    },
    
    getFilterPromptTitle: function(index) {
        return this.filters[index].promptTitle;        
    },
    
    getFilterType: function(index) {
        return this.filters[index].type;
    },
    
    getFilterDefaultValue: function(index) {
        return this.filters[index].defaultValue;
    },
    
    getFilterParams: function(index) {        
        return this.filters[index].params;
    },
    
    getCustomField: function(index) {
        return null;
    },
    
    getActionsInfo: function() {
        var actions = [
            {
                id: "cancel",
                title: Constants.getMessage("labelReset"),
                callback: dojo.hitch(this, "filterResetActionInvoked"),
                callbackData: null,
                isDefault: false
            }, {
                id: "run",
                title: Constants.getMessage("labelRun"),
                callback: dojo.hitch(this, "filterRunActionInvoked"),
                callbackData: null,
                isDefault: true
            }
        ];
        return actions;
    },
    
    filterResetActionInvoked: function(actionName, filters) {
        this.tableView.tableViewer.setContentFilterAttributeProvider(this.tableView.filterProvider);
    },

    filterRunActionInvoked: function(actionName, filters){
        var args = {};
        for (var nameKey in filters) {
            if (filters[nameKey] != null) {
                args[nameKey] = filters[nameKey] || "";
                if (args[nameKey] == 'Any@@') {
					args[nameKey] = '';
				}
            }
        }
        this.tableView.runQuery(args);
    }
});

dojo.declare("com.ibm.rqm.execution.web.ui.internal.view.table.ExecutionLogTableView", 
    [dijit._Widget, dijit._Templated, AbstractFilteredExecutionTableView],
{    
    templateString: '<div dojoAttachPoint="_tableViewerNode" class="com-ibm-rqm-test-artifact-table-view" tabindex="-1">' +
                    '  <div dojoType="com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout" "noline"=true dojoAttachPoint="viewHeaderNode">' +
                    '    <div dojoAttachPoint="_tableViewerNode" class="com-ibm-rqm-test-artifact-table-view" tabindex="-1"></div>' +
                    '  </div>' +
                    '</div>',

    widgetsInTemplate: true,

    constructor: function() {
	 	this.results = null;
        this.showInitLoadProgress = false;
		this._itemsToTrack = {};
        this.showQueryFilters = false;
	 },

    postCreate: function() {
        this.inherited("postCreate", arguments);

        // the view is in a query page if there is a query name otherwise it is within
        // some container that don't need the header
        this.isQueryPage = this.queryName;
        
        this._projectAlias = com.ibm.asq.common.web.ui.internal.util.Utility.getCurrentProjectAreaAlias();
		
        // we're showing query filters, we'll be managing our own
        // contents. Initialize the query filters first.
        if (this.isQueryPage && this.showQueryFilters) {
	        //setup search details
			this.setSearchFunction(dojo.hitch(ExecutionResultGroupClient, "searchAllResults"));
	        this.setSearchCallback(dojo.hitch(this, "refresh"));
	        this.setResponseHandlerType(AllResultsMapper);
	        this.setTypeLabel(Constants.getMessage("labelAllExeResult"));
		    
			//initialize filters
            this._initializeFilters();
			
        } else {
            this._initialize();
        }
	},
	
    // Constructs the query filter definitions and the content filter provider for the
    // table. The table will construct the filters section based on the definitions.
    // 
    _initializeFilters: function() {
        // create the filter provider for the table
        this.filterProvider = new ExecutionLogTableView.TableFilterProvider(this, this.isInitiallyOpen(), this.isDefaultsToMine());

        //append new filters - owner and then states (via callback)
        var callback = dojo.hitch(this, function(){
	        var statesFilter = {           
	            //filterName, filterLabel, filterPrompt, filterType, callback
	            name: "stateIds",
	            label: Constants.getMessage("labelStateLabel"),
	            prompt: Constants.getMessage("labelState"),
				type:TableContentFilterProvider.FIELD_TOGGLELIST
	        }
	        this.addExecutionStateFilter(statesFilter, this.filterProvider.filters, dojo.hitch(this, "_initialize")); 			
		});
		
		//append owner field
        var ownerFilter = {
            name: "ownerUUIDs",
            label: Constants.getMessage("labelowner"),
            prompt: Constants.getMessage("labelOwner") ,
			type:TableContentFilterProvider.FIELD_TOGGLELIST
        }
        this.addContributorFilter(ownerFilter, this.filterProvider.filters, callback);
    },
	
	_initialize: function() {
        var tableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer({
            allowAdjustSettings: true,
            autoSaveSettings: true,
            allowMultiSort: true,
            tableId: "RQM-TE-LOG-TABLEVIEWER"                                
        });        
		
        if (this.showQueryFilters) {
			this.initFilterProvider(this.filterProvider);
            tableViewer.setContentFilterAttributeProvider(this.filterProvider);
        }
				
        this._tableViewerNode.appendChild(tableViewer.domNode);
		          
        var content = this.results ? this.results : [];
		this.queryName = this.queryName ? this.queryName : Constants.getMessage("labelExeResults");
        
		 if (this.isQueryPage) {
            // it is a query page so set header title and add table viewer as the header content
            this.viewHeaderNode.setTitle(this.queryName);
			this.viewHeaderNode.setCSHelpId("rqm_view_exec_results.html");
			this.viewHeaderNode.setCSHelpButtonLabel(Constants.getMessage("labelExeResultsHelp"));
            this._tableViewerNode.appendChild(tableViewer.domNode);
        } else {
            // it is not a query page i.e. within a section without header
            this.viewHeaderNode.domNode.style.display = "none";
            this.domNode.appendChild(tableViewer.domNode);
        }
		  
        tableViewer.setContentPageSize(20);
        tableViewer.setContent(content);
        tableViewer.setContentProvider(new ExecutionLogTableView.TableProvider());
        tableViewer.setTableListener(new ExecutionLogTableView.TableListener(this));
		tableViewer.setTableSummary(Constants.getMessage("labelTableSummary", this.queryName));
		
		//add refresh action (use 'refreshQuery' api if showing filters)
        this.refreshCallback = this.showQueryFilters ? dojo.hitch(this, "refreshQuery") : this.refreshCallback;
		if (this.refreshCallback && dojo.isFunction(this.refreshCallback)) {
        	tableViewer.addAction("refresh", Constants.getMessage("labelRefresh"), this, "refresh-icon-image", this.refreshCallback);    
        }
		
        var type = com.ibm.asq.common.web.client.internal.PermissionsClient.OP_EXECUTION_RESULT;
        var perm = com.ibm.asq.common.web.client.internal.PermissionsClient.getStoredPermission(type);
        
		if (this.isQueryPage && (!perm || perm.archive)) {
            this.deleteActionNode = tableViewer.addAction(
                    "delete",                                  // action id
                    Constants.getMessage("labelDelete"),       // label
                    null,                                      // callback data
                    "delete-icon-image",                       // icon class
                    dojo.hitch(this, "_onDeleteActionClick")); // callback
            this.deleteActionNode.setDisabled(true);
        }
		tableViewer.setTableRowsCheckable(true, false);
        if(this.showInitLoadProgress) {
            tableViewer.showLoadingProgress();
        }
        tableViewer.show();
		  
		this.tableViewer = tableViewer;
		
		var printMenu = new dijit.Menu({ style: "display: none;"});
        var historyOption = new dijit.MenuItem({
        	label: Constants.getMessage("printLabelHistory"),
        	onClick: dojo.hitch(this, "_onPrintHistoryActionClick")
        });
        printMenu.addChild(historyOption);
		this._itemsToTrack.menus = [];
		this._itemsToTrack.menus.push(printMenu);
		
       	this.printActionNode = tableViewer.addAction(
       			"printpdf",
       			Constants.getMessage("labelPDFView"),
       			null,
       			"pdf-icon-image",
       			dojo.hitch(this, "_onPrintHistoryActionClick"),
       			printMenu
       	);      	

       	this.printActionNode.setDisabled(true);
       	dojo.style(this.printActionNode.domNode, "opacity", 0.3);
		
		//if preference specifies, run the query
		if (this.showQueryFilters) {
			this.initRunQuery();
		}
    },
    
	_onPrintHistoryActionClick: function() {
		var type = "executionresult";
		var selectedScripts = this.tableViewer.getCheckedRows();
		var loc = window.location.href;
		loc = loc.replace(/[&]/g,"%26");
		var summary = false;
		if (!selectedScripts.length){
			selectedScripts = this.executionWorkItems;
			summary = true;
		}
		this.tableViewer.sendPdfHistoryRequest(selectedScripts,type,loc,this._projectAlias, summary);
	},

	_onDeleteActionClick: function() {
        var args = {
            'message': Constants.getMessage("msgDelExecutionResultConfirm"),
            'yesCallback': 
                function(view) {
                    view._deleteAction();
                },
            'yesCallbackData': this,
            'noCallback': null,
            'noCallbackData': null
        };
        var confirmDialog = new com.ibm.asq.common.web.ui.internal.widgets.YesNoDialog(args);
        confirmDialog.setSecondaryTitle(Constants.getMessage("labelConfirmation"));
        confirmDialog.open();
    },

    _deleteAction: function() {         
        var selectedERs = this.tableViewer.getCheckedRows();
        this.deleteActionNode.setDisabled(true);
        this.selectedERCount = selectedERs.length;
        this.errorERCount = 0;
        this.deletedERCount = 0;

        if (this.selectedERCount > 0) {
            for (var i = 0; i < this.selectedERCount; i++) {
				if (selectedERs[i].type != Constants.TYPE_SUITE) {
					var responseHandler = new ServiceResponseHandler(this, "_deleteSuccess", "_deleteFailure");
					ExecutionResultClient.archiveExecutionResult(responseHandler, {
						uuid_er: selectedERs[i].itemId,
						resultStateId: selectedERs[i].stateId,
						archive: true
					});
				}else{
					var responseHandler = new ServiceResponseHandler(this, "_deleteSuccess", "_deleteFailure");
					ExecutionResultGroupClient.postDeleteResult(responseHandler,{
						uuid_erg:selectedERs[i].itemId,
						stateId:selectedERs[i].stateId,
						archive:true
					});
				}
                if (this.isQueryPage)
                    this.viewHeaderNode.setProgressStart(Constants.getMessage("msgDeletingExecutionResult", selectedERs[i].name));
            }
        }
    },
    
    _deleteSuccess: function(response) {
        if (this.isQueryPage) {
			this.viewHeaderNode.setProgressEnd();
		}
        this.deletedERCount++;
        this._setDeleteStatus();
    },
    
    _deleteFailure: function(err) {
        if (this.isQueryPage) {
			this.viewHeaderNode.setProgressEnd();
		}
        this.errorERCount++;
        this._setDeleteStatus();
    },
    
    _setDeleteStatus: function() {
        if ((this.deletedERCount + this.errorERCount) == this.selectedERCount) {
            if (this.isQueryPage)
                this.viewHeaderNode.setStatus(
                    Constants.getMessage("msgDeletedExecutionResults", this.deletedERCount, this.selectedERCount),
                    this.errorERCount == 0 ? ViewHeaderLayout.SUCCESS : this.selectedERCount == 1 ? ViewHeaderLayout.ERROR : ViewHeaderLayout.INFO
                );
            if (this.deletedERCount > 0) {
                // notify all pages (including itself) execution results are deleted
                dojo.publish(GlobalEvents.ArtifactsDeleted, [Constants.TYPE_EXE_LOG, this.tableViewer.getCheckedRows()]);
            }
        }
    },

	refresh: function(content) {
        if(this.showInitLoadProgress && !this.inProgress) {
            this.tableViewer.endLoadingProgress();
            this.showInitLoadProgress = false;
        }
		
		this.results = content;
        this.tableViewer.setContent(content);
        this.tableViewer.refresh();
    },

	uninitialize: function(){
		//Remove menu items
		var menus = this._itemsToTrack.menus;
		var menuLength = menus.length;
		if(menus && menuLength>0){
			for(var i=0;i<menuLength;i++){
				menus[i].destroyRecursive();
			}
		}
	},
	
    // handler on added exe log
    onArtifactChanged: function(changeType, artifactType, artifactArray) {
        // only care about exe log
        if (artifactType == Constants.TYPE_EXE_LOG) {
            if (changeType == GlobalEvents.ArtifactsAdded) {
                // add exe log to the table
                if (!this.results) {
                    this.results = artifactArray;
                } else {
                    this.results = this.results.concat(artifactArray);
                }
            } else {
				var found = false;
                // iterate through the array of artifacts
                for (var i = 0; i < artifactArray.length; i++) {
					found = false;
                    // iterate through the array of results in the table
                    for (var j = 0; j < this.results.length; j++) {
                        // handle the matching result
                        if (artifactArray[i].itemId == this.results[j].itemId) {
                            // swap result on update
							if (changeType == GlobalEvents.ArtifactsUpdated){
								this.results.splice(j, 1, artifactArray[i]);
							}else if (changeType == GlobalEvents.ArtifactsDeleted){//remove on deletion
								this.results.splice(j, 1);
							}
							found = true;
                            break;
                        }
                    }
					if (!found) {
						this.results = this.results.concat(artifactArray[i]);
					}
			    }
            }
			this.tableViewer.setContent(this.results);
            this.tableViewer.refresh();
        }
    }
});

})();