/**EWITV***************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.execution.web.ui.internal.view.table.ExecutionWorkItemTableView");
 
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.asq.common.web.client.internal.PermissionsClient");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");

dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.execution.web.ui.internal.util.Utility");

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentFilterProvider");

dojo.require("com.ibm.rqm.execution.web.ui.internal.view.table.AbstractFilteredExecutionTableView");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.table.cellrenderers.TextComboCellRenderer");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.table.cellrenderers.ScriptComboCellRenderer");
dojo.require("com.ibm.asq.common.web.client.internal.CommonPreferenceClient");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.asq.common.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionWorkItemClient");
dojo.require("com.ibm.asq.common.web.ui.internal.util.GlobalEvents");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.views.configurations.ConfigurationsUriUtil");
dojo.require("com.ibm.asq.common.web.client.internal._catalog.Configuration");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultStates");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultStateClient");
dojo.require("com.ibm.rqm.execution.web.client.internal.mapper.EWIMapper");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.properties.SelectWeightPopup");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.properties.SelectOwnerPopup");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.properties.SelectTestPhasePopup");
dojo.require("com.ibm.rqm.planning.web.client.internal.UserClient");
dojo.require("com.ibm.rqm.process.web.client.internal.timebox.TimeboxClient");

(function() {

var ServiceResponseHandler	= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var TableConstants 			= com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;
var ImageCache     			= com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
var Utility        			= com.ibm.rqm.execution.web.ui.internal.util.Utility;
var Constants      			= com.ibm.rqm.planning.web.client.internal.Constants;
var AbstractFilteredExecutionTableView = com.ibm.rqm.execution.web.ui.internal.view.table.AbstractFilteredExecutionTableView;
var GlobalEvents   			= com.ibm.asq.common.web.ui.internal.util.GlobalEvents;
var ExecutionWorkItemClient	= com.ibm.rqm.execution.web.client.internal.execution.ExecutionWorkItemClient;
var YesNoDialog				= com.ibm.asq.common.web.ui.internal.widgets.YesNoDialog;
var ConfigurationUriUtil 	= com.ibm.rational.test.lm.web.ui.internal.views.configurations.ConfigurationsUriUtil;
var ViewHeaderLayout        = com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout;
var PermissionsClient       = com.ibm.asq.common.web.client.internal.PermissionsClient;
var TableContentFilterProvider = com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentFilterProvider;
var ExecutionResultStateClient = com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultStateClient;
var EWIMapper                  = com.ibm.rqm.execution.web.client.internal.mapper.EWIMapper;
var UserClient 				= com.ibm.rqm.planning.web.client.internal.UserClient;
var TimeboxClient           = com.ibm.rqm.process.web.client.internal.timebox.TimeboxClient;
var CommonPreferenceClient 	= com.ibm.asq.common.web.client.internal.CommonPreferenceClient;
var LabelNone               = Constants.getMessage("labelNone");

dojo.declare("ExecutionWorkItemTableView.TableListener", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableListener,
{        
	constructor: function(parentView) {
        this.parentView = parentView;
        this._printsHistory = true;
    },
	
	setRowCheckListener: function(listener) {
		this.rowCheckListener = listener;
	},
	
    rowCheckStateChanged: function(tableViewer, rowObject, state){
		var selectionCount = tableViewer.getCheckedRows().length;
		var p = this.parentView;
		if (p.inEditMode)
			return;
        if (p.deleteActionNode)
            p.deleteActionNode.setDisabled(selectionCount == 0 || !tableViewer.isEditable());
		
		if (selectionCount > 0 && tableViewer.isEditable()){
			p.enableAction("edit");
			p.enableAction("unblock");
		} else {
			p.disableAction("edit");
			p.disableAction("unblock");
		}
		
		p.disableAction("execute");
		if (selectionCount == 1) {
			var section = p.parentSection;
			if (tableViewer.isEditable()) {
				p.hideAction("printpdfsummarymenu");
				p.hideAction("printpdfmultiplemenu");
				p.enableAction("printpdfhistorycarmenu");
				p.showAction("printpdfhistorycarmenu");
				
				p.enableAction("execute");
			} else if (section && section.isSnapshot() && !rowObject.clonedForSnapshot) {
				p.enableAction("execute");				
			}
		}
		
		if (this.rowCheckListener && dojo.isFunction(this.rowCheckListener)) {
			this.rowCheckListener(rowObject, state);
		}

		if (selectionCount == 0) {
			p.hideAction("printpdfhistorycarmenu");
			p.hideAction("printpdfmultiplemenu");
			p.enableAction("printpdfsummarymenu");
			p.showAction("printpdfsummarymenu");
		} else if (selectionCount > 1) {
			p.hideAction("printpdfhistorycarmenu");
			p.hideAction("printpdfsummarymenu");
			p.enableAction("printpdfmultiplemenu");
			p.showAction("printpdfmultiplemenu");
		}
    },
    
    groupRowsCheckStateChanged: function(tableViewer, rowObjects, state){
        this.rowCheckStateChanged(tableViewer, rowObjects, state);
    },
	
    tableContentActionInvoked: function(tableViewer, actionId, callbackData, callback){                
        if (callback == null && callbackData != null && dojo.isFunction(callbackData)) {
            callbackData();
        }
		
		if (callback != null && dojo.isFunction(callback)) {
            if (callbackData != null) {
                callback(callbackData);
            } else {
                callback();
            }
        } 
    },

    tableContentFilterActionInvoked: function(tableViewer, actionId, filters, callback, callbackData){
        if(callback) {
            callback(actionId, filters);
        }                     
    },
	
    tableHeaderColumnActionInvoked: function(tableViewer, columnIndex, /*optional*/actionId){
		this.parentView.tableHeaderColumnActionInvoked(columnIndex, actionId);  
    }  
});

dojo.declare("ExecutionWorkItemTableView.CellModifier", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier,
{
    showTestCase: true,
    constructor: function(args) {
        dojo.mixin(this, args);
    },
    
	setComboChangeListener: function(listener){
		this.comboChangeListener = listener;
	},
	
    _recordSelectedScriptName: function(rowData) {
        var tc = rowData.testCase;
        var tsItemId = rowData.selectedScriptId;
        
        if (tsItemId == '-1') {
            rowData.selectedScriptName = LabelNone;
        }
        else {
            var ts = tc ? tc.scripts : null;
            if (ts) {
                var len = ts.length;
                for (var i = 0; i < len; i++) {
                    if (ts[i].versionableItemId == tsItemId) {
                        rowData.selectedScriptName = ts[i].name;
                        break;
                    }
                }
            }
        }       
    },
    
    cellValueChanged: function(oldValue, newValue, rowObject, columnIndex){
		if( this.parent.parentSection && this.parent.inEditMode){
			this.parent.parentSection.setDirty();
		}
        // store the new values in our internal data model
        columnIndex += (this.showTestCase || (columnIndex == 0)|| (columnIndex == 1 )|| (columnIndex == 2 ) ? 0 : 1);
		if(columnIndex == 8) {
            // update the current selected script on the row.
			rowObject.selectedScriptId = newValue;
            rowObject.testScriptValues.select = newValue;
            this._recordSelectedScriptName(rowObject);
            
			if(this.parent.inEditMode){	
				rowObject.isChanged = true;	
				var listener = this.comboChangeListener;
				if(rowObject.defaultScript)
					rowObject.defaultScript.versionableItemId = newValue;
				else 
					rowObject.defaultScript = { versionableItemId: newValue };
				if(rowObject.defaultScript.versionableItemId == "-1") 
					rowObject.defaultScript.versionableItemId = null;
				if(listener && listener.method)
					listener.method.apply(listener.context, [rowObject]);
			}
        }
    },
    
    cellActionInvoked: function(rowObject, columnIndex){}
});

dojo.declare("ExecutionWorkItemTableView.TableProvider", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider,
{
    showTestCase: true,
    customEditable: false,
    labelUnassigned: Constants.getMessage("labelUnassigned"),
    labelBlocking: Constants.getMessage("msgHasBlockingDefect"),
    labelNonBlocking: Constants.getMessage("msgNoBlockingDefect"),
    labelNoDefect: Constants.getMessage("msgNoDefect"),
    
    constructor: function(args) {
        dojo.mixin(this, args);
    },
    
    // Summary:
    //    This method is called whenever a new content is set to the table viewer. Rebuild
    //    the test script's values for all of the TERs. We need to pre-build this information
    //    to ensure sorting of the test script column would produce the correct results. The
    //    sort would need to be on the current selected test script in each of the row.
    //
    contentChangedNotify: function(content) {
        if(!content || !dojo.isArray(content)) {
            return;
        }
        
        var showlastrunscript = CommonPreferenceClient.getExecutionPreference().showlastrunscript;
        var content_len = content.length;
 
        for (var n = 0; n < content_len; n++) {
            var rowData = content[n];
            var val = {};
            val.select = null;
            var defaultScriptId = null;
            var showlastrunscript = CommonPreferenceClient.getExecutionPreference().showlastrunscript;
            if(rowData.selectedScriptId)
                val.select = rowData.selectedScriptId;
            else if(rowData.currentResult && showlastrunscript == true) {
                if(rowData.currentResult.script){
                    val.select = rowData.currentResult.script.versionableItemId;
                }else{
                    val.select = "-1";
                }
            }else if(rowData.defaultScript && rowData.defaultScript.versionableItemId){
                val.select = rowData.defaultScript.versionableItemId;
                defaultScriptId = rowData.defaultScript.versionableItemId;
            }
            var choices = [];
            var tc = rowData.testCase;
            var testscripts = tc ? tc.scripts : null;
            var ts_len = testscripts ? testscripts.length : 0;
            var curSelectIndex = -1;
            var defaultScriptIndex = -1;
            if (ts_len > 0) {
                var found = false;
                var defaultScriptFound = false;
                for (var i = 0; i < ts_len; i++) {
                	var testscript=testscripts[i];
                	var versionableItemId=testscript.versionableItemId;
                    if(!testscript.archived){
                        choices.push({text: testscript.name, value: versionableItemId});
                        if(val.select == versionableItemId){
                            found = true;
                            curSelectIndex = i;
                        }
                        if(versionableItemId == defaultScriptId){
                            defaultScriptFound = true;
                            defaultScriptIndex = i;
                        }
                    }else{
                        if(rowData.selectedScriptId == versionableItemId){
                            rowData.selectedScriptId = null;
                        }   
                        if(val.select == versionableItemId){
                            found = false;
                        }   
                    }
                }
                if(!found && val.select != "-1"){
                    val.select = defaultScriptFound ? rowData.defaultScript.versionableItemId : "-1";
                }
                choices.push({text: LabelNone, value: "-1"});
                if (!rowData.selectedScriptId) {
                    rowData.selectedScriptId = val.select ? val.select : (val.choices.length > 1 ? val.choices[0].value : "-1");
                }
            }else{
                choices.push({text: LabelNone, value: "-1"});
                val.select = "-1";
                rowData.selectedScriptId = "-1";
            }
            // store the testscript values in the row object.
            val.choices = choices;
            rowData.testScriptValues = val;
            
            // get and store the current selected item's name. 
            if(curSelectIndex == -1) {
                var choices_len = choices.length;
                for(var i = 0; i < choices_len; i++) {
                    if(val.select == choices[i].value) {
                        curSelectIndex = i;
                        break;
                    }
                }
            }
            rowData.selectedScriptName = choices[curSelectIndex].text;
        }
    },
     
	getIsCellEditable: function(rowData, atColumnIndex){
		atColumnIndex += (this.showTestCase || (atColumnIndex == 0 )|| (atColumnIndex == 1 )|| (atColumnIndex == 2 ) ? 0 : 1);
		if (atColumnIndex == 8) {
			if (this.isCustomEditable()) {
				var editableRows = this.getEditableRows();
				if (editableRows) {
					var len = editableRows.length;
					for (var j = 0; j < len; j++) {
						if (editableRows[j].id == rowData.id) {
							return true;
						}
					}
				}
				return false;
			}else {
				return true;
			}
		}
		return false;
	},
	    
    getNumColumns: function(content){
        return this.showTestCase ? 13 : 12;
    },

    _columnHeadings: [
		Constants.getMessage("labelName"),
		Constants.getMessage("labelCommunityRiskHeader"),
		Constants.getMessage("labelRiskAssessment"),
		Constants.getMessage("labelTestCase"),
        Constants.getMessage("labelConfig"),
		Constants.getMessage("labelTestPlan"),
		Constants.getMessage("labelIteration"),
		Constants.getMessage("labelOwner"),
		Constants.getMessage("labelScript"),
		Constants.getMessage("labelBlockingStatus"),
		Constants.getMessage("labelLastResult"),
		Constants.getMessage("labelLastMod"),
		Constants.getMessage("labelWeight")
    ],
    
    _customEditableLabel: Constants.getMessage("labelDefaultTS"),
    getColumnHeading: function(content, index){
	    if ((!this.showTestCase) && index > 2){
    		index++;
    	}
    	if (index == 8 && this.isCustomEditable())
    		return this._customEditableLable;
    	
        return this._columnHeadings[index];
    },
  
    getColumnHeadingImage: function(content, atColumnIndex){
        atColumnIndex += (this.showTestCase || (atColumnIndex == 0 )|| (atColumnIndex == 1 )|| (atColumnIndex == 2 ) ? 0 : 1);
		if(this.parent.editable) {
			var actionId = "";
			if(atColumnIndex == 12)
				actionId = Constants.getMessage("labelWeight");
			else if(atColumnIndex == 7) 
				actionId = Constants.getMessage("labelOwner");
			else if(atColumnIndex ==  6)				
				actionId = Constants.getMessage("labelIteration");
			if(actionId != "") {
                var img = {
                    actionId: actionId,
                    src: ImageCache.BULK_CHANGE,
                    disabled: true
                };
                img.tooltip = Constants.getMessage("labelChangeProperties", img.actionId);
                return img;
			}	
		}
        return null;
    },

    getColumnHeadingAlignment: function(atColumnIndex){
        atColumnIndex += (this.showTestCase || (atColumnIndex == 0 )|| (atColumnIndex == 1 )|| (atColumnIndex == 2 ) ? 0 : 1);
        return this.getCellAlignment(null, atColumnIndex);
    },	 
    
    getIsColumnGroupable: function(content, atColumnIndex){
        atColumnIndex += (this.showTestCase || (atColumnIndex == 0 )|| (atColumnIndex == 1 )|| (atColumnIndex == 2 ) ? 0 : 1);
        return ((atColumnIndex > 2 && atColumnIndex < 8 )|| atColumnIndex == 10);     
    },

    getIsColumnSortable: function(content, atColumnIndex)
    {
        atColumnIndex += (this.showTestCase || (atColumnIndex == 0 )|| (atColumnIndex == 1 )|| (atColumnIndex == 2 ) ? 0 : 1);
        return true;   
    },
	
	getIsColumnVisible: function(atColumnIndex)
    {
        if(atColumnIndex == 1)
			return false;
		return true;
    },
    
    getColumnWidth: function(content, atColumnIndex)
    {
        atColumnIndex += (this.showTestCase || (atColumnIndex == 0 )|| (atColumnIndex == 1 )|| (atColumnIndex == 2 ) ? 0 : 1);
        switch(atColumnIndex) {
			case 0: 
                return 10;
			case 1: 
                return 8;
			case 2: 
                return 8;
            case 3: 
                return 12;
            case 4: 
                return this.showTestCase ? 5 : 13;
			case 5:
				return this.showTestCase ? 10 : 13;	
            case 6: 
                return 7;
            case 7: 
                return this.showTestCase ? 8 : 10;
            case 8: 
                return 20;
			case 9: 
                return 3;		
            case 10: 
                return 8;
			case 11:
				return 8;
        }
		//Do not return 0 width, it causes and invalid argument in IE
        return 1;
    },
    
    getContentObjects: function(content){
        return content;
    },
    
    getRowDataId: function(rowData){
        return "_table_row_for_ewi_" + rowData.id;
    },
    
    getCellDisplayType: function(rowData, atColumnIndex){
        atColumnIndex += (this.showTestCase || (atColumnIndex == 0 )|| (atColumnIndex == 1 )|| (atColumnIndex == 2 ) ? 0 : 1);
        var type = TableConstants.RENDER_TYPE_TEXT;
        switch(atColumnIndex) {
			case 1: 
			case 2:
			case 9: 
			case 10: 
                type = TableConstants.RENDER_TYPE_IMAGE;
                break;		
			case 3:
                type = TableConstants.RENDER_TYPE_LINK;
                break;
			case 4:
				type = rowData.config && rowData.config.name ? TableConstants.RENDER_TYPE_LINK : TableConstants.RENDER_TYPE_TEXT;
				break;
            case 8: 
                type = "RenderType.ScriptCombo";
                break;
            case 11: 
                type = TableConstants.RENDER_TYPE_DATE;
                break;                                   
        }
        return type;
    },

    getCellAlignment: function(rowData, atColumnIndex){
		atColumnIndex += (this.showTestCase || (atColumnIndex == 0 )|| (atColumnIndex == 1 )|| (atColumnIndex == 2 ) ? 0 : 1);
		var val = TableConstants.ALIGN_LEFT;
		switch(atColumnIndex){
			case 1: 
			case 2: 
			case 9:
			case 10:
				val = TableConstants.ALIGN_CENTER;
				break; 
		}
        return val ;
    },
    
    getCellDisplayData: function(rowData, atColumnIndex)
    {
        atColumnIndex += (this.showTestCase || (atColumnIndex == 0 )|| (atColumnIndex == 1 )|| (atColumnIndex == 2 ) ? 0 : 1);
        var val = "";
		var currentResult = rowData.currentResult;
        var compact = (this.viewer) ? this.viewer.isCompactMode : false;
        
        switch(atColumnIndex) {
            case 0: 
                val = rowData.name || "";
                if(!compact && this.shouldWrap && val != "") {
                    val = this._wordWrap(val, 20, "\n", false);
                }
                break;
			case 1: 
                val = this._getRiskLevel(rowData.risk, "communityRisk");
                break;
			case 2: 
                val = this._getRiskLevel(rowData.risk, "calculatedRisk");
                break;
			case 3: 
                val = (rowData.testCase && rowData.testCase.name)? rowData.testCase.name : this.labelUnassigned; //TestCase Name
                if(!compact && this.shouldWrap && val != "") {
                    val = this._wordWrap(val, 20, "\n", false);
                }
                break;
            case 4: 
                val = (rowData.config && rowData.config.name) ? rowData.config.name : this.labelUnassigned; //Configuration
                if(!compact && this.shouldWrap && val != "") {
                    val = this._wordWrap(val, 20, "\n", false);
                }
				break;          
            case 5: 
				val = (rowData.testPlan && rowData.testPlan.name) ? rowData.testPlan.name : this.labelUnassigned; //Test Plan
				break;
			case 6:
				val = (rowData.phase && rowData.phase.name) ? rowData.phase.name : this.labelUnassigned;//Iteration
                break;
			case 7: 
                val = (rowData.owner && rowData.owner.name)? rowData.owner.name:this.labelUnassigned;//Owner
                break; 
			case 8: 
                val = rowData.selectedScriptName || LabelNone; //Script
                break;
			case 9: 
                val = ""; //Blocking
                break;	
			case 10:
			    val = "";//Last Result
			    break;
			case 11: 
                var date = new Date();
                date.setTime(rowData.modified);
                val = date; //Last Modified
                break;	
            case 12:
            	if (rowData.weight) {
					val = rowData.weight;
				} else {
					val = "";
				}
            	break;	
		}
        return val;
    },	
    getCellRawData: function(rowData, atColumnIndex)
    {
        atColumnIndex += (this.showTestCase || (atColumnIndex == 0 )|| (atColumnIndex == 1 )|| (atColumnIndex == 2 ) ? 0 : 1);
        var val = "";
        switch(atColumnIndex) {
            case 0: 
                val = (rowData.name || "");
                break;
			case 1: 
                val = this._getRiskLevel(rowData.risk, "communityRisk");
                break;
			case 2: 
                val = this._getRiskLevel(rowData.risk, "calculatedRisk");
                break;		
            case 3: 
                val = (rowData.testCase && rowData.testCase.name) ? rowData.testCase.name : this.labelUnassigned; //TestCase Name
                break;
            case 4: 
                val = (rowData.config && rowData.config.name) ? rowData.config.name : this.labelUnassigned; //Configuration
                break;          
            case 5: 
                val = (rowData.testPlan && rowData.testPlan.name) ? rowData.testPlan.name : this.labelUnassigned; //Test Plan
                break;
            case 6:
                val = (rowData.phase && rowData.phase.name) ? rowData.phase.name : this.labelUnassigned;//Iteration
                break;
            case 7: 
                val = (rowData.owner && rowData.owner.name) ? rowData.owner.name : this.labelUnassigned;//Owner
                break; 
            case 8: 
                val = rowData.selectedScriptName || LabelNone; //Script
                break;
            case 9: 
                if(rowData.defects && rowData.defects.length > 0){
                    val =  this.labelNonBlocking;
					var len = rowData.defects.length;
                    for(var i=0;i<len;i++){
                        if(rowData.defects[i].isBlocking){
                            val = this.labelBlocking;
							break;
                        }
                    }
                }else {
                    val = this.labelNoDefect;
                }
                break;  
            case 10:
                val = rowData.currentResult ? rowData.currentResult.state.id : "none";
                break;
            case 11: 
                val = rowData.modified;
                break;  
        }
        return val;
    },  
	_wordWrap: function(bigString, metric, b, force){ 
		var i, j, s, results = bigString.split("\n"); 
    	if(metric > 0) 
			for(i in results){ 
	        	for(s = results[i], results[i] = "";
					s.length > metric; 
					j = force ? metric : (j = s.substr(0, metric).match(/\S*$/)).input.length - j[0].length || metric,  results[i] += s.substr(0, j) + ((s = s.substr(j)).length ? b : "") 
				); 
	        	results[i] += s; 
    		} 
    	return results.join("\n"); 
	},
    getCellDisplayExtendedInfo: function(rowData, atColumnIndex){  
        atColumnIndex += (this.showTestCase || (atColumnIndex == 0 )|| (atColumnIndex == 1 )|| (atColumnIndex == 2 ) ? 0 : 1);
        var val = null;
		if(atColumnIndex == 9) {
            val = {};
			if(rowData.defects && rowData.defects.length > 0){
				val.image = ImageCache.NOIMAGE;
				val.tooltip = this.labelNonBlocking;
				for(var i=0;i<rowData.defects.length;i++){
					if(rowData.defects[i].isBlocking){
						val.image = ImageCache.BLOCKING_DEFECT;
						val.tooltip = this.labelBlocking;
						return val;
					}
				}
			}else{
				val.image = ImageCache.NOIMAGE;
				val.tooltip = this.labelNoDefect;
			}
        }
		else if(atColumnIndex == 1) {
            val = {};
			var level = this._getRiskLevel(rowData.risk, "communityRisk");
			var image = ImageCache.RISK_LEVELS[level];
            if (image) {
                val.image = image;
                val.tooltip = this._getRiskLabel(level);
            }
        }
		else if(atColumnIndex == 2) {
            val = {};
			var level = this._getRiskLevel(rowData.risk, "calculatedRisk");
			var image = ImageCache.RISK_LEVELS[level];
            if (image) {
                val.image = image;
                val.tooltip = this._getRiskLabel(level);
            }
        }
		else if(atColumnIndex == 3) {
            val = {};
            val.href = Utility.getTestCaseURI(rowData.testCase.id);
			val.tooltip = Constants.getMessage("labelClickToOpenTestCase")				
        }
		else if(atColumnIndex == 4){
			val = {}
			if(rowData.config && rowData.config.id)
				val['href'] = ConfigurationUriUtil.getEditConfigurationURI(rowData.config.id);
		}
		else if(atColumnIndex == 8) {
            // the test scripts values are pre-built. Just return it.
            return rowData.testScriptValues;
        }     
        else if(atColumnIndex == 10) {
            val = {};
			var resultState = rowData.currentResult ? rowData.currentResult.state.id : null;
			val.image = Utility.getImageForState(resultState);
            val.href = rowData.currentResult && rowData.currentResult.state ? Utility.getEWIResultsURI(rowData.itemId) : "javascript:{}";
			val.tooltip = rowData.currentResult ? Utility.getResultsTooltip({result: rowData.currentResult, ewiItemId:rowData.itemId}) : Utility.getResultsTooltip();
        }		       
        return val;
    },
	
	setCustomEditable: function(flag,editableRows){
		this.customEditable = flag;
		if(flag && editableRows)
			this.editableRows = editableRows;
	},
    getEditableRows:function(){
		return this.editableRows;
	},
	isCustomEditable: function(){
		return this.customEditable;
	},
	
	setContributors: function(contributors){
		this.contributors = contributors;
	},
	
	setIterations: function(iterations){
		this.iterations = iterations;
	},
	
	//return value is int (0 ~ 5)
	_getRiskLevel: function(dtoRisk, riskType) {
		if (dtoRisk) {
			var levelString = null;
			switch (riskType) {
				case "communityRisk":
					levelString = dtoRisk.slice(dtoRisk.indexOf("communityRisk")+14, dtoRisk.indexOf("communityRisk")+15);
					break;
				case "calculatedRisk":
					levelString = dtoRisk.slice(dtoRisk.indexOf("calculatedRisk")+15, dtoRisk.indexOf("calculatedRisk")+16);
					break;
			}
			var level = Number(levelString);
            if (level != NaN && level >= 0) {
				return level;
            } 
		}
		return 0;
	},
	
	_getRiskLabel: function(riskLevel) {
        switch (riskLevel) {
            case 1:
                return Constants.getMessage("labelVeryLow");
            case 2:
                return Constants.getMessage("labelLow");
            case 3:
                return Constants.getMessage("labelNeutral");
            case 4:
                return Constants.getMessage("labelHigh");
            case 5:
                return Constants.getMessage("labelVeryHigh");
        }
        return Constants.getMessage("msgNoRiskShort");
	}
    
});

dojo.declare("ExecutionWorkItemTableView.TableFilterProvider", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentFilterProvider,
{
    constructor: function(tableView, openSection, defaultToMine) {
        this.tableView = tableView;
        this.initOpenFilter = openSection;
		this.defaultToMine = (defaultToMine === true);		

        // define the static filters
        this.filters = [
            {
                name: "myItemsOnly",  // must match key in the arg list of the API
                title: Constants.getMessage("labelOnlyMyTERs"),
                promptTitle: Constants.getMessage("labelOnlyMyTERs"),
                type: TableContentFilterProvider.FIELD_CHECKBOX,
                defaultValue: this.defaultToMine,
                params: null
            }, {
                name: "name",  // must match key in the arg list of the API
                title: Constants.getMessage("labelname"),
                promptTitle: Constants.getMessage("labelName"),
                type: TableContentFilterProvider.FIELD_TEXT,
                defaultValue: null,
                params: null
            }
        ];
    },

    getTitle: function() {
        return Constants.getMessage("labelFilterTitle");    
    },
    
    getSummaryText: function() {
        return Constants.getMessage("labelFilterDescription", Constants.getMessage("labelEWIs"));
    },
    
    getIsSectionOpenInitially: function() {
       return this.initOpenFilter; 
    },
    
    getInitialVisibleFilterCount: function() {
        return 4;    
    },
	
    getFilters: function() {
        return this.filters;
    },	
    
    getFilterCount: function() {
        return this.filters.length;
    },
    
    getFilterName: function(index) {
        return this.filters[index].name;
    },
    
    getFilterTitle: function(index) {
        return this.filters[index].title;
    },
    
    getFilterPromptTitle: function(index) {
        return this.filters[index].promptTitle;        
    },
    
    getFilterType: function(index) {
        return this.filters[index].type;
    },
    
    getFilterDefaultValue: function(index) {
        return this.filters[index].defaultValue;
    },
    
    getFilterParams: function(index) {        
        return this.filters[index].params;
    },
    
    getCustomField: function(index) {
        return null;
    },
    
    getActionsInfo: function() {
        var actions = [
            {
                id: "cancel",
                title: Constants.getMessage("labelReset"),
                callback: dojo.hitch(this, "filterResetActionInvoked"),
                callbackData: null,
                isDefault: false
            }, {
                id: "run",
                title: Constants.getMessage("labelRun"),
                callback: dojo.hitch(this, "filterRunActionInvoked"),
                callbackData: null,
                isDefault: true
            }
        ];
        return actions;
    },
    
    filterResetActionInvoked: function(actionName, filters) {
        this.tableView.tableViewer.setContentFilterAttributeProvider(this.tableView.filterProvider);
    },

    filterRunActionInvoked: function(actionName, filters){
        var args = {};
        for (var nameKey in filters) {
            if (filters[nameKey] != null) {
                if (nameKey == "weight") {
                    args['weightComparator'] = filters[nameKey].operator;
                    args['weightValue'] = filters[nameKey].value;
                } else {
                    args[nameKey] = filters[nameKey] || "";
                    if (args[nameKey] == 'Any@@') 
                        args[nameKey] = '';
                }
            }
        }
        this.tableView.runQuery(args);
    }
});

dojo.declare("com.ibm.rqm.execution.web.ui.internal.view.table.ExecutionWorkItemTableView", 
    [dijit._Widget, dijit._Templated, AbstractFilteredExecutionTableView],
{    
    templateString: '<div dojoAttachPoint="_tableViewerNode" class="com-ibm-rqm-test-artifact-table-view" tabindex="-1">' +
	                '  <div dojoType="com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout" "noline"=true dojoAttachPoint="viewHeaderNode">' +
                    '    <div dojoAttachPoint="_tableViewerNode" class="com-ibm-rqm-test-artifact-table-view" tabindex="-1"></div>' +
                    '  </div>' +
				    '</div>',

    editable: true,
    printable: false,
    widgetsInTemplate: true,

    constructor: function() {
        this.actions = [];
        this._actionButtons = [];
	 	this.executionWorkItems = [];
		this.queryName = null;
		this.executable = false;
        this.showTestCase = true;
		this._itemsToTrack = {};
		this.contentAfterEdit = [];
        this.showInitLoadProgress = false;
        this.showQueryFilters = false;
        this.filterArgs = null;
		this.archiveEnabled = true;
	 },

    postCreate: function() {
        this.inherited("postCreate", arguments);

        // the view is in a query page if there is a query name otherwise it is within
        // some container that don't need the header
        this.isQueryPage = this.queryName;
		this._projectAlias = com.ibm.asq.common.web.ui.internal.util.Utility.getCurrentProjectAreaAlias();
		
        // apply the user preference whether to initially open the filter area
        if (this.showQueryFilters) {
			//set options for search filters
	        this.setSearchFunction(dojo.hitch(ExecutionWorkItemClient, "searchExecutionWorkItem"));
			this.setSearchCallback(dojo.hitch(this, "show"));
	        this.setResponseHandlerType(EWIMapper);
	        this.setTypeLabel(Constants.getMessage("labelEWIs"));
					
			this._initializeFilters();
        } else {
            this._initialize();
        }
    },
	
    // Constructs the query filter definitions and the content filter provider for the
    // table. The table will construct the filters section based on the definitions.
    // 
    _initializeFilters: function() {
        // create the filter provider for the table
        this.filterProvider = new ExecutionWorkItemTableView.TableFilterProvider(this, this.isInitiallyOpen(), this.isDefaultsToMine());

        // get the list of contributors for originator and owner filters
        if (this.contributors && this.contributors.length > 0) {
            var contributors = [];
            var owners = [];
            for (var i = 0; i < this.contributors.length; i++) {
                var isUnassignedContributor = com.ibm.asq.common.web.ui.internal.util.Utility.isUnassignedUserId(this.contributors[i].itemId);
                contributors.push({
                    name: isUnassignedContributor ? Constants.getMessage("labelUnassigned") : this.contributors[i].name,
                    value: this.contributors[i].itemId,
                    checked: false
                });
                owners.push({
                    name: isUnassignedContributor ? Constants.getMessage("labelUnassigned") : this.contributors[i].name,
                    value: this.contributors[i].itemId,
                    checked: false
                });
            }
                
            this.filterProvider.filters.push ({
                name: "originatorUUIDs",  // must match key in the arg list of the API
                title: Constants.getMessage("labeloriginatorLabel"),
                promptTitle: Constants.getMessage("labelOriginator"),
                type: TableContentFilterProvider.FIELD_TOGGLELIST,
                defaultValue: [],
                params: {options: contributors}
            });
            
            this.filterProvider.filters.push ({
                name: "ownerUUIDs",  // must match key in the arg list of the API
                title: Constants.getMessage("labelowner"),
                promptTitle: Constants.getMessage("labelOwner"),
                type: TableContentFilterProvider.FIELD_TOGGLELIST,
                defaultValue: [],
                params: {options: owners}
            });
        }

        this.weightFilter = {
            name: "weight",
            title: Constants.getMessage("labelWeight") + Constants.getMessage("labelColen"),
            promptTitle: Constants.getMessage("labelWeight"),
            type: TableContentFilterProvider.FIELD_NUMERIC,
            defaultValue: null,
            params: {'showNumericOperators':true}            
        };
		
		var finishFilters = dojo.hitch(this, function() {
            this.filterProvider.filters.push(this.weightFilter);
            this._initialize();			
		});

        // initlize the execution state filter
		var statesFilter = {           
            //filterName, filterLabel, filterPrompt, filterType, callback
            name: "stateIds",
            label: Constants.getMessage("labelStateLabel"),
            prompt: Constants.getMessage("labelState"),
			type:TableContentFilterProvider.FIELD_TOGGLELIST
        }
        this.addExecutionStateFilter(statesFilter, this.filterProvider.filters, finishFilters);
    },	
        
    _initialize: function()  {
        this.printable = this.parentSection ? this.parentSection.isPrintView() : false;
		// We are trying to get the Last Modified column index 
		var lastModifiedColumn = this.showTestCase ? 11 : 10;

        //create the table viewer
        var tableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer({
            //turn off all controls if in print mode 
            showPagingControl: !this.printable,
			showPagingRangeControl: !this.printable,
            showGroupFilterControls: !this.printable,
            showPagingActionsControls: !this.printable,
			sortByColumn: lastModifiedColumn,
			sortDir: TableConstants.SORT_DIR_DESCEND,
            allowMultiSort: true,
            allowAdjustSettings: true,
            autoSaveSettings: true
        });
			        
        if (this.showQueryFilters) {
			this.initFilterProvider(this.filterProvider);			
            tableViewer.setContentFilterAttributeProvider(this.filterProvider);
        }

        this._tableViewerNode.appendChild(tableViewer.domNode);
        var content = this.executionWorkItems ? this.executionWorkItems : [];

        if (this.isQueryPage) {
            // it is a query page so set header title and add table viewer as the header content
            this.viewHeaderNode.setTitle(this.queryName);
            this.viewHeaderNode.setCSHelpId("rqm_view_ters.html");
			this.viewHeaderNode.setCSHelpButtonLabel(this.queryName+" "+Constants.getMessage("labelHelp"));        
            this._tableViewerNode.appendChild(tableViewer.domNode);
        } else {
            // it is not a query page i.e. within a section without header
            this.viewHeaderNode.domNode.style.display = "none";
            this.domNode.appendChild(tableViewer.domNode);
        }
        
        // setup the table's id for saving table settings
        tableViewer.tableId = (this.isQueryPage) ? "RQM-TER-QUERY-TABLEVIWER" : "RQM-TER-TABLEVIWER";
        
		var shouldWrap = CommonPreferenceClient.getIsWordWrapEnabled();
        var showArgs = {
            showTestCase: this.showTestCase,
			contributors: this.contributors,
			iterations: this.iterations,
			parent: this,
			shouldWrap: shouldWrap,
            viewer: tableViewer
        }
        tableViewer.setContentProvider(new ExecutionWorkItemTableView.TableProvider(showArgs));
        tableViewer.setContent(dojo.clone(content));
		tableViewer.setTableSummary(Constants.getMessage("labelTableSummary", this.queryName ? this.queryName: Constants.getMessage("labelEWIs")));
		tableViewer.getContentProvider().setCustomEditable(false);  
		var tableListener = new ExecutionWorkItemTableView.TableListener(this);
		if (this.executable && this.rowCheckListener)
           tableListener.setRowCheckListener(this.rowCheckListener);
		tableViewer.setTableListener(tableListener);		
		var cellModifier = new ExecutionWorkItemTableView.CellModifier(showArgs)
		var listener = {
			context: this,
			method:dojo.hitch(this, function(rowObject, state) {
                    this.storeChangedEWIs(rowObject);
                })
		}
		cellModifier.setComboChangeListener(listener)
		tableViewer.setCellModifier(cellModifier);
		this.inEditMode = false;
		tableViewer.setTableRowsCheckable(this.editable && this.executable && !this.printable, false);
        tableViewer.registerCellRenderer("RenderType.TextCombo", 
			new com.ibm.rqm.execution.web.ui.internal.view.table.cellrenderers.TextComboCellRenderer());
				
		tableViewer.registerCellRenderer("RenderType.ScriptCombo",
			new com.ibm.rqm.execution.web.ui.internal.view.table.cellrenderers.ScriptComboCellRenderer());
		tableViewer.customEditable = false;
		
		//add refresh action via 'refreshQuery' api if showing filters
		if (this.showQueryFilters) {
        	tableViewer.addAction("refresh", Constants.getMessage("labelRefresh"), this, "refresh-icon-image", dojo.hitch(this, "refreshQuery"));    
        }
		var len = this.actions?this.actions.length:0;
        for (var i = 0; i < len; i++) {
            var action = this.actions[i];
            var actionButton = tableViewer.addAction(action.actionId, action.label, action.actionHandler, action.iconClass);
			actionButton.setDisabled((action.disabled === true));
            if (action.hidden && action.hidden == true)
                dojo.addClass(actionButton.domNode, "dijitDisplayNone");
            this._actionButtons.push(actionButton);
        }

        this.ewi_exe_perm = PermissionsClient.getStoredPermission(PermissionsClient.OP_EXECUTION_EWI_EXE);
        var ewi_perm = PermissionsClient.getStoredPermission(PermissionsClient.OP_EXECUTION_EWI);

        if (this.archiveEnabled && (!ewi_perm || ewi_perm.archive)) {
            this.deleteActionNode = tableViewer.addAction("delete", // action id
                Constants.getMessage("labelDelete"), // label
                null, // callback data
                "delete-icon-image", // icon class
                dojo.hitch(this, "_onDeleteActionClick")); // callback
            this.deleteActionNode.setDisabled(true);
        }
        

        if(this.showInitLoadProgress) {
            tableViewer.showLoadingProgress();
        }
		if (this.printable) {
			tableViewer.setContentPageSize(-1);
		}		
        tableViewer.show();
		tableViewer.setEditable(this.editable);		
		this.tableViewer = tableViewer;		  
        
		var printHistoryCARMenu = new dijit.Menu({ style: "display: none;"});
		var printSummaryMenu = new dijit.Menu({ style: "display: none;"});
		var printMultipleMenu = new dijit.Menu({ style: "display: none;"});
		
		this._itemsToTrack.menus = [];
		this._itemsToTrack.menus.push(printHistoryCARMenu);//Add menu items so that they can be deleted later
		this._itemsToTrack.menus.push(printSummaryMenu);
		this._itemsToTrack.menus.push(printMultipleMenu);
		
        var normalOption = new dijit.MenuItem({
        	label: Constants.getMessage("printLabelCAR"),
        	onClick: dojo.hitch(this, "_onPrintPdfActionClick")
        });
        var historyOption = new dijit.MenuItem({
        	label: Constants.getMessage("printLabelHistory"),
        	onClick: dojo.hitch(this, "_onPrintHistoryActionClick")
        });
        var summaryOption = new dijit.MenuItem({
        	label: Constants.getMessage("printLabelSummary"),
        	onClick: dojo.hitch(this, "_onPrintPdfActionClick")
        });        
        var multipleOption = new dijit.MenuItem({
        	label: Constants.getMessage("printLabelMultiple"),
        	onClick: dojo.hitch(this, "_onPrintPdfActionClick")
        });
		
        printHistoryCARMenu.addChild(normalOption);
        printHistoryCARMenu.addChild(historyOption);      
        printSummaryMenu.addChild(summaryOption);
        printMultipleMenu.addChild(multipleOption);
        
       	this.printSummaryActionNode = tableViewer.addAction(
       			"printpdfsummarymenu",
       			Constants.getMessage("labelPDFView"),
       			null,
       			"pdf-icon-image",
       			dojo.hitch(this, "_onPrintPdfActionClick"),
       			printSummaryMenu
       	);      	
       	this._actionButtons.push(this.printSummaryActionNode);
       	this.enableAction("printpdfsummarymenu");
       	
       	this.printHistoryCARActionNode = tableViewer.addAction(
       			"printpdfhistorycarmenu",
       			Constants.getMessage("labelPDFView"),
       			null,
       			"pdf-icon-image",
       			dojo.hitch(this, "_onPrintPdfActionClick"),
       			printHistoryCARMenu
       	);
       	this._actionButtons.push(this.printHistoryCARActionNode);
       	this.hideAction("printpdfhistorycarmenu");
       	
       	this.printMultipleActionNode = tableViewer.addAction(
       			"printpdfmultiplemenu",
       			Constants.getMessage("labelPDFView"),
       			null,
       			"pdf-icon-image",
       			dojo.hitch(this, "_onPrintPdfActionClick"),
       			printMultipleMenu
       	);
       	this._actionButtons.push(this.printMultipleActionNode);
       	this.hideAction("printpdfmultiplemenu");
       	
		//if preference specifies, run the query
		if (this.showQueryFilters) {
			this.initRunQuery();
		} 
    },
	    
	 // API
    getSelectedEWIs: function() {
        return this.tableViewer.getCheckedRows();
    },

    getAction: function(actionId) {
		var len = this.actions?this.actions.length:0;
        for (var i = 0; i < len; i++) {
            if (this.actions[i].actionId == actionId) {
                return this.actions[i];
            }
        }        
    },
    
    getActionButton: function(actionId) {
		var len = this._actionButtons ? this._actionButtons.length : 0;
        for (var i = 0; i < len; i++) {
            if (this._actionButtons[i].actionId == actionId) {
                return this._actionButtons[i];
            }
        }        
    },
    
    hideAction: function(actionId) {
        var button = this.getActionButton(actionId);
        if (button && !dojo.hasClass(button.domNode, "dijitDisplayNone")) {
			dojo.addClass(button.domNode,"dijitDisplayNone");
        }
    },
    
    showAction: function(actionId) {
        var button = this.getActionButton(actionId);
        if (button && dojo.hasClass(button.domNode, "dijitDisplayNone")) {
			dojo.removeClass(button.domNode,"dijitDisplayNone");
        } 
    },    

	disableAction: function(actionId) {
        var button = this.getActionButton(actionId);
         if (button ) {
            button.setDisabled(true);
        } 
    },
	
	enableAction: function(actionId) {
        var button = this.getActionButton(actionId);
        if (button ) {
            button.setDisabled(false);
        } 
    }, 
        
    appendEWI: function(ewi) {
    	var content = this.tableViewer.getContent();
        content.push(ewi);
        this.tableViewer.setContent(content);
        this.tableViewer.show();
    },
	
    addConfigurationInfo: function(ewiId, config) {
        var content = this.tableViewer.getContent();
		var len = content.length;
        for (var i = 0; i < len; i++) {
        	if (content[i].id == ewiId) {
        		content[i].config = config;
				break;
        	}
        }
        this.tableViewer.setContent(content);
        this.tableViewer.refresh();
    },
	
	updateEWI: function(ewi,refresh) {
        var content = this.tableViewer.getContent();
		var len = content.length;
        for (var i = 0; i < len; i++) {
        	if (content[i].id == ewi.id) {
        		content[i].phase = ewi.phase;
				content[i].owner = ewi.owner;
				content[i].modified = ewi.modified;
				content[i].stateId = ewi.stateId;
				content[i].defaultScript = ewi.defaultScript;
				if(!ewi.defaultScript || !ewi.defaultScript.versionableItemId)
					content[i].selectedScriptId = null;
				content[i].defects = ewi.defects;
				break;
        	}
        }
        this.tableViewer.setContent(content);
		if(refresh)
        	this.tableViewer.refresh();
    },
	
	refresh: function(content, iterations, contributors, resetProgress) {
		var tableContentProvider = this.tableViewer.getContentProvider()
		this.iterations = iterations ? iterations : this.iterations;
		this.contributors = contributors ? contributors : this.contributors;
        tableContentProvider.setIterations(this.iterations)
		tableContentProvider.setContributors(this.contributors);
		// need this for WI 4015
		var oldContent = this.tableViewer.getContent();
		if(oldContent && content){
			var len = oldContent.length;
			var len2 = content.length;
			for(var i=0;i<len;i++){
				for(var j=0;j<len2;j++){
					if(content[j].itemId == oldContent[i].itemId){
						if(oldContent[i].selectedScriptId){
							content[j].selectedScriptId = oldContent[i].selectedScriptId;
							break;
						}
					}
				}
			}
		}
        if(this.showInitLoadProgress && resetProgress) {
            this.tableViewer.endLoadingProgress();
            this.showInitLoadProgress = false;
        }
		this.executionWorkItems = content ? content:[];
		if(this.printSummaryActionNode){
			if(!content || !content.length){
				this.printSummaryActionNode.setDisabled(true);
				dojo.addClass(this.printSummaryActionNode.domNode,"dijitButtonDisabled");
			}else{
				this.printSummaryActionNode.setDisabled(false);
				dojo.removeClass(this.printSummaryActionNode.domNode,"dijitButtonDisabled");
			}
		}
		this.tableViewer.setContent(dojo.clone(this.executionWorkItems));
		this.tableViewer.refresh();
		this.enableEditableActions(false);
	 },
	 
	 show: function(ters) {
        if (this.ewiList) {
            this.ewiList._setEWITableContent(ters || []);
        } else {
            this.refresh(ters || []);
            this.stopInProgress();
        }	 	
	 },
	
	isCustomEditable: function()
	{
		return this.tableViewer.getContentProvider().isCustomEditable();;
	},
	
	toggleTableStateForEditing: function(discard)
	{
		if(this.inEditMode && discard)
			this.tableViewer.setContent(dojo.clone(this.executionWorkItems));
		this.inEditMode = !this.inEditMode;
		var selectedEWIs = null;
		if(this.inEditMode){
			selectedEWIs = this.tableViewer.getCheckedRows();
			this.contentAfterEdit = selectedEWIs;
		}
		
		this.tableViewer.getContentProvider().setCustomEditable(this.inEditMode,selectedEWIs)
		this.tableViewer.setTableRowsCheckable(this.executable, false);
		this.enableEditableActions(this.inEditMode);
		this.changedEWIList = []; //initial definition
		this.tableViewer.refresh();
		this.toggleTableHeaderName(this.inEditMode);
	},
	
	toggleTableHeaderName: function(inEditMode) {
		//change Test Script column header. If in edit mode, the column header is "Default Test Script".
		//Otherwise, it is "Test Script"
		var columnIndex = this.showTestCase ? 8 : 7;
		var header = this.tableViewer.headerRenderer.getColumnHeaderAt(columnIndex);
		if(header) {
			var text = inEditMode ? Constants.getMessage("labelDefaultTS") : Constants.getMessage("labelScript");
			var children = header.getElementsByTagName("A");
			if(children && children.length == 1)
				children[0].innerHTML = text;
		}
	},
	
	getContentAfterEdit: function(){
		return this.contentAfterEdit;   //Store the checked row's state when click the "Edit" button.
	},
	
    storeChangedEWIs: function(rowData)
    {
        var found = false;
        if (this.changedEWIList) {
			var len = this.changedEWIList.length;
            for (var i = 0; i < len; i++) {
                if (this.changedEWIList[i].id == rowData.id) {
                    found = true;
                    this.changedEWIList[i].defaultScript = rowData.defaultScript ? rowData.defaultScript.versionableItemId : null;
                }
            }
            if (!found) {
                var args = {
                    id: rowData.id,
                    owner: rowData.owner ? rowData.owner.userId : null,
                    testPhase: rowData.phase ? rowData.phase.itemId : null,
                    defaultScript: rowData.defaultScript ? rowData.defaultScript.versionableItemId : null,
                    newExecutionWorkItem: false,
                    ewiStateId: rowData.stateId,
                    weight: rowData.weight
                }
                this.changedEWIList.push(args);
            }
        }
    },
	
	getChangedEWIs: function()
	{
		var allChanges = [];  // Adding checked rows which values changed before edit and no change before save
		
		var included = this.getContentAfterEdit();
		var len = included.length;
		for( var m = 0; m < len; m ++){
			included[m].needToPost = false;  
			if( included[m].isChanged){
				included[m].needToPost = true;
			}
		}

		if(included.length == this.changedEWIList.length){
			return this.changedEWIList;
		}
		var missed = [];
		for(var i = 0; i < len; i ++){
			var found = false;
			for(var j = 0; j < this.changedEWIList.length; j ++){
				if(included[i].id == this.changedEWIList[j].id){
					found = true;
					break;
				}
			}
			if((!found) && included[i].needToPost){
				missed.push(i);
			}
		}
		var len2 = missed.length;
		for( var k = 0; k < len2; k ++){
			var ewi = included[missed[k]];
			var args = {
					id: ewi.id,
					defaultScript: ewi.defaultScript ? ewi.defaultScript.versionableItemId : null,
					ewiStateId: ewi.stateId
				}
				this.changedEWIList.push(args);
		}		
		return this.changedEWIList;
	},
	
	enableEditableActions: function(editable)
	{
		if (editable) {
			this.disableAction("edit");
			this.hideAction("edit");
			this.hideAction("execute");
			this.hideAction("resume");
			this.hideAction("unblock");
			this.hideAction("refresh");
			if(this.deleteActionNode)
				dojo.addClass(this.deleteActionNode.domNode, "dijitDisplayNone");
			this.showAction("discardedit");
            this.showAction("save");
			this.enableAction("discardedit");
			this.enableAction("save");
			this.hideAction("generate");
		} else {
            if (!this.ewi_exe_perm || this.ewi_exe_perm.execute) {
                this.showAction("execute");
                this.showAction("resume");
                this.disableAction("execute");
                this.disableAction("resume");
            } else {
                this.hideAction("execute");
                this.hideAction("resume");
            }
			this.showAction("unblock");
			this.showAction("refresh");
			this.showAction("edit");
			this.showAction("generate");
						
			//generate/execute actions for snapshot view		
			var section = this.parentSection;
			if (this.editable && section && section.canGenerateEWI && section.canGenerateEWI()) {
				this.enableAction("generate");
			} else if (!this.editable && section && section.isSnapshot()) {
				//snapshots - execute/generate must be enabled
				this.tableViewer.setTableRowsCheckable(true, true);
				this.enableAction("generate");
			} else {
				this.disableAction("generate");
			}
					
			//hidden class doesnt work with IE7
			if (this.deleteActionNode) {
				dojo.removeClass(this.deleteActionNode.domNode, "dijitDisplayNone");
				this.deleteActionNode.setDisabled(true);
			}
			this.disableAction("unblock");
			this.disableAction("edit");
				
			//need to disable first otherwise dijit unhides it
			this.disableAction("save");
			this.disableAction("discardedit");
			this.hideAction("save");
			this.hideAction("discardedit");
			this.enableAction("refresh");			
		}
	},    
	
	_onPrintHistoryActionClick: function() {
		var type = "executionworkitem";
		var selectedScripts = this.tableViewer.getCheckedRows();
		var loc = window.location.href;
		loc = loc.replace(/[&]/g,"%26");
		var summary = false;
		if (!selectedScripts.length){
			selectedScripts = this.executionWorkItems;
			summary = true;
		}
		this.tableViewer.sendPdfHistoryRequest(selectedScripts,type,loc,this._projectAlias, summary);
	},

	_onPrintPdfActionClick: function() {
		this.tableViewer._history = false;
        var type = "executionworkitem";
        var selectedScripts = this.tableViewer.getCheckedRows();
        var loc = window.location.href;
		loc = loc.replace(/[&]/g,"%26");
		var summary = false;
		if (!selectedScripts.length){
				selectedScripts = this.executionWorkItems;
				summary = true;
			}
		this.tableViewer.sendPdfPrintRequest(selectedScripts,type,loc,this._projectAlias, summary);
    },

    _onDeleteActionClick: function() {
        var args = {
            'message': Constants.getMessage("msgDelEWIConfirm"),
            'yesCallback': 
                function(view) {
                    view._deleteAction();
                },
            'yesCallbackData': this,
            'noCallback': null,
            'noCallbackData': null
        };
        var confirmDialog = new YesNoDialog(args);
        confirmDialog.setSecondaryTitle(Constants.getMessage("labelConfirmation"));
        confirmDialog.open();
    },

    _deleteAction: function() {         
        var selectedEWIs = this.tableViewer.getCheckedRows();
        this.deleteActionNode.setDisabled(true);
        this.selectedEWICount = selectedEWIs.length;
        this.errorEWICount = 0;
        this.deletedEWICount = 0;
        if (this.selectedEWICount > 0) {
			var ewiList = this.ewiList;
			if(ewiList){
				var ewiSaveContextGroup = ewiList.ewiSaveContextGroup;
				if(ewiSaveContextGroup && ewiSaveContextGroup.length) {
					var length = ewiSaveContextGroup.length;
					for (var j = 0; j < length; j++){
						ewiSaveContextGroup[j].removeEwis(selectedEWIs);
					}
				}
			}
			var nEwi = this.selectedEWICount;
			var itemIds = [];
			var stateIds = [];
			var ewiName = "";
            for (var i = 0; i < nEwi; i++) {
				var selectedEWI = selectedEWIs[i];
				if(!selectedEWI.isNew){
            		itemIds.push(selectedEWI.itemId);
            		stateIds.push(selectedEWI.stateId);
            		ewiName = selectedEWI.name; 
            	}
            }
            nEwi = itemIds.length;
            if (nEwi > 0){
	            var responseHandler = new ServiceResponseHandler(this, "_deleteSuccess", "_deleteFailure");
	            var args = {
	                        uuid_ewis: itemIds,
							ewiStateIds:stateIds,
	                        archive: true
		                    };
				ExecutionWorkItemClient.postArchiveEWI(responseHandler, args);
	            if (this.isQueryPage) {
	                this.viewHeaderNode.setProgressStart(Constants.getMessage("msgDeletingEWI", ewiName));
	            }
	        }else{
				this._deleteSuccess();
			}
	        
        }
    },
	
    _deleteSuccess: function(response) {
        if (this.isQueryPage)
            this.viewHeaderNode.setProgressEnd();
        if (response) {
        	this.deletedEWICount= +response;
        }else{
        	this.deletedEWICount = 0;
        }
        this._setDeleteStatus();

    },
    
    _deleteFailure: function(err) {
        this.errorEWICount = this.selectedEWICount;
        if (this.isQueryPage)
            this.viewHeaderNode.setProgressEnd();
        this._setDeleteStatus();
    },
    
    _setDeleteStatus: function() {
        if ((this.deletedEWICount + this.errorEWICount) == this.selectedEWICount) {
            if (this.isQueryPage)
                this.viewHeaderNode.setStatus(
                    Constants.getMessage("msgDeletedEWI", this.deletedEWICount, this.selectedEWICount),
                    this.errorEWICount == 0 ? ViewHeaderLayout.SUCCESS : this.selectedEWICount == 1 ? ViewHeaderLayout.ERROR : ViewHeaderLayout.INFO
                );
            if (this.deletedEWICount > 0) {
                // notify all pages (including itself) execution workitem are deleted
                dojo.publish(GlobalEvents.ArtifactsDeleted, [Constants.TYPE_EWI, this.tableViewer.getCheckedRows()]);
				if(!this.isQueryPage){//Inside editor Update myself
					this.onArtifactChanged(GlobalEvents.ArtifactsDeleted, Constants.TYPE_EWI, this.tableViewer.getCheckedRows());
				}
            }
        }
    },

    // handler on artifacts changed
    onArtifactChanged: function(changeType, artifactType, artifactArray) {
        // only care about EWI
		var len = artifactArray.length;
        if (artifactType == Constants.TYPE_EWI) {
            if (changeType == GlobalEvents.ArtifactsAdded) {
                // add EWI to the table
                if (!this.executionWorkItems)
                    this.executionWorkItems = artifactArray;
                else
                    this.executionWorkItems = this.executionWorkItems.concat(artifactArray);
            } else {
				var executionWorkItems = this.executionWorkItems;
                // iterate through the array of artifacts
                for (var i = 0; i < len; i++) {
					var len2 = executionWorkItems.length;
                    // iterate through the array of EWI's in the table
                    var artifact = artifactArray[i];
                    for (var j = 0; j < len2; j++) {
                        // handle the matching EWI
                        if (artifact.id == executionWorkItems[j].id) {
                            if (changeType == GlobalEvents.ArtifactsUpdated) {
                                // swap EWI on update
								if(!artifact.config)
									artifact.config = this.executionWorkItems[j].config;
                                executionWorkItems.splice(j, 1, artifact);
                            } else if (changeType == GlobalEvents.ArtifactsDeleted) {
                                // remove EWI from table on delete
                                executionWorkItems.splice(j, 1);
                            }
                            break;
                        }
                    }
                }
            }
            this.tableViewer.setContent(this.executionWorkItems);
            this.tableViewer.refresh();
        }else if ((artifactType == Constants.TYPE_CASE) && ((changeType == GlobalEvents.ArtifactsUpdated))){
			var executionWorkItems = this.executionWorkItems;
			var len2 = executionWorkItems.length;
			for (var i = 0; i < len; i++) {
				var artifact = artifactArray[i];
                // iterate through the array of EWI's in the table
                for (var j = 0; j <len2; j++) {//Should traverse all EWIs to update test case
                    // handle the matching EWI
                    if (artifact.id == executionWorkItems[j].testCase.id) {
							executionWorkItems[j].testCase =artifact; 
                    }
                }
            }
			this.tableViewer.setContent(this.executionWorkItems);
            this.tableViewer.refresh();
		}
    },
	
	tableHeaderColumnActionInvoked: function(columnIndex, actionId) {
		var self = this;
        if (actionId == Constants.getMessage("labelWeight")) {
            var args = {
                actionId: actionId,
                okCallback: dojo.hitch(this, "_handleTERBulkChanged")
            }
            var dlg = new com.ibm.rqm.planning.web.ui.internal.view.common.properties.SelectWeightPopup();
            dlg.initialize(args);
        }
		if (actionId == Constants.getMessage("labelOwner")) {
            var handler = {
                success: function(users){
                    if (dojo.isArray(users) && users.length > 0) {
						var len = users.length;
                        var owners = [];
                        for (var i = 0; i < len; i++) {
                            if (users[i].name != "ADMIN" && users[i].name != "GUEST" && !users[i].archived) {
								if(com.ibm.asq.common.web.ui.internal.util.Utility.isUnassignedUserId(users[i].itemId))
									users[i].name = Constants.getMessage("labelUnassigned");
                                owners.push(users[i]);
                            }
                        }
                        
                        var args = {
                            owners: owners,
                            actionId: actionId,
                            okCallback: dojo.hitch(self, "_handleTERBulkChanged")
                        }
                        
                        var dlg = new com.ibm.rqm.planning.web.ui.internal.view.common.properties.SelectOwnerPopup();
                        dlg.initialize(args);
                    }
                    
                },
                error: function(e){
                    console.error(e);
                }
            };
            var responseHandler = new ServiceResponseHandler(handler, "success", "error");
            UserClient.getContributors(responseHandler);
        }
		if (actionId == Constants.getMessage("labelIteration")) {
			var selectedEWIs = this.tableViewer.getCheckedRows();
			var samePlan = true;
			var planItemId = selectedEWIs && selectedEWIs[0].testPlan? selectedEWIs[0].testPlan.versionableItemId : "";
			var len = selectedEWIs ? selectedEWIs.length : 0;
			for (var i = 0; i < len; i++) {
				if(!selectedEWIs[i].testPlan || selectedEWIs[i].testPlan.versionableItemId != planItemId) {
					samePlan = false;
					break;
				}
			}
			if(samePlan && planItemId) {
                var handler = {
                    success: function(phases){
                        var args = {
                            phases: phases,
                            actionId: actionId,
                            okCallback: dojo.hitch(self, "_handleTERBulkChanged")
                        }
                        
                        var dlg = new com.ibm.rqm.planning.web.ui.internal.view.common.properties.SelectTestPhasePopup();
                        dlg.initialize(args);
                    },
                    error: function(e){
                        console.error(e);
                    }
                };
                var responseHandler = new ServiceResponseHandler(handler, "success", "error");
                TimeboxClient.getTestPhasesSummaryDTO(responseHandler, {
                    testPlanId: planItemId
                });
			}
			else {
				var msg = Constants.getMessage("msgNotInSamePlan")
				if(!planItemId)
					msg = Constants.getMessage("msgNotInPlan")
                var args = {
                    'message': msg
                };
                var alertDialog = new com.ibm.asq.common.web.ui.internal.widgets.AlertDialog(args);
                alertDialog.setSecondaryTitle("");
                alertDialog.open();
			}
		}
	},
	
	_handleTERBulkChanged: function(args){
		var self = this;
		var selectedEWIs = this.tableViewer.getCheckedRows();
		
		
		var ewiList = this.ewiList;
		if(ewiList){
			var ewiSaveContextGroup = ewiList.ewiSaveContextGroup;
			if(ewiSaveContextGroup && ewiSaveContextGroup.length) {
				var updatedEwis = [];
				var selectedEWIsLength = selectedEWIs.length;
				for(var i = 0; i < selectedEWIsLength; i++){
					var ewi = selectedEWIs[i];
					if(ewi.isNew) {
						if (args.actionId == Constants.getMessage("labelWeight")) {
							ewi.weight = args.weight;
						}	
						if (args.actionId == Constants.getMessage("labelOwner")) {
							ewi.owner = args.owner;
							ewi.ownerName = args.owner.name;
							ewi.ownerUserId = args.owner.userId;
						}	
						if (args.actionId == Constants.getMessage("labelIteration")) {
							ewi.phase = args.phase;
						}
						updatedEwis.push(ewi);
					}
				}
				this.tableViewer.refresh();
				var length = ewiSaveContextGroup.length;
				for(var j = 0; j < length; j++){
					ewiSaveContextGroup[j].updateEwis(updatedEwis);
				}
			}
		}
		
		
        var handler = {
            success: function(ters){
                var content = self.tableViewer.getContent();
                for (var i in ters) {
                	var ter=ters[i];
                	var terId=ter.id;
                    for (var j in content) {
                    	var theContent=content[j];
                        if (theContent.id == terId) {
							theContent.stateId = ter.stateId;
                            theContent.modified = ter.modified;
                            theContent.weight = ter.weight;
							theContent.owner = {
								name: ter.ownerName,
								userId: ter.ownerUserId
							}
							theContent.phase = {
								itemId: ter.phaseItemId,
								name: ter.phaseName
							}
                        }
                    }
                }
				self.executionWorkItems = self.tableViewer.getContent();
                self.tableViewer.refresh();
            },
            error: function(e){
                self._error(e);
            }
        }
				
		args.ids = [];
		args.ewiStateIds = [];
		var length=(selectedEWIs ? selectedEWIs.length : 0);
        for (var i = 0; i < length; i++) {
        	var selectedEWI=selectedEWIs[i];
        	if(!selectedEWI.isNew){
            args.ids.push(selectedEWI.id);
			args.ewiStateIds.push(selectedEWI.stateId);
        }
        }
		if (args.actionId == Constants.getMessage("labelWeight")) {
			args.weight = args.weight;
		}	
		if (args.actionId == Constants.getMessage("labelOwner")) {
			args.owner = args.OwnerUserId;
		}	
		if (args.actionId == Constants.getMessage("labelIteration")) {
			args.testPhase = args.testPhaseItemId;
		}	
		
		if(args.ids.length){
		var responseHandler = new ServiceResponseHandler(handler, "success", "error");          
        ExecutionWorkItemClient.postBulkChangeEWI(responseHandler, args); 
		}
	},
	
	getCurrentEditableRows: function(){
		return this.tableViewer.getContentProvider().getEditableRows();
	},

	getIsInEditMode:function(){
		return this.inEditMode;
	},

	uninitialize: function(){
		//Remove menu items
		var menus = this._itemsToTrack.menus;
		var menuLength = menus.length;
		if(menus && menuLength>0){
			for(var i=0;i<menuLength;i++){
				menus[i].destroyRecursive();
			}
		}
	},
	
    _error: function(e) {
        console.error(this.declaredClass + ": Error: " + e.message);
    }
});
})();
