//GenerateEWITableView
/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.configuration.web.ui.internal.view.table.GeneratedEWITableView");
 
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");

dojo.require("com.ibm.rqm.planning.web.ui.internal.util.Utility");

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.ListRowRenderer");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.views.configurations.ConfigurationsUriUtil");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");

(function() {

var TableConstants = com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;
var ImageCache     = com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
var Utility        = com.ibm.rqm.planning.web.ui.internal.util.Utility;
var ConfigurationUriUtil = com.ibm.rational.test.lm.web.ui.internal.views.configurations.ConfigurationsUriUtil;
var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
var ViewHeaderLayout = com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout;

dojo.declare("GeneratedEWITableView.TableListener", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableListener,
{
	parentView: null,
	
	constructor: function(testView)	{
    	this.parentView = testView;
	},
	
	setRowCheckListener: function(listener) {
		this.rowCheckListener = listener;
	},
	
    // Summary:
    //   If the table's rows are checkable, when a row is checked, or unchecked, this method is
    //   called.
    //
    rowCheckStateChanged: function(tableViewer, rowObject, state)
    {
      var selectionCount = tableViewer.getCheckedRows().length;
	  if(this.parentView.changeIterationActionNode)
	 		 this.parentView.changeIterationActionNode.setDisabled(selectionCount == 0); 
	  if(this.parentView.changeOwnerActionNode)
	 		 this.parentView.changeOwnerActionNode.setDisabled(selectionCount == 0);
	  if(this.parentView.deleteEWIActionNode)
	 		 this.parentView.deleteEWIActionNode.setDisabled(selectionCount == 0);
      if(this.parentView.configActionNode)
	 		 this.parentView.configActionNode.setDisabled(selectionCount == 0);		 
    },
	
	// Summary:
	//    If the client have registered table actions, this message will be fired when an action (button)
	//    is invoked by the user.
	//
	tableContentActionInvoked: function(tableViewer, actionId, callbackData, callback)
	{
		if (callback != null && dojo.isFunction(callback)) {
	        callback();
	   } 
	},
	
    // Summary:
    //    If the client have specified a header image and specified that it's an action (see TableContentProvider 
    //    for details), when the column's image is clicked, this message is invoked.
    //
    tableHeaderColumnActionInvoked: function(tableViewer, columnIndex, /*optional*/actionId)
    {
        this.parentView.parent._tableHeaderColumnActionInvoked(tableViewer, columnIndex, actionId);         
    }
});

dojo.declare("GeneratedEWITableView.CellModifier", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier,
{
    // Summary:
    //    Method to be called when a cell renderer changes the cell value. This notifies
    //    the cell's value change event. 
    //    
    //    
    cellValueChanged: function(oldValue, newValue, rowObject, columnIndex)
    {       
        if(columnIndex == 6){
            var listener = this.comboChangeListener;
            if (newValue.search(/^\s*[0-9]*[1-9][0-9]*\s*$/) != -1) {
				rowObject.weight = parseInt(newValue);
			}else{
				rowObject.weight = -1;
			}
        }        
    },
    
    cellActionInvoked: function(rowObject, columnIndex)
    {
		//handle delete action
    }
});

dojo.declare("GeneratedEWITableView.ListRowRenderer",
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.ListRowRenderer,
{    
    // Summary:
    //   Override the base list row renderer's create list content method
    //   to supply more custom contents.
    //
    _createListContents: function(viewer, rowObject, listWidget)
    {
        this.inherited("_createListContents", arguments);   
        
        var moreContents = document.createElement("div");
        var toggle = document.createElement("button");
        toggle.innerHTML = "Added Custom Control";
        moreContents.appendChild(toggle);
        listWidget.contentNode.appendChild(moreContents);
    }
});

dojo.declare("GeneratedEWITableView.TableProvider", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider,
{
    // Summary:
    //
    getNumColumns: function(content)
    {
        return 7;
    },
    
    _columnHeadings: [
		//Constants.getMessage("labelId"),
		Constants.getMessage("labelName"),
    	Constants.getMessage("labelTestCase"),
    	Constants.getMessage("labelConfiguration"),
    	Constants.getMessage("labelBlockingStatus"),
		//Constants.getMessage("labelDefectStatus"),
	   	Constants.getMessage("labelAssignedTo"),
		Constants.getMessage("labelIteration"),
		Constants.getMessage("labelWeight")
    ],
    
    // Summary:
    //
    getColumnHeading: function(content, index)
    {
        return this._columnHeadings[index];
    },

    // Summary:
    //    Optionally, returns an image src URL to be placed in the column header. If both heading
    //    and image are specified, both are shown.
    //    
    getColumnHeadingImage: function(content, atColumnIndex)
    {
 
        if(atColumnIndex == 4) {
			return {
				actionId: "owner",
				tooltip: Constants.getMessage("labelChangeProperties", Constants.getMessage("labelOwner")),
				src: ImageCache.BULK_CHANGE
			};

        }
        if(atColumnIndex == 5) {
			if (this.parentView.reassignable) {
	            return {
	                actionId: "phase",
	                tooltip: Constants.getMessage("labelChangeProperties", Constants.getMessage("labelIteration")),
	                src: ImageCache.BULK_CHANGE
	            };
			}
        }
        if(atColumnIndex == 6) {
            return {
                actionId: "weight",
                tooltip: Constants.getMessage("labelChangeProperties", Constants.getMessage("labelWeight")),
                src: ImageCache.BULK_CHANGE
            };
        }
        return null;
    },
	 
    // Summary:
    //    Returns the column header horizontal alignment. By default, the columns are
    //    aligned to the left.
    //
    //    Client optionally can indicate the alignment for the column header.
    //
    getColumnHeadingAlignment: function(atColumnIndex)
    {
        return this.getCellAlignment(null, atColumnIndex);
    },	 
    
    getIsColumnGroupable: function(content, atColumnIndex)
    {
        return (true);     
    },

    getIsColumnSortable: function(content, atColumnIndex)
    {
        return (true);   
    },
	
    _columnWidths: [20,20,20,5,15,10,10],

    getColumnWidth: function(content, atColumnIndex)
    {
        return this._columnWidths[atColumnIndex];
    },
    
    // Summary:
    //    The only assumptions the table have on the data that it displays
    //    is that it's an array contents. These are the data content/object that
    //    will be displayed in the table rows.
    //
    getContentObjects: function(content)
    {
        // our content is already an array of objects
        return content;
    },
    
    getRowDataId: function(rowData)
    {
        return "_table_row_for_ewi_" + rowData.id;
    },
    
    // Summary:
    //    Returns the type of the cell to be displayed. By default, the TableViewer
    //    will support a set of cell types. The type of the cell will map to a specific
    //    cell renderer (to be discussed).
    getCellDisplayType: function(rowData, atColumnIndex)
    {
        var type = TableConstants.RENDER_TYPE_TEXT;

        switch(atColumnIndex) {
            case 0: 
                //type = TableConstants.RENDER_TYPE_IMAGE;
                break;
			case 2:
				if(rowData.config.isExist == true)
					type = TableConstants.RENDER_TYPE_LINK;
				break;
			case 3:
				type = TableConstants.RENDER_TYPE_IMAGE;
				break;	
			case 6:
				type = TableConstants.RENDER_TYPE_EDITABLE_TEXT;
				break;
        }
        return type;
    },

    getCellAlignment: function(rowData, atColumnIndex)
    {
        return TableConstants.ALIGN_LEFT;
    },
    
    // Summary:
    //    Returns the display data of the cell. For cell renderer type of TEXT, this will
    //    be the string. Others cell render type would be Date, or integer value, etc. If the 
    //    cell renderer type is image, the client can also supply cell data that can be sortable/groupable. 
    //    The TableViewer's default sorter, filter operates on this returned data. For "complex" 
    //    cell types such as image where it could have multiple values for different states, the 
    //    client also needs to implement the next method.
    //    
    //    Client must implement this method to provide the cell data.
    //    
    getCellDisplayData: function(rowData, atColumnIndex)
    {
        var val = "";
        switch(atColumnIndex) {
			case 0: 
                val = rowData.name; //EWI Name
                break;
            case 1: 
                val = rowData.testCaseName; //TestCase Name
                break;
            case 2: 
                val = (rowData.testConfigName) ? rowData.testConfigName : "Loading..."; //Configuration
                break;
			case 3: 
                val = "";//Defect status
                break;	          
            case 4: 
                val = rowData.owner.userId; //Owner
                break; 
            case 5: 
                val = rowData.testPhase ? rowData.testPhase.name : "None"; //Schedule Iteration
                break; 	
			case 6: 
                val = rowData.weight;
                break; 							 
        }
        return val;
    },

    
    // Summary:
    //    If applicable, returns the extended display information of the cell. The return extended
    //    info must be an object with the following attributes:
    //    
    //    {
    //      /* attribute common for all cell renderer types */
    //      "tooltip": <string>,
    //
    //      /* attributes for IMAGE and ACTION cell renderer types */
    //      "isHidden": <true, false> the image is hidden if the row is not on the mouse over
    //      "image": base image URL,  
    //      "mouseOverImage": image URL, (optional)
    //      "mouseOutImage": image URL,  (optional) (overrides "image")
    //
    //      /* attributes for SELECT cell renderer type */
    //      "select" : 'value', the selection in the combo
    //      "choices" : [{'text':'display text', 'value':'value'}, ] array of objects with 'text' and 'value' attributes
    //
    //      /* attributes for CHECKBOX cell renderer type */
    //      "state" : <true, false> initial state of the check box
    //
    //      /* attributes for LINK cell renderer type */
    //      "href" : <string> the href string for the link
    //    }
    //
    //    Client can implement this method to provide extended display infor for the cell.
    //    Certain cell renderer type will require the client to implement this method to
    //    provide needed display information, such as an image ACTION.
    //
    getCellDisplayExtendedInfo: function(rowData, atColumnIndex)
    {  
        var val = {};
		if(atColumnIndex == 2) {
			if(rowData.config && rowData.config.id){
				var catalog = new com.ibm.asq.common.web.client.internal.Catalog();
				var configuration = null;
				if(rowData.config.isExist == true){
	            	var configuration = new com.ibm.asq.common.web.client.internal._catalog.Configuration(rowData.config.configuration);
				}else{
					configuration = rowData.config;
				}
                // display types are returned as an object that fully identifies a catalog type,
                // included fields are name, path, and template.
	            var attributeIds = catalog.getDisplayTypes();
	            var attributeVals = [];
	            for (var i = 0; i < attributeIds.length; i++) {
	                var attribute = configuration.getValue(attributeIds[i]);
	                if (!attribute) {
	                    attributeVals.push(Constants.getMessage("labelNotConfig"));
	                }
	                else 
	                    attributeVals.push(attribute);
	            }
				var html = "<table>";
	            for (var i = 0; i < attributeIds.length; i++) {
					html += "<tr><td><b>" + attributeIds[i].name + ":</b>" + attributeVals[i] + "</td></tr>";
	            }
				html += "</table>";
				if(rowData.config.isExist == true){
					val['href'] = ConfigurationUriUtil.getEditConfigurationURI(rowData.config.id);
				}
				val['tooltip'] = html;
			}
        }else if(atColumnIndex == 3){
			val.image = rowData.isBlocking ? ImageCache.BLOCKING_DEFECT : ImageCache.NOIMAGE;
			val.tooltip = rowData.isBlocking ? Constants.getMessage("msgHasBlockingDefect") : Constants.getMessage("msgNoBlockingDefect");
		}	
        return val;
    }
});

dojo.declare("com.ibm.rqm.configuration.web.ui.internal.view.table.GeneratedEWITableView", 
    [dijit._Widget, dijit._Templated],
{    
    templateString: '<div tabindex="-1">' + 
					'	<div style="display: inline" dojoAttachPoint="domNode" tabindex="-1" class="com-ibm-asq-common-web-ui-view-header">' +
					'   	<div style="float:right;clear:right;width:auto;position:relative;" dojoAttachPoint="wholestatusContainer"> ' +
                    '       	<span dojoAttachPoint="statusContainer">' +
                    '              <img dojoAttachPoint="statusWarningNode" class="view-status-icon"></img>' +
                    '              <span dojoAttachPoint="statusLineNode" class="view-status-value">&nbsp;</span>' +					
					'			 </span> ' +
                    '       </div> ' +
					'   </div>' +
					'</div>',
					

    widgetsInTemplate: true,
	parent: null,

    constructor: function() {
	 	this.results = null;
		this.queryName = null;
	 },

    postCreate: function() 
    {
        this.inherited("postCreate", arguments);
		
        this.statusWarningNode.src = com.ibm.asq.common.web.ui.internal.view.common.ImageCache.WARNING_ICON;
		this.statusPopup = new dijit.Tooltip({label: "", showDelay: 100, connectId:[this.statusLineNode]});
		
        var tableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer();        
        this.domNode.appendChild(tableViewer.domNode);
		          
        var content = this.executionWorkItems ? this.executionWorkItems : [];
		  
        tableViewer.setContentPageSize(20);
        tableViewer.setContent(content);
		var tableProvider = new GeneratedEWITableView.TableProvider();
		tableProvider.parentView = this;
        tableViewer.setContentProvider(tableProvider);
		tableViewer.setTableSummary(Constants.getMessage("labelTableSummary", Constants.getMessage("labelGeneratedTER")));  
		  
		var tableListener = new GeneratedEWITableView.TableListener(this);
		/*
		if (this.executable && this.rowCheckListener) {
		tableListener.setRowCheckListener(this.rowCheckListener);
		} 
		*/

		this.deleteEWIActionNode = tableViewer.addAction("Delete", Constants.getMessage("labelDeleteTestEnvironmentRecord"), null, "remove-from-group-icon-image", dojo.hitch(this, "removeSelectedEWIs")); 
		this.deleteEWIActionNode.setDisabled(true);
		
		tableViewer.setTableListener(tableListener);
		tableViewer.setCellModifier(new GeneratedEWITableView.CellModifier());
		tableViewer.setTableRowsCheckable(true, /* isSingleSelect */ false);        
		tableViewer.show();
		
		this.tableViewer = tableViewer;
		  
    },
	
	 // API
	 getSelectedEWIs: function() {
	     return this.tableViewer.getCheckedRows();
	 },
	 
    refresh: function(ewis) {
      this.tableViewer.setContent(ewis);
      this.tableViewer.show();
    },
	
	// API
	removeSelectedEWIs: function(){
		var selectedEWIs = this.getSelectedEWIs();
		for(var j = 0; j < selectedEWIs.length; j++){
			this.tableViewer.deleteItem(selectedEWIs[j]);
		}
		var content = this.tableViewer.getContent();
		this.tableViewer.setContent(content);
		this.tableViewer.show();
	},
	 
    appendEWIs: function(ewis) {
      var content = this.tableViewer.getContent();
      for (var i = 0; i < ewis.length; i++) {
         content.push(ewis[i]);	
		}		
      this.tableViewer.setContent(content);
      this.tableViewer.show();
    },	 
	 
    updateEWIs: function(ewis) {
      var content = this.tableViewer.getContent();
      for (var i = 0; i < (ewis ? ewis.length : 0); i++) {
			for (var j = 0; j < (content ? content.length : 0); j++) {
				if (content[j].id == ewis[i].id) {
					content[j] = ewis[i];
				}
			}
		}
      this.tableViewer.setContent(content);
      this.tableViewer.show();
    },   	 
	 
    addConfigurationInfo: function(ewiId, configText) {
      var content = this.tableViewer.getContent();
      for (var i = 0; i < content.length; i++) {
			if (content[i].id == ewiId) {
				content[i].configurationText = configText;
			}
		}
      this.tableViewer.setContent(content);
      this.tableViewer.show();
    },
	
	setStatus: function(status, type, /*optional*/details) {
        this.statusContainer.style.display = "inline";
        
        var stText = status;
        var detailText = details;
        
        // stop the status line from extending too far off to the
        // left. Cap its length at 40. Show the full text in the tooltip.
        //
        if((status.length - 40) > 5) {
            stText = status.substr(0, 40) + "...";
            if(details) {
                detailText = status + "\n" + details;
            }
        }
        // detail message is in the tooltip popup
        this.statusPopup.label = (details) ? detailText : status;

        this.statusWarningNode.style.display = (type == ViewHeaderLayout.WARNING) ? "inline" : "none";
        
        this.statusLineNode.innerHTML = stText;
    }
   	 
});

})();
