/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.requirement.web.ui.internal.view.table.RequirementTableView");
 
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.asq.common.web.client.internal.PermissionsClient");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");

dojo.require("com.ibm.asq.common.web.ui.internal.util.Utility");

dojo.require("com.ibm.rqm.planning.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.table.AbstractFilteredTableView");
dojo.require("com.ibm.rqm.planning.web.client.internal.UserClient");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.properties.SelectOwnerPopup");
dojo.require("com.ibm.rqm.requirement.web.client.internal.requirement.RequirementWorkItemClient");

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.ListRowRenderer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentFilterProvider");

(function() {

var ServiceResponseHandler = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var TableConstants = com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;
var ImageCache     = com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
var Utility        = com.ibm.rqm.planning.web.ui.internal.util.Utility;
var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
var UserClient = com.ibm.rqm.planning.web.client.internal.UserClient;	
var AbstractFilteredTableView = com.ibm.rqm.planning.web.ui.internal.view.table.AbstractFilteredTableView;
var getCurrentProjectArea	= com.ibm.team.process.web.client.projectarea.getCurrentProjectArea;
var LOCATION                = "jazz/web/projects/";
var WORKITEM_URL 				= "#action=com.ibm.team.workitem.viewWorkItem&id=";
var RENDER_TYPE_REQLINK = "RenderType.ReqLink";
var RequirementWorkItemClient = com.ibm.rqm.requirement.web.client.internal.requirement.RequirementWorkItemClient;
var ViewHeaderLayout = com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout;
var TableContentFilterProvider = com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentFilterProvider;

dojo.declare("com.ibm.rqm.requirement.web.ui.internal.view.table.RequirementTableViewTableListener", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableListener,
{
	parentView: null,
    
	constructor: function(testView)
	{
    	this.parentView = testView;
	},
	// Summary:
    //   If the table's rows are checkable, when a row is checked, or unchecked, this method is
    //   called.
    //
    setRowCheckListener: function(listener) {
		this.rowCheckListener = listener;
	},
	
	rowCheckStateChanged: function(tableViewer, rowObject, state)
    {
		if (rowObject instanceof Array) {
			for(var i=0; i<rowObject.length; i++) {
				rowObject[i].selected = state;
			}
		}
		else {
			rowObject.selected = state;
		}
		var listener = this.rowCheckListener;
      	if (listener && listener.context && listener.method) {
			listener.method.apply(listener.context, [rowObject, state]);
		}
		var selectionCount = tableViewer.getCheckedRows().length;
        var disabledSingleSelect = (selectionCount != 1 || !tableViewer.isEditable());
		var disabledMultipleSelect = (selectionCount == 0 || !tableViewer.isEditable());
		if (this.parentView.clearStatusActionNode) {
			var requirements = tableViewer.getCheckedRows();
			var noChange = true;
			for(var i=0; i<requirements.length; i++) {
				if(requirements[i].status == "updated" || requirements[i].status == "removed") {
					noChange = false;
					break;
				}
			}
			this.parentView.clearStatusActionNode.setDisabled(noChange);
		}
		if (this.parentView.assoicatedTestPlanNode) {
			this.parentView.assoicatedTestPlanNode.setDisabled(disabledSingleSelect); 
		}
		if (this.parentView.assoicatedTestCaseNode) {
			this.parentView.assoicatedTestCaseNode.setDisabled(disabledSingleSelect);
		}	
		if (this.parentView.disaccosicateButton) {
			this.parentView.disaccosicateButton.setDisabled(disabledMultipleSelect);
		}
		if (this.parentView.deleteButton) {
			this.parentView.deleteButton.setDisabled(disabledMultipleSelect);
		}
		if (this.parentView.createCaseButton) {
			this.parentView.createCaseButton.setDisabled(disabledMultipleSelect);
		}
		if (this.parentView.bulkchangeActionNode)
		    this.parentView.bulkchangeActionNode.setDisabled(selectionCount == 0);
	},
	
	groupRowsCheckStateChanged: function(tableViewer, rowObjects, state) 
    {
        this.rowCheckStateChanged(tableViewer, rowObjects, state);
    },
	
	// Summary:
    //    If the client have registered table actions, this message will be fired when an action (button)
    //    is invoked by the user.
    //
    tableContentActionInvoked: function(tableViewer, actionId, callbackData, callback)
    {
        if (callback != null && dojo.isFunction(callback)) {
            if (callbackData != null) {
                callback(callbackData);
            } else {
                callback();
            }
        }        
    },
	
    tableContentFilterActionInvoked: function(tableViewer, actionId, filters, callback, callbackData)
    {
        if(callback) {
            callback(actionId, filters);
        }                     
    },
	
	tableHeaderColumnActionInvoked: function(tableViewer, columnIndex, /*optional*/actionId)
    {
		if (this.parentView && this.parentView.requirementHeaderColumnActionInvoked) {
			this.parentView.requirementHeaderColumnActionInvoked(tableViewer, columnIndex, actionId);
		}         
    }   
});

dojo.declare("com.ibm.rqm.requirement.web.ui.internal.view.table.RequirementRowCheckedHandler",
			TableViewer.RowCheckedHandler, 
{
	getRowCheckState: function(rowObject)
    {
        var provider = this.viewer.getContentProvider();
        var id = provider.getRowDataId(rowObject);
        var check = false;
        
        if(id && (typeof this.rowStates[id] != "undefined")) {
            check = this.rowStates[id].checked;
        } else if (rowObject && rowObject.selected) {
			this.setRowCheckState(rowObject, true);
			return true;
		}
        return check;
    }				
});

dojo.declare("com.ibm.rqm.requirement.web.ui.internal.view.table.RequirementTableLinkCellRenderer",
			com.ibm.asq.common.web.ui.internal.widgets.tableViewer.LinkCellRenderer,
{
	renderCell: function(viewer, cellData, extendedDisplayInfo,cellModifier, rowObject, columnIndex, cellWidthHint)
	{
		var doc=document;
		var node = doc.createElement("a");
        var textData = cellData + "";
        var displayNode = document.createElement("div");
        var href = "#";
                
        if(extendedDisplayInfo && (typeof extendedDisplayInfo['href'] != "undefined")) {
            href = extendedDisplayInfo['href'];
        }
        if(viewer.isCompactMode && typeof cellWidthHint != "undefined") {
            textData = this._handleCompactCellText(viewer, textData, extendedDisplayInfo, displayNode, cellWidthHint);
        }
        else {
            // the parent class's attach tooltip will not create a tooltip
            // if the string is null, or undefined. Don't have to check it here.
            this._attachTooltipToCell(node, extendedDisplayInfo['tooltip']);            
        }
        displayNode.innerHTML = textData;
        node.appendChild(displayNode);
        node.href = href;
		node.target ="_blank";
		return node;
	}
	
});

dojo.declare("com.ibm.rqm.requirement.web.ui.internal.view.table.RequirementTableViewCellModifier", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier,
{
	parentView: null,
    
   	constructor: function(testView)	{
        	this.parentView = testView;
    },
		
    // Summary:
    //    Method to be called when a cell renderer changes the cell value. This notifies
    //    the cell's value change event. 
    //    
    //    
    cellValueChanged: function(oldValue, newValue, rowObject, columnIndex)
    {
        // store the new values in our internal data model
        if(columnIndex == 5) {
            if(dojo.isString(newValue)) {
                //rowObject.selection = newValue;
            }
        }
    },
    
    cellActionInvoked: function(rowObject, columnIndex)
    {
		// do nothing
    }
});

dojo.declare("com.ibm.rqm.requirement.web.ui.internal.view.table.RequirementTableViewListRowRenderer",
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.ListRowRenderer,
{    
    // Summary:
    //   Override the base list row renderer's create list content method
    //   to supply more custom contents.
    //
    _createListContents: function(viewer, rowObject, listWidget)
    {
        this.inherited("_createListContents", arguments);   
        
        var moreContents = document.createElement("div");
        var toggle = document.createElement("button");
        toggle.innerHTML = "Added Custom Control";
        moreContents.appendChild(toggle);
        listWidget.contentNode.appendChild(moreContents);
    }
});

dojo.declare("com.ibm.rqm.requirement.web.ui.internal.view.table.RequirementTableViewTableProvider", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider,
{
	
	constructor: function(args) {
        dojo.mixin(this, args);
    },
    // Summary:
    //
	
    getNumColumns: function(content)
    {
        return 9;
    },
    
	_columnHeadings: [
        	Constants.getMessage("labelStatusRequirementTable"),
            Constants.getMessage("labelId"), //"WorkItem No.",
            Constants.getMessage("labelCommunityRiskHeader"),
			Constants.getMessage("labelRiskAssessment"),
            Constants.getMessage("labelSourceIdRequirementTable"),
			Constants.getMessage("labelRequirementSourceWithoutColon"),
            Constants.getMessage("labelName"),
            Constants.getMessage("labelDescriptionRequirementTable"),
            Constants.getMessage("labelOwner")
    ],
    
    
    // Summary:
    //
    getColumnHeading: function(content, index)
    {
        return this._columnHeadings[index];
    },

    getIsColumnGroupable: function(content, atColumnIndex)
    {
	 	  return (atColumnIndex == 8 || atColumnIndex == 0);
    },

    getIsColumnSortable: function(content, atColumnIndex)
    {
        return (true);     
    },
    
    _columnWidths: [5,5,10,10,10,5,20,30,15],
    getColumnWidth: function(content, atColumnIndex)
    {
    	// note - using the array lookup rather than a switch statement
    	// is about 17x faster on FF 3.5 - but the same speed on IE7 and IE8.
    	// Probably not worth making these fixes any further.
    	return this._columnWidths[atColumnIndex];
    },
    
	getColumnHeadingImage: function(content, atColumnIndex)
    {
		if (atColumnIndex == 3 && this.tableViewer.queryName) {
            return {
                actionId: "risk",
                tooltip: Constants.getMessage("labelChangeProperties", Constants.getMessage("labelRiskAssessment")),
                src: ImageCache.BULK_CHANGE
            };
		}
		if (atColumnIndex == 8 && this.tableViewer.queryName) {
            return {
                actionId: "owner",
                tooltip: Constants.getMessage("labelChangeProperties", Constants.getMessage("labelOwner")),
                src: ImageCache.BULK_CHANGE
            };
		}
		return null;
    },
	
	getIsColumnVisible: function(atColumnIndex)
    {
        if(atColumnIndex == 2 || atColumnIndex == 5)
			return false;
		return true;
    },
	
    // Summary:
    //    The only assumptions the table have on the data that it displays
    //    is that it's an array contents. These are the data content/object that
    //    will be displayed in the table rows.
    //
    getContentObjects: function(content)
    {
        // our content is already an array of objects
        return content;
    },
    
    getRowDataId: function(rowData)
    {
        return "_table_row_for_requirement_" + rowData.id;
    },
    
    // Summary:
    //    Returns the type of the cell to be displayed. By default, the TableViewer
    //    will support a set of cell types. The type of the cell will map to a specific
    //    cell renderer (to be discussed).
    getCellDisplayType: function(rowData, atColumnIndex)
    {
        var type = TableConstants.RENDER_TYPE_TEXT;

        switch(atColumnIndex) {
        	case 0:
				type = TableConstants.RENDER_TYPE_IMAGE;
				break;
            case 1: 
                type = TableConstants.RENDER_TYPE_LINK;  //RENDER_TYPE_REQLINK;
                break;	
			case 2: 
                type = TableConstants.RENDER_TYPE_FADEINOUT;  
                break;	
			case 3: 
                type = TableConstants.RENDER_TYPE_FADEINOUT;  
                break;		
			case 6:
				if (rowData.externalUrl != null && rowData.externalUrl.match(/^https?:\//i)) {
					type = RENDER_TYPE_REQLINK;		
				}
				else if (rowData.externalId!=null && ( rowData.externalId.match(/^reqpro\//i) || rowData.externalId.match(/^reqprohttps\//i) || rowData.externalId.match(/^doors\//i) || rowData.externalId.match(/^https?:\//i) || rowData.externalId.match(/^caliberrm\//i))) {
					type = RENDER_TYPE_REQLINK;		
				}else{
					type = TableConstants.RENDER_TYPE_LINK;
				}
				break; 			 
        }
        return type;
    },

    getCellAlignment: function(rowData, atColumnIndex)
    {
        if(atColumnIndex == 0)
            return TableConstants.ALIGN_CENTER;
        return TableConstants.ALIGN_LEFT;
    },
    
    // Summary:
    //    Returns the display data of the cell. For cell renderer type of TEXT, this will
    //    be the string. Others cell render type would be Date, or integer value, etc. If the 
    //    cell renderer type is image, the client can also supply cell data that can be sortable/groupable. 
    //    The TableViewer's default sorter, filter operates on this returned data. For "complex" 
    //    cell types such as image where it could have multiple values for different states, the 
    //    client also needs to implement the next method.
    //    
    //    Client must implement this method to provide the cell data.
    //    
    getCellDisplayData: function(rowData, atColumnIndex)
    {
        var val = "data";
        switch(atColumnIndex) {
            case 1: 
                val = rowData.id ? parseInt(rowData.id, 10) : "";
                break;
			case 2: 
                val = this._getRiskLevel(rowData.risk, "communityRisk");
                break;
			case 3: 
                val = this._getRiskLevel(rowData.risk, "calculatedRisk");
                break;
			case 4: 
                val = rowData.externalTag ? rowData.externalTag : "";
                break;
			case 5: 
                val = this.getReqSourse(rowData.externalId);
                break;
            case 6: 
                val = this.encodeSpecialChars(rowData.name);
                break;
			case 7: 
                val = this.restoreTags(rowData.description);
                break;
            case 8: 
                val = "";
				if (rowData.owner) {
					if (com.ibm.asq.common.web.ui.internal.util.Utility.isUnassignedUserId(rowData.owner.itemId)) 
						val = Constants.getMessage("labelUnassigned");
					else 
						val = rowData.owner.name;
				}
                break;
			case 0: 
				if(!rowData.status || rowData.status=="new")
					val = Constants.getMessage("labelRequirementNormal");
				else if(rowData.status=="unknown")
					val = "";
				else if(rowData.status == "updated")
	                val = Constants.getMessage("labelRequirementUpdated");
				else if(rowData.status == "removed")
	                val = Constants.getMessage("labelRequirementRemoved");
                break;          

        }
        return val;
    },

    
    getCellDisplayExtendedInfo: function(rowData, atColumnIndex)
    {  
        var val = null;
        if(atColumnIndex == 0){
			val = {};
			if(!rowData) {
				val.image = "";
			} else if(rowData.status == "updated"){
				val.image = ImageCache.REQ_UPDATED;
			}else if(rowData.status == "removed"){
				val.image = ImageCache.REQ_REMOVED;
			}else if(rowData.status == "new"){
				val.image = ImageCache.REQ_NORMAL;
			}else {
				val.image = ImageCache.REQ_NORMAL;
			}
		}
        if(atColumnIndex == 1) {
            val = {};
			val.href = Utility.getViewWorkItemURI(rowData.id);  
			val.linkType = Constants.getMessage("RequirementId");
        }
		if(atColumnIndex == 2) {
            val = {};
			var image = ImageCache.RISK_LEVELS[this._getRiskLevel(rowData.risk, "communityRisk")];
            if (image) {
                val.image = image;
                val.tooltipInfo = {
                    createContents: dojo.hitch(this, this._createTooltip, rowData),
                    onOpen: dojo.hitch(this, this._openTooltip, rowData),
                    onClose: dojo.hitch(this, this._closeTooltip)
                };
            }
        }
		if(atColumnIndex == 3) {
            val = {};
            var image = this.tableViewer.queryName ? ImageCache.RISK_LEVELS[this._getRiskLevel(rowData.risk, "calculatedRisk")] : ImageCache.RISK_LEVELS_READONLY[this._getRiskLevel(rowData.risk, "calculatedRisk")];
            if (image) {
                val.image = image;
                val.tooltipInfo = {
                    createContents: dojo.hitch(this, this._createTooltip, rowData),
                    onOpen: dojo.hitch(this, this._openTooltip, rowData),
                    onClose: dojo.hitch(this, this._closeTooltip)
                };
            }
        }
		if(atColumnIndex == 6){
			val = {};
			if (rowData.externalUrl!=null && rowData.externalUrl.match(/^https?:\//i)) {
				val.href = rowData.externalUrl;
			}
			else if (rowData.externalId!=null) {
				var eid=rowData.externalId;
				if(rowData.externalId.match(/^reqpro\//i)){
					// for requirement from reqpro, externaid is like: "reqpro/<reqproserver>:<port>/<project>/<reqKey>", see wi9912
					eid = eid.substring("reqpro/".length, eid.length);
					var idx = eid.indexOf("/");
					var serverAndPort = eid.substring(0, idx);
					eid = eid.substring(idx+1,eid.length);
					idx=eid.indexOf("/");
					var project = eid.substring(0, idx);
					var reqKey = eid.substring(idx+1, eid.length);
					//form reqweb url like: "http://<server>:<port>/ReqWeb/ReqTabbedProp_Page.jsp?txtProject=<project>&ReqKey=<reqKey>&shortCut=true&showMainFrame=true&txtUID=<TypeYourUserID>&txtPWD=<TypeYourPassword>"
					val.href = "http://" + serverAndPort + "/ReqWeb/ReqTabbedProp_Page.jsp?txtProject=" + project + "&ReqKey=" + reqKey +"&shortCut=true&showMainFrame=true&txtUID=<TypeYourUserID>&txtPWD=<TypeYourPassword>";
				}
				else if(rowData.externalId.match(/^reqprohttps\//i)){
					// for requirement from reqpro https, externaid is like: "reqprohttps/<reqproserver>:<port>/<project>/<reqKey>", see wi9912
					eid = eid.substring("reqprohttps/".length, eid.length);
					var idx = eid.indexOf("/");
					var serverAndPort = eid.substring(0, idx);
					eid = eid.substring(idx+1,eid.length);
					idx=eid.indexOf("/");
					var project = eid.substring(0, idx);
					var reqKey = eid.substring(idx+1, eid.length);
					//form reqweb url like: "https://<server>:<port>/ReqWeb/ReqTabbedProp_Page.jsp?txtProject=<project>&ReqKey=<reqKey>&shortCut=true&showMainFrame=true&txtUID=<TypeYourUserID>&txtPWD=<TypeYourPassword>"
					val.href = "https://" + serverAndPort + "/ReqWeb/ReqTabbedProp_Page.jsp?txtProject=" + project + "&ReqKey=" + reqKey +"&shortCut=true&showMainFrame=true&txtUID=<TypeYourUserID>&txtPWD=<TypeYourPassword>";
				}					
				else if(rowData.externalId.match(/^doors\//i)){
					// for requirement from doors, externaid is like: "doors/<server>:<port>/<otherPart>", see wi9912
					eid = eid.substring("doors/".length, eid.length);
					var idx = eid.indexOf("/");
					var serverAndPort = eid.substring(0, idx);
					var otherPart = eid.substring(idx+1, eid.length);
					//form doors url like: "doors://<server>:<port>/?<otherPart>"
					val.href = "doors://" + serverAndPort + "/?" + otherPart.replace(/%26/gi, "&");
				}					
				else if(rowData.externalId.match(/^caliberrm\//i)){
					// for requirement from CaliberRM, externaid is like: "caliberrm/<SERVER LOCATION>/<CaliberRM REQUIREMENT INTERNAL ID>", see wi 18359
					eid = eid.substring("caliberrm/".length, eid.length);
					var idx = eid.indexOf("/");
					var serverLocation = eid.substring(0, idx);
					var otherPart = eid.substring(idx+1, eid.length);
					//for caliber url like: "alm://caliberrm!<server_location>/<otherPart>"
					val.href = "alm://caliberrm!" + serverLocation + "/" + otherPart.replace(/%26/gi, "&");
				}					
				else{
					val.href = Utility.getViewWorkItemURI(rowData.id);  
					val.linkType = Constants.getMessage("RequirementId");
				}
			}
		}		  
        return val;
    },
	
	restoreTags: function(value){
    	var rawText = value;
        rawText = rawText.replace(/\&gt;/gi, ">");
        rawText = rawText.replace(/\&lt;/gi, "<");
        rawText = rawText.replace(/\&amp;/gi, "&");
        rawText = rawText.replace(/\&tilde;/gi, "~");
        rawText = rawText.replace(/\&quot;/gi, "\"");
        rawText = rawText.replace(/\&circ;/gi, "^");
        rawText = rawText.replace(/\&nbsp;/gi, " ");
        rawText = rawText.replace(/<br\/>/gi, "\n");
        rawText = rawText.replace(/\&#09;/g, "\t");
        return rawText;
    },
	
	// encode special characters for html display for requirement names, see wi11946
	encodeSpecialChars: function(str){
		var rawText = str;
		rawText = rawText.replace(/&/gi, "&amp;");
        rawText = rawText.replace(/>/gi, "&gt;");
        rawText = rawText.replace(/</gi, "&lt;");        
        rawText = rawText.replace(/"/gi, "&quot;");
        return rawText;
	},
	
	//filter externalTag to identify its source: ReqPro, DOORS, RRC, CaliberRM or Local
	getReqSourse: function(externalTag) {
		var source = Constants.getMessage("labelLocalRequirement");
		if(externalTag && (externalTag.indexOf("reqpro")==0 || externalTag.indexOf("reqprohttps")==0)){
			// for requirement from reqpro, externaid is like: "reqpro/<reqproserver>:<port>/<project>/<reqKey>", see wi9912
			var source = Constants.getMessage("labelReqproRequirement");
		}
		else if(externalTag.indexOf("doors")==0){
			// for requirement from doors, externaid is like: "doors/<server>:<port>/<otherPart>", see wi9912
			var source = Constants.getMessage("labelDoorsRequirement");
		}		
		else if(externalTag.indexOf("caliberrm")==0){
			// for requirement from CaliberRM, externaid is like: "caliberrm/<SERVER LOCATION>/<CaliberRM REQUIREMENT INTERNAL ID>", see wi 18359
			var source = Constants.getMessage("labelCaliberRequirement");
		}		
		return source;			
	},
	
	//return value is int (0 ~ 5)
	_getRiskLevel: function(dtoRisk, riskType) {
		if (dtoRisk) {
			var levelString = null;
			switch (riskType) {
				case "communityRisk":
					levelString = dtoRisk.slice(dtoRisk.indexOf("communityRisk")+14, dtoRisk.indexOf("communityRisk")+15);
					break;
				case "calculatedRisk":
					levelString = dtoRisk.slice(dtoRisk.indexOf("calculatedRisk")+15, dtoRisk.indexOf("calculatedRisk")+16);
					break;
			}
			var level = Number(levelString);
            if (level != NaN && level >= 0) {
				return level;
            } 
		}
		return 0;
	},
	
	_createTooltip: function(rowData, hoverPopup) {
		this.riskTooltipWidget = new com.ibm.rqm.risk.web.ui.internal.view.assessment.AssessmentOverview({
			artifact: rowData,
			artifactType: Constants.MODEL_TYPE_REQUIREMENT,
			editable: this.tableViewer.queryName ? true : false
		});
		hoverPopup.content = this.riskTooltipWidget.domNode;
	},
	
	_openTooltip: function(data) {
	},
	
	_closeTooltip: function(hoverPopup) {
		hoverPopup._lastOpen = -1;
		if(this.riskTooltipWidget && this.tableViewer.queryName) 
			this.riskTooltipWidget.onSave(this.tableViewer);
	} 
});

dojo.declare("com.ibm.rqm.requirement.web.ui.internal.view.table.ExternalRequirementTableViewTableProvider", 
             com.ibm.rqm.requirement.web.ui.internal.view.table.RequirementTableViewTableProvider,
{
    getNumColumns: function(content)
    {
        return 3;
    },
    
	_columnHeadings: [
			Constants.getMessage("labelStatusRequirementTable"),
            Constants.getMessage("labelName"),
            Constants.getMessage("labelDescriptionRequirementTable")
    ],
    getColumnHeading: function(content, index)
    {
        return this._columnHeadings[index];
    },
	
	getIsColumnGroupable: function(content, atColumnIndex)
    {
	 	  return (content && content.length > 0 )?(atColumnIndex == 0):false;
    },

	_columnWidths: [5,35,65],
    getColumnWidth: function(content, atColumnIndex)
    {
   		return this._columnWidths[atColumnIndex];
    },
	
	getColumnHeadingImage: function(content, atColumnIndex)
    {
		return null;
    },
    
	getIsColumnVisible: function(atColumnIndex)
    {
        return true;
    },
	
    getCellDisplayType: function(rowData, atColumnIndex)
    {
        var type = TableConstants.RENDER_TYPE_TEXT;
        switch(atColumnIndex) {
        	case 0:
				type = TableConstants.RENDER_TYPE_IMAGE;
				break;
        }
        return type;
    },

    getCellAlignment: function(rowData, atColumnIndex)
    {
        if(atColumnIndex == 0)
            return TableConstants.ALIGN_CENTER;
        return TableConstants.ALIGN_LEFT;
    },
    
    getCellDisplayData: function(rowData, atColumnIndex)
    {
        var val = "data";
        switch(atColumnIndex) {
            case 1: 
                val = rowData ? rowData.name : "";
                break;
            case 2: 
                val = this.restoreTags(rowData ? rowData.description : "");
                break;
			case 0: 
                if(!rowData||!rowData.status || rowData.status=="new")
					val = Constants.getMessage("labelRequirementNormal");
				else if(rowData.status == "updated")
	                val = Constants.getMessage("labelRequirementUpdated");
				else if(rowData.status == "removed")
	                val = Constants.getMessage("labelRequirementRemoved");
	                
        }
        return val;
    },
	
	getCellDisplayExtendedInfo: function(rowData, atColumnIndex)
    {  
        var val = null;
        if(atColumnIndex == 0){
			val = {};
			if(!rowData) {
				val.image = "";
			} else if(rowData.status == "updated"){
				val.image = ImageCache.REQ_UPDATED;
			}else if(rowData.status == "removed"){
				val.image = ImageCache.REQ_REMOVED;
			}else if(rowData.status == "new"){
				val.image = ImageCache.REQ_NORMAL;
			}else {
				val.image = ImageCache.REQ_NORMAL;
			}
		}
        return val;
    }  
});

dojo.declare("com.ibm.rqm.requirement.web.ui.internal.view.table.ExternalRequirementWithPriorityProvider", 
             com.ibm.rqm.requirement.web.ui.internal.view.table.RequirementTableViewTableProvider,
{
    getNumColumns: function(content)
    {
        return 6;
    },
    
	_columnHeadings: [
			Constants.getMessage("labelStatusRequirementTable"),
			Constants.getMessage("labelSourceIdRequirementTable"),
            Constants.getMessage("labelName"),
            Constants.getMessage("labelDescriptionRequirementTable"),
			Constants.getMessage("labelPriorityRequirementTable"),
			Constants.getMessage("labelReviewStatusRequirementTable")
    ],
    getColumnHeading: function(content, index)
    {
        return this._columnHeadings[index];
    },

	getIsColumnGroupable: function(content, atColumnIndex)
    {
	 	  return (atColumnIndex == 4 || atColumnIndex == 5 || atColumnIndex == 0);
    },
	
	getColumnHeadingImage: function(content, atColumnIndex)
    {
		return null;
    },
    
	getIsColumnVisible: function(atColumnIndex)
    {
        return true;
    },
	
	_columnWidths: [5,10,30,50,5,5],
    getColumnWidth: function(content, atColumnIndex)
    {
   		return this._columnWidths[atColumnIndex];
    },
    
    getCellDisplayType: function(rowData, atColumnIndex)
    {
        var type = TableConstants.RENDER_TYPE_TEXT;
        switch(atColumnIndex) {
        	case 0:
				type = TableConstants.RENDER_TYPE_IMAGE;
				break;
        }
        return type;
    },

    getCellAlignment: function(rowData, atColumnIndex)
    {
        if(atColumnIndex == 0)
            return TableConstants.ALIGN_CENTER;
        return TableConstants.ALIGN_LEFT;
    },
    
    getCellDisplayData: function(rowData, atColumnIndex)
    {
        var val = "data";
        switch(atColumnIndex) {
			case 1:
				val = rowData ? rowData.tag : "";
				break;
            case 2: 
                val = rowData ? rowData.name : "";
                break;
            case 3: 
                val = this.restoreTags(rowData ? rowData.description : "");
                break;
			case 4: 
                val = rowData ? rowData.priority : "";
                break;
			case 5: 
                val = rowData ? rowData.reviewStatus : "";
                break;
			case 0: 
				if(!rowData || !rowData.status || rowData.status=="new")
					val = Constants.getMessage("labelRequirementNormal");
				else if(rowData.status == "updated")
	                val = Constants.getMessage("labelRequirementUpdated");
				else if(rowData.status == "removed")
	                val = Constants.getMessage("labelRequirementRemoved");
                break;
        }
        return val;
    },
	
	getCellDisplayExtendedInfo: function(rowData, atColumnIndex)
    {  
        var val = null;
        if(atColumnIndex == 0){
			val = {};
			if(!rowData) {
				val.image = "";
			} else if(rowData.status == "updated"){
				val.image = ImageCache.REQ_UPDATED;
			}else if(rowData.status == "removed"){
				val.image = ImageCache.REQ_REMOVED;
			}else if(rowData.status == "new"){
				val.image = ImageCache.REQ_NORMAL;
			}else {
				val.image = ImageCache.REQ_NORMAL;
			}
		}
        return val;
    }  
});

dojo.declare("RequirementTableView.TableFilterProvider", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentFilterProvider,
{
    constructor: function(tableView, openSection, defaultToMine) {
        this.tableView = tableView;
        this.initOpenFilter = openSection;
		this.defaultToMine = (defaultToMine === true);		
		
        // define the static filters
        this.filters = [
            {
                name: "myItemsOnly",  // must match key in the arg list of the API
                title: Constants.getMessage("labelOnlyMyRequirements"),
                promptTitle: Constants.getMessage("labelOnlyMyRequirements"),
                type: TableContentFilterProvider.FIELD_CHECKBOX,
                defaultValue: this.defaultToMine, params: null
            }, {
                name: "name",  // must match key in the arg list of the API
                title: Constants.getMessage("labelname"),
                promptTitle: Constants.getMessage("labelName"),
                type: TableContentFilterProvider.FIELD_TEXT,
                defaultValue: null, params: null
            }
        ];
    },

    getTitle: function() {
        return Constants.getMessage("labelFilterTitle");    
    },
    
    getSummaryText: function() {
        return Constants.getMessage("labelFilterDescriptionAllVisible", Constants.getMessage("labelRequirements"));
    },
    
    getIsSectionOpenInitially: function() {
       return this.initOpenFilter; 
    },
    
    getInitialVisibleFilterCount: function() {
        return 4;    
    },
    
    getFilters: function() {
        return this.filters;
    },
		
    getFilterCount: function() {
        return this.filters.length;
    },
    
    getFilterName: function(index) {
        return this.filters[index].name;
    },
    
    getFilterTitle: function(index) {
        return this.filters[index].title;
    },
    
    getFilterPromptTitle: function(index) {
        return this.filters[index].promptTitle;        
    },
    
    getFilterType: function(index) {
        return this.filters[index].type;
    },
    
    getFilterDefaultValue: function(index) {
        return this.filters[index].defaultValue;
    },
    
    getFilterParams: function(index) {        
        return this.filters[index].params;
    },
    
    getCustomField: function(index) {
        // custom field widget are dynamically created and stored as the params of the filter
		return this.filters[index].params;
    },
    
    getActionsInfo: function() {
        var actions = [
            {
                id: "cancel",
                title: Constants.getMessage("labelReset"),
                callback: dojo.hitch(this, "filterResetActionInvoked"),
                callbackData: null,
                isDefault: false
            }, {
                id: "run",
                title: Constants.getMessage("labelRun"),
                callback: dojo.hitch(this, "filterRunActionInvoked"),
                callbackData: null,
                isDefault: true
            }
        ];
        return actions;
    },
    
    filterResetActionInvoked: function(actionName, filters) {
        // reset the filters by recreating it.
        this.tableView.tableViewer.setContentFilterAttributeProvider(this.tableView.filterProvider);
    },

    filterRunActionInvoked: function(actionName, filters){
        if (this.tableView) {
            // must have the view context to perform the query and update the table display
            var args = {};
            
            for (var nameKey in filters) {
                // iterate through the filters and skip those that are not specified
                if (filters[nameKey] != null) {
                        args[nameKey] = filters[nameKey] || "";
                        if(args[nameKey] == 'Any@@')
                            args[nameKey] = '';
                }
            }
            this.tableView.runQuery(args);
        }
    }
});

dojo.declare("com.ibm.rqm.requirement.web.ui.internal.view.table.RequirementTableView", 
    [dijit._Widget, dijit._Templated, AbstractFilteredTableView],
{    
    templateString: '<div class="com-ibm-rqm-test-artifact-table-view" tabindex="-1">' +
                    '  <div dojoType="com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout" "noline"=true dojoAttachPoint="viewHeaderNode">' +
                    '    <div dojoAttachPoint="_tableViewerNode" class="com-ibm-rqm-test-artifact-table-view" tabindex="-1"></div>' +
                    '  </div>' +
                    '</div>',
	widgetsInTemplate: true, 

    editable: true,
    printable: false,
	isExternal: false,
	hideResetButton: false,

    constructor: function() {
        this.actions = [];
        this.requirements = [];
        this.showInitLoadProgress = false;
		this.showQueryFilters = false;
    },

    postCreate: function() 
    {
        this.inherited("postCreate", arguments);    
		    
		//load class in Risk component
		jazz.core.internal.loader.load_async("com.ibm.rqm.risk.web.ui.internal.view.assessment.AssessmentOverview", function(){});
		jazz.core.internal.loader.load_async("com.ibm.rqm.risk.web.ui.internal.view.assessment.RiskProfileTemplateDialog", function(){});
		jazz.core.internal.loader.load_async("com.ibm.rqm.risk.web.client.internal.risk.RiskClient", function(){});
				
		this._projectAlias = com.ibm.asq.common.web.ui.internal.util.Utility.getCurrentProjectAreaAlias();
		
		// apply the user preference whether to initially open the 
        // filter area
        if (this.showQueryFilters) {
			//init options for running search			
	        this.setSearchFunction(dojo.hitch(RequirementWorkItemClient, "searchRequirements"));
			this.setSearchCallback(dojo.hitch(this, "show"));
	        this.setTypeLabel(Constants.getMessage("labelAllReqmt"));
			
			//init filters
			this._initializeFilters();
        } else {
            this._initialize();
        }               
	},
	
	// Constructs the query filter definitions and the content filter provider for the
    // table. The table will construct the filters section based on the definitions.
    // 
    _initializeFilters: function() {
        // create the filter provider for the table
        this.filterProvider = new RequirementTableView.TableFilterProvider(this, this.isInitiallyOpen(), this.isDefaultsToMine());

		// save the status filter to add later after the originator
//        this.statusFilter = {
//            name: "status", // must match key in the arg list of the API
//            title: Constants.getMessage("labelstatus"),
//            promptTitle: Constants.getMessage("labelstatus"),
//            type: TableContentFilterProvider.FIELD_TOGGLELIST,
//            defaultValue: [],
//            params: {
//                options: [{
//                    name: Constants.getMessage("labelRequirementNormal"),
//                    value: Constants.getMessage("labelRequirementNormal"),
//                    checked: false
//                }, {
//                    name: Constants.getMessage("labelRequirementUpdated"),
//                    value: Constants.getMessage("labelRequirementUpdated"),
//                    checked: false
//                }, {
//                    name: Constants.getMessage("labelRequirementRemoved"),
//                    value: Constants.getMessage("labelRequirementRemoved"),
//                    checked: false
//                }]
//            }
//        };
		
		// save the status filter to add later after the originator
        this.tagFilter = {
            name: "tag", // must match key in the arg list of the API
            title: Constants.getMessage("labelTagRequirementTable"),
            promptTitle: Constants.getMessage("labelTagRequirementTable"),
            type: TableContentFilterProvider.FIELD_TEXT,
			defaultValue: null, params: null
        };
		
		// initlize the orginator filter with the list of contributors
        var self = this;
        var serviceObj = {
            success: function(contributors) {
				contributors = contributors || [];
        		for (var i = 0; i < contributors.length; i++) {
            		if (com.ibm.asq.common.web.ui.internal.util.Utility.isUnassignedUserId(contributors[i].itemId)) {
                		contributors[i].name = Constants.getMessage("labelUnassigned");
            		}
            		contributors[i].value = contributors[i].itemId;
                    contributors[i].checked = false;
        		}
				var owners = {
                    name: "ownerUUIDs",  // must match key in the arg list of the API
                    title: Constants.getMessage("labelowner"),
                    promptTitle: Constants.getMessage("labelOwner"),
                    type: TableContentFilterProvider.FIELD_TOGGLELIST,
                    defaultValue: [],
                    params: (contributors == null) ? null : {options: contributors}
            	};
				self.filterProvider.filters.push(owners);
//                self.filterProvider.filters.push(self.statusFilter);
               // add the tag filter
                self.filterProvider.filters.push(self.tagFilter);
				self._initialize();
            },
			
            failure: function(e) {
                self._error(e);
                // add the status and tag filters to the end even when
                // it failed to initialize the originator filter
//                self.filterProvider.filters.push(self.statusFilter);
                self.filterProvider.filters.push(self.tagFilter);
				self._initialize();
            }
        };
        var responseHandler = new ServiceResponseHandler(serviceObj, "success", "failure");
        UserClient.getContributors(responseHandler);
    },	
	
	_initialize: function() {
        //create the table viewer
        var tableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer({
            //turn off all controls if in print mode 
			showPagingControl: !this.printable,
			showPagingRangeControl: !this.printable,
            showGroupFilterControls: !this.printable,
            showPagingActionsControls: !this.printable,
            allowAdjustSettings: true,
            autoSaveSettings: true          
        });
		
		if (this.showQueryFilters) {
			this.initFilterProvider(this.filterProvider);
            tableViewer.setContentFilterAttributeProvider(this.filterProvider);
        }
		
		tableViewer.performSelectAll = function(select) {
			//clear the last click info whenever the content is reconstructed
			tableViewer.lastSelectedInfo = null; 
			
	        if(tableViewer.getContentItemCount() == 0)
	            return;
	            
	        var selectedRows = [];
	        
	        tableViewer.rowCheckedHandler.clearRowStates();
	        for (var i = 0; i < tableViewer.orderedObjects.length; i++) {
	            for (var j = 0; j < tableViewer.orderedObjects[i].length; j++) {
	                tableViewer.rowCheckedHandler.setRowCheckState(tableViewer.orderedObjects[i][j], select);
	            }
	        }
	       
	        tableViewer._loadTableContents();
	        
	        // notify internally
	        tableViewer._internalRowChecked();
	
	        var listener = tableViewer.getTableListener();
	        if(listener) {
	            listener.rowCheckStateChanged(tableViewer, tableViewer.getContent(), select);
	        }  
    	};
		
		// the view is in a query page if there is a query name otherwise it is within
        // some container that don't need the header
        this.isQueryPage = this.queryName;
		if (this.isQueryPage) {
            // it is a query page so set header title and add table viewer as the header content
            this.viewHeaderNode.setTitle(this.queryName);
	        this.viewHeaderNode.setCSHelpId("rqm_all_req.html");
			this.viewHeaderNode.setCSHelpButtonLabel(Constants.getMessage("labelRequirementTableViewHelp"));
			this._tableViewerNode.appendChild(tableViewer.domNode);
        } else {
            // it is not a query page i.e. within a section without header
            this.viewHeaderNode.domNode.style.display = "none";
			this.domNode.appendChild(tableViewer.domNode);
        }
		                        
        var content = this.requirements ? this.requirements : [];
        
        tableViewer.tableId = (this.isQueryPage) ? "RQM-REQ-QUERY-TABLEVIWER" : "RQM-REQ-TABLEVIWER";
        tableViewer.setContent(content);
		if(this.isExternal) {
			tableViewer.setContentProvider(new com.ibm.rqm.requirement.web.ui.internal.view.table.ExternalRequirementTableViewTableProvider({tableViewer: this}));
		} else if(this.isExternalByPriority){
			tableViewer.setContentProvider(new com.ibm.rqm.requirement.web.ui.internal.view.table.ExternalRequirementWithPriorityProvider({tableViewer: this}));
		} else {
        	tableViewer.setContentProvider(new com.ibm.rqm.requirement.web.ui.internal.view.table.RequirementTableViewTableProvider({tableViewer: this}));
        }
		tableViewer.registerCellRenderer(RENDER_TYPE_REQLINK, 
            new com.ibm.rqm.requirement.web.ui.internal.view.table.RequirementTableLinkCellRenderer);
		tableViewer.rowCheckedHandler = new com.ibm.rqm.requirement.web.ui.internal.view.table.RequirementRowCheckedHandler(tableViewer);
		tableViewer.setTableListener(new com.ibm.rqm.requirement.web.ui.internal.view.table.RequirementTableViewTableListener(this));
        tableViewer.setCellModifier(new com.ibm.rqm.requirement.web.ui.internal.view.table.RequirementTableViewCellModifier(this));
        tableViewer.setTableRowsCheckable(this.editable && !this.printable, /* isSingleSelect */ false);
        tableViewer.setTableSummary(Constants.getMessage("labelTableSummary", Constants.getMessage("labelRequirements")));
		
		//add refresh action (use 'refreshQuery' api if showing filters)
        this.refreshCallback = this.showQueryFilters ? dojo.hitch(this, "refreshQuery") : this.refreshCallback;
		if (this.refreshCallback && dojo.isFunction(this.refreshCallback)) {
        	tableViewer.addAction("refresh", Constants.getMessage("labelRefresh"), this, "refresh-icon-image", this.refreshCallback);    
        }
				
        //add external actions to the table viewer
        for (var i = 0; i < (this.actions ? this.actions.length : 0); i++) {
            var action = this.actions[i];
		    var actionButton = tableViewer.addAction(action.label, action.label, this, action.iconClass, action.actionHandler);
        	if (action.label == Constants.getMessage("labelAssociatedTestPlans")) {
				this.assoicatedTestPlanNode = actionButton;
				this.assoicatedTestPlanNode.setDisabled(true);
			}
			if (action.label == Constants.getMessage("labelAssociatedTestCases")) {
				this.assoicatedTestCaseNode = actionButton;
				this.assoicatedTestCaseNode.setDisabled(true);
			}
			if (action.label == Constants.getMessage("labelDisassociateRequirements")) {
				this.disaccosicateButton = actionButton;
				this.disaccosicateButton.setDisabled(true);
			}
			if (action.label == Constants.getMessage("labelArchive")) {
				this.deleteButton = actionButton;
				this.deleteButton.setDisabled(true);
			}
			if (action.label == Constants.getMessage("labelCreateTestCases")) {
				this.createCaseButton = actionButton;
				this.createCaseButton.setDisabled(true);
			}
		}
		
		this.printActionNode = tableViewer.addAction(
        			"printpdf",
        			Constants.getMessage("labelPDFView"),
        			null,
        			"pdf-icon-image",
        			dojo.hitch(this, "_onPrintPdfActionClick")
        );
        
		//add trace action

        var type = com.ibm.asq.common.web.client.internal.PermissionsClient.OP_REQ_WORKITEM;
        var perm = com.ibm.asq.common.web.client.internal.PermissionsClient.getStoredPermission(type);
        
        if(!this.hideResetButton) {
        	if (!perm || perm.changestatus) {
        		this.clearStatusActionNode = tableViewer.addAction("changeStatus", // action id
        				Constants.getMessage("labelResetRequirementStatus"), // label
        				null, // callback data
        				"reset-reqstatus-icon-image", // icon class
        		dojo.hitch(this, "_onChangeStatusActionClick")); // callback
        		this.clearStatusActionNode.setDisabled(true);
        	}
        }
        this.tableViewer = tableViewer;
        if(this.showInitLoadProgress) {
            this.tableViewer.showLoadingProgress();
        }
        this.tableViewer.show();
        this.tableViewer.setEditable(this.editable);     
		
		if (this.showQueryFilters) {
			this.initRunQuery();
		}   
    },
	
	_onChangeStatusActionClick: function() {
		if (this.getSelectedRows() && this.getSelectedRows().length > 0) {
			this.refreshData(this.getSelectedRows());
		}
	},
    
    setEditable: function(isEditable) {
        this.editable = isEditable;   
        this.tableViewer.setEditable(this.editable);     
    },
    
	show: function(requirements) {
        this.refresh(requirements || []);
		if(dojo.isFunction(this.stopInProgress))
        	this.stopInProgress(); 	
	 },
	 
    refresh: function(requirements) {
      	this.requirements = this._filterArchivedRequirements(requirements);
	  	this.tableViewer.setContent(this.requirements);
        if(this.showInitLoadProgress) {
            this.tableViewer.endLoadingProgress();
            this.showInitLoadProgress = false;
        }
		if(this.printActionNode){
			if(!requirements || !requirements.length){
				this.printActionNode.setDisabled(true);
			}else{
				this.printActionNode.setDisabled(false);
			}
		}
	 	this.tableViewer.refresh();
      	this.tableViewer.setEditable(this.editable);
      	//refresh table actions
      	if(this.clearStatusActionNode!=null)
			this.clearStatusActionNode.setDisabled(true);
       	if(this.disaccosicateButton!=null)
			this.disaccosicateButton.setDisabled(true);
		if(this.assoicatedTestPlanNode!=null)
			this.assoicatedTestPlanNode.setDisabled(true);
		if(this.assoicatedTestCaseNode!=null)
			this.assoicatedTestCaseNode.setDisabled(true);
		if(this.deleteButton!=null)
			this.deleteButton.setDisabled(true);
		if(this.createCaseButton!=null)
			this.createCaseButton.setDisabled(true);
    },
	
	_onPrintPdfActionClick: function() {
        var type = "requirement";
        var selectedScripts = this.tableViewer.getCheckedRows();
        var loc = window.location.href;
		loc = loc.replace(/[&]/g,"%26");
		var summary = false;
		if (!selectedScripts.length){
				selectedScripts = this.requirements;
				summary = true;
			}
		this.tableViewer.sendPdfPrintRequest(selectedScripts,type,loc,this._projectAlias, summary);
    },
    
	//change status with latest data
    refreshData: function(requirements){
		var updatedRequirementIds = [];
		for(var i=0; i<requirements.length; i++) {
			if(requirements[i].status == "updated" || requirements[i].status == "removed") {
				updatedRequirementIds.push(requirements[i].id);
			}
		}
		if (updatedRequirementIds.length > 0) {
			this._needUpdatedReq = updatedRequirementIds;
            var args = {
                'message': Constants.getMessage("msgConfirmUpdateRequirement"),
                'yesCallback': dojo.hitch(this, "_refreshDataAction")
            };
            var confirmDialog = new com.ibm.asq.common.web.ui.internal.widgets.YesNoDialog(args);
            confirmDialog.setSecondaryTitle(Constants.getMessage("labelConfirmation"));
            confirmDialog.open();
        } else {
			var alertDialog = new com.ibm.asq.common.web.ui.internal.widgets.AlertDialog({'message': Constants.getMessage("msgNoRequirementInSuspect")});
    	    alertDialog.setSecondaryTitle(Constants.getMessage("labelAlert"));
        	alertDialog.open();
		}
    },
    
	_refreshDataAction: function() {
		var responseHandler = new ServiceResponseHandler(this, "_refreshNewestData", "_error");
        RequirementWorkItemClient.getLastestWorkItemDTOs(responseHandler, {
                    	ids: this._needUpdatedReq
                	});
	},
	
    _refreshNewestData: function(requirements){
        var newRequirements = new Array();
		if (this.requirements && this.requirements.length) {
            for (var i = 0; i < this.requirements.length; i++) {
				var noChange = true; 
				//for update
				for (var j = 0; requirements && j < requirements.length; j++) {
					if (this.requirements[i].id == requirements[j].id) {
						newRequirements.push(requirements[j]);
						noChange = false;
						break;
					}
				}
				//for delete
				if (noChange) {
					for (var k = 0; k < this._needUpdatedReq.length; k++) {
						if (this._needUpdatedReq[k] == this.requirements[i].id) {
							noChange = false;
							break;
						}
					}
				}
                if (noChange) {
				    this.requirements[i].selected = false;
					newRequirements.push(this.requirements[i]);
				}
            }
            this.requirements = newRequirements;
            this.refresh(newRequirements);			
		}
    },
	
	//Hack: remove archived requirements. Service won't filter archived requirements
	_filterArchivedRequirements: function(requirements) {
		var newReqs = [];
		for(var i = 0; i < (requirements ? requirements.length : 0); i++) {
			if(requirements[i].status != "archived")
				newReqs.push(requirements[i]);
		}
		delete requirements;
		return newReqs;
	},
	
	_error: function(e) {
		if (this.isQueryPage) {
			this.viewHeaderNode.setStatus("Error: " + e.message, ViewHeaderLayout.ERROR);
		}
        console.error(this.declaredClass + ": Error: " + e.message);
    },
    
	// API
	getSelectedRows: function() {
	    var selectrows = this.tableViewer.getCheckedRows();
		return selectrows;
	},
	
	getViewer: function() {
		return this.tableViewer;
	}
});

dojo.declare("com.ibm.rqm.requirement.web.ui.internal.view.table.ExtRequirementTableView", com.ibm.rqm.requirement.web.ui.internal.view.table.RequirementTableView, {
	
	_initialize: function() {
		this.inherited("_initialize", arguments);
		this.tableViewer.setTableRowsCheckable(!this.printable, /* isSingleSelect */ false);
		this.tableViewer.setTableSummary(Constants.getMessage("labelTableSummary", Constants.getMessage("labelRequirements")));
		this.tableViewer.show();
	},
	
	requirementHeaderColumnActionInvoked: function(tableViewer, columnIndex, actionId){
        if (actionId == "risk") {
            //handle risk assessment
            var profileDialog = new com.ibm.rqm.risk.web.ui.internal.view.assessment.RiskProfileTemplateDialog({
                artifactType: Constants.MODEL_TYPE_REQUIREMENT,
                actionId: actionId,
                okCallback: dojo.hitch(this, "_handleRiskProfile")
            });
        }
		
		if (actionId == "owner") {
			var self = this;
			var handler = {
                success: function(users){
                    if (dojo.isArray(users) && users.length > 0) {
						var len = users.length;
                        var owners = [];
                        for (var i = 0; i < len; i++) {
                            if (users[i].name != "ADMIN" && users[i].name != "GUEST" && !users[i].archived) {
								if(com.ibm.asq.common.web.ui.internal.util.Utility.isUnassignedUserId(users[i].itemId))
									users[i].name = Constants.getMessage("labelUnassigned");
                                owners.push(users[i]);
                            }
                        }
                        
                        var args = {
                            owners: owners,
                            actionId: actionId,
                            okCallback: dojo.hitch(self, "_handleChangeOwner")
                        }
                        
                        var dlg = new com.ibm.rqm.planning.web.ui.internal.view.common.properties.SelectOwnerPopup();
                        dlg.initialize(args);
                    }
                    
                },
                error: function(e){
                    console.error(e);
                }
            };
            var responseHandler = new ServiceResponseHandler(handler, "success", "error");
            UserClient.getContributors(responseHandler);
		}
	},
	
	_handleChangeOwner: function(args) {
		var selectedItems = this.tableViewer.getCheckedRows();
		var ids = [];
		var length = selectedItems.length;
		for(var i = 0; i < length; i++){
			ids.push(selectedItems[i].id);
		}
		var params = {
			ids: ids,
			ownerUUID: args.OwnerItemId
		};
		
		var self = this;
		var handler = {
			success: function(requirementDtos){
				var selectedItems = self.tableViewer.getCheckedRows();
				var length = selectedItems.length;
				var length2 = requirementDtos.length;
				for(var i = 0; i < length; i++){
					var item = selectedItems[i];
					for(var j = 0; j < length2; j++){
						var dto = requirementDtos[j];
						if(dto.id == item.id){
							item.owner = dto.owner;
							break;
						}
					}
				}
				self.tableViewer.refresh();
			},
			error: function(error){
				console.error(error);
			}
		};
		var responseHandler = new ServiceResponseHandler(handler, "success", "error");
		
		RequirementWorkItemClient.postReassignRequirementOwner(responseHandler, params)
	},
	
	_handleRiskProfile: function(args) {
        if (args && args.selectedProfile) {
            var selectedItems = this.tableViewer.getCheckedRows();
            
            var self = this;
            var handler = {
                success: function(riskAssessments){
                    var content = self.tableViewer.getContent();
                    for (var i in selectedItems) {
                    	var selectedItemId=selectedItems[i].id;
                        for (var j in content) {
                        	var c=content[j];
                            if (c.id == selectedItemId) {
                                c.risk = self._refreshRequirementRisk(c, riskAssessments);
                            }
                        }
                    }
                    self.tableViewer.refresh();
                },
                error: function(e){
                    self._error(e);
                }
            }
            var itemIds = [];
            var length=selectedItems.length;
            for (var i = 0; i < length; i++) {
                itemIds.push(selectedItems[i].itemId);
            }
            var params = {
                artifactType: Constants.MODEL_TYPE_REQUIREMENT,
                riskProfileId: args.selectedProfile.id,
                operation: args.handleAction,
                artifactItemIds: itemIds
            };
            
            var responseHandler = new ServiceResponseHandler(handler, "success", "error");
            com.ibm.rqm.risk.web.client.internal.risk.RiskClient.postSwitchRiskProfile(responseHandler, params);
        }
	},
			
	_refreshRequirementRisk: function(req, riskAssessments) {
        var newSystemRiskLevel = "0";
        var length=(riskAssessments ? riskAssessments.length : 0);
        var reqItemId=req.itemid;
        for (var i = 0; i < length; i++) {
            if (reqItemId == riskAssessments[i].targetArtifactItemId) {
                newSystemRiskLevel = riskAssessments[i].riskLevel;
                break;
            }
        }
        var newRisk = "";
        var oldRisk = req.risk;
        if (oldRisk != "") 
            newRisk = oldRisk.slice(0, oldRisk.indexOf("calculatedRisk") + 15) + newSystemRiskLevel;
        else 
            newRisk = "communityRisk:0 calculatedRisk:" + newSystemRiskLevel;
        return newRisk;
	}
});

})();
