//SequenceResultTableView
/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rational.test.lm.sequencer.web.ui.internal.view.table.SequenceResultTableView");
 
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
/*
 * author: vasrivas
 */
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");
dojo.require("com.ibm.asq.common.web.ui.internal.util.GlobalEvents");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.ListRowRenderer");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.rational.test.lm.sequencer.web.ui.internal.Constants");
dojo.require("com.ibm.rational.test.lm.sequencer.web.client.internal.sequence.SequenceClient");
dojo.require("com.ibm.rational.test.lm.sequencer.web.ui.internal.util.Utility");
dojo.require("com.ibm.team.repository.web.client.session.Session");

(function() {

var TableConstants 					= com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;
var ImageCache     					= com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
var ServiceResponseHandler			= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var Constants 						= com.ibm.rational.test.lm.sequencer.web.ui.internal.Constants;
var SequenceClient 					= com.ibm.rational.test.lm.sequencer.web.client.internal.sequence.SequenceClient;
var getAuthenticatedContributor		= com.ibm.team.repository.web.client.session.getAuthenticatedContributor;
var Utility  						= com.ibm.rational.test.lm.sequencer.web.ui.internal.util.Utility;
var GlobalEvents 					= com.ibm.asq.common.web.ui.internal.util.GlobalEvents;

dojo.declare("SequenceResultTableView.TableListener", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableListener,
{
    constructor: function(args) {
		dojo.mixin(this, args);
    },
    
  rowCheckStateChanged: function(tableViewer, rowObject, state)
    {
        var selection = tableViewer.getCheckedRows();
        var selectionCount = selection.length;
		//if table view has a rowCheckListener, invoke it
		var p = this.parentView;
        if (p && p.rowCheckedListener && dojo.isFunction(p.rowCheckedListener)) {
			p.rowCheckedListener(rowObject, state);
		}
    },
    
    // Summary:
    //    A group check box is shown when the tables rows are checkable and the in multi-select mode.
    //    This method is called when the group's check box is checked/unchecked. The affected rows and 
    //    their states are passed.
    //
    groupRowsCheckStateChanged: function(tableViewer, rowObjects, state) 
    {
        this.rowCheckStateChanged(tableViewer, rowObjects, state);
    },
    
    // Summary:
    //    If the client have registered table actions, this message will be fired when an action (button)
    //    is invoked by the user.
    //
     tableContentActionInvoked: function(tableViewer, actionId, callbackData, callback)
    {                
        if (callback == null && callbackData != null && dojo.isFunction(callbackData)) {
            callbackData();
        }
		
		if (callback != null && dojo.isFunction(callback)) {
            if (callbackData != null) {
                callback(callbackData);
            } else {
                callback();
            }
        } 
    },

    tableContentFilterActionInvoked: function(tableViewer, actionId, filters, callback, callbackData)
    {
        if(callback) {
            callback(actionId, filters);
        }                     
    },
	
	// Summary:
    //    If the client have specified a header image and specified that it's an action (see TableContentProvider 
    //    for details), when the column's image is clicked, this message is invoked.
    //
    tableHeaderColumnActionInvoked: function(tableViewer, columnIndex, /*optional*/actionId)
    {
		this.parentView.tableHeaderColumnActionInvoked(columnIndex, actionId);  
    }  
});

dojo.declare("SequenceResultTableView.CellModifier", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier,
{
    // Summary:
    //    Method to be called when a cell renderer changes the cell value. This notifies
    //    the cell's value change event. 
    //    
    //    
    cellValueChanged: function(oldValue, newValue, rowObject, columnIndex)
    {
        // store the new values in our internal data model
        if(columnIndex == 1) {
            if(dojo.isString(newValue)) {
                rowObject.testScriptName = newValue;
            }
        }
    },
    
    cellActionInvoked: function(rowObject, columnIndex)
    {
    }
});

dojo.declare("SequenceResultTableView.TableProvider", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider,
{
    // Summary:
    //
    getNumColumns: function(content)
    {
        return 6;
    },
    
    // Summary:
    //
	_columnHeadings: [
			"",
			Constants.getMessage("labelSequenceName"),
            Constants.getMessage("labelStartTime"),
			Constants.getMessage("labelEndTime"),
			Constants.getMessage("labelStatus"),
			Constants.getMessage("labelActualResult")
    ],
    // Summary:
    //
    getColumnHeading: function(content, index)
    {
        return this._columnHeadings[index];
    },

    // Summary:
    //    Optionally, returns an image src URL to be placed in the column header. If both heading
    //    and image are specified, both are shown.
    //    
    getColumnHeadingImage: function(content, atColumnIndex)
    {
        return null;
    },
	 
    // Summary:
    //    Returns the column header horizontal alignment. By default, the columns are
    //    aligned to the left.
    //
    //    Client optionally can indicate the alignment for the column header.
    //
    getColumnHeadingAlignment: function(atColumnIndex)
    {
        return this.getCellAlignment(null, atColumnIndex);
    },	 
    
    getIsColumnGroupable: function(content, atColumnIndex)
    {
        return (atColumnIndex == 1 || atColumnIndex == 5);     
    },

    getIsColumnSortable: function(content, atColumnIndex)
    {
        return (true);     
    },
    
    getColumnWidth: function(content, atColumnIndex)
    {
        switch(atColumnIndex) {
            case 0: 
                return 5;
            case 1: 
                return 35;
            case 2: 
                return 15;
			case 3:
				return 15;
			case 4:
				return 15;
			case 5:
				return 15;
        }
        return 0;
    },
    
    // Summary:
    //    The only assumptions the table have on the data that it displays
    //    is that it's an array contents. These are the data content/object that
    //    will be displayed in the table rows.
    //
    getContentObjects: function(content)
    {
        // our content is already an array of objects
        return content;
    },
    
    getRowDataId: function(rowData)
    {
        return "_table_row_for_sequence_result_table" + rowData.itemId;
    },
    
    // Summary:
    //    Returns the type of the cell to be displayed. By default, the TableViewer
    //    will support a set of cell types. The type of the cell will map to a specific
    //    cell renderer (to be discussed).
    getCellDisplayType: function(rowData, atColumnIndex)
    {
        var type = TableConstants.RENDER_TYPE_TEXT;

        switch(atColumnIndex) {
            case 0:
			case 4:
                type = TableConstants.RENDER_TYPE_IMAGE;
                break;
			case 1:
			case 5: 
                type = TableConstants.RENDER_TYPE_LINK;
                break;
			case 2:
			case 3: 
                type = TableConstants.RENDER_TYPE_DATE;
                break;
        }
        return type;
    },

    getCellAlignment: function(rowData, atColumnIndex)
    {
        return (atColumnIndex == 0 || atColumnIndex == 4? TableConstants.ALIGN_CENTER : TableConstants.ALIGN_LEFT);
    },
    
    // Summary:
    //    Returns the display data of the cell. For cell renderer type of TEXT, this will
    //    be the string. Others cell render type would be Date, or integer value, etc. If the 
    //    cell renderer type is image, the client can also supply cell data that can be sortable/groupable. 
    //    The TableViewer's default sorter, filter operates on this returned data. For "complex" 
    //    cell types such as image where it could have multiple values for different states, the 
    //    client also needs to implement the next method.
    //    
    //    Client must implement this method to provide the cell data.
    //    
    getCellDisplayData: function(rowData, atColumnIndex)
    {
        var val = "";
        switch(atColumnIndex) {
            case 0: 
                val = "";
                break;
            case 1: 
                val = rowData.sequenceName; 
                break;
            case 2: 
                val = new Date();
                val.setTime(rowData.startTime);
                break;
			case 3: 
				val = Constants.getMessage("labelNA");
				if(rowData.endTime && parseInt(rowData.endTime) && parseInt(rowData.endTime) != 0){
	                val = new Date();
	                val.setTime(rowData.endTime);
				}	
				break;
			case 4: 
                val = ""
                break;
			case 5: 
                val = Utility.getResultString(rowData.result);
                break;	
        }
        return val;
    },
    
    // Summary:
    //    If applicable, returns the extended display information of the cell. The return extended
    //    info must be an object with the following attributes:
    //    
    //    {
    //      /* attribute common for all cell renderer types */
    //      "tooltip": <string>,
    //
    //      /* attributes for IMAGE and ACTION cell renderer types */
    //      "isHidden": <true, false> the image is hidden if the row is not on the mouse over
    //      "image": base image URL,  
    //      "mouseOverImage": image URL, (optional)
    //      "mouseOutImage": image URL,  (optional) (overrides "image")
    //
    //      /* attributes for SELECT cell renderer type */
    //      "select" : 'value', the selection in the combo
    //      "choices" : [{'text':'display text', 'value':'value'}, ] array of objects with 'text' and 'value' attributes
    //
    //      /* attributes for CHECKBOX cell renderer type */
    //      "state" : <true, false> initial state of the check box
    //
    //      /* attributes for LINK cell renderer type */
    //      "href" : <string> the href string for the link
    //    }
    //
    //    Client can implement this method to provide extended display infor for the cell.
    //    Certain cell renderer type will require the client to implement this method to
    //    provide needed display information, such as an image ACTION.
    //
    getCellDisplayExtendedInfo: function(rowData, atColumnIndex)
    {  
		var val = null;
		if(atColumnIndex == 0){
			val ={};
			val.image = ImageCache.EXECUTION_SEQ_RESULT;
			val.tooltip = Constants.getMessage("labelClickToOpen");
			val.href = Utility.getSequenceResultURI(rowData.itemId);
		}else if(atColumnIndex == 1){
			val ={};
			val.tooltip = Constants.getMessage("labelClickToOpen");
			val.href = Utility.getSequenceURI(rowData.sequenceId);
		}else if(atColumnIndex == 4){
			val ={};
			val.image = rowData.isRunning ? ImageCache.IN_PROGRESS : ImageCache.COMPLETE;
			val.tooltip = rowData.isRunning ? Constants.getMessage("labelInProgress") : Constants.getMessage("labelComplete");
			val.href = Utility.getSequenceResultURI(rowData.itemId);
		}else if(atColumnIndex == 5){
			val ={};
			val.tooltip = Constants.getMessage("labelClickToOpen");
			val.href = Utility.getSequenceResultURI(rowData.itemId);
		}		
		return val;
    }
});

dojo.declare("com.ibm.rational.test.lm.sequencer.web.ui.internal.view.table.SequenceResultTableView", 
    [dijit._Widget, dijit._Templated],
{    
    templateString: '<div dojoAttachPoint="_tableViewerNode" class="com-ibm-rqm-test-artifact-table-view" tabindex="-1">' +
                    '  <div dojoType="com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout" "noline"=true dojoAttachPoint="viewHeaderNode"></div>' +
					'    <div dojoAttachPoint="_tableViewerNode" class="com-ibm-rqm-test-artifact-table-view" tabindex="-1"></div>' +
                    '  </div>' +
				    '</div>',

    widgetsInTemplate: true,

    constructor: function() {
		this.actions = [];
		this.sequenceResults = [];
		this._actionButtons = [];
	 },

    postCreate: function() {
        this.inherited("postCreate", arguments);
    },
	
	initialize: function(args){
		this.queryName = args.queryName;
		this.sequenceId = args.sequenceId;
		this.isQueryPage = this.queryName;
        if (this.isQueryPage) {
            this.viewHeaderNode.setTitle(this.queryName);
            this.viewHeaderNode.setCSHelpId("rqm_view_exec_sequence.html");
        } else {
            this.viewHeaderNode.domNode.style.display = "none";
        }
		var responseHandler = new ServiceResponseHandler(this, "_initialize", "_error");
		var param = {};  
		if(!this.sequenceId ){
			SequenceClient.getExecutionSequenceResultsSummaryDTO(responseHandler, param);
		}else{
			param.sequenceId = this.sequenceId;
			SequenceClient.getExecutionSequenceResultsSummaryDTO(responseHandler, param);
		}
	},
	
	_initialize: function(sequenceResults){
		this.sequenceResults = sequenceResults ? sequenceResults : [];
		if(!this.tableViewer){
			dojox.data.dom.removeChildren(this._tableViewerNode);     
			var tableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer({
	            allowAdjustSettings: true,
	            autoSaveSettings: true,
	            tableId: "SEQUENCE-RESULT-TABLEVIEWER"                                
	        });        
	        this._tableViewerNode.appendChild(tableViewer.domNode);
	
	        var content = this.sequenceResults;
			if(content && content.length>0){
				this.parentEditor.getHeader().setSummary(content[0].sequenceDescription);
			}
	        tableViewer.setContentPageSize(20);
	        tableViewer.setContent(content);
	        tableViewer.setContentProvider(new SequenceResultTableView.TableProvider());
	        tableViewer.setTableListener(new SequenceResultTableView.TableListener({parentView: this}));
	        tableViewer.setCellModifier(new SequenceResultTableView.CellModifier());
			tableViewer.setTableSummary(Constants.getMessage("labelTableSummary", this.queryName ?this.queryName : "Results"));
			tableViewer.setTableRowsCheckable(false, /* isSingleSelect */ false);
			
			this.actions = this.getTableActions();
			var actionLen  =(this.actions ? this.actions.length : 0);
			for (var i = 0; i < actionLen; i++) {
	            var action = this.actions[i];
	            var actionButton = tableViewer.addAction(action.actionId, action.label, action.actionHandler, action.iconClass);
	            if (action.disabled && action.disabled == true)
	                actionButton.setDisabled(true);
	            if (action.hidden && action.hidden == true)
	                dojo.addClass(actionButton.domNode, "dijitDisplayNone");
				if(action.actionId == "delete"){
					this.deleteActionNode = actionButton;
				}	
	            this._actionButtons.push(actionButton);
	        }
			
	        tableViewer.show();
			this.tableViewer = tableViewer;
		}else{
			if (this.isQueryPage)
            	this.viewHeaderNode.setProgressEnd();
			this.tableViewer.endLoadingProgress();
			this.tableViewer.setContent(this.sequenceResults);
			this.tableViewer.refresh();
		}	
	},
	
	getTableActions: function(){
		var actions = [];
		actions.push({
                    actionId: "refresh",
                    label: Constants.getMessage("labelRefresh"),
                    actionHandler: dojo.hitch(this, "_handleRefresh"),
                    iconClass: "refresh-icon-image"
                });
		return actions;
	},

	_handleRefresh: function(){
		if (this.isQueryPage)
				this.viewHeaderNode.setProgressStart(Constants.getMessage("msgLoadingSchedules"));
		this.tableViewer.setContent([]);
		this.tableViewer.refresh();
		this.tableViewer.showLoadingProgress();
		this.initialize({queryName:this.queryName, sequenceId: this.sequenceId});
	},
	
	refresh: function(){
		this.tableViewer.refresh();
	},
	
	getContent: function(){
		return this.tableViewer.getContent();
	},
	
	disableAllActions: function(){
		var actions = this.tableViewer.getActionButtons();
		for(var action in actions){
			if(actions[action].actionId != "add")
				actions[action].setDisabled(true);
		}
	},
	
	onArtifactChanged: function(changeType, artifactType, artifactArray) {
        if (artifactType == Constants.TYPE_SEQUENCE_RESULT) {
            if (changeType == GlobalEvents.ArtifactsAdded) {
				var content = this.tableViewer.getContent();
				content = content.concat(artifactArray);
                this.tableViewer.setContent(content);
                this.tableViewer.refresh();
				this.artifactUpdated = true;
            } else {
				var content = this.tableViewer.getContent();
				var artifactArrayLength = artifactArray.length;
                for (var i = 0; i < artifactArrayLength; i++) {
					var contentLength = content.length;
                    for (var j = 0; j < contentLength; j++) {
                        if (artifactArray[i].itemId == content[j].itemId) {
                            if (changeType == GlobalEvents.ArtifactsUpdated) {
                                content.splice(j, 1, artifactArray[i]);
                                this.tableViewer.setContent(content);
                                this.tableViewer.refresh();
								this.artifactUpdated = true;
                            } else if (changeType == GlobalEvents.ArtifactsDeleted) {
                                content.splice(j, 1);
                                this.tableViewer.setContent(content);
                                this.tableViewer.refresh();
								this.artifactUpdated = true;
                            }
                            break;
                        }
                    }
                }
            }
        }
    },
	
	_error: function(error){
		console.error("Error in SequenceResultTableView "+ error.message);
	}
});
})();
