//TestRecordDetailTableView
/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rational.test.lm.sequencer.web.ui.internal.view.table.TestRecordDetailTableView");
 
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
/*
 * author: vasrivas
 */
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.ListRowRenderer");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.rational.test.lm.sequencer.web.ui.internal.Constants");

(function() {

var TableConstants 				= com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;
var ImageCache     				= com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
var ServiceResponseHandler		= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var Constants 					= com.ibm.rational.test.lm.sequencer.web.ui.internal.Constants;

dojo.declare("TestRecordDetailTableView.TableListener", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableListener,
{
    constructor: function(args) {
		dojo.mixin(this, args);
    },
    
   
  rowCheckStateChanged: function(tableViewer, rowObject, state)
    {
        var selection = tableViewer.getCheckedRows();
        var selectionCount = selection.length;
		if(selectionCount > 0){
			this.parentView.editActionNode.setDisabled(false);
		}else{
			this.parentView.editActionNode.setDisabled(true);
		}
		//if table view has a rowCheckListener, invoke it
		var p = this.parentView;
        if (p && p.rowCheckedListener && dojo.isFunction(p.rowCheckedListener)) {
			p.rowCheckedListener(rowObject, state);
		}
    },

    groupRowsCheckStateChanged: function(tableViewer, rowObjects, state) 
    {
        this.rowCheckStateChanged(tableViewer, rowObjects, state);
    },

     tableContentActionInvoked: function(tableViewer, actionId, callbackData, callback)
    {                
        if (callback == null && callbackData != null && dojo.isFunction(callbackData)) {
            callbackData();
        }
		
		if (callback != null && dojo.isFunction(callback)) {
            if (callbackData != null) {
                callback(callbackData);
            } else {
                callback();
            }
        } 
    },

    tableContentFilterActionInvoked: function(tableViewer, actionId, filters, callback, callbackData)
    {
        if(callback) {
            callback(actionId, filters);
        }                     
    },

    tableHeaderColumnActionInvoked: function(tableViewer, columnIndex, /*optional*/actionId)
    {
		this.parentView.tableHeaderColumnActionInvoked(columnIndex, actionId);  
    }  
});

dojo.declare("TestRecordDetailTableView.CellModifier", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier,
{

    cellValueChanged: function(oldValue, newValue, rowObject, columnIndex)
    {
        // store the new values in our internal data model
        if(columnIndex == 1) {
            if(dojo.isString(newValue)) {
                rowObject.testScriptName = newValue;
            }
        }
    },
    
    cellActionInvoked: function(rowObject, columnIndex)
    {
    }
});

dojo.declare("TestRecordDetailTableView.TableProvider", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider,
{
    // Summary:
    //
    getNumColumns: function(content)
    {
        return 7;
    },
    
    // Summary:
    //
    _columnHeadings: [
            Constants.getMessage("labelTestCase"),
			Constants.getMessage("labelTestPlan"),
			Constants.getMessage("labelMilestone"),
			Constants.getMessage("labelTestScript"),
			Constants.getMessage("labelMachine"),
			Constants.getMessage("labelHealth"),
            ""
        ],
    
    // Summary:
    //
    
    getColumnHeading: function(content, index){
        return this._columnHeadings[index];
    },

    getColumnHeadingImage: function(content, atColumnIndex)
    {
        return null;
    },
	 
    getColumnHeadingAlignment: function(atColumnIndex)
    {
        return this.getCellAlignment(null, atColumnIndex);
    },	 
    
    getIsColumnGroupable: function(content, atColumnIndex)
    {
        return false;     
    },

    getIsColumnSortable: function(content, atColumnIndex)
    {
        return false;     
    },
    
    getColumnWidth: function(content, atColumnIndex)
    {
        switch(atColumnIndex) {
            case 0: 
                return 20;
            case 1: 
                return 20;
            case 2: 
                return 15;
			case 3: 
                return 20;
            case 4: 
                return 15;
            case 5: 
                return 5;
			case 6: 
                return 5;		
        }
        return 0;
    },
    
    getContentObjects: function(content)
    {
        // our content is already an array of objects
        return content;
    },
    
    getRowDataId: function(rowData)
    {
        return "_table_row_for_test_record_details" + rowData.id;
    },
    
    getCellDisplayType: function(rowData, atColumnIndex)
    {
        var type = TableConstants.RENDER_TYPE_TEXT;

        switch(atColumnIndex) {
            case 3: 
                type = TableConstants.RENDER_TYPE_ENUM;
                break;
			case 5: 
                type = TableConstants.RENDER_TYPE_IMAGE;
                break;
			case 6: 
                type = TableConstants.RENDER_TYPE_IMAGE;
                break;		
        }
        return type;
    },

    getCellAlignment: function(rowData, atColumnIndex)
    {
        return TableConstants.ALIGN_LEFT;
    },
       
    getCellDisplayData: function(rowData, atColumnIndex)
    {
        var val = "";
        switch(atColumnIndex) {
            case 0: 
                val = rowData.testCase ? rowData.testCase.name:"";
                break;
            case 1: 
                val = rowData.testPlan ? rowData.testPlan.name : Constants.getMessage("labelUnassigned");//Test plan 
                break;
            case 2: 
                val = rowData.testPhase ? rowData.testPhase.name : (rowData.phase ?rowData.phase.name : Constants.getMessage("labelUnassigned") );//Test iteration
                break;
			case 3: 
                val = "";
                break;
			case 4: 
                val = rowData.machine;
                break;
			case 5: 
                val = "";
                break;
			case 6: 
                val = "";
                break;				
        }
        return val;
    },
    
    getCellDisplayExtendedInfo: function(rowData, atColumnIndex)
    {  
		var val = null;
		if(atColumnIndex == 3) {
            val = {};
			val.choices = [];
				if (rowData.testCase.scripts && rowData.testCase.scripts.length > 0) {
					var scriptsLen = rowData.testCase.scripts.length;
					for (var i = 0; i < scriptsLen; i++) {
						val.choices.push({
							text: rowData.testCase.scripts[i].name,
							value: rowData.testCase.scripts[i].id
						});
						val.select = rowData.defaultScript?rowData.defaultScript.id:rowData.testCase.scripts[0].id;
					}
				}
        }else if(atColumnIndex == 5) {
            val = {};
			val.image = ImageCache.TEST_SUITE;
//            val.href = Utility.getTestSuiteURI(rowData.id);
//			val.tooltip = Constants.getMessage("labelClickToOpenTestSuite");				
        }else if(atColumnIndex == 6) {
            val = {};
			val.image = ImageCache.EDIT;
//            val.href = Utility.getTestSuiteURI(rowData.id);
//			val.tooltip = Constants.getMessage("labelClickToOpenTestSuite");				
        }
		return val;
    }
    
    
});

dojo.declare("com.ibm.rational.test.lm.sequencer.web.ui.internal.view.table.TestRecordDetailTableView", 
    [dijit._Widget, dijit._Templated],
{    
    templateString: '<div dojoAttachPoint="_tableViewerNode" class="com-ibm-rqm-test-artifact-table-view" tabindex="-1">' +
                    '    <div dojoAttachPoint="_tableViewerNode" class="com-ibm-rqm-test-artifact-table-view" tabindex="-1"></div>' +
                    '  </div>' +
				    '</div>',

    widgetsInTemplate: true,

    constructor: function() {
		this.actions = [];
		this.ters = [];
		this._actionButtons = [];
	 },

    postCreate: function() {
        this.inherited("postCreate", arguments);
    },
	
	initialize: function(){
		var tableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer({
            allowAdjustSettings: true,
            autoSaveSettings: true,
            showGroupFilterControls: false,
            tableId: "TEST-RECORD-DETAILS-TABLEVIEWER"                                
        });        
        this._tableViewerNode.appendChild(tableViewer.domNode);

        var content = this.ters;

        tableViewer.setContentPageSize(20);
        tableViewer.setContent(content);
        tableViewer.setContentProvider(new TestRecordDetailTableView.TableProvider());
        tableViewer.setTableListener(new TestRecordDetailTableView.TableListener({parentView: this}));
        tableViewer.setCellModifier(new TestRecordDetailTableView.CellModifier());
		tableViewer.setTableSummary(Constants.getMessage("labelTableSummary", this.queryName));
		tableViewer.setTableRowsCheckable(true, /* isSingleSelect */ false);
		
		this.actions = this.getTableActions();
		var actionLen = (this.actions ? this.actions.length : 0);
		for (var i = 0; i < actionLen; i++) {
            var action = this.actions[i];
            var actionButton = tableViewer.addAction(action.actionId, action.label, action.actionHandler, action.iconClass);
            if (action.disabled && action.disabled == true)
                actionButton.setDisabled(true);
            if (action.hidden && action.hidden == true)
                dojo.addClass(actionButton.domNode, "dijitDisplayNone");
			if(action.actionId == "edit"){
				this.editActionNode = actionButton;
			}	
            this._actionButtons.push(actionButton);
        }
		
        tableViewer.show();
		this.tableViewer = tableViewer;
	},
	
	getTableActions: function(){
		var actions = [];
		actions.push({
                    actionId: "searchatruntime",
                    label: Constants.getMessage("labelChoseAdaptersAtRunTime"),
                    actionHandler: dojo.hitch(this, "_handleChoseAdaptersAtRunTime"),
                    iconClass: "assign-machine-image",
                    disabledOnReadOnly: true
                });
		actions.push({
                    actionId: "edit",
                    label: Constants.getMessage("labelEditAdapters"),
                    actionHandler: dojo.hitch(this, "_handleEditAdapters"),
                    iconClass: "edit-icon-image",
                    disabled: true
                });
		return actions;		
	},
	
	_handleChoseAdaptersAtRunTime: function(){
		
	},
	
	_handleEditAdapters: function(){
		
	},
	
	getContent: function(){
		return this.tableViewer.getContent();
	},
	
	setContent: function(items){
		this.ters = items;
		this.tableViewer.setContent(items);
		this.tableViewer.refresh();
	},
	
	_error: function(error){
		console.error("Error in TestRecordDetailTableView "+ error.message);
	}
});
})();
