//QMTrendReportViewlet
/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.viewlets.QMTrendReportViewlet");


dojo.require("com.ibm.team.reports.viewlets.web.ui.internal.TrendReportViewlet");

(function() {

var JazzReportsViewlet 			= com.ibm.team.reports.viewlets.web.ui.internal.TrendReportViewlet;

	
dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.viewlets.QMTrendReportViewlet",	
	JazzReportsViewlet,
{
	//The only difference between this template file and that supplied by RTC is a div around the parameter area.
	//See the init method below for more information.
	templatePath: dojo.moduleUrl("com.ibm.rqm.planning.web", "ui/internal/view/templates/viewlets/QMTrendReportViewlet.html"),
		
    /*
     * Private Method
     * 
     * @param void
     * @return void
     */ 
    _initializeStaticCommons: function() {
       this.inherited("_initializeStaticCommons", arguments);

        // QM Micro Reports (don't have any but TrendReportViewlet expects entries in this map)
        this._static._EXECUTION_TREND = "execution.Trend";
		this._static._SCORECARD = "scorecard.main";
        this._static._TESTER = "tester.report";
        this._static._TESTER_WEIGHT = "testerWeight.report";
        //Defect Reports
        this._static._DEFECT_ARRIVAL_RESOLUTION = "defects.arrival.resolution";
        this._static._DEFECT_LIST = "defect.list";
        //Execution reports
        this._static._EXECUTION_OVERALL = "execution.OverallStatus";
        this._static._EXECUTIONWEIGHT_OVERALL = "executionWeight.OverallStatus";
        this._static._EXECUTIONWEIGHT_OWNER = "executionWeight.StatusByOwner";
        this._static._EXECUTION_OWNER = "execution.StatusByOwner";
        this._static._EXECUTION_MACHINE = "execution.StatusByMachine";
        this._static._EXECUTIONWEIGHT_MACHINE = "executionWeight.StatusByMachine";
        this._static._EXECUTIONDEFECTS_OWNER = "EWI.tester";
        this._static._TER_LISTING = "execution.ewiDetails";
        this._static._TER_STATUS = "execution.ewiTERDetails";
        this._static._PLAN_SUMMARY = "EWI.phase";
        //Requirement reports
        this._static._REQUIREMENT_PLANCOVERAGE = "requirements.PlanCoverage";
        this._static._REQUIREMENT_COVERAGEDETAIL = "requirements.CoverageDetail";
        this._static._REQUIREMENT_NOTCOVERED = "requirements.notCovered";
        this._static._REQUIREMENT_NOTCOVERING = "requirements.notCovering";
        this._static._REQUIREMENT_TRACEABILIY = "requirements.traceability";
        this._static._REQUIREMENT_EXECUTION = "requirements.ExecutionStatus";
        this._static._REQUIREMENT_EXECUTIONWEIGHT = "requirementsWeight.ExecutionStatus";
        this._static._REQUIREMENT_DEFECTIMPACT = "requirements.defect.impact";
        //Test Case Reports
        this._static._TESTCASE = "testcase.all";
        this._static._TESTCASE_TEAM = "testcase.team";
        this._static._TESTCASE_ENVIRONMENT = "testcase.configuration";
        this._static._TESTCASE_REVIEW = "testcase.review";
        this._static._TESTCASE_CREATION = "testcase.creation";
        this._static._TESTCASE_DEFECTIMPACT = "testcase.defect.impact";
        //LM Reports
        this._static._RESOURCE_UTILIZATION = "lab.utilization.trend";
        this._static._RESOURCE_RESERVATIONLENGTH = "reservation.length";
        this._static._RESOURCE_FREETIME = "machine.freetime.rate";
        this._static._REQUEST_RESPONSETIME = "request.response.time";
        this._static._REQUEST_STATE = "request.state";

		
        // QM Reports
        this._static._microReportIDMap[this._static._EXECUTION_TREND] = this._static._EXECUTION_TREND;
		this._static._microReportIDMap[this._static._SCORECARD] = this._static._SCORECARD;
		this._static._microReportIDMap[this._static._TESTER] = this._static._TESTER;
		this._static._microReportIDMap[this._static._TESTER_WEIGHT] = this._static._TESTER_WEIGHT;
		//Defect Reports
		this._static._microReportIDMap[this._static._DEFECT_ARRIVAL_RESOLUTION] = this._static._DEFECT_ARRIVAL_RESOLUTION;
		this._static._microReportIDMap[this._static._DEFECT_LIST] = this._static._DEFECT_LIST;
		//Execution Reports
		this._static._microReportIDMap[this._static._EXECUTION_OVERALL] = this._static._EXECUTION_OVERALL;
		this._static._microReportIDMap[this._static._EXECUTIONWEIGHT_OVERALL] = this._static._EXECUTIONWEIGHT_OVERALL;
		this._static._microReportIDMap[this._static._EXECUTIONWEIGHT_OWNER] = this._static._EXECUTIONWEIGHT_OWNER;
		this._static._microReportIDMap[this._static._EXECUTION_OWNER] = this._static._EXECUTION_OWNER;
		this._static._microReportIDMap[this._static._EXECUTION_MACHINE] = this._static._EXECUTION_MACHINE;
		this._static._microReportIDMap[this._static._EXECUTIONWEIGHT_MACHINE] = this._static._EXECUTIONWEIGHT_MACHINE;
		this._static._microReportIDMap[this._static._EXECUTIONDEFECTS_OWNER] = this._static._EXECUTIONDEFECTS_OWNER;
		this._static._microReportIDMap[this._static._TER_LISTING] = this._static._TER_LISTING;
		this._static._microReportIDMap[this._static._TER_STATUS] = this._static._TER_STATUS;
		this._static._microReportIDMap[this._static._PLAN_SUMMARY] = this._static._PLAN_SUMMARY;
		//Requirement Reports
		this._static._microReportIDMap[this._static._REQUIREMENT_PLANCOVERAGE] = this._static._REQUIREMENT_PLANCOVERAGE;
		this._static._microReportIDMap[this._static._REQUIREMENT_COVERAGEDETAIL] = this._static._REQUIREMENT_COVERAGEDETAIL;
		this._static._microReportIDMap[this._static._REQUIREMENT_NOTCOVERED] = this._static._REQUIREMENT_NOTCOVERED;
		this._static._microReportIDMap[this._static._REQUIREMENT_NOTCOVERING] = this._static._REQUIREMENT_NOTCOVERING;
		this._static._microReportIDMap[this._static._REQUIREMENT_TRACEABILIY] = this._static._REQUIREMENT_TRACEABILIY;
		this._static._microReportIDMap[this._static._REQUIREMENT_EXECUTION] = this._static._REQUIREMENT_EXECUTION;
		this._static._microReportIDMap[this._static._REQUIREMENT_EXECUTIONWEIGHT] = this._static._REQUIREMENT_EXECUTIONWEIGHT;
		this._static._microReportIDMap[this._static._REQUIREMENT_DEFECTIMPACT] = this._static._REQUIREMENT_DEFECTIMPACT;
		//Test Case Reports
		this._static._microReportIDMap[this._static._TESTCASE_TEAM] = this._static._TESTCASE_TEAM;
		this._static._microReportIDMap[this._static._TESTCASE_ENVIRONMENT] = this._static._TESTCASE_ENVIRONMENT;
		this._static._microReportIDMap[this._static._TESTCASE] = this._static._TESTCASE;
		this._static._microReportIDMap[this._static._TESTCASE_REVIEW] = this._static._TESTCASE_REVIEW;
		this._static._microReportIDMap[this._static._TESTCASE_CREATION] = this._static._TESTCASE_CREATION;
		this._static._microReportIDMap[this._static._TESTCASE_DEFECTIMPACT] = this._static._TESTCASE_DEFECTIMPACT;
		//LM Reports
		this._static._microReportIDMap[this._static._RESOURCE_UTILIZATION] = this._static._RESOURCE_UTILIZATION;
		this._static._microReportIDMap[this._static._RESOURCE_RESERVATIONLENGTH] = this._static._RESOURCE_RESERVATIONLENGTH;
		this._static._microReportIDMap[this._static._RESOURCE_FREETIME] = this._static._RESOURCE_FREETIME;
		this._static._microReportIDMap[this._static._REQUEST_RESPONSETIME] = this._static._REQUEST_RESPONSETIME;
		this._static._microReportIDMap[this._static._REQUEST_STATE] = this._static._REQUEST_STATE;
		
    },
	
	init: function()
	{
		this.inherited('init', arguments);
		//Work Item 17893.
		//As of release 2.0, the report's Query Parameters only contain the selected VALUES of parameters, not the LABELS.
		//So if we show the parameters the user will see internal IDs (UIDs) of selected objects rather than the name.
		//The difference between the template supplied by RTC and this one is simply a div that encompasses the parameter display area.
		//So lets hide the parameter display area now.
		this._hiddenArea.style.display="none";
	},
	
    /*
     * Private Method
     * 
     * @param String html
     * @return boolean
     */ 
    _containsReport: function(html) {
        /*
		var matcher = new String(html);
        if (matcher.match(/\.png/)) {
            return true;
        }
        return false;
        */
		
		//Jazz TrendReportViewlet restricts displaying of anything but charts in the dashboard reports
		//RQM has several text based reports to show, so overriding this method is required
		return true;
    }	
});

})();