/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.appscan.web.ui.internal.view.viewlets.SecurityTrainingOverviewViewlet");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojox.data.dom");
dojo.require("com.ibm.team.dashboard.web.ui.Viewlet");
dojo.require("dojo.parser");
dojo.require("com.ibm.rqm.appscan.web.client.internal.Constants");
dojo.require("com.ibm.rqm.appscan.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.asq.common.web.ui.internal.view.viewlets.AbstractViewlet");

(function()
{
	
var AbstractViewlet = com.ibm.asq.common.web.ui.internal.view.viewlets.AbstractViewlet;
var ImageCache				= com.ibm.rqm.appscan.web.ui.internal.view.common.ImageCache;	
var Viewlet 				= com.ibm.team.dashboard.web.ui.Viewlet;
var Constants    			= com.ibm.rqm.appscan.web.client.internal.Constants;

dojo.declare("com.ibm.rqm.appscan.web.ui.internal.view.viewlets.SecurityTrainingOverviewViewlet", AbstractViewlet,
{
	templatePath: dojo.moduleUrl("com.ibm.rqm.appscan.web", "ui/internal/view/templates/viewlets/SecurityTrainingOverviewViewlet.html"),
        
	init: function() {
		this._initLabels();		
    },
	
	/**
	 * Initialize the static labels on the viewlet
	 */
	_initLabels: function() {
		var extlink = document.createElement("sup");
		var extlinkSup = document.createElement("sup");
		var extlinkImg = document.createElement("img");
		extlinkImg.src = ImageCache.EXTERNALLINK;
		extlinkSup.appendChild(extlinkImg);
		extlink.appendChild(extlinkSup);
		this._overviewLabel.innerHTML = Constants.getMessage("toviewlet_overview");
		this._courseIntroLabel.innerHTML = Constants.getMessage("toviewlet_course_intro");
		this._courseTitleTitleLabel.innerHTML = Constants.getMessage("toviewlet_course_title_title");
		this._courseCodeTitleLabel.innerHTML = Constants.getMessage("toviewlet_course_code_title");
		this._courseTitleWebAppSecLabel.innerHTML = Constants.getMessage("toviewlet_course_title_webappsec") + extlink.innerHTML;
		this._courseTitleASELabel.innerHTML = Constants.getMessage("toviewlet_course_title_ase") + extlink.innerHTML;
		this._buyLinkBeforeLabel.innerHTML = Constants.getMessage("toviewlet_buy_link_before");
		this._buyLinkLabel.innerHTML = Constants.TOVIEWLETBUYLINK + extlink.innerHTML;
		this._buyLinkAfterLabel.innerHTML = Constants.getMessage("toviewlet_buy_link_after");
	},
	
	refresh: function() {		
	},
	
	update: function()
	{
		this.getSite().setLoading(false);
	},
	
	_error: function(errorObj)
	{
		console.error("Error getting data (message: '" + errorObj.message + "') in SecurityTrainingOverviewViewlet#_error");
	},
	
	hasZoomableContent: function() {
		return false;
	},
	
	settingsChanged: function(oldSettings, newSettings) {
	}
});

})();
