// ********  CONFIGURATION EDITOR *********//
/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008,2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
//
//
// Author: L. To
//
// Summary:
//    
//
dojo.provide("com.ibm.rational.test.lm.web.ui.internal.views.configurations.ConfigurationEditor");
 
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.form.Button");

dojo.require("net.jazz.ajax.ui.PlatformUI");

dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");

dojo.require("com.ibm.asq.common.web.client.internal.Catalog");
dojo.require("com.ibm.asq.common.web.client.internal.PermissionsClient");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");
dojo.require("com.ibm.asq.common.web.ui.internal.util.GlobalEvents");
dojo.require("com.ibm.asq.common.web.ui.internal.util.Utility");
dojo.require("com.ibm.rational.test.lm.web.client.internal.config");

dojo.require("com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.widgets.layout.SectionLayoutForm");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.widgets.layout.FormListener");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.widgets.layout.FormTextField");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.views.machines.ActionCustomElementProvider");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.views.machines.AssetContentProviderFactory");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.views.configurations.ConfigurationsUriUtil");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.MoreLessCollapsibleArea");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.widgets.ActionConfigSummary");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.widgets.ConfigSummaryAndEditor");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.widgets.FilteredSelectionDialog");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.richtext.RichTextControl");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil");

dojo.require("com.ibm.rational.test.lm.web.ui.internal.widgets.catalogAttrBuilder.ConfigurationDisplay");

(function() {

var ConfigDisplay = com.ibm.rational.test.lm.web.ui.internal.widgets.catalogAttrBuilder.ConfigurationDisplay;
var RtlmUiUtil = com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil;
var ServiceResponseHandler = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var AssetContentProviderFactory = com.ibm.rational.test.lm.web.ui.internal.views.machines.AssetContentProviderFactory;
var CustomElementProvider = com.ibm.rational.test.lm.web.ui.internal.views.machines.ActionCustomElementProvider;
var AssetUriUtil = com.ibm.rational.test.lm.web.ui.internal.pages.AssetUriUtil;
var RichTextControl = com.ibm.asq.common.web.ui.internal.widgets.richtext.RichTextControl;
var TableConstants = com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;
var ConfigUriUtil = com.ibm.rational.test.lm.web.ui.internal.views.configurations.ConfigurationsUriUtil;
var PermissionsClient = com.ibm.asq.common.web.client.internal.PermissionsClient;
var ViewHeaderLayout = com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout;

var GlobalEvents = com.ibm.asq.common.web.ui.internal.util.GlobalEvents;

var RtlmUiUtil_getMessage = RtlmUiUtil.getMessage;
var RtlmUiUtil_getCatalogMessage = RtlmUiUtil.getCatalogMessage;
var LOADING = RtlmUiUtil_getMessage("appWorking");

	//An initial configuration string.
	//THIS IS TRULY MEANT TO BE A CLASS LEVEL (as opposed to instance level) VARIABLE.
	//This is set when creating a config from a machine.
	//A config string is created from the machine and then a "New" config window is opened
	//The "New" config is prepopulated with this config information
	//This is a bit of a hack but the alternative is to try to pass the whole config string as a parameter
	//on the new config URI and that is likely to fail as the config string is a nasty json string
var	initialConfigString = null;



dojo.declare("ConfigurationEditor.TocTableProvider",
			 com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider, 
{
    // Summary:
    //
    getNumColumns: function(content)
    {
        return 8;
    },
 
    _columnHeadings: [
		RtlmUiUtil.getMessage("cfgName"),
        RtlmUiUtil.getCatalogMessage("DataBase"),
        RtlmUiUtil.getCatalogMessage("pl_operatingsystem"),
		RtlmUiUtil.getCatalogMessage("ApplicationServer"),
		RtlmUiUtil.getCatalogMessage("Browser"),
		RtlmUiUtil.getCatalogMessage("Test Adapter"),
		RtlmUiUtil.getCatalogMessage("CPU"),
		RtlmUiUtil.getCatalogMessage("ManagementAgent")
    ],
    
    // Summary:
    //
    getColumnHeading: function(content, index)
    {
        return this._columnHeadings[index];
    },

	 
    getIsColumnGroupable: function(content, atColumnIndex)
    {
        return false;     
    },

    getIsColumnSortable: function(content, atColumnIndex)
    {
        return true;   
    },
    
    _columnWidths: [13,13,13,13,13,9,13,13],

    getColumnWidth: function(content, atColumnIndex)
    {
        return this._columnWidths[atColumnIndex];
    },
    
    // Summary:
    //    The only assumptions the table have on the data that it displays
    //    is that it's an array contents. These are the data content/object that
    //    will be displayed in the table rows.
    //
    getContentObjects: function(content)
    {
        // our content is already an array of objects
        return content;
    },
    
    getRowDataId: function(rowData)
    {
        return rowData.id;
    },
    
    // Summary:
    //    Returns the type of the cell to be displayed. By default, the TableViewer
    //    will support a set of cell types. The type of the cell will map to a specific
    //    cell renderer (to be discussed).
    getCellDisplayType: function(rowData, atColumnIndex)
    {
        var type = TableConstants.RENDER_TYPE_TEXT;
//Left this here in case we ever go back to using the first column as an "action"
//        switch(atColumnIndex) {
// 			case 0:
//               type = TableConstants.RENDER_TYPE_ACTION;
//                break;
//        }
        return type;
    },

    getCellAlignment: function(rowData, atColumnIndex)
    {
        return TableConstants.ALIGN_LEFT;
    },
    
    // Summary:
    //    Returns the display data of the cell. For cell renderer type of TEXT, this will
    //    be the string. Others cell render type would be Date, or integer value, etc. If the 
    //    cell renderer type is image, the client can also supply cell data that can be sortable/groupable. 
    //    The TableViewer's default sorter, filter operates on this returned data. For "complex" 
    //    cell types such as image where it could have multiple values for different states, the 
    //    client also needs to implement the next method.
    //    
    //    Client must implement this method to provide the cell data.
    //    
    getCellDisplayData: function(rowData, atColumnIndex)
    {
        var val = "";
        switch(atColumnIndex) {
            case 0: 
                val = rowData.name;
                break;
            case 1: 
                val = rowData.database;
                break;          
            case 2: 
                val = rowData.os;
                break;          
            case 3: 
                val = rowData.appServer;
                break;          
            case 4: 
                val = rowData.browsers;
                break;          
            case 5: 
                val = rowData.testTools;
                break;          
            case 6: 
                val = rowData.cpu;
                break;          
            case 7: 
                val = rowData.managementAgent;
                break;          
        }
        return val;
    }

});


// Summary:
//    Create a subclass of the rich text control to add reporting back onChange events.
//
dojo.declare("ConfigurationEditor.RichTextControl", 
    [com.ibm.asq.common.web.ui.internal.widgets.richtext.RichTextControl],
{   
    initOnChange: false,
     
    _doEdit: function() {
        this.inherited("_doEdit", arguments);
        
        if(!this.initOnChange && this._editor) {
            this.initOnChange = true;
            
            var self = this;
            this._editor.onChange = function() {
                self.onChange();
           }
        }
    },

    onChange: function() {
        
    }
});

dojo.declare("com.ibm.rational.test.lm.web.ui.internal.views.configurations.ConfigurationEditor", 
    [dijit._Widget, dijit._Templated],
{    
    templateString: '<div class="config-editor" dojoAttachPoint="domNode" tabindex="-1">' +
                    '  <div dojoType="com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout" dojoAttachPoint="viewHeaderNode"' +
                    '       titleEditable="true" summaryEditable="true" summaryAsDesc="false" maxSummaryLength=250>' +
                    '    <div class="editor-area" dojoAttachPoint="viewMainNode">' +
                    '      <div dojoType="com.ibm.asq.common.web.ui.internal.view.common.CollapsibleSection" open="true" dojoAttachPoint=richTextNode>' +
                    '      </div>' +
                    '      <div>' +
        			'        <div dojoType="com.ibm.asq.common.web.ui.internal.view.common.CollapsibleSection" dojoAttachPoint="configurationToc" open="true">'+
                    '        </div>' +
                    '        <div dojoType="com.ibm.asq.common.web.ui.internal.view.common.CollapsibleSection" open="true" dojoAttachPoint="configContainerNode">' +
                    '        </div>' +
                    '     </div>' +
                    '    </div>' +
                    ' </div>' +
                    '</div>',

    widgetsInTemplate: true,
    
    // initialize the view's labels from the message catalog.
    saveButtonLabel: RtlmUiUtil_getMessage("save_button"),
	cancelButtonLabel: RtlmUiUtil_getMessage("discard_button"),
    discardButtonLabel: RtlmUiUtil_getMessage("discard_button"),
    nameLabel: RtlmUiUtil_getMessage("name") + " *",
    descriptionLabel: RtlmUiUtil_getMessage("cfgDescriptionLabel"),
	descriptionPrompt: RtlmUiUtil_getMessage("cfgNewDescriptionPrompt"),
    labResLabel: RtlmUiUtil_getMessage("cfgAssetDescription"),
    summaryLabel: RtlmUiUtil_getMessage("cfgSummary"),
	addPartButtonLabel: RtlmUiUtil_getMessage("cfgAddPart"),
	addConfigButtonLabel: RtlmUiUtil_getMessage("cfgAddConfig"),
    
    // the configuration ID being viewed.
    configId: null,
    
    // if the asset is new (doesn't exist yet)
    isNew: false,
    
	// if we are creating a copy
	isCopy: false,
	
    // the type of the assset
    assetType: "Machine",
    
	configResponse : null,
	
    // the actual config object
    config: null,
	
	stateId: null,
	
	configName: "",
	
	configDescription: "",
	
	configSummary: "",
    
    // interal catalog object
    theCatalog: null,
	
	//Internal object of all the configs
	allConfigs:{},
	
	_richText:null,
	
	initialized:false,
    
    configEditor: null,
    
    deleted: false, // flag to indicate if config is deleted
        
    postCreate: function() 
    {
        this.inherited("postCreate", arguments);
        this.viewHeaderNode.setIconClass("config-icon-48");
        this.viewHeaderNode.setTypeLabel(RtlmUiUtil_getMessage("cfgCfgLabel"));
        this.viewHeaderNode.setNoValueEditableTitleLabel(RtlmUiUtil_getMessage("cfgNewPrompt"));
        if (this.isNew) {
            this.viewHeaderNode.setCSHelpId("rtlm_config.html", com.ibm.rational.test.lm.web.CSHelpID);
			this.viewHeaderNode.setCSHelpButtonLabel(RtlmUiUtil_getMessage("labelHelp", RtlmUiUtil_getMessage("labelNew"), RtlmUiUtil_getMessage("cfgCfgLabel")));
        } else {
            this.viewHeaderNode.setCSHelpId("rtlm_view_configuration.html", com.ibm.rational.test.lm.web.CSHelpID);
			this.viewHeaderNode.setCSHelpButtonLabel(RtlmUiUtil_getMessage("labelHelp", RtlmUiUtil_getMessage("cfgCfgLabel"), RtlmUiUtil_getMessage("labelDetail")));
        }
		
        this.discardButtonNode = this.viewHeaderNode.addRightViewAction(this.cancelButtonLabel, dojo.hitch(this, "_onDiscardActionClick"), null, null);
        this.saveButtonNode = this.viewHeaderNode.addRightViewAction(this.saveButtonLabel, dojo.hitch(this, "_onSaveActionClick"), null, null);

		this.viewHeaderNode.onTitleEdited = dojo.hitch(this, "nameChanged");
		
		this.viewHeaderNode.setNoValueEditableSummaryLabel(this.descriptionPrompt);
		this.viewHeaderNode.setSummaryLabel(this.descriptionLabel);
		this.viewHeaderNode.onSummaryEdited = dojo.hitch(this, "summaryChange");
				
        this.theCatalog = new com.ibm.asq.common.web.client.internal.Catalog();
		
		if (this._richText == null) 
		{
			this._richText = new ConfigurationEditor.RichTextControl({
				'inEditMode': false,
				'contentHTML': "",
				'save': dojo.hitch(this, "_onSaveActionClick")
			});

			this.connect(this._richText, "onChange", "descriptionChange");
			this.richTextNode.setDisplayTitle(RtlmUiUtil_getMessage("cfgSummary"));
			this.richTextNode.summaryNode.innerHTML = RtlmUiUtil_getMessage("configDescription");
			this.richTextNode.containerNode.appendChild(this._richText.domNode);
			this._richText.show();
		}
		
		this.edited = false;
        this.requireTabUpdate = this.isNew;
               
        if(this.isNew  && !this.isCopy) {
			//If an initialConfigString was set then use it now
			if (initialConfigString != null) 
			{
				this.config = this.theCatalog.createConfigurationFromJson(initialConfigString);
				//Save the initial Class Level string in a member variable.  This will be used if the user clicks the discard button to reload the initial config values
				this.machineConfigString = initialConfigString;
				//Clear the CLASS LEVEL string so that the next New config action does not see this string
				initialConfigString = null;
			}
			else 
				// this is a new config, we'll just create a blank one
				this.config = this.theCatalog.createConfiguration(this.assetType);

            this._loadConfigurationToView();
        }
        else {
            this._loadConfigurationById(this.configId);
        }

        if (this.isNew) {
            // for new config set focus to the title
            this.viewHeaderNode.setEditableTitleFocus();
        }
    },
    
    _loadDataSuccess: function(response)
    {
        this.viewHeaderNode.setProgressEnd();
        
		this.configResponse = response;
        this.config = this.theCatalog.createConfigurationFromJson(response.configuration);
		this.configId = response.id;
		this.configName = response.name;
		//If this is really a copy then update the name to show "Copy of"
		if (this.isCopy)
			this.configName = RtlmUiUtil_getMessage("CopyOf", this.configName);
		this.configSummary = response.summary;
		this.configDescription = response.description;
		this.stateId = response.stateId;

		//Get the IDs for the LRDs and set them into the parts
		this.resourceDescriptionIDs = response.resourceDescriptionIds;
		this.setLRDIDs();
				
		this._loadConfigMetaInfo();
        this._loadConfigurationToView();
        
        if(this.statusMessage) {
            this.viewHeaderNode.setStatus(this.statusMessage);
        }
        // show the proper asset's name in its parent container.
        dojo.publish(GlobalEvents.UpdateTabLabel, [window.location.hash, this.configName, "config-icon-16"]);
		
		// update browser title
		this._updateBrowserTitle();
    },
    
    _loadDataFailure: function(response)
    {
        var details = (response && response.message) ? response.message : null;
        
        this.viewHeaderNode.setProgressEnd();
        this.viewHeaderNode.setStatus(RtlmUiUtil_getMessage("fetchConfigFailed"), ViewHeaderLayout.ERROR, details);  
        
        // call the common artifact data load error handler.  
        com.ibm.asq.common.web.ui.internal.util.Utility.handleArtifactLoadError(RtlmUiUtil_getMessage("cfgCfgLabel"), details);
    },
    
    // Summary:
    //    Retrieves the asset's full content based on the specified Id. This method invokes
    //    an asynchrous call to the server to get the asset contents.
    // 
    _loadConfigurationById: function(id)
    {
        this.viewHeaderNode.setProgressStart(LOADING, /*hideContent*/true);
        var responseHandler = new com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper(this, "_loadDataSuccess", "_loadDataFailure");
        var configService = new com.ibm.rational.test.lm.web.client.internal.config();
        
		configService.retrieveConfigurationWithDetails(responseHandler, this.configId);
    },
	
    _loadConfigurationToView: function()
    {        
        if (!this.isNew || this.isCopy) {
            this.viewHeaderNode.setTitle(this.configName);
        }
				        
		this.viewHeaderNode.setSummary(this.configSummary);
        
        if (!this.configEditor) {
            this.configEditor = new ConfigDisplay({
                'catalogConfig': this.config,
                'assetType': this.assetType,
                'showTitle': true,
                'bgShading': false,
                'title': this.labResLabel,
                'onValueChanged': dojo.hitch(this, "attributeValueChanged")
            });
			this.configContainerNode.setDisplayTitle(RtlmUiUtil_getMessage("cfgAssetDescription"));
            this.configContainerNode.contentNode.appendChild(this.configEditor.domNode);
        }
        else {
            this.configEditor.setCatalogConfig(this.config);
        }
		
		//Create the table of contents (ie list of parts) table		
		if (this.TOCTable == null)
		{
			this.createTOC();
		}
		
		//Load up the TOC
		this.loadTOC();
        
		//If this is new or a copy, highlight the name field
		if (this.isCopy) {
			if (this.viewHeaderNode.viewEditableTitle) {
				this.viewHeaderNode.viewEditableTitle._onClick();
			}
		}
		
		//Enable the save button when copying so, if the user wants, they can just hit save
		if (this.isCopy)
			this.edited = true;
			
        // update the buttons
        this._updateFormActions();
        this.initialized = true;
    },
    
	_retrieveConfigMetaInfo: function()
	{
		this.configSummary = this.viewHeaderNode.getSummary();
		if (this._richText != null)
			this.configDescription = this._richText.getContentHTML();
	},

    _loadConfigMetaInfo: function()
    {
		// calling nameField.setValue will call into attributeValueChanged,
		// which will call _retrieveConfigMetaInfo.  This will set the
		// configDescription based on the summaryNode.value, so it is
		// important to set the summaryNode.value before calling 
		// nameField.setValue.  Seems a bit mystical to me.
		this.initialized = false;
        this.viewHeaderNode.setSummary(this.configSummary);
		if (this._richText)
			this._richText.setContentHTML(this.configDescription);
        this.viewHeaderNode.setTitle(this.configName);
		this.initialized = true;
    },
	
	nameChanged : function(value)
	{
		var oldvalue = this.configName;
		this.configName = value;
		this.attributeValueChanged();
        this.requireTabUpdate = true;
		//Just make sure on new test environment that the edited flag is not true.
		if(!this.edited)
			this.edited = ( oldvalue != value );
	},
	
	summaryChange : function(value)
	{
		this.configSummary = value;
		this.attributeValueChanged();
	},
	
	descriptionChange: function()
	{
		if(!this.edited)
			this.attributeValueChanged();		
	},
	
    // Summary:
    //     capture meta value changed event.
    // 
    attributeValueChanged: function()
    {
		if (!this.initialized)
			return;
        
        this.edited = true;			
        
        // something changed. Enable the save button and clear and status.
        this._updateFormActions();
		this._updateTabLabel();
        
        // we can just redraw the rows without refreshing the entire table
        // if the number of the rows didn't change, i.e., the number of parts
        // in the config
        var partCount = this.config.getRootParts().length;
        var redrawOnly = this.nConfigParts == partCount;
        this.loadTOC(redrawOnly);        
    },

    _hasRequired: function()
    {
        return (this.configName && this.configName.length > 0);
    },
    
    _hasEditPermission: function()
    {
        var perm = PermissionsClient.getStoredPermission(PermissionsClient.OP_LM_TEST_ENVIRONMENT);  
        return (!perm || perm[PermissionsClient.ACTION_EDIT]);           
    },
    
    _updateFormActions: function()
    {
        if (this.deleted)
            return;
            
        var msg = null;
        var hasError = this.configEditor.hasError();
        var hasRequired = this._hasRequired();

        // don't enable the save button if there's no editing, or doesn't have require
        // field, or the form has error.
        var hasEditPerm = this._hasEditPermission();
        this.saveButtonNode.setDisabled((!hasEditPerm || !this.edited || !hasRequired || hasError));
        this.discardButtonNode.setDisabled((!hasEditPerm || !this.edited));
        
        if (!hasEditPerm) {
            msg = RtlmUiUtil.getCommonMessage("statusNoEditPerm");
            var details = RtlmUiUtil.getCommonMessage("msgNoEditPermDetails", RtlmUiUtil_getMessage("cfgCfgLabel"));
            
            this.viewHeaderNode.setStatus(msg, ViewHeaderLayout.WARNING, details);
        }
        else {
            if (!hasRequired) 
                msg = RtlmUiUtil_getMessage("cfgRequireNameError");
            else 
                if (hasError) {
                    msg = RtlmUiUtil_getMessage("cfgHasError");
                }
            
            if (msg) {
                this.viewHeaderNode.setStatus(msg, (hasError) ? ViewHeaderLayout.ERROR : ViewHeaderLayout.INFO);
            }
            else 
                if (this.edited) {
                    var msgId = (this.isNew) ? "saveNewReminderMsg" : "saveChangeReminderMsg";
                    msg = RtlmUiUtil_getMessage(msgId);
                    this.viewHeaderNode.setStatus(msg, ViewHeaderLayout.INFO);
                }
                else {
                    this.viewHeaderNode.clearStatus();
                }
        }
    },
    
	_updateTabLabel: function()
	{
		if (!this.isNew)  //don't update the tab label for "New" configs
			dojo.publish(GlobalEvents.UpdateTabLabel, [window.location.hash, this.configName, "config-icon-16", this.edited]);            
	},
    
    // Summary:
    //    Handles save action button click. This method invokes an asynchrous call
    //    to the server to save the asset's new attributes. Based on the viewer's "isNew"
    //    state, it invokes the appropriate service to either create a new asset, or to
    //    update it.
    //
    _onSaveActionClick: function()
    {
        var responseHandler = new ServiceResponseHandler(this, "_saveSuccess", "_failureHandler");
		var configService = new com.ibm.rational.test.lm.web.client.internal.config();
		
		this._retrieveConfigMetaInfo();
					
		if(this.isNew) {
			configService.createConfiguration(responseHandler, this.config, this.configName, this.configDescription, this.configSummary);
		}
		else {
			var lrdIDList = [];
			//The lrdIDList is a list of IDs.  There is one ID for each Lab Resource Description in the Test Environment.
			//For existing Lab Resource Descriptions the ID was retrieved when the Test Environment was loaded.
			//For new Lab Resource Descriptions the ID is set to a predefined "new" value.  It will be replaced by a "real" value when the Test Environment is stroed.
			lrdIDList = this.getLRDIDs(configService.getNewConfigPartId());
			configService.updateConfiguration(responseHandler, this.configId, this.stateId, this.config, lrdIDList, this.configName, this.configDescription, this.configSummary);
		}
        this.viewHeaderNode.setProgressStart(RtlmUiUtil_getMessage("savingConfig"));
        this.viewHeaderNode.setStatus(RtlmUiUtil_getMessage("savingConfig"), ViewHeaderLayout.INFO);
        
        // disable the actions while we're saving.
        this.saveButtonNode.setDisabled(true);
        this.discardButtonNode.setDisabled(true);        
    },

    // Summary:
    //    Handles save action button click. This method invokes an asynchrous call
    //    to the server to save the asset's new attributes. Based on the viewer's "isNew"
    //    state, it invokes the appropriate service to either create a new asset, or to
    //    update it.
    //
    _onDiscardActionClick: function()
    {
		if (!confirm(RtlmUiUtil_getMessage("configDiscardNew"))) 
			return;
		
        // reset the edit flag, and reload the view.
        this.edited = false;	
        this.requireTabUpdate = false;
        
		if (this.isNew  && !this.isCopy)	{
			//If this.machineConfig is not null then this view was created when the user asked to create a config from a machine.
			//In this case we create the config object from that machine config and proceed as if this is a new config.
			if (this.machineConfigString != null) 
				this.config = this.theCatalog.createConfigurationFromJson(this.machineConfigString);
			else
				// this is a new config, we'll just create a blank one
				this.config = this.theCatalog.createConfiguration(this.assetType);

			//Init the local vars for the "metadata"
			this.configSummary = "";	
			this.configDescription = "";		
			this.configName = "";
			
			//Load the new new config to the ui
			this._loadConfigMetaInfo();
            this.configEditor.setCatalogConfig(this.config);
            this._updateFormActions();
            this._updateTabLabel();
		}
		else
			this._loadConfigurationById(this.configId);	//User OKd the discard so reload the config
		return;
    },
    
    // Summary:
    //   asynchrous success callback handler for the save action. 
    //
    _saveSuccess: function(response)
    {
        this.viewHeaderNode.setProgressEnd();
		
		// update the config object's ids.
        this.configResponse = response;
        this.configId = response.id;
        this.stateId = response.stateId;

        // create a wrapper object for notifying the query page
        var configWrapper = {
            id: this.configId,
            name: this.configName,
            summary: this.configSummary,
            config: this.config
        };
        
        if(this.isNew) {
            dojo.publish(GlobalEvents.UpdateTabUri, [window.location.hash, ConfigUriUtil.getEditConfigurationURI(this.configId)]);
            dojo.publish(GlobalEvents.ArtifactsAdded, [ RtlmUiUtil.TYPE_CONFIG, [ configWrapper ], ConfigUriUtil.getEditConfigurationURI(this.configId) ]);
        } 
        else {
            dojo.publish(GlobalEvents.ArtifactsUpdated, [ RtlmUiUtil.TYPE_CONFIG, [ configWrapper ], ConfigUriUtil.getEditConfigurationURI(this.configId) ]);
        }
        
        // also update the label for the page.
        if(this.isNew || this.requireTabUpdate) {
            dojo.publish(GlobalEvents.UpdateTabLabel, [window.location.hash, this.configName, "config-icon-16"]);            
        }
        
        this.isNew = false;
		this.isCopy = false;
        this.edited = false;
        this.requireTabUpdate = false;

		//Make sure that all the Lab Resource Descriptions have their assigned IDs.  The IDs were created for any LRDs that were added.
		this.resourceDescriptionIDs = response.resourceDescriptionIds;
		this.setLRDIDs();    

        this._updateFormActions();
        this._updateTabLabel();
        
        
        // update action would clear the status. Set the status
        // after the button state update. 
        var msg = RtlmUiUtil_getMessage("savedSuccessMsg", RtlmUiUtil.getCurrentTimeString());
        this.viewHeaderNode.setStatus(msg, ViewHeaderLayout.SUCCESS);
		
		// update browser title
		this._updateBrowserTitle();
    },
    
    _failureHandler: function(response)
    {
        this.viewHeaderNode.setProgressEnd();
        if (response.status == 409) {
            // Stale data
            this.viewHeaderNode.setStatus(RtlmUiUtil_getMessage("configOpFailedStaleData"), ViewHeaderLayout.ERROR);
        }
        else {
            if(response && response.message && response.message.toLowerCase().indexOf('license') > -1) {
                RtlmUiUtil.showServerErrorMessage(MessageUtil.getMessage(MessageBundle.COMMON, "serverLicenseErrMsg"));                  
            }
            var details = (response && response.message) ? response.message : null;
            this.viewHeaderNode.setStatus(RtlmUiUtil_getMessage("configOpFailed"), ViewHeaderLayout.ERROR, details);
        }
    },

    // update the UI to reflect the config is deleted 
    setConfigDeleted: function() {
        this.deleted = true;
        this.saveButtonNode.setDisabled(true);
        this.discardButtonNode.setDisabled(true);
        this.viewHeaderNode.setStatus(RtlmUiUtil_getMessage("cfgMsgConfigDeleted"), ViewHeaderLayout.ERROR);
    },
    
    // handler on artifacts changed
    onArtifactChanged: function(changeType, artifactType, artifactArray) {
        // only care about deleted config
        if ((artifactType == RtlmUiUtil.TYPE_CONFIG) && (changeType == GlobalEvents.ArtifactsDeleted)) {
            var artifactArray_length = artifactArray.length;
            for (var i = 0; i < artifactArray_length; i++) {
                // check if the config of this editor is deleted
                if (artifactArray[i].id == this.configId) {
                    // update the UI to reflect the config is deleted 
                    this.setConfigDeleted();
                    break;
                }
            }
        }
		this.loadTOC();
    },
	
	createTOC: function()
    {
		this.configurationToc.setTitle(RtlmUiUtil_getMessage("configCoverageSummary"));
		this.configurationToc.summaryNode.innerHTML = RtlmUiUtil_getMessage("configPropsAtAGlance");
        this.TOCTable = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer();
		this.configurationToc.containerNode.appendChild( this.TOCTable.domNode );
		if (this.isNew)
			this.configurationToc.toggle();
        
        // refresh the toc table when the section is opened to ensure that the
        // table contents are update & would not contain '...'.
        this.configurationToc.onToggle = dojo.hitch(this, function() {
            if(this.configurationToc.open) {
                this.TOCTable.refresh();
            }
        });

        this.TOCTable.setTableMajorMode(TableConstants.MAJOR_MODE_GRID);
        this.TOCTable.setContentProvider( new ConfigurationEditor.TocTableProvider() );
        this.TOCTable.setContentPageSize(10);
        this.TOCTable.setCellModifier(this);
        this.TOCTable.setShowingFilterControl(false);
        this.TOCTable.setTableListener(this);        
		this.TOCTable.setTableSummary(RtlmUiUtil_getMessage("labelTableSummary", RtlmUiUtil_getMessage("configCoverageSummary")));
        this.TOCTable.setContent([]);
        this.TOCTable.show();
    },
    
    loadTOC : function(redrawOnly)
    {
        redrawOnly = (typeof redrawOnly == "undefined") ? false : redrawOnly;
        
        //Build the content to be passed to the TOC
        var content = [];
        var partCount = this.config.getRootParts().length;
        for (var i = 0; i < partCount; i++)
        {
            var rowData = {};
            var thisPart = this.config.getRootPart(i);
            var thisLabel = this.config.getLabel(i);
            rowData.id = i + "";
            rowData.name = (thisLabel) ? thisLabel : "";
            rowData.database = this.config.getValueByIndex(i, "DataBase");
            rowData.os = this.config.getValueByIndex(i, "OperatingSystem");
            rowData.appServer = this.config.getValueByIndex(i, "Application Server");
            rowData.browsers = this.config.getValueByIndex(i, "Browsers");
            rowData.testTools = this.config.getValueByIndex(i, "Test Adapter");
            rowData.cpu = this.config.getValueByIndex(i, "CPU");
            rowData.managementAgent = this.config.getValueByIndex(i, "ManagementAgent");
            content.push(rowData);
        }

        this.TOCTable.setContent(content);
        this.nConfigParts = partCount;
        
        // redrawRows doesn't 'disturb' the table rows, it just redraws
        // the contents. This removes the page's jumping due to table rows
        // removed and then added.
        if(redrawOnly)
            this.TOCTable.redrawRows();
        else     
            this.TOCTable.refresh();
    },
	
	isDirty: function()
	{
		return( this.edited );
	},
	
	_updateBrowserTitle: function(){
		if (this.page) {
			var	name ;
			if (this.isNew) {
				name = RtlmUiUtil_getMessage("labelCapitalNew");
			}
			else {
				name = this.configName;
			}
			this.page.browserTitle = RtlmUiUtil_getMessage("pageTitleTestEnvironment", name);
			net.jazz.ajax.ui.PlatformUI.getWorkbench().setTitle(this.page.browserTitle );
			net.jazz.ajax.ui.PlatformUI.getWorkbench().browserTitle = this.page.browserTitle;
		}
	},


	setLRDIDs: function()
	{
		//Set the Lab Resource Description IDs into each part for retrieval later
		//There is an ID for each Lab Resource Description.
		if (this.resourceDescriptionIDs) 
		{
			var partCount = this.config.getRootParts().length;
			for (var i = 0; i < partCount; i++) 
			{
				var thisPart = this.config.getRootPart(i);
				if (this.resourceDescriptionIDs[i])
					thisPart.labResourceDescriptionID = this.resourceDescriptionIDs[i];
			}
		}
	},
	
	getLRDIDs: function(newPartID)
	{
		var partCount = this.config.getRootParts().length;
		var lrdIDs = [];
		for (var i = 0; i < partCount; i++) 
		{
			var thisPart = this.config.getRootPart(i);
			var lrdID = thisPart.labResourceDescriptionID;
			lrdIDs.push(lrdID ? lrdID : newPartID);
		}

		return lrdIDs;
	}
});
com.ibm.rational.test.lm.web.ui.internal.views.configurations.ConfigurationEditor.setInitialConfigString = function(config) {
	initialConfigString = config;		
};
com.ibm.rational.test.lm.web.ui.internal.views.configurations.ConfigurationEditor.getInitialConfigString = function() {
	return initialConfigString;		
};
	
})();
