//LRDSelectorDialog
/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/

dojo.provide("com.ibm.rational.test.lm.web.ui.internal.views.configurations.LRDSelectorDialog");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.rational.test.lm.web.client.internal.config");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.widgets.ConfigSummary");

( function() {
	
	var RtlmUiUtil = com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil;
	var TableConstants = com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;		
	var ServiceResponseHandler = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
	var ImageCache = com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
    var RtlmUiUtil_getMessage = RtlmUiUtil.getMessage;
		
dojo.declare("LRDSelectorDialog.TETableProvider",
			 com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider, 
{
    // Summary:
    //
    getNumColumns: function(content)
    {
        return 3;
    },

    _columnHeadings: [
		"",
        RtlmUiUtil.getMessage("cfgName"),
        RtlmUiUtil.getMessage("reqLabel_description")
    ],
    
    // Summary:
    //
    getColumnHeading: function(content, index)
    {
        return this._columnHeadings[index];
    },

	 
    getIsColumnGroupable: function(content, atColumnIndex)
    {
        return false;     
    },

    getIsColumnSortable: function(content, atColumnIndex)
    {
        return atColumnIndex > 0;   
    },

    _columnWidths: [1,34,65],
    
    getColumnWidth: function(content, atColumnIndex)
    {
        return this._columnWidths[atColumnIndex];
    },
    
    // Summary:
    //    The only assumptions the table have on the data that it displays
    //    is that it's an array contents. These are the data content/object that
    //    will be displayed in the table rows.
    //
    getContentObjects: function(content)
    {
        // our content is already an array of objects
        return content;
    },
    
    getRowDataId: function(rowData)
    {
        return rowData.id;
    },
    
    // Summary:
    //    Returns the type of the cell to be displayed. By default, the TableViewer
    //    will support a set of cell types. The type of the cell will map to a specific
    //    cell renderer (to be discussed).
    getCellDisplayType: function(rowData, atColumnIndex)
    {
        var type = TableConstants.RENDER_TYPE_TEXT;

        if (atColumnIndex == 0) {
            type = TableConstants.RENDER_TYPE_IMAGE;
        }
        return type;
    },

    getCellAlignment: function(rowData, atColumnIndex)
    {
        return TableConstants.ALIGN_LEFT;
    },
    
    // Summary:
    //    Returns the display data of the cell. For cell renderer type of TEXT, this will
    //    be the string. Others cell render type would be Date, or integer value, etc. If the 
    //    cell renderer type is image, the client can also supply cell data that can be sortable/groupable. 
    //    The TableViewer's default sorter, filter operates on this returned data. For "complex" 
    //    cell types such as image where it could have multiple values for different states, the 
    //    client also needs to implement the next method.
    //    
    //    Client must implement this method to provide the cell data.
    //    
    getCellDisplayData: function(rowData, atColumnIndex)
    {
        var val = "";
        switch(atColumnIndex) {
            case 1: 
                val = rowData.name;
                break;
            case 2: 
                if(rowData.summary != null)
                    val = rowData.summary;
                break;          
        }
        return val;
    },

    
    // Summary:
    //    If applicable, returns the extended display information of the cell. The return extended
    //    info must be an object with the following attributes:
    //    
    //    {
    //      /* attribute common for all cell renderer types */
    //      "tooltip": <string>,
    //
    //      /* attributes for IMAGE and ACTION cell renderer types */
    //      "isHidden": <true, false> the image is hidden if the row is not on the mouse over
    //      "image": base image URL,  
    //      "mouseOverImage": image URL, (optional)
    //      "mouseOutImage": image URL,  (optional) (overrides "image")
    //
    //      /* attributes for SELECT cell renderer type */
    //      "select" : 'value', the selection in the combo
    //      "choices" : [{'text':'display text', 'value':'value'}, ] array of objects with 'text' and 'value' attributes
    //
    //      /* attributes for CHECKBOX cell renderer type */
    //      "state" : <true, false> initial state of the check box
    //
    //      /* attributes for LINK cell renderer type */
    //      "href" : <string> the href string for the link
    //    }
    //
    //    Client can implement this method to provide extended display infor for the cell.
    //    Certain cell renderer type will require the client to implement this method to
    //    provide needed display information, such as an image ACTION.
    //
     getCellDisplayExtendedInfo: function(rowData, atColumnIndex)
    {  
        var val = null;
        if(atColumnIndex == 0) {
            val = {};
			val['image'] = ImageCache.CONFIGURATION_ICON;
        }

        return val;
    }  
    
    
});


dojo.declare("LRDSelectorDialog.LRDTableProvider",
			 com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider, 
{
    // Summary:
    //
    getNumColumns: function(content)
    {
        return 1;
    },
    
    _columnHeadings: [
        RtlmUiUtil.getMessage("cfgName")
    ],
    
    // Summary:
    //
    getColumnHeading: function(content, index)
    {
        return this._columnHeadings[index];
    },

	 
    getIsColumnGroupable: function(content, atColumnIndex)
    {
        return false;     
    },

    getIsColumnSortable: function(content, atColumnIndex)
    {
        return true;   
    },
    
    getColumnWidth: function(content, atColumnIndex)
    {
        return 100;
    },
    
    // Summary:
    //    The only assumptions the table have on the data that it displays
    //    is that it's an array contents. These are the data content/object that
    //    will be displayed in the table rows.
    //
    getContentObjects: function(content)
    {
        // our content is already an array of objects
        return content;
    },
    
    getRowDataId: function(rowData)
    {
        return rowData.id;
    },
    
    // Summary:
    //    Returns the type of the cell to be displayed. By default, the TableViewer
    //    will support a set of cell types. The type of the cell will map to a specific
    //    cell renderer (to be discussed).
    getCellDisplayType: function(rowData, atColumnIndex)
    {
        return TableConstants.RENDER_TYPE_TEXT;
    },

    getCellAlignment: function(rowData, atColumnIndex)
    {
        return TableConstants.ALIGN_LEFT;
    },
    
    // Summary:
    //    Returns the display data of the cell. For cell renderer type of TEXT, this will
    //    be the string. Others cell render type would be Date, or integer value, etc. If the 
    //    cell renderer type is image, the client can also supply cell data that can be sortable/groupable. 
    //    The TableViewer's default sorter, filter operates on this returned data. For "complex" 
    //    cell types such as image where it could have multiple values for different states, the 
    //    client also needs to implement the next method.
    //    
    //    Client must implement this method to provide the cell data.
    //    
    getCellDisplayData: function(rowData, atColumnIndex)
    {
        return rowData.name;
    }

});



	
dojo.declare("com.ibm.rational.test.lm.web.ui.internal.views.configurations.LRDSelectorDialog",
			 com.ibm.asq.common.web.ui.internal.widgets.ConfirmationDialog,
{	
    width: "70%",
	defaultID: null,
	
	postCreate: function()
	{
		this.inherited( "postCreate", arguments );

        if (this.title) {
            this.setTitle(this.title);
        }

        //Create the table that will hold the assets
        this.createTable();
        this.loadTable();
        this._checkButtonStatus();
		
		//Create the summary node
		this.summaryNode = new com.ibm.rational.test.lm.web.ui.internal.widgets.ConfigSummary();
		//Add the contents to the dialog
		this.contentContainer.appendChild(document.createTextNode(RtlmUiUtil_getMessage("Configuration")));
		this.contentContainer.appendChild( this.TETableViewer.domNode );
		this.contentContainer.appendChild(document.createTextNode(RtlmUiUtil_getMessage("cfgNonameLRD")));
		this.contentContainer.appendChild( this.LRDTableViewer.domNode );
		this.contentContainer.appendChild(this.summaryNode.domNode);	
	},
	
	//allow the user to specify a callback when OK is clicked
	setOKAction :function(callback)
	{
		this.yesCallback = callback;
	},
	
    //allow the user to specify a callback when Cancel is clicked
    setCancelAction :function(callback)
    {
        this.noCallback = callback;
    },
	
	getSelectedIDs: function()
	{
		var retVal = [];
		var rows = this.TETableViewer.getCheckedRows();
        var rows_length = rows.length;
		for( var iRow = 0; iRow < rows_length; iRow++ )
		{
			var id = rows[iRow].id;
			if (id)
				retVal.push(id);
		}
		return(retVal);	
	},
	
	getSelectedItems: function()
	{
		return this.TETableViewer.getCheckedRows();		
	},
	
	getSelectedAssetDescriptor:function()
	{
		var rows = this.LRDTableViewer.getCheckedRows();
		if (rows == null || rows.length == 0)
			return null;
			
		return rows[0].part;
	},
	
	getSelectedConfigID: function()
	{
		var selectedTEs = this.TETableViewer.getCheckedRows();
		if (selectedTEs == null || selectedTEs.length == 0)
			return null;
			
		return selectedTEs[0].id;
	},
	
	getSelectedIndex:function()
	{
		var rows = this.LRDTableViewer.getCheckedRows();
		if (rows == null || rows.length == 0)
			return null;
			
		return rows[0].index;		
	},
	
    show: function() {
        this.open();
    },
    
	createTable: function()
	{
		//Create the Test Environment table
		this.TETableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer();
		var tableContentProvider = new LRDSelectorDialog.TETableProvider();
		this.TETableViewer.setTableSummary(RtlmUiUtil_getMessage("labelTableSummary", RtlmUiUtil_getMessage("cfgCfgLabel")));
		this.TETableViewer.setTableRowsCheckable( true, true );
		this.TETableViewer.setContentProvider( tableContentProvider );
		this.TETableViewer.setTableListener( this );

		//Create the Lab Resource Description table
		var args = {
			showPagingControl:false,
			showFilterControl:false,
			showFooterPagingControl:false,
			showPagingRangeControl:false,
			showTableControls:false
		}
		this.LRDTableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer(args);
		var LRDTableContentProvider = new LRDSelectorDialog.LRDTableProvider();
		this.LRDTableViewer.setTableSummary(RtlmUiUtil_getMessage("labelTableSummary", RtlmUiUtil_getMessage("cfgNonameLRD")));
		this.LRDTableViewer.setTableRowsCheckable( true, true );
		this.LRDTableViewer.setContentProvider( LRDTableContentProvider );
		this.LRDTableViewer.setTableListener( this );
		this.LRDTableViewer.noItemMessage = "";

        this._clearTable();        
	},
	
	loadTable: function()
	{
        this.TETableViewer.showLoadingProgress();

        var TEs = new com.ibm.rational.test.lm.web.client.internal.config();
        var responseHandler= new com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper(this, "_searchSuccess", "_searchError");

		if (this.defaultID)
	        TEs.retrieveConfiguration(responseHandler, this.defaultID);
		else    
	        TEs.getAll(responseHandler);
		        
	},
	
	_searchSuccess: function( response )
	{
        this.TETableViewer.endLoadingProgress();
		
		if (response && !dojo.isArray(response))  //Not an array when preloaded with an id (defaultID != null)
			response = [response];
			
        this.TETableViewer.setContent( response );
		if (response && response.length > 0) 
		{
			this.TETableViewer.rowCheckedHandler.setRowCheckState(response[0], true);
			this._loadLRD();
		}
        this.TETableViewer.show();
        this.updatePosition();
	},
	
	_searchError: function( message, error )
	{
        this.TETableViewer.endLoadingProgress();
        this.TETableViewer.noItemMessage = RtlmUiUtil_getMessage("errRetrieveAllConfigs");
        this.TETableViewer.setContent([]);
        this.TETableViewer.show();
	},
	
	_clearTable: function()
	{
        // loads an empty content to the table to clear the content.
        var emptyContent = [];
        
        this.TETableViewer.setContent(emptyContent);
        this.TETableViewer.show();

        this.LRDTableViewer.setContent(emptyContent);
        this.LRDTableViewer.show();
	},
	
	
	// a row was checked so lets enable and disable actions appropriately    
    rowCheckStateChanged: function(tableViewer, rowObject, state)
    {
		if (tableViewer == this.TETableViewer) //Checked or unchecked a TE
		{
			if (state)  //checked
				this._loadLRD();
			else
			{
				//clear the lrdTable since no TE is selected
		        var emptyContent = [];
		        this.LRDTableViewer.setContent(emptyContent);
		        this.LRDTableViewer.refresh();
				this.summaryNode.setDefaultText("");
			}
			this._checkButtonStatus();
		}
		else //checked or unchecked an LRD
 		{
			if (state) 
			{
				var part = rowObject.part;
				//update the summary node with the selected part
				this.summaryNode.setPart(part);
				this.summaryNode.refresh();
			}
			else 
				this.summaryNode.setDefaultText("");
			
			this._checkButtonStatus();
		}
    },

	//Enable the OK button when a row is selected	
	_checkButtonStatus: function()
	{
		var rows = this.LRDTableViewer.getCheckedRows();
        this._yesButton.disabled = (!rows || rows.length == 0);
	},
	
	_loadLRD:function()
	{
        this.LRDTableViewer.showLoadingProgress();
		//Clear the summary node since no Lab Resource Description are selected
		this.summaryNode.setDefaultText("");
		
		var selectedTEs = this.TETableViewer.getCheckedRows();
		if (selectedTEs != null && selectedTEs.length > 0)
		{
			var id = selectedTEs[0].id;

	        var TEs = new com.ibm.rational.test.lm.web.client.internal.config();
        	var responseHandler= new com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper(this, "_loadSuccess", "_loadError");
    
	        TEs.retrieveConfigurationWithDetails(responseHandler, id);
		}
	},
	
	_loadSuccess:function(response)
	{
        this.LRDTableViewer.endLoadingProgress();
		
		//Save this in a member variable because the data in the TETable is summary while this is the fully loaded TE
		this.selectedTE = response;

		//Create a config object from the response config string and load the individual asset descriptions into the select control
		var catalog = new com.ibm.asq.common.web.client.internal.Catalog();
        var config = catalog.createConfigurationFromJson(response.configuration);

		//Clean out the list of asset descriptors (AKA parts)
		var parts = [];
		
		//Get the number of parts in the config
		var partCount = config.getRootParts().length;
		var defaultLRD = null;
		for (var i = 0; i < partCount; i++) 
		{
			//Get the part
			var part = config.getRootPart(i);
			//Get the label of the part to show in the select object
			var label = config.getLabel(i);
			
			//If there is no label then initialize it to a default value
			if (label == null || label == "") 
				label = RtlmUiUtil_getMessage("cfgNoLabel");
			
			var tableEntry = {
				id:i+1,  //Table row indices can't be zero
				index: i,
				name: label,
				part:part
			}
			parts.push(tableEntry)
			if (i == 0)
				defaultLRD = tableEntry;
		}
		
        this.LRDTableViewer.setContent( parts );
		if (defaultLRD != null) 
		{
			this.LRDTableViewer.rowCheckedHandler.setRowCheckState(defaultLRD, true);
			this.rowCheckStateChanged(this.LRDTableViewer, defaultLRD, true);
		}
        this.LRDTableViewer.show();
        this.updatePosition();
	},
	
	_loadError:function()
	{
        this.LRDTableViewer.endLoadingProgress();
        this.LRDTableViewer.noItemMessage = RtlmUiUtil_getMessage("fetchConfigFailed");
        this.LRDTableViewer.setContent([]);
        this.LRDTableViewer.show();		
	}
});

})();
