/**InventoryView**************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/

dojo.provide("com.ibm.rational.test.lm.web.ui.internal.views.inventory.InventoryView");
 
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.form.CheckBox");

dojo.require("com.ibm.asq.common.web.client.internal.Catalog");
dojo.require("com.ibm.asq.common.web.client.internal.PermissionsClient");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil");

dojo.require("com.ibm.asq.common.web.ui.internal.view.common.RelatedInfo");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.widgets.layout.SectionLayoutForm");

dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.EditorSectionContainer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.propertyeditor.PropertyEditor");

dojo.require("com.ibm.rational.test.lm.web.client.internal.inventory");

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");

dojo.require("com.ibm.rational.test.lm.web.ui.internal.views.providers.InventoryOperationsTableProvider"); 
dojo.require("com.ibm.rational.test.lm.web.ui.internal.views.providers.DeployOperationsTableProvider"); 
dojo.require("com.ibm.rational.test.lm.web.ui.internal.widgets.AbstractForm");
dojo.require("com.ibm.team.process.web.client.projectarea");

//
// Summary:
//
(function() {

var ServiceResponseHandler  = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var PermissionsClient = com.ibm.asq.common.web.client.internal.PermissionsClient;
var ViewHeaderLayout = com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout;
var getCurrentProjectArea = com.ibm.team.process.web.client.projectarea.getCurrentProjectArea;

var RtlmUiUtil = com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil;
var RelatedInfoPanel=com.ibm.asq.common.web.ui.internal.view.common.RelatedInfoPanel;
var ONE_SEC = 1000;
var RtlmUiUtil_getMessage = RtlmUiUtil.getMessage;
		
dojo.declare("com.ibm.rational.test.lm.web.ui.internal.views.inventory.InventoryView", 
    [dijit._Widget, dijit._Templated,
     com.ibm.asq.common.web.ui.internal.view.common.RelatedInfoMixin,
     com.ibm.rational.test.lm.web.ui.internal.widgets.AbstractForm],
{    
    templatePath: dojo.moduleUrl("com.ibm.rational.test.lm.web", "ui/internal/views/inventory/templates/InventoryView.html"),
    widgetsInTemplate: true,
	listTable: null,
	asset: null,
	assetType: null,
    assetTypeNames:null,
    staticRelatedInfo: null,
	// flag to identify whether deploy or undeploy, default is deploy
	deployFlag: true,
    
    refreshInterval: ONE_SEC * 8, // the interval to auto refresh the deploy view. 
    
    getStaticRelatedInfo: function() {
        return this.staticRelatedInfo;
    },
        
    getStaticRelatedInfoId: function() {
        return "com.ibm.rational.test.lm.web.ui.internal.views.inventory.InventoryView";
    },

    postCreate: function() {
        this.inherited("postCreate", arguments);

        this.staticRelatedInfo = new RelatedInfoPanel();
        this.staticRelatedInfo.addLink(RtlmUiUtil_getMessage("labelRelatedSites"),
                                       RtlmUiUtil_getMessage("productTSRM"),
                                       "http://www-306.ibm.com/software/tivoli/products/service-request-mgr/");
        this.staticRelatedInfo.addLink(RtlmUiUtil_getMessage("labelRelatedSites"),
                                       RtlmUiUtil_getMessage("productTADDM"),
                                       "http://www-306.ibm.com/software/tivoli/products/taddm/");

		this.viewHeaderNode.setTitle(RtlmUiUtil.getRQMMessage("labelAllInvHist"));
		this.viewHeaderNode.setCSHelpId("rtlm_inventory_history.html", com.ibm.rational.test.lm.web.CSHelpID);
		this.viewHeaderNode.setCSHelpButtonLabel(RtlmUiUtil_getMessage("labelHelp", "", "Inventory"));
				
        this.synchronizeButtonNode = this.viewHeaderNode.addRightViewAction(RtlmUiUtil_getMessage("Synchronize"), dojo.hitch(this, "_update"), null, null);
        this.discoverButtonNode = this.viewHeaderNode.addRightViewAction(RtlmUiUtil_getMessage("Discover"), dojo.hitch(this, "_discover"), null, null);
        this.refreshButton = this.viewHeaderNode.addLeftViewAction(RtlmUiUtil_getMessage("Refresh"), dojo.hitch( this, this._onRefreshActionClick ), null, "refresh-icon-image" );
        var self = this;
		this.inventoryHistoryClosed = true;
		this.deployClosed = true;
		
        var inventorysection_args = {
            title: RtlmUiUtil_getMessage("Inventory Operations"), 
            open: false,
            onFirstExpand: function( widget ) { self._getInventoryHistory(); },
            onToggle: dojo.hitch( self, self._inventoryHistoryToggled )
        };
		this.inventorysection = new com.ibm.asq.common.web.ui.internal.view.common.EditorSectionContainer(inventorysection_args);
        // hide unused header div's
        this.inventorysection.infoNode.style.display = "none";
        this.inventorysection.summaryNode.style.display = "none";
		
        var deploymentsection_args = {
            title: RtlmUiUtil_getMessage("Deployment Operations"),
            open: false,
            onFirstExpand: function( widget ) { self._runDeploy(); },
            onToggle: dojo.hitch( self, self._deployToggled )
        };
		this.deploymentsection = new com.ibm.asq.common.web.ui.internal.view.common.EditorSectionContainer(deploymentsection_args);
        // hide unused header div's
        this.deploymentsection.infoNode.style.display = "none";
        this.deploymentsection.summaryNode.style.display = "none";
        
		this.listAreaNode.appendChild( this.inventorysection.domNode );
//		this.listAreaNode.appendChild( this.newinventorysection.domNode );
		this.listAreaNode.appendChild( this.deploymentsection.domNode );
		this.inventoryHistoryFirstTime = true;
		this.deployPerformed = false;
        
        this.synchronizeButtonNode.setDisabled(true); 
        this.discoverButtonNode.setDisabled(true);
        this.init();
        
        // save our view's uri for comparison later when
        // auto refreshing.
        this.myViewUri = window.location.hash;
        this._setButtonStates();
    },
                     
    _hasSynchronizePermission: function()
    {
        var perm = PermissionsClient.getStoredPermission(PermissionsClient.OP_LM_INVENTORY);
        return (!perm || perm[PermissionsClient.ACTION_SYNCHRONIZE]);
    },
    
    _hasDiscoverPermission: function()
    {
        var perm = PermissionsClient.getStoredPermission(PermissionsClient.OP_LM_DISCOVERY);  
        return (!perm || perm[PermissionsClient.ACTION_RUN]);   
    },

    _hasVirtualizationPermission: function()
    {
        var perm = PermissionsClient.getStoredPermission(PermissionsClient.OP_LM_VIRTUALIZATION);  
        return (!perm || perm[PermissionsClient.ACTION_DEPLOY]);   
    },
    
    _setButtonStates: function()
    {
        this.synchronizeButtonNode.setDisabled(!this._hasSynchronizePermission()); 
        this.discoverButtonNode.setDisabled(!this._hasDiscoverPermission());

        if(!this._hasSynchronizePermission() || !this._hasDiscoverPermission()) {
            var text = RtlmUiUtil_getMessage("inventoryNoPerms");
            var details = RtlmUiUtil_getMessage("inventoryNoPermsDetails");
            this.viewHeaderNode.setStatus(text, ViewHeaderLayout.WARNING, details);    
        } 
    },
    
	_inventoryHistoryToggled: function( widget )
	{
		this.inventoryHistoryClosed = !this.inventoryHistoryClosed;
	},
	
	_deployToggled: function( widget )
	{
		this.deployClosed = !this.deployClosed;
	},
	
    init: function()
    {
        this.autoDeployRefresh = false;
        this.autoInventoryRefresh = false;
        
	    this._checkExternalRun(false);
        
        // there's no external invocation of actions. This is a plain opening of the
        // inventory page. Just populate the section's contents.
        //
		if (!this.deployPerformed && !this.discoveryPerformed && !this.undeplyPerformed && !this.showDeployCollection) {
			if( this.inventoryHistoryClosed )
				this.inventorysection.toggle();
			if( this.deployClosed )
				this.deploymentsection.toggle();
            
			this._getInventoryHistory();
			this._runDeploy();
		}
    },
    
    // Summary:
    //    NOT BEING USED.
    //    Initilaize the view to auto refresh the synchronize & deploy entries. 
    //     
    //    NOTE: The UI is disabled at this point. The controls for auto refresh
    //    is managed internally and doesn't require user interaction.
    //    
    _initAutoRefresh: function()
    {
        this.deploymentsection.infoNode.style.display = "";
        
        var args = {'checked':this.autoDeployRefresh};
        this.autoRefreshToggle = new dijit.form.CheckBox(args);
        this.autoRefreshToggle.domNode.style.margin = "0em 0.3em 0em 0.5em";
        this.connect(this.autoRefreshToggle, "onChange", dojo.hitch(this, "_toggleAutoRefresh"));
        
        this.deploymentsection.infoNode.appendChild(this.autoRefreshToggle.domNode);
        
        var autoRefreshLabel = document.createElement("span");
        autoRefreshLabel.innerHTML = RtlmUiUtil_getMessage("labelAutoRefreshDeployView");
        autoRefreshLabel.style.marginTop = "0.7em";
        this.deploymentsection.infoNode.appendChild(autoRefreshLabel);
       
        // setup the timer to auto refresh the deploy view
        this._toggleAutoRefresh();
    },
    
    _toggleAutoRefresh: function()
    {
        var isChecked = this.autoDeployRefresh || this.autoInventoryRefresh;//this.autoRefreshToggle.checked;
        
        if (isChecked) {
            if (!this.refreshViewTimer) {
                // initiate a refresh right away and enable the timer to refresh.
                this.autoRefreshView();
                this.refreshViewTimer = setInterval(dojo.hitch(this, "autoRefreshView"), this.refreshInterval);
            }
        }
        else {
            this.clearAutoRefresh();
        }    
    },
	
    // Summary:
    //   External pages will instruct this page to perform discover machines and to deploy/undeploy
    //   virtual images. The is communicated thru global objects. Check the object for set data and
    //   carry out the directive.
    _checkExternalRun: function(/*optional*/ retainRefresh)
    {
        this.deployPerformed = false;
        this.discoveryPerformed = false;
        this.undeployPerformed = false;
        this.showDeployCollection = false;
        
        // initialize the auto-refresh flags.
        if (!retainRefresh) {
            this.autoDeployRefresh = false;
            this.autoInventoryRefresh = false;
        }
        
        if( dojo.getObject( "com.ibm.rational.test.lm.web.virtualimages" ) )
            this.deployPerformed = true;
        else if( dojo.getObject( "com.ibm.rational.test.lm.web.discoverimages" ) )
            this.discoveryPerformed = true;
        else if( dojo.getObject( "com.ibm.rational.test.lm.web.virtualmachines" ) )
            this.undeployPerformed = true;
        else if( dojo.getObject( "com.ibm.rational.test.lm.web.deployCollection" ) )
            this.showDeployCollection = true;
        
        // there're external directives. Clear the current status line first
        // before running the external action.
        if (this.deployPerformed || this.discoveryPerformed || this.undeplyPerformed || this.showDeployCollection) {
            this.viewHeaderNode.clearStatus();
        }        
        
        if (this.deployPerformed) {
            if (this.deployClosed) 
                this.deploymentsection.toggle();
            if( !this.inventoryHistoryClosed )
                this.inventorysection.toggle();
            this._runDeploy();
            this.autoDeployRefresh = true;
        }
        else if (this.discoveryPerformed) {
            if( this.inventoryHistoryClosed )
                this.inventorysection.toggle();
            if (!this.deployClosed) 
                this.deploymentsection.toggle();
            this._runDiscovery();
            this.autoInventoryRefresh = true;
        }
        else if( this.undeployPerformed )
        {
            if( this.deployClosed )
                this.deploymentsection.toggle();
            if( !this.inventoryHistoryClosed )
                this.inventorysection.toggle();
            this._runUndeploy();
            this.autoDeployRefresh = true;
        }
        else if( this.showDeployCollection )
        {
            dojo.setObject( "com.ibm.rational.test.lm.web.deployCollection", null );
            if( this.deployClosed )
                this.deploymentsection.toggle();
            if( !this.inventoryHistoryClosed )
                this.inventorysection.toggle();
            this._getDeployed();
        }
        
        // we've either turned ON/OFF auto refresh, reset the
        // refresh state.
        this._toggleAutoRefresh();
    },
    
    onActivated: function()
    {
        // this page is being shown on top. It could be that other sources
        // is asking this page to perform discovery/deploy actions. Check for
        // them. 
        this._checkExternalRun(/*keep the current refresh flags*/true);
    },
    
	_update: function()
	{
		this._checkCPULimit();
		this.viewHeaderNode.clearStatus();
		this.synchronizeButtonNode.setDisabled(true);
		this.inventoryProviderNotConfig = false;
		this.virtualizationProviderNotConfig = false;
		var inven = new com.ibm.rational.test.lm.web.client.internal.inventory();
	   	var responseHandler = new com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper(this, "_updateSuccess", "_updateError");
		inven.updateAllAssets( responseHandler );
	},
	
	_discover: function()
	{
		this._checkCPULimit();		
		this.viewHeaderNode.clearStatus();
		this.discoverButtonNode.setDisabled(true);
		var inven = new com.ibm.rational.test.lm.web.client.internal.inventory();
	   	var responseHandler = new com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper(this, "_discoverSuccess", "_discoverError");
		inven.discoverAllAssets( responseHandler );
	},
	
	_updateSyncStatus: function()
	{
		var msgKey = "msgSyncBothProvidersConfigured";
		var level = ViewHeaderLayout.INFO;
		if (this.inventoryProviderNotConfig && this.virtualizationProviderNotConfig) {
			msgKey = "warnSyncNoProviderConfigured";
			level = ViewHeaderLayout.WARNING;
		} else if (this.inventoryProviderNotConfig) {
			msgKey = "msgSyncVirtualizationProviderConfigured";
		} else if (this.virtualizationProviderNotConfig) {
			msgKey = "msgSyncInventoryProviderConfigured";
		}
		this.viewHeaderNode.setStatus( RtlmUiUtil_getMessage( msgKey ), level );
	},
	
	_updateSuccess: function( response )
	{
		if (response && ( response == "SPIRC_INVENTORY_PROVIDER_NOT_CONFIG_ERROR" ) ) {
			this.inventoryProviderNotConfig = true;			
		}
		var inven = new com.ibm.rational.test.lm.web.client.internal.inventory();
	   	var responseHandler = new com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper(this, "_syncVIsSuccess", "_syncVIsError");
		inven.syncAllVirtualImages( responseHandler );        
	},
	
	_syncVIsSuccess: function( response )
	{		
		if (response && ( response == "SPIRC_VIRTUALIZATION_PROVIDER_NOT_CONFIG_ERROR" ) ) {
			this.virtualizationProviderNotConfig = true;			
		}		
		var inven = new com.ibm.rational.test.lm.web.client.internal.inventory();
		var responseHandler = new com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper(this, "_syncVMsSuccess", "_syncVMsError");
		inven.syncAllVirtualMachines( responseHandler );
	},
	
	_syncVMsSuccess: function( response )
	{
		if (response && ( response == "SPIRC_VIRTUALIZATION_PROVIDER_NOT_CONFIG_ERROR" ) ) {
			if (!this.virtualizationProviderNotConfig) {
				this.virtualizationProviderNotConfig = true;
			}			
		}
		this._updateSyncStatus();	
        this._getInventoryHistory();
	},
	
	_syncVMsError: function( errorObj )
	{
		this.synchronizeButtonNode.setDisabled(false);
        this._getInventoryHistory();
	},
	
	_syncVIsError: function( errorObj )
	{
		this._setButtonStates();		
        this._getInventoryHistory();
	},
	
	_updateError: function( response )
	{
		this._setButtonStates();		
        this._getInventoryHistory();
	},

	_discoverSuccess: function( response )
	{
		if (response && ( ( response == "SPIRC_INVENTORY_PROVIDER_NOT_CONFIG_ERROR" ) || ( response == "SPIRC_VIRTUALIZATION_PROVIDER_NOT_CONFIG_ERROR" ) ) ) {
			this.viewHeaderNode.setStatus( RtlmUiUtil_getMessage( response ), ViewHeaderLayout.WARNING );			
		}
		this._getInventoryHistory();
	},
	
	_discoverError: function( response )
	{
        this._setButtonStates();        
	},
	
	_getInventoryHistory: function()
    {
		if( !( this.tableViewer ) )
		{
            var tableViewer_args = {
                groupByColumn: 0,
                allowAdjustSettings: true,
                autoSaveSettings: true,
                tableId: "RQM-LM-INVEN-TABLEVIEWER"                                
            };
        	this.tableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer(tableViewer_args);
			this.inventorysection.contentNode.appendChild( this.tableViewer.domNode );
			var iops = new com.ibm.rational.test.lm.web.ui.internal.views.providers.InventoryOperationsTableProvider();
			iops.setCancelCallback( dojo.hitch( this, this._cancelOperation ) );
			
	        this.tableViewer.setContentProvider( iops );
	       	this.tableViewer.setContentPageSize(15);
            var inventoryOperationsTableSorter = new com.ibm.rational.test.lm.web.ui.internal.views.providers.InventoryOperationsTableSorter();
	       	this.tableViewer.setSorter(inventoryOperationsTableSorter);
	       	this.tableViewer.setTableSummary(RtlmUiUtil_getMessage("labelTableSummary", RtlmUiUtil_getMessage("Inventory Operations")));
			
			this.tableViewer.setContent( [] );
	       	this.tableViewer.show();
		}
		
		this.tableViewer.showLoadingProgress();
		
		//New InventoryOperations 
//		this.newIOPSTable = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer();
//		this.newinventorysection.contentNode.appendChild( this.newIOPSTable.domNode );

//		var niops = new com.ibm.rational.test.lm.web.ui.internal.views.providers.NewInventoryOperationsTableProvider();
//        this.newIOPSTable.setContentProvider( niops );
//       	this.newIOPSTable.setContentPageSize(15);
//		var modifier = new com.ibm.rational.test.lm.web.ui.internal.views.providers.InventoryOperationsCellModifier( this );
//		this.newIOPSTable.setCellModifier( modifier );
		
		var inven = new com.ibm.rational.test.lm.web.client.internal.inventory();
	   	var responseHandler = new com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper(this, "_searchSuccess", "_searchError");
		inven.getOperations( responseHandler );
    },

    _hasRunningInventoryOperations: function(response)
    {
        if(!response)
            return false;
        
        var response_length = response.length;
        for(var i = 0; i < response_length; i++) {
            var opRec = response[i];
            
            // if the status is not completed (and its variant) and
            // it's not canceled, it's an active operation.
            if (opRec.status && opRec.status.indexOf('COMPLETED') < 0 && opRec.status != 'CANCELED') {
                return true;
            }    
        }
        return false;
    },
	
	_searchSuccess: function( response )
	{
		this.tableViewer.endLoadingProgress();
		
		this.tableViewer.setContent( ( response ) ? response : [] );
        this.tableViewer.refresh();
        this._setButtonStates();        

        // check for running operations. Change our auto-refresh state
        // based on the whether we've running ops, if the two states
        // are different, change the auto refresh status. Basically, turn ON 
        // autoRefresh if we've active ops, or turn OFF autoRefresh if we 
        // don't have active ops anymore.
        var hasRunningOp = this._hasRunningInventoryOperations(response);
        
        this.autoInventoryRefresh = hasRunningOp;
        this._toggleAutoRefresh();
	},
	
	_searchError: function( message, error )
	{
		this.tableViewer.endLoadingProgress();
        this._setButtonStates();        
	},
		
	_runDeploy: function()
	{
		var ids = dojo.getObject( "com.ibm.rational.test.lm.web.virtualimages" );
		dojo.setObject( "com.ibm.rational.test.lm.web.virtualimages", null );
		
		this.deployFlag = true;
		this.viewHeaderNode.clearStatus();
		
		if( ids && this._hasVirtualizationPermission())
		{
			var inven = new com.ibm.rational.test.lm.web.client.internal.inventory();
	   		var responseHandler = new com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper(this, "_deployActionSuccess", "_deployActionError");
            
			inven.deployMutipleVirtualImages( responseHandler, ids );
		}
		else
		{
			this._getDeployed();
		}
	},
	
	_deployActionSuccess: function( response )
	{
		if( response && ( dojo.isArray( response ) ) && ( response.length > 0 ) )
		{
			this.selectedCount = response.length;
			this.successCount = 0;
			this.errorCount = 0;
            var hasError = false;
            
			if( this.selectedCount == 1 ) 
			{
				// Deployed only one virtual image
				hasError = this._handleSingleReturnCodeDTO( response[0] );
			}
			else
			{
				// Deployed mutiple virtual images
				this._handleMutipleReturnCodeDTO( response );
                hasError = (this.successCount == 0);
			}
			this._getDeployed();
		}
	},
	
	_handleSingleReturnCodeDTO: function( dto )
	{
		if( dto && ( dto.rc != "SPIRC_NO_ERROR" )) 
		{
			var message = dto.message;
			var localMsg = ( message != null ) 
								? ( RtlmUiUtil_getMessage( dto.rc ) + ": " + message ) 
								: RtlmUiUtil_getMessage( dto.rc );
			this.viewHeaderNode.setStatus( localMsg, ViewHeaderLayout.ERROR );
            
            // return true to indicate hasError
            return true;
		}
        // hasError == false;
        return false;
	},
	
	_handleMutipleReturnCodeDTO: function( dtos )
	{
        var dtos_length = dtos.length;
		for( var idto = 0; idto < dtos_length; idto++ )
		{
			if(dtos[ idto ].rc && ( dtos[ idto ].rc == "SPIRC_NO_ERROR" ) )
			{
				this.successCount++;
			}
			else
			{
				this.errorCount++;
			}
			var messageKey = this.deployFlag ? "msgDeployedVIs" : "msgUndeployedVMs";
			this.viewHeaderNode.setStatus(
                RtlmUiUtil_getMessage( messageKey, this.successCount, this.selectedCount ),
                this.errorCount == 0 ? ViewHeaderLayout.SUCCESS :
                    this.errorCount == this.selectedCount ? ViewHeaderLayout.ERROR : ViewHeaderLayout.INFO
            );
		}
	},
	
	_deployActionError: function( errorObj )
	{
		this._getDeployed();
	},
	
	_getDeployed: function()
	{
        if (!this.deployTableViewer) {
            dojox.data.dom.removeChildren(this.deploymentsection.contentNode);
            
            var deployTableViewer_args = {
                allowAdjustSettings: true,
                autoSaveSettings: true,
                tableId: "RQM-LM-DEPLOY-TABLEVIEWER"                                
            };
            this.deployTableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer(deployTableViewer_args);
            this.deploymentsection.contentNode.appendChild(this.deployTableViewer.domNode);
            
            var deployOperationsTableProvider = new com.ibm.rational.test.lm.web.ui.internal.views.providers.DeployOperationsTableProvider();
            this.deployTableViewer.setContentProvider(deployOperationsTableProvider);
            this.deployTableViewer.setContentPageSize(15);
            var deployOperationsTableSorter = new com.ibm.rational.test.lm.web.ui.internal.views.providers.DeployOperationsTableSorter();
            this.deployTableViewer.setSorter(deployOperationsTableSorter);
            this.deployTableViewer.setTableSummary(RtlmUiUtil_getMessage("labelTableSummary", RtlmUiUtil_getMessage("Deployment Operations")));

            //Set initial sorting so that the sorting is not random on the items within the group
            this.deployTableViewer.sortDir = this.deployTableViewer.getContentProvider().getInitialSortDirection();
            this.deployTableViewer.sortByColumn = this.deployTableViewer.getContentProvider().getInitialSortByColumn();
            this.deployTableViewer.setContent([]);
            this.deployTableViewer.show();
        }		
        this.deployTableViewer.setContent([]);
        this.deployTableViewer.refresh();
		this.deployTableViewer.showLoadingProgress();
       	
		var inven = new com.ibm.rational.test.lm.web.client.internal.inventory();
	   	var responseHandler = new com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper(this, "_getDeploySuccess", "_getDeployError");
		inven.getAllDeployingOperations( responseHandler );
	},

    _hasRunningDeployOperations: function(response)
    {
        if(!response)
            return false;
            
        var response_length = response.length;
        for(var i = 0; i < response_length; i++) {
            var opRec = response[i];
            
            // when the VM is running (for deploy) or (for undeploy)
            // the VM is 'removed', there're no more active operations.
            // Or if the operation failed, that's a terminal status too.
            //
            if(opRec.status != 'Running' && opRec.status != 'Removed' && opRec.status != 'Failed')
                return true;
        }
        return false;
    },
	
	_getDeploySuccess: function( response )
	{
		this.deployTableViewer.endLoadingProgress();
		this.deployTableViewer.setContent( ( response ) ? response : [] );
		this.deployTableViewer.refresh();

        // check for running operations. Change our auto-refresh state
        // based on the whether we've running ops, if the two states
        // are different, change the auto refresh status. Basically, turn ON 
        // autoRefresh if we've active ops, or turn OFF autoRefresh if we 
        // don't have active ops anymore.
        var hasRunningOp = this._hasRunningDeployOperations(response);
        
        this.autoDeployRefresh = hasRunningOp;
        this._toggleAutoRefresh();
	},
	
	_getDeployError: function()
	{
		this.deployTableViewer.endLoadingProgress();
	},
	
	_onRefreshActionClick:function()
	{
		this.viewHeaderNode.clearStatus();
		if( this.inventorysection.open )
		{
			this._getInventoryHistory();
		}
		
		this._getDeployed();
	},
	
	_cancelOperation: function( data, e )
	{
		var inven = new com.ibm.rational.test.lm.web.client.internal.inventory();
   		var responseHandler = new com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper(this, "_cancelDiscoverySuccess", "_cancelDiscoveryError");
		inven.cancelDiscovery( responseHandler, data.operationId );
	},
		
	_cancelDiscoverySuccess: function( response )
	{
		this._getInventoryHistory();
	},
	
	_cancelDiscoveryError: function( errorObj )
	{
		
	},
	
	_runDiscovery: function()
	{
		var ids = dojo.getObject( "com.ibm.rational.test.lm.web.discoverimages" );
		dojo.setObject( "com.ibm.rational.test.lm.web.discoverimages", null );
		
		if( ids && this._hasDiscoverPermission())
		{
			var inven = new com.ibm.rational.test.lm.web.client.internal.inventory();
	   		var responseHandler = new com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper(this, "_discoverActionSuccess", "_discoverActionError");
			inven.discoverMutipleAssets( responseHandler, ids );
			//this._getInventoryHistory();
		}
		else
		{
			this._getInventoryHistory();
		}		
	},
	
	_discoverActionSuccess: function( response )
	{
		this._getInventoryHistory();
	},
	
	_discoverActionError: function( errorObj )
	{
		this._getInventoryHistory();
	},
	
	_runUndeploy: function()
	{
		var ids = dojo.getObject( "com.ibm.rational.test.lm.web.virtualmachines" );
		dojo.setObject( "com.ibm.rational.test.lm.web.virtualmachines", null );
		
		this.deployFlag = false;
		this.viewHeaderNode.clearStatus();
		
		if( ids  && this._hasVirtualizationPermission() )
		{
			var inven = new com.ibm.rational.test.lm.web.client.internal.inventory();
	   		var responseHandler = new com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper(this, "_undeployActionSuccess", "_undeployActionError");
			inven.undeployMultipleVMs( responseHandler, ids );
		}
		else
		{
			this._getDeployed();
		}
	},
	
	_undeployActionSuccess: function( result )
	{
		if( result && ( dojo.isArray( result ) ) && ( result.length > 0 ) )
		{
			this.selectedCount = result.length;
			this.successCount = 0;
			this.errorCount = 0;
            var hasError = false;

			if( this.selectedCount == 1 ) 
			{
				// Undeployed only one virtual machines
				hasError = this._handleSingleReturnCodeDTO( result[0] );
			}
			else
			{
				// Undeployed mutiple virtual machines
				this._handleMutipleReturnCodeDTO( result );
                hasError = (this.successCount == 0);
			}
			this._getDeployed();
		}
	},
	
	_undeployActionError: function( errorObj )
	{
	},
	
    //Checks to see if the number of CPUs in the system exeeds the licensed limit.
    //If it does, it displays a warning.
	_checkCPULimit: function()
	{
        var adminClient = new com.ibm.asq.common.web.client.internal.admin();
        var responseHandler = new com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper(
            {
                parent: this,
                _success: function(response) 
                {
					var cpuLimit = response.globalCpuSoftLimit;
					var numCPUs = response.numGlobalCpus;
					if (numCPUs > cpuLimit)
						alert(RtlmUiUtil_getMessage("msgCPULimit", numCPUs, cpuLimit));
                },
                _failure: function(errObj) 
                {
                    //Ignore failure
                }
            },
            "_success",
            "_failure"
        );
        adminClient.getSystemOptions(responseHandler);
	},
    
    autoRefreshView: function()
    {
        // if our page is not in view, don't waste the cycle to update
        // the deploy data. Suspend the refresh until we're in view again.
        if (dojo.isDescendant(this.domNode, document) && this.myViewUri == window.location.hash) {
            if(this.autoDeployRefresh)
                this._getDeployed();
                
            if(this.autoInventoryRefresh)
                this._getInventoryHistory();
            return;    
        }
    },
    
    clearAutoRefresh: function()
    {
        if(this.refreshViewTimer) {
            clearInterval(this.refreshViewTimer);
            delete this.refreshViewTimer;
        }
    },
    
    uninitialize: function()
    {
        // the page is being removed. Clear any timers that we've started.
        this.clearAutoRefresh();
        // remove RelatedInfo
        this.staticRelatedInfo.destroy();
    } 
});

})();
