/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rational.test.lm.web.ui.internal.views.machines.AssetContentProviderFactory");

dojo.require("com.ibm.rational.test.lm.web.ui.internal.views.machines.TemplatedAssetContentProvider");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.views.machines.DefaultAssetContentProvider");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.views.machines.RTLMMachineContentProvider");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.views.machines.AssetTemplateUtil");

(function(){
    
// Summary:
//    Factory object to construct content providers for the different asset types.
//
com.ibm.rational.test.lm.web.ui.internal.views.machines.AssetContentProviderFactory = {

    // Summary:
    //    Returns the appropriate content provider for the given assetType  
    //        
    getAssetContentProvider: function(assetType, sectionForm, /* optional */ formListener){
        var template = null;
			
		template = com.ibm.rational.test.lm.web.ui.internal.views.machines.AssetTemplateUtil.getAssetDetailsTemplate( assetType );
        var provider = new com.ibm.rational.test.lm.web.ui.internal.views.machines.TemplatedAssetContentProvider(sectionForm, formListener, template);
        return provider;
    },
    
    // Summary:
    //    Returns the appropriate search content provider for the given assetType. Search
    //    content providers are used to construct a configuration building form for the search.  
    //        
    getAssetSearchContentProvider: function(assetType, sectionForm, /* optional */ formListener){
        var template = null;
            
        template = com.ibm.rational.test.lm.web.ui.internal.views.machines.AssetTemplateUtil.getAdvancedSearchTemplate( assetType );
        var provider = new com.ibm.rational.test.lm.web.ui.internal.views.machines.TemplatedAssetContentProvider(sectionForm, formListener, template);            
        return provider;
    },

    // Summary:
    //    Returns the appropriate search content provider for the given assetType. Search
    //    content providers are used to construct a configuration building form for the search.  
    //        
    getAssetConfigurationProvider: function(assetType, sectionForm, /* optional */ formListener){
        var template = null;
            
        template = com.ibm.rational.test.lm.web.ui.internal.views.machines.AssetTemplateUtil.getConfigurationTemplate( assetType );
        var provider = new com.ibm.rational.test.lm.web.ui.internal.views.machines.TemplatedAssetContentProvider(sectionForm, formListener, template);            
        return provider;
    }
	
    
};

})();
