// TestCellEditor
/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/

dojo.provide("com.ibm.rational.test.lm.web.ui.internal.views.testcells.TestCellEditor");
 
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.form.Button");

dojo.require("net.jazz.ajax.ui.PlatformUI");

dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");

dojo.require("com.ibm.asq.common.web.client.internal.Catalog");
dojo.require("com.ibm.rational.test.lm.web.client.internal.config");

dojo.require("com.ibm.asq.common.web.client.internal.PermissionsClient");

dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.widgets.layout.SectionLayoutForm");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.widgets.layout.FormListener");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.widgets.layout.FormTextField");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.richtext.RichTextControl");

dojo.require("com.ibm.asq.common.web.ui.internal.util.GlobalEvents");
dojo.require("com.ibm.asq.common.web.ui.internal.util.Utility");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");

dojo.require("com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.views.configurations.ConfigurationsUriUtil");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.pages.AssetUriUtil");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.views.testcells.TestCellUriUtil");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.views.machines.AssetSelectorDialog");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.scheduler.Scheduler");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.Util");
dojo.require("com.ibm.rational.test.lm.web.client.internal.collections");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.views.configurations.TESelectorDialog");

(function() {

var RtlmUiUtil = com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil;
var ServiceResponseHandler = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var RichTextControl = com.ibm.asq.common.web.ui.internal.widgets.richtext.RichTextControl;
var TableConstants = com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;
var ConfigUriUtil = com.ibm.rational.test.lm.web.ui.internal.views.configurations.ConfigurationsUriUtil;
var AssetUriUtil = com.ibm.rational.test.lm.web.ui.internal.pages.AssetUriUtil;
var TestCellUriUtil = com.ibm.rational.test.lm.web.ui.internal.views.testcells.TestCellUriUtil;
var PermissionsClient = com.ibm.asq.common.web.client.internal.PermissionsClient;
var ViewHeaderLayout = com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout;
var GlobalEvents = com.ibm.asq.common.web.ui.internal.util.GlobalEvents;
var theCatalog = new com.ibm.asq.common.web.client.internal.Catalog();
var RtlmUiUtil_getMessage=RtlmUiUtil.getMessage;
var LOADING = RtlmUiUtil_getMessage("appWorking");
var SAVING = RtlmUiUtil_getMessage("savingTestCell");
var ImageCache = com.ibm.asq.common.web.ui.internal.view.common.ImageCache;

dojo.declare("com.ibm.rational.test.lm.web.ui.internal.views.testcells.TestCellEditor", 
    [dijit._Widget, dijit._Templated],
{ 
    templateString: '<div class="test-editor" dojoAttachPoint="domNode" tabindex="-1">' +
                    '    <div dojoType="com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout" dojoAttachPoint="viewHeaderNode"' +
                    '         titleEditable="true" summaryEditable="true" summaryAsDesc="false" maxSummaryLength=250>' +
                    '        <div class="editor-area" dojoAttachPoint="viewMainNode">' +
                    '            <div dojoType="com.ibm.asq.common.web.ui.internal.view.common.CollapsibleSection" open="false" dojoAttachPoint=descriptionNode>' +
                    '            </div>' +
                    '            <div dojoType="com.ibm.asq.common.web.ui.internal.view.common.CollapsibleSection" open="true" dojoAttachPoint="environmentNode">' +
                    '            </div>' +
                    '            <div dojoType="com.ibm.asq.common.web.ui.internal.view.common.CollapsibleSection" open="false" dojoAttachPoint="availabilityNode">' +
                    '            </div>' +
                    '        </div>' +
                    '    </div>' +   //Tables that get relocated into the header and the environment section
                    '    <table border="0" dojoAttachPoint="attributeTable">' +
                    '        <tr>' +
                    '            <td valign="middle" nowrap><span dojoAttachPoint="assetTypeLabel" class="attributes-entry-label"></span></td>' +
                    '            <td width="100%" valign="middle">' +
                    '                <select dojoAttachPoint="assetTypeSelector" class="attributes-entry-value"></select>' +
                    '                <span dojoAttachPoint="assetTypeField" class="attributes-entry-value" style="color: gray"></span>' +
                    '            </td>' +
                    '            <td valign="middle" nowrap><span dojoAttachPoint="ownerLabel" class="attributes-entry-label" style="padding-left: 10px"></span></td>' +
                    '            <td width="100%" valign="middle">' +
                    '                <select dojoAttachPoint="ownerSelector" class="attributes-entry-value"></select>' +
                    '            </td>' +
                    '        </tr>' +
                    '    </table>' +
					'    <div dojoAttachPoint = "environmentDiv">' +
                    '        <table border="0" dojoAttachPoint="environmentSelectorTable">' +
                    '            <tr>' +
                    '                <td valign="middle" nowrap><span dojoAttachPoint="environmentLabel" class="attributes-entry-label" style="color: black"></span></td>' +
                    '                <td valign="middle">' +
                    '                    <span dojoAttachPoint="environmentField" class="attributes-entry-value" style="color: gray"></span>' +
                    '                    <a href="" dojoAttachPoint="environmentLink">""</a>' +
                    '                </td>' +
                    '                <td><span dojoAttachPoint="environmentSelectorNode"></span></td>' +
                    '            </tr>' +
                    '        </table>' +                    
                    '        <table border="0" dojoAttachPoint="environmentCoverageTable">' +
                    '            <tr>' +
                    '                <td valign="middle" nowrap><span dojoAttachPoint="coverageLabel" class="attributes-entry-label" style="color: black"></span></td>' +
                    '                <td><span dojoAttachPoint="coverageButtonNode"></span></td>' +
                    '            </tr>' +
                    '        </table>' +
                    '        <table border="0" dojoAttachPoint="progressTable">' +
                    '            <tr>' +
					'                <td dojoAttachPoint="progressCellNode">'+
		            '                    <div dojoAttachPoint="progressIndicator" class="progress-indicator" style="display: none">' +
                    '                        <div class="view-progress-image">' +
                    '                            <span dojoAttachPoint="progressLabel" class="view-progress-label"></span>' +
                    '                        </div>' +
                    '                    </div>' +
				    '                </td>' +
                    '            </tr>' +
                    '        </table>' +					
                    '    </div>' +
                    '</div>',

                    

	widgetsInTemplate: true,
    
    //  ****** Parameters that can be set by clients   ******
    
	// the ID of the TestCell being edited.
	//Clients should initialize this on construction to open an existing Test Cell
	cellID: null,
	
	// indicator of whether the TestCell is being created (New) or not
	isNew: true,
	
	//id of a configuration to initialize the cell from.
	//This only applies if isNew == true
	testEnvironmentID: null,
    
    
	//Types of Test Cell
	PROVIDER_VIRTUAL_IMAGES: 1,		//Managed Externally 
	PROVIDER_VIRTUAL_MACHINES: 2,	//Managed Externally
	GENERIC_LAB_RESOURCES: 3,
	GENERIC_VIRTUAL_IMAGES: 4,

    
	constructor: function(args) 
	{    
		//Internal variables
		this._testCell = null;
		this._richTextEditor = null;//The Rich Text Editor widget
		this._initialized = false;	//Set to true when PostCreate is complete
		this._edited = false;		//Set to true when we catch a modification event	
		this._deleted = false;		//Set to true if we catch a global event that this Test Cell has been deleted
		this._requireTabUpdate = false;  //Flag so we know when to update the tab text.  For example when saving a new Test Cell
		this._testCellName = "";
		this._wasDirty = false;
		this._TestEnvironmentID = null;  //The ID of the Test Environment associated with the Test Cell
		this._TestEnvironment = null;  //The Test Environment associated with the Test Cell - this the Test Environment object
		this._rowIDCounter = 1;		//Counter used to generate temporary "IDs" for rows in the topology table
		this._LRDList = [];			//The list of Lab Resource Descriptions in the selecte Test Environment if any
		this.assetType = "Machine";  //The type of asset that can be referenced from the Test Cell
		this.testCellType = 3;  //this.GENERIC_LAB_RESOURCES;  //Default to generic (ie managed by RQM) Machine type
		this.owner = null;
		
		
/* Topology structure
    rowID - non-persistent row identifier
	lrdName - The name of the Lab Resource Description
	lrdTag - The ID of the LRD
	machineName - the Name of the Machine
	machineID - the ID of the machine
	note - a note about that row in the table
*/
		this.topologyData = [];
	},
    
    postCreate: function() 
    {
        this.inherited("postCreate", arguments);
		
		this._originalTestEnvironmentID = this.testEnvironmentID;   //Save this incase we were seeded with a Test Environment and the user discards changes.
        				
        //Set up the look of the header
        this.viewHeaderNode.setIconClass("testcell-icon-48");
        this.viewHeaderNode.setTypeLabel(RtlmUiUtil_getMessage("cellLabel"));
        this.viewHeaderNode.setNoValueEditableTitleLabel(RtlmUiUtil_getMessage("cellNewPrompt"));
		this.viewHeaderNode.setSummaryLabel(RtlmUiUtil_getMessage("reqLabel_summary"));
        this.ownerLabel.innerHTML = RtlmUiUtil_getMessage("jobOwner");
        this.environmentLabel.innerHTML = RtlmUiUtil_getMessage("cellTestEnvironment");
		this.assetTypeLabel.innerHTML = RtlmUiUtil_getMessage("cellAssetTypeLabel");    

		//Set Name and Summary change handlers
		this.viewHeaderNode.onTitleEdited = dojo.hitch(this, "nameChanged");
		this.viewHeaderNode.onSummaryEdited = dojo.hitch(this, "summaryChanged");
        

		//Create the save and discard changes buttons
        this.discardButton = this.viewHeaderNode.addRightViewAction(RtlmUiUtil_getMessage("discard_button"), dojo.hitch(this, "_onDiscardActionClick"), null, null);
        this.saveButton = this.viewHeaderNode.addRightViewAction(RtlmUiUtil_getMessage("save_button"), dojo.hitch(this, "_onSaveActionClick"), null, null);

        // relocate attributes into the header
        this.viewHeaderNode.getInfoAttributesNode().appendChild(this.attributeTable);
		
		//Create the Rich Text control for editing the description
		if (this._richTextEditor == null) 
		{
			this._richTextEditor = new TestCellEditor.RichTextControl({
				'inEditMode': false,
				'contentHTML': "",
				'save': dojo.hitch(this, "_onSaveActionClick")
			});

			dojo.connect(this._richTextEditor, "onChange", this, "descriptionChanged");
			this.descriptionNode.setDisplayTitle(RtlmUiUtil_getMessage("cellDescription"));
			this.descriptionNode.summaryNode.innerHTML = RtlmUiUtil_getMessage("cellDescriptionPrompt");
			this.descriptionNode.containerNode.appendChild(this._richTextEditor.domNode);
			this._richTextEditor.show();
		}
		
		this.connect(this.ownerSelector, "onchange", "ownerChanged");			
		
		// create the Environment section
		this._createEnvironmentSection();
		
		//create the availability section
		this._createAvailabilitySection();
		
		//Set up CSHelp
        this.viewHeaderNode.setCSHelpId("rtlm_cre_testcell.html", com.ibm.rational.test.lm.web.CSHelpID);
		this.viewHeaderNode.setCSHelpButtonLabel(RtlmUiUtil_getMessage("labelHelp", RtlmUiUtil_getMessage("labelNew"), RtlmUiUtil_getMessage("cellLabel")));
        
        //If new then we'll need a Tab update on a save
        this.requireTabUpdate = this.isNew;
        
		this._loadForm();
        
		this._updateButtonStatus();

        //Set initialized to true so that events will be processed
        this._initialized = true;
	},
	
	_loadForm: function()
	{
		if (this.isNew || this.cellID == null)
		{
			this._hideTELink();
			// for a new Test Cell set focus to the title
			this.viewHeaderNode.setEditableTitleFocus();
			
			if (this._originalTestEnvironmentID != null)  //seeded with a config
			{
				this._TestEnvironmentID = this._originalTestEnvironmentID;
				this._loadAndShowTE(this._originalTestEnvironmentID);
			}

		//Load the users into the owners combo box.
		this._loadOwnerControl();

		//Make sure form buttons are enabled/disabled appropriately			
		this._updateFormActions();
        }
		else
		{
			this._loadTestCell(this.cellID);
		}        		
	},
	
	_clearForm: function()
	{
		this._testCell = null;
		this._edited = false;		//Set to true when we catch a modification event	
		this._deleted = false;		//Set to true if we catch a global event that this Test Cell has been deleted
		this._requireTabUpdate = false;  //Flag so we know when to update the tab text.  For example when saving a new Test Cell
		this._testCellName = "";
		this._TestEnvironmentID = null;  //The ID of the Test Environment associated with the Test Cell
		this._TestEnvironment = null;  //The Test Environment associated with the Test Cell - this the Test Environment object
		this._rowIDCounter = 1;		//Counter used to generate temporary "IDs" for rows in the topology table
		this._LRDList = [];			//The list of Lab Resource Descriptions in the selecte Test Environment if any
		this.assetType = "Machine";  //The type of asset that can be referenced from the Test Cell
		this.testCellType = 3;  //this.GENERIC_LAB_RESOURCES;  //Default to generic (ie managed by RQM) Machine type
		
		this.viewHeaderNode.setTitle("");
		this.viewHeaderNode.setSummary("");
		this._richTextEditor.setContentHTML("");
		this._setTopology(null);		
	},
	
	_createEnvironmentButtons : function()
	{
		var args = {
			'showLabel': false,
			'label' : RtlmUiUtil_getMessage("cellSelectEnv"),
			'iconClass' : "addfromconfig-icon-image",
			'onClick' : dojo.hitch(this, "_onSelectEnvironment"),
			'class': "testcell-editor"
		};
        
		var selButton;
		selButton = new dijit.form.Button(args);
		this.environmentSelectorNode.appendChild(selButton.domNode);		
		
		args = {
			'showLabel': false,
			'label' : RtlmUiUtil_getMessage("cellClearEnv"),
			'iconClass' : "delete-icon-image",
			'onClick' : dojo.hitch(this, "_onClearEnvironment"),
			'class': "testcell-editor"
		};
        
		var clearButton;
		clearButton = new dijit.form.Button(args);
		this.environmentSelectorNode.appendChild(clearButton.domNode);
	},
	
	_createCoverageButton : function()
	{
		var args = {
			'showLabel': false,
			'label' : RtlmUiUtil_getMessage("cellAddMissingCoverage"),
			'iconClass' : "add-icon-image",
			'onClick' : dojo.hitch(this, "_updateCoverage"),
			'class': "testcell-editor"
		};
        
		this.coverageButton = new dijit.form.Button(args);
		this.coverageButtonNode.appendChild(this.coverageButton.domNode);		
	},
	
	_createEnvironmentSection : function()
	{
		//Set the title and summary of the section
        this.environmentNode.setTitle(RtlmUiUtil_getMessage("cellEnvironmentSection"));
		this.environmentNode.summaryNode.innerHTML = RtlmUiUtil_getMessage("cellEnvironmentPrompt");
		
		//show/hide the asset type controls appropriately
		if (this.isNew)
		{
			this.assetType = "Machine";  //Defaults to this but let's set it anyway
			this.assetTypeLabel.innerHTML = RtlmUiUtil_getMessage("cellAssetTypeLabel");
			this._loadAssetTypeControl();
			this.connect(this.assetTypeSelector, "onchange", "assetTypeChanged");			
		}
		else
		{
			this.assetTypeSelector.style.display = "none";
		}
		
		//create the envirionment selector button
		this._createEnvironmentButtons();
		
		//Create the coverage completion button.
		this._createCoverageButton();		
		
		this.environmentNode.containerNode.appendChild(this.environmentDiv);

        //Create the table of LRD-to machine associations
		this.assetTableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer();
		this.assetTableViewer.setContentProvider(new TestCellEditor.TableProvider(this));
		this.assetTableViewer.setContentPageSize(15);
		this.assetTableViewer.setTableRowsCheckable(true);
		this.assetTableViewer.setTableListener(new TestCellEditor.TableListener(this));
		this.assetTableViewer.setCellModifier(new TestCellEditor.CellModifier(this));

		//Add the table actions
        if (this._hasEditPermission()) 
        {
            this.assignMachinesButton = this.assetTableViewer.addAction("_assignMachines",
                RtlmUiUtil_getMessage("cellAssignMachines"), 
                null, //callback data
                "assignmachines-icon-image",
                dojo.hitch(this, "_onAssignMachines"));

            this.findMachineButton = this.assetTableViewer.addAction("_findMachine",
                RtlmUiUtil_getMessage("cellFindMachine"), 
                null, //callback data
                "search-icon-image",
                dojo.hitch(this, "_onFindMachine"));
				
            this.addRowButton = this.assetTableViewer.addAction("_addRow",
                RtlmUiUtil_getMessage("cellAddRow"), 
                null, //callback data
                "add-icon-image",
                dojo.hitch(this, "_onAddRowClick"));
                         
            this.removeRowButton = this.assetTableViewer.addAction("_removeRow", // action id
                RtlmUiUtil_getMessage("cellRemoveRow"), // label
                null, //callback data
                "delete-icon-image", //icon class
                dojo.hitch(this, "_onRemoveRowClick")); // callback
                
            this.findMachineButton.setDisabled(true);        
            this.removeRowButton.setDisabled(true);        
        }
		
  		this.environmentNode.containerNode.appendChild(this.assetTableViewer.domNode);

		this.assetTableViewer.setContent(this.topologyData);
		this._updateCoverageInfo();
		this.assetTableViewer.show();
	
	},

	//Create the section that shows the machine reservation status for all the machines referenced by the Test Cell.
	_createAvailabilitySection: function()
	{
		//Set the title and summary of the section
        this.availabilityNode.setTitle(RtlmUiUtil_getMessage("cellAvailabilitySection"));
		this.availabilityNode.summaryNode.innerHTML = RtlmUiUtil_getMessage("cellAvailabilityPrompt");

		this.scheduler = new com.ibm.asq.common.web.ui.internal.widgets.scheduler.Scheduler( { "entities": null, 
																							   "showentities": true, 
																							   "zoomlevel": "monthly",
																							   "showRefresh": true } );
		this.scheduler.addReserveClickListener( dojo.hitch( this, this.reserveMachines ) );
		this.scheduler.addRefreshClickListener( dojo.hitch( this, this._updateAvailability));

		if (!this._hasReservePermission())
			this.scheduler.hideReservationControls();
		
		this.availabilityNode.containerNode.appendChild( this.scheduler.domNode );
	},
	
	_loadTestCell: function(cellID)
	{
        this.viewHeaderNode.setProgressStart(LOADING, /*hideContent*/true);
        var responseHandler = new com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper(this, "_loadCellSuccess", "_loadCellFailure");
        var cellService = new com.ibm.rational.test.lm.web.client.internal.collections();
        
		cellService.getTestCell(responseHandler, cellID);
	},
	
	_loadCellSuccess: function(response)
	{
		this._testCell = response;
		this.cellID = response.itemId;
		this.stateId = response.stateId;
		this._testCellName = response.name;		
		
		//Set the name
		this.viewHeaderNode.setTitle(this._testCell.name);
		
		//set the type
		var typeString = this._getTypeName(this._testCell.instanceType.id);
		this.assetTypeField.innerHTML = typeString;
		
		//set the summary
		this.viewHeaderNode.setSummary(this._testCell.summary ? this._testCell.summary : "");
		
		this.owner = this._testCell.owner;

		//Load the users into the owners combo box.
		this._loadOwnerControl();

		//Set the owner into the owner selector
		this._setOwner(this._testCell.owner);
				
		//set the description
		if (this._richTextEditor)
			this._richTextEditor.setContentHTML(this._testCell.longDescription);
			
		//Set the Test Environment
		this._setTestEnvironment(this._testCell.testEnvItemId, this._testCell.testEnvName, this._testCell.testEnv, this._testCell.labResourceIds);	
		
		//Set the topologies
		this._setTopology(this._testCell.topologies);
		
		//Creater deploy/undeploy buttons if necessary
		this._addDeployButtons(this._testCell.instanceType.id);	

        this.viewHeaderNode.setProgressEnd();
		
		//Make sure form buttons are enabled/disabled appropriately
		this._updateFormActions();
		
		//Update the browser with the right title
		this._updateBrowserTitle();
		this._updateTabLabel();
	},
	
    _loadCellFailure: function(response)
    {
        var details = (response && response.message) ? response.message : null;
        
        this.viewHeaderNode.setProgressEnd();
        this.viewHeaderNode.setStatus(RtlmUiUtil_getMessage("fetchCellFailed"), ViewHeaderLayout.ERROR, details);  
        
        // call the common artifact data load error handler.  
        com.ibm.asq.common.web.ui.internal.util.Utility.handleArtifactLoadError(RtlmUiUtil_getMessage("cellLabel"), details);
    },
	
	_setOwner: function(owner)
	{
		if (owner)
			this.ownerSelector.value = owner.id;
	},
	
	_getOwner: function()
	{
		return this.ownerSelector.value;
	},
	
	_setType: function(cellType)
	{
		//Update the type string to indicate what assets can be in the cell
		this.assetTypeLabel.innerHTML = RtlmUiUtil_getMessage("cellKnownAssetTypeLabel", RtlmUiUtil_getMessage(this.assetType+"s"));	//+"s" finds the plural form or Machine or Virtual Machine

		//TODO disable functionality if this is a "Managed" Test Cell.
		if (this.isManaged())
		{
			this.updateUIForManagedCell();
		}		
	},
	
	_setTestEnvironment: function(teID, teName, teConfigString, lrdIDs)
	{
		if (teConfigString == null || teID == null || lrdIDs == null) //No config associated with the Test Cell 
		{
			this._TestEnvironment = null;
			this._TestEnvironmentID = null;
			this._LRDList = [];
			this._hideTELink();  //Shows the none-selected text rather than a link
		}
		else 
		{
			//Save the basic stuff
			this._TestEnvironmentID = teID;		
			this._TestEnvironment = theCatalog.createConfigurationFromJson(teConfigString);
			
			//Now get each Part within the Test Environment and create an array instance out of it
			var rootAttr = this._TestEnvironment.getRootAttribute();
			//Get the parts array
			var parts = rootAttr.getArrayValues();
			var nParts = parts.length;
			
			//Loop over each part and add the part to this._LRDList
			//The individual Lab Resource Descriptions in the list can be associated with a row in the topology table
			//Each Part has an associated ID in the this.lrdIDs array
			this._LRDList = [];
			for (var i = 0; i < nParts; i++) 
			{
				var partTag = parts[i].getTag();
				var partLabel = this._TestEnvironment.getLabelByTag(partTag);
				var theLRDID = lrdIDs[i];
				var LRDEntry = {
					lrdTag: partTag,
					lrdName: partLabel,
					lrdPart: parts[i],
					lrdID: theLRDID
				};
				this._LRDList.push(LRDEntry);

				//Show the Name as a link
				var TEhref = ConfigUriUtil.getEditConfigurationURI(teID);
				this._showTELink(teName, TEhref);
			}
			
		}
	},
	
	_setTopology: function(topologies)
	{
		//Initialize the topology data
		this.topologyData = [];
		
		//If there are topologies in the Test Cell
		if (topologies && topologies.length > 0)
		{
			//Get each one and build our internal data structure from it
			var len = topologies.length;
			for (var i = 0; i < len; i++)
			{
				var topology = topologies[i];
				var id = topology.resourceDescriptionId;
				
				//We only get the Lab Resource Description ID from the topology so we have
				//to find the details of the info from the Test Environment that we loaded previously 
				var lrdInfo = this._getlrdInfoByID(topology.resourceDescriptionId);
				var addValue = 
		    	{
					rowID : this._rowIDCounter++,  //our counter
					lrdID : id ? topology.resourceDescriptionId : null, //The ID of the Lab Resource Description
					lrdTag: id ? lrdInfo.lrdTag : "",  //If there is an associated Lab Resource Description then this is it's tag
					lrdName : id ? lrdInfo.lrdName : "",  //If there is an associated Lab Resource Description, then this is it's name
					lrdPart : id ? lrdInfo.lrdPart : null, //If there is an associated Lab Resource Description, then this is it's part
					machineID : topology.resourceId,  //The Machine ID
					machineName : topology.resourceName,  //The Machine Name
					note : topology.note				//The note
				};
				//Add the topology to the array
				this.topologyData.push(addValue);								
			}
		}
		//Show the topology info in the table
		this.assetTableViewer.setContent(this.topologyData);
		this.assetTableViewer.refresh();
		
		//Update the availability view
		this._updateAvailability();
		
		//update the coverage display
		this._updateCoverageInfo();        
	},
	
	//Given the ID of a Lab Resource Description, look for that id in our LRDlist
	//Assuming we find one (we should) get the name and tag out of the list.
	_getlrdInfoByID: function(id)
	{
		var retVal = {};
		if (id)
		{
			//Loop over all the LRDs looking for a match
			var len = this._LRDList.length;
			for (var i = 0; i < len; i++)
			{
				if (this._LRDList[i].lrdID == id)
				{
					var lrd = this._LRDList[i];
					retVal.lrdName = lrd.lrdName;
					retVal.lrdTag = lrd.lrdTag;
					retVal.lrdPart = lrd.lrdPart;
					break;
				}
			}
		}
		return retVal;
	},
	
	_getTypeName: function(typeID)
	{
		switch (typeID)
		{
			case 1:
				return RtlmUiUtil_getMessage("labelManagedVirtualImage");
			case 2:
				return RtlmUiUtil_getMessage("labelManagedVirtualMachine");
			case 3:
				return RtlmUiUtil_getMessage("MachTitleMachine");
			case 4:
				return RtlmUiUtil_getMessage("VirtualImage");
		}
		return "unknown";
	},
		
	updateUIForManagedCell: function()
	{
		this.assignMachinesButton.style.display = "none";
		this.findMachineButton.style.display = "none";
		this.addRowButton.style.display = "none";
		this.removeRowButtonstyle.display = "none";
	},
	
	//add buttons to the view to deploy or un-deploy based on the Test Cell type
	_addDeployButtons: function(cellType)
	{
		if( cellType == this.PROVIDER_VIRTUAL_MACHINES && this._hasDeployPermission)
			this.undeployButton = this.viewHeaderNode.addLeftViewAction(RtlmUiUtil_getMessage("Undeploy"), dojo.hitch(this, this._onUnDeployActionClick), null, "undeploy-icon-image");
		else if( cellType == this.PROVIDER_VIRTUAL_IMAGES && this._hasDeployPermission)
			this.deployButton = this.viewHeaderNode.addLeftViewAction(RtlmUiUtil_getMessage("Deploy"), dojo.hitch(this, this._onDeployActionClick), null, "configure-deploy-icon-image");
	},
	
	/*
	 *     ACTIONS 
	 */
	_onRemoveRowClick: function() 
	{
        var args = 
        {
            'message': RtlmUiUtil_getMessage("cellConfirmRemoveRow"),
            'yesCallback': 
                function(view) 
                {
                    view._removeRowAction();
                },
            'yesCallbackData': this,
            'noCallback': null,
            'noCallbackData': null
        };
        var confirmDialog = new com.ibm.asq.common.web.ui.internal.widgets.YesNoDialog(args);
        confirmDialog.setSecondaryTitle(RtlmUiUtil_getMessage("cellConfirmRemoveRowTitle"));
        confirmDialog.open();
    },
    
    _removeRowAction : function()
    {
        if(this.removeRowButton)
		    this.removeRowButton.setDisabled(true);
		var selectedAssets = this.assetTableViewer.getCheckedRows();
		var newData = [];
		if (selectedAssets.length > 0) 
		{
			var len = this.topologyData.length;
			for (var i = 0; i < len; i++)
			{
				var row = this.topologyData[i];
				var found = false;
				var selLen = selectedAssets.length;
				for (var j = 0; j < selLen; j++) 
				{
					var selectedRow = selectedAssets[j];
					if (row.rowID == selectedRow.rowID)
					{
						found = true;
						break;
					}
				}
				if (!found)
					newData.push(row);
			}
			this.topologyData = newData;
			this.assetTableViewer.setContent(this.topologyData);
			this.assetTableViewer.refresh();
			this._updateAvailability();
			this._attributeValueChanged();
			this._updateButtonStatus();			   	
		}
    },
    
    _onAddRowClick : function()
    {
    	var addValue = 
    	{
			rowID : this._rowIDCounter++,
			lrdName : "None",
			lrdTag: null,
			machineName : "",
			machineID : null,
			note : ""
		};
		this.topologyData.push(addValue);
//		this.assetTableViewer.setContent(this.topologyData);
		this.assetTableViewer.refresh();
		this._updateButtonStatus();			   	
    },
    
    _updateCoverage : function()
    {
    	//Add rows to the table for any LRDs that are not covered
		//Loop over the Test Environment
		var rowsAdded = false;
		var _LRDList = this._LRDList;
		var length = _LRDList.length;
        var topologyData = this.topologyData;
        var topoLength = topologyData.length; 
		
        for (var i = 0; i < length; i++)
		{
			var lrd = _LRDList[i];
			//Loop over all the rows in the topology table looking for a matching Lab Resource Description.
			//If no match is found, add a row to the table for the Lab Resource Description
			var found = false;
			for (var j = 0; j < topoLength; j++)
			{
				var rowData = topologyData[j];
				if (rowData.lrdID == lrd.lrdID)
				{
					found = true;
					break;
				}
			}
			//If not in the topology data then add it
			if (!found)
			{
		    	var addValue = 
		    	{
					rowID : this._rowIDCounter++,
					lrdName : lrd.lrdName,
					lrdTag :  lrd.lrdTag,
					lrdPart : lrd.lrdPart,
					lrdID : lrd.lrdID,
					machineName : "",
					machineID : null,
					note : ""
				};
				topologyData.push(addValue);
				rowsAdded = true;				
			}
		}
		//if we added rows then update the table
		if (rowsAdded)
		{
			this.assetTableViewer.setContent(this.topologyData);
			this.assetTableViewer.refresh();	
		}
    	
    	this.coverageButtonNode.style.display = "none";
		this.coverageLabel.innerHTML = RtlmUiUtil_getMessage("All Lab Resource Descriptions Covered");
		
		this._attributeValueChanged();
		this._updateButtonStatus();			   	
				
    },

	_onFindMachine : function()
	{
		//If there is a Lab Resource Description associated with the selected row then we need to create a Test Environment based on that Lab Resource Description.
		var selectedRows = this.assetTableViewer.getCheckedRows();
		var asset = null;
		var initialPart = null;
		if (selectedRows && selectedRows.length > 0) 
		{
			var row = selectedRows[0]; //Single select so 0 is the only one
			if (row.lrdTag != null) 
			{
				//Create a new "asset" and insert the selected part into it
				var asset = theCatalog.createConfiguration(this.assetType);
				var rootAtt = asset.getRootAttribute();
				//Remove the 0th element which is the existing part
				rootAtt.removeArrayValue(0);

				//Set the asset type into the lrdPart
//Need some way to search for Virtual Images based on a Machine Lab Resource Description.				
//				row.lrdPart.path = this.assetType;
//				row.lrdPart.templateObj.name = this.assetType;
//				row.lrdPart.templateObj.type = this.assetType;

				//Add in the new part
				rootAtt.addArrayValue(row.lrdPart);
			}
		}
		var title = RtlmUiUtil_getMessage("toolFindMach");
		this._machineSelectorDialog = new com.ibm.rational.test.lm.web.ui.internal.views.machines.AssetSelectorDialog({isSingleSelect:true, asset:asset, assetType:this.assetType, title:title});
		this._machineSelectorDialog.setOKAction(dojo.hitch(this,"_onFindMachineOK"));
		this._machineSelectorDialog.show();		
	},
	
	_onFindMachineOK : function()
	{
		//Get the info on the selected machine
		var machineArray = this._machineSelectorDialog.getSelectedAssetInfo();
		var assetType = this._machineSelectorDialog.getAssetType();
		
		if (machineArray && machineArray.length > 0) 
		{
			var machineInfo = machineArray[0];
			var selectedRows = this.assetTableViewer.getCheckedRows();
			if (selectedRows && selectedRows.length > 0) 
			{
				var rowID = selectedRows[0].rowID;
				
				//Loop over the topology data and update the machine ID and Name appropriately
				var len = this.topologyData.length;
				for (var i = 0; i < len; i++) 
				{
					var row = this.topologyData[i];
					if (row.rowID == rowID) 
					{
						row.machineID = machineInfo.id;
						row.machineName = machineInfo.name;
						row.machineType = assetType;
						break;
					}
				}
				this.assetTableViewer.refresh();
				this._updateAvailability();
				this._attributeValueChanged();
				this._updateButtonStatus();			   				
			}
		}		
	},
	
	_onAssignMachines: function()
	{
//	   	var responseHandler = new ServiceResponseHandler(this, "_machineSearchSuccess", "_machineSearchError");

		//Loop over all the rows looking for a machine that matches the Lab Resource Description
		//Hack counter till we get the right back end method
		this.searchCounter = 0;
		var len = this.topologyData.length;
		for (var i = 0; i < len; i++) 
		{
			var row = this.topologyData[i];
			if (row.machineID == null) 
				this.searchCounter++;
		}

		for (var i = 0; i < len; i++) 
		{
			var row = this.topologyData[i];
			if (row.machineID == null)
			{
				this._setProgressStart( RtlmUiUtil_getMessage("Processing"));		
				var asset = theCatalog.createConfiguration(this.assetType);
				if (row.lrdPart != null)
				{
					var rootAtt = asset.getRootAttribute();
					//Remove the 0th element which is the existing part
					rootAtt.removeArrayValue(0);

					//Add in the new part
					rootAtt.addArrayValue(row.lrdPart);
				}
				var searchColumns = "";
				
				if (this.assetType == "Machine")
					searchColumns = "machine.id, machine.name";
				else
					searchColumns = "VirtualImage.id, VirtualImage.name";
					
				var searchParam = {
                    configuration: asset,
                    columns: ( searchColumns )
                };
				var self = this;
				var rowCounter = i;
				var handler = new TestCellEditor.AssignHandler(this, i);
			   	var responseHandler = new ServiceResponseHandler(handler, "success", "error");

		        theCatalog.search(responseHandler, searchParam);
			}
		}
	},
	
	_machineSearchSuccess: function(response, row)
	{
		if (response.Data && response.Data.length > 0)
		{
			var row = this.topologyData[row];
			if (row.machineID == null) 
			{
				row.machineID = response.Data[0][0];
				row.machineName = response.Data[0][1];
				row.machineType = this.assetType;
			}
				
			this.assetTableViewer.refresh();
		}	

		//Hack using counter till we get the right back end method
		this.searchCounter--;
		if (this.searchCounter == 0) 
		{
			this._updateAvailability();
			this._updateButtonStatus();			   					
			this._setProgressEnd();
		}
	},
	
	_machineSearchError: function(response)
	{
    	var details = (response && response.message) ? response.message : null;
        
        this._setProgressEnd();
        this.viewHeaderNode.setStatus(RtlmUiUtil_getMessage("reqMsgNoMachineFoundErr"), ViewHeaderLayout.ERROR, details);  
	},
	
	nameChanged : function(value)
	{
		
		var oldvalue = this.configName;
		//remember the new name
		this._testCellName = value;
		
		//handle changes - mark dirty, etc.
		this._attributeValueChanged();
		
		//we'll need to update the tab label (add asterisk, etc.)
        this._requireTabUpdate = true;

		if(!this._edited)
			this._edited = ( oldvalue != value );
	},
	
	//Handle a change to the summary
	summaryChanged : function(value)
	{
		this._attributeValueChanged();
	},
		
	// process description changes
	descriptionChanged: function()
	{
		this._attributeValueChanged();		
	},
	
    // process change events.
    _attributeValueChanged: function()
    {
    	// If not done initializing the form, or
        // we're currently saving the content, 
        // then ignore the event. 
        // We could still receive changed event while
        // we're saving. The summary field would report
        // the last changed event when it lost focus
        // (the save button is clicked).
		if (!this._initialized || this._saving)
			return;
        
        //remember that the Test Cell has been edited
        this._edited = true;			
        
        // something changed. Enable the save button and clear and status.
        this._updateFormActions();
		this._updateTabLabel();
		this._updateCoverageInfo();        
    },

	assetTypeChanged: function()
	{
		var newType = this.assetTypeSelector.options[this.assetTypeSelector.selectedIndex].value;
		if (this.assetType != newType)
		{
			this.assetType = newType;
			this._clearAllMachines();
			//hide the availability section if the type is virtual image since we do not allow reservations on Virtual Images
			if (this.assetType == "VirtualImage") 
			{
				this.previousStyle = this.availabilityNode.domNode.style.display;
				this.availabilityNode.domNode.style.display = "none";
				this.testCellType = this.GENERIC_VIRTUAL_IMAGES;
			}
			else 
			{
				this.availabilityNode.domNode.style.display = this.previousStyle;
				this.testCellType = this.GENERIC_LAB_RESOURCES;
			}
		}
		
	},
	
	ownerChanged: function()
	{
		//Nothing to do but update the dirty flag and such.
		this._attributeValueChanged();
	},
	        
    _updateFormActions: function()
    {
        if (this._deleted)
            return;
            
        var msg = null;
        var hasRequired = this._hasRequired();

        // don't enable the save button if there's no editing, or doesn't have require
        // field, or the form has error.
        var hasEditPerm = this._hasEditPermission();
        
        //Enable/disable buttons based on the current state
        this.saveButton.setDisabled((!hasEditPerm || !this._edited || !hasRequired || this._saving));
        this.discardButton.setDisabled((!hasEditPerm || !this._edited || this._saving));
        
        if (!hasEditPerm) 
        {
            msg = RtlmUiUtil.getCommonMessage("statusNoEditPerm");
            var details = RtlmUiUtil.getCommonMessage("msgNoEditPermDetails", RtlmUiUtil_getMessage("cellLabel"));
            this.viewHeaderNode.setStatus(msg, ViewHeaderLayout.WARNING, details);
        }
        else 
        {
            if (!hasRequired && this._edited)
            { 
                msg = RtlmUiUtil_getMessage("cellRequireNameError");
                this.viewHeaderNode.setStatus(msg, ViewHeaderLayout.WARNING);
            }
            else 
                if (this._edited) 
                {
                    var msgId = (this.isNew && !this._wasDirty) ? "saveNewReminderMsg" : "saveChangeReminderMsg";
					if(!this._wasDirty){//Only affective for new unsaved test cells.
						this._wasDirty = true;
					}
                    msg = RtlmUiUtil_getMessage(msgId);
                    this.viewHeaderNode.setStatus(msg, ViewHeaderLayout.INFO);
                }
                else 
                {
                    this.viewHeaderNode.clearStatus();
                }
        }
    },
    
	isDirty: function(){
		return this._edited;
	},

	_updateTabLabel: function()
	{
		if (!this.isNew)  //don't update the tab label for "New" configs
			dojo.publish(GlobalEvents.UpdateTabLabel, [window.location.hash, this._testCellName, "testcell-icon-16", this._edited]);            
	},
	
	_updateCoverageInfo : function()
	{
		//Update the coverage label and show/hide the update button as appropriate
		//If there is no associated Test Environment then hide the Test Environment coverage info
		if (this._TestEnvironment == null) {
			this.coverageLabel.style.display = "none"
			this.coverageButtonNode.style.display = "none";
			
		}
		else {
			//Loop over all the LRDs to make sure there is a row for them
			var notCoveredCount = 0;
			var len = this._LRDList.length;
			var topologyLen = this.topologyData.length;
			for (var i = 0; i < len; i++) 
			{
				var lrd = this._LRDList[i];
				var lrdTag = lrd.lrdTag;
				
				//Loop over all the rows in the topology table looking for a matching Lab Resource Description.
				//If no match is found, add a row to the table for the Lab Resource Description
				var found = false;

				for (var j = 0; j < topologyLen; j++) 
				{
					var rowData = this.topologyData[j];
					if (rowData.lrdTag == lrdTag) 
					{
						found = true;
						break;
					}
				}
				//If not in the topology data then add it
				if (!found) {
					notCoveredCount++;
				}
			}
			//If at least one is not covered then show that and display the add button
			//else indicate all are covered and hide the button
			if (notCoveredCount > 0) 
			{
				var coverString = RtlmUiUtil_getMessage("cellNotAllCovered", this._LRDList.length - notCoveredCount, this._LRDList.length);
				this.coverageLabel.style.display = "inline";
				this.coverageLabel.innerHTML = coverString;
				if (!this.isManaged())  //if managed,never show the update coverage button
					this.coverageButtonNode.style.display = "inline";
			}
			else 
			{
				var coverString = RtlmUiUtil_getMessage("cellAllCovered");
				this.coverageLabel.style.display = "inline";
				this.coverageLabel.innerHTML = coverString;
				this.coverageButtonNode.style.display = "none";
			}
		}
	},
	


    _hasRequired: function()
    {
        return (this._testCellName && this._testCellName.length > 0);
    },
    
    //TODO Add permission settings for Test Cells?
    _hasEditPermission: function()
    {
        var perm = PermissionsClient.getStoredPermission(PermissionsClient.OP_LM_TEST_ENVIRONMENT);  
        return (!perm || perm[PermissionsClient.ACTION_EDIT]);           
    },
    
    _hasReservePermission: function()
    {
        var perm = PermissionsClient.getStoredPermission(PermissionsClient.OP_LM_RESERVATION);  
        return (!perm || perm[PermissionsClient.ACTION_CREATE]);           
    },
	
	_onSaveActionClick: function()
	{
        this._saving = true;
        this.viewHeaderNode.setProgressStart(SAVING, /*hideContent*/false);
        this.discardButton.setDisabled(true);
        this.saveButton.setDisabled(true);
		
        var responseHandler = new com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper(this, "_saveCellSuccess", "_saveCellFailure");
        var cellService = new com.ibm.rational.test.lm.web.client.internal.collections();
		
		var name = this._testCellName;
		var description = this.viewHeaderNode.getSummary();
		var testEnvironmentID = this._TestEnvironmentID;
		var instanceType = this.testCellType;
		var owner = this._getOwner();
		var longDescription = this._richTextEditor.getContentHTML();
		
		//Loop over the topology data building up the arrays of info
		var topologyResourceIDs = [];
		var topologyResourceDescriptionIDs = [];
		var topologyNotes = [];
		
		var len = this.topologyData.length;
		for (var i = 0; i < len; i++)
		{
			var row = this.topologyData[i];
			var machineID = row.machineID;
			if (machineID == null)	//Each topology row MUST have a machine ID
				continue;
			var lrdID = row.lrdID ? row.lrdID : cellService.getNullId();  //Can't pass nulls so use a special ID that indicates no referenced Lab Resource Description
			var note = row.note;
			topologyResourceIDs.push(machineID);
			topologyResourceDescriptionIDs.push(lrdID);
			topologyNotes.push(note ? note : "");
		}

		if (this.isNew)        
			cellService.createTestCell(responseHandler, name, description, testEnvironmentID, instanceType, owner, longDescription, topologyResourceIDs, topologyResourceDescriptionIDs, topologyNotes);
		else
			cellService.updateTestCell(responseHandler, this.cellID, this.stateId, name, description, testEnvironmentID, owner, longDescription, topologyResourceIDs, topologyResourceDescriptionIDs, topologyNotes);
    
	},
	
	_saveCellSuccess: function(response)
	{
        this._saving = false;
		this._testCell = response;
		this.viewHeaderNode.setProgressEnd();
		this._edited = false;
		this._updateTabLabel();	
				

        var msg = RtlmUiUtil_getMessage("savedSuccessMsg", RtlmUiUtil.getCurrentTimeString());
        this.viewHeaderNode.setStatus(msg, ViewHeaderLayout.SUCCESS);
        
        if (this.isNew) 
		{
            this.isNew = false;
            this.cellID = response.itemId;
			this.stateId = response.stateId;
            
            // update our URI
            dojo.publish(GlobalEvents.UpdateTabUri, [window.location.hash, TestCellUriUtil.getEditTestCellURI(this.cellID)]);
            dojo.publish(GlobalEvents.ArtifactsAdded, [ RtlmUiUtil.TYPE_TEST_CELL, [ this._testCell ], TestCellUriUtil.getEditTestCellURI(this.cellID) ]);
        } 
		else 
		{
            dojo.publish(GlobalEvents.ArtifactsUpdated, [ RtlmUiUtil.TYPE_TEST_CELL, [ this._testCell ], TestCellUriUtil.getEditTestCellURI(this.cellID) ]);
        }
		
		this._updateTabLabel();
		this._updateBrowserTitle();		
	},
	
	_saveCellFailure: function(response)
	{
        this._saving = false;
        var details = (response && response.message) ? response.message : null;
        
        this.viewHeaderNode.setProgressEnd();
        this.viewHeaderNode.setStatus(RtlmUiUtil_getMessage("errSavingTestCell"), ViewHeaderLayout.ERROR, details);
		this.viewHeaderNode.setProgressEnd();					
	},
    
	_onDiscardActionClick: function()
	{
        var args = {
            'message': RtlmUiUtil_getMessage("confirmDiscard"),
            'yesCallback': 
                function(view) {
			    	view._clearForm();
					view._loadForm();
                },
            'yesCallbackData': this,
            'noCallback': null,
            'noCallbackData': null
        };
        var confirmDialog = new com.ibm.asq.common.web.ui.internal.widgets.YesNoDialog(args);
        confirmDialog.setSecondaryTitle(RtlmUiUtil_getMessage("confirmDiscardTitle"));
        confirmDialog.open();		
	},

	_onSelectEnvironment : function()
    {
		this.selectDlg = new com.ibm.rational.test.lm.web.ui.internal.views.configurations.TESelectorDialog({title:RtlmUiUtil_getMessage("cellSelectEnv")});
		this.selectDlg.setOKAction( dojo.hitch( this, this._handleSelectOK ) );		
		this.selectDlg.show();				
    },
    
	
	_onClearEnvironment : function()
	{
		this._hideTELink();
		this._TestEnvironment = null;
		this._TestEnvironmentID = null;
		this._LRDList = [];
		this._clearAllLRDReferences();
		this._attributeValueChanged();
	},

	
	//Handle the change of the referenced Test Environment
    _handleSelectOK :function()
    {
		var newTestEnvironment = this.selectDlg.getSelectedItems()[0];
		
		//error case where the user didn't select anything.  Should never happen but check anyway
		if (newTestEnvironment == null)
			return;

		//Get the ID of the selected Test Environment.  We'll use this to load the Test Environment			
		var theID = newTestEnvironment.id;
		
		//if the user selected the same Test Environment then just return
		if (this._TestEnvironmentID == theID)
			return;

		//Load the details of the selected Test Cell
        var TEs = new com.ibm.rational.test.lm.web.client.internal.config();
        var responseHandler= new com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper(this, "_loadTESuccessHandler", "_loadTEErrorHandler");
		
		TEs.retrieveConfigurationWithDetails(responseHandler, theID);
    },

	_loadTESuccessHandler: function(response)
	{
       	this.viewHeaderNode.setProgressEnd();						
		if (response) 
		{
			//Save the ID of the selected Test Environment
			this._TestEnvironmentID = response.id;
			
			//Get the Test Environment specification JSon string
			var TEString = response.configuration;
			if (TEString) 
			{
				this._TestEnvironment = theCatalog.createConfigurationFromJson(TEString);
			}
			else //Kind of an error condition.  The user selected a Test Environment but the Test Environment has no real environment spec string so use an empty one
				this._TestEnvironment = theCatalog.createConfiguration(this.assetType);

			//Get the resource descriptions
			this.lrdIDs = response.resourceDescriptionIds;

			//update the table based on the new Test Environment
			this._TEChanged();
			
			//Show the Name as a link
			var TEName = response.name;
			var TEhref = ConfigUriUtil.getEditConfigurationURI(response.id);
			this._showTELink(TEName, TEhref);
						
			this._attributeValueChanged();
		}
		
	},

    _loadTEErrorHandler :function(errorType, errorMessage)
    {
        this.viewHeaderNode.setProgressEnd();					        
    },


	_onDeployActionClick: function()
	{
		this.deployButton.setDisabled(true);
		this.viewHeaderNode.setProgressStart(RtlmUiUtil_getMessage("labelDeployingVICollection"));
        
		var responseHandler = new ServiceResponseHandler(this, "_deployUndeployResult", "_deployUndeployResult");
		var inventoryService = new com.ibm.rational.test.lm.web.client.internal.inventory();

		inventoryService.deployVirtualCollection(responseHandler, this.cellID);
	},
	
	_onUnDeployActionClick: function()
	{
		this.undeployButton.setDisabled(true);
		this.viewHeaderNode.setProgressStart(RtlmUiUtil_getMessage("labelUndeployingVMCollection"));
        
		var responseHandler = new ServiceResponseHandler(this, "_deployUndeployResult", "_deployUndeployResult");
        var inventoryService = new com.ibm.rational.test.lm.web.client.internal.inventory();

		inventoryService.undeployVirtualCollection(responseHandler, this.cellID);
	},	
	
	_deployUndeployResult: function (successResponse) 
	{
		var successful = true;
		var statusMessage = "";
		if(successResponse && (successResponse.rc == "SPIRC_NO_ERROR")) 
		{
			successful = true;
			statusMessage = RtlmUiUtil_getMessage(this._testCell.instanceType.id == this.PROVIDER_VIRTUAL_IMAGES ? "msgDeployedTestCell" : "msgUndeployedTestCell");			
		}
		else
		{
			successful = false;
			statusMessage = RtlmUiUtil_getMessage(this._testCell.instanceType.id == this.PROVIDER_VIRTUAL_IMAGES ? "msgErrDeployedTestCell" : "msgErrUndeployedTestCell");			
		}

		this.viewHeaderNode.setStatus(statusMessage, successful ? ViewHeaderLayout.SUCCESS : ViewHeaderLayout.ERROR);
        
		this.viewHeaderNode.setProgressEnd();

		if (this.deployButton)
			this.deployButton.setDisabled(false);

		if (this.undeployButton)
			this.undeployButton.setDisabled(false);
            
		// bring up the deployment page, seed it with deploy directive.
		dojo.setObject( "com.ibm.rational.test.lm.web.deployCollection", "true" );
		window.location.href = AssetUriUtil.getDeployViewURI();
	},

	
	
	_updateBrowserTitle: function(){
		if (this.page) 
		{
			var	name ;
			if (this.isNew) 
			{
				name = RtlmUiUtil_getMessage("labelCapitalNew");
			}
			else 
			{
				name = this._testCellName;
			}
			this.page.browserTitle = RtlmUiUtil_getMessage("pageTitleTestCell", name);
			net.jazz.ajax.ui.PlatformUI.getWorkbench().setTitle(this.page.browserTitle );
			net.jazz.ajax.ui.PlatformUI.getWorkbench().browserTitle = this.page.browserTitle;
		}
	},
	
	_loadOwnerControl: function()
    {
		var users = com.ibm.rational.test.lm.web.client.internal.RtlmInitializer.getUsers();
    	
		var pos = 0;

		if(users && users.length > 0) 
		{
			var len = users.length;
			var ownerName = this.owner ? this.owner.name : null;
			for (var i = 0; i < len; i++) 
			{
				var user = users[i];
				//Don't include archived users UNLESS the archived user is the current owner
				if (user.archived)
				{
					if (user.name != ownerName)
						continue;
				}

				var option = new Option(user.name, user.itemId);
				option.disabled = user.archived;
				this.ownerSelector.options[pos] = option;

				pos++;
			}
		}

		this.ownerSelector.selectedIndex = -1;
	},
	
	_loadAssetTypeControl: function()
	{
		var option = new Option(RtlmUiUtil_getMessage("Machine"), "Machine");
		option.selected = true;
		this.assetTypeSelector.options[0] = option;
		option = new Option(RtlmUiUtil_getMessage("VirtualImage"), "VirtualImage");
		this.assetTypeSelector.options[1] = option;
	},
	
	_clearAllMachines: function()
	{
		//Clear out the associated Lab Resources from the existing rows.
		var len = this.topologyData.length;
		for (var i = 0; i < len; i++)
		{
			this.topologyData[i].machineID = null;
			this.topologyData[i].machineName = "";
		}
		
		this._updateAvailability();
		this.assetTableViewer.refresh();		
	},
    
	
	_loadAndShowTE: function(testEnvironmentID)
	{
        var TEs = new com.ibm.rational.test.lm.web.client.internal.config();
        var responseHandler= new com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper(this, "_loadTESuccessHandler", "_loadTEErrorHandler");

        this.viewHeaderNode.setProgressStart(LOADING, /*hideContent*/false);
    
        TEs.retrieveConfigurationWithDetails(responseHandler, testEnvironmentID);
		
	},

	_TEChanged: function()
	{
		//Clear out the associated Lab Resource Descriptions from the existing rows.
		var len = this.topologyData.length;
		for (var i = 0; i < len; i++)
		{
			this.topologyData[i].lrdName = "";
			this.topologyData[i].lrdTag = "";
		}
		
		//Now get each Part within the Test Environment and create an array instance out of it
		var rootAttr = this._TestEnvironment.getRootAttribute();
		//Get the parts array
		var parts = rootAttr.getArrayValues();
		var nParts = parts.length;
		
		//Loop over each part and add the part to this._LRDList
		//The individual Lab Resource Descriptions in the list can be associated with a row in the topology table
		//Each Part has an associated ID in the this.lrdIDs array
		this._LRDList = [];
		for (var i = 0; i < nParts; i++) 
		{
			var partTag = parts[i].getTag();
			var partLabel = this._TestEnvironment.getLabelByTag(partTag);
			var theLRDID = this.lrdIDs[i];
			var LRDEntry = {lrdTag:partTag, lrdName:partLabel, lrdPart:parts[i], lrdID:theLRDID};
			this._LRDList.push(LRDEntry);
		}
		
		//If there are no rows in our topology table then automatically create them based on the new Test Environment
		if (this.topologyData.length == 0)
			this._createRowsForTheTE();
		else
			this.assetTableViewer.refresh();
			
		this._updateButtonStatus();
	},
		
	getLRDsForTable: function()
	{
		return this._LRDList;
	},
	
	_createRowsForTheTE: function()
	{
		//Add a new row to the topologyData for each entry in the Lab Resource Description list and redisplay the table
		var len = this._LRDList.length;
		for (var i = 0; i < len; i++)
		{
			var lrd = this._LRDList[i];
			var addValue = 
	    	{
				rowID : this._rowIDCounter++,
				lrdName : lrd.lrdName,
				lrdTag: lrd.lrdTag,
				lrdPart: lrd.lrdPart,
				lrdID: lrd.lrdID,
				machineName : "",
				machineID : null,
				note : ""
			};
			this.topologyData.push(addValue);
		}
		this.assetTableViewer.setContent(this.topologyData);
		this.assetTableViewer.refresh();
	},
	
	//Show a link to the associated Test Environment
	_showTELink: function(name, href)
	{
		this.environmentField.style.display = "none";
		this.environmentLink.style.display = "inline";
		this.environmentLink.innerHTML = name;
		this.environmentLink.href = href;
	},
	
	//Hide the link to the Test Environmentand show the "no environment" label
	_hideTELink: function(displayText)
	{
		this.environmentField.style.display = "inline";
		this.environmentLink.style.display = "none";
		this.environmentField.innerHTML = displayText != null ? displayText : RtlmUiUtil_getMessage("cellNoEnvironment");		
	},
	
	//Remove any Lab Resource Descriptions associated with any rows in the topology table
	_clearAllLRDReferences: function()
	{
		var len = this.topologyData.length;
		for (var j = 0; j < len; j++) 
		{
			var rowData = this.topologyData[j];
			rowData.lrdTag = null;
			rowData.lrdName = "None";
			rowData.lrdID = null;
		}
		this.assetTableViewer.refresh();		
	},
	
	//Given the Lab Resource Description tag and the Row ID from the topology table, update that row with the new Lab Resource Description association.
	updateLRDforRow: function(id, rowID)
	{
		var found = false;
		var lrdName = null;
		var lrdPart = null;
		var lrdID = null;
		var lrdTag = null;
		
		//if the tag is the "none" tag then just set found to true, no need to search
		if (id == -1) 
		{
			found = true;
			lrdName = "None";
			lrdID = null;
			lrdTag = null;
		}
		else 
		{
			//Need to loop over ALL the lrds to get the name and the part information
			var len = this._LRDList.length;
			for (var i = 0; i < len; i++) 
			{
				var lrd = this._LRDList[i];
				if (lrd.lrdID == id) //If the id matches then save the name and part
				{
					lrdName = lrd.lrdName;
					lrdPart = lrd.lrdPart;
					lrdID = lrd.lrdID;
					lrdTag = lrd.lrdTag;
					found = true;
					break;
				}
			}
		}
		//If we found a matching Lab Resource Description then set it into the appropriate row
		if (found) 
		{
			//Loop over all the rows in the topology table looking for a matching rowID.
			//when we find the match, update the lrdTag and lrdName
			var topoLen = this.topologyData.length;
			for (var j = 0; j < topoLen; j++) 
			{
				var rowData = this.topologyData[j];
				if (rowData.rowID == rowID) 
				{
					rowData.lrdTag = lrdTag;
					rowData.lrdName = lrdName;
					rowData.lrdPart = lrdPart;
					rowData.lrdID = lrdID;
					break;
				}
			}
			//Update the table with the new data
			this.assetTableViewer.refresh();				
	        this._attributeValueChanged();
		}
	},
	
	updateNote: function(note, rowID)
	{
		//Loop over all the rows in the topology table looking for a matching rowID.
		//when we find the match, update the note
		var len = this.topologyData.length;
		for (var j = 0; j < len; j++) 
		{
			var rowData = this.topologyData[j];
			if (rowData.rowID == rowID) 
			{
				rowData.note = note;
				break;
			}
		}
		this._attributeValueChanged();
	},
		
	_updateAvailability: function()
	{
		var machine = new com.ibm.rational.test.lm.web.client.internal.machine();
		var responseHandler= new com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper(this, "_loadAvailabilityTable", "_machineReservationLoadError");
        
		this.scheduler.clear();
		var len = this.topologyData.length;
		for (var j = 0; j < len; j++) 
		{
			var rowData = this.topologyData[j];
			
			if (rowData.machineID)			
			{
				var machineLink = AssetUriUtil.getViewAssetDetailURI(this.assetType, rowData.machineID);
				var machineEntity = {name:rowData.machineName, id:rowData.machineID, link:machineLink};
				this.scheduler.addEntity(machineEntity);

				machine.getReservationsFromMachine(responseHandler, rowData.machineID);
			}
		}
	},
	
	_loadAvailabilityTable: function(response)
	{
		if (response) 
		{			
			for (var iReservation = 0; response && (iReservation < response.length); iReservation++) 
			{
				var reservation = response[iReservation];
				var machine = theCatalog.createAssetFromJson(reservation.configuration);
				var machineName = machine.getRoot().getAttributeValue("name");
				var machineID = machine.getId();
				var machineEntity = {id:machineID, name:machineName};
				var util = com.ibm.asq.common.web.ui.internal.widgets.tableViewer.Util;
				var start = util.convertTimeStampToDate(reservation.reserveFrom);
				var end = util.convertTimeStampToDate(reservation.reserveTo);
				var resBy = reservation.reservedBy ? reservation.reservedBy.name : null;
				var resFor = reservation.reservedFor ? reservation.reservedFor.name : null;
				
				this.scheduler.reserve(machineEntity, start, end, false, resBy, resFor);
			}
		}		
		this.scheduler.update();  
	},
	
	_machineReservationLoadError: function(responseHandler)
	{
		this.viewHeaderNode.setStatus(RtlmUiUtil_getMessage("userHmFailGetMyReservations"));
	},
	
	reserveMachines: function(startTime, endTime)
	{
		//Hack, count the reservations to be made until we have the back end service to do them all at once
		this.reservationsCounter = 0;
		var len = this.topologyData.length;
		for (var i = 0; i < len; i++) 
		{
			var rowData = this.topologyData[i];
			
			if (rowData.machineID) 
				this.reservationsCounter++;
		}		
		
		var transportService = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
		for (var j = 0; j < len; j++) 
		{
			var rowData = this.topologyData[j];
			
			if (rowData.machineID)
			{
				var reservations = new com.ibm.rational.test.lm.web.client.internal.reservations();

				if (this._validateDates(startTime, endTime)) 
				{
					var responseHandler = new transportService(this, "_reserveSuccess", "_reserveError");
					reservations.fillReservationGaps(responseHandler, rowData.machineID, startTime.getTime(), endTime.getTime(), false);
				}
			}
		}
	},
	
	_validateDates :function(fromDate, toDate)
	{
		if (fromDate == null || toDate == null)
			return false;

		var fromDateLong = fromDate.getTime();
		var toDateLong = toDate.getTime();
		
		if (fromDateLong == null || toDateLong == null)
			return false;
		
		if (fromDateLong >= toDateLong)
			return false;
			
		return true;
	},
	
	_reserveSuccess:function(response)
	{
		this.reservationsCounter--;
		if (this.reservationsCounter == 0) 
		{
			this.scheduler.onFinishReservation();
			this._updateAvailability();
		}
	},
	
	_reserveError:function(response)
	{
		this.viewHeaderNode.setStatus("_reserveError");
		this.reservationsCounter--;
		if (this.reservationsCounter == 0) 
		{
			this.scheduler.onFinishReservation();
			this._updateAvailability();
		}
	},
	
	// show the in-progress indicator and hide the title
    //
    _setProgressStart: function(message) 
	{
        this.progressLabel.innerHTML = message;
        this.progressIndicator.style.display = "inline";
    },
    
    // restore the title and hide the in-progress indicator
    //
    _setProgressEnd: function() 
	{
        this.progressLabel.innerHTML = "";
        this.progressIndicator.style.display = "none";
    },
	
	_updateButtonStatus: function()
	{
		var checkedRows = this.assetTableViewer.getCheckedRows();
		
		if (!this.isManaged())  //If this is a managed Test Cell then the buttons are hidden so don't bother with this logic 
		{
			this.removeRowButton.setDisabled(checkedRows.length == 0); //Need at least one row checked for Remove to be enabled
			this.findMachineButton.setDisabled(checkedRows.length != 1); //single row for find machine
			//Enable the assign all button if there is at least one row in the topology table without a machine assigned to it
			var disable = true;
			var len = this.topologyData.length;
			for (var j = 0; j < len; j++) 
			{
				var rowData = this.topologyData[j];
				
				if (!rowData.machineID) 
				{
					disable = false;
					break;
				}
			}
			this.assignMachinesButton.setDisabled(disable);
		}
				
	},
	
	isManaged: function()
	{
		return (this._testCell != null && (this._testCell.instanceType.id == this.PROVIDER_VIRTUAL_IMAGES || this._testCell.instanceType.id == this.PROVIDER_VIRTUAL_MACHINES)); 
	},
	
    _hasDeployPermission: function()
    {
        var perm = PermissionsClient.getStoredPermission(PermissionsClient.OP_LM_VIRTUALIZATION);  
        return (!perm || perm[PermissionsClient.ACTION_DEPLOY]);   
    }	        
});


// Summary:
//    Create a subclass of the rich text control to add reporting back onChange events.
//
dojo.declare("TestCellEditor.RichTextControl", 
    [com.ibm.asq.common.web.ui.internal.widgets.richtext.RichTextControl],
{   
    initOnChange: false,
     
    _doEdit: function() 
	{
        this.inherited("_doEdit", arguments);
        
        if(!this.initOnChange && this._editor) 
		{
            this.initOnChange = true;
            
            var self = this;
            this._editor.onChange = function() {
                self.onChange();
           }
        }
    },

    onChange: function() {
        
    }
});


dojo.declare("TestCellEditor.TableProvider", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider,
{
	_parentView: null,
	
	constructor: function(parentView) 
	{
		this._parentView = parentView;
	},
	
    getNumColumns: function(content) 
    {
        return 4;
    },
	
    getColumnHeading: function(content, atColumnIndex) 
    {
        var headings = 
        [
			"",  //No header for the type column
            RtlmUiUtil_getMessage("cellResourceName"),
            RtlmUiUtil_getMessage("cellLRDName"),
            RtlmUiUtil_getMessage("cellNote")
        ];
        return headings[atColumnIndex];
    },

    getColumnHeadingImage: function(content, atColumnIndex) 
    {
        return null;
    },
    
    getIsColumnGroupable: function(content, atColumnIndex) 
    {
        return false;     
    },

    getIsColumnSortable: function(content, atColumnIndex) 
    {
    	//Sort by the LRD Name and Machine Name columns
		return (atColumnIndex == 1);
    },
    
    getColumnWidth: function(content, atColumnIndex) 
    {
        var columnWidth = 
        [
			5,	// "Type"
            20,	// "Machine",
            20, // "LRD",
            60	// "note",
        ];
        return columnWidth[atColumnIndex];
    },
    
    getContentObjects: function(content) 
    {
        // the groups data is already an array
        return content;
    },
    
    getRowDataId: function(rowData) 
    {
        return( rowData.rowID );
    },

    getCellDisplayType: function(rowData, atColumnIndex) 
    {
        var types = 
        [
			TableConstants.RENDER_TYPE_IMAGE,			// Type
            TableConstants.RENDER_TYPE_LINK,   			// "Machine Name",
            TableConstants.RENDER_TYPE_ENUM,   			// "LRD Name",
            TableConstants.RENDER_TYPE_EDITABLE_TEXT	// "Note",
        ];
		return types[atColumnIndex];
    },

        
    getCellDisplayData: function(rowData, atColumnIndex) 
    {
			switch (atColumnIndex) 
			{
				case 0:
					return "";
				case 1: // LRD Name
					return rowData.machineName;
				case 2: // Machine Name
					return rowData.lrdName;
				case 3: // Machine Name
					return rowData.note;
			}

		return "";
    },

    getCellDisplayExtendedInfo: function(rowData, atColumnIndex) 
    {
		switch (atColumnIndex) 
		{
			case 0:
				var val = {};
				if (rowData.machineID)
					val.image = this._parentView.assetType == "Machine" ? ImageCache.MACHINE : ImageCache.VIRTUALIMAGE;
				else
					val.image = ImageCache.NOIMAGE;
				return val;

			case 1:
				return { 'href': AssetUriUtil.getViewAssetDetailURI(this._parentView.assetType, rowData.machineID) };
			case 2:
				var val = {};
				val.select = rowData.lrdID;
				var LRDs = this._parentView.getLRDsForTable();
				var choices = [];
				//Add in the "None" entry
				var noneLRD = {text: RtlmUiUtil_getMessage("labelNone"), value: -1};
				choices.push(noneLRD);		
				
				//Loop over all the LRDs in the Test Environment		
				for (var i = 0; i < LRDs.length; i++)
				{
					var choice = {text: LRDs[i].lrdName, value:LRDs[i].lrdID};
					choices.push(choice);
				}
				val.choices = choices;
				return val;
		}			
		return( {} );
    }
});

dojo.declare("TestCellEditor.TableListener",
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableListener,
{    
	_parentView: null,
	
	constructor: function(parentView) 
	{
		this._parentView = parentView;
	},
	
    rowCheckStateChanged: function(tableViewer, rowObject, state) 
    {
		this._parentView._updateButtonStatus();
    },

    tableContentActionInvoked: function(tableViewer, actionId, callbackData, callback) 
    {
        callback(callbackData);
    }	
});

dojo.declare("TestCellEditor.CellModifier", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier,
{
	constructor: function(parentView) 
	{
		this._parentView = parentView;
	},

	cellValueChanged: function(lastSelected, val, rowData, columnIndex)
	{
		if (this._parentView && columnIndex == 2)
			this._parentView.updateLRDforRow(val, rowData.rowID);
		else
			if (this._parentView && columnIndex == 3)
				this._parentView.updateNote(val, rowData.rowID)

	}
});

//Class to handle the response when assigning machines to rows
//We need the class because there may be simultaneous calls to the machine search service
//and we need to know for which row the handler is being called.
//Therefore we set the row id in the constructor.
dojo.declare("TestCellEditor.AssignHandler", null,
{
	constructor: function(parentView, row)
	{
		this.parentView = parentView;
		this.row = row;  //Remember the row for later use
	},
	
	success: function(response) 
	{
		//Set the associated machine for the specific row
		this.parentView._machineSearchSuccess(response, this.row)
	},
	error: function(response) 
	{
		this.parentView._machineSearchError(response);
	}	
});

})();