/*****************************TestCellQueryView***************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
//
//
//
dojo.provide("com.ibm.rational.test.lm.web.ui.internal.views.testcells.TestCellQueryView");
 
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");

dojo.require("com.ibm.asq.common.web.client.internal.PermissionsClient");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.SimpleClearCollapsibleArea");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellRenderer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.ListRowRenderer");

dojo.require("com.ibm.rational.test.lm.web.client.internal.collections");
dojo.require("com.ibm.rational.test.lm.web.client.internal.inventory");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.pages.AssetUriUtil");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.views.testcells.TestCellUriUtil");

dojo.require("com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.views.configurations.ConfigurationsUriUtil");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");


(function() {

var RtlmUiUtil = com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil;
var ServiceResponseHandler = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var TableConstants = com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;
var AssetUriUtil = com.ibm.rational.test.lm.web.ui.internal.pages.AssetUriUtil;
var ConfigurationUriUtil = com.ibm.rational.test.lm.web.ui.internal.views.configurations.ConfigurationsUriUtil;
var LOADING = RtlmUiUtil.getMessage("appWorking");
var PermissionsClient = com.ibm.asq.common.web.client.internal.PermissionsClient;
var ViewHeaderLayout = com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout;
var ImageCache = com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
var TestCellUriUtil = com.ibm.rational.test.lm.web.ui.internal.views.testcells.TestCellUriUtil;

dojo.declare("com.ibm.rational.test.lm.web.ui.internal.views.testcells.TestCellQueryView", 
    [dijit._Widget, dijit._Templated],
{    
    templateString: '<div class="testcell-query-view" dojoAttachPoint="domNode" tabindex="-1">' +
                    '  <div dojoType="com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout" dojoAttachPoint="viewHeaderNode" noline="true">' +
                    '    <div class="testcell-area-container">' +
                    '      <div dojoAttachPoint="testCellArea" class="testcell-area"></div>' +
                    '    </div>' +
                    '  </div>' +
                    '</div>',

    widgetsInTemplate: true,
    
    refreshActionNode: null,

    collectionsService: null,
    inventoryService: null,
    deployActionNode: null,
    undeployActionNode: null,
    
    // the table to display the Test Cells
    tableViewer: null,
    
    postCreate: function() 
	{
        // set title and subtitle
        this.inherited("postCreate", arguments);
        this.viewHeaderNode.setTitle(RtlmUiUtil.getMessage("labelAllTestCells"));
        this.viewHeaderNode.setCSHelpId("rtlm_allvirtcoll.html", com.ibm.rational.test.lm.web.CSHelpID);		
		this.viewHeaderNode.setCSHelpButtonLabel(RtlmUiUtil.getMessage("labelAllTestCellsHelp"));

        this.collectionsService = new com.ibm.rational.test.lm.web.client.internal.collections();
        this.inventoryService = new com.ibm.rational.test.lm.web.client.internal.inventory();
        
        // create the table to display the Test Cells
        this.tableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer({
            allowAdjustSettings: true,
            autoSaveSettings: true,
            tableId: "RQM-LM-TESTCELL-TABLEVIEWER"                                
        });
        this.tableViewer.setContentProvider(new TestCellQueryView.TableProvider());
        this.tableViewer.setContentPageSize(15);
        this.tableViewer.setTableRowsCheckable(true);
        this.tableViewer.setTableListener(new TestCellQueryView.TableListener(this));
		this.tableViewer.setTableSummary(RtlmUiUtil.getMessage("labelTableSummary", RtlmUiUtil.getMessage("labelAllTestCells")));

        // set the custom row renderer to render as list
        this.tableViewer.rowRenderer.container = this;
		

        this.tableViewer.setContent([]);
        this.tableViewer.show();
        
        
        this.refreshActionNode = this.tableViewer.addAction(
                "refresh",                     // action id
                RtlmUiUtil.getMessage("labelRefreshButton"),  // label
                null,                          // callback data
                "refresh-icon-image",          // icon class
                dojo.hitch(this, "refresh"));  // callback

        this.deployActionNode = this.tableViewer.addAction(
                "deploy",                        // action id
                RtlmUiUtil.getMessage("Deploy"), // label
                null,                            // callback data
                "deploy-collection-icon-image", // icon class
                dojo.hitch(this, "deploy"));     // callback

        this.undeployActionNode = this.tableViewer.addAction(
                "undeploy",                        // action id
                RtlmUiUtil.getMessage("Undeploy"), // label
                null,                              // callback data
                "undeploy-collection-icon-image",  // icon class
                dojo.hitch(this, "undeploy"));     // callback

        this.deleteActionNode = this.tableViewer.addAction(
                "delete",                        // action id
                RtlmUiUtil.getMessage("labelDeleteButton"), // label
                null,                              // callback data
                "delete-icon-image",  // icon class
                dojo.hitch(this, "onDeleteCells"));     // callback
        this._updateActionsDisplay();
        this.testCellArea.appendChild(this.tableViewer.domNode);
        
        // load collections into table
        this._loadTestCells();
    },
    	
    _loadTestCells: function() 
	{
		var responseHandler = new ServiceResponseHandler(this, "_loadSuccess", "_loadFailure");
		this.viewHeaderNode.setProgressStart(LOADING);
		this.collectionsService.getAllTestCells(responseHandler);
    },
    
    _loadSuccess: function(response) 
	{
        this.viewHeaderNode.setProgressEnd();
		this.testCells = response;

        this.tableViewer.setContent(response ? response : []);
        this.tableViewer.refresh();
        this._updateActionsDisplay();
        this.viewHeaderNode.clearStatus();
    },
    
    _loadFailure: function(response) 
	{
        this.viewHeaderNode.setProgressEnd();
        this.viewHeaderNode.setStatus(RtlmUiUtil.getMessage("errLoadingTestCells"), ViewHeaderLayout.ERROR);
    },
    
    _hasDeployPermission: function()
    {
        var perm = PermissionsClient.getStoredPermission(PermissionsClient.OP_LM_VIRTUALIZATION);  
        return (!perm || perm[PermissionsClient.ACTION_DEPLOY]);   
    },

    _hasCollectionPermission: function()
    {
        var perm = PermissionsClient.getStoredPermission(PermissionsClient.OP_LM_COLLECTION);  
        return (!perm || perm[PermissionsClient.ACTION_EDIT]);   
    },

    _updateActionsDisplay: function() 
	{
        var hasNoRows = (this.tableViewer.getCheckedRows().length == 0);
		var disableDeploy = (hasNoRows || !this._hasDeployPermission());
		var disableEdit = (hasNoRows || !this._hasCollectionPermission());
		
		
		//Need to determine if ONLY Managed Virtual Images or ONLY Managed Virtual Machines are selected
		//This will determine whether to enable/disable the deploy and undeploy button.
		var onlyManagedImagesSelected = !hasNoRows;  //If any rows initialize to true and we'll validate that by looping over the selected rows  
		var onlyManagedMachinesSelected = !hasNoRows; //If any rows initialize to true and we'll validate that by looping over the selected rows
		var selectedRows = this.tableViewer.getCheckedRows();
		for (var i = 0; i < selectedRows.length; i++)
		{
			var row = selectedRows[i];
			if (row.instanceType.id != 1)  //Shouldn't be hard coded.  See TestCellEditor.js for defines
				onlyManagedImagesSelected = false;
			if (row.instanceType.id != 2)  //Shouldn't be hard coded.  See TestCellEditor.js for defines
				onlyManagedMachinesSelected = false;
		}

		//disable the deploy button if types other than managed virtual images are selected		
        this.deployActionNode.setDisabled(disableDeploy || !onlyManagedImagesSelected);

		//disable the undeploy button if types other than managed virtual machines are selected		
        this.undeployActionNode.setDisabled(disableDeploy || !onlyManagedMachinesSelected);
		
		this.deleteActionNode.setDisabled(hasNoRows);
    },
    
    refresh: function() 
	{
        this._loadTestCells();
    },
	
	onDeleteCells: function()
	{
        var selectedCells = this.tableViewer.getCheckedRows();
        var args = 
        {
            'message': RtlmUiUtil.getMessage("cellConfirmRemove", selectedCells.length == 1 ? RtlmUiUtil.getMessage("cellLabel") : RtlmUiUtil.getMessage("cellCells")),
            'yesCallback': 
                function(view) 
                {
                    view.deleteCells();
                },
            'yesCallbackData': this,
            'noCallback': null,
            'noCallbackData': null
        };
        var confirmDialog = new com.ibm.asq.common.web.ui.internal.widgets.YesNoDialog(args);
        confirmDialog.setSecondaryTitle(RtlmUiUtil.getMessage("cellConfirmRemoveTitle"));
        confirmDialog.open();		
	},
	
	deleteCells: function()
	{
        var selectedCells = this.tableViewer.getCheckedRows();
        this.deleteActionNode.setDisabled(true);
		var responseHandler = new ServiceResponseHandler(this, "_deleteSuccess", "_deleteFailure");
		this.itemsRemainingToDelete = selectedCells.length;
		for (var i = 0; i < selectedCells.length; i++)
		{
			this.collectionsService.deleteTestCell(responseHandler, selectedCells[i].itemId);
		}
	},
	
	_deleteSuccess: function(response)
	{
		this.itemsRemainingToDelete--;
		if (this.itemsRemainingToDelete == 0)
			this._loadTestCells();		
	},
	
	_deleteFailure: function()
	{
		this.itemsRemainingToDelete--;
		if (this.itemsRemainingToDelete == 0)
			this._loadTestCells();		
	},
    
    deploy: function() 
	{
        var selectedCollections = this.tableViewer.getCheckedRows();
        this.deployActionNode.setDisabled(true);
        this.viewHeaderNode.setProgressStart(RtlmUiUtil.getMessage("labelDeployingVICollection"));
        
        this.selectedCollectionsCount = selectedCollections.length;
        this.successCollectionsCount = 0;
        this.errorCollectionsCount = 0;

        for (var i = 0; i < selectedCollections.length; i++) 
		{
            var responseHandler = new ServiceResponseHandler(this, "_deployUndeploySuccess", "_deployUndeployFailure");
            this.inventoryService.deployVirtualCollection(responseHandler, selectedCollections[i].itemId);
        }
    },
    
    undeploy: function() 
	{
        var selectedCollections = this.tableViewer.getCheckedRows();
        this.undeployActionNode.setDisabled(true);
        this.viewHeaderNode.setProgressStart(RtlmUiUtil.getMessage("labelUndeployingVMCollection"));
        
        this.selectedCollectionsCount = selectedCollections.length;
        this.successCollectionsCount = 0;
        this.errorCollectionsCount = 0;

        for (var i = 0; i < selectedCollections.length; i++) 
		{
            var responseHandler = new ServiceResponseHandler(this, "_deployUndeploySuccess", "_deployUndeployFailure");
            this.inventoryService.undeployVirtualCollection(responseHandler, selectedCollections[i].itemId);
        }
    },

    _deployUndeploySuccess: function (successResponse) 
	{
		if(successResponse && (successResponse.rc == "SPIRC_NO_ERROR")) 
		{
			this.successCollectionsCount++;
		} 
		else 
		{
			this.errorCollectionsCount++;
		}
        this._setDeployUndeployStatus();
    },
    
    _deployUndeployFailure: function (failureResponse) 
	{
        this.errorCollectionsCount++;
        console.debug(failureResponse['message']);
        this._setDeployUndeployStatus();
    },

    _setDeployUndeployStatus: function() 
	{
        if ((this.successCollectionsCount + this.errorCollectionsCount) == this.selectedCollectionsCount) 
		{
            var messageKey = this.showVMI ? "msgDeployedVICollections" : "msgUndeployedVMCollections";
            this.viewHeaderNode.setStatus
			(
                RtlmUiUtil.getMessage(messageKey, this.successCollectionsCount, this.selectedCollectionsCount),
                this.errorCollectionsCount == 0 ? ViewHeaderLayout.SUCCESS :
                    this.errorCollectionsCount == this.selectedCollectionsCount ? ViewHeaderLayout.ERROR : ViewHeaderLayout.INFO
            );
            this.viewHeaderNode.setProgressEnd();

			//Update the button stati
			this._updateActionsDisplay();
            
            // bring up the deployment page, seed it with deploy directive.
            dojo.setObject( "com.ibm.rational.test.lm.web.deployCollection", "true" );
            window.location.href = AssetUriUtil.getDeployViewURI();
        }
    },
    
    onArtifactChanged: function(changeType, artifactType, artifactArray)
	{
		// only care about virtual collections, image or machine
		if (artifactType == RtlmUiUtil.TYPE_TEST_CELL) 
		{
			// update the table display
			this._loadTestCells();
		}
    }
});

dojo.declare("TestCellQueryView.TableProvider", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider,
{
    getNumColumns: function(content) 
	{
        return 5;
    },
    
    _columnHeadings: [
		RtlmUiUtil.getMessage("cellType"),
        RtlmUiUtil.getMessage("Name"),
        RtlmUiUtil.getMessage("cellOwner"),
        RtlmUiUtil.getMessage("cellSummary"),
        RtlmUiUtil.getMessage("cfgCfgLabel")
    ],
    
    getColumnHeading: function(content, atColumnIndex) 
	{
        return this._columnHeadings[atColumnIndex];
    },

    getColumnHeadingImage: function(content, atColumnIndex) 
	{
        return null;
    },
    
    getIsColumnGroupable: function(content, atColumnIndex) 
	{
        return atColumnIndex == 0;
    },

    getIsColumnSortable: function(content, atColumnIndex) 
	{
        return atColumnIndex > 0;
    },
    
    _columnWidths: [
		5,
        20, // name
        20, // owner
        35, // description
        20  // configuration
	],
    
    getColumnWidth: function(content, atColumnIndex) 
	{
        return this._columnWidths[atColumnIndex];
    },
    
    getContentObjects: function(content) 
	{
        // the collections data is already an array
        return content;
    },
    
    getRowDataId: function(rowData) 
	{
        return rowData.itemId;
    },

    getCellDisplayType: function(rowData, atColumnIndex) 
	{
        var types = [
			TableConstants.RENDER_TYPE_IMAGE,  // type
            TableConstants.RENDER_TYPE_LINK,   // name
            TableConstants.RENDER_TYPE_TEXT,   // owner
            TableConstants.RENDER_TYPE_TEXT,   // description
            TableConstants.RENDER_TYPE_LINK    // configuration
        ];
        return types[atColumnIndex];
    },
    
    getCellDisplayData: function(rowData, atColumnIndex) 
	{
        switch(atColumnIndex) {
			case 0:
				return this._getTypeName(rowData.instanceType.id);
            case 1: // name
                return rowData.name;
            case 2: // owner
                return rowData.owner ? rowData.owner.name : "";
            case 3: // description
                return rowData.summary;
            case 4: // configuration
                return rowData.testEnvName ? rowData.testEnvName : RtlmUiUtil.getMessage("cfgUnassigned");
        }
        return "";
    },
	
    getCellDisplayExtendedInfo: function(rowData, atColumnIndex) 
    {
		switch (atColumnIndex) 
		{
			case 0:
				var val = {};
				if (rowData.instanceType.id == 2 || rowData.instanceType.id == 3)  //Todo use defines here
					val.image = ImageCache.MACHINE;
				else
					val.image = ImageCache.VIRTUALIMAGE;
				return val;
				
			case 1:
				return { href: TestCellUriUtil.getEditTestCellURI(rowData.itemId) };
			
			case 4:
				if (rowData.testEnvItemId)
					return { 'href': ConfigurationUriUtil.getEditConfigurationURI(rowData.testEnvItemId) };
				else
					return {};
		}			
		return( {} );
    },
	
	_getTypeName: function(typeID)
	{
		switch (typeID)
		{
			case 1:
				return RtlmUiUtil.getMessage("labelManagedVirtualImage");
			case 2:
				return RtlmUiUtil.getMessage("labelManagedVirtualMachine");
			case 3:
				return RtlmUiUtil.getMessage("MachTitleMachine");
			case 4:
				return RtlmUiUtil.getMessage("VirtualImage");
		}
		return "unknown";
	}
});

dojo.declare("TestCellQueryView.TableListener",
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableListener,
{    
    _testCellsView: null,
    
    constructor: function(_testCellsView) 
	{
        this._testCellsView = _testCellsView;
    },
    
    tableContentActionInvoked: function(tableViewer, actionId, callbackData, callback) 
	{
        callback(callbackData);
    },

    groupRowsCheckStateChanged: function(tableViewer, rowObjects, state) 
    {
        this.rowCheckStateChanged(tableViewer, rowObjects, state);
    },

    rowCheckStateChanged: function(tableViewer, rowObject, state) 
	{
        this._testCellsView._updateActionsDisplay();
    }
});

})();
