/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/

/*
 * PC  09/08/09
 * This file doesn't seem to be used by any JS file.
 * 
 * MFV 03/14/08
 * 
 * THIS WIDGET IS NOT COMPLETE YET IT REQUIRES THE FOLLOWING
 * 
 * 1.  A new service that returns a set of congigs given a list of config IDs
 * 
 * 2.  The new super table that Lam is working on.
 */
dojo.provide("com.ibm.rational.test.lm.web.ui.internal.widgets.ConfigListPanel");
 
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.asq.common.web.client.internal.Catalog");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.pages.AssetUriUtil");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.views.configurations.ConfigurationsUriUtil");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.widgets.FilteredSelectionDialog");
dojo.require("com.ibm.rational.test.lm.web.client.internal.config");
//dojo.require("com.ibm.rqm.planning.web.ui.internal.view.extension.AbstractArtifactEditorSection");

(function() 
{
	var RtlmUiUtil = com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil;
	var ConfigurationUriUtil = com.ibm.rational.test.lm.web.ui.internal.views.configurations.ConfigurationsUriUtil;
//	var AbstractArtifactEditorSection    = com.ibm.rqm.planning.web.ui.internal.view.extension.AbstractArtifactEditorSection;
   	
	dojo.declare("com.ibm.rational.test.lm.web.ui.internal.widgets.ConfigListPanel", [dijit._Widget, dijit._Templated/*,AbstractArtifactEditorSection*/],
{
	widgetsInTemplate: true,
	configList:null,    

    templateString: '<div id="${id}" dojoAttachPoint="domNode" tabindex="-1">' +
					'  <div dojoAttachPoint="buttonBar">'+
					'   <table border="0" cellpadding="0" cellspacing="5">' +
					'     <tr align="left" dojoAttachPoint="buttonRow">' +
					'     </tr>' +
					'   </table>'+
					'  </div>'+                    
					'  <div dojoAttachPoint="configTableArea"> ' +
					'   <table border="0" cellpadding="0" cellspacing="5" width="100%">' +
					'     <tr align="left">' +
					'       <td>'+
					'         <div dojoAttachPoint="configTableArea"> ' +
					'         </div>' +					
					'       </td>'+
					'     </tr>' +
					'   </table>'+
					'  </div>'+
					'</div>',

	selectDlg:null,

	postCreate: function()
	{
		//Need to load the confgis from the Test Plan
		//Not sure how to do that yet		
//		this._plan = this.getArtifact();

		this._createTable();
		this._createButtons();
		this._loadConfigs();
	},
	
	_createTable :function()
	{
		// initialize the table's settings and columns.
		this.tableArgs = 
		{ 
			maxRows: 10,
			rangeStart: 1,
			isFilterable: false, 
			showQuery: false, 
			isQueryEditable: false, 
			showFooter: true,
			sortColumn: 0, 
			sortDirection: SortableFilterableTable.SORT_ASC,
			isMultiselect: this.multiselect,
			isRowSelectable: true 
		};
		
		var theTable = new com.ibm.asq.common.web.ui.internal.view.common.SortableFilterableTable(this.tableArgs, this.configTableArea);
        theTable.initialize(this.tableArgs);
        theTable.addColumn({title: RtlmUiUtil.getMessage("cfgName"), isSortable: true, includeInFilter: true, width: "20"});              
        theTable.addColumn({title: RtlmUiUtil.getMessage("cfgDescription"), isSortable: true, includeInFilter: true, width: "80%"});              

		this.configTable = theTable;
		this.configTable.displayTable();	
	},
	
	_loadConfigs :function()
	{
		// ************************************************
		//
		// MFV 03/14/08
		//
		//THIS NEEDS TO BE REPLACED BY A TO BE PROVIDED SERVICE THAT RETURNS CONFIGS BASED ON A LIST OF IDS (supplied by the widtet's client).
		//
		// ************************************************

		if (this.configList == null || this.configList.length == 0)
			return;
			
		var configs = new com.ibm.rational.test.lm.web.client.internal.config();
		var responseHandler= new com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper(this, "_loadTable", "_errorFunc");
		for (var i = 0; i < this.configList.length; i++)
			configs.retrieveConfiguration(responseHandler, this.configList[i]);
	},
	
	_loadTable: function(response)
	{
		var rows = [];
		if (response)
		{  
			for(var i = 0; i < response.length; i++) 
			{
				var name = response[i].name;
				var description = response[i].description;
				var id = response[i].id;
				
				var assetUri = ConfigurationUriUtil.getEditConfigurationURI(id);
				
				var aRow = {href: assetUri,
							elements: [
							{type: SortableFilterableTable.TYPE_STRING, data: name, isLink: false}, 
							{type: SortableFilterableTable.TYPE_STRING, data: description, isLink: false}
	                        ]};
				
				rows.push(aRow);
	        }
		}
		this.tableArgs["rows"] = rows;
		this.configTable.initialize(this.tableArgs);
		this.configTable.displayTable();
	},
	
	_errorFunc: function(errorType, errorMessage) 
	{

	},
	
	_createButtons :function()
	{

		var td = document.createElement("td");
		var newAction = document.createElement("a");
		newAction.innerHTML = RtlmUiUtil.getMessage("newLabel");
		this.connect(newAction, "onkeypress", "_newConfigActionKeyHandler");
		this.connect(newAction, "onclick", "_newConfigActionHandler");
		td.appendChild(newAction);
		this.buttonRow.appendChild(td);

		var td2 = document.createElement("td");
		var selectAction = document.createElement("a");
		selectAction.innerHTML = RtlmUiUtil.getMessage("selectLabel");
		this.connect(selectAction, "onkeypress", "_selectConfigActionKeyHandler");
		this.connect(selectAction, "onclick", "_selectConfigActionHandler");
		td2.appendChild(selectAction);
		this.buttonRow.appendChild(td2);

	},
	
	_newConfigActionKeyHandler :function()
	{
		
	},
	
	_newConfigActionHandler :function()
	{
		window.location.href = ConfigurationUriUtil.getNewConfigurationURI();
	},
	

	_selectConfigActionKeyHandler :function()
	{
		
	},
	
	_selectConfigActionHandler :function()
	{
		
		var configs = new com.ibm.rational.test.lm.web.client.internal.config();
		var responseHandler= new com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper(this, "_loadAllConfigsSuccessHandler", "_loadAllConfigsErrorHandler");
	
		configs.getAll(responseHandler);
	},
	
	_loadAllConfigsSuccessHandler :function(response)
	{
		this.selectDlg = new com.ibm.rational.test.lm.web.ui.internal.widgets.FilteredSelectionDialog({title:"Select Test Environments"});
		this.selectDlg.setOKaction( dojo.hitch( this, this._handleSelectOK ) );
		if (response) 
		{
			for (var i = 0; i < response.length; i++) 
			{
				var name = response[i].name;
				var id = response[i].id;
				
				this.selectDlg.addListItem(id, name);
			}
		}
		this.selectDlg.show();
	},
	
	_handleSelectOK :function()
	{
		var newItems = this.selectDlg.getSelectedItems();
		for (var i = 0; i < newItems.length; i++)
		{
			var id = newItems[i].id;
			var name = newItems[i].name;
			this.addItem(id, name, "");
		}
	},
	
	_loadAllConfigsErrorHandler :function(errorType, errorMessage)
	{
		
	},
	
	addItem :function(id, name, description)
	{
		var assetUri = ConfigurationUriUtil.getEditConfigurationURI(id);
				
		var aRow = {href: assetUri,
							elements: [
							{type: SortableFilterableTable.TYPE_STRING, data: name, isLink: false}, 
							{type: SortableFilterableTable.TYPE_STRING, data: description, isLink: false}
	                        ]};
		
		if (this.tableArgs["rows"] == null)
			this.tableArgs["rows"] = new Array();
			
		this.tableArgs["rows"].push(aRow);
		this.configTable.initialize(this.tableArgs);
		this.configTable.displayTable();
	}


					
});

})();					
