/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rational.test.lm.web.ui.internal.widgets.ConfigThruReservationWidget");
 
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.layout.ASQValidateTextBox");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.widgets.layout.SectionLayoutForm");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.widgets.layout.FormListener");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.widgets.layout.FormTextField");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.views.machines.ActionCustomElementProvider");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.views.machines.AssetContentProviderFactory");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.views.machines.FilteringCustomElementProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.MoreLessCollapsibleArea");
dojo.require("com.ibm.asq.common.web.client.internal.Catalog");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.widgets.ActionConfigSummary");

//Table viewers for found machines and reserved machines
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.views.providers.RequestReservationsTableProvider"); 
dojo.require("com.ibm.rational.test.lm.web.ui.internal.views.providers.RequestReservedMachinesTableProvider"); 

(function() 
{
var AssetContentProviderFactory = com.ibm.rational.test.lm.web.ui.internal.views.machines.AssetContentProviderFactory;
var RtlmUiUtil = com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil;
var ViewHeaderLayout = com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout;
var RtlmUiUtil_getMessage = RtlmUiUtil.getMessage;
var RtlmUiUtil_getCommonMessage = RtlmUiUtil.getCommonMessage;

dojo.declare("com.ibm.rational.test.lm.web.ui.internal.widgets.ConfigThruReservationWidget", [dijit._Widget, dijit._Templated, com.ibm.rational.test.lm.web.ui.internal.widgets.layout.FormListener],
{    
    templateString: '<div dojoAttachPoint="domNode" tabindex="-1">' +
	                '  <tr width="100%">' +
                    '   <table dojoAttachPoint="partTable" align="left" width="100%" cellPadding="0" cellSpacing="0" border="0">' +
                    '     <tr width="100%" dojoAttachPoint="partRow">' +
                    '       <td width="100%" align="left">' +
					'         <div dojoAttachPoint=moreLessNode>' +
					'         </div>' +
					'       </td>' +
					'     </tr> ' +
                    '   </table>' +
					'  </tr>' +
					'</div>',

    widgetsInTemplate: true,
	//The Part we are displaying
	part:null,
	//Expand the display by default?
	expand:false,
	//Show the editable view of the config part by default
	edit:false,
	//The label to display for the part
	partLabel:null,
	//Is the label editable?
	editLabel:false,
	//Call back method when the part is modified
	changeCallback:null,
	//The asset type we will be searching for
	assetType:"Machine",
	//The request form in which we are embedded
	reqForm:null,
	//The default state for the part (different from the display state this determines IF a part can be edited)
	state:"EDITABLE",
	//A member variable for preserving the original state of the config
	origConfig:null,
	
	postCreate:function()
	{
		this._determineAvailableActions();
		//Create the more-less area for this config part
		this.moreLessSection = new com.ibm.asq.common.web.ui.internal.view.common.MoreLessCollapsibleArea( {editableLabel:this.state == "EDITABLE", title:this.partLabel, open:this.expand} );
		this.removePartAction = this.moreLessSection.addAction( RtlmUiUtil_getMessage("cfgDeleteResourceDescription"), dojo.hitch( this, this._deleteSection), null, "delete-icon-image" );
		if (this.editLabel && this.state == "EDITABLE")
			this.moreLessSection.editableTitleNode._edit();
			
		this.moreLessSection.editableTitleNode.onChange = dojo.hitch(this, "_labelChanged");	

		//Now create a table that will be contained in the more/less section
		//The table will contain two rows.  One for the summary info and one for the detail/editing area
		var dataTable = document.createElement("table");
		dataTable.cellPadding = "0";
		dataTable.cellSpacing = "0";
		dataTable.border = "0";
		dataTable.align = "left";
		dataTable.width = "100%"
		var dataBody = document.createElement("tbody");
		dataTable.appendChild(dataBody);
		
		//save the table and body to "member variables" in case we need to mess with them later
		this.dataTable = dataTable;
		this.dataBody = dataBody;
		
		//Create the rows in the table
		//Each "Row" is a different section in the display
		//
		//There can be a summary section
		//There can be a detail section
		//There can be a section for displaying found machines
		//Finally, there can be a section showing a reserved machine
		//The table can have the following
		this.summaryRow = document.createElement("tr");
		this.summaryTD = document.createElement("td");
		
		//The detail Row
		this.detailRow = document.createElement("tr");
		this.detailRow.width="100%";
		this.detailTD = document.createElement("td");
		this.detailTD.width="100%";

		//The found machines row
		this.foundMachinesRow = document.createElement("tr");
		this.foundMachinesRow.width = "100%"
		this.foundMachinesTD = document.createElement("TD");
		this.foundMachinesTD.width="100%";
		//The actions row for the found machines
		//This is where the Reserve action will go
		this.foundMachinesActionRow = document.createElement("tr");
		this.foundMachinesActionRow.width="100%";
		this.foundMachinesActionTD = document.createElement("TD");
		this.foundMachinesActionTD.width="100%";
		this.foundMachinesActionTD.align="right";
		//The reserved machine row
		this.reservedMachineRow = document.createElement("tr");
		this.reservedMachineTD = document.createElement("TD");
		this.reservedMachineTD.width="100%";
		
		
		
		//Create the summary section and attach it to the datatable
		this.summarySection = new com.ibm.rational.test.lm.web.ui.internal.widgets.ActionConfigSummary({configPart:this.part});

		//Add the Edit/Config actions
		//Determine the label for the edit/summary button.  If we are editing then use Summary otherwise use Edit
		var buttonLabel = this.edit ? RtlmUiUtil_getMessage("cfgSummary") : RtlmUiUtil_getMessage("cfgEdit");
		this.editAction = this.summarySection.addAction(buttonLabel, dojo.hitch(this, "_edit"), {});

		//Add the Find Machines action
		buttonLabel = RtlmUiUtil_getMessage("cfgFindMachines");
		this.findMachinesAction = this.summarySection.addAction(buttonLabel, dojo.hitch(this, "_findMachines"), {});
		if (!this.findMachinesAvailable)
			this._hide(this.findMachinesAction);
		
		this.summaryTD.appendChild(this.summarySection.domNode);
		this.summaryRow.appendChild(this.summaryTD);
		this.dataBody.appendChild(this.summaryRow);
		
		//Now create the detail section
        var formLayout = new com.ibm.rational.test.lm.web.ui.internal.widgets.layout.SectionLayoutForm(this.detailTD);
        var custProvider = new com.ibm.rational.test.lm.web.ui.internal.views.machines.FilteringCustomElementProvider(formLayout);
        var provider = AssetContentProviderFactory.getAssetConfigurationProvider(this.assetType, formLayout, this);
        formLayout.setContentProvider(provider);
        formLayout.setCustomElementProvider(custProvider);         
        formLayout.setContent(this.part);
        formLayout.doLayout();
        formLayout.loadDataToForm();
		
		if (this.edit == false)
			this.detailTD.style.display = "none";

		this.detailRow.appendChild(this.detailTD);
		this.dataBody.appendChild(this.detailRow);
		
		//Now Create the Found Machines Section  This will also include the Reserve Machine Action
		this.foundMachinesTable = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer();
		this.foundMachinesTable.setContentPageSize( 10 );
		this.foundMachinesTable.setTableRowsCheckable( true, true );        
        var foundMachinesContentProvider = new com.ibm.rational.test.lm.web.ui.internal.views.providers.RequestReservationsTableProvider();
		this.foundMachinesTable.setContentProvider(foundMachinesContentProvider);
		this.foundMachinesTable.setTableSummary(RtlmUiUtil_getMessage("labelTableSummary", RtlmUiUtil_getMessage("labelFoundMachine")));
		this.foundMachinesTD.appendChild(this.foundMachinesTable.domNode);
		this.foundMachinesRow.appendChild(this.foundMachinesTD);

        //Here's the reserve machine button
        this.reserveButton = this.foundMachinesTable.addAction("reserve", RtlmUiUtil_getMessage("reqLabel_reserveMachine"), null, "reserve-icon-16");
        this.reserveButton.setDisabled(true);
        
        // create a table listener to monitor table row events and actions firing
        var tableListener = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableListener();
        tableListener.rowCheckStateChanged = dojo.hitch(this, function() {
            this.reserveButton.setDisabled(this.foundMachinesTable.getCheckedRows().length == 0);
        });
        tableListener.tableContentActionInvoked = dojo.hitch(this, function(tableViewer, actionId, callbackData, callback) {
            if(actionId == "reserve")
                this._reserveMachine();
        });
        this.foundMachinesTable.setTableListener(tableListener);
		this._hide(this.foundMachinesTD);
		this.dataBody.appendChild(this.foundMachinesRow);

		//Now Create the Reserved Machines Section
		this.reservedMachineTable = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer();
		this.reservedMachineTable.setContentPageSize( 10 );
        var reservedMachineContentProvider = new com.ibm.rational.test.lm.web.ui.internal.views.providers.RequestReservedMachinesTableProvider();
		this.reservedMachineTable.setContentProvider(reservedMachineContentProvider);
		this.reservedMachineTable.setTableSummary(RtlmUiUtil_getMessage("labelTableSummary", RtlmUiUtil_getMessage("labelReservedMachine")));
		this.reservedMachineTD.appendChild(this.reservedMachineTable.domNode);
		this.reservedMachineRow.appendChild(this.reservedMachineTD);
		this._hide(this.reservedMachineTD);
		this.dataBody.appendChild(this.reservedMachineRow);


        this.moreLessSection.contentNode.style.display = "table";
        this.moreLessSection.contentNode.style.width = "100%";
		this.moreLessSection.contentNode.appendChild(this.dataTable);
		this.moreLessNode.appendChild(this.moreLessSection.domNode);
		
		//Initialize the form with data....
		//All the work above defaulted to the settings for a new editable request
		this.initializeFormWithData();

	},
	
	initializeFormWithData :function()
	{
		//Determine if there is already a reservation for this part.
		//If there is then we should be able to find the reservation record in the list of reservations
		var resID = this.part.document.getIdentifierByTag(this.part.getTag());
		if (resID)
		{
			//There is a reservation already so we need to hide and show the appropriate widgets.
			this._setReservedUIState();
			
			//Now get the appropriate Reservation record from the ReqData and set it into the reserved machine table
			var theReservation = this._getReservation(resID);
			if (theReservation != null)
			{
				this.reservedMachineTable.setContent(theReservation);
				this.reservedMachineTable.show();
			}
		}
		if (this.state == "SELECTABLE")
			this._setSelectableUIState();
	},
	
	_determineAvailableActions : function()
	{
		var reqData = this.reqForm._requestData;

		//Determine if the find machines action is available
		var actionInfo = reqData.getActionInfo(this.FIND_MACHINE_ACTION_ID);
		this.findMachinesAvailable = actionInfo != null;
		
	},
	
	//Display the editable part.  This the the Detail section
	_edit :function(callbackData)
	{
		if (this.detailTD.style.display == "none") 
		{
			callbackData.buttonNode.innerHTML = RtlmUiUtil_getMessage("cfgSummary");
			this.detailTD.width="100%";
			this.detailTD.style.display = "inline";
		}
		else 
		{
			this.detailTD.width="100%";
			this.detailTD.style.display = "none";
			callbackData.buttonNode.innerHTML = RtlmUiUtil_getMessage("cfgEdit");
			this.summarySection.setPart(this.part);
			this.summarySection.refresh();
		}
	},

	//Handle a change to the label for the part	
	_labelChanged: function(value)
	{
		this.moreLessSection.setTitle(value);
		this.part.document.setLabelByTag(this.part.getTag(), value);
		if (this.changeCallback != null)
			this.changeCallback();
	},
	
	//Handle the delete section action
	_deleteSection: function()
	{
		//Ensure this is not the only part in the config
		if (this.part.document.getRootParts().length == 1)
		{
			alert(RtlmUiUtil_getMessage("configCantRemoveLastDescriptor"));
			return;
		}
		var self = this;
		var args = {
			message: RtlmUiUtil_getMessage("configConfirmRemovePart"),
			yesCallback: function(){
				self._removeThisPartFromTheConfig();
				self.partTable.style.display = "none";
				return true;          
			},
			noCallback: function() {
				return;
			}
		}
		var dialog = new com.ibm.asq.common.web.ui.internal.widgets.YesNoDialog(args);
        dialog.setSecondaryTitle(RtlmUiUtil_getMessage("msgConfirmTitle"));
		dialog.open();
	},
	
	//User wants to delete the part from the config
	_removeThisPartFromTheConfig :function()
	{
		//Find the matching part in the config and remove it
		var parts = this.part.document.getRootParts();
		var partTag = this.part.getTag();
        var parts_length = parts.length;
		for (var i = 0; i < parts_length; i++)
		{
			if (parts[i].getTag() == partTag)
			{
				this.part.document.removeRootPart(i);
				 break;
			}
		}
		if (this.changeCallback != null)		
			this.changeCallback();
	},
	
	setChangeCallback : function(callback)
	{
		this.changeCallback = callback;
	},
	
	attributeValueChanged: function(attributeKey, oldValue, newValue)
    {
		if (this.changeCallback != null)
			this.changeCallback();
	},
	
	//Find machines that match the config (and dates)
	_findMachines : function()
	{
        //Retrieve the data from the request form.  This includes the From and To dates the user specified for the request
        var reqData = this.reqForm._getFormData();

        // ensure the request has a date range specified.
        if(!reqData[this.RESERVE_FROM_ATTR] || !reqData[this.RESERVE_TO_ATTR]) {
            var dlg = new com.ibm.asq.common.web.ui.internal.widgets.AlertDialog({message:RtlmUiUtil_getMessage("reqMsgCantFindMachine")});
            dlg.open();
            return;
        }
		this.reqForm.viewHeaderNode.setProgressStart(RtlmUiUtil_getMessage("MsgRequestMachineSearch"));
		//We need to create a config from the Part that is in use.
		//That config will be used in the search.
		//See below where reqData[this.CONFIGURATION_ATTR] is set
		var theCatalog = new com.ibm.asq.common.web.client.internal.Catalog();
		var config = theCatalog.createConfiguration(this.assetType);
		//Insert the selected part into "this.asset" which is a config
		var rootAtt = config.getRootAttribute();
		//Remove the 0th element which is the existing part
		rootAtt.removeArrayValue(0);
		//Add in the new part
		rootAtt.addArrayValue(this.part);
		
		 
		var responseHandler = new com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper(this, "_findMachineSuccessHandler", "_findMachineFailHandler");
		var request = new com.ibm.rational.test.lm.web.client.internal.request();		
		
		//Set the config we created above into the reqData
		reqData[this.CONFIGURATION_ATTR] = config.toJson();
		// fill in the action directive to invoke in the backend.
		reqData[this.DIRECTIVE_ATTR] = this.FIND_MACHINE_ACTION_ID;
            
		// fill in the project area ID to use in the backend.
		reqData[this.PROJECT_AREA_ATTR] = com.ibm.team.process.web.projectArea.itemId;
		
		//Find the machines
        request.update(responseHandler, reqData);
	},
	
	//Hand success from the find machines
	_findMachineSuccessHandler : function(response)
	{
		//Kill the progress indicator
		this.reqForm.viewHeaderNode.setProgressEnd();
		//Show the found machines row
		this.foundMachinesTD.style.display="block";
		//Show the reserve machine action
		this.foundMachinesActionTD.style.display="block";
		//Setthe found machines into the table
		this.foundMachinesTable.setContent(response[this.FOUND_MACHINE_ATTR]);
		//show the table
		this.foundMachinesTable.show();
	},
	
    _findMachineFailHandler :function(response)
    {
        this.reqForm.viewHeaderNode.setProgressEnd();

        if(response && response.message && response.message.toLowerCase().indexOf('license')) {
            RtlmUiUtil.showServerErrorMessage(RtlmUiUtil_getCommonMessage("serverLicenseErrMsg"));                  
        }
        this.reqForm.showStatusLine(RtlmUiUtil_getMessage("reqMsgRequestActionFailed"), ViewHeaderLayout.ERROR);
    },
	
	//Handle the reserve machine action
	_reserveMachine :function()
	{
		//Get the selected machine id
		var checkedRows = this.foundMachinesTable.getCheckedRows()
		var machineID = null;
		if (checkedRows.length > 0)
			machineID = checkedRows[0]["machine.id"];

		//If the user did not select a machine, prompt them to do so
		if (machineID == null)
		{
			var dlg = new com.ibm.asq.common.web.ui.internal.widgets.AlertDialog({message:RtlmUiUtil_getMessage("reqMsgSelectMachine")});
			dlg.open();
			return;
		}            
		//Start the progress indicator
		this.reqForm.viewHeaderNode.setProgressStart(RtlmUiUtil_getMessage("MsgReserveMachine"));

		var responseHandler = new com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper(this, "_reserveMachineSuccessHandler", "_reserveMachineFailHandler");
		var request = new com.ibm.rational.test.lm.web.client.internal.request();		
		
		//Get the data from the request form
		var reqData = this.reqForm._getFormData();
        
		//Save this for use in the success handler
		this.reservedMachineID = machineID;
		
		//Set the id of the machine to reserve into the request data
		reqData[this.RESERVE_MACHINE_ID_ATTR] = machineID;
		// fill in the action directive to invoke in the backend.
		reqData[this.DIRECTIVE_ATTR] = this.RESERVE_MACHINE_ACTION_ID;
            
		// fill in the project area ID to use in the backend.
		reqData[this.PROJECT_AREA_ATTR] = com.ibm.team.process.web.projectArea.itemId;
		
		reqData[this.RESERVE_ASSET_TYPE] = "machine";  //MFV Some day we'll be able to reserve other stuff too
		
		//Reserve the machine
        request.update(responseHandler, reqData);	
	},
	
	//Handle successfully reserving a machine
	_reserveMachineSuccessHandler : function(response)
	{
		//Get ID of the machine we reserved
		var machineID = this.reservedMachineID;
		
		//Update the request Data object from the response object.
		//THIS IS NECESSARY BECAUSE THE DATA CONTAINS STATE CHANGE INFORMATION THAT IS USED
		//ON SUBSEQUENT BACK END CALLS
		this.reqForm._requestData = new Request.DataObject(this.reqForm, response);

		//Get the reservations array (although there should be only 1)
		this.reservations = response.reservations;
		
		//Save the id of the reservation into the config and the original config

		//The response back from the reserve call is a RequestDTO which contains ALL the reservations for this request
		//We need to find the reservation that references a machine with the same ID as the one we used to make the request
		var resID = null;
		var thisReservationArr = [];
        var reservations_length = this.reservations.length;
		for (var i = 0; i < reservations_length; i++) 
		{
			if (this.reservations[i].configuration.getId() == machineID) 
			{
				resID = this.reservations[i].id;
				//Put the matching reservation into an array for using in the UI/Table below
				thisReservationArr.push(this.reservations[i]);  
				break;
			}
		}
		if (resID != null) 
		{
			this.part.document.setIdentifierByTag(this.part.getTag(), resID);
			if (this.origConfig) 
			{
				//HUGE ASSUMPTION THAT THE INDEX OF THE PART IN THE CONFIG IS THE SAME
				//AS THE INDEX IN THE ORIGINAL CONFIG.
				//THIS SHOULD BE TRUE SINCE WE DON'T ALLOW THE USER TO ADD OR REMOVE PARTS
				//AT THE POINT OF RESERVING A MACHINE BUT STILL THIS IS A BIG ASSUMPTION
				//
				//THE REASON FOR USING THIS ASSUMPTION IS THAT WHEN THE ORIGINAL CONFIG IS CLONED
				//TO MAKE THE CONFIG THAT IS PASSED INTO HERE THE PART TAGS ARE UPDATED SO WE CAN'T SET
				//THE IDENTIFIER BY TAG
				var index = this.part.document.getRootAttribute().getIndexByTag(this.part.getTag());
				this.origConfig.getRootAttribute().setIdentifier(index, resID);
			}

			//Show the reserved machine in the reserved machine table			
			this.reservedMachineTable.setContent(thisReservationArr);
			this.reservedMachineTable.show();

			//Hide and show the appropriate widgets now that a reservation has been made
			this._setReservedUIState();
			
			//A little klugey......
			//We need to save the request now in order to ensure that the reservation ID that we
			//set into the config is saved.  Without this we could not correlate the reserved machine back to this part
			this._saveRequest();
		}
	},
	
    _reserveMachineFailHandler :function(response)
    {
        this.reqForm.viewHeaderNode.setProgressEnd();

        if(response && response.message && response.message.toLowerCase().indexOf('license')) {
            RtlmUiUtil.showServerErrorMessage(RtlmUiUtil_getCommonMessage("serverLicenseErrMsg"));                  
        }
        this.reqForm.showStatusLine(RtlmUiUtil_getMessage("reqMsgRequestActionFailed"), ViewHeaderLayout.ERROR);
    },  
	
	//Utility method to hide a widget
	_hide :function (widget)
	{
		if (widget)
			widget.style.display = "none";
	},
	
	//Utility method to show a widget
	_show :function(widget)
	{
		if (widget)
			widget.style.display = "block";		
	},
	
	//Set the state of the UI when a machine is already reserved for this part
	//In this case we want to hide/remove the widgets that allow editing of the part
	_setReservedUIState :function()
	{
			//Show the reserved machines table
			this._show(this.reservedMachineTD);
			//Hide the found machines table
			this._hide(this.foundMachinesTD);
			//Hide the reserve button
			this._hide(this.reserveButton.domNode);
			//Hide the edit (and remove config) action.  Can't change a config after a reservation has been made
			this._hide(this.editAction);
			//remove the delete part action (The red X on the header)
			this.removePartAction.destroyRendering();
			//Hide the find machines action.  No sense looking for more now that one is reserved
			this._hide(this.findMachinesAction);
			//Don't allow editing of the part label
			this.moreLessSection.setEditableTitle(false);		
	},
	
	//When in selectable mode, we allow the user to modify the contents of the part 
	//but we don't allow them to remove the part 
	_setSelectableUIState : function()
	{
			this.removePartAction.destroyRendering();
	},
	
	//Get the reservation record for this part.
	//Typically the resID passed in here was extracted from this config part
	//The reservation id was stored in the conf 
	_getReservation:function(resID)
	{
		//Get the list of reservations from the Request Data
		var reqData = this.reqForm._requestData;
		var reservations = reqData.getReservedMachines();
		var retVal = null;
		//Loop over the reservations looking for one that matches the id
		if (reservations != null) 
		{
            var reservations_length = reservations.length;
			for (var i = 0; i < reservations_length; i++) 
			{
				var reservation = reservations[i];
				if (reservation.id == resID) 
				{
					//The table display needs and array so we'll return one
					retVal = [];
					retVal.push(reservation);
					break;
				}
			}
		}
		return retVal;
	},
	
	//When a reservation is made, we need to save the request in order to save the part which we updated with the ID of the reservation
	_saveRequest :function()
	{
		var responseHandler = new com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper(this, "_saveSuccessHandler", "_saveFailHandler");
		var request = new com.ibm.rational.test.lm.web.client.internal.request();		
		
		var reqData = this.reqForm._getFormData();
        
		// fill in the action directive to invoke in the backend.
		reqData[this.DIRECTIVE_ATTR] = this.SAVE_ACTION_ID;
            
		// fill in the project area ID to use in the backend.
		reqData[this.PROJECT_AREA_ATTR] = com.ibm.team.process.web.projectArea.itemId;
		
        request.update(responseHandler, reqData);	
	},
	
	_saveSuccessHandler : function(response)
	{
		this.reqForm.viewHeaderNode.setProgressEnd();	
        var req_data = new Request.DataObject(this.reqForm, response);
		this.reqForm._requestData = req_data;
	},
	
    _saveFailHandler : function(response)
    {
        this.reqForm.viewHeaderNode.setProgressEnd();   
        
        if(response && response.message && response.message.toLowerCase().indexOf('license')) {
            RtlmUiUtil.showServerErrorMessage(RtlmUiUtil_getCommonMessage("serverLicenseErrMsg"));                  
        }
    },
	
	//Actions and attributes typically used in calls to the back end
	//THESE STRINGS WERE COPIED FROM RequestFormView.js.
	DIRECTIVE_ATTR: "directive",
	PROJECT_AREA_ATTR: "projectAreaItemId",
	FOUND_MACHINE_ATTR: "foundMachines",
	CONFIGURATION_ATTR: "configuration",
	FOUND_MACHINE_ATTR: "foundMachines",
	RESERVE_MACHINE_ID_ATTR: "reserveMachineId",
	RESERVE_ASSET_TYPE: "reserveAssetType",
    RESERVE_FROM_ATTR: "reserveFrom",
    RESERVE_TO_ATTR: "reserveTo",


	FIND_MACHINE_ACTION_ID: "findMachine",
	RESERVE_MACHINE_ACTION_ID: "reserveMachine",
	SAVE_ACTION_ID: "save"


});

})();
