/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
//
// pc 09/08/09
// This file doesn't seem to be used by any JS file.
//
dojo.provide("com.ibm.rational.test.lm.web.ui.internal.widgets.MachineSummaryPanel");

dojo.require("dijit.layout.ContentPane");
dojo.require("dijit._Templated");
dojo.require("dijit._Widget")
dojo.require("com.ibm.rational.test.lm.web.ui.internal.widgets.ConfigSummary");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil");


dojo.declare(
  "com.ibm.rational.test.lm.web.ui.internal.widgets.MachineSummaryPanel",
  [dijit._Widget, dijit._Templated],
{
	widgetsInTemplate: true,
	templatePath: dojo.moduleUrl("com.ibm.rational.test.lm.web", "ui/internal/widgets/templates/MachineSummaryPanel.html"),
	
	configString:null,
	title: "",
	
	/* classes for various parts to allow override particular part of main class */
	headerClass: null,       // header div area for title and action
	headerLabelClass: null,  // header div area for title and action

	postCreate :function()
	{
		var RtlmUiUtil = com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil;
		
		//Set the title of the panel
		if (this.title == "")
			this.title = RtlmUiUtil.getMessage("reqLabel_machine_def");
		this._setTitle(this.title);		
		
		//Init the class types for the various nodes
		this._initClasses();

		this._createSummaryArea();
	},
	
	_createSummaryArea :function()
	{
		var summary = new com.ibm.rational.test.lm.web.ui.internal.widgets.ConfigSummary({configString:this.configString});
		this.configLayoutNode.appendChild(summary.domNode);
	},

	_setTitle :function(title)
	{
		this.headerNode.innerHTML = title;
	},
	
	_initClasses :function()
	{
		// allow override the class of individual part from the main class
		if (this.headerClass != null)
			this.headerRowNode.className = this.headerClass;
			
		if(this.headerLabelClass != null) 
			this.headerNode.className = this.headerLabelClass;
	},
	
	setConfig :function(state, config)
	{
		this.state = state.toUpperCase();
		this.config = config;
	},
	
	getConfig :function()
	{
		return this.config;
	},
	
	getError: function()
	{
		var errorMessage = "";
		return errorMessage;
	},
	
	getWarning: function()
	{
		var warningMessage = "";
		return warningMessage;
	}

});
