/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
//
// pc 09/08/09
// This file doesn't seem to be used by any JS file.
//

dojo.provide("com.ibm.rational.test.lm.web.ui.internal.widgets.RLMTable");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil");
//Commented line below to get rid of load error in FireFox
//dojo.require("com.ibm.rational.test.lm.web.client.internal.Catalog");

dojo.declare(
    "com.ibm.rational.test.lm.web.ui.internal.widgets.RLMTable", 
    [dijit._Widget, dijit._Templated],
{
/*
 * usage
 *	<div dojoType="com.ibm.rational.test.lm.web.ui.internal.widgets.RLMTable" idCol="<column to use for id>" tableId="<id to use for table>"></div>
 *
 *
 *  var table = new custom.widgets.RLMTable({"idCol": "<column to use for id>" , 
 *										     "id": "<id under which table is placed>",
 *										     "tableId": "<id to use for the table>"});
 *	Note:
 *		tableId should be unique for tables elsewise a clash will occur if multiple tables occur on the
 *		same page with the same id.
 *
 *  Here is an example of a table declaration in the html.
 *
 *     <div dojoType="com.ibm.rational.test.lm.web.ui.internal.widgets.RLMTable" 
 *     	   rowClickEvent="myReservationsRowClickHandler"
 *          tableId="myReservationsResultsTable" 
 *          id="my_reservations_results"
 *          width="99%"
 *          sortable="true"
 *          style="background: none !important; border: 0px !important;"
 *          columns="{'visibleId':'resId',
 *          			 'machine':{'hierarchy':['machine', 'hostname'], 'nametouse':'resMachineHostname'},
 *          			 'reserveFrom':'resStartDate',
 *          			 'reserveTo': 'resEndDate',
 *          			 'requestId':{'hierarchy':['requestSummary', 'visibleId'], 'nametouse':'resRequestId'},
 *          			 'requestStatus':{'hierarchy':['requestSummary', 'currentState'], 'nametouse':'resRequestStatus'},
 *          			 'assignedTo':{'hierarchy':['requestSummary', 'fulfiller', 'name'], 'nametouse':'resAssignedTo'}}"
 *          columnCBs="{'reserveFrom': Request.fixColumn, 'reserveTo': Request.fixColumn}"
 *          maxrows="10"
 *          sortFunctions="{'reserveFrom': Request.sortDates, 'reserveTo': Request.sortDates}">
 *     </div>
 * 
 */ 
	    templateString: "<div dojoType=\"${dojoType}\" columns=\"${columns}\"" +
	    				" id=\"${id}\" dojoAttachPoint=\"controlNode\" rowClickEvent=\"${rowClickEvent}\"" +
	    				" width=\"${width}\" noHeaders=\"${noHeaders}\" idCol=\"${idCol}\" tableId=\"${tableId}\" columnCBs=\"${columnCBs}\"" +
	    				" hilite=\"${hilite}\" textrow=\"${textrow}\" sortFunctions=\"${sortFunctions}\"" +
	    				" attrFunc=\"${attrFunc}\" maxrows=\"${maxrows}\" loadSortColumn=\"${loadSortColumn}\" sortable=\"${sortable}\"" +
	    				" vcellalign=\"${vcellalign}\" cellalign=\"${cellalign}\" getCellDataHandlers=\"${getCellDataHandlers}\"" +
	    				" columnClickHandlers=\"${columnClickHandlers}\"" +
	    				" def_valign=\"${def_valign}\" ></div>",
	    controlNode: null,
	    // idCol is the column within the data that can be used as the uuid to be used for other operations
	    // it can have the form of just a string, or it can be an object.  For example,
	    // 
	    // idCol = "id"
	    //
	    // idCol = { 'hierarchy': ['machine' : 'id' ] }
	    //
	    // The above uses the hiearcy notation to find the id.
	    idCol: "",
	    // tableId is the id that will be used for the table when it is created.  It should not be the same as the id used in
	    // the div tag for id for the widget.
	    tableId: "",
	    // The type of widget
	    dojoType: "",
	    // This is the width of the table, it can be a percentage as well as other forms of units
	    width: "",
	    //This is a flag to tell the widget to not show the column headers
	    noHeaders: "false",
	    //
	    //reverseorder: "false",
	    
	    // columns is a JSON object that has a listing of the columns. It has the following form:
	    //
	    // { '<data field name>' : '<column 1 message lookup>', '<data field name>' : '<column 2 message lookup>' 
	    //	 '<place name>' : 'hierarchy' : { [ '<top level stucture name>', '<2nd level structure/field name>', ... '<nth level field name>'],
	    //	 'nametouse' :' <column message lookup>' }
	    //
	    // Note: In the above structure, the bracketed, i.e. '<' and '>', data is what needs to be entered into the structure. 
	    //       The 'hierarchy' structure above is a special structure signifying how to find data that is stored hierarchically
	    //       in the data structure.
	    columns: "",
	    // columnCBs are call backs that can be used for some, all, or none of the columns.  It has the following form:
	    //
	    // { '<column i>' : call back function, '<column j>' : call back function .... }
	    columnCBs: "",
	    // hilite either allows hover highlighting or shuts it off
	    hilite: true,
	    //textrow allows a row of text to be added as the first row in a table.  This is good for giving instrutions and the like
	    textrow: "",
	    //This is an internal paratmeter for knowing how many columns there are
	    numColumns: 0,
	    //sortable is a flag to know whether the table is sortable or not
	    sortable: "true",
	    // sortFunctions are used to know how to sort the data properly.  The table has built in sorts by text, but it does not
	    // know how to sort more complicated data such as images or time properly.  These would have to be done with a sort function.
	    // This is set up the same as the call back mechanism as follows:
	    //
	    // {'<column>':sortcallback}
	    //
	    // sortcallback has the following signature: sortcallback( celli, celli text, cellj, cellj text, direction )
	    //
	    // direction is the either 1 ascending  or -1 descending
	    sortFunctions: "",  //ensure that these are strings, otherwise they do not work properly when instantiating the widgets
	    sortDirection: 0,  //ascending is 1, descending is -1, 0 is unset
	    //Keeps track of the previous sorted column to know what column header needs to be reset properly if another column is sorted
	    previousSortedColumn: null,
	    table: null,
	    // maximum number of rows to show per page
	    maxrows: -1,
	    rowsShowing: 0,
	    currentstoreIdx:0,
	    currentDataSetStartIdx: 0,
	    dataStore: null,
	    // loadSortColumn is the sorting that should be done on the data before it is loaded into the table.
	    // It is an object, that has the following structure:
	    // 
	    // {'<column>':[direction, sort function]}
	    loadSortColumn: "",
	    attrFunc: function( domNode, columnName, columnValue ) {},
	    //Used to keep track of the current tab index on the page
	    currentTabIndex:-1,
	    //The default vertical alignment for the table cells
	    def_valign: "",
	    //vertical alignment array for the tables cells.  Format is as follows:
	    //
	    // { '<column a>': '<valign value>' .... }
	    vcellalign: "",
	    //horizontal alignment array for the tables cells.  Format is as follows:
	    //
	    // { '<column a>': '<align value>' .... }
	    cellalign: "",
	    // getCellDataHandlers are functions used to get data from the JSON row data.  It may be used to build up
	    // a piece of data from several elements in the row of data.  It has the following format
	    //
	    // { '<column a>' : hanlder( JSON data row, DOM cell, current column, all column amppings )
	    getCellDataHandlers: "",
	    // columnClickHandlers are handlers for handling the clicks on specific cells of the table.  They have the following
	    // format.
	    //
	    // { '<column a>' : fnc( event ) }
	    columnClickHandlers: "",
	    //table row data lookup
	    rowToDataLookup : {},
	    //paging functions
	    nextPageFnc: function( event )
	    {
	    	var disable = true;
	    	
	    	if( event && event.preventDefault )
	    	{
	    		event.preventDefault();
	    	}
	    	else if( window.event )
	    	{
	    		window.event.cancelBubble = true;
	    	}
	    	
	    	if( this.currentstoreIdx != this.dataStore.length )
	    	{
		    	this.controlNode.innerHTML = "";
		    	if( this.currentstoreIdx + this.maxrows >= this.dataStore.length )
		    	{
		    		disable = true;
		    	}
		    	
	    		this.fillTable( this.dataStore, null );
	    	}
	    	
	    	if( disable )
	    	{
		    		//Disable the Page Forward Link
		    		var linkf = dojo.byId( this.tableId + "_linkf" );
		    		if( linkf )
		    		{
		    			linkf.className = "pagingLinkDisabled";
		    		}	
	    	}
	    	
    		//Enable the Page Reverse Link
    		var linkp = dojo.byId( this.tableId + "_linkp" );
    		if( linkp )
    		{
    			linkp.className = "pagingLink";
    		}		    			
	    	
	    	
	    	return( false );
	    },
	    
	    prevPageFnc: function( event )
	    {
	    	var disable = false;
	    	
	    	if( event && event.preventDefault )
	    	{
	    		event.preventDefault();
	    	}
	    	else if( window.event )
	    	{
	    		window.event.cancelBubble = true;
	    	}
	    	
	    	if( this.currentDataStoreStartIdx != 0 )
	    	{
	    		this.controlNode.innerHTML = "";
	    		//update the current ptr to point back at most maxrows.
	    		this.currentstoreIdx = this.currentDataStoreStartIdx - this.maxrows;
	    		this.currentstoreIdx = ( this.currentstoreIdx < 0 ) ? 0 : this.currentstoreIdx;
	    		if( this.currentstoreIdx == 0 )
	    		{
	    			disable = true;
	    		}
	    		
	    		this.fillTable( this.dataStore, null );
	    	}
	    	
	    	if( disable )
	    	{
	    		//Disable the Page Reverse Link
	    		var linkp = dojo.byId( this.tableId + "_linkp" );
	    		if( linkp )
	    		{
	    			linkp.className = "pagingLinkDisabled";
	    		}		    			
	    	}
	    	
	    	//Enable the Page Forward Link
    		var linkf = dojo.byId( this.tableId + "_linkf" );
    		if( linkf )
    		{
    			linkf.className = "pagingLink";
    		}	
	    	
	    	return( false );
	    },
	    
	    postCreate: function()
	    {
	    	if( this.idCol && ( this.idCol.indexOf( "{" ) != -1 ) )
	    	{
	    		eval( "this.idCol = " + this.idCol );
	    	}
	    	
	    	if( this.columns )
	    	{
	    		eval( "this.columns = " + this.columns );
	    	}
	    	
	    	if( this.columnCBs )
	    	{
	    		eval( "this.columnCBs = " + this.columnCBs );
	    	}
	    	
	    	if( this.colWidths )
	    	{
	    		eval( "this.colWidths = " + this.colWidths );
	    	}
	    	
	    	if( this.sortFunctions )
	    	{
	    		eval( "this.sortFunctions = " + this.sortFunctions );
	    	}
	    	
	    	if( this.maxrows )
	    	{
	    		eval( "this.maxrows = " + this.maxrows );
	    	}
	    	
	    	if( this.loadSortColumn )
	    	{
	    		eval( "this.loadSortColumn = " + this.loadSortColumn );
	    	}
	    	
	    	if( this.sortable )
	    	{
	    		eval( "this.sortable = " + this.sortable );
	    	}
	    	
	    	if( this.valign )
	    	{
	    		eval( "this.vcellalign = " + this.vcellalign );
	    	}
	    	
	    	if( this.cellalign )
	    	{
	    		eval( "this.cellalign = " + this.cellalign );
	    	}
	    	
	    	if( this.rowClickEvent )
	    	{
	    		eval( "this.rowClickEvent = " + this.rowClickEvent );
	    	}
	    	
	    	if( this.getCellDataHandlers )
	    	{
	    		eval( "this.getCellDataHandlers = " + this.getCellDataHandlers );
	    	}
	    	
	    	if( this.columnClickHandlers )
	    	{
	    		if( this.rowClickEvent && this.rowClickEvent != "" )
	    		{
	    			this.textrow = "ERROR: Row Click Handlers as well as column click handlers are being assigned.";
	    		}
	    		
	    		eval( "this.columnClickHandlers = " + this.columnClickHandlers );
	    	}
	    },
	    rowClickEvent: "",
	    startup: function() {},
	    clear: function()
	    {
	    	this.controlNode.innerHTML = "";
	    	this.currentstoreIdx = 0;
	    },
	    
	    setContent: function( content )
	    {
	    	this.controlNode.innerHTML = "<h2>" + content + "</h2>";
	    },
	    
	    _getMessage: function(keyword) 
	    {
		   var RtlmUiUtil = com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil;
			
	       try {
	           var str = RtlmUiUtil.getMessage(keyword);
	           return str;
	       }
	       catch(e) {
	       }
	       return keyword;
	    },
	    
	    fillTable: function( JSArray, mappings )
	    {
	        //Set up a table with no padding for cells and no space between cells
            this.table = document.createElement("table");
            this.table.setAttribute("id", this.tableId );
            this.table.setAttribute( "summary", this._getMessage( "ResultsSummary" ) );
            this.table.setAttribute("cellpadding", "4" );
            this.table.setAttribute("cellspacing", "0" );
            this.table.setAttribute("widgetid", this.id );
            if( this.width != null && this.width.length > 0 )
            {
            	this.table.setAttribute( "width", this.width );
            }
                                  
            this.domNode.appendChild( this.table );
            
            var dhtmlTable = document.getElementById( this.tableId );
            
            //printObjectFields( JSArray );
            
            var machineData = JSArray;//getDataItem( JSArray, "values" )
            
            if( mappings )
            {
            	this.columns = mappings;
            }
            
            this.dataStore = machineData;
            
            if( this.loadSortColumn && this.loadSortColumn != "" )
            {
            	this._sortDataByColumn( this.loadSortColumn ); 
            }
            
            //if( this.noHeaders != "true" )
            //{
            	this._createTableHeaders( dhtmlTable, this.dataStore, this.columns );
            //}
            
	        this._createTableRows( dhtmlTable, this.dataStore, this.columns );
	    },
	    
	    _sortDataByColumn: function( sortCriteria )
	    {
	    	var key = null;
	    	
	    	for( key in sortCriteria )
	    	{
	    		break;
	    	}
	    	
	    	if( key && this.dataStore )
	    	{
	    		var direction = sortCriteria[ key ][ 0 ];
	    		var fnc = sortCriteria[ key ][ 1 ];
	    		
	    		for( var i = 0; i < this.dataStore.length; i++ )
	    		{
	    			for( var j = i + 1; j < this.dataStore.length; j++ )
	    			{
	    				if( fnc( key, this.dataStore[ i ], this.dataStore[ j ], direction ) )
	    				{ 
	    					var swap = this.dataStore[ i ];
	    					this.dataStore[ i ] = this.dataStore[ j ];
	    					this.dataStore[ j ] = swap;
	    				}
	    			} 
	    		}
	    	}
	    },
	   
	   ///////////////////////////////////////////////////////////////////////////////////////
	   // This method creates the headers for the table.   The headers are created using the
	   // the columnMappings that are passed in.  These column mappings object is a JSON object
	   // that contains the mappings between columns and data within the table.
	   ///////////////////////////////////////////////////////////////////////////////////////
	    _createTableHeaders: function( htmlTable, JSArray, columnMappings )
        {
	        //get the first element of the JSON array and
	        //get the column names to use
	        
	        for ( var elem in columnMappings )
	        {
	        	this.numColumns++;
	        }
	        
	        var thead = document.createElement( "thead" );
	        thead.setAttribute( "id", this.tableId + "headergroup" );
	        if( this.noHeaders == "true" )
	        {
	        	thead.style.display = "none";
	        }
	        
	        htmlTable.appendChild( thead );
	        thead = document.getElementById( this.tableId + "headergroup" );

	        var headerRow = document.createElement("tr");
        	
	        headerRow.setAttribute( "id", this.tableId + "header" );
	        headerRow.setAttribute( "widget", this.id );
	        headerRow.className = "searchResults_headerClass";
	        thead.appendChild(headerRow);
            var regex = new RegExp( "\\b[a-zA-Z0-9]*" );
        	
        	this.currentTabIndex = this._parsePageToFindMaxTabIndex();
        	
	        for ( var elem in columnMappings )
	        {
	        	//this.numColumns += 1;
		        var columnInfo = columnMappings[ elem ];
		        var headers = this._getColumnUseName( columnInfo );
        				
		        var htmlHRow = document.getElementById( this.tableId + "header");
        		
		        var colElem = document.createElement( "th" );
		        var match = regex.exec( elem );
		        colElem.setAttribute( "id", this.tableId + "sr_" + match[0] );
		        colElem.setAttribute( "column", match[0] );
		        colElem.setAttribute( "msgscol", headers );
		        //Set up the coumn headers with left alignment
		        colElem.setAttribute( "align", "left" );
		        colElem.setAttribute( "title", this._getMessage( headers ) );
		        
		        if( this.sortable )
		        {
		            if( colElem.attachEvent )	
			        {
				        colElem.attachEvent( "onclick", this.sortColumn );
			        }
			        else if( colElem.addEventListener )
			        {
				        colElem.addEventListener( "click", this.sortColumn, false );
			        }
			        
			        colElem.className = "sortableColumn " + this.tableId + "_" + match[0];
		        }
		        
		        var link = this._createlink( null, 
		        							 "sortableColumn cellLink", 
		        							 "", 
		        							 null, 
		        							 this._getMessage( headers ), 
		        							 null, 
		        							 null, 
		        							 this.currentTabIndex++ );
		        colElem.appendChild( link );
		        htmlHRow.appendChild( colElem );
	        }
		},
		
		////////////////////////////////////////////////////////////////////////////////////
		//Create a DOM object <a> object and allows the setting of 
		// id, class, event attachment, text for link/object, title, and tabIndex
		//
		// id, method, fnc, title, and htmlObject can be null.
		//
		// if no method is passed in, then a default onclick method is added that cancels
		// the current click on the link.  The canceling of the click is necesary so that
		// the link does not forward the page to the home page.
		//
		// If htmlObject is not null, then text is ignored.
		//
		// The return is a <a> DOM node that can then be added to a parent element within the
		// table.
		////////////////////////////////////////////////////////////////////////////////////
		_createlink: function( id, clsname, method, fnc, text, title, htmlObject, tabIndex )
		{
			var link = document.createElement( "a" );
			
			if( id )
			{
				link.id = id;
			}
			
			if( title )
			{
				link.setAttribute( "title", title );
			}
			
			if( method.length > 0 && fnc )
			{
				if( link.attachEvent )
				{
					link.attachEvent( "on" + method, fnc );
				}
				else if( link.addEventListener )
				{
					link.addEventListener( method, fnc, false );
				}
			}
			else
			{
				if( link.attachEvent )
				{
					link.attachEvent( "onclick", this._cancelLinkOnClick );
				}
				else if( link.addEventListener )
				{
					link.addEventListener( "click", this._cancelLinkOnClick, false ); 
				}
			}
			
			//If the link does not have any tab index, then it is not
			//a clickable control.  Don't underline it causing a deceptive UI.
			if( link.attachEvent )
			{
				if( tabIndex != -1 )
				{
					link.attachEvent( "onmouseenter", this._highlightlink );
					link.attachEvent( "onmouseleave", this._unhighlightlink );
				}
				else
				{
					link.attachEvent( "onmouseenter", this._changeToHandPointerLink );
					link.attachEvent( "onmouseleave", this._changeToDefaultPointerLink );
				}
			}
			
			link.className = clsname;
			link.href="";
			link.setAttribute( "tabIndex", tabIndex );
		
			var node = ( htmlObject == null ) ? document.createTextNode( text ) : htmlObject;
			link.appendChild( node );
			
			return( link );
		},
		
		//////////////////////////////////////////////////////////////
		// Changes the class name so that the link can be highlighted
		//////////////////////////////////////////////////////////////
		_highlightlink: function( event )
		{
			event.srcElement.className = event.srcElement.className.replace( "cellLink", "cellLinkHover" );
		},
		
		//////////////////////////////////////////////////////////////////
		// Changes the class name so that the link will not be highlighted
		//////////////////////////////////////////////////////////////////
		_unhighlightlink: function( event )
		{
			event.srcElement.className = event.srcElement.className.replace( "Hover", "" );
		},
		
		//////////////////////////////////////////////////////////////
		// Changes the class name so that the link can be highlighted
		//////////////////////////////////////////////////////////////
		_changeToHandPointerLink: function( event )
		{
			event.srcElement.className = event.srcElement.className.replace( "columnLink", "columnLinkHover" );
		},
		
		//////////////////////////////////////////////////////////////////
		// Changes the class name so that the link will not be highlighted
		//////////////////////////////////////////////////////////////////
		_changeToDefaultPointerLink: function( event )
		{
			event.srcElement.className = event.srcElement.className.replace( "Hover", "" );
		},

		////////////////////////////////////////////////////////////////////////////////////////
		// This method cancels the default action on the clicked link.  For IE, clicks on a 
		// link that is in a row that has a rowClickEvent, must be passed on to the table rows
		// handler.  This is done in the else below.
		////////////////////////////////////////////////////////////////////////////////////////
		_cancelLinkOnClick: function( obj )
		{
			if( obj.preventDefault )
			{
				obj.preventDefault();
			}
			else
			{
				window.event.cancelBubble = true;
				if( window.event.srcElement.parentNode.tagName.toLowerCase() == "td" )
				{
					var td = window.event.srcElement.parentNode;
					var tr = window.event.srcElement.parentNode.parentNode;
					var tbl = tr;
						
					while( tbl.tagName.toLowerCase() != "table" )
					{
						tbl = tbl.parentNode;
					}
					
					if( tbl )
					{				
						var tblwidget = dijit.byId( tbl.attributes["widgetid"].value );
						//Forward the event to the row event handler
						if( tblwidget.rowClickEvent )
						{
							if( tr.fireEvent )
							{
								var evt = document.createEventObject();
								td.fireEvent( "onclick", evt );
							}
							//Set the source of the click to be the table row
							//window.event.srcElement = tr;
							//return( tblwidget.rowClickEvent( obj ) );
						}
						//Foward the event to the column handler
						else if( td.attributes[ "column" ] &&
							     //The checks for the column handler is made so that the
							     //firing of the event will not bubble up past the td element
							     //to a parent's onclick handler 
								 tblwidget.columnClickHandlers &&
								 tblwidget.columnClickHandlers[ td.attributes[ "column" ].value ] )
						{
							if( td.fireEvent )
							{
								var evt = document.createEventObject();
								td.fireEvent( "onclick", evt );
							}
						}
					}
				}
				else if( window.event.srcElement.parentNode.tagName.toLowerCase() == "th" )
				{
					var th = window.event.srcElement.parentNode;
					var tbl = window.event.srcElement.parentNode.parentNode;
					
					while( tbl.tagName.toLowerCase() != "table" )
					{
						tbl = tbl.parentNode;
					}
					
					if( tbl )
					{
						var tblwidget = dijit.byId( tbl.attributes["widgetid"].value );
						//Forward the event to the row handler
						if( tblwidget.sortable )
						{
							if( th.fireEvent )
							{
								var evt = document.createEventObject();
								th.fireEvent( "onclick", evt );
							}
						}						
					}
				}
			}
			
			return( false );
		},
		
		////////////////////////////////////////////////////////////////////////////////////////////
		// This method changes the column header to have the appropriate sort direction indicator
		// listed in the column header.
		////////////////////////////////////////////////////////////////////////////////////////////
		_changeColumnSortDirection: function( htmlColHeader, columnName )
		{
			var msgcol = htmlColHeader.attributes[ "msgscol" ].value;
			var childNode = null;
				
			if( htmlColHeader && 
			    htmlColHeader.childNodes && 
			    ( htmlColHeader.childNodes.length > 0 ) &&
			    ( htmlColHeader.childNodes[ 0 ].tagName.toLowerCase() == "a" ) )
			{
				var tabIndex = htmlColHeader.childNodes[ 0 ].tabIndex;
	        	childNode = this._createlink( null, 
		        	 					 	  ( ( tabIndex == -1 )  ? "sortableColumn" : "sortableColumn cellLink" ), 
		        	 						  "", 
		        	 						  null, 
		        							  this._getMessage( msgcol )  + ( ( this.sortDirection == 1 ) ? " \u25b2" : " \u25bc" ), 
		        							  null, 
		        							  null, 
		        							  tabIndex );
	        }
	        else
	        {
				childNode = document.createTextNode( this._getMessage( msgcol ) + ( ( this.sortDirection == 1 ) ? " \u25b2" : " \u25bc" ) );
			}
			
			htmlColHeader.replaceChild( childNode, htmlColHeader.childNodes[ 0 ] );
			
			if( this.previousSortedColumn != columnName )
			{
				var parent = htmlColHeader.parentNode;
				
				for( var i = 0; i < parent.childNodes.length; i++ )
				{
					if( parent.childNodes[ i ].attributes[ "column" ].value == this.previousSortedColumn )
					{
						var colHeader = parent.childNodes[ i ];
						msgcol = this._getMessage( parent.childNodes[ i ].attributes[ "msgscol" ].value );
						if( colHeader && 
						    colHeader.childNodes && 
						    ( colHeader.childNodes.length > 0 ) &&
						    ( colHeader.childNodes[ 0 ].tagName.toLowerCase() == "a" ) )
						{
							var tabIndex = colHeader.childNodes[ 0 ].tabIndex;
				        	childNode = this._createlink( null, 
					        	 					 	  ( ( tabIndex == -1 ) ? "sortableColumn" : "sortableColumn cellLink" ), 
					        	 						  "", 
					        	 						  null, 
					        							  this._getMessage( msgcol ), 
					        							  null, 
					        							  null, 
					        							  tabIndex );
				        }
				        else
				        {
							childNode = document.createTextNode( this._getMessage( msgcol ) );
						}
						
						parent.childNodes[ i ].replaceChild( childNode, parent.childNodes[ i ].childNodes[ 0 ] );
						break;
					}
				}
			}
		},
		
		//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
		// This function adds the data to the table.  The table to fill with data is htmlTable.
		// The data to fill the table with is found in JSArray. JSArray is a JSON object that contains
		// the data in any structure.  The columnMappings object maps from column to data field within
		// the JSArray[ i ] object.  
		// Furthermore, as alluded to above, JSArray is an array object.  Each row of data in the table
		// is an element of the JSArray.  
		// Furthermore, columnMappings has the following structure:
		//
		// { 'JSON object field name 1':'column name to use 1', 'JSON object field name 2': 'column name to use 2', ..... }
		//   -------------------------------------------------  --------------------------------------------------
		//                            |                                                    |
		//                         column 1                                             column 2           ... column N
		//
		// Above is shown how the data maps to the columns in the table.  One of other special case is data that needs
		// to be retrieved from the JSArray element that is not in a top level structure of the object.  For example,
		// given the objec below:
		//	
		// { "reservation" : {"request" : { "id" : 0, "state" : "fulfilled" } } }
		//
		// where the desire is to place the state in the table, then the following columnMappings structure can be used
		// { "state" : "hierarchy" : { [ "reservation", "request", "state" ], "nametouse" : "colname" } }
		//
		// In the above, "hierarchy" is used to tell the table generation engine tha the data to be found is in a hieararchical
		// structure, for example, in the above "state" is under the following:
		//
		// JSArray[ i ][ "reservation" ][ "request" ][ "state" ]
		// 
		////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
		_createTableRows: function( htmlTable, JSArray, columnMappings )
        {
	        //loop through the JSON array and put all the rows
	        //in place with their respective column values
	        
	        var tbody = document.createElement( "tbody" );
	        tbody.setAttribute( "id", this.tableId + "bodygroup" );
	        htmlTable.appendChild( tbody );
	        tbody = document.getElementById( this.tableId + "bodygroup" );
        	
	       	if( ( this.textrow != null ) && ( this.textrow != "" ) )
        	{
		        var textRow = document.createElement("tr");
		        textRow.setAttribute( "name", "notforsort" );
		        var colElem = document.createElement( "td" );
		        //Give a colspan this way instead of using
		        //colElem.setAttribute( "colspan", this.numColumns );
		        //This does not work for IE.
		        colElem.colSpan = this.numColumns;
		        var text = document.createTextNode( this._getMessage( this.textrow ) );
			    colElem.appendChild( text );
			    textRow.appendChild( colElem );
			    tbody.appendChild( textRow );
         	}
 			        	 
	        var first_one = true;
	        var start = 0;
	        var inc = 1;
	        
/*	        if( this.reverseorder == "true" )
	        {
	        	start = ( JSArray == null ) ? -1 : JSArray.length - 1;
	        	inc = -1;
	        }*/

   			var regex = new RegExp( "\\b[a-zA-Z0-9]*" );
   			
   			var firstrow = null;
   			this.rowsShowing = 0;   			
   			
   			//Set the start index for the current # of rows.
   			this.currentDataStoreStartIdx = this.currentstoreIdx;
   			
   			var tabIndex = this.currentTabIndex;
   			
	        for ( var index = this.currentstoreIdx; 
	        	( ( this.maxrows == -1 ) || ( this.rowsShowing < this.maxrows ) ) && ( JSArray && ( index < JSArray.length ) );
	        	index += inc )
	        {
	        	this.rowsShowing++;  //How many rows have been added
	        	this.currentstoreIdx++;	//Update the current datastore index
	        	
	        	var rowElem = JSArray[index];
	        	
	        	// if the object is a configuration, don't create an associate
	        	// array for the object, we need to preserve the object.
	        	//if(!(rowElem instanceof com.ibm.rational.test.lm._catalog.configuration))
		         //   rowElem = this._getObjectFields( JSArray[index] );
		            
		        var name = this._getRowName( rowElem );

		        var tblrow = document.createElement("tr");
		        
		        firstrow = ( firstrow != null ) ? firstrow : tblrow;
        			
        		if( this.rowClickEvent )
        		{
		        	tblrow.className = ( this.hilite ) ? "searchResults_normal rowLink" : "sr_nohilite rowLink";
		        }
		        else
		        {
		        	tblrow.className = ( this.hilite ) ? "searchResults_normal" : "sr_nohilite";
		        }
		        			
		        tblrow.setAttribute( "id", this.tableId + "_" + name );
		        tblrow.setAttribute( "uuid", name );
		        
		        if( name )
		        {
		        	this.rowToDataLookup[ name ] = JSArray[ index ];
		        }
        	
	            if( tblrow.attachEvent )	
		        {
		        	if( this.hilite )
		        	{
			        	tblrow.attachEvent( "onmouseenter", this._onMouseEnterRow );
			        	tblrow.attachEvent( "onmouseleave", this._onMouseLeaveRow );
			        }
			        
			        if( this.rowClickEvent )
			        {
			        	tblrow.attachEvent( "onclick", this.rowClickEvent );
			        }
		        }
		        else if( tblrow.addEventListener )
		        {
		        	if( this.rowClickEvent )
		        	{
			        	tblrow.addEventListener( "click", this.rowClickEvent, false );
			        }
		        }
		        
		        tbody.appendChild(tblrow);
		                		        		        		
		        var first_column = true;
		                				
		        for ( var map in columnMappings )
		        {
			        var colElem = document.createElement( "td" );
			        var column = this.getCellChild( rowElem, colElem, map, columnMappings, tabIndex, first_column );
			        var parent = tblrow;
        			
        			var match = regex.exec( map );        			
			        colElem.setAttribute( "id", this.tableId + index + match[0] );
			        if( this.vcellalign && this.vcellalign[ map ] )
			        {
			        	//If there is any valign for a column, set it up
			        	colElem.setAttribute( "valign", this.vcellalign[ map ] );
			        }
			        else if( this.def_valign )
			        {
			        	colElem.setAttribute( "valign", this.def_valign );			        	
			        }
			        
			        if( this.cellalign && this.cellalign[ map ] )
			        {
			        	colElem.setAttribute( "align", this.cellalign[ map ] );
			        }
			        
			        if( first_one )
			        {
				        colElem.className = "searchResults_firstrowcells " + this.tableId + "_" + match[0];
			        }
			        else
			        {
				        colElem.className = "searchResults_allothercells " + this.tableId + "_" + match[0];
			        }
			        
			        //Add column event handlers
			        if( this.columnClickHandlers && this.columnClickHandlers[ map ] )
			        {
			        	this._addEventHandler( colElem, "click", this.columnClickHandlers[ map ] );
			        }
			         
			        //Set up and attribute for use in sorting			        
			        colElem.setAttribute( "column", map );
			        
			        if( this.attrFunc )
			        {
			        	this.attrFunc( colElem, map, column );
			        }
        			
        			if( column.tagName && column.tagName.toLowerCase() == "a" && this.rowClickEvent )
        			{        			
	        			if( first_column )
	        			{
	        				tabIndex++;
	        			}
			        }
			        else if( column.tagName && column.tagName.toLowerCase() == "a"  && 
			        		this.columnClickHandlers && this.columnClickHandlers[ map ] )
			        {
	        			tabIndex++;
			        }
			        
			        tblrow.appendChild( colElem );
			        first_column = false;
		        }
        		        		
		        first_one = false;
	        }
	        
	        if( ( this.maxrows != -1 ) && JSArray && ( JSArray.length > this.maxrows ) )
	        {
	        	//Add a row that has the next link etc.
	         
		        var linkRow = document.createElement("tr");
		        linkRow.setAttribute( "name", "notforsort" );
		        var colElem = document.createElement( "td" );
		        //Give a colspan this way instead of using
		        //colElem.setAttribute( "colspan", this.numColumns );
		        //This does not work for IE.
		        colElem.colSpan = this.numColumns;
		        colElem.setAttribute( "align", "right" );
				colElem.className = "searchResults_allothercells";
				
				var linkf = this._createlink( this.tableId + "_linkf",
											  "pagingLink", 
											  "click", 
											  dojo.hitch( this, this.nextPageFnc ), 
											  ">",
											  this._getMessage( "pageforward" ), 
											  null, 
											  tabIndex++ );
				var linkp = this._createlink( this.tableId + "_linkp",
											  "pagingLinkDisabled", 
											  "click", 
											  dojo.hitch( this, this.prevPageFnc ), 
											  "<", 
											  this._getMessage( "pagereverse" ),
											  null, 
											  tabIndex ); 
						        
		        colElem.appendChild( linkp );
			    colElem.appendChild( linkf );
			    
			    linkRow.appendChild( colElem );
			    tbody.appendChild( linkRow );
	        }
        },
        
        _addEventHandler: function( /*html object*/htmlobject , /*action name*/name, /*event handler*/ handler )
        {
        	if( htmlobject && handler && name )
        	{
        		if( htmlobject.attachEvent )
        		{
        			htmlobject.attachEvent( "on" + name, handler );
        		}
        		else if( htmlobject.addEventListener )
        		{
        			htmlobject.addEventListener( name, handler, false );
        		}
        	}
        },
        
        _getDataItem: function( JSArray, memberArrayName )
        {
	        var data = null;
        	
	        for ( var member in JSArray )
	        {
		        if( memberArrayName == member )
		        {
			        return( JSArray[ member ] );
		        }
		        else if( typeof( JSArray[ member ] ) == "object" )
		        {
			        var test = getDataItem( JSArray[ member ], memberArrayName );
        			
			        if( test != null )
			        {
				        data = test;
				        return( data );
			        }
		        }	
	        }	
        },

		///////////////////////////////////////////////////////////////////////////////////
		// This method gets the data from the data array for a given column within the map.
		// The parameters are as follows:
		//
		// JSArray - JSON object row of data
		// htmlCell - The cell, i.e. <TD>, that the column data for the particular row will
		//			  be added to the table.
		// map - The current data field name to work on in the data row.
		// columnMaps - Complete column mappings for the table
		// tabIndex - The tab index that can be used for the particular cell element
		// first_column - flag to know whehter that this is the first column of the table
		//                or not.
		//
		// This function returns the htmlObject that is created to fill the table cell.  
		// Essentially this object is a DOM node.  
		//
		// Furthermore, the htmlCell passed in, if it is not null or undefined, the 
		// returned DOM node above will have been already added to the table cell.
		///////////////////////////////////////////////////////////////////////////////////
        getCellChild: function( JSArray, htmlCell, map, columnMaps, tabIndex, first_column )
        {
        	var htmlObject = null;
        	
        	var cellData = null;
        	var cellText = null;
        	
        	if( this.getCellDataHandlers[ map ] )
        	{
        		cellData = dojo.hitch( this, this.getCellDataHandlers[ map ] )( JSArray, htmlCell, map, columnMaps );
        	}
        	
//        	if( !cellData && JSArray.getAttribute && typeof( JSArray.getAttribute ) == "function" )
//        	{
//        		//For new catalog API
//                var catalog = new com.ibm.rational.test.lm.web.client.internal.Catalog();
//                var template = catalog.getTemplate();
//                
//                // ensure that the map value is an attribute in the configuration.
//                // the map value could be columnCB directives like "!radiobutton"
//                if(template.isValidAttributeName(map))
//        		    cellData = JSArray.getAttribute( map );
//        	}
        	
        	if( !cellData && ( columnMaps != null ) && ( typeof( columnMaps[ map ] ) == "object" ) )
        	{
        		var startobject = JSArray;
        		for( var i = 0; i < columnMaps[ map ][ "hierarchy" ].length; i++ )
        		{
        			try
        			{
        				if( startobject.getAttribute && typeof( startobject.getAttribute ) == "function" )
        				{
        					startobject = startobject.getAttribute( columnMaps[ map ][ "hierarchy" ][ i ] );
        				}
        				else
        					startobject = startobject[ columnMaps[ map ][ "hierarchy" ][ i ] ];
        			}
        			catch( e )
        			{
        				htmlObject = document.createTextNode( "" );
        				htmlCell.appendChild( htmlObject );
        				return( htmlObject );
        			}
        		}
        		
        		if( this.columnCBs && this.columnCBs[ map ] )
        		{
        			var cell = new custom.widgets.Cell( htmlCell, this.tableId, this.id, map );
        			htmlObject = this.columnCBs[ map ]( cell, map, startobject, tabIndex );
        			//Check to see if it a html node
        			if( !htmlObject.nodeType )
        			{
        				//Assume that the data passed back is a string that can be displayed
        				//in the table cell
        				cellText = htmlObject;
        				htmlObject = document.createTextNode( htmlObject )
        			}
        		}
        		else
        		{
        			htmlObject = document.createTextNode( startobject );
        			cellText = startobject;
        		}
        	}
        	else if( !cellData && this.columnCBs && this.columnCBs[ map ] )
        	{
         		var cell = new custom.widgets.Cell( htmlCell, this.tableId, this.id, map );
        		htmlObject = this.columnCBs[ map ]( cell, map, JSArray[ map ], tabIndex );
       			//Check to see if it a html node
       			if( !htmlObject.nodeType )
       			{
       				//Assume that the data passed back is a string that can be displayed
       				//in the table cell
       				cellText = htmlObject;
       				htmlObject = document.createTextNode( htmlObject )
       			}
        	}
        	else
        	{
        		cellText = ( cellData ) ? cellData : 
        											  ( ( JSArray[ map ] != null ) ? JSArray[ map ] : "" )
				if( cellText == "" )
				{
					cellText = "\u00a0";
				}													  
        		htmlObject = document.createTextNode( cellText );
        	}
        	
			if( htmlCell && htmlObject.nodeType == 3 && this.rowClickEvent )
			{       
				//If the node is a text node and there is a row click event, then
				//only put a tabbable link on the first column. 			
				var link = this._createlink( null, 
											 ( first_column ) ? "cellLink" : "columnLink", 
											 "", 
											 null, 
											 null, 
											 null, 
											 htmlObject, 
											 ( first_column ) ? tabIndex : -1 );
				htmlCell.appendChild( link ); 
				htmlObject = link;
			 }
			 else if( htmlCell && htmlObject.nodeType == 3 && 
			 		  this.columnClickHandlers && 
			 		  this.columnClickHandlers[ map ])
			 {
				//If the node is a text node and there is a cell click event, then put tab indices
				//on all the event columns
				var link = this._createlink( null, "cellLink", "", null, null, null, htmlObject, tabIndex );
				htmlCell.appendChild( link ); 
				htmlObject = link;
			 }
			 else if( htmlCell )
			 {
			 	htmlCell.appendChild( htmlObject );
			 }
		        
	        return( htmlObject );
	    },
	    
	    //////////////////////////////////////////////////////
	    // Returns a count of the number of rows in the table.
	    // This is a count of the <tr> tags within the 
	    // <tbody> tag.
	    //////////////////////////////////////////////////////
	    getRowCount: function()
	    {
	    	var tbl = dojo.byId( this.tableId );
	    	var body = ( tbl == null ) ? null : tbl.getElementsByTagName( "tbody" );
	    	
	    	return( ( body != null ) ? body[ 0 ].getElementsByTagName( "tr" ).length : 0 ); 
	    },
	    
	    //////////////////////////////////////////////////////
	    // Returns the number of columns in the table.
	    // Essentially, this is the count of the <th> tags
	    // within the <thead> tag
	    //////////////////////////////////////////////////////
	    getNumColumns: function()
	    {
	    	var tbl = dojo.byId( this.tableId );    	
	    	var head = ( tbl == null ) ? null: tbl.getElementsByTagName( "thead" );
	    	
	    	return( ( head != null ) ? head[ 0 ].getElementsByTagName( "th" ).length : 0 );
	    },
	    
	    ///////////////////////////////////////////////////////
	    // Returns a html DOM node <td> for a particular
	    // row and column.
	    ///////////////////////////////////////////////////////
	    getCell: function( rowNumber, cellNumber )
	    {
	    	var tbl = dojo.byId( this.tableId );
	    	var body = tbl.getElementsByTagName( "tbody" );	 
	    	var row = ( body[ 0 ].getElementsByTagName( "tr" ) )[ rowNumber ];
	    	var cell = ( row.getElementsByTagName( "td" ) )[ cellNumber ]; 
	    	
	    	return( cell );  		
	    },
	    
	    ////////////////////////////////////////////////////////
	    // Returns the DOM rows in the table under the <tbody>
	    ////////////////////////////////////////////////////////
	    getRows: function()
	    {
	    	var tbl = dojo.byId( this.tableId );
	    	var body = tbl.getElementsByTagName( "tbody" );	 
	    	var rows = body[ 0 ].getElementsByTagName( "tr" );
	    	return( rows );
	    },
	    
	    /////////////////////////////////////////////////////////////
	    // This function returns the elements that are a particular
	    // DOM node of a particular type.
	    /////////////////////////////////////////////////////////////
	    getElementsWithTagMatchingTableAndType: function( tag, type )
	    {
	    	var elems = this.table.getElementsByTagName( tag );
	    	
	    	var types = [];
	    	var count = 0;
	    	for( var i = 0; i < elems.length; i++ )
	    	{
	    		if( elems[ i ].type == type )
	    		{
	    			types[ count ] = elems[ i ];
	    			count++;
	    		} 
	    	}
	    	
	    	return( types );
	    },
	    
	    /////////////////////////////////////////////////////////////////
	    // Returns the next id that can be used for a particular object
	    // within the table.  For example, placing input items within a
	    // cell usually need an id to be able to work on a particular 
	    // input object.  This function allows, each added input to the
	    // table to have a particular id that can be known.
	    /////////////////////////////////////////////////////////////////
	    getNextIdForType: function( tag, type )
	    {
	    	var types = this.getElementsWithTagMatchingTableAndType( tag, type );
	    	
	    	if( types.length == 0 )
	    	{
	    		return( this.tableId  + "_0" );
	    	}
	    	else
	    	{
	    		var idNum = 0;
	    		
	    		for( var i = 0; i < types.length; i++ )
	    		{
	    			var splitStr = types[ i ].id.split( "_" );
	    			var id = parseInt( splitStr[ splitStr.length - 1 ] );
	    			if( ( splitStr != null ) && ( id > idNum ) )
	    			{
	    				idNum = id;
	    			}	
	    		}
	    		
	    		idNum++;
	    		
	    		return( this.tableId  + "_" + idNum );
	    	}
	    },
	            
        //The function below generically goes through an
        //object and introspects if for its field members and
        //places them in an associateive array.
        _getObjectFields: function( generalObject )
        {
	        var objArray = new Array();
	        for ( var member in generalObject )
	        {		
		        if( typeof( generalObject[ member ] ) == "object" )
		        {
			        objArray[ member ] = this._getObjectFields( generalObject[ member ] );
		        }
		        else
		        {
			        objArray[ member ] = generalObject[ member ];
		        }
	        }
        	
	        return( objArray ); 
        },
        
        _getColumnUseName: function( columnInfo )
        {
        	if( typeof( columnInfo ) == "object" )
        	{
        		return( columnInfo[ "nametouse" ] );
        	}
        	
        	return( columnInfo );
        },
        
        //This function takes an object and gets the first
        //member name and returns that as the name to be used
        //to get the row from an associative array
        _getRowName: function( rowObject )
        {
        	if( rowObject.getId && ( typeof( rowObject.getId ) == "function" ) )
        	{
        		return( rowObject.getId() );
        	}
        	
        	if( this.idCol == null ||
        	    this.idCol == "" )
        	{
        		for( var col in this.columns )
        		{
        			this.idCol = col;
        			if( this.idCol.indexOf( "!" ) == 0 )
        			{
        				continue;
        			}
        			
        			break;
        		}
        	}
        	    
        	if( typeof( this.idCol ) == "object" )
        	{
        		var name = rowObject;
        		for( var i = 0; i < this.idCol[ "hierarchy" ].length; i++ )
        		{
        			if( name.getId && ( typeof( name.getId ) == "function" ) )
        			{
        				name = name.getId();
        			}
        			else
        				name = name[ this.idCol[ "hierarchy" ][ i ] ];
        		}
        		
        		return( name );
        	}
        	else   	
        	{
        		var htmlobj = this.getCellChild( rowObject, null, this.idCol, null, -1, false );
        		        		
 	        	return( htmlobj.nodeValue );
 	        }
        },

		////////////////////////////////////////////////////////////////////
		// Used for IE row highlighting.  The class name is associated with
		// the stylesheet.
		////////////////////////////////////////////////////////////////////
        _onMouseEnterRow: function()
        {
	        window.event.srcElement.className = 
	        	window.event.srcElement.className.replace( "searchResults_normal", "searchResults_highlight" );
        },

		////////////////////////////////////////////////////////////////////
		// Used for IE row highlighting.  The class name is associated with
		// the stylesheet.
		////////////////////////////////////////////////////////////////////
        _onMouseLeaveRow: function()
        {
	        window.event.srcElement.className = 
	        	window.event.srcElement.className.replace( "searchResults_highlight", "searchResults_normal" );
        },
        
		///////////////////////////////////////////////////////////////////////////////
		// This function is used to sort the table row data given a particular header
		// column click.  At this time, the sorting is done within a page of the table.
		// In the future, data will probably have to be sorted at the server, so that
		// the data comes back sorted properly within the complete set of data.
		///////////////////////////////////////////////////////////////////////////////		
		sortColumn: function()
		{
			var column = null;
			var widgetid = null;
			var htmlCol = null;
			
			if( window.event )
			{
				htmlCol = window.event.srcElement;
				column = window.event.srcElement.attributes[ "column" ].value;
				widgetid = window.event.srcElement.parentNode.attributes[ "widget" ].value;
			}
			else
			{
				htmlCol = this;
				column  = this.attributes[ "column" ].value;
				widgetid = this.parentNode.attributes[ "widget" ].value;
			}
			
			var sameColumn = false;
			
			if( column && widgetid )
			{	
				var tbl = dijit.byId( widgetid );
				var trows = tbl.getRows();
				
				if( ( tbl.previousSortedColumn != null ) && ( tbl.previousSortedColumn == column ) )
				{
					tbl.sortDirection = ( tbl.sortDirection == 1 ) ? -1 : 1;
					sameColumn = true;
				}
				else
				{
					tbl.sortDirection = 1; //Always start with an ascending sort on a new column click.
					sameColumn = false;
				}
				
				var rows = [];
				for( var iRow = 0; iRow < trows.length; iRow++ )
				{
					
					rows[ iRow ] = trows[ iRow ];
				}
				
				for( var iRow = 0; iRow < rows.length; iRow++ )
				{
					if( rows[ iRow ].attributes[ "name" ] &&
						rows[ iRow ].attributes[ "name" ].value == "notforsort" )
					{
						continue;
					}
					
					for( var jRow = iRow + 1; jRow < rows.length; jRow++ )
					{
						if( rows[ jRow ].attributes[ "name" ] &&
							rows[ jRow ].attributes[ "name" ].value == "notforsort" )
						{
							continue;
						}
						
						var iCells = rows[ iRow ].childNodes;
						var jCells = rows[ jRow ].childNodes;
						
						var celli = null;
						var cellj = null;
						
						var ciNode = null;
						var cjNode = null;
						
						for( var iCell = 0; iCell < iCells.length; iCell++ )
						{
							var colname = iCells[ iCell ].getAttribute( "column" );
							if( colname == column )
							{
								celli = iCells[ iCell ];
								if( celli.childNodes && 
									( celli.childNodes.length > 0 ) && 
									( celli.childNodes[ 0 ].tagName ) &&
									( celli.childNodes[ 0 ].tagName.toLowerCase() == "a" ) )
								{
									//Get the text node
									ciNode = celli.childNodes[ 0 ].childNodes;
								}
								else
								{
									ciNode = celli.childNodes;
								}
								
								break;
							}
								
						}
						
						for( var jCell = 0; jCell < jCells.length; jCell++ )
						{
							var colname = jCells[ jCell ].getAttribute( "column" );
							if( colname == column )
							{
								cellj = jCells[ jCell ];
								if( cellj.childNodes && 
									( cellj.childNodes.length > 0 ) && 
									( cellj.childNodes[ 0 ].tagName ) && 
									( cellj.childNodes[ 0 ].tagName.toLowerCase() == "a" ) )
								{
									//Get the text node
									cjNode = cellj.childNodes[ 0 ].childNodes;
								}
								else
								{
									cjNode = cellj.childNodes;
								}
								
								break;
							}
								
						}
												
						if( ciNode && cjNode && ciNode.length == 1 && cjNode.length == 1 )
						{
							if( ( tbl.sortFunctions && tbl.sortFunctions[ column ] && 
								  tbl.sortFunctions[ column ]( celli, ciNode[ 0 ].nodeValue, cellj, cjNode[ 0 ].nodeValue, tbl.sortDirection ) ) ||
								
								( ( !tbl.sortFunctions || ( tbl.sortFunctions && !tbl.sortFunctions[ column ] ) ) &&
								  ( ( ( tbl.sortDirection == 1 ) && ( ciNode[ 0 ].nodeValue > cjNode[ 0 ].nodeValue ) ) ||
						    		( ( tbl.sortDirection == -1 ) && ( ciNode[ 0 ].nodeValue < cjNode[ 0 ].nodeValue ) ) ) ) )
							{
								var swap = rows[ iRow ];
								rows[ iRow ] = rows[ jRow ];
								rows[ jRow ] = swap;
							}
						}
					}
				}
				
				tbl._changeColumnSortDirection( htmlCol, column );
				
				tbl.previousSortedColumn = column;
												
				var htmlTbl = dojo.byId( tbl.tableId );
	    		var body = htmlTbl.getElementsByTagName( "tbody" );
	    		
	    		for( var iRow = 0; iRow < rows.length; iRow++ )
	    		{
	    			if( iRow == 0 )
			        {
			        	for( var iCol = 0; iCol < rows[ iRow ].childNodes.length; iCol++ )
			        	{
				        	rows[ iRow ].childNodes[ iCol ].className = 
				        		rows[ iRow ].childNodes[ iCol ].className.replace( "searchResults_allothercells", "searchResults_firstrowcells" );
				        }
			        }
			        else
			        {
			        	for( var iCol = 0; iCol < rows[ iRow ].childNodes.length; iCol++ )
			        	{
				        	rows[ iRow ].childNodes[ iCol ].className =
				        		rows[ iRow ].childNodes[ iCol ].className.replace( "searchResults_firstrowcells", "searchResults_allothercells" );
				        }
			        }
	    		
	    			body[ 0 ].insertBefore( rows[ iRow ], body[ 0 ].childNodes[ iRow ] );
	    		}
			}
		},
		
		////////////////////////////////////////////////////////////////////////////
		// Parses the page that the table is on so that it can intelligently add
		// tabIndexes to the links that are added in the table 
		////////////////////////////////////////////////////////////////////////////
		_parsePageToFindMaxTabIndex: function()
		{
			return( this._parsePageForTabs( document ) );
		},
		
		////////////////////////////////////////////////////////////////////////////
		// The purpose of this function is to search what tab index the table can
		// start using.  The whole table is parsed, to find the greatest tabIndex.
		// This gives a tabIndex that can be used by the table to be able to tab
		// within the table.
		////////////////////////////////////////////////////////////////////////////
		_parsePageToFindStartTab: function()
		{
			var index = -1;
			
			if( this.controlNode.attributes && this.controlNode.attributes[ "tabIndex" ] )
			{
				return( parseInt( this.controlNode.attributes[ "tabIndex" ].value, 10 ) + 1 );
			}
			else
			{
				var relation = this.controlNode.previousSibling;
				
				do
				{
					var parent = relation.parentNode;
					
					while( ( relation != null ) && ( index == -1 ) )
					{
						index = this._parseChildrenForTabIndex( relation );
						
						if( ( index == -1 ) && relation.attributes && relation.attributes[ "tabIndex" ] )
						{
							index = parseInt( relation.attributes[ "tabIndex" ].value, 10 ) + 1;
						}
						
						relation = relation.previousSibling;
					}
					
					if( ( index == -1 ) && parent.attributes && parent.attributes[ "tabIndex" ] )
					{
						index = parseInt( parent.attributes[ "tabIndex" ].value, 10 ) + 1;
					}
					
					relation = parent.previousSibling;
				}
				while( index == -1 );
			}
			
			return( index );
		},
		
		_parseChildrenForTabIndex: function( parent )
		{
			var index = -1;
			
			//Loop starting at the last child as it will be closes to the table
			for( var i = parent.childNodes.length - 1; ( index == -1 ) && ( i >= 0 ); i-- )
			{
				if( parent.childNodes[ i ].attributes && parent.childNodes[ i ].attributes[ "tabIndex" ] )
				{
					return( parseInt( parent.childNodes[ i ].attributes[ "tabIndex" ].value, 10 ) + 1 );
				}
				else
				{
					index = this._parseChildrenForTabIndex( parent.childNodes[ i ] );
				}
			}
			
			return( index );
		},
		
		////////////////////////////////////////////////////////////////////////////
		// The purpose of this function is to search what tab index the table can
		// start using.  The whole table is parsed, to find the greatest tabIndex.
		// This gives a tabIndex that can be used by the table to be able to tab
		// within the table.
		////////////////////////////////////////////////////////////////////////////
		_parsePageForTabs: function( ancestor )
		{
			var index = -1;
			
			//Loop starting at the last child as it will be closes to the table
			for( var i = 0; ancestor.childNodes && ( i < ancestor.childNodes.length ); i++ )
			{
				if( ancestor.childNodes[ i ].attributes && ancestor.childNodes[ i ].attributes[ "tabIndex" ] )
				{
					var idx = parseInt( ancestor.childNodes[ i ].attributes[ "tabIndex" ].value, 10 );
					index = ( idx > index ) ? idx : index;
				}
				
				var idx = this._parsePageForTabs( ancestor.childNodes[ i ] );
				index = ( idx > index ) ? idx : index;
			}
			
			return( index );
		},
		
		getDataForRow: function( rowId )
		{
			return( this.rowToDataLookup[ rowId ] );
		}
});

dojo.declare(
    "custom.widgets.Cell", null,
	{
		column_mapping: "",
		tableid: "",
		table_w_id: "",
		domNode: null,
		constructor: function( domNode, id, widgetid, columnName )
		{
			this.domNode = domNode;
			this.column_mapping = columnName;
			this.tableid = id;
			this.table_w_id = widgetid;
		},
		
		getTable: function()
		{
			return( dijit.byId( this.table_w_id ) );
		},
		
		getCellColumn: function()
		{
			return( this.column_mapping );
		},
		
		getHtmlCell: function()
		{
			return( this.domNode );
		},
		
		getHtmlTableId: function()
		{
			return( tableid );
		}
	}
);
	
