/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
//
// pc 09/08/09
// This file doesn't seem to be used by any JS file.
//
dojo.provide("com.ibm.rational.test.lm.web.ui.internal.widgets.YetAnotherMachineConfigPanel");
 
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");

dojo.require("com.ibm.asq.common.web.client.internal.Catalog");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");
dojo.require("com.ibm.rational.test.lm.web.client.internal.config");

dojo.require("com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.widgets.layout.FormListener");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.widgets.FilteredSelectionDialog");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.widgets.ConfigThruReservationWidget");

(function() {

var RtlmUiUtil = com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil;
var ServiceResponseHandler = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var AssetUriUtil = com.ibm.rational.test.lm.web.ui.internal.pages.AssetUriUtil;

dojo.declare("com.ibm.rational.test.lm.web.ui.internal.widgets.YetAnotherMachineConfigPanel", 
    [dijit._Widget, dijit._Templated, 
	 com.ibm.rational.test.lm.web.ui.internal.widgets.layout.FormListener],
{    
    templateString: '<div class="config-editor" dojoAttachPoint="domNode" tabindex="-1">' +
                    '    <table border="0" cellpadding="0" cellspacing="0" width="100%"> ' +
                    '     <tr dojoAttachPoint="headerRowNode">' +
                    '       <td align="left" dojoAttachPoint="headerNode" colspan="3"></td> ' +
                    '       <td align="right" width="100%" dojoAttachPoint="actionsNode"></td> ' +
					'     </tr>' +
                    '     <tr>' +
					'     <tr align="left">' +
					'       <td align="left" dojoAttachPoint="partActionNode">' +
					'          <a class="configActionLink" dojoAttachPoint="addPartButtonNode"   dojoAttachEvent="onclick: _addNewPart"></a>' +
					'          |' +
					'          <a class="configActionLink" dojoAttachPoint="addConfigButtonNode" dojoAttachEvent="onclick: _addConfigPart"></a>' +
					'       </td>' +
					'     </tr>' +
                    '     <tr>' +
                    '       <td width="100%">' +
                    '         <div dojoAttachPoint="configurationNode">' +
                    '         </div>' +
                    '       </td>' +
                    '     </tr>' +
                    '    </table>' +
                    '</div>',

    widgetsInTemplate: true,
    
	//Buttons for adding a part and adding one by selecting a config
	addPartButtonLabel: RtlmUiUtil.getMessage("cfgAddPart"),
	addConfigButtonLabel: RtlmUiUtil.getMessage("cfgAddConfig"),
    
    // the type of the assset
    assetType: "Machine",
    
    // interal catalog object
    theCatalog: null,
	
	//Internal object of all the configs
	allConfigs:{},
	
	//The config
	configString:null,
		
	//Used to preserve the original config when in selectable mode
	originalConfig:null,
	
	title: "",
	
	_selectConfigAction:null,
	
	/* the state of the config panel */
	state: this.EDITABLE,
  
	/* the state that the config can be in which affects the display */
	EDITABLE: "EDITABLE",
	READONLY: "READONLY",
	SELECTABLE: "SELECTABLE",  // read only with check boxes to select param

	/* classes for various parts to allow override particular part of main class */
	headerClass: null,       // header div area for title and action
	headerLabelClass: null,  // header div area for title and action
	
	reqForm:null,  //The request form that is using this widget
    
    postCreate: function() 
    {
        this.inherited("postCreate", arguments);
		this.edited = false;
		this._initClasses();
		
        this.theCatalog = new com.ibm.asq.common.web.client.internal.Catalog();
		
		this.addPartButtonNode.innerHTML = this.addPartButtonLabel;
		this.addConfigButtonNode.innerHTML = this.addConfigButtonLabel;

		//Set the title of the panel
		this._setTitle(this.title);		
		
        if(this.configString == null) 
		{
			// this is a new config, we'll just create a blank one
			// create the editor for it.
            this.config = this.theCatalog.createConfiguration(this.assetType);
        }
        else 
		{
			//We have a config string so generate a config from it
			this.config = this.catalog.createConfigurationFromJson(this.configString);
			if (this.config) 
				this.assetType = this._getAssetTypeFromAsset(this.config);
        }
    },
    
	//Set the panel title
    _setTitle :function(title)
	{
		this.headerNode.innerHTML = title;
	},
	
	//Set the classes for the look of the area
	_initClasses :function()
	{
		// allow override the class of individual part from the main class
		if (this.headerClass != null)
			this.headerRowNode.className = this.headerClass;
			
		if(this.headerLabelClass != null) 
			this.headerNode.className = this.headerLabelClass;
	},

    _loadConfigurationToView: function()
    {
        // construct the form part that does the configuration editing.
        //
		//We need a table because a config can contain multiple parts
		//Each table row will be an expandable area that will contain a formlayout for a particular part
		//The user can add or remove parts if they wish.
		
		//Create the HTML table control that we will fill
		if (this.configTable == null) 
		{
			this.configTable = document.createElement("table");
			this.configTable.cellPadding = "0";
			this.configTable.cellSpacing = "0";
			this.configTable.border = "0";
			this.configTable.align = "left";
			this.configTable.width = "100%"
			
			this.tBody = document.createElement("tbody");
			this.configTable.appendChild(this.tBody);
		}
		else
		{
			//reloading an existing config so remove all the table rows
			while(this.configTable.rows.length > 0)  
		        this.configTable.deleteRow(this.configTable.rows.length-1); 
		}
		//Now create a table row for each part within the config
		var partCount = this.config.getRootParts().length;
		
		for (var i = 0; i < partCount; i++)
		{
			var thisPart = this.config.getRootPart(i);
			var thisLabel = this.config.getLabel(i);
			this._createPartRow(thisPart, thisLabel, this.tBody, partCount==1, /*if only 1 part then expand initially*/false);
		}
		
		this.configurationNode.appendChild(this.configTable);
    },
    
	//Creates a row for each of the parts in the config
	_createPartRow :function(thePart, thePartLabel, theTBody, theExpand, theEdit)
	{
		//get the label for the part.  If there is no label then make the label be a prompt
		var editLabel = false;
		if (thePartLabel == null || thePartLabel == "") 
		{
			thePartLabel = RtlmUiUtil.getMessage("cfgLabelPrompt");
			editLabel = true;
		}
		var row = document.createElement("tr");
		var td = document.createElement("td");

		//Create an instance of the widget that actually displays the part
		var partRow = new com.ibm.rational.test.lm.web.ui.internal.widgets.ConfigThruReservationWidget({part:thePart, expand:theExpand, edit:theEdit, partLabel:thePartLabel, editLabel:editLabel, reqForm:this.reqForm, state:this.state, origConfig:this.originalConfig});
		partRow.setChangeCallback(dojo.hitch(this, "_valueChanged"));
		td.appendChild(partRow.domNode);
		row.appendChild(td);
		theTBody.appendChild(row);
	},
	
	//Handle the addition of a part to the config	
	_addNewPart :function()
	{
		this.config.addRoot("Machine");
		var parts = this.config.getRootParts();
		var newPart = parts[parts.length-1];
		this._createPartRow(newPart, "", this.tBody, true, true);
		this._valueChanged();
	},
	
	//Handle the additon of a part (or parts) from a config
	_addConfigPart :function()
	{
		this.allConfigs = [];
		var configs = new com.ibm.rational.test.lm.web.client.internal.config();
		var responseHandler= new com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper(this, "_loadAllConfigsSuccessHandler", "_loadAllConfigsErrorHandler");
	
		configs.getAllWithDetails(responseHandler);
	},
	
	//Loaded the configs so lets show them in the dialog
	_loadAllConfigsSuccessHandler :function(response)
	{
		//Create the dialog
		this.selectDlg = new com.ibm.rational.test.lm.web.ui.internal.widgets.FilteredSelectionDialog({title:"Select Test Environments"});
		this.selectDlg.setOKaction( dojo.hitch( this, this._handleSelectOK ) );
		if (response) 
		{
			//Add each config to the dialog
			for (var i = 0; i < response.length; i++) 
			{
				var name = response[i].name;
				var id = response[i].id;
				
				this.selectDlg.addListItem(id, name);
				this.allConfigs[i] = {id:id, config:response[i].configuration};
			}
		}
		this.selectDlg.show();
	},
	
	//Handle the OK from the dialog
	_handleSelectOK :function()
	{
		//Get the selected items
		var newItems = this.selectDlg.getSelectedItems();
		//For each selected config, add it to the UI
		for (var i = 0; i < newItems.length; i++)
		{
			var id = newItems[i].id;
			var configString = null;
			for (var j = 0; j < this.allConfigs.length; j++) 
				if (this.allConfigs[j].id == id) 
				{
					configString = this.allConfigs[j].config;
					break;
				}
			if (configString != null)
			{
				var configToInsert = this.theCatalog.createConfigurationFromJson(configString);
				this.config.insertConfig(configToInsert);
				this._loadConfigurationToView();
				this._valueChanged();
			}
		}
	},
	
	_loadAllConfigsErrorHandler :function(errorType, errorMessage)
	{
		//MFV probably need something here		
	},
	
	//Method called by the Request Form to set the config to show
	setConfig :function(state, config)
	{
		this.state = state.toUpperCase();
		this.configString = null;
		
		//Save the original config - used when in "Selectable" mode.
		//In Selectable mode we let Larry mess with the congif but not save it.
		this.originalConfig = config;
		if (config != null)
			this.config = config.clone();
			
		if (this.state == this.SELECTABLE || state == this.READONLY)
		{
			this.partActionNode.style.display = "none";
		}
			
		this._loadConfigurationToView();
	},
	
	//Return the config to the form
	getConfig :function(reason)
	{
		//Here's the deal with the if statement below.
		//We let Larry modify the config in "Selectable" mode.
		//This means that if he wants to mess with the config in order to look for machines he can.
		//BUT we don't want to allow Larry to save the changes to the config so
		//If we are in "Selectable" mode return the original config
		if (this.state == this.SELECTABLE)
		{
				return(this.originalConfig);
		} 
		else
			return this.config;
	},
	
	getError: function()
	{
		var errorMessage = "";
		return errorMessage;
	},
	
	getWarning: function()
	{
		var warningMessage = "";
		return warningMessage;
	},
	
	_valueChanged : function()
	{
		this.edited = true;
		if (this.reqForm != null)
			this.reqForm.valueChanged(this.reqForm.CONFIGURATION_ID);
	},
	
	isEdited : function()
	{
		if (this.state == this.EDITABLE)
			return this.edited;
		else
			return false;
	}

});

})();
