/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
 //This widget is used for navigating the links and widgets in a page for Accessibility.
 //
 //If the desire is to activate a link, then override the onActivate method.  In this
 //method the code can be placed to activate the link such as when Activate Link is 
 //selected in JAWS.
 //
 //If the desire is to focus on the item, then th onFocus method should be overriden.
 //This will allow the desired effect when Move to Link is selected in the JAWS program.  
 
dojo.provide("com.ibm.asq.common.web.ui.internal.widgets.accessibility.SkipNavigation");

dojo.require("com.ibm.asq.common.web.ui.internal.util.MessageUtil");

(function() {

dojo.declare("com.ibm.asq.common.web.ui.internal.widgets.accessibility.SkipNavigation",
[dijit._Widget, dijit._Templated],
{
	templateString: '<div style="position: absolute; left: -3000px; width: 500px;" dojoattachpoint="domNode" class="skipnavigation">' +
					' <a href="#" dojoattachpoint="linkNode" dojoattachevent="onclick: _onSkipActivation, onfocus: _onFocusItem"></a>' +
					'</div>',
	linkname: "",
					
    postCreate: function() {
		
		var list = dojo.query("div.skipnavigation a", this.parent);
		var i=0;
		for(i=0; i<list.length; i++)
		{	
			if(list[i].innerHTML.indexOf(this.linkname) >0)
				return;
		}
 
		this.linkNode.appendChild( document.createTextNode( MessageUtil.getMessage( MessageBundle.COMMON, "skipto", this.linkname ) ) );
		if( this.parent && this.insertReference )
		{
			this.parent.insertBefore( this.domNode, this.insertReference );
		}
	},
	
	_onSkipActivation: function( event )
	{
		var evt = event;
		
		if( !event )
			evt = window.event;
		
		dojo.stopEvent( evt );
		
		this.onActivate();
		
	},
	
	_onFocusItem: function( event )
	{
		this.onFocus();
	},
	
	onActivate: function()  //Use this method for click activation, such as in JAWS Acivate Link
	{
		//override to get activation
	},
	
	onFocus: function() //Use this method for setting focus such as in JAWS "Move to Link"
	{
		//override to get focus
	}
});
})();