/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.asq.common.web.ui.internal.widgets.layout.FormCheckboxField");

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.layout.AbstractFormField");

(function() {
dojo.declare("com.ibm.asq.common.web.ui.internal.widgets.layout.FormCheckboxField", 
    com.ibm.asq.common.web.ui.internal.widgets.layout.AbstractFormField,
{
    // Summary:
    //    if set to true, an empty choice (option) will always be created
    //    at the first option in the dropdown list. 
    checked: false,
    
    postCreate: function() {
        this.inherited("postCreate", arguments);
		
		// override the root node's class to avoid 
		// the second td to overlap to the checkbox's
		// td.
	    this.domNode.className = "asq-section-form-field-checkbox";
		
        var td = this.fieldRowNode.insertCell(0);
        
        var inputLabel = document.createElement("label");
        this.checkbox = document.createElement("input");
        this.checkbox.type = "checkbox";
        this.checkbox.checked = this.checked;
        this.connect(this.checkbox, "onchange", "_valueChangedHandler");
        inputLabel.appendChild(this.checkbox)
        td.appendChild(inputLabel);
        
        this.formField = document.createElement("div");
        this.fieldHolderNode.appendChild(this.formField);
        
        this.fieldLabelNode.style.padding = "0 0 0.2em 0.4em";
        this.fieldLabelHolderNode.style.width = "99%";
        this.fieldHolderNode.style.width = "1%";
    },
    
    _valueChangedHandler: function()
    {
        this.onValueChanged(this, !this.checkbox.checked, this.checkbox.checked);
    },
    
    setValue: function(value)
    {
        this.checked = value;
        this.checkbox.checked = this.checked;
    },

    // Summary:
    //    Returns the value from the field. Subclass must override. A null is returned if
    //    no value is specified.
    //
    getValue: function()
    {
        return this.checkbox.checked;
    }
});

})();
