//debugFormLinkField
/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rational.test.lm.web.ui.internal.widgets.layout.FormLinkField");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.widgets.layout.AbstractFormField");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.layout.ASQValidateTextBox");
dojo.require("dojo.parser");
dojo.require("dijit.InlineEditBox");
dojo.require("dijit.form.Textarea");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil");

              

(function() {

var ValidateTextBox = com.ibm.asq.common.web.ui.internal.widgets.layout.ASQValidateTextBox;
var RtlmUiUtil = com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil;

dojo.declare("com.ibm.rational.test.lm.web.ui.internal.widgets.layout.FormLinkField", 
    com.ibm.rational.test.lm.web.ui.internal.widgets.layout.AbstractFormField,
{
 	linkButton: null,
	target:null,
	cancelButton: null,
	saveButton: null,	
	okButton: null,		
	textField: null,
	protocol: null,
	dialog: null,
    templateString:'<table tabindex="-1" id="${id}" dojoAttachPoint="domNode" class="section-form-field" tabindex="-1" border="0" cellpadding="0" cellspacing="0" width="100%">' +
                    '  <tr tabindex="-1" dojoAttachPoint="fieldRowNode">' +
                    '    <td tabindex="-1" class="field-label-td">' +
                    '      <div class="field-label" dojoAttachPoint="fieldLabelNode" tabindex="-1">' +
                    '      </div>' +
                    '    </td>' +
                    '    <td align="left" tabindex="-1" width=400px", class="field-td" dojoAttachPoint="linkOrTextNode">' +
                    '    </td>' +
                    '    <td align="left" tabindex="-1" class="field-td" dojoAttachPoint="saveEditButtonNode">' +
                    '    </td>' +
                    '    <td align="left" tabindex="-1" class="field-td" dojoAttachPoint="cancelButtonNode">' +
                    '    </td>' +
                    '  </tr>' +
                    '</table>',
					
    					
 
    postCreate: function() {
        this.inherited("postCreate", arguments);
    },

	_init: function(linkProtocol)
	{
		
		this.protocol = linkProtocol;		
		this.textField = new ValidateTextBox({
                    name: "textField",
                    externalValidation: true,
                    reportChangeWhenEdit: true,
                    value: this.target,
                    'class': this._getBaseClassName()
                });
		
		var argSave = {
            label:  RtlmUiUtil.getMessage("labelSaveButton"),
            showLabel: true,
            parent: this,
            onClick: dojo.hitch(this, "_onSave")
        };
		this.saveButton = new com.ibm.asq.common.web.ui.internal.widgets.Button(argSave);
		var argCancel = {
            label: RtlmUiUtil.getMessage("labelCancelButton"),
            showLabel: true,
            parent: this,
            onClick: dojo.hitch(this, "_onCancel")
        };
		
        this.cancelButton = new com.ibm.asq.common.web.ui.internal.widgets.Button(argCancel);
		
		var argLink = {
            label: linkProtocol,
            showLabel: true,
            //iconClass: "remoteconnection-property",
            parent: this,
            onClick: dojo.hitch(this, "_onLink")
        };				
		this.linkButton = new com.ibm.asq.common.web.ui.internal.widgets.Button(argLink);
		
		var argEdit = {
            label: RtlmUiUtil.getMessage("labelEditButton"),
            showLabel: false,
            iconClass: "edit-property",
            parent: this,
            onClick: dojo.hitch(this, "_onEdit")
        };
        this.editButton = new com.ibm.asq.common.web.ui.internal.widgets.Button(argEdit);
		this._switchIntoLinkMode();	 
	},
	
	
	_onLink: function()
	{
		window.open(this.target);

	},
		
	_onEdit: function()
	{
		this.textField.setValue(this.target);
		this._removeChildren();
		this.linkOrTextNode.appendChild(this.textField.domNode);		
	    this.saveEditButtonNode.appendChild(this.saveButton.domNode);		
        this.cancelButtonNode.appendChild(this.cancelButton.domNode);		
	},
	
	_onSave: function()
	{
		this.target = this.textField.getValue();
		if(this.target.indexOf("://") == -1)
			this.target = this.protocol + "://" + this.target;
		this.linkButton.setLabel(this.target);
		var oldValue = this.currentValue;
        this.currentValue = this.getValue(); 
        this.onValueChanged(this, oldValue, this.currentValue);
		this._switchIntoLinkMode();
	},
	
	_onCancel: function()
	{
		this._switchIntoLinkMode();
	},
	
	_switchIntoLinkMode: function()
	{
		this._removeChildren();
        this.linkOrTextNode.appendChild(this.linkButton.domNode);
        this.saveEditButtonNode.appendChild(this.editButton.domNode);
        this.formField = this.linkButton;
	},
	
	_removeChildren: function()
	{
		if (this.linkOrTextNode.hasChildNodes()) {
			while (this.linkOrTextNode.childNodes.length >= 1) {
				this.linkOrTextNode.removeChild(this.linkOrTextNode.firstChild);
			}
		} 
		if (this.saveEditButtonNode.hasChildNodes()) {
			while (this.saveEditButtonNode.childNodes.length >= 1) {
				this.saveEditButtonNode.removeChild(this.saveEditButtonNode.firstChild);
			}
		} 
		if (this.cancelButtonNode.hasChildNodes()) {
			while (this.cancelButtonNode.childNodes.length >= 1) {
				this.cancelButtonNode.removeChild(this.cancelButtonNode.firstChild);
			}
		} 

	},
	
	
    _valueChangedHandler: function()
    {
        var oldValue = this.currentValue;
        this.currentValue = this.getValue(); 
        this.onValueChanged(this, oldValue, this.currentValue);
    },
	
	
	
    setValue: function(value)
    {
	   this.target = value;
	   this.linkButton.setLabel(value);
    },

    // Summary:
    //    Returns the value from the field. Subclass must override. A null is returned if
    //    no value is specified.
    //
    getValue: function()
    {
		return this.target;
    },
    
    _getBaseClassName: function()
    {
        return "link-field";
    }
});





})();
