/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008,2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
InsertImagePlugin = dojo.provide("com.ibm.asq.common.web.ui.internal.widgets.richtext.plugins.InsertImagePlugin");
InsertImagePlugin.PLUGIN_ID = "insertimage"

dojo.require("dijit._editor._Plugin");
dojo.require("dijit.Dialog");
dojo.require("dijit.form.Button");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.richtext.plugins.InsertImageDialog");
dojo.require("com.ibm.asq.common.web.client.internal.Constants");
dojo.require("com.ibm.asq.common.web.ui.internal.util.Utility");
( function() {

	var Constants = com.ibm.asq.common.web.client.internal.Constants;
    var TeamServerClient = com.ibm.team.repository.web.transport.TeamServerClient;
    var DOWNLOAD_SERVICE_URI = "com.ibm.rqm.planning.service.internal.rest.IAttachmentRestService/";
    
    dojo.declare("com.ibm.asq.common.web.ui.internal.widgets.richtext.plugins.InsertImagePlugin", dijit._editor._Plugin, {    
        useDefaultCommand: false,
        
        getImageTemplate: function(attachment){
            var src = TeamServerClient._getServicePrefix() + DOWNLOAD_SERVICE_URI + attachment.uuid;
			var fileName = attachment.fileName ? attachment.fileName : Constants.getMessage("labelInsertImageAlt");
            var imageString = "<a href='" + src + "'><img id ='" + attachment.uuid + "' border='0' src='" + src + "' alt='" + fileName + "'/></a>";
            return imageString;
        },
        
        setValue: function(args){
            //TODO: prevent closing popup if the text is empty
            this._onCloseDialog();
            var imageString = this.getImageTemplate(args);
            this.editor.execCommand('inserthtml', imageString);
        },
        
        _onCloseDialog: function(){
            // FIXME: IE is really messed up here!!
            if (dojo.isIE) {
                if ("_savedSelection" in this) {
                    var b = this._savedSelection;
                    delete this._savedSelection;
                    this.editor.focus();
                    var range = this.editor.document.selection.createRange();
                    range.moveToBookmark(b);
                    range.select();
                }
            }
            else {
                this.editor.focus();
            }
			if (this.insertImageDialog) {
				this.insertImageDialog.destroyRecursive();
			}
			this.insertImageDialog = null;
        },
        
        _onOpenDialog: function(){
            var a = dojo.withGlobal(this.editor.window, "getAncestorElement", dijit._editor.selection, [this.tag]);
            var url, text;
            // FIXME: IE is *really* b0rken
            if (dojo.isIE) {
                this._savedSelection = this.editor.document.selection.createRange().getBookmark();
            }
            this.insertImageDialog = new com.ibm.asq.common.web.ui.internal.widgets.richtext.plugins.InsertImageDialog({parentWidget: this});
            this.toolTipDialog._setContentAttr(this.insertImageDialog.domNode);
			this.toolTipDialog.domNode.style.overflow="auto";
            this.toolTipDialog.startup();
        },
        
        _initButton: function(){
            var _this = this;
            this.tag = this.command == InsertImagePlugin.PLUGIN_ID ? 'img' : 'a';
            this.command = InsertImagePlugin.PLUGIN_ID;
            var messages = dojo.i18n.getLocalization("dijit._editor", "LinkDialog", this.lang);
            this.toolTipDialog = new dijit.TooltipDialog({
                title: Constants.getMessage("InsertImage"),
                onOpen: function(){
                    _this._onOpenDialog();
                    dijit.TooltipDialog.prototype.onOpen.apply(this, arguments);
					//remove the 'V'
					dojo.removeClass(this.domNode,"dijitTooltipConnector");
					dojo.removeClass(this.domNode,"dijitTooltipBelow");
					dojo.removeClass(this.domNode,"dijitTooltipAbove");
					dojo.removeClass(this.containerNode,"dijitTooltipFocusNode");
                },
                onCancel: function(){
                    setTimeout(dojo.hitch(_this, "_onCloseDialog"), 0);
                },
                onClose: dojo.hitch(this, "_onCloseDialog")
            });
            
            this.button = new dijit.form.DropDownButton({
                label: Constants.getMessage("InsertImage"),
                showLabel: false,
                dropDown: this.toolTipDialog,
                iconClass: "InsertImageIcon InsertImageIconPos",
                tabIndex: "-1"
            });
        },
        
        setToolbar: function(){
            this.inherited("setToolbar", arguments);
        }  
    });
})();

dojo.subscribe("dijit.Editor.getPlugin", null, function(o){
    if (o.plugin) {
        return;
    }
    switch (o.args.name) {
        case InsertImagePlugin.PLUGIN_ID:
            o.plugin = new com.ibm.asq.common.web.ui.internal.widgets.richtext.plugins.InsertImagePlugin({
                command: o.args.name
            });
    }
});
