/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojox.data.dom");

dojo.require("com.ibm.asq.common.web.client.internal.CommonPreferenceClient");
dojo.require("com.ibm.asq.common.web.ui.internal.util.MessageUtil");
dojo.require("com.ibm.asq.common.web.ui.internal.util.Utility")
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.Button");

dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.layout.AttributeBuilder");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.CommentCellRenderer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.ActionCellRenderer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.FadeInOutCellRenderer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.CheckboxCellRenderer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.ComboBoxCellRenderer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.DateCellRenderer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.LinkCellRenderer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.ListRowRenderer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.GroupController");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.ImageCellRenderer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellRenderer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableFilter");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableHeaderRenderer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableListener");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableSorter");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableRowRenderer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TextCellRenderer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.EditableTextCellRenderer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.PasswordCellRenderer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TimeStampCellRenderer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TimeStampDateCellRenderer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.DropdownMenuCellRenderer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableSettingsDialog");

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.Util");

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.GridTableHeaderRenderer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.ListTableHeaderRenderer");

(function() {

var TableConstants = com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;
var ImageCache     = com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
var ROW_CHECK_WIDTH = 4;
var AttributeBuilder = com.ibm.asq.common.web.ui.internal.widgets.layout.AttributeBuilder;
var Preferences    = com.ibm.asq.common.web.client.internal.CommonPreferenceClient;
var ServiceResponseHandler = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var CommonUtility = com.ibm.asq.common.web.ui.internal.util.Utility;
var ListRowRenderer=com.ibm.asq.common.web.ui.internal.widgets.tableViewer.ListRowRenderer;
var GridTableHeaderRenderer=com.ibm.asq.common.web.ui.internal.widgets.tableViewer.GridTableHeaderRenderer;
var ListTableHeaderRenderer=com.ibm.asq.common.web.ui.internal.widgets.tableViewer.ListTableHeaderRenderer;
var GroupController=com.ibm.asq.common.web.ui.internal.widgets.tableViewer.GroupController;
// Summary:
//   Internal checkbox cell renderer to draw a checkbox next to the row
//   if the table viewer's rows are checkable. 
// 
dojo.declare("TableViewer.RowCheckBoxCellRenderer", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.CheckboxCellRenderer,
{    
    // Summary:
    //    Renders the cell content. For renderer that can modify the cell value,
    //    
    renderCell: function(viewer, cellData, extendedDisplayInfo, /*table.CellModifier*/cellModifier, rowObject, groupIndex, rowIndex)
    {
        var isChecked = false;
        
        if(extendedDisplayInfo && (typeof extendedDisplayInfo['state'] != "undefined")) {
            isChecked = extendedDisplayInfo['state'];
        }
        
        var provider = viewer.contentProvider;
        var rowName = (provider.getRowDataName && dojo.isFunction(provider.getRowDataName)) ? provider.getRowDataName(rowObject) : null;
        var args = {'checked':isChecked};
        var button = new dijit.form.CheckBox(args);
		var title = (rowName) ? rowName : (rowObject.name || rowObject.id);
        
		if(title){
			var label = document.createElement("label");
			label.appendChild(document.createTextNode(title));
			label.setAttribute("for", button.focusNode.id); 
			label.style.display = "none";
			button.domNode.appendChild(label);
		}
        
        // keep the associated attributes in the button.
        // 
        button.cellModifier = cellModifier;
        button.rowObject = rowObject;
        button.rowIndex = rowIndex;
		button.groupIndex = groupIndex;
		button.viewer = viewer;
        button.onChange = function() {
            if(this.cellModifier)
                this.cellModifier.cellValueChanged(!this.checked, this.checked, this.rowObject, this.rowIndex);
        }
		button._onClick = function(e) {
			//check this button
			if(this.disabled){ return false; }
			this._clicked(); // widget click actions
			
			if(e.shiftKey && !this.viewer.getIsSingleSelectionMode()) {
				var lastSelectedInfo = this.viewer.lastSelectedInfo;
				var orderedObjects = this.viewer.orderedObjects;
				var startGroup = 0;
				var endGroup = this.groupIndex;
				var startRow = 0;
				var endRow = this.rowIndex;
				var changedRows = [];
				 
				if(lastSelectedInfo) {
					var lastCheckState = this.viewer.rowCheckedHandler.getRowCheckState(orderedObjects[lastSelectedInfo.groupIndex][lastSelectedInfo.rowIndex]);
					if (lastCheckState != this.checked) {
						//if lastButton.checked != current button, just return
						this.viewer.lastSelectedInfo = {
							groupIndex: this.groupIndex,
							rowIndex: this.rowIndex
						};
						return true;
					}
					
					if ((lastSelectedInfo.groupIndex > this.groupIndex) || ((lastSelectedInfo.groupIndex == this.groupIndex) && (lastSelectedInfo.rowIndex > this.rowIndex))) {
						//lastButton is behind current button, switch strat & end
						startGroup = this.groupIndex;
						startRow = this.rowIndex;
						endGroup = lastSelectedInfo.groupIndex;
						endRow = lastSelectedInfo.rowIndex;
					}
					else {
						startGroup = lastSelectedInfo.groupIndex;
						startRow = lastSelectedInfo.rowIndex;
					}
				}
					
				for(var i=startGroup; i <= endGroup; i++) {
					var orderedObject=orderedObjects[i];
					var j = (i == startGroup)? startRow:0;
					var length=((i == endGroup)?endRow:orderedObject.length);
					for(; j<length; j++){
						var object = orderedObject[j];
						changedRows.push(object);
						this.viewer.rowCheckedHandler.setRowCheckState(object, this.checked);
					}
				}
				
				//refresh table
				this.viewer._loadTableContents();
		        var listener = this.viewer.getTableListener();
        		if(listener) {
            		listener.rowCheckStateChanged(this.viewer, changedRows, this.checked);
        		}  
			}
			this.viewer.lastSelectedInfo = {
				groupIndex: this.groupIndex,
				rowIndex: this.rowIndex
			};
			return true;
		}
        this.cellNodes.push(button);
        return button;
    }
});

// Summary:
//    Internal cell modifier to track the row's check box states. The TableViewer 
//    can provide a check box for each of the rows for row selections. This is 
//    the handler to receive the row checked events. It stores the states of the 
//    rows as they're being checked or unchecked.
//
dojo.declare("TableViewer.RowCheckedHandler", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier,
{
    viewer: null,
    rowStates: null,
    lastSelected: null,
    inSingleSelectHandling: false,
    
    constructor: function(viewer)
    {
        this.viewer = viewer;
        this.rowStates = {};
    },
    
    clearRowStates: function()
    {
        this.rowStates = {};
        this.lastSelected = null;
    },
    
    setRowCheckState: function(rowObject, checkState)
    {
        var provider = this.viewer.getContentProvider();
        var id = provider.getRowDataId(rowObject);
        var obj = {};
        obj["rowObject"] = rowObject;
        obj["checked"] = checkState;
        
        if(this.viewer.getIsSingleSelectionMode()) {
            this.inSingleSelectHandling = true;
            
            // clear the last selected row's visual state: the checkbox
            // and the row's selection highlight
            if(this.lastSelected) {
                var button = this.viewer.rowCheckBoxes[this.lastSelected];
                if(button && this.lastSelected != id) {
                    button.setChecked(false);
                }
                var tr = this.viewer.tableRows[this.lastSelected];
                if(tr) {
                    dojo.toggleClass(tr, "selected-row-highlight", false);
                }
            }
            this.inSingleSelectHandling = false;
            this.lastSelected = id;
            this.rowStates = {};
        }
        if(id) {
            this.rowStates[id] = obj;
        }
    },

    getRowCheckState: function(rowObject)
    {
        var provider = this.viewer.getContentProvider();
        var id = provider.getRowDataId(rowObject);
        var check = false;
        
        if(id && (typeof this.rowStates[id] != "undefined")) {
            check = this.rowStates[id].checked;
        }
        return check;
    },
    
    getAllCheckedRows: function()
    {
        var selectedRows = [];
        for(var rowId in this.rowStates) {
            if(this.rowStates[rowId].checked) {
                selectedRows.push(this.rowStates[rowId].rowObject);
            }
        }
        return selectedRows;
    },
    
    getAllRows: function()
    {
        var allRows = [];
        for(var rowId in this.rowStates) {
              allRows.push(this.rowStates[rowId].rowObject);
        }
        return allRows;
    },
    
    cellValueChanged: function(oldValue, newValue, rowObject, columnIndex)
    {
        if(this.inSingleSelectHandling)
            return;

        this.setRowCheckState(rowObject, newValue);
        
        // notify internally to the table
        this.viewer._internalRowChecked();
        
        // change the row's selected state style
        var provider = this.viewer.getContentProvider();
        var id = provider.getRowDataId(rowObject);
        var tr = this.viewer.tableRows[id];
        if(tr) {
            dojo.toggleClass(tr, "selected-row-highlight", newValue);
        }
        var listener = this.viewer.getTableListener();
        
        if(listener) {
            listener.rowCheckStateChanged(this.viewer, rowObject, newValue);
        }
    }
});

dojo.declare("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer",
             [dijit._Widget, dijit._Templated],
{
    templateString: '<div class="com-ibm-asq-common-tableViewer" dojoAttachPoint="domNode" tabindex="-1">' +
                    '  <div dojoAttachPoint="contentFilterAttrNode" class="filter-attr-area" style="display:none">' +
                    '  </div>' +
                    '  <table dojoAttachPoint="controlAreaNode" class="control-area">' +
                    '    <tr dojoAttachPoint="controlAreaGroupFilterNode">' +
                    '      <td valign="bottom" colspan=3>' +
                    '        <span dojoAttachPoint="groupControlNode">' +
                    '        </span>' +
					'        <span dojoAttachPoint="contentControlNode">' +
                    '        </span>' +
                    '        <span dojoAttachPoint="viewModeControlNode">' +
                    '        </span>' +
                    '        <span class="filter-area" dojoAttachPoint="filterControlNode">' +
                    '        </span>' +
                    '      </td>' +
                    '    </tr>' +
                    '    <tr dojoAttachPoint="controlAreaSeparatorNode">' +
                    '      <td colspan="3">' +
                    '        <div class="table-separator-2">' +
                    '        </div>' +
                    '      </td>' +
                    '    </tr>' +
                    '    <tr dojoAttachPoint="controlAreaPagingActionsNode">' +
                    '      <td width="33%" valign="middle" nowrap>' +
                    '        <div dojoAttachPoint="PageSelectControlNode">' +
                    '        </div>' +
                    '      </td>' +
                    '      <td width="34%" valign="middle" align="center" nowrap>' +
                    '        <div class="paging-control" width="100%" dojoAttachPoint="PageControlNode">' +
                    '        </div>' +
                    '      </td>' +
                    '      <td width="33%" valign="middle" align="right" dojoAttachPoint="actionsTD">' +
                    '        <div dojoAttachPoint="actionsAreaNode">' +
                    '        </div>' +
                    '      </td>' +
                    '    </tr>' +
                    '  </table>' +
                    '  <div class="table-container-node" dojoAttachPoint="tableContainerNode">' +
                    '  </div>' +
                    '  <div class="table-message" style="display:none" dojoAttachPoint="messageAreaNode">' +
                    '  </div>' +
                    '  <div dojoAttachPoint="loadingProgressNode" class="progress-area" style="display:none">' +
                    '    <div class="progress-image">' +
                    '      <span dojoAttachPoint="loadingLabelNode" class="progress-label">${loadingLabel}</span>' +
                    '    </div>' +
                    '  </div>' +
                    '  <div dojoAttachPoint="errorMessageNode" class="progress-area" style="display:none">' +
                    '    <div class="error-image">' +
                    '      <span dojoAttachPoint="errorLabelNode" class="progress-label"></span>' +
                    '    </div>' +
                    '  </div>' +
                    '  <table class="footer-area" dojoAttachPoint="footerAreaNode">' +
                    '    <tr><td width="100%" valign="middle" align="center" nowrap><div class="paging-control" dojoAttachPoint="footerPageControlNode">' +
                    '    </div></td></tr>' +
					'  </table>' +
                    '  </div>' +
                    '</div>',

    loadingLabel: MessageUtil.getMessage(MessageBundle.COMMON, "tableViewer_loading"),
    workingLabel: MessageUtil.getMessage(MessageBundle.COMMON, "tableViewer_working"),
    errorLabel: MessageUtil.getMessage(MessageBundle.COMMON, "tableViewer_errorContent"),
    
    // When performing the base table's operations, if the number of rows exceeds or equals this
    // threshold value (default to 2500), the table will display a working message while
    // doing SORT, GROUP, and FILTER.
    displayWorkingThreshold: (dojo.isIE ? 1000 : 2500),
    
    // The mode of the table. We support two modes, a grid mode
    // and a list mode. The mode determines the controls and column
    // header rendering and the default row renderer type to use.
    // 
    majorMode: null,
    
    // The content to be displayed in the table. This is the data
    // object that is being displayed. 
    //
    content: null,
    
    // The provider that viewer uses to obtain the display data
    // from the content object.
    // 
    contentProvider: null,
    
    // The provider that viewer uses to build the filter attributes for
    // the content.
    // 
    filterAttrProvider: null,

    // The filter object the viewer uses to filter out entries from
    // the display. If no custom filter is provided, a default one is created.
    //
	contentFilter: null,
	
    // The sorter object the viewer uses to sort the entries. If no
    // custom sorter is provided, a default one is created.
    //
    contentSorter: null,
    
    // The row renderer object the viewer uses to draw a row data in the 
    // table. If no custom row renderer is provided, a default one is created.
    //
    rowRenderer: null,
	
    // The list of registered renderers that the viewer uses to draw
    // the data in the table cell. By default, the viewer populates the registry
    // with the support cell renderer types.
    // 
    cellRendererRegistry: null,

    // The registered client cell modifier. The modifier is notified when activities
    // in table cells happened.
    //
    cellModifier: null,
    
    // The registererd client listener to receive table events. The listener is notified
    // when table activities happened.
    //
    tableListener: null,
     
    // The page size for our table. It controls the number of items to be shown at any one
    // time. Note that the size does not include the group heading row. Only the actual data
    // rows are counted in the display page. 
    //
    pageSize: -1,
    
    // provides an message when the content is empty (no rows)
    noItemMessage: "",
    
    // provides an message when the content is empty due to no matching filter
    noMatchFilterMessage: "",
    
    groupByColumn: -1,
    
    sortByColumn: -1,
    
    sortDir: TableConstants.SORT_DIR_ASCEND,
    
    // Controls whether the rows in the table are checkable (selected). The current implementation
    // is a check box style selection.
    rowsCheckable: false,
    
    // Controls the style of row selection. If set to true, only one row can be selected at a time.
    // This setting is only valid if the rowCheckable is true.
    rowSelectIsSingle: false,
    
    // Controls whether the user would be able to select/deselect all rows in the table. This setting
    // is only valid if the rows are checkable and that the style is not single selection. Please note 
    // that this is only supported in the Grid mode and not in the List mode.
    allowSelectAll: true,
    
    editable: true,
    
    showTableHeading: true,
    
    showFilterControl: true,
    
    showPagingControl: true,

    showFooterPagingControl: true,
	
	showPagingRangeControl: true,
    
    showTableControls: true,
    
	//more granular control than 'showTableControls', which disables both the paging/actions controls 
	//and the grouping/filtering/viewMode controls
	showPagingActionsControls: true,	
	showGroupFilterControls: true,
	showViewModeControl: false,
	
    // Enable/disable the creation of a default table action to change the table's settings. If the flag
    // is set to true, a default action is created allowing the user to adjust the table's display settings.
    // However, if the client turns of the showing of the action controls area, the action won't be displayed,
    // and thus negating this attribute.
    allowAdjustSettings: false,
    
    // If adjust settings is set to true, whenever the user changed the settings, the table will automatically
    // save the settings as preferences if this flag is set to true. A unique table ID must also be provided, otherwise
    // no saving is done.
    autoSaveSettings: false,
    tableId: null,
    
	// Compacts the column cell's data to fit inside the cell width. No word wrapping
	// is allowed. All textual data would be trimmed to fit. 
    isCompactMode: true,
    
	// Allows sorting by more then one column at a time. Grouping is still on a single column.
	allowMultiSort: false,
	
	tableSummary: "",
	
	//used for shift-click multi-select for table checkboxes: {groupIndex, rowIndex}
	lastSelectedInfo: null,
	
    postCreate: function()
    {
        this.table = null;
		this.tableSummary = "";
        this.orderedObjects = null;
        this.headerRenderer = null;
        this.groupStates = null;
        this.unspecifiedGroupTitle = "";
        
        this.totalItems = 0;
        this.curPageItemStart = 0;
        this.filterBy = null;
        this.nFiltered = 0;
        this.nItemsShown = 0;
        this.tableActionList = [];
        this.viewModeList = [];
        this.rawObjects = null;
        this.columnSettings = null;
        this.sortColumns = [];
        this._groupRowWidgets = [];
        
        this._history = false;
		this.uninitialized = false;
		
        // initialize the sort column in a multi-col sorting table.
        if(this.allowMultiSort && this.sortByColumn > -1) {
            this.sortColumns.push({
                col: this.sortByColumn,
                dir: this.sortDir
            })
        }
        
        this._initializeViewer();      
        
        if(this.allowAdjustSettings) {
            this._addPreferenceSettingsAction();
        } 
    },
    
    uninitialize: function() {
    	//console.debug("============TableViewer Uninitialize");
		this.uninitialized = true;
        if (this.headerRenderer){
        	this.headerRenderer.destroyTableHeader();
        	this.headerRenderer.destroyTableControls();
        }
        this._clearGroupRowWidgets();
        this._clearRendererContents();
        
        this.table = null;
        this.orderedObjects = null;
        this.headerRenderer = null;
        this.groupStates = null;
        this.tableActionList = null;
        this.viewModeList = null;
        this.rawObjects = null;
        this.columnSettings = null;
        this.sortColumns = null;
        this.cellRendererRegistry = null;
        this.rowCheckBoxRenderer = null;
        this.contentFilter = null;
        this._groupRowWidgets = null;
        this.filterBuilder = null;
    },
    
    _clearGroupRowWidgets: function()
    {
    	if (!this._groupRowWidgets) return;
        var len = this._groupRowWidgets.length;
        for(var i = 0; i < len; i++) {
            this._groupRowWidgets[i].destroy();
        }
        this._groupRowWidgets = [];            
    },

    _clearRendererContents: function()
    {        
        for(var i in this.cellRendererRegistry) {
            var renderer = this.cellRendererRegistry[i];
            renderer.disconnectAll();
        }
        if(this.rowCheckBoxRenderer) {
            this.rowCheckBoxRenderer.disconnectAll();
        }                
    },
    
    _initializeViewer: function()
    {
        if (!this.ruler){
            // prevent ruler from being looked up repeatedly
            this.ruler = dojo.byId("com-ibm-rqm-app-ruler-node");
        }        
		var ruler = this.ruler;
		
        // ensure we have a default setting for the table.
        if(!this.contentFilter) {
            this.contentFilter = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableFilter();
        }
        if(!this.contentSorter) {
            this.contentSorter = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableSorter();
        }
        if(!this.majorMode) {
            this.majorMode = TableConstants.MAJOR_MODE_GRID;
        }
        if(!this.rowRenderer) {
            this.setTableMajorMode(this.majorMode);
        }
        if (!this.showTableControls) {
			//hide entire controls area
			dojo.style(this.controlAreaNode, "display", "none");
		} else {
			//more granular - hide paging and actions controls row
			if (!this.showPagingActionsControls) {
				dojo.style(this.controlAreaPagingActionsNode, "display", "none");
				dojo.style(this.controlAreaSeparatorNode, "display", "none");
			}
			//more granular - hide grouping/filtering controls row
			if (!this.showGroupFilterControls) {
				dojo.style(this.controlAreaGroupFilterNode, "display", "none");
				dojo.style(this.controlAreaSeparatorNode, "display", "none");
			}
			//more granular - hide viewMode controls row
			if (!this.showViewModeControl) {
				dojo.style(this.viewModeControlNode, "display", "none");
			}
		}
            
        this.rowCheckBoxRenderer = new TableViewer.RowCheckBoxCellRenderer();
        this.rowCheckedHandler = new TableViewer.RowCheckedHandler(this);

        // setup the cell renderer registry to have default cell types
        this.cellRendererRegistry = {};
		
        this.registerCellRenderer(TableConstants.RENDER_TYPE_TEXT, 
            new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TextCellRenderer());
        this.registerCellRenderer(TableConstants.RENDER_TYPE_ACTION, 
            new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.ActionCellRenderer());
		this.registerCellRenderer(TableConstants.RENDER_TYPE_FADEINOUT, 
            new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.FadeInOutCellRenderer());
        this.registerCellRenderer(TableConstants.RENDER_TYPE_CHECKBOX, 
            new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.CheckboxCellRenderer());
        this.registerCellRenderer(TableConstants.RENDER_TYPE_IMAGE, 
            new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.ImageCellRenderer());
        this.registerCellRenderer(TableConstants.RENDER_TYPE_DATE, 
            new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.DateCellRenderer());
        this.registerCellRenderer(TableConstants.RENDER_TYPE_ENUM, 
            new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.ComboBoxCellRenderer());
        this.registerCellRenderer(TableConstants.RENDER_TYPE_LINK, 
            new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.LinkCellRenderer());
        this.registerCellRenderer(TableConstants.RENDER_TYPE_EDITABLE_TEXT, 
            new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.EditableTextCellRenderer());
        this.registerCellRenderer(TableConstants.RENDER_TYPE_PASSWORD, 
            new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.PasswordCellRenderer());
        this.registerCellRenderer(TableConstants.RENDER_TYPE_TIMESTAMP, 
            new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TimeStampCellRenderer());
        this.registerCellRenderer(TableConstants.RENDER_TYPE_TIMESTAMPDATE, 
            new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TimeStampDateCellRenderer());
        this.registerCellRenderer(TableConstants.RENDER_TYPE_DROPDOWN_MENU,
            new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.DropdownMenuCellRenderer());
		this.registerCellRenderer(TableConstants.RENDER_TYPE_COMMENT,	
			new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.CommentCellRenderer());
        
        if(this.filterAttrProvider) {
            this.setContentFilterAttributeProvider(this.filterAttrProvider);
        }
    },

    _onResize: function()
    {
        // reconstruct the content table including the table header.
        var win = window;
        
        if(this.lastWinWidth && this.lastWinWidth == window.innerWidth) {
            return;
        }
        this.lastWinWidth = window.innerWidth;
        
        this._recreateContentTable();
        this.tableContainerNode.appendChild(this.table);
        this._loadTableContents();
    },
    
    _recreateContentTable: function()
    {
        // remove the table and recreate the table header.
        this.headerRenderer.destroyTableHeader();
        dojox.data.dom.removeChildren(this.tableContainerNode);
        this.table = document.createElement("table");
        dojo.addClass(this.table, "content-table");
        
        this.headerRenderer.createTableHeader(this.table);
        this.tbody = document.createElement("tbody");
        this.table.appendChild(this.tbody);        
        this.table.summary = this.tableSummary;      		
    },
    
    _addPreferenceSettingsAction: function() 
    {
        var arg = {
            label: MessageUtil.getMessage(MessageBundle.COMMON, "tableViewer_changeSettings"),
            showLabel: false,
            iconClass: "edit-settings-icon-image",
            parent: this,
            onClick: dojo.hitch(this, "_handleSettingsAction")
        };
        this.settingAction = new com.ibm.asq.common.web.ui.internal.widgets.Button(arg);
        this.actionsAreaNode.appendChild(this.settingAction.domNode);
    },
    
    _handleSettingsAction: function()
    {
        var args = {
            viewer: this,
            showDisplayMode: this.autoSaveSettings && this.tableId,
            isCompactMode: this.isCompactMode,
            okCallback: dojo.hitch(this, "_handleSettingsChanged")
        };
        this.settingsDialog = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableSettingsDialog(args);
        this.settingsDialog.open();
        
    },
    
    _handleSettingsChanged: function()
    {
        this.columnSettings = this.settingsDialog.getSettings();
        this.isCompactMode = this.settingsDialog.isCompactDisplayMode();
        
        // reconstruct the content table including the table header.
        this._recreateContentTable();
        
        // load the content into the table.
        if(this.getContentItemCount() >= this.displayWorkingThreshold)
            this._loadTableContentsWithProgress();   
        else
            this._loadTableContents();
            
        this.tableContainerNode.appendChild(this.table);
        
        // save the settings if we're instructed to do so.     
        if(this.autoSaveSettings) {
            if(!this.tableId) {
                console.debug("To auto save table settings, you must provide a tableId attribute!");
                return;
            }
            this.tableSettings = {};
            this.tableSettings.columnSettings = this.columnSettings;
            this.tableSettings.isCompactMode = this.isCompactMode;
            var pref = {
                key: this.tableId,
                value: dojo.toJson(this.tableSettings)
            }
            var handler = {
                success: function(response) {
                },
                failure: function(e) {
                }
            }
            var responseHandler = new ServiceResponseHandler(handler, "success", "failure");
            Preferences.mergeAndSaveUserPreferences(pref, responseHandler);
        }
    },
    
	// Summary:
	//    The column width cache is used when the user updates (refresh, etc.) the table
	//    and the table isn't in view. In that situation, the table wouldn't have any column
	//    sizing to render cell text for compact mode. By caching the widths, we at least have  
	//    the last rendered widths to start from. This method is called by the table update methods.
	//
	_resetColumnWidthsCache: function(reset)
	{
        var provider = this.contentProvider;
        var content = this.getContent();
        var nColumns = provider.getNumColumns(content);
		
		// if this is an explicit reset, or we don't have the cache setup
		// yet, or the table has a valid width, reset the cache.
		if(reset || !this.columnWidthCache) {
			this.columnWidthCache = new Array(nColumns);
			for(var i = 0; i < nColumns; i++) {
				this.columnWidthCache[i] = 0;
			}
		}
	},
	
    isColumnVisible: function(columnIndex)
    {
        if(this.columnSettings && 
           dojo.isArray(this.columnSettings) && 
           columnIndex < this.columnSettings.length && 
           typeof this.columnSettings[columnIndex].show != "undefined") {
            return this.columnSettings[columnIndex].show;
        }
		else {
			var provider = this.contentProvider;
			if(provider && dojo.isFunction(provider.getIsColumnVisible)) {
				return provider.getIsColumnVisible(columnIndex);
			}
		}
        return true;
    },
    
    getColumnWidth: function(columnIndex, /* optional */getDefault)
    {
        if(!getDefault && this.columnSettings &&
           dojo.isArray(this.columnSettings) && 
           columnIndex < this.columnSettings.length &&
           this.columnSettings.length == this.contentProvider.getNumColumns() &&
           typeof this.columnSettings[columnIndex].width != "undefined") {
            return this.columnSettings[columnIndex].width;
        }
        
        var provider = this.contentProvider;
        var content = this.getContent();
        return provider.getColumnWidth(content, columnIndex);
    },
    
    getColumnWidthInPixel: function(columnIndex)
    {
        if(this.headerRenderer.getColumnHeaderWidthInPixel) {
			var width = this.headerRenderer.getColumnHeaderWidthInPixel(columnIndex);
			
			// there's a valid width for the column, use that and update the
			// cache. If not, we'll just use the value in the cache.
            if(width > 0) {
				this.columnWidthCache[columnIndex] = width;
			}
        }
        return this.columnWidthCache[columnIndex]; 
    },
   
    // Summary:
    //    Set the TableViewer's major display mode. Two modes are supported, one
    //    is the GRID mode, the other is the LIST mode. When in GRID mode, the TableViewer
    //    displays table headings and each row of data is renderer in cell aligning with
    //    each column. In LIST mode, no table headings is displayed and each row are shown
    //    as expandable items. However, this is only the default row renderer behavior, if the 
    //    client provides a custom row renderer, the row display will be drawn by the registered
    //    renderer.
    // 
    setTableMajorMode: function(mode)
    {
        if(mode != TableConstants.MAJOR_MODE_GRID && mode != TableConstants.MAJOR_MODE_LIST) {
            throw new Error("Unknown table major mode: " + mode);       
        }
        if(this.majorMode != mode || this.rowRenderer == null) {
            this.majorMode = mode;
            this.rowRenderer = (mode == TableConstants.MAJOR_MODE_GRID) ? new TableViewer.DefaultTableRowRenderer() :
                new ListRowRenderer();
        }
        if(this.majorMode == TableConstants.MAJOR_MODE_GRID) {
            this.headerRenderer = new GridTableHeaderRenderer(this);
        }
        else {
            this.headerRenderer = new ListTableHeaderRenderer(this);            
        }
    },
    
    // Summary:
    //    Set whether each row of the table is checkable. By checkable, it means a check box
    //    is placed on each row at the left most column. This behavior works the same for both
    //    GRID and LIST mode. Each row can be checked/unchecked. If the client registers a TableListener,
    //    the listener will receive row checked event notifications.
    //    @param Optionally specify whether the row select is single. By default is mult-row selection mode
    //
    setTableRowsCheckable: function(checkable, isSingleSelect)
    {
        this.rowsCheckable = checkable;
        this.rowCheckedHandler.clearRowStates();
        this.headerRenderer.resetStates();
        
        if(typeof isSingleSelect != "undefined") {
            this.rowSelectIsSingle = isSingleSelect;
        }
    },
    
    // Summary:
    //    Set the editable state of the table viewer.  The cell renderer must obey this setting
    //    to render the cell properly.  Actions and links should not be affected by this setting.
    //
    setEditable: function(editable)
    {
        if (this.editable != editable)
        {
            this.editable = editable;
            
            // update the table action's states
            for(var i = 0; i < this.tableActionList.length; i++) {
                this.tableActionList[i].setDisabled(!this.editable);
            }
            this._constructTableContents();
        }
    },
    
    // Summary:
    //    Set the editable state of the table viewer.  
    //
    isEditable: function()
    {
        return this.editable;
    },
    
    // Summary:
    //    Set a fixed page size for the TableViewer. If a page size is provided, the table will
    //    only show that number of rows at one time. If the content exceeds this size, the user can
    //    "page" through the contents via the page controls (created automatically by the TableViewer)
    //
    //    NOTE: (change of behavior)
    //    The TableViewer enforces the page size by providing a page size controller to the user. The
    //    user can set the appropriate page size for the content using this controller. Client should 
    //    not use this method directly. 
    //
    setContentPageSize: function(pageSize)
    {
        this.pageSize = pageSize;
    },
    
    // Summary:
    //    Set the content that is to be displayed in the TableViewer.
    //
    setContent: function(content)
    {
        this.content = content;
        this.rawObjects = null;
        this.rowCheckedHandler.clearRowStates();
        this.rowRenderer.clearRowStates();
        this.headerRenderer.resetStates();
        
        // notify the content provider of the content
        // changed event, if it implements the method.
        if(this.contentProvider && this.contentProvider.contentChangedNotify) {
            this.contentProvider.contentChangedNotify(content);
        }
    },
    
    // Summary:
    //    Set the content provider for the set content. The TableViewer relies on the provider
    //    obtain displayable data from the set content.
    //
    setContentProvider: function(contentProvider)
    {
        this.contentProvider = contentProvider;
        
        if(!(this.contentProvider instanceof com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider)) {
            throw new Error("contentProvider must be a subclass of the TableContentProvider.");       
        }
        this.rawObjects = null;
        this.rowCheckedHandler.clearRowStates();
        this.rowRenderer.clearRowStates();
        this.headerRenderer.resetStates();
		this._resetColumnWidthsCache(true);
    },
    
    // Summary:
    //    Set the content filter provider in the TableViewer. If a filter provider is set, the 
    //    TableViewer creates a section that displays input fields for the content's filters.
    //    The TableViewer queries the filter provider to generate the input fields. See 
    //    com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentFilterProvider for more
    //    details about the required data.
    //
    setContentFilterAttributeProvider: function(filterProvider)
    {
        if(!(filterProvider instanceof com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentFilterProvider)) {
            throw new Error("contentFilterProvider must be a subclass of the TableContentFilterProvider.");       
        }
        this.filterAttrProvider = filterProvider;
        
        // destroy any widgets under our attr node. If we have created
        // a filter builder earlier, this will destroy the entire widget
        // set associated w/ the builder
        CommonUtility.destroyWidgetsFromNode(this.contentFilterAttrNode);
        dojox.data.dom.removeChildren(this.contentFilterAttrNode);

        this.filterBuilder = new com.ibm.asq.common.web.ui.internal.widgets.layout.AttributeBuilder(
            {
                title: this.filterAttrProvider.getTitle(),
                summaryText: this.filterAttrProvider.getSummaryText(),
                visibleAttributeCount: this.filterAttrProvider.getInitialVisibleFilterCount(),
                labelWidth: this.filterAttrProvider.getFilterFieldLabelWidth(),
                fieldAreaWidth: this.filterAttrProvider.getFilterFieldAreaWidth(),
				initialOpen: this.filterAttrProvider.getIsSectionOpenInitially()
            });
		this.filterBuilder.setCSHelpId("rqm_viewbuilder.html"); //$NON-NLS$
		this.filterBuilder.setCSHelpButtonLabel(MessageUtil.getMessage(MessageBundle.COMMON, "tableViewer_viewBuilderCsHelp"));
        this.contentFilterAttrNode.appendChild(this.filterBuilder.domNode);
        
        // build the filter contents
        var nFilters = this.filterAttrProvider.getFilterCount();
        for(var i = 0; i < nFilters; i++) {
            var type = this.filterAttrProvider.getFilterType(i);
            var name = this.filterAttrProvider.getFilterName(i);
            var title = this.filterAttrProvider.getFilterTitle(i);
            var promptTitle = this.filterAttrProvider.getFilterPromptTitle(i);
            var defValue = this.filterAttrProvider.getFilterDefaultValue(i);
            var params = this.filterAttrProvider.getFilterParams(i);
            
            // create a 'std' field, or if the client specified a custom field,
            // get it from the provider.
            if (type == com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentFilterProvider.FIELD_CUSTOM) {
                var field = this.filterAttrProvider.getCustomField(i);
                this.filterBuilder.addCustomAttribute(name, title, promptTitle, field);
            }
            else {
                // supported field type, just let the builder create it.
                this.filterBuilder.addAttribute(name, title, promptTitle, type, defValue, params);            
            }
        }
        var actions = this.filterAttrProvider.getActionsInfo();
        
        if(actions && dojo.isArray(actions)) {
            for(var i = 0; i < actions.length; i++) {
                this.filterBuilder.addAction(actions[i].id, actions[i].title, 
                    dojo.hitch(this,
                        function(id, cbData) {
                            var listener = this.getTableListener();
                            var filters = this.filterBuilder.getAttributeValues();
                            if(listener) {
                                listener.tableContentFilterActionInvoked(this, id, filters, cbData.callback, cbData.callbackData);
                            }
                        }), 
                actions[i], actions[i].isDefault);
            }
        }
        this.contentFilterAttrNode.style.display = "";
    },
    
    // Summary:
    //    Provides a more specify filter for the content. By default, the TableViewer 
    //    has a default filter. The default filter operates only on the data supplied
    //    by the content provider to do the filtering.
    //
    setFilter: function(filter)
    {
        this.contentFilter = filter;
    },
    
    // Summary:
    //    Provides a more specify sorter for the content. By default, the TableViewer 
    //    has a default sorter. The default sorter operates only on the data supplied
    //    by the content provider to do the sorting.
    //
    setSorter: function(sorter)
    {
        this.contentSorter = sorter;
    },
    
    // Summary:
    //    Registers a cell modifier to receive cell data changed events.
    //
    setCellModifier: function(cellModifier)
    {
        this.cellModifier = cellModifier;
    },
    
    // Summary:
    //    Registers a listener to receive TableViewer events.
    //
    setTableListener: function(tableListener)
    {
        this.tableListener = tableListener;
    },
    
    // Summary:
    //    Set whether to display the table's heading. Client must call the show() method
    //    to update the table display after calling this method. If dynamic behavior is not 
    //    needed, the client should set the attribute, 'showTableHeading', when creating this widget.
    //
    setShowingTableHeading: function(show)
    {
        this.showTableHeading = show;    
    },

    // Summary:
    //    Set whether to display the filter control. Client must call the show() method
    //    to update the table display after calling this method. If dynamic behavior is not 
    //    needed, the client should set the attribute, 'showFilterControl', when creating this widget.
    //
    setShowingFilterControl: function(show)
    {
        this.showFilterControl = show;    
    },

    // Summary:
    //    Set whether to display the paging control. Client must call the show() method
    //    to update the table display after calling this method. If dynamic behavior is not 
    //    needed, the client should set the attribute, 'showPagingControl', when creating this widget.
    //
    setShowingPagingControl: function(show)
    {
        this.showPagingControl = show; 
        this.showFooterPagingControl = show;   
    },
	
	// Summary:
    //    Set whether to display the paging range control. Client must call the show() method
    //    to update the table display after calling this method. If dynamic behavior is not 
    //    needed, the client should set the attribute, 'showPagingRangeControl', when creating this widget.
    //
    setShowingPagingRangeControl: function(show)
    {
        this.showPagingRangeControl = show; 
    },
    
    // Summary:
    //    Set text to display in group row when there are rows in the table that have no 
    //      specified value on which the table is being grouped.  
    //
    setUnspecifiedGroupTitle: function(title) {
        this.unspecifiedGroupTitle = title;
    },    
    
    // Summary:
    //    The TableViewer has a set of default cell renderers to draw cell data. The client
    //    can either extends (add more) renderer type for its specific content, or to change 
    //    a default renderer's drawing. The Type parameter identifies a cell renderer. When
    //    the content provider specifies a cell renderer type for a row data at a column, the 
    //    particular cell renderer is retrieved to draw the cell data. Thus, before a content
    //    provider can reference a cell renderer type, the client must first register it through
    //    this method.
    //
    registerCellRenderer: function(type, cellRenderer)
    {
        this.cellRendererRegistry[type] = cellRenderer;        
    },

    // Summary:
    //    Overrides the default table mode renderers to draw each row of the content by the client. The drawing of
    //    a row data is completely delegated to this renderer. The TableViewer at this point has no knowledge of
    //    how the data is being shown. However, the client must still provide the content and the content
    //    provider in order for the default sorter/filter to function properly.
    //
    setCustomRowRenderer: function(rowRenderer)
    {
        this.rowRenderer = rowRenderer;
    },
    
    // Summary:
    //    Provides a place holder for the TableViewer client to drop in list of table content selections.
    //    The specified selections will be presented in a dropdown combo box. When an entry is selected by
    //    the user, the TableListener.tableContentSelectionChanged message is fired. The client upon receiving this
    //    event, can set the appropriate content into the table. 
    //    @param  selectors [{name: 'display name for the entry', value: 'actual value to be returned when selected', def: boolean indicating the default initial selection},...]
    //
    setTableContentSelectors: function(selectors)
    {
        dojox.data.dom.removeChildren(this.contentControlNode);
		var selectLabel = document.createElement("label");
			
        this.contentSelect = document.createElement("select");
        this.contentSelect.id = "table-view-selector";
        this.connect(this.contentSelect, "onchange", "_contentSelectChanged");
        
        var pos = 0;
        for(var i = 0; i < selectors.length; i++) {
            var option = new Option(selectors[i].name, selectors[i].value);
            this.contentSelect.options[i] = option;
			if (selectors[i].def == true)
				this.contentSelect.options[i].selected = true;             
        }
        selectLabel.appendChild(document.createTextNode(MessageUtil.getMessage(MessageBundle.COMMON, "tableViewer_contentViewSelect")+" "));    
        selectLabel.appendChild(this.contentSelect); 
        selectLabel.setAttribute("for", "table-view-selector"); 
        this.contentControlNode.appendChild(selectLabel);
		dojo.addClass(this.contentControlNode, "content-control-area");
		return( this.contentSelect );
    },
	
	// Summary:
	// For accessiblility, add "summary" attribute to the content table.
	setTableSummary: function(msg) {
		this.tableSummary = msg;
	},
    
    // Summary:
    //    Add a table action to the table action area. The table viewer provides an area for the client
    //    to install actions for the table content. A buton is created for the action in that area. 
    //    When a registered action is invoked by the user, the table viewer fires the TableListener.tableContentActionInvoked
    //    message. Additionally, if the client supplies callbackData and a callback method, they will be forwarded
    ///   in the TableListener's tableContentActionInvoked message. 
    //    
    addAction: function(actionId, label, /* optional */callbackData, /* optional */iconClass, /* optional */callback, /* optional*/  dropDown) 
    {
        var arg = {
            label: label,
            showLabel: true,
            onClick: function(e) {
                var listener = this.parent.getTableListener();
                if(listener) {
                    listener.tableContentActionInvoked(this.parent, this.actionId, this.callbackData, this.callback)
                }        
            }
        };
        
        if (iconClass) {
            arg["iconClass"] = iconClass;
            arg["showLabel"] = false;
        }
        var button;
        if (dropDown) {
        	arg['dropDown'] = dropDown;
        	button = new dijit.form.DropDownButton(arg);
        }
        else {
            button = new com.ibm.asq.common.web.ui.internal.widgets.Button(arg);
        }
                
        // store the client callback and data into the button
        button.actionId = actionId;
        button.parent = this;
        button.callbackData = callbackData;
        button.callback = callback;
        button.setDisabled(!this.isEditable());
        
        this.tableActionList.push(button);
        
        if(this.settingAction) 
            this.actionsAreaNode.insertBefore(button.domNode, this.settingAction.domNode);
        else 
            this.actionsAreaNode.appendChild(button.domNode);
        
        return button;
    },
    
    // Summary:
    //    Add an alternate view mode to the table.  Calling this method
    //    will add the view mode to the "View By" select list above the
    //    table.  When the user selects an alternate view mode the provided
    //    callback is called with its provided callback data.  It is the
    //    responsibility of the callback function to take any actions
    //    on the table (hide the table rows, toggle filters, etc...)
    addViewMode: function(id, label, callback, /* optional */callbackData) 
    {
        var mode = {
        	id: id,
            label: label,
            callback: callback,
            callbackData: callbackData
        };
    	this.viewModeList.push(mode);
    },
    
	
	/*
	 * Returns ALL actions associated with the table
	 */
	getActionButtons: function(/*String*/ id) {
	   return this.tableActionList;
	},
	
	/*
	 * Finds and returns an action button by its identifier;
	 * Returns null if no match is found
	 */
	getActionButton: function(/*String*/ id) {
		if (this.tableActionList && this.tableActionList.length > 0) {
			for (var i = 0; i < this.tableActionList.length; i++) {
				if (this.tableActionList[i].actionId == id) {
					return this.tableActionList[i];
				}
			}
		}
		return null;
	},

    // Summary:
    //    A convenient method to delete a row object from the content. It obtains the content objects
    //    from the content provider and remove the specified row object. The row object to
    //    be deleted must be an object in the content objects set. Please note the object is only removed
    //    from the content objects array. The client of the table must delete the actual content that represents
    //    the row object.
    //     
    deleteItem: function(rowObject)
    {
        var rawObjects = this._getContentObjects();
        var hasDelete = false;
        
        for(var i = 0; i < rawObjects.length; i++) {
            if(rawObjects[i] === rowObject) {
                rawObjects.splice(i, 1);
                hasDelete = true;
                break;
            }
        }
        if(hasDelete) {
            // if we deleted the last item in the page, go back to prev page, but only need
            // to do this if we're paging.
            if(this.getIsPagingContents() && this.curPageItemStart >= (this.totalItems - 1)) {
                var lastPage = this.curPageItemStart - this.pageSize;
                this.curPageItemStart = Math.max(0, lastPage);
            }
            this._constructTableContents(false);
        }     
    },
    
    // Summary:
    //    If the TableViewer is set to allow checkable rows, this methods returns the currently selected/checked
    //    rows. An array of row objects are returned. In the case of the table is not in checkable mode, or 
    //    no rows are checked, it returns an empty array.
    //
    getCheckedRows: function()
    {
        var checkedRows = [];
        
        if(this.rowsCheckable) {
            checkedRows = this.rowCheckedHandler.getAllCheckedRows();
        }
        return checkedRows;
    },
    
    getAllRows: function()
    {
        var allRows = [];
        
        if(this.rowsCheckable) {
            allRows = this.rowCheckedHandler.getAllRows();
        }
        return allRows;
    },

    getSortByColumn: function()
    {
        return this.sortByColumn;    
    },
    
    getMultiColumSortInfo: function()
    {
        return this.sortColumns;
    },
    
    getGroupByColumn: function()
    {
        return this.groupByColumn;    
    },

    getTableMajorMode: function()
    {
        return this.majorMode;
    },
    
    getFilter: function()
    {
        return this.filterBy;    
    },
    
    getContent: function()
    {
        return this.content;
    },

    getSortDirection: function()
    {
        return this.sortDir;    
    },

    getTableRowsCheckable: function()
    {
        return this.rowsCheckable;
    },

    getIsSingleSelectionMode: function()
    {
        return this.rowSelectIsSingle;
    },
    
    getIsAllowSelectAll: function()
    {
        return this.allowSelectAll;
    },
    
    getRowCheckboxColumnWidth: function()
    {
        return ROW_CHECK_WIDTH;  
    },
    
    getIsShowingTableHeading: function()
    {
        return this.showTableHeading;    
    },

    getIsShowingFilterControl: function()
    {
        return this.showFilterControl;    
    },

    getIsShowingViewModeControl: function()
    {
        return this.showViewModeControl;
    },
    
    getIsShowingPagingControl: function()
    {
        return this.showPagingControl;    
    },
	
	getIsShowingPagingRangeControl: function()
    {
        return this.showPagingRangeControl;    
    },
    
    getContentPageSize: function()
    {
        return this.pageSize;
    },
    
    // Summary:
    //    Returns the number of rows that are not shown due to collapsed groups.
    //    
    getHiddenRowsSize: function()
    {
        return this.nFiltered;    
    },
    
    getContentProvider: function()
    {
        return this.contentProvider;
    },
    
    getTableListener: function(tableListener)
    {
        return this.tableListener;
    },
    
    getCellRenderer: function(type) 
    {
        if(this.cellRendererRegistry[type]) {
            return this.cellRendererRegistry[type];
        }
        console.debug("No cell renderer registered for: " + type);
        return this.cellRendererRegistry[TableConstants.RENDER_TYPE_TEXT];
    },

    getCellModifier: function()
    {
        return this.cellModifier;
    },

    // Summary:
    //    Returns the total number of items in the current display content.
    getContentItemCount: function()
    {
        var rawObjects = this._getContentObjects();
        return rawObjects ? rawObjects.length : 0;    
    },

    // Summary:
    //    Returns the number of items in the current display set. This number could
    //    be different from the total items in the content due to filtering.
    //
    getCurrentDisplayItemsCount: function()
    {
        return this.totalItems;    
    },
    
    getIsPagingContents: function()
    {
        return this.pageSize > -1;        
    },
    
    getCurrentPageStartItem: function()
    {
        return this.curPageItemStart;
    },
    
    // Summary:
    //    Given the current page size and the current page start position, calculate the
    //    previous's starting page position. The calculation takes into the consideration of
    //    whether a group is collapsed in the current display. If so, the starting position is
    //    skipped to the group's beginning position. Optionally, specify the fromCurrent flag to
    //    true, we start the calculation from the current page position.
    //
    _calculatePrevPagePos: function(fromCurrent)
    {
        var prevPage = this.curPageItemStart - ((fromCurrent) ? 0 : this.pageSize);
        
        // check to see if the group we're currently at is
        // closed.
        if(prevPage > 0 && this.groupByColumn > -1) {
            var startPos = this._calculateGroupStartPos(prevPage);
            var groupState = this._getGroupDisplayState(startPos.groupIndex);
            var groupOffset = (startPos.groupStartPos + startPos.offset);
            
            // if the "prev" page is in the middle of this closed group,
            // roll all the way back to the beginning of the group.
            if(!groupState.isOpen && prevPage >= groupOffset) {
                while(prevPage > startPos.groupStartPos) {
                    prevPage -= this.pageSize;
                }
            }
        }
        prevPage = (prevPage >= 0) ? prevPage : 0; 
        return prevPage;
    },
    
    _calculateNextPagePos: function()
    {
        var nextPage = this.curPageItemStart + this.pageSize;
        
        // skip over filtered items (hidden items from group collapse) in 
        // multiples of the page size.
        if(this.nFiltered > 0) {
            var nPageToSkip = this.nFiltered / this.pageSize;
            
            if(nPageToSkip > 0)
                nextPage = nextPage + (nPageToSkip * this.pageSize);
        }
        return nextPage;
    },
    
    getHasPreviousPage: function()
    {
        if(this.getIsPagingContents()) {
            var prevPage = this._calculatePrevPagePos(true);
            return prevPage > 0;
        }
        return false;
    },

    getHasNextPage: function()
    {
        if(this.getIsPagingContents()) {
            var nextPage = this._calculateNextPagePos();
            return (nextPage < this.totalItems);
        }                
        return false;
    },
    
    performPreviousPage: function()
    {
        if(this.getHasPreviousPage()) {
            this.curPageItemStart = this._calculatePrevPagePos();
            this._loadTableContents();
        }
    },

    performNextPage: function()
    {
        if(this.getHasNextPage()) {
            var nextPage = this._calculateNextPagePos();
            this.curPageItemStart = (nextPage < (this.totalItems - 1)) ? nextPage : this.totalItems - 1;            
            
            this._loadTableContents();
        }        
    },

    performSortBy: function(colIndex, sortDir)
    {
        this.sortByColumn = colIndex;
        this.sortDir = sortDir;
        
        if(this.getContentItemCount() >= this.displayWorkingThreshold)
            this._constructTableContentsWithProgress(this.workingLabel);   
        else
            this._constructTableContents();
    },

    performMultiColumnSort: function(sortColumns)
    {
        this.sortColumns = sortColumns;
        
        if(this.getContentItemCount() >= this.displayWorkingThreshold)
            this._constructTableContentsWithProgress(this.workingLabel);   
        else
            this._constructTableContents();
    },
    
    performGroupBy: function(colIndex)
    {
        this.groupByColumn = colIndex;
        
        // reset the sort if we're grouping
        // the same column.
        if(this.sortByColumn == this.groupByColumn) {
            this.sortByColumn = -1;
            this.sortDir = TableConstants.SORT_DIR_ASCEND;
        }
        
        // reconstruct the content table including the table header.
        this._recreateContentTable();
        
        // load the content into the table, but we also have to reconstruct
        // the contents based on the new grouping.
        if(this.getContentItemCount() >= this.displayWorkingThreshold)
            this._constructTableContentsWithProgress(this.workingLabel);   
        else
            this._constructTableContents();

        this.tableContainerNode.appendChild(this.table);        
    },
    
    // Summary:
    //    Switch to the view mode with the provided id 
    switchViewMode: function(id)
    {
    	var viewMode = null;
        for(var i = 0; i < this.viewModeList.length; i++) {
        	var tmpViewMode = this.viewModeList[i];
        	if (tmpViewMode.id == id) {
        		viewMode = tmpViewMode;
        		break;
        	}
        }
        
        if (viewMode==null) {
			console.debug("View mode with id "+ id + " was not found.");
        } else if (viewMode.callback==null) {
			console.debug("A callback for view mode with id "+ id + " was not found.");
        } else {
        	this._currentViewModeId = id;
        	viewMode.callback(viewMode.callbackData);
        }
    },
    
    performFilterBy: function(filterBy)
    {
		//clear the last click info whenever the content is reconstructed
		this.lastSelectedInfo = null; 
		
        this.filterBy = (filterBy && filterBy.length > 0) ? filterBy : null;
        
        // reset the current page index into the content's items.
        // this is the index for the top item in the current display
        // page.  
        this.curPageItemStart = 0;
        if(this.getContentItemCount() >=this.displayWorkingThreshold)
            this._displayContentsWithProgress(this.workingLabel);   
        else
            this._displayContents();
    },
    
    performSelectAll: function(select)
    {
		//clear the last click info whenever the content is reconstructed
		this.lastSelectedInfo = null; 
		
        if(this.getContentItemCount() == 0)
            return;
            
        var selectedRows = [];
        
        this.rowCheckedHandler.clearRowStates();
        if (select) {
            for (var i = 0; i < this.orderedObjects.length; i++) {
                for (var j = 0; j < this.orderedObjects[i].length; j++) {
                    this.rowCheckedHandler.setRowCheckState(this.orderedObjects[i][j], select);
                }
            }
        }
        this._loadTableContents();
        
        // notify internally
        this._internalRowChecked();

        var listener = this.getTableListener();
        if(listener) {
            listener.rowCheckStateChanged(this, selectedRows, select);
        }  
    },
    
    // Summary:
    //    Redraw the current content. Unlike the show() method, this method
    //    retains the current user settings of the table. 
    //    Optionally specify whether to reset the page start to the top, i.e., show
    //    the first page of content. By default, the start page is always kept.
    //
    refresh: function(/* optional */resetToTop)
    {
        if(!this.content || !this.contentProvider) {
            return;            
        }
        // if our table contents are not visible, don't have to refresh
        if(this.tableContainerNode && this.tableContainerNode.style.display == "none") {
            return;
        }
        
        // the content could have changed, added/removed, etc. update
        // the page size controller too.
        if (this.getIsShowingPagingRangeControl()) {
            dojox.data.dom.removeChildren(this.PageSelectControlNode);
            this.headerRenderer._createPageRangeControl(this.PageSelectControlNode);
        }
        
        // just in case the user change the window size, recreate the
        // table header, etc. to pickup and size changes before refreshing
        // contents. Also, in case the client calls refresh before calling
        // a show() as the tbody has not been created, call recreateContentTable 
        // as well.
        this._resetColumnWidthsCache();
        if(!this.tbody || this.isCompactMode) {
            this._recreateContentTable();            
            this.tableContainerNode.appendChild(this.table);
        }
        var reset = (typeof resetToTop != "undefined") ? resetToTop : false;
        
        // in the case where there is page start pos but
        // the content is no longer page-able, force a reset.
        if(this.pageSize < 0 && this.curPageItemStart > 0)
            reset = true;
            
        this._constructTableContents(reset);
		this.table.summary = this.tableSummary;
    },
    
    // Summary:
    //    Displays the content's row objects in the specified display mode. This method must be
    //    called when a new (or initial) content is set, a new (or initial) content provider is set,
    //    an custom renderer, or new cell renderer type is set, a new major display mode is set,
    //    or changing the row checkable setting.
    //
    show: function()
    {
        //console.debug("entering: show");
        if(!this.content || !this.contentProvider) {
            return;            
        }
        
        if (this.allowAdjustSettings && this.autoSaveSettings && this.tableId && this.columnSettings == null) {
            var pref = Preferences.getStoredUserPreferences(this.tableId);
            if(pref && pref.value) {
                this.tableSettings = dojo.fromJson(pref.value);
                this.columnSettings = this.tableSettings.columnSettings;
                this.isCompactMode = this.tableSettings.isCompactMode;
            }
        }
        dojox.data.dom.removeChildren(this.PageSelectControlNode);
        dojox.data.dom.removeChildren(this.filterControlNode);
        dojox.data.dom.removeChildren(this.groupControlNode);
        dojox.data.dom.removeChildren(this.viewModeControlNode);
        dojox.data.dom.removeChildren(this.PageControlNode);
        dojox.data.dom.removeChildren(this.footerPageControlNode);
        dojox.data.dom.removeChildren(this.tableContainerNode);
        
        this.table = document.createElement("table");
        dojo.addClass(this.table, "content-table");
        this.filterBy = null;
        this.nFiltered = 0;
        
        // the group states keep track of the group's open/close
        // states. reset it. The groups will get recreated.
        this.groupStates = {};

        this._resetColumnWidthsCache(true);
        this._constructTableControls();
		
		if (this.showViewModeControl) {
			var key = Preferences.USER_UI_CUSTOMISE_QUERYLISTS_DEFAULT_VIEW_MODE.key;
			var defaultViewModePref = Preferences.getStoredUserPreferences(key);
			if (defaultViewModePref!=null && defaultViewModePref.value!=null) {
				var defaultViewModeId = defaultViewModePref.value;
				this.switchViewMode(defaultViewModeId);
			}
		}

        this.tbody = document.createElement("tbody");
        this.table.appendChild(this.tbody);        
        this._constructTableContents();
		this.table.summary = this.tableSummary;
        this.tableContainerNode.appendChild(this.table);        
    },
	
	// Summary:
    //    Get current page control information, including filter text, group column and sort column.
    //
	getCurrentPageControl: function() {
		var params = {};
		params.filterInput = this.filterBy;
		
		if(this.headerRenderer.groupSelect && this.groupByColumn > -1) {
			//grouped
			params.groupName = this.contentProvider.getColumnHeading("", this.groupByColumn);
		}
		if (this.sortByColumn > -1) {
			params.sortName = this.contentProvider.getColumnHeading("", this.sortByColumn);
			params.sortDir = this.sortDir;
		}
		return params;
	},
	
	// Summary:
    //    Redraw the current table. Unlike the show() method, this method
    //    retains the current user settings of the table. Unlike the refresh() method, 
	//    this method redraw table header. This method must be called when a new content provider is set.
    //
	reconstruct: function(controlParam) {
		if(controlParam.groupName) {
			//grouped
			this.groupByColumn = this.contentProvider.getColumnIndex(controlParam.groupName);
		}
		if(controlParam.sortName) {
			//sorted
			this.sortByColumn = this.contentProvider.getColumnIndex(controlParam.sortName);
			this.sortDir = controlParam.sortDir;
		}
		
		//console.debug("entering: show");
        if(!this.content || !this.contentProvider) {
            return;            
        }
        
        dojox.data.dom.removeChildren(this.PageSelectControlNode);
        dojox.data.dom.removeChildren(this.filterControlNode);
        dojox.data.dom.removeChildren(this.groupControlNode);
        dojox.data.dom.removeChildren(this.viewModeControlNode);
        dojox.data.dom.removeChildren(this.PageControlNode);
        dojox.data.dom.removeChildren(this.footerPageControlNode);
        dojox.data.dom.removeChildren(this.tableContainerNode);
        
        this.table = document.createElement("table");
        dojo.addClass(this.table, "content-table");
        
        // the group states keep track of the group's open/close
        // states. reset it. The groups will get recreated.
        this.groupStates = {};
        
        // reset the current list of displayed groups
        this._displayedGroups = [];
		
        this._resetColumnWidthsCache(true);
        this._constructTableControls();
		
		if(this.filterBy && this.filterBy.length > 0) {
			this.headerRenderer.filterInput.value = this.filterBy;
		}

        this.tbody = document.createElement("tbody");
        this.table.appendChild(this.tbody);        
        this._constructTableContents();
		this.table.summary = this.tableSummary;
        this.tableContainerNode.appendChild(this.table);      
        
        // restore the current view mode if necessary
        var viewModeId = this.getCurrentViewModeId();
        if (viewModeId!=null) {
        	this.switchViewMode(viewModeId);
        }
	},
	
    // Summary:
    //    Return the current view mode ID.  It corresponds to the
    //    select box that is next to the Group By control.
    // 
    getCurrentViewModeId: function() {
    	return this._currentViewModeId;
    },
	
	
    // Summary:
    //    Internal method to fetch the provider's content objects. All access
    //    to the provider's raw objects should be done through this method to 
    //    avoid possible inefficiency that the client might be building the 
    //    objects on the fly.
    _getContentObjects: function()
    {
        if(!this.rawObjects) {
            this.rawObjects = this.contentProvider.getContentObjects(this.content);
        }
        return this.rawObjects;
    },
    
    _constructTableContentsWithProgress: function(message, resetStartPos)
    {
        this._clearTableContents();
        this.showLoadingProgress(message);
        this.clearProgressAfterLoad = true;
        
        setTimeout(dojo.hitch(this, function() {
            this._constructTableContents(resetStartPos);
        }), 0);
        
    },
    
    _displayContentsWithProgress: function(message)
    {
        this._clearTableContents();
        this.showLoadingProgress(message);
        this.clearProgressAfterLoad = true;
        
        setTimeout(dojo.hitch(this, "_displayContents"), 0);        
    },
    
    _canDoMultiSort: function()
    {
        var sorterSupported = this.contentSorter.groupSortByColumns && this.contentSorter.sortByColumns;
        return sorterSupported;
    },
    
    // Summary:
    //    This method prepares the content data and displays the contents from the
    //    top position. It sort/group the content and loads the data into the display
    //    table. Optionally, the method could keep the current page display position and
    //    not resetting the top display position to 0.
    //    @param resetStartPos Optional, if specified and set to false, the current top display position is no reset to 0
    //
    _constructTableContents: function(resetStartPos)
    {
        // clear any group widgets when the table's being refreshed.
        this._clearGroupRowWidgets();        
        
		//clear the last click info whenever the content is reconstructed
		this.lastSelectedInfo = null; 
		
        var rawObjects = this._getContentObjects();
        
        // if the content is being renewed and the content has items,
        // clear any error message that was set. This is done unconditionally
        // regardless we are showing an error message.
        if(rawObjects.length > 0) {
            this.clearContentError();
        }
        
        // there's grouping and sorting turned on. Do 
        // the group/sort business.        
        if(this.allowMultiSort && this._canDoMultiSort()) {
            // multi-column sorting and our sorter supports it.
            // invoke the multi-sort/group methods.
            if (this.groupByColumn > -1) {
                this.unfilteredObjects = this.contentSorter.groupSortByColumns(this, rawObjects, this.groupByColumn, this.sortColumns);
            }
            else if (this.sortColumns && this.sortColumns.length > 0) {
                this.unfilteredObjects = this.contentSorter.sortByColumns(this, rawObjects, this.sortColumns);
            }
            else {
                this.unfilteredObjects = [];
                this.unfilteredObjects.push(rawObjects);
            }         
        }
        else if(this.groupByColumn > -1 || this.sortByColumn > -1) {
            if(this.groupByColumn > -1)
                this.unfilteredObjects = this.contentSorter.groupSortBy(this, rawObjects, this.groupByColumn, this.sortByColumn, this.sortDir);
            else
                this.unfilteredObjects = this.contentSorter.sortBy(this, rawObjects, this.sortByColumn, this.sortDir);
        }
        else {
            this.unfilteredObjects = [];
            this.unfilteredObjects.push(rawObjects);            
        }
        
        // reset the current page index into the content's items.
        // this is the index for the top item in the current display
        // page.  
        if(typeof resetStartPos == "undefined" || resetStartPos)
            this.curPageItemStart = 0;
        else if(this.getIsPagingContents()) {
            // if we're not resetting the item start pos, double check
            // the current item start is still valid.
            if (this.curPageItemStart > this.getContentItemCount()) {
                while (this.curPageItemStart > this.getContentItemCount()) {
                    this.curPageItemStart -= this.getContentPageSize();
                }
                this.curPageItemStart = Math.max(0, this.curPageItemStart);
            }
        }
        this._displayContents();
    },
    
    // Summary:
    //
    _displayContents: function()
    {
        if(this.filterBy) {
            this.orderedObjects = [];
            for(var i = 0; i < this.unfilteredObjects.length; i++) {
                var aGroup = [];
                for(var j = 0; j < this.unfilteredObjects[i].length; j++) {
                    if(this.contentFilter.accepts(this, this.unfilteredObjects[i][j], this.filterBy)) {
                        aGroup.push(this.unfilteredObjects[i][j]);
                    }
                }
                this.orderedObjects.push(aGroup);
            }
        }
        else {
            this.orderedObjects = this.unfilteredObjects;
        }
        
        this.totalItems = 0;
        
        // tally up the total items in the content
        for(var i = 0; i < this.orderedObjects.length; i++) {
            this.totalItems += (this.orderedObjects[i].length);
        }

        // fill the table rows with the content's data. The number
        // of rows being filled is controlled by the page size attribute.
        this._loadTableContents();
        
        this.headerRenderer.updatePageControlDisplay();
                
        // no items in the table, show a message.
        if(this.totalItems == 0) {
            var message = (this.filterBy == null) ? this.noItemMessage : this.noMatchFilterMessage;
            if(message.length == 0) {
                if(this.filterBy) 
                    message = MessageUtil.getMessage(MessageBundle.COMMON, "tableViewer_filteredAllMsg");
                else
                    message = MessageUtil.getMessage(MessageBundle.COMMON, "tableViewer_noItemMsg");
            }
            dojo.style(this.messageAreaNode, "display", "block");
            this.messageAreaNode.innerHTML = message;
        }
        else {
            dojo.style(this.messageAreaNode, "display", "none");           
        }
    },
    
    _constructTableControls: function()
    {
        // based on the major mode of the table, constructt
        // the proper header/controls.
        this.headerRenderer.destroyTableHeader();
        this.headerRenderer.createTableControls(this.PageSelectControlNode, this.PageControlNode, this.footerPageControlNode, this.filterControlNode, this.groupControlNode, this.viewModeControlNode);
        this.headerRenderer.createTableHeader(this.table);
    },
    
    // Summary:
    //    Deletes the table's rows before it's being reloaded with data.
    //
    _clearTableContents: function()
    {            
        if(this.tbody && this.tbody.rows.length > 0) {
            var nToDelete = this.tbody.rows.length - 1;
            
            for(var i = nToDelete; i >= 0; i--) {
                this.tbody.deleteRow(i);
            }
        }
        this._clearRendererContents();
        dojo.style(this.messageAreaNode, "display", "none");           
    },
    
    // Summary:
    //    Based on the current page starting position, find the starting group
    //    index and any offset from the start of the group.
    //
    _calculateGroupStartPos: function(pos)
    {
        var groupPos = 0;
        var offset = 0;
        var groupStart = {};
        var pageStart = (pos) ? pos : this.curPageItemStart;
        
        // no group in the ordered objects, or we don't have 
        // any page offset, start at the first group.
        if(pageStart > 0) {
            var groupItemCnt = 0;
            
            for(var i = 0; i < this.orderedObjects.length; i++) {
                if((groupItemCnt + this.orderedObjects[i].length) > pageStart) {
                    groupPos = i;
                    offset = pageStart - groupItemCnt;
                    break;
                }
                // not reach the group we are show, continue.
                groupItemCnt += (this.orderedObjects[i].length);
            }
        }
        groupStart["groupIndex"] = groupPos;
        groupStart["groupStartPos"] = groupItemCnt;
        groupStart["offset"] = offset;
        return groupStart;
    },
    
    _loadTableContentsWithProgress: function()
    {
        this._clearTableContents();              
        this.showLoadingProgress();
        this.clearProgressAfterLoad = true;
        setTimeout(dojo.hitch(this, "_loadTableContents"), 0);
    },
	
	// Summary:
	//    Main entry point to actually render the table contents. This method
	//    decides whether to draw the content right away or, we have to wait for
	//    the table to be a part of the active dom tree before drawing the contents.
	//
    _loadTableContents: function()
    {
		// the client is making multiple calls into the refresh contents while
		// we're in the check width mode. Ignore this.
        if (this._checkTableInDomTreeCnt) {
            return;
        }
		
        // clear any contents the table might be showing
        this._clearTableContents();

        // if this is NOT in compact mode or we have a proper dimension
		// we can start drawing the table content right away. Another optimization
		// is if we don't have rows to draw, we don't need to wait.
        if(!this.isCompactMode || this.table.clientWidth > 0 || this.getContentItemCount() == 0) {
            this._loadTableContentsImpl();
        }
        else {
			// need to go to timer mode to wait and check for valid size info.
	        this._preLoadCheckSize();
        }    
    },
    
	// Summary:
	//    When the table has not yet been added to the dom tree, it has
	//    no dimensions. We need to effectively wait until the dom node
	//    shows up. This method sets up a timer event to check for a valid
	//    size before rendering cell data.
	//
	_preLoadCheckSize: function()
	{
        // if this is NOT in compact mode, we can start drawing the
        // the table content right away. Or, we have waited long enough
        // that the table has been added to the DOM tree and that the
        // table already has a dimension, we can render the table content
        // with accurate cell dimensions to do the proper clipping in
        // compact mode.
        if(this.table.clientWidth > 0) {
			// we've the size, clear the check width flag and render things.
            if(this._checkTableInDomTreeCnt) {
                delete this._checkTableInDomTreeCnt;
            }
            this._loadTableContentsImpl();
        }
        else {
            // initialized the counter to track whether the table
            // is actually have been added to the dom tree. This is 
            // IMPORTANT. Otherwise, if the client just created the 
            // table and doesn't add it to the dom tree, we would be
            // leaking timeouts...
            if (!this._checkTableInDomTreeCnt) {
				this._checkTableInDomTreeCnt = 0;
			}
			
			// we're going to retry several times to obtain the proper size. If
			// after certain number of retries and we still don't have the size, 
			// the table is probably not in view and we need to give up to avoid infinite
			// callback. 
            if (this._checkTableInDomTreeCnt < 6) {
                this._checkTableInDomTreeCnt++;
                setTimeout(dojo.hitch(this, "_preLoadCheckSize"), 30);
            }
            else {
				// giving up. Just render now. If this table was in view
				// at one point and had the sizing data, we'll use the cached
				// widths.
                delete this._checkTableInDomTreeCnt;
                this._loadTableContentsImpl();
            }
        }    
	},
	
    // Summary:
    //     Get an array of Groups that corresponds to the groupings currently
    //     shown in the table. Each Group has a "name" attribute and an
    //     "objects" attribute.   The name corresponds to the title of the
    //     group shown in the table and the "objects" corresponds to the
    //     underlying objects for each row in that group.
    //
    //     If the Group By control is not in use then a single group with no
    //     name is returned.
    getDisplayedGroups: function()
    {
    	return this._displayedGroups;
    },
	
    // Summary:
    //     listener method that is called whenever the displayed groups have
    //     changed.  this could be triggered by some interaction with the
    //     table filter, column sort, View Builder query, etc.  A dummy 
    //     implementation of this listener method which can be overridden
    //     is provided here.
    onDisplayedGroupsUpdated: function()
    {
    	// dummy implementation
    },
	
    // Summary:
    //     Actual implementation of rendering a page of the table contents.
    _loadTableContentsImpl: function()
    {
        var provider = this.contentProvider;
        var content = this.getContent();
        var table = this.table;
        var orderedObjects = this.orderedObjects;
        var hasGroups = (orderedObjects.length > 1 || this.groupByColumn > -1);
        var maxItemInPage = (this.pageSize > -1) ? this.pageSize : this.totalItems;
        var startPos = this._calculateGroupStartPos();
        var groupStart = startPos.groupIndex;
        var groupStartOffset = startPos.offset;
        
        if(this.tableRows) {
            delete this.tableRows;
        }
        if(this._displayedGroups) {
            delete this._displayedGroups;
        }
        if(this.rowCheckBoxes) {
            delete this.rowCheckBoxes;
        }
        
        // keep a running list of objects that are currently displayed
        this._displayedGroups = [];
        
        // reset the current number of item filtered from the 
        // current start of the page (this.curPageItemStart)
        this.nFiltered = 0;
        this.nItemsShown = 0;
        this.rowCheckBoxes = {};
        this.tableRows = {};
        var orderedObjectsLength = orderedObjects.length;
        var doc = document;
        var bodyFragment=doc.createDocumentFragment();
        for(var i = groupStart; i < orderedObjectsLength; i++) {
            var groupCtrl = null;
            var groupItemShown = 0;

            var displayedGroup = {'name': null, 'objects': []};
            this._displayedGroups.push(displayedGroup);
            
            var orderedObject=orderedObjects[i];
            var orderedObjectLen = orderedObject.length;
            if(hasGroups) {
                var groupName = this._getGroupName(i);
                var groupImage = this._getGroupImage(i);
				var groupExtra = this.contentProvider.getGroupColumnExtraData(orderedObject[0], this.groupByColumn);
                groupCtrl = this._createGroupHeading(table, i, groupName, groupImage, groupExtra, bodyFragment);
                
                this._groupRowWidgets.push(groupCtrl);
                displayedGroup.name = groupName;
                
                // the group state is collapse. Don't draw the
                // group's rows.
                var groupState = this._getGroupDisplayState(i);
                if(!groupState.isOpen) {
                    this._updateGroupDetails(groupCtrl, false, orderedObjectLen, groupStartOffset, 0);
                    
                    // update the number of items "filtered". We're skipping
                    // showing the group's items. 
                    this.nFiltered += orderedObjectLen;
                    
                    // the group start offset applies only to the first group 
                    // being displayed in the current page. Reset it.
                    groupStartOffset = 0;
                    continue;
                }
             }
            // show the rows for the group
            for(var j = groupStartOffset; j < orderedObjectLen; j++) {
            	var orderedObject_j=orderedObject[j];
                var tr = doc.createElement('tr');
                bodyFragment.appendChild(tr);
				
                // if this is grouped, insert an indentation column in front
                // of normal rows to emphasize the rows belonging to the group
                // row.
                if(hasGroups) {
                    var td = doc.createElement('td');
                    tr.appendChild(td);
                    td.width = 8;
					td.appendChild(doc.createTextNode(" "));
                }
                
                // insert the check box for the row if the rows
                // are to be checkable/selectable. 
                if(this.rowsCheckable) {
                    var initChecked = this.rowCheckedHandler.getRowCheckState(orderedObject_j);
                    var extendedInfo = {'state': initChecked};
                    var button = this.rowCheckBoxRenderer.renderCell(this, "", extendedInfo, this.rowCheckedHandler, orderedObject_j, i, j);
                    var td = doc.createElement('td');
                    tr.appendChild(td);
                    var id = provider.getRowDataId(orderedObject_j);
            
                    td.align = "center";
                    td.appendChild(button.domNode);
                    
                    // tie the id to the row & checkbox UI elements.
                    if (id) {
                        this.rowCheckBoxes[id] = button;
                        this.tableRows[id] = tr;
                    }
                    if(initChecked) {
                        dojo.addClass(tr, "selected-row-highlight");
                    }
                }
                // draw a row content
                this.rowRenderer.renderRow(this, orderedObject_j, tr);
                displayedGroup.objects.push(orderedObject_j);

                // cerate a filler cell for the dropdown column to show the multi-sort
				// header. 
                if(this.allowMultiSort) {
					var td = doc.createElement('td');
					td.width = 10;
					td.appendChild(doc.createTextNode(" "));
					tr.appendChild(td);
				}

                this.nItemsShown++;
                groupItemShown++;
                
                // we're done showing the items on the page.
                if(this.nItemsShown == maxItemInPage)
                    break;
            }
            
            // we have displayed items for the group, show the group's accounting
            if(groupCtrl) {
                this._updateGroupDetails(groupCtrl, true, orderedObjectLen, groupStartOffset, groupItemShown);                
            }
            
            // we're done showing the items on the page.
            if(this.nItemsShown == maxItemInPage)
                break;
           
            // reset the group's start offset. We've finished
            // render the group's remainder.
            groupStartOffset = 0;
        }
        this.tbody.appendChild(bodyFragment);

        // Clear the progress if we have initiated the progress indicator.
        if (this.clearProgressAfterLoad) {
            this.endLoadingProgress();
            this.clearProgressAfterLoad = false;
        }            

        // notify any listeners that the displayed groups have been updated
        if (this.onDisplayedGroupsUpdated) {
        	this.onDisplayedGroupsUpdated();
        }
    },
    
    showLoadingProgress: function(message)
    {
        // disable the no item message during loading progress.
        this.noItemMessage = " ";
        dojo.style(this.messageAreaNode, "display", "none");
        
        var msg = (message || this.loadingLabel);
        this.loadingLabelNode.innerHTML = msg;

        dojo.style(this.loadingProgressNode, "display", "block");
    },
    
    endLoadingProgress: function()
    {
        this.noItemMessage = "";
        dojo.style(this.loadingProgressNode, "display", "none");
    },

    showContentError: function(message)
    {
        // disable the no item message when we show an error
        this.noItemMessage = " ";
        dojo.style(this.messageAreaNode, "display", "none");
        
        var msg = (message || this.errorLabel);
        this.errorLabelNode.innerHTML = msg;

        dojo.style(this.errorMessageNode, "display", "");        
    },

    clearContentError: function()
    {
        this.errorLabelNode.innerHTML = "";
        dojo.style(this.errorMessageNode, "display", "none");
    },
            
	setGroupEnabled: function(/*boolean*/ enabled) {
		this.headerRenderer.setGroupControlEnabled(enabled);
	},
	
	setFilterEnabled: function(/*boolean*/ enabled) {
		this.headerRenderer.setFilterControlEnabled(enabled);
	},
	
	setTableRowsVisible: function(/*boolean*/ visible) {
		var style = visible ? "block" : "none";
        
        dojo.style(this.tableContainerNode, "display", style);
        dojo.style(this.footerPageControlNode, "display", style);
        
        // FF needs to specify the row to be a table-row display type.
        if(dojo.isFF && visible) style = "table-row";
        dojo.style(this.controlAreaPagingActionsNode, "display", style);
	},

    // Summary:
    //    NOTE: Experimental API... Redraws the table's contents without 
    //    recreating the table's rows.
    //
    //    This is a very limited redraws capability in the table. It
    //    can only redraw the table contents properly when there's no sorting
    //    grouping, row checkable, etc. If any of these table settings are 
    //    turned on, this method reverts to refresh().
    //
    redrawRows: function()
    {
        // revert to refresh if there are complicated content management....
        if(this.groupByColumn > -1 || this.sortByColumn > -1 || 
           this.rowsCheckable || !this.rowRenderer.redrawRow || 
           this.curPageItemStart > 0) {
            this.refresh();
            return;
        }
        var provider = this.contentProvider;
        var table = this.table;
        var rawObjects = this._getContentObjects();
        this.unfilteredObjects = [];
        this.unfilteredObjects.push(rawObjects);  
        this.orderedObjects = this.unfilteredObjects;          
        
        for(var i = 0; i < this.tbody.childNodes.length; i++) {
            var tr = this.tbody.childNodes[i];
            this.rowRenderer.redrawRow(this, this.orderedObjects[0][i], tr);
        }            
    },
    
    // Summary:
    //    Get the group name based on the current group index in our ordererd content
    //    The current display content could be filtered and the group may be empty in the
    //    ordered content. In this case get the group name from the unfiltered content.
    //
    _getGroupName: function(groupIndex)
    {
        var obj = null;
        var name = "";
        
        if(this.orderedObjects[groupIndex].length > 0)
            obj = this.orderedObjects[groupIndex][0];
        else if(this.unfilteredObjects[groupIndex].length > 0)
            obj = this.unfilteredObjects[groupIndex][0];
        
        if(obj) {
            name = this.contentProvider.getCellDisplayData(obj, this.groupByColumn);
            if(name instanceof Date || this.contentProvider.getCellDisplayType(obj, this.groupByColumn) == TableConstants.RENDER_TYPE_TIMESTAMP) {
                var date = (name instanceof Date) ? name : com.ibm.asq.common.web.ui.internal.widgets.tableViewer.Util.convertTimeStampToDate(name);
         
                if(date) {
                    name = CommonUtility.formatDate(date);
                }
            }
            else if(!dojo.isString(name)) {
                name = name + "";
            }
        }
        if (name == null || dojo.trim(name).length == 0) {
            name = this.unspecifiedGroupTitle;
        }
        return name;        
    },
    
    // Summary:
    //    Get the group image based on the current group index in our ordererd content.
    //    The current display content could be filtered and the group may be empty in the
    //    ordered content. In this case get the first row object in the group from the 
    //    unfiltered content. If the row object's display type for the grouped column is
    //    an image, use that image for the group, otherwise, just use the grouped column's
    //    image if one is provided.
    //
    _getGroupImage: function(groupIndex)
    {
        var img = this.contentProvider.getColumnHeadingImage(this.getContent(), this.groupByColumn);
        var obj = null;
        
		// the header image is an action. Don't show that in the group's image.
		if(img && dojo.isObject(img) && img.actionId) {
			img = null;
		}
        if(this.orderedObjects[groupIndex].length > 0)
            obj = this.orderedObjects[groupIndex][0];
        else if(this.unfilteredObjects[groupIndex].length > 0)
            obj = this.unfilteredObjects[groupIndex][0];
        
        if (obj) {
            if (this.contentProvider.getCellDisplayType(obj, this.groupByColumn) == TableConstants.RENDER_TYPE_IMAGE) {
                var extData = this.contentProvider.getCellDisplayExtendedInfo(obj, this.groupByColumn);
                if(extData['image']) {
                    img = extData['image'];
                }
            }
        }
        return img;    
    },
        
    _getInitGroupRowsCheckedStates: function(groupIndex)
    {
        var group = this.orderedObjects[groupIndex];
        
        for(var i = 0; i < group.length; i++) {
            if(!this.rowCheckedHandler.getRowCheckState(group[i]))
                return false;
        }
        return true;
    },
    
    _getGroupDisplayState: function(groupIndex)
    {
        var name = "group-" + groupIndex;
        var isOpen = true;
        var states = {
            'isOpen': isOpen,
            'isChecked': false
        }
        if(typeof this.groupStates[name] == "undefined") {
            this.groupStates[name] = states;
        } 
        this.groupStates[name].isChecked =  this._getInitGroupRowsCheckedStates(groupIndex);
        return this.groupStates[name];
    },

    _setGroupDisplayStateIsOpen: function(groupIndex, isOpen)
    {
        var name = "group-" + groupIndex;
        
        if(typeof this.groupStates[name] != "undefined") {
            this.groupStates[name].isOpen = isOpen;
        } 
    },

    _setGroupDisplayStateIsChecked: function(groupIndex, isChecked)
    {
        var name = "group-" + groupIndex;
        
        if(typeof this.groupStates[name] != "undefined") {
            this.groupStates[name].isChecked = isChecked;
        } 
    },

    _createGroupHeading: function(table, groupIndex, groupName, image, extra, bodyFragment)
    {
        var msg;
        var doc=document;
        var tr = doc.createElement('tr');
        var states = this._getGroupDisplayState(groupIndex);
        var showcheckbox = this.rowsCheckable && !this.rowSelectIsSingle;
        var args = {
            'title' : groupName,
            'isOpen': states.isOpen,
            'index' : groupIndex,
            'image' : image,
			'extra': extra,
            'showGroupCheckBox': showcheckbox,
            'groupChecked': states.isChecked
        }
        var groupCtrl = new GroupController(args);
        var td = doc.createElement('td');
        tr.appendChild(td);
        var addCol = (this.rowsCheckable) ? 1 : 0;
        tr.className = "group-tr";
        td.colSpan = this.contentProvider.getNumColumns() + addCol;
        td.className = "group-td";
        td.valign = "middle";
        td.appendChild(groupCtrl.domNode);
        groupCtrl.onGroupToggled = dojo.hitch(this, "_onGroupToggled");
        groupCtrl.onGroupCheckBoxStateChanged = dojo.hitch(this, "_onGroupCheckBoxChanged");
        bodyFragment.appendChild(tr);
        return groupCtrl;
    },
    
    _updateGroupDetails: function(groupCtrl, isOpen, itemInGroup, groupOffset, nItemInGroupShown)
    {
        var grpStart = (nItemInGroupShown == 0) ? 0 : (groupOffset + 1);
        var grpEnd = Math.min(itemInGroup, (groupOffset + nItemInGroupShown));
        var msg;
        if(!isOpen) {
            msg = MessageUtil.getMessage(MessageBundle.COMMON, "tableViewer_groupClosed", itemInGroup);
        }
        else {
            var key = (groupOffset > 0) ? "tableViewer_groupPartial" : "tableViewer_groupShowAll";
            msg = MessageUtil.getMessage(MessageBundle.COMMON, key, grpStart, grpEnd, itemInGroup);            
        }
        groupCtrl.setDetails(msg);
    },
    
    // Summary:
    //    Internal method to handle a group control's collapse/expand state changes.
    //
    _onGroupToggled: function(groupCtrl)
    {
        this._setGroupDisplayStateIsOpen(groupCtrl.index, groupCtrl.getIsOpen());
        this._loadTableContents();
        
        // if the collapse of the group would "roll back" the start
        // page position, change the page start pos too.
        var pageStartPos = this._calculatePrevPagePos(true);

        if(pageStartPos != this.curPageItemStart) {
            this.curPageItemStart = pageStartPos;
            this._loadTableContents();
        }
            
        this.headerRenderer.updatePageControlDisplay();
    },
    
    // Summary:
    //     Internal method to handle a group's check box state changes. This selects/deselects
    //     all items in that group.
    //
    _onGroupCheckBoxChanged: function(groupCtrl, checked)
    {
        // save the group's checked state
        this._setGroupDisplayStateIsChecked(groupCtrl.index, checked);
        
        // apply the checked states to all of the group's contents.
        var group = this.orderedObjects[groupCtrl.index];
        var rows = [];
        
        for(var i = 0; i < group.length; i++) {
            this.rowCheckedHandler.setRowCheckState(group[i], checked);
            rows.push(group[i]);
        }
        this._loadTableContents();

        // notify internally
        this._internalRowChecked();
       
        var listener = this.getTableListener();
        if(listener) {
            listener.groupRowsCheckStateChanged(this, rows, checked);
        }	
    },
    
    _contentSelectChanged: function()
    {
        var listener = this.getTableListener();
        if(listener) {
            var selectValue = null;
        
            for(var i = 0; i < this.contentSelect.options.length; i++) {
                if(this.contentSelect.options[i].selected) {
                    selectValue = this.contentSelect.options[i].value;
                    break;
                }
            }
            listener.tableContentSelectionChanged(this, selectValue);
        }        
    },
    
    _internalRowChecked: function()
    {
        // internal notification of rows selected
        if(this.headerRenderer.setColumnActionEnablement) {
            this.headerRenderer.setColumnActionEnablement();
        }
    },
    
    sendPdfHistoryRequest: function(rows, type, loc, alias, summary) {
    	this._history = true;
    	this.sendPdfPrintRequest(rows, type, loc, alias, summary);
    },
    
    sendPdfPrintRequest: function(rows, type, loc, alias, summary) {
    		var locale = djConfig.locale;
			if (locale.length != 2 && locale != "en-us" && locale != "pt-br" && locale != "zh-hk" && locale != "zh-tw" && locale != "en-zz") {
				locale = locale.substring(0,2);
			}
			if (locale != "de" && locale != "es" && locale != "fr" && locale != "it" && locale != "ja" && locale != "ko" && locale != "pt-br" && locale != "zh" && locale != "zh-hk" && locale != "zh-tw"){
				locale = "en-us";
			}
    		if (!summary){
	        var mimeTypeVar = "application/pdf";
	        var data = "<printReq><mimeType>"+mimeTypeVar+"</mimeType><fileExtension>pdf</fileExtension>";
			data += "<resources>";
			for (var i=0; i<rows.length; i++){
				var identifier = type + "/urn:com.ibm.rqm:" + type +":"+ rows[i].id;
				data += "<resource>";
				data += "<identifier>" + identifier + "</identifier>";
				data += "<transformArgs>";
				data += "<originUrl>" + loc + "</originUrl>";
				data += "<reqNumber>" + i + "</reqNumber>";
				data += "<componentType>STAND_ALONE</componentType>";
				data += "<containsTable>0</containsTable>";
				data += "<locale>" + locale + "</locale>";
				data += "<history>" + this._history + "</history>";
				data += "</transformArgs>";
				data += "</resource>";
			}
			
			data += "</resources></printReq>";
		}
		else {
	        var mimeTypeVar = "application/pdf";
	        var data = "<printReq><mimeType>"+mimeTypeVar+"</mimeType><fileExtension>pdf</fileExtension>";
			data += "<resources>";
			if (type == "request"){
					var identifier = type + "/RQ"+ rows[0]["visibleId"];}
				else{
					var identifier = type + "/urn:com.ibm.rqm:" + type +":"+ rows[0].id;}
				data += "<resource>";
				data += "<identifier>" + identifier + "</identifier>";
				data += "<transformArgs>";
				data += "<originUrl>" + loc + "</originUrl>";
				data += "<reqNumber>0</reqNumber>";
				data += "<componentType>STAND_ALONE_SUMMARY</componentType>";
				data += "<containsTable>1</containsTable>";
				data += "<locale>" + locale + "</locale>";
				data += "<history>" + this._history + "</history>";
				data += "</transformArgs>";
				data += "</resource>";
			
			for (var i=1; i<rows.length; i++){
				if (type == "request"){
					var identifier = type + "/RQ"+ rows[i]["visibleId"];}
				else{
					var identifier = type + "/urn:com.ibm.rqm:" + type +":"+ rows[i].id;}
				data += "<resource>";
				data += "<identifier>" + identifier + "</identifier>";
				data += "<transformArgs>";
				data += "<originUrl>" + loc + "</originUrl>";
				data += "<reqNumber>" + i + "</reqNumber>";
				data += "<componentType>SUMMARY</componentType>";
				data += "<containsTable>1</containsTable>";
				data += "<locale>" + locale + "</locale>";
				data += "<history>" + this._history + "</history>";
				data += "</transformArgs>";
				data += "</resource>";
			}
			
			data += "</resources></printReq>";
		}
		if (printFormDiv == null){
		var printFormDiv = document.createElement("div");
		var printForm = document.createElement("form");
		printForm.setAttribute("name","printViewForm");
		printForm.setAttribute("action","/jazz/secure/service/com.ibm.rqm.integration.service.IIntegrationService/fop/" + alias);
		printForm.setAttribute("method","POST");
		var printFormData = document.createElement("input");
		printFormData.setAttribute("name","printData");
		printFormData.setAttribute("type","hidden");
		printFormData.setAttribute("value","");
		printForm.appendChild(printFormData);
		printFormDiv.appendChild(printForm);
		document.body.appendChild(printFormDiv);}
		printFormData.value = data;
		printForm.submit();	    
    }
    
});

})();
