/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005-2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.rqm.defects.web.ui.view.common.ListDialog");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.ProgressBar")

dojo.require("com.ibm.team.repository.web.foundation.ProgressMonitor");

dojo.require("dojox.data.dom");

dojo.require("jazz.ui.Dialog");

dojo.require("com.ibm.rqm.defects.web.ui.utils.DefectsUIUtil");

(function() {

var DefectsUIUtil = com.ibm.rqm.defects.web.ui.utils.DefectsUIUtil;

dojo.declare("com.ibm.rqm.defects.web.ui.view.common.ListDialog",
			 [dijit._Widget, dijit._Templated], {

	labelOpen: 	DefectsUIUtil.getMessage("labelOpen"),
	labelClose: DefectsUIUtil.getMessage("labelClose"),
	// ---- constructor mixed-in properties --------------------------------------------------------------------------------	

	_dialogRoot: null,
	_labelDescription: null,
	_elementList: null,
	_openButton: null,
	_closeButton: null,
	
	_currentSelection: null,
	
//	_width: "50em",
	_height: "15em",
	_title: "Elements",
	_description: "Elements",
	
	_onOpenHandler: null,
	
	constructor: function() {
	},
	
	// ---- api ------------------------------------------------------------------------------------------------------------	

	showElements: function(elements) {
		
		this._labelDescription.innerHTML= this._description;
		
		if(dojo.isArray(elements)){
			dojo.forEach(elements, dojo.hitch(this, function(element, index, array){
				var option= document.createElement("option");
				option.appendChild(document.createTextNode(element));
				option.setAttribute("value", element);
				
				this._elementList.appendChild(option);
				
				this.connect(option, "onclick", function(){
					this._currentSelection= option.attributes.value.value;
				})
			}));
		}
	},

	// ---- widget implementation ------------------------------------------------------------------------------------------

	templatePath: dojo.moduleUrl("com.ibm.rqm.defects.web", "ui/view/common/templates/ListDialog.html"),

	postCreate: function() {
		
		this._dialog = new jazz.ui.Dialog({
			contentNode: this._dialogRoot,
			primaryTitle: this._title,
//			width: this._width,
			isClosable: false
		});
		
		this.connect(this._closeButton, "onclick", function(){
			this._dialog.close();
		});
		
		this.connect(this._openButton, "onclick", "_onOpen");
	},

	// ---- implementation -------------------------------------------------------------------------------------------------

	_onOpen: function(){
		this._dialog.close();
		if(dojo.isFunction(this._onOpenHandler)){
			this._onOpenHandler(this._currentSelection);
		}
	},
	
	__sentinel: null // terminates this class definition
});

com.ibm.rqm.defects.web.ui.view.common.ListDialog.create= function(title) {
	var args= {};
	if (title)
		args["_title"]= title;
	
	return new com.ibm.rqm.defects.web.ui.view.common.ListDialog(args, null);
};
com.ibm.rqm.defects.web.ui.view.common.ListDialog.doShowElements = function(title, description, elements, openHandler){
	var args= {};
	if (title)
		args["_title"]= title;
	if (description)
		args["_description"]= description;
	args["_onOpenHandler"]= openHandler;
		
	return new com.ibm.rqm.defects.web.ui.view.common.ListDialog(args).showElements(elements);
};

})();
