/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.defects.web.ui.view.common.RichHoverCellRenderer");

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellRenderer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("jazz.app.ResourceLink");

(function() {

dojo.declare("com.ibm.rqm.defects.web.ui.view.common.RichHoverCellRenderer", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellRenderer,
{    
    // Summary:
    //    Renders the cell content which need a rich hover to display the content. 
    //    
    renderCell: function(viewer, cellData, extendedDisplayInfo, /*table.CellModifier*/cellModifier, rowObject, columnIndex, cellWidthHint)
    {
		if(!(extendedDisplayInfo.workItemUri) || !(extendedDisplayInfo.workItemPresentationUri))
			throw new Error("RichHoverCellRenderer REQUIRES that the extendedDisplayInfo.workItemUri and extendedDisplayInfo.workItemPresentationUri parameters are given");
        var node = document.createElement("A");
		node.target = "_blank";
        this._renderCellText(viewer, cellData, extendedDisplayInfo, node, cellWidthHint);
		var resourceLinkArgs= { 
				uri: extendedDisplayInfo.workItemUri,
				presentationUri: extendedDisplayInfo.workItemPresentationUri,
				label: extendedDisplayInfo.label
			};
		new jazz.app.ResourceLink(resourceLinkArgs, node);
        return node;
    }
});

})();
