/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
//

//
package com.ibm.rational.test.lm.spi.bf.internal;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

import com.buildforge.services.client.dbo.Server;

public class DiscoveryUnit implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 5142768245402651515L;

	private List<Server> servers = new ArrayList<Server>();
	private int discoveredNum = 0;
	private boolean isCanceled = false;
	private boolean isCompleted = false;
	
	public DiscoveryUnit() {
		super();
	}
	
	public DiscoveryUnit(List<Server> servers) {
		super();
		this.servers = servers;
	}
	
	/**
	 * @return the servers
	 */
	public List<Server> getServers() {
		return servers;
	}
	/**
	 * @param servers the servers to set
	 */
	public void setServers(List<Server> servers) {
		this.servers = servers;
	}
	/**
	 * @return the isCanceled
	 */
	public boolean isCanceled() {
		return isCanceled;
	}
	/**
	 * @param isCanceled the isCanceled to set
	 */
	public void setCanceled(boolean isCanceled) {
		this.isCanceled = isCanceled;
	}
	/**
	 * @return the isCompleted
	 */
	public boolean isCompleted() {
		return isCompleted;
	}
	/**
	 * @param isCompleted the isCompleted to set
	 */
	public void setCompleted(boolean isCompleted) {
		this.isCompleted = isCompleted;
	}
	/**
	 * @return the serialVersionUID
	 */
	public static long getSerialVersionUID() {
		return serialVersionUID;
	}

	/**
	 * @return the discoveredNum
	 */
	public int getDiscoveredNum() {
		return discoveredNum;
	}

	/**
	 * @param discoveredNum the discoveredNum to set
	 */
	public void setDiscoveredNum(int discoveredNum) {
		if (discoveredNum > servers.size()) {
			throw new IllegalArgumentException(discoveredNum
					+ "is out of servers list size.");
		}
		this.discoveredNum = discoveredNum;
	}
	
	
}
